(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
	typeof define === 'function' && define.amd ? define(['exports'], factory) :
	(global = global || self, factory(global.tensorscript = {}));
}(this, function (exports) { 'use strict';

	function createCommonjsModule(fn, module) {
		return module = { exports: {} }, fn(module, module.exports), module.exports;
	}

	var _typeof_1 = createCommonjsModule(function (module) {
	function _typeof2(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof2 = function _typeof2(obj) { return typeof obj; }; } else { _typeof2 = function _typeof2(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof2(obj); }

	function _typeof(obj) {
	  if (typeof Symbol === "function" && _typeof2(Symbol.iterator) === "symbol") {
	    module.exports = _typeof = function _typeof(obj) {
	      return _typeof2(obj);
	    };
	  } else {
	    module.exports = _typeof = function _typeof(obj) {
	      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : _typeof2(obj);
	    };
	  }

	  return _typeof(obj);
	}

	module.exports = _typeof;
	});

	function _assertThisInitialized(self) {
	  if (self === void 0) {
	    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
	  }

	  return self;
	}

	var assertThisInitialized = _assertThisInitialized;

	function _possibleConstructorReturn(self, call) {
	  if (call && (_typeof_1(call) === "object" || typeof call === "function")) {
	    return call;
	  }

	  return assertThisInitialized(self);
	}

	var possibleConstructorReturn = _possibleConstructorReturn;

	var getPrototypeOf = createCommonjsModule(function (module) {
	  function _getPrototypeOf(o) {
	    module.exports = _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
	      return o.__proto__ || Object.getPrototypeOf(o);
	    };
	    return _getPrototypeOf(o);
	  }

	  module.exports = _getPrototypeOf;
	});

	var setPrototypeOf = createCommonjsModule(function (module) {
	  function _setPrototypeOf(o, p) {
	    module.exports = _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
	      o.__proto__ = p;
	      return o;
	    };

	    return _setPrototypeOf(o, p);
	  }

	  module.exports = _setPrototypeOf;
	});

	function _inherits(subClass, superClass) {
	  if (typeof superClass !== "function" && superClass !== null) {
	    throw new TypeError("Super expression must either be null or a function");
	  }

	  subClass.prototype = Object.create(superClass && superClass.prototype, {
	    constructor: {
	      value: subClass,
	      writable: true,
	      configurable: true
	    }
	  });
	  if (superClass) setPrototypeOf(subClass, superClass);
	}

	var inherits = _inherits;

	function _isNativeFunction(fn) {
	  return Function.toString.call(fn).indexOf("[native code]") !== -1;
	}

	var isNativeFunction = _isNativeFunction;

	var construct = createCommonjsModule(function (module) {
	  function isNativeReflectConstruct() {
	    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
	    if (Reflect.construct.sham) return false;
	    if (typeof Proxy === "function") return true;

	    try {
	      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
	      return true;
	    } catch (e) {
	      return false;
	    }
	  }

	  function _construct(Parent, args, Class) {
	    if (isNativeReflectConstruct()) {
	      module.exports = _construct = Reflect.construct;
	    } else {
	      module.exports = _construct = function _construct(Parent, args, Class) {
	        var a = [null];
	        a.push.apply(a, args);
	        var Constructor = Function.bind.apply(Parent, a);
	        var instance = new Constructor();
	        if (Class) setPrototypeOf(instance, Class.prototype);
	        return instance;
	      };
	    }

	    return _construct.apply(null, arguments);
	  }

	  module.exports = _construct;
	});

	var wrapNativeSuper = createCommonjsModule(function (module) {
	  function _wrapNativeSuper(Class) {
	    var _cache = typeof Map === "function" ? new Map() : undefined;

	    module.exports = _wrapNativeSuper = function _wrapNativeSuper(Class) {
	      if (Class === null || !isNativeFunction(Class)) return Class;

	      if (typeof Class !== "function") {
	        throw new TypeError("Super expression must either be null or a function");
	      }

	      if (typeof _cache !== "undefined") {
	        if (_cache.has(Class)) return _cache.get(Class);

	        _cache.set(Class, Wrapper);
	      }

	      function Wrapper() {
	        return construct(Class, arguments, getPrototypeOf(this).constructor);
	      }

	      Wrapper.prototype = Object.create(Class.prototype, {
	        constructor: {
	          value: Wrapper,
	          enumerable: false,
	          writable: true,
	          configurable: true
	        }
	      });
	      return setPrototypeOf(Wrapper, Class);
	    };

	    return _wrapNativeSuper(Class);
	  }

	  module.exports = _wrapNativeSuper;
	});

	var runtime_1 = createCommonjsModule(function (module) {
	  /**
	   * Copyright (c) 2014-present, Facebook, Inc.
	   *
	   * This source code is licensed under the MIT license found in the
	   * LICENSE file in the root directory of this source tree.
	   */
	  var runtime = function (exports) {

	    var Op = Object.prototype;
	    var hasOwn = Op.hasOwnProperty;
	    var undefined$1; // More compressible than void 0.

	    var $Symbol = typeof Symbol === "function" ? Symbol : {};
	    var iteratorSymbol = $Symbol.iterator || "@@iterator";
	    var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
	    var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

	    function wrap(innerFn, outerFn, self, tryLocsList) {
	      // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
	      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
	      var generator = Object.create(protoGenerator.prototype);
	      var context = new Context(tryLocsList || []); // The ._invoke method unifies the implementations of the .next,
	      // .throw, and .return methods.

	      generator._invoke = makeInvokeMethod(innerFn, self, context);
	      return generator;
	    }

	    exports.wrap = wrap; // Try/catch helper to minimize deoptimizations. Returns a completion
	    // record like context.tryEntries[i].completion. This interface could
	    // have been (and was previously) designed to take a closure to be
	    // invoked without arguments, but in all the cases we care about we
	    // already have an existing method we want to call, so there's no need
	    // to create a new function object. We can even get away with assuming
	    // the method takes exactly one argument, since that happens to be true
	    // in every case, so we don't have to touch the arguments object. The
	    // only additional allocation required is the completion record, which
	    // has a stable shape and so hopefully should be cheap to allocate.

	    function tryCatch(fn, obj, arg) {
	      try {
	        return {
	          type: "normal",
	          arg: fn.call(obj, arg)
	        };
	      } catch (err) {
	        return {
	          type: "throw",
	          arg: err
	        };
	      }
	    }

	    var GenStateSuspendedStart = "suspendedStart";
	    var GenStateSuspendedYield = "suspendedYield";
	    var GenStateExecuting = "executing";
	    var GenStateCompleted = "completed"; // Returning this object from the innerFn has the same effect as
	    // breaking out of the dispatch switch statement.

	    var ContinueSentinel = {}; // Dummy constructor functions that we use as the .constructor and
	    // .constructor.prototype properties for functions that return Generator
	    // objects. For full spec compliance, you may wish to configure your
	    // minifier not to mangle the names of these two functions.

	    function Generator() {}

	    function GeneratorFunction() {}

	    function GeneratorFunctionPrototype() {} // This is a polyfill for %IteratorPrototype% for environments that
	    // don't natively support it.


	    var IteratorPrototype = {};

	    IteratorPrototype[iteratorSymbol] = function () {
	      return this;
	    };

	    var getProto = Object.getPrototypeOf;
	    var NativeIteratorPrototype = getProto && getProto(getProto(values([])));

	    if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
	      // This environment has a native %IteratorPrototype%; use it instead
	      // of the polyfill.
	      IteratorPrototype = NativeIteratorPrototype;
	    }

	    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
	    GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
	    GeneratorFunctionPrototype.constructor = GeneratorFunction;
	    GeneratorFunctionPrototype[toStringTagSymbol] = GeneratorFunction.displayName = "GeneratorFunction"; // Helper for defining the .next, .throw, and .return methods of the
	    // Iterator interface in terms of a single ._invoke method.

	    function defineIteratorMethods(prototype) {
	      ["next", "throw", "return"].forEach(function (method) {
	        prototype[method] = function (arg) {
	          return this._invoke(method, arg);
	        };
	      });
	    }

	    exports.isGeneratorFunction = function (genFun) {
	      var ctor = typeof genFun === "function" && genFun.constructor;
	      return ctor ? ctor === GeneratorFunction || // For the native GeneratorFunction constructor, the best we can
	      // do is to check its .name property.
	      (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
	    };

	    exports.mark = function (genFun) {
	      if (Object.setPrototypeOf) {
	        Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
	      } else {
	        genFun.__proto__ = GeneratorFunctionPrototype;

	        if (!(toStringTagSymbol in genFun)) {
	          genFun[toStringTagSymbol] = "GeneratorFunction";
	        }
	      }

	      genFun.prototype = Object.create(Gp);
	      return genFun;
	    }; // Within the body of any async function, `await x` is transformed to
	    // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
	    // `hasOwn.call(value, "__await")` to determine if the yielded value is
	    // meant to be awaited.


	    exports.awrap = function (arg) {
	      return {
	        __await: arg
	      };
	    };

	    function AsyncIterator(generator) {
	      function invoke(method, arg, resolve, reject) {
	        var record = tryCatch(generator[method], generator, arg);

	        if (record.type === "throw") {
	          reject(record.arg);
	        } else {
	          var result = record.arg;
	          var value = result.value;

	          if (value && _typeof_1(value) === "object" && hasOwn.call(value, "__await")) {
	            return Promise.resolve(value.__await).then(function (value) {
	              invoke("next", value, resolve, reject);
	            }, function (err) {
	              invoke("throw", err, resolve, reject);
	            });
	          }

	          return Promise.resolve(value).then(function (unwrapped) {
	            // When a yielded Promise is resolved, its final value becomes
	            // the .value of the Promise<{value,done}> result for the
	            // current iteration.
	            result.value = unwrapped;
	            resolve(result);
	          }, function (error) {
	            // If a rejected Promise was yielded, throw the rejection back
	            // into the async generator function so it can be handled there.
	            return invoke("throw", error, resolve, reject);
	          });
	        }
	      }

	      var previousPromise;

	      function enqueue(method, arg) {
	        function callInvokeWithMethodAndArg() {
	          return new Promise(function (resolve, reject) {
	            invoke(method, arg, resolve, reject);
	          });
	        }

	        return previousPromise = // If enqueue has been called before, then we want to wait until
	        // all previous Promises have been resolved before calling invoke,
	        // so that results are always delivered in the correct order. If
	        // enqueue has not been called before, then it is important to
	        // call invoke immediately, without waiting on a callback to fire,
	        // so that the async generator function has the opportunity to do
	        // any necessary setup in a predictable way. This predictability
	        // is why the Promise constructor synchronously invokes its
	        // executor callback, and why async functions synchronously
	        // execute code before the first await. Since we implement simple
	        // async functions in terms of async generators, it is especially
	        // important to get this right, even though it requires care.
	        previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, // Avoid propagating failures to Promises returned by later
	        // invocations of the iterator.
	        callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
	      } // Define the unified helper method that is used to implement .next,
	      // .throw, and .return (see defineIteratorMethods).


	      this._invoke = enqueue;
	    }

	    defineIteratorMethods(AsyncIterator.prototype);

	    AsyncIterator.prototype[asyncIteratorSymbol] = function () {
	      return this;
	    };

	    exports.AsyncIterator = AsyncIterator; // Note that simple async functions are implemented on top of
	    // AsyncIterator objects; they just return a Promise for the value of
	    // the final result produced by the iterator.

	    exports.async = function (innerFn, outerFn, self, tryLocsList) {
	      var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList));
	      return exports.isGeneratorFunction(outerFn) ? iter // If outerFn is a generator, return the full iterator.
	      : iter.next().then(function (result) {
	        return result.done ? result.value : iter.next();
	      });
	    };

	    function makeInvokeMethod(innerFn, self, context) {
	      var state = GenStateSuspendedStart;
	      return function invoke(method, arg) {
	        if (state === GenStateExecuting) {
	          throw new Error("Generator is already running");
	        }

	        if (state === GenStateCompleted) {
	          if (method === "throw") {
	            throw arg;
	          } // Be forgiving, per 25.3.3.3.3 of the spec:
	          // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume


	          return doneResult();
	        }

	        context.method = method;
	        context.arg = arg;

	        while (true) {
	          var delegate = context.delegate;

	          if (delegate) {
	            var delegateResult = maybeInvokeDelegate(delegate, context);

	            if (delegateResult) {
	              if (delegateResult === ContinueSentinel) continue;
	              return delegateResult;
	            }
	          }

	          if (context.method === "next") {
	            // Setting context._sent for legacy support of Babel's
	            // function.sent implementation.
	            context.sent = context._sent = context.arg;
	          } else if (context.method === "throw") {
	            if (state === GenStateSuspendedStart) {
	              state = GenStateCompleted;
	              throw context.arg;
	            }

	            context.dispatchException(context.arg);
	          } else if (context.method === "return") {
	            context.abrupt("return", context.arg);
	          }

	          state = GenStateExecuting;
	          var record = tryCatch(innerFn, self, context);

	          if (record.type === "normal") {
	            // If an exception is thrown from innerFn, we leave state ===
	            // GenStateExecuting and loop back for another invocation.
	            state = context.done ? GenStateCompleted : GenStateSuspendedYield;

	            if (record.arg === ContinueSentinel) {
	              continue;
	            }

	            return {
	              value: record.arg,
	              done: context.done
	            };
	          } else if (record.type === "throw") {
	            state = GenStateCompleted; // Dispatch the exception by looping back around to the
	            // context.dispatchException(context.arg) call above.

	            context.method = "throw";
	            context.arg = record.arg;
	          }
	        }
	      };
	    } // Call delegate.iterator[context.method](context.arg) and handle the
	    // result, either by returning a { value, done } result from the
	    // delegate iterator, or by modifying context.method and context.arg,
	    // setting context.delegate to null, and returning the ContinueSentinel.


	    function maybeInvokeDelegate(delegate, context) {
	      var method = delegate.iterator[context.method];

	      if (method === undefined$1) {
	        // A .throw or .return when the delegate iterator has no .throw
	        // method always terminates the yield* loop.
	        context.delegate = null;

	        if (context.method === "throw") {
	          // Note: ["return"] must be used for ES3 parsing compatibility.
	          if (delegate.iterator["return"]) {
	            // If the delegate iterator has a return method, give it a
	            // chance to clean up.
	            context.method = "return";
	            context.arg = undefined$1;
	            maybeInvokeDelegate(delegate, context);

	            if (context.method === "throw") {
	              // If maybeInvokeDelegate(context) changed context.method from
	              // "return" to "throw", let that override the TypeError below.
	              return ContinueSentinel;
	            }
	          }

	          context.method = "throw";
	          context.arg = new TypeError("The iterator does not provide a 'throw' method");
	        }

	        return ContinueSentinel;
	      }

	      var record = tryCatch(method, delegate.iterator, context.arg);

	      if (record.type === "throw") {
	        context.method = "throw";
	        context.arg = record.arg;
	        context.delegate = null;
	        return ContinueSentinel;
	      }

	      var info = record.arg;

	      if (!info) {
	        context.method = "throw";
	        context.arg = new TypeError("iterator result is not an object");
	        context.delegate = null;
	        return ContinueSentinel;
	      }

	      if (info.done) {
	        // Assign the result of the finished delegate to the temporary
	        // variable specified by delegate.resultName (see delegateYield).
	        context[delegate.resultName] = info.value; // Resume execution at the desired location (see delegateYield).

	        context.next = delegate.nextLoc; // If context.method was "throw" but the delegate handled the
	        // exception, let the outer generator proceed normally. If
	        // context.method was "next", forget context.arg since it has been
	        // "consumed" by the delegate iterator. If context.method was
	        // "return", allow the original .return call to continue in the
	        // outer generator.

	        if (context.method !== "return") {
	          context.method = "next";
	          context.arg = undefined$1;
	        }
	      } else {
	        // Re-yield the result returned by the delegate method.
	        return info;
	      } // The delegate iterator is finished, so forget it and continue with
	      // the outer generator.


	      context.delegate = null;
	      return ContinueSentinel;
	    } // Define Generator.prototype.{next,throw,return} in terms of the
	    // unified ._invoke helper method.


	    defineIteratorMethods(Gp);
	    Gp[toStringTagSymbol] = "Generator"; // A Generator should always return itself as the iterator object when the
	    // @@iterator function is called on it. Some browsers' implementations of the
	    // iterator prototype chain incorrectly implement this, causing the Generator
	    // object to not be returned from this call. This ensures that doesn't happen.
	    // See https://github.com/facebook/regenerator/issues/274 for more details.

	    Gp[iteratorSymbol] = function () {
	      return this;
	    };

	    Gp.toString = function () {
	      return "[object Generator]";
	    };

	    function pushTryEntry(locs) {
	      var entry = {
	        tryLoc: locs[0]
	      };

	      if (1 in locs) {
	        entry.catchLoc = locs[1];
	      }

	      if (2 in locs) {
	        entry.finallyLoc = locs[2];
	        entry.afterLoc = locs[3];
	      }

	      this.tryEntries.push(entry);
	    }

	    function resetTryEntry(entry) {
	      var record = entry.completion || {};
	      record.type = "normal";
	      delete record.arg;
	      entry.completion = record;
	    }

	    function Context(tryLocsList) {
	      // The root entry object (effectively a try statement without a catch
	      // or a finally block) gives us a place to store values thrown from
	      // locations where there is no enclosing try statement.
	      this.tryEntries = [{
	        tryLoc: "root"
	      }];
	      tryLocsList.forEach(pushTryEntry, this);
	      this.reset(true);
	    }

	    exports.keys = function (object) {
	      var keys = [];

	      for (var key in object) {
	        keys.push(key);
	      }

	      keys.reverse(); // Rather than returning an object with a next method, we keep
	      // things simple and return the next function itself.

	      return function next() {
	        while (keys.length) {
	          var key = keys.pop();

	          if (key in object) {
	            next.value = key;
	            next.done = false;
	            return next;
	          }
	        } // To avoid creating an additional object, we just hang the .value
	        // and .done properties off the next function object itself. This
	        // also ensures that the minifier will not anonymize the function.


	        next.done = true;
	        return next;
	      };
	    };

	    function values(iterable) {
	      if (iterable) {
	        var iteratorMethod = iterable[iteratorSymbol];

	        if (iteratorMethod) {
	          return iteratorMethod.call(iterable);
	        }

	        if (typeof iterable.next === "function") {
	          return iterable;
	        }

	        if (!isNaN(iterable.length)) {
	          var i = -1,
	              next = function next() {
	            while (++i < iterable.length) {
	              if (hasOwn.call(iterable, i)) {
	                next.value = iterable[i];
	                next.done = false;
	                return next;
	              }
	            }

	            next.value = undefined$1;
	            next.done = true;
	            return next;
	          };

	          return next.next = next;
	        }
	      } // Return an iterator with no values.


	      return {
	        next: doneResult
	      };
	    }

	    exports.values = values;

	    function doneResult() {
	      return {
	        value: undefined$1,
	        done: true
	      };
	    }

	    Context.prototype = {
	      constructor: Context,
	      reset: function reset(skipTempReset) {
	        this.prev = 0;
	        this.next = 0; // Resetting context._sent for legacy support of Babel's
	        // function.sent implementation.

	        this.sent = this._sent = undefined$1;
	        this.done = false;
	        this.delegate = null;
	        this.method = "next";
	        this.arg = undefined$1;
	        this.tryEntries.forEach(resetTryEntry);

	        if (!skipTempReset) {
	          for (var name in this) {
	            // Not sure about the optimal order of these conditions:
	            if (name.charAt(0) === "t" && hasOwn.call(this, name) && !isNaN(+name.slice(1))) {
	              this[name] = undefined$1;
	            }
	          }
	        }
	      },
	      stop: function stop() {
	        this.done = true;
	        var rootEntry = this.tryEntries[0];
	        var rootRecord = rootEntry.completion;

	        if (rootRecord.type === "throw") {
	          throw rootRecord.arg;
	        }

	        return this.rval;
	      },
	      dispatchException: function dispatchException(exception) {
	        if (this.done) {
	          throw exception;
	        }

	        var context = this;

	        function handle(loc, caught) {
	          record.type = "throw";
	          record.arg = exception;
	          context.next = loc;

	          if (caught) {
	            // If the dispatched exception was caught by a catch block,
	            // then let that catch block handle the exception normally.
	            context.method = "next";
	            context.arg = undefined$1;
	          }

	          return !!caught;
	        }

	        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
	          var entry = this.tryEntries[i];
	          var record = entry.completion;

	          if (entry.tryLoc === "root") {
	            // Exception thrown outside of any try block that could handle
	            // it, so set the completion value of the entire function to
	            // throw the exception.
	            return handle("end");
	          }

	          if (entry.tryLoc <= this.prev) {
	            var hasCatch = hasOwn.call(entry, "catchLoc");
	            var hasFinally = hasOwn.call(entry, "finallyLoc");

	            if (hasCatch && hasFinally) {
	              if (this.prev < entry.catchLoc) {
	                return handle(entry.catchLoc, true);
	              } else if (this.prev < entry.finallyLoc) {
	                return handle(entry.finallyLoc);
	              }
	            } else if (hasCatch) {
	              if (this.prev < entry.catchLoc) {
	                return handle(entry.catchLoc, true);
	              }
	            } else if (hasFinally) {
	              if (this.prev < entry.finallyLoc) {
	                return handle(entry.finallyLoc);
	              }
	            } else {
	              throw new Error("try statement without catch or finally");
	            }
	          }
	        }
	      },
	      abrupt: function abrupt(type, arg) {
	        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
	          var entry = this.tryEntries[i];

	          if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
	            var finallyEntry = entry;
	            break;
	          }
	        }

	        if (finallyEntry && (type === "break" || type === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
	          // Ignore the finally entry if control is not jumping to a
	          // location outside the try/catch block.
	          finallyEntry = null;
	        }

	        var record = finallyEntry ? finallyEntry.completion : {};
	        record.type = type;
	        record.arg = arg;

	        if (finallyEntry) {
	          this.method = "next";
	          this.next = finallyEntry.finallyLoc;
	          return ContinueSentinel;
	        }

	        return this.complete(record);
	      },
	      complete: function complete(record, afterLoc) {
	        if (record.type === "throw") {
	          throw record.arg;
	        }

	        if (record.type === "break" || record.type === "continue") {
	          this.next = record.arg;
	        } else if (record.type === "return") {
	          this.rval = this.arg = record.arg;
	          this.method = "return";
	          this.next = "end";
	        } else if (record.type === "normal" && afterLoc) {
	          this.next = afterLoc;
	        }

	        return ContinueSentinel;
	      },
	      finish: function finish(finallyLoc) {
	        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
	          var entry = this.tryEntries[i];

	          if (entry.finallyLoc === finallyLoc) {
	            this.complete(entry.completion, entry.afterLoc);
	            resetTryEntry(entry);
	            return ContinueSentinel;
	          }
	        }
	      },
	      "catch": function _catch(tryLoc) {
	        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
	          var entry = this.tryEntries[i];

	          if (entry.tryLoc === tryLoc) {
	            var record = entry.completion;

	            if (record.type === "throw") {
	              var thrown = record.arg;
	              resetTryEntry(entry);
	            }

	            return thrown;
	          }
	        } // The context.catch method must only be called with a location
	        // argument that corresponds to a known catch block.


	        throw new Error("illegal catch attempt");
	      },
	      delegateYield: function delegateYield(iterable, resultName, nextLoc) {
	        this.delegate = {
	          iterator: values(iterable),
	          resultName: resultName,
	          nextLoc: nextLoc
	        };

	        if (this.method === "next") {
	          // Deliberately forget the last sent value so that we don't
	          // accidentally pass it on to the delegate.
	          this.arg = undefined$1;
	        }

	        return ContinueSentinel;
	      }
	    }; // Regardless of whether this script is executing as a CommonJS module
	    // or not, return the runtime object so that we can declare the variable
	    // regeneratorRuntime in the outer scope, which allows this module to be
	    // injected easily by `bin/regenerator --include-runtime script.js`.

	    return exports;
	  }( // If this script is executing as a CommonJS module, use module.exports
	  // as the regeneratorRuntime namespace. Otherwise create a new empty
	  // object. Either way, the resulting object will be used to initialize
	  // the regeneratorRuntime variable at the top of this file.
	  module.exports);

	  try {
	    regeneratorRuntime = runtime;
	  } catch (accidentalStrictMode) {
	    // This module should not be running in strict mode, so the above
	    // assignment should always work unless something is misconfigured. Just
	    // in case runtime.js accidentally runs in strict mode, we can escape
	    // strict mode using a global Function call. This could conceivably fail
	    // if a Content Security Policy forbids using Function, but in that case
	    // the proper solution is to fix the accidental strict mode problem. If
	    // you've misconfigured your bundler to force strict mode and applied a
	    // CSP to forbid Function, and you're not willing to fix either of those
	    // problems, please detail your unique predicament in a GitHub issue.
	    Function("r", "regeneratorRuntime = r")(runtime);
	  }
	});

	var regenerator = runtime_1;

	function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
	  try {
	    var info = gen[key](arg);
	    var value = info.value;
	  } catch (error) {
	    reject(error);
	    return;
	  }

	  if (info.done) {
	    resolve(value);
	  } else {
	    Promise.resolve(value).then(_next, _throw);
	  }
	}

	function _asyncToGenerator(fn) {
	  return function () {
	    var self = this,
	        args = arguments;
	    return new Promise(function (resolve, reject) {
	      var gen = fn.apply(self, args);

	      function _next(value) {
	        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
	      }

	      function _throw(err) {
	        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
	      }

	      _next(undefined);
	    });
	  };
	}

	var asyncToGenerator = _asyncToGenerator;

	function _classCallCheck(instance, Constructor) {
	  if (!(instance instanceof Constructor)) {
	    throw new TypeError("Cannot call a class as a function");
	  }
	}

	var classCallCheck = _classCallCheck;

	function _defineProperties(target, props) {
	  for (var i = 0; i < props.length; i++) {
	    var descriptor = props[i];
	    descriptor.enumerable = descriptor.enumerable || false;
	    descriptor.configurable = true;
	    if ("value" in descriptor) descriptor.writable = true;
	    Object.defineProperty(target, descriptor.key, descriptor);
	  }
	}

	function _createClass(Constructor, protoProps, staticProps) {
	  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
	  if (staticProps) _defineProperties(Constructor, staticProps);
	  return Constructor;
	}

	var createClass = _createClass;

	var global$1 = typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {};

	// shim for using process in browser
	// based off https://github.com/defunctzombie/node-process/blob/master/browser.js
	function defaultSetTimout() {
	  throw new Error('setTimeout has not been defined');
	}

	function defaultClearTimeout() {
	  throw new Error('clearTimeout has not been defined');
	}

	var cachedSetTimeout = defaultSetTimout;
	var cachedClearTimeout = defaultClearTimeout;

	if (typeof global$1.setTimeout === 'function') {
	  cachedSetTimeout = setTimeout;
	}

	if (typeof global$1.clearTimeout === 'function') {
	  cachedClearTimeout = clearTimeout;
	}

	function runTimeout(fun) {
	  if (cachedSetTimeout === setTimeout) {
	    //normal enviroments in sane situations
	    return setTimeout(fun, 0);
	  } // if setTimeout wasn't available but was latter defined


	  if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
	    cachedSetTimeout = setTimeout;
	    return setTimeout(fun, 0);
	  }

	  try {
	    // when when somebody has screwed with setTimeout but no I.E. maddness
	    return cachedSetTimeout(fun, 0);
	  } catch (e) {
	    try {
	      // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
	      return cachedSetTimeout.call(null, fun, 0);
	    } catch (e) {
	      // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
	      return cachedSetTimeout.call(this, fun, 0);
	    }
	  }
	}

	function runClearTimeout(marker) {
	  if (cachedClearTimeout === clearTimeout) {
	    //normal enviroments in sane situations
	    return clearTimeout(marker);
	  } // if clearTimeout wasn't available but was latter defined


	  if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
	    cachedClearTimeout = clearTimeout;
	    return clearTimeout(marker);
	  }

	  try {
	    // when when somebody has screwed with setTimeout but no I.E. maddness
	    return cachedClearTimeout(marker);
	  } catch (e) {
	    try {
	      // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
	      return cachedClearTimeout.call(null, marker);
	    } catch (e) {
	      // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
	      // Some versions of I.E. have different rules for clearTimeout vs setTimeout
	      return cachedClearTimeout.call(this, marker);
	    }
	  }
	}

	var queue = [];
	var draining = false;
	var currentQueue;
	var queueIndex = -1;

	function cleanUpNextTick() {
	  if (!draining || !currentQueue) {
	    return;
	  }

	  draining = false;

	  if (currentQueue.length) {
	    queue = currentQueue.concat(queue);
	  } else {
	    queueIndex = -1;
	  }

	  if (queue.length) {
	    drainQueue();
	  }
	}

	function drainQueue() {
	  if (draining) {
	    return;
	  }

	  var timeout = runTimeout(cleanUpNextTick);
	  draining = true;
	  var len = queue.length;

	  while (len) {
	    currentQueue = queue;
	    queue = [];

	    while (++queueIndex < len) {
	      if (currentQueue) {
	        currentQueue[queueIndex].run();
	      }
	    }

	    queueIndex = -1;
	    len = queue.length;
	  }

	  currentQueue = null;
	  draining = false;
	  runClearTimeout(timeout);
	}

	function nextTick(fun) {
	  var args = new Array(arguments.length - 1);

	  if (arguments.length > 1) {
	    for (var i = 1; i < arguments.length; i++) {
	      args[i - 1] = arguments[i];
	    }
	  }

	  queue.push(new Item(fun, args));

	  if (queue.length === 1 && !draining) {
	    runTimeout(drainQueue);
	  }
	} // v8 likes predictible objects

	function Item(fun, array) {
	  this.fun = fun;
	  this.array = array;
	}

	Item.prototype.run = function () {
	  this.fun.apply(null, this.array);
	};

	var title = 'browser';
	var platform = 'browser';
	var browser = true;
	var env = {};
	var argv = [];
	var version = ''; // empty string to avoid regexp issues

	var versions = {};
	var release = {};
	var config = {};

	function noop() {}

	var on = noop;
	var addListener = noop;
	var once = noop;
	var off = noop;
	var removeListener = noop;
	var removeAllListeners = noop;
	var emit = noop;
	function binding(name) {
	  throw new Error('process.binding is not supported');
	}
	function cwd() {
	  return '/';
	}
	function chdir(dir) {
	  throw new Error('process.chdir is not supported');
	}
	function umask() {
	  return 0;
	} // from https://github.com/kumavis/browser-process-hrtime/blob/master/index.js

	var performance$1 = global$1.performance || {};

	var performanceNow = performance$1.now || performance$1.mozNow || performance$1.msNow || performance$1.oNow || performance$1.webkitNow || function () {
	  return new Date().getTime();
	}; // generate timestamp or delta
	// see http://nodejs.org/api/process.html#process_process_hrtime


	function hrtime(previousTimestamp) {
	  var clocktime = performanceNow.call(performance$1) * 1e-3;
	  var seconds = Math.floor(clocktime);
	  var nanoseconds = Math.floor(clocktime % 1 * 1e9);

	  if (previousTimestamp) {
	    seconds = seconds - previousTimestamp[0];
	    nanoseconds = nanoseconds - previousTimestamp[1];

	    if (nanoseconds < 0) {
	      seconds--;
	      nanoseconds += 1e9;
	    }
	  }

	  return [seconds, nanoseconds];
	}
	var startTime = new Date();
	function uptime() {
	  var currentTime = new Date();
	  var dif = currentTime - startTime;
	  return dif / 1000;
	}
	var process = {
	  nextTick: nextTick,
	  title: title,
	  browser: browser,
	  env: env,
	  argv: argv,
	  version: version,
	  versions: versions,
	  on: on,
	  addListener: addListener,
	  once: once,
	  off: off,
	  removeListener: removeListener,
	  removeAllListeners: removeAllListeners,
	  emit: emit,
	  binding: binding,
	  cwd: cwd,
	  chdir: chdir,
	  umask: umask,
	  hrtime: hrtime,
	  platform: platform,
	  release: release,
	  config: config,
	  uptime: uptime
	};

	var lookup = [];
	var revLookup = [];
	var Arr = typeof Uint8Array !== 'undefined' ? Uint8Array : Array;
	var inited = false;

	function init() {
	  inited = true;
	  var code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';

	  for (var i = 0, len = code.length; i < len; ++i) {
	    lookup[i] = code[i];
	    revLookup[code.charCodeAt(i)] = i;
	  }

	  revLookup['-'.charCodeAt(0)] = 62;
	  revLookup['_'.charCodeAt(0)] = 63;
	}

	function toByteArray(b64) {
	  if (!inited) {
	    init();
	  }

	  var i, j, l, tmp, placeHolders, arr;
	  var len = b64.length;

	  if (len % 4 > 0) {
	    throw new Error('Invalid string. Length must be a multiple of 4');
	  } // the number of equal signs (place holders)
	  // if there are two placeholders, than the two characters before it
	  // represent one byte
	  // if there is only one, then the three characters before it represent 2 bytes
	  // this is just a cheap hack to not do indexOf twice


	  placeHolders = b64[len - 2] === '=' ? 2 : b64[len - 1] === '=' ? 1 : 0; // base64 is 4/3 + up to two characters of the original data

	  arr = new Arr(len * 3 / 4 - placeHolders); // if there are placeholders, only get up to the last complete 4 chars

	  l = placeHolders > 0 ? len - 4 : len;
	  var L = 0;

	  for (i = 0, j = 0; i < l; i += 4, j += 3) {
	    tmp = revLookup[b64.charCodeAt(i)] << 18 | revLookup[b64.charCodeAt(i + 1)] << 12 | revLookup[b64.charCodeAt(i + 2)] << 6 | revLookup[b64.charCodeAt(i + 3)];
	    arr[L++] = tmp >> 16 & 0xFF;
	    arr[L++] = tmp >> 8 & 0xFF;
	    arr[L++] = tmp & 0xFF;
	  }

	  if (placeHolders === 2) {
	    tmp = revLookup[b64.charCodeAt(i)] << 2 | revLookup[b64.charCodeAt(i + 1)] >> 4;
	    arr[L++] = tmp & 0xFF;
	  } else if (placeHolders === 1) {
	    tmp = revLookup[b64.charCodeAt(i)] << 10 | revLookup[b64.charCodeAt(i + 1)] << 4 | revLookup[b64.charCodeAt(i + 2)] >> 2;
	    arr[L++] = tmp >> 8 & 0xFF;
	    arr[L++] = tmp & 0xFF;
	  }

	  return arr;
	}

	function tripletToBase64(num) {
	  return lookup[num >> 18 & 0x3F] + lookup[num >> 12 & 0x3F] + lookup[num >> 6 & 0x3F] + lookup[num & 0x3F];
	}

	function encodeChunk(uint8, start, end) {
	  var tmp;
	  var output = [];

	  for (var i = start; i < end; i += 3) {
	    tmp = (uint8[i] << 16) + (uint8[i + 1] << 8) + uint8[i + 2];
	    output.push(tripletToBase64(tmp));
	  }

	  return output.join('');
	}

	function fromByteArray(uint8) {
	  if (!inited) {
	    init();
	  }

	  var tmp;
	  var len = uint8.length;
	  var extraBytes = len % 3; // if we have 1 byte left, pad 2 bytes

	  var output = '';
	  var parts = [];
	  var maxChunkLength = 16383; // must be multiple of 3
	  // go through the array every three bytes, we'll deal with trailing stuff later

	  for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
	    parts.push(encodeChunk(uint8, i, i + maxChunkLength > len2 ? len2 : i + maxChunkLength));
	  } // pad the end with zeros, but make sure to not forget the extra bytes


	  if (extraBytes === 1) {
	    tmp = uint8[len - 1];
	    output += lookup[tmp >> 2];
	    output += lookup[tmp << 4 & 0x3F];
	    output += '==';
	  } else if (extraBytes === 2) {
	    tmp = (uint8[len - 2] << 8) + uint8[len - 1];
	    output += lookup[tmp >> 10];
	    output += lookup[tmp >> 4 & 0x3F];
	    output += lookup[tmp << 2 & 0x3F];
	    output += '=';
	  }

	  parts.push(output);
	  return parts.join('');
	}

	var base64 = /*#__PURE__*/Object.freeze({
		toByteArray: toByteArray,
		fromByteArray: fromByteArray
	});

	function read(buffer, offset, isLE, mLen, nBytes) {
	  var e, m;
	  var eLen = nBytes * 8 - mLen - 1;
	  var eMax = (1 << eLen) - 1;
	  var eBias = eMax >> 1;
	  var nBits = -7;
	  var i = isLE ? nBytes - 1 : 0;
	  var d = isLE ? -1 : 1;
	  var s = buffer[offset + i];
	  i += d;
	  e = s & (1 << -nBits) - 1;
	  s >>= -nBits;
	  nBits += eLen;

	  for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {}

	  m = e & (1 << -nBits) - 1;
	  e >>= -nBits;
	  nBits += mLen;

	  for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {}

	  if (e === 0) {
	    e = 1 - eBias;
	  } else if (e === eMax) {
	    return m ? NaN : (s ? -1 : 1) * Infinity;
	  } else {
	    m = m + Math.pow(2, mLen);
	    e = e - eBias;
	  }

	  return (s ? -1 : 1) * m * Math.pow(2, e - mLen);
	}
	function write(buffer, value, offset, isLE, mLen, nBytes) {
	  var e, m, c;
	  var eLen = nBytes * 8 - mLen - 1;
	  var eMax = (1 << eLen) - 1;
	  var eBias = eMax >> 1;
	  var rt = mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0;
	  var i = isLE ? 0 : nBytes - 1;
	  var d = isLE ? 1 : -1;
	  var s = value < 0 || value === 0 && 1 / value < 0 ? 1 : 0;
	  value = Math.abs(value);

	  if (isNaN(value) || value === Infinity) {
	    m = isNaN(value) ? 1 : 0;
	    e = eMax;
	  } else {
	    e = Math.floor(Math.log(value) / Math.LN2);

	    if (value * (c = Math.pow(2, -e)) < 1) {
	      e--;
	      c *= 2;
	    }

	    if (e + eBias >= 1) {
	      value += rt / c;
	    } else {
	      value += rt * Math.pow(2, 1 - eBias);
	    }

	    if (value * c >= 2) {
	      e++;
	      c /= 2;
	    }

	    if (e + eBias >= eMax) {
	      m = 0;
	      e = eMax;
	    } else if (e + eBias >= 1) {
	      m = (value * c - 1) * Math.pow(2, mLen);
	      e = e + eBias;
	    } else {
	      m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen);
	      e = 0;
	    }
	  }

	  for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

	  e = e << mLen | m;
	  eLen += mLen;

	  for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

	  buffer[offset + i - d] |= s * 128;
	}

	var toString = {}.toString;
	var isArray = Array.isArray || function (arr) {
	  return toString.call(arr) == '[object Array]';
	};

	var INSPECT_MAX_BYTES = 50;
	/**
	 * If `Buffer.TYPED_ARRAY_SUPPORT`:
	 *   === true    Use Uint8Array implementation (fastest)
	 *   === false   Use Object implementation (most compatible, even IE6)
	 *
	 * Browsers that support typed arrays are IE 10+, Firefox 4+, Chrome 7+, Safari 5.1+,
	 * Opera 11.6+, iOS 4.2+.
	 *
	 * Due to various browser bugs, sometimes the Object implementation will be used even
	 * when the browser supports typed arrays.
	 *
	 * Note:
	 *
	 *   - Firefox 4-29 lacks support for adding new properties to `Uint8Array` instances,
	 *     See: https://bugzilla.mozilla.org/show_bug.cgi?id=695438.
	 *
	 *   - Chrome 9-10 is missing the `TypedArray.prototype.subarray` function.
	 *
	 *   - IE10 has a broken `TypedArray.prototype.subarray` function which returns arrays of
	 *     incorrect length in some situations.

	 * We detect these buggy browsers and set `Buffer.TYPED_ARRAY_SUPPORT` to `false` so they
	 * get the Object implementation, which is slower but behaves correctly.
	 */

	Buffer.TYPED_ARRAY_SUPPORT = global$1.TYPED_ARRAY_SUPPORT !== undefined ? global$1.TYPED_ARRAY_SUPPORT : true;

	function kMaxLength() {
	  return Buffer.TYPED_ARRAY_SUPPORT ? 0x7fffffff : 0x3fffffff;
	}

	function createBuffer(that, length) {
	  if (kMaxLength() < length) {
	    throw new RangeError('Invalid typed array length');
	  }

	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    // Return an augmented `Uint8Array` instance, for best performance
	    that = new Uint8Array(length);
	    that.__proto__ = Buffer.prototype;
	  } else {
	    // Fallback: Return an object instance of the Buffer class
	    if (that === null) {
	      that = new Buffer(length);
	    }

	    that.length = length;
	  }

	  return that;
	}
	/**
	 * The Buffer constructor returns instances of `Uint8Array` that have their
	 * prototype changed to `Buffer.prototype`. Furthermore, `Buffer` is a subclass of
	 * `Uint8Array`, so the returned instances will have all the node `Buffer` methods
	 * and the `Uint8Array` methods. Square bracket notation works as expected -- it
	 * returns a single octet.
	 *
	 * The `Uint8Array` prototype remains unmodified.
	 */


	function Buffer(arg, encodingOrOffset, length) {
	  if (!Buffer.TYPED_ARRAY_SUPPORT && !(this instanceof Buffer)) {
	    return new Buffer(arg, encodingOrOffset, length);
	  } // Common case.


	  if (typeof arg === 'number') {
	    if (typeof encodingOrOffset === 'string') {
	      throw new Error('If encoding is specified then the first argument must be a string');
	    }

	    return allocUnsafe(this, arg);
	  }

	  return from(this, arg, encodingOrOffset, length);
	}
	Buffer.poolSize = 8192; // not used by this implementation
	// TODO: Legacy, not needed anymore. Remove in next major version.

	Buffer._augment = function (arr) {
	  arr.__proto__ = Buffer.prototype;
	  return arr;
	};

	function from(that, value, encodingOrOffset, length) {
	  if (typeof value === 'number') {
	    throw new TypeError('"value" argument must not be a number');
	  }

	  if (typeof ArrayBuffer !== 'undefined' && value instanceof ArrayBuffer) {
	    return fromArrayBuffer(that, value, encodingOrOffset, length);
	  }

	  if (typeof value === 'string') {
	    return fromString(that, value, encodingOrOffset);
	  }

	  return fromObject(that, value);
	}
	/**
	 * Functionally equivalent to Buffer(arg, encoding) but throws a TypeError
	 * if value is a number.
	 * Buffer.from(str[, encoding])
	 * Buffer.from(array)
	 * Buffer.from(buffer)
	 * Buffer.from(arrayBuffer[, byteOffset[, length]])
	 **/


	Buffer.from = function (value, encodingOrOffset, length) {
	  return from(null, value, encodingOrOffset, length);
	};

	if (Buffer.TYPED_ARRAY_SUPPORT) {
	  Buffer.prototype.__proto__ = Uint8Array.prototype;
	  Buffer.__proto__ = Uint8Array;
	}

	function assertSize(size) {
	  if (typeof size !== 'number') {
	    throw new TypeError('"size" argument must be a number');
	  } else if (size < 0) {
	    throw new RangeError('"size" argument must not be negative');
	  }
	}

	function alloc(that, size, fill, encoding) {
	  assertSize(size);

	  if (size <= 0) {
	    return createBuffer(that, size);
	  }

	  if (fill !== undefined) {
	    // Only pay attention to encoding if it's a string. This
	    // prevents accidentally sending in a number that would
	    // be interpretted as a start offset.
	    return typeof encoding === 'string' ? createBuffer(that, size).fill(fill, encoding) : createBuffer(that, size).fill(fill);
	  }

	  return createBuffer(that, size);
	}
	/**
	 * Creates a new filled Buffer instance.
	 * alloc(size[, fill[, encoding]])
	 **/


	Buffer.alloc = function (size, fill, encoding) {
	  return alloc(null, size, fill, encoding);
	};

	function allocUnsafe(that, size) {
	  assertSize(size);
	  that = createBuffer(that, size < 0 ? 0 : checked(size) | 0);

	  if (!Buffer.TYPED_ARRAY_SUPPORT) {
	    for (var i = 0; i < size; ++i) {
	      that[i] = 0;
	    }
	  }

	  return that;
	}
	/**
	 * Equivalent to Buffer(num), by default creates a non-zero-filled Buffer instance.
	 * */


	Buffer.allocUnsafe = function (size) {
	  return allocUnsafe(null, size);
	};
	/**
	 * Equivalent to SlowBuffer(num), by default creates a non-zero-filled Buffer instance.
	 */


	Buffer.allocUnsafeSlow = function (size) {
	  return allocUnsafe(null, size);
	};

	function fromString(that, string, encoding) {
	  if (typeof encoding !== 'string' || encoding === '') {
	    encoding = 'utf8';
	  }

	  if (!Buffer.isEncoding(encoding)) {
	    throw new TypeError('"encoding" must be a valid string encoding');
	  }

	  var length = byteLength(string, encoding) | 0;
	  that = createBuffer(that, length);
	  var actual = that.write(string, encoding);

	  if (actual !== length) {
	    // Writing a hex string, for example, that contains invalid characters will
	    // cause everything after the first invalid character to be ignored. (e.g.
	    // 'abxxcd' will be treated as 'ab')
	    that = that.slice(0, actual);
	  }

	  return that;
	}

	function fromArrayLike(that, array) {
	  var length = array.length < 0 ? 0 : checked(array.length) | 0;
	  that = createBuffer(that, length);

	  for (var i = 0; i < length; i += 1) {
	    that[i] = array[i] & 255;
	  }

	  return that;
	}

	function fromArrayBuffer(that, array, byteOffset, length) {
	  array.byteLength; // this throws if `array` is not a valid ArrayBuffer

	  if (byteOffset < 0 || array.byteLength < byteOffset) {
	    throw new RangeError('\'offset\' is out of bounds');
	  }

	  if (array.byteLength < byteOffset + (length || 0)) {
	    throw new RangeError('\'length\' is out of bounds');
	  }

	  if (byteOffset === undefined && length === undefined) {
	    array = new Uint8Array(array);
	  } else if (length === undefined) {
	    array = new Uint8Array(array, byteOffset);
	  } else {
	    array = new Uint8Array(array, byteOffset, length);
	  }

	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    // Return an augmented `Uint8Array` instance, for best performance
	    that = array;
	    that.__proto__ = Buffer.prototype;
	  } else {
	    // Fallback: Return an object instance of the Buffer class
	    that = fromArrayLike(that, array);
	  }

	  return that;
	}

	function fromObject(that, obj) {
	  if (internalIsBuffer(obj)) {
	    var len = checked(obj.length) | 0;
	    that = createBuffer(that, len);

	    if (that.length === 0) {
	      return that;
	    }

	    obj.copy(that, 0, 0, len);
	    return that;
	  }

	  if (obj) {
	    if (typeof ArrayBuffer !== 'undefined' && obj.buffer instanceof ArrayBuffer || 'length' in obj) {
	      if (typeof obj.length !== 'number' || isnan(obj.length)) {
	        return createBuffer(that, 0);
	      }

	      return fromArrayLike(that, obj);
	    }

	    if (obj.type === 'Buffer' && isArray(obj.data)) {
	      return fromArrayLike(that, obj.data);
	    }
	  }

	  throw new TypeError('First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.');
	}

	function checked(length) {
	  // Note: cannot use `length < kMaxLength()` here because that fails when
	  // length is NaN (which is otherwise coerced to zero.)
	  if (length >= kMaxLength()) {
	    throw new RangeError('Attempt to allocate Buffer larger than maximum ' + 'size: 0x' + kMaxLength().toString(16) + ' bytes');
	  }

	  return length | 0;
	}
	Buffer.isBuffer = isBuffer;

	function internalIsBuffer(b) {
	  return !!(b != null && b._isBuffer);
	}

	Buffer.compare = function compare(a, b) {
	  if (!internalIsBuffer(a) || !internalIsBuffer(b)) {
	    throw new TypeError('Arguments must be Buffers');
	  }

	  if (a === b) return 0;
	  var x = a.length;
	  var y = b.length;

	  for (var i = 0, len = Math.min(x, y); i < len; ++i) {
	    if (a[i] !== b[i]) {
	      x = a[i];
	      y = b[i];
	      break;
	    }
	  }

	  if (x < y) return -1;
	  if (y < x) return 1;
	  return 0;
	};

	Buffer.isEncoding = function isEncoding(encoding) {
	  switch (String(encoding).toLowerCase()) {
	    case 'hex':
	    case 'utf8':
	    case 'utf-8':
	    case 'ascii':
	    case 'latin1':
	    case 'binary':
	    case 'base64':
	    case 'ucs2':
	    case 'ucs-2':
	    case 'utf16le':
	    case 'utf-16le':
	      return true;

	    default:
	      return false;
	  }
	};

	Buffer.concat = function concat(list, length) {
	  if (!isArray(list)) {
	    throw new TypeError('"list" argument must be an Array of Buffers');
	  }

	  if (list.length === 0) {
	    return Buffer.alloc(0);
	  }

	  var i;

	  if (length === undefined) {
	    length = 0;

	    for (i = 0; i < list.length; ++i) {
	      length += list[i].length;
	    }
	  }

	  var buffer = Buffer.allocUnsafe(length);
	  var pos = 0;

	  for (i = 0; i < list.length; ++i) {
	    var buf = list[i];

	    if (!internalIsBuffer(buf)) {
	      throw new TypeError('"list" argument must be an Array of Buffers');
	    }

	    buf.copy(buffer, pos);
	    pos += buf.length;
	  }

	  return buffer;
	};

	function byteLength(string, encoding) {
	  if (internalIsBuffer(string)) {
	    return string.length;
	  }

	  if (typeof ArrayBuffer !== 'undefined' && typeof ArrayBuffer.isView === 'function' && (ArrayBuffer.isView(string) || string instanceof ArrayBuffer)) {
	    return string.byteLength;
	  }

	  if (typeof string !== 'string') {
	    string = '' + string;
	  }

	  var len = string.length;
	  if (len === 0) return 0; // Use a for loop to avoid recursion

	  var loweredCase = false;

	  for (;;) {
	    switch (encoding) {
	      case 'ascii':
	      case 'latin1':
	      case 'binary':
	        return len;

	      case 'utf8':
	      case 'utf-8':
	      case undefined:
	        return utf8ToBytes(string).length;

	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return len * 2;

	      case 'hex':
	        return len >>> 1;

	      case 'base64':
	        return base64ToBytes(string).length;

	      default:
	        if (loweredCase) return utf8ToBytes(string).length; // assume utf8

	        encoding = ('' + encoding).toLowerCase();
	        loweredCase = true;
	    }
	  }
	}

	Buffer.byteLength = byteLength;

	function slowToString(encoding, start, end) {
	  var loweredCase = false; // No need to verify that "this.length <= MAX_UINT32" since it's a read-only
	  // property of a typed array.
	  // This behaves neither like String nor Uint8Array in that we set start/end
	  // to their upper/lower bounds if the value passed is out of range.
	  // undefined is handled specially as per ECMA-262 6th Edition,
	  // Section 13.3.3.7 Runtime Semantics: KeyedBindingInitialization.

	  if (start === undefined || start < 0) {
	    start = 0;
	  } // Return early if start > this.length. Done here to prevent potential uint32
	  // coercion fail below.


	  if (start > this.length) {
	    return '';
	  }

	  if (end === undefined || end > this.length) {
	    end = this.length;
	  }

	  if (end <= 0) {
	    return '';
	  } // Force coersion to uint32. This will also coerce falsey/NaN values to 0.


	  end >>>= 0;
	  start >>>= 0;

	  if (end <= start) {
	    return '';
	  }

	  if (!encoding) encoding = 'utf8';

	  while (true) {
	    switch (encoding) {
	      case 'hex':
	        return hexSlice(this, start, end);

	      case 'utf8':
	      case 'utf-8':
	        return utf8Slice(this, start, end);

	      case 'ascii':
	        return asciiSlice(this, start, end);

	      case 'latin1':
	      case 'binary':
	        return latin1Slice(this, start, end);

	      case 'base64':
	        return base64Slice(this, start, end);

	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return utf16leSlice(this, start, end);

	      default:
	        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding);
	        encoding = (encoding + '').toLowerCase();
	        loweredCase = true;
	    }
	  }
	} // The property is used by `Buffer.isBuffer` and `is-buffer` (in Safari 5-7) to detect
	// Buffer instances.


	Buffer.prototype._isBuffer = true;

	function swap(b, n, m) {
	  var i = b[n];
	  b[n] = b[m];
	  b[m] = i;
	}

	Buffer.prototype.swap16 = function swap16() {
	  var len = this.length;

	  if (len % 2 !== 0) {
	    throw new RangeError('Buffer size must be a multiple of 16-bits');
	  }

	  for (var i = 0; i < len; i += 2) {
	    swap(this, i, i + 1);
	  }

	  return this;
	};

	Buffer.prototype.swap32 = function swap32() {
	  var len = this.length;

	  if (len % 4 !== 0) {
	    throw new RangeError('Buffer size must be a multiple of 32-bits');
	  }

	  for (var i = 0; i < len; i += 4) {
	    swap(this, i, i + 3);
	    swap(this, i + 1, i + 2);
	  }

	  return this;
	};

	Buffer.prototype.swap64 = function swap64() {
	  var len = this.length;

	  if (len % 8 !== 0) {
	    throw new RangeError('Buffer size must be a multiple of 64-bits');
	  }

	  for (var i = 0; i < len; i += 8) {
	    swap(this, i, i + 7);
	    swap(this, i + 1, i + 6);
	    swap(this, i + 2, i + 5);
	    swap(this, i + 3, i + 4);
	  }

	  return this;
	};

	Buffer.prototype.toString = function toString() {
	  var length = this.length | 0;
	  if (length === 0) return '';
	  if (arguments.length === 0) return utf8Slice(this, 0, length);
	  return slowToString.apply(this, arguments);
	};

	Buffer.prototype.equals = function equals(b) {
	  if (!internalIsBuffer(b)) throw new TypeError('Argument must be a Buffer');
	  if (this === b) return true;
	  return Buffer.compare(this, b) === 0;
	};

	Buffer.prototype.inspect = function inspect() {
	  var str = '';
	  var max = INSPECT_MAX_BYTES;

	  if (this.length > 0) {
	    str = this.toString('hex', 0, max).match(/.{2}/g).join(' ');
	    if (this.length > max) str += ' ... ';
	  }

	  return '<Buffer ' + str + '>';
	};

	Buffer.prototype.compare = function compare(target, start, end, thisStart, thisEnd) {
	  if (!internalIsBuffer(target)) {
	    throw new TypeError('Argument must be a Buffer');
	  }

	  if (start === undefined) {
	    start = 0;
	  }

	  if (end === undefined) {
	    end = target ? target.length : 0;
	  }

	  if (thisStart === undefined) {
	    thisStart = 0;
	  }

	  if (thisEnd === undefined) {
	    thisEnd = this.length;
	  }

	  if (start < 0 || end > target.length || thisStart < 0 || thisEnd > this.length) {
	    throw new RangeError('out of range index');
	  }

	  if (thisStart >= thisEnd && start >= end) {
	    return 0;
	  }

	  if (thisStart >= thisEnd) {
	    return -1;
	  }

	  if (start >= end) {
	    return 1;
	  }

	  start >>>= 0;
	  end >>>= 0;
	  thisStart >>>= 0;
	  thisEnd >>>= 0;
	  if (this === target) return 0;
	  var x = thisEnd - thisStart;
	  var y = end - start;
	  var len = Math.min(x, y);
	  var thisCopy = this.slice(thisStart, thisEnd);
	  var targetCopy = target.slice(start, end);

	  for (var i = 0; i < len; ++i) {
	    if (thisCopy[i] !== targetCopy[i]) {
	      x = thisCopy[i];
	      y = targetCopy[i];
	      break;
	    }
	  }

	  if (x < y) return -1;
	  if (y < x) return 1;
	  return 0;
	}; // Finds either the first index of `val` in `buffer` at offset >= `byteOffset`,
	// OR the last index of `val` in `buffer` at offset <= `byteOffset`.
	//
	// Arguments:
	// - buffer - a Buffer to search
	// - val - a string, Buffer, or number
	// - byteOffset - an index into `buffer`; will be clamped to an int32
	// - encoding - an optional encoding, relevant is val is a string
	// - dir - true for indexOf, false for lastIndexOf


	function bidirectionalIndexOf(buffer, val, byteOffset, encoding, dir) {
	  // Empty buffer means no match
	  if (buffer.length === 0) return -1; // Normalize byteOffset

	  if (typeof byteOffset === 'string') {
	    encoding = byteOffset;
	    byteOffset = 0;
	  } else if (byteOffset > 0x7fffffff) {
	    byteOffset = 0x7fffffff;
	  } else if (byteOffset < -0x80000000) {
	    byteOffset = -0x80000000;
	  }

	  byteOffset = +byteOffset; // Coerce to Number.

	  if (isNaN(byteOffset)) {
	    // byteOffset: it it's undefined, null, NaN, "foo", etc, search whole buffer
	    byteOffset = dir ? 0 : buffer.length - 1;
	  } // Normalize byteOffset: negative offsets start from the end of the buffer


	  if (byteOffset < 0) byteOffset = buffer.length + byteOffset;

	  if (byteOffset >= buffer.length) {
	    if (dir) return -1;else byteOffset = buffer.length - 1;
	  } else if (byteOffset < 0) {
	    if (dir) byteOffset = 0;else return -1;
	  } // Normalize val


	  if (typeof val === 'string') {
	    val = Buffer.from(val, encoding);
	  } // Finally, search either indexOf (if dir is true) or lastIndexOf


	  if (internalIsBuffer(val)) {
	    // Special case: looking for empty string/buffer always fails
	    if (val.length === 0) {
	      return -1;
	    }

	    return arrayIndexOf(buffer, val, byteOffset, encoding, dir);
	  } else if (typeof val === 'number') {
	    val = val & 0xFF; // Search for a byte value [0-255]

	    if (Buffer.TYPED_ARRAY_SUPPORT && typeof Uint8Array.prototype.indexOf === 'function') {
	      if (dir) {
	        return Uint8Array.prototype.indexOf.call(buffer, val, byteOffset);
	      } else {
	        return Uint8Array.prototype.lastIndexOf.call(buffer, val, byteOffset);
	      }
	    }

	    return arrayIndexOf(buffer, [val], byteOffset, encoding, dir);
	  }

	  throw new TypeError('val must be string, number or Buffer');
	}

	function arrayIndexOf(arr, val, byteOffset, encoding, dir) {
	  var indexSize = 1;
	  var arrLength = arr.length;
	  var valLength = val.length;

	  if (encoding !== undefined) {
	    encoding = String(encoding).toLowerCase();

	    if (encoding === 'ucs2' || encoding === 'ucs-2' || encoding === 'utf16le' || encoding === 'utf-16le') {
	      if (arr.length < 2 || val.length < 2) {
	        return -1;
	      }

	      indexSize = 2;
	      arrLength /= 2;
	      valLength /= 2;
	      byteOffset /= 2;
	    }
	  }

	  function read(buf, i) {
	    if (indexSize === 1) {
	      return buf[i];
	    } else {
	      return buf.readUInt16BE(i * indexSize);
	    }
	  }

	  var i;

	  if (dir) {
	    var foundIndex = -1;

	    for (i = byteOffset; i < arrLength; i++) {
	      if (read(arr, i) === read(val, foundIndex === -1 ? 0 : i - foundIndex)) {
	        if (foundIndex === -1) foundIndex = i;
	        if (i - foundIndex + 1 === valLength) return foundIndex * indexSize;
	      } else {
	        if (foundIndex !== -1) i -= i - foundIndex;
	        foundIndex = -1;
	      }
	    }
	  } else {
	    if (byteOffset + valLength > arrLength) byteOffset = arrLength - valLength;

	    for (i = byteOffset; i >= 0; i--) {
	      var found = true;

	      for (var j = 0; j < valLength; j++) {
	        if (read(arr, i + j) !== read(val, j)) {
	          found = false;
	          break;
	        }
	      }

	      if (found) return i;
	    }
	  }

	  return -1;
	}

	Buffer.prototype.includes = function includes(val, byteOffset, encoding) {
	  return this.indexOf(val, byteOffset, encoding) !== -1;
	};

	Buffer.prototype.indexOf = function indexOf(val, byteOffset, encoding) {
	  return bidirectionalIndexOf(this, val, byteOffset, encoding, true);
	};

	Buffer.prototype.lastIndexOf = function lastIndexOf(val, byteOffset, encoding) {
	  return bidirectionalIndexOf(this, val, byteOffset, encoding, false);
	};

	function hexWrite(buf, string, offset, length) {
	  offset = Number(offset) || 0;
	  var remaining = buf.length - offset;

	  if (!length) {
	    length = remaining;
	  } else {
	    length = Number(length);

	    if (length > remaining) {
	      length = remaining;
	    }
	  } // must be an even number of digits


	  var strLen = string.length;
	  if (strLen % 2 !== 0) throw new TypeError('Invalid hex string');

	  if (length > strLen / 2) {
	    length = strLen / 2;
	  }

	  for (var i = 0; i < length; ++i) {
	    var parsed = parseInt(string.substr(i * 2, 2), 16);
	    if (isNaN(parsed)) return i;
	    buf[offset + i] = parsed;
	  }

	  return i;
	}

	function utf8Write(buf, string, offset, length) {
	  return blitBuffer(utf8ToBytes(string, buf.length - offset), buf, offset, length);
	}

	function asciiWrite(buf, string, offset, length) {
	  return blitBuffer(asciiToBytes(string), buf, offset, length);
	}

	function latin1Write(buf, string, offset, length) {
	  return asciiWrite(buf, string, offset, length);
	}

	function base64Write(buf, string, offset, length) {
	  return blitBuffer(base64ToBytes(string), buf, offset, length);
	}

	function ucs2Write(buf, string, offset, length) {
	  return blitBuffer(utf16leToBytes(string, buf.length - offset), buf, offset, length);
	}

	Buffer.prototype.write = function write(string, offset, length, encoding) {
	  // Buffer#write(string)
	  if (offset === undefined) {
	    encoding = 'utf8';
	    length = this.length;
	    offset = 0; // Buffer#write(string, encoding)
	  } else if (length === undefined && typeof offset === 'string') {
	    encoding = offset;
	    length = this.length;
	    offset = 0; // Buffer#write(string, offset[, length][, encoding])
	  } else if (isFinite(offset)) {
	    offset = offset | 0;

	    if (isFinite(length)) {
	      length = length | 0;
	      if (encoding === undefined) encoding = 'utf8';
	    } else {
	      encoding = length;
	      length = undefined;
	    } // legacy write(string, encoding, offset, length) - remove in v0.13

	  } else {
	    throw new Error('Buffer.write(string, encoding, offset[, length]) is no longer supported');
	  }

	  var remaining = this.length - offset;
	  if (length === undefined || length > remaining) length = remaining;

	  if (string.length > 0 && (length < 0 || offset < 0) || offset > this.length) {
	    throw new RangeError('Attempt to write outside buffer bounds');
	  }

	  if (!encoding) encoding = 'utf8';
	  var loweredCase = false;

	  for (;;) {
	    switch (encoding) {
	      case 'hex':
	        return hexWrite(this, string, offset, length);

	      case 'utf8':
	      case 'utf-8':
	        return utf8Write(this, string, offset, length);

	      case 'ascii':
	        return asciiWrite(this, string, offset, length);

	      case 'latin1':
	      case 'binary':
	        return latin1Write(this, string, offset, length);

	      case 'base64':
	        // Warning: maxLength not taken into account in base64Write
	        return base64Write(this, string, offset, length);

	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return ucs2Write(this, string, offset, length);

	      default:
	        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding);
	        encoding = ('' + encoding).toLowerCase();
	        loweredCase = true;
	    }
	  }
	};

	Buffer.prototype.toJSON = function toJSON() {
	  return {
	    type: 'Buffer',
	    data: Array.prototype.slice.call(this._arr || this, 0)
	  };
	};

	function base64Slice(buf, start, end) {
	  if (start === 0 && end === buf.length) {
	    return fromByteArray(buf);
	  } else {
	    return fromByteArray(buf.slice(start, end));
	  }
	}

	function utf8Slice(buf, start, end) {
	  end = Math.min(buf.length, end);
	  var res = [];
	  var i = start;

	  while (i < end) {
	    var firstByte = buf[i];
	    var codePoint = null;
	    var bytesPerSequence = firstByte > 0xEF ? 4 : firstByte > 0xDF ? 3 : firstByte > 0xBF ? 2 : 1;

	    if (i + bytesPerSequence <= end) {
	      var secondByte, thirdByte, fourthByte, tempCodePoint;

	      switch (bytesPerSequence) {
	        case 1:
	          if (firstByte < 0x80) {
	            codePoint = firstByte;
	          }

	          break;

	        case 2:
	          secondByte = buf[i + 1];

	          if ((secondByte & 0xC0) === 0x80) {
	            tempCodePoint = (firstByte & 0x1F) << 0x6 | secondByte & 0x3F;

	            if (tempCodePoint > 0x7F) {
	              codePoint = tempCodePoint;
	            }
	          }

	          break;

	        case 3:
	          secondByte = buf[i + 1];
	          thirdByte = buf[i + 2];

	          if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80) {
	            tempCodePoint = (firstByte & 0xF) << 0xC | (secondByte & 0x3F) << 0x6 | thirdByte & 0x3F;

	            if (tempCodePoint > 0x7FF && (tempCodePoint < 0xD800 || tempCodePoint > 0xDFFF)) {
	              codePoint = tempCodePoint;
	            }
	          }

	          break;

	        case 4:
	          secondByte = buf[i + 1];
	          thirdByte = buf[i + 2];
	          fourthByte = buf[i + 3];

	          if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80 && (fourthByte & 0xC0) === 0x80) {
	            tempCodePoint = (firstByte & 0xF) << 0x12 | (secondByte & 0x3F) << 0xC | (thirdByte & 0x3F) << 0x6 | fourthByte & 0x3F;

	            if (tempCodePoint > 0xFFFF && tempCodePoint < 0x110000) {
	              codePoint = tempCodePoint;
	            }
	          }

	      }
	    }

	    if (codePoint === null) {
	      // we did not generate a valid codePoint so insert a
	      // replacement char (U+FFFD) and advance only 1 byte
	      codePoint = 0xFFFD;
	      bytesPerSequence = 1;
	    } else if (codePoint > 0xFFFF) {
	      // encode to utf16 (surrogate pair dance)
	      codePoint -= 0x10000;
	      res.push(codePoint >>> 10 & 0x3FF | 0xD800);
	      codePoint = 0xDC00 | codePoint & 0x3FF;
	    }

	    res.push(codePoint);
	    i += bytesPerSequence;
	  }

	  return decodeCodePointsArray(res);
	} // Based on http://stackoverflow.com/a/22747272/680742, the browser with
	// the lowest limit is Chrome, with 0x10000 args.
	// We go 1 magnitude less, for safety


	var MAX_ARGUMENTS_LENGTH = 0x1000;

	function decodeCodePointsArray(codePoints) {
	  var len = codePoints.length;

	  if (len <= MAX_ARGUMENTS_LENGTH) {
	    return String.fromCharCode.apply(String, codePoints); // avoid extra slice()
	  } // Decode in chunks to avoid "call stack size exceeded".


	  var res = '';
	  var i = 0;

	  while (i < len) {
	    res += String.fromCharCode.apply(String, codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH));
	  }

	  return res;
	}

	function asciiSlice(buf, start, end) {
	  var ret = '';
	  end = Math.min(buf.length, end);

	  for (var i = start; i < end; ++i) {
	    ret += String.fromCharCode(buf[i] & 0x7F);
	  }

	  return ret;
	}

	function latin1Slice(buf, start, end) {
	  var ret = '';
	  end = Math.min(buf.length, end);

	  for (var i = start; i < end; ++i) {
	    ret += String.fromCharCode(buf[i]);
	  }

	  return ret;
	}

	function hexSlice(buf, start, end) {
	  var len = buf.length;
	  if (!start || start < 0) start = 0;
	  if (!end || end < 0 || end > len) end = len;
	  var out = '';

	  for (var i = start; i < end; ++i) {
	    out += toHex(buf[i]);
	  }

	  return out;
	}

	function utf16leSlice(buf, start, end) {
	  var bytes = buf.slice(start, end);
	  var res = '';

	  for (var i = 0; i < bytes.length; i += 2) {
	    res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256);
	  }

	  return res;
	}

	Buffer.prototype.slice = function slice(start, end) {
	  var len = this.length;
	  start = ~~start;
	  end = end === undefined ? len : ~~end;

	  if (start < 0) {
	    start += len;
	    if (start < 0) start = 0;
	  } else if (start > len) {
	    start = len;
	  }

	  if (end < 0) {
	    end += len;
	    if (end < 0) end = 0;
	  } else if (end > len) {
	    end = len;
	  }

	  if (end < start) end = start;
	  var newBuf;

	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    newBuf = this.subarray(start, end);
	    newBuf.__proto__ = Buffer.prototype;
	  } else {
	    var sliceLen = end - start;
	    newBuf = new Buffer(sliceLen, undefined);

	    for (var i = 0; i < sliceLen; ++i) {
	      newBuf[i] = this[i + start];
	    }
	  }

	  return newBuf;
	};
	/*
	 * Need to make sure that buffer isn't trying to write out of bounds.
	 */


	function checkOffset(offset, ext, length) {
	  if (offset % 1 !== 0 || offset < 0) throw new RangeError('offset is not uint');
	  if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length');
	}

	Buffer.prototype.readUIntLE = function readUIntLE(offset, byteLength, noAssert) {
	  offset = offset | 0;
	  byteLength = byteLength | 0;
	  if (!noAssert) checkOffset(offset, byteLength, this.length);
	  var val = this[offset];
	  var mul = 1;
	  var i = 0;

	  while (++i < byteLength && (mul *= 0x100)) {
	    val += this[offset + i] * mul;
	  }

	  return val;
	};

	Buffer.prototype.readUIntBE = function readUIntBE(offset, byteLength, noAssert) {
	  offset = offset | 0;
	  byteLength = byteLength | 0;

	  if (!noAssert) {
	    checkOffset(offset, byteLength, this.length);
	  }

	  var val = this[offset + --byteLength];
	  var mul = 1;

	  while (byteLength > 0 && (mul *= 0x100)) {
	    val += this[offset + --byteLength] * mul;
	  }

	  return val;
	};

	Buffer.prototype.readUInt8 = function readUInt8(offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 1, this.length);
	  return this[offset];
	};

	Buffer.prototype.readUInt16LE = function readUInt16LE(offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length);
	  return this[offset] | this[offset + 1] << 8;
	};

	Buffer.prototype.readUInt16BE = function readUInt16BE(offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length);
	  return this[offset] << 8 | this[offset + 1];
	};

	Buffer.prototype.readUInt32LE = function readUInt32LE(offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length);
	  return (this[offset] | this[offset + 1] << 8 | this[offset + 2] << 16) + this[offset + 3] * 0x1000000;
	};

	Buffer.prototype.readUInt32BE = function readUInt32BE(offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length);
	  return this[offset] * 0x1000000 + (this[offset + 1] << 16 | this[offset + 2] << 8 | this[offset + 3]);
	};

	Buffer.prototype.readIntLE = function readIntLE(offset, byteLength, noAssert) {
	  offset = offset | 0;
	  byteLength = byteLength | 0;
	  if (!noAssert) checkOffset(offset, byteLength, this.length);
	  var val = this[offset];
	  var mul = 1;
	  var i = 0;

	  while (++i < byteLength && (mul *= 0x100)) {
	    val += this[offset + i] * mul;
	  }

	  mul *= 0x80;
	  if (val >= mul) val -= Math.pow(2, 8 * byteLength);
	  return val;
	};

	Buffer.prototype.readIntBE = function readIntBE(offset, byteLength, noAssert) {
	  offset = offset | 0;
	  byteLength = byteLength | 0;
	  if (!noAssert) checkOffset(offset, byteLength, this.length);
	  var i = byteLength;
	  var mul = 1;
	  var val = this[offset + --i];

	  while (i > 0 && (mul *= 0x100)) {
	    val += this[offset + --i] * mul;
	  }

	  mul *= 0x80;
	  if (val >= mul) val -= Math.pow(2, 8 * byteLength);
	  return val;
	};

	Buffer.prototype.readInt8 = function readInt8(offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 1, this.length);
	  if (!(this[offset] & 0x80)) return this[offset];
	  return (0xff - this[offset] + 1) * -1;
	};

	Buffer.prototype.readInt16LE = function readInt16LE(offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length);
	  var val = this[offset] | this[offset + 1] << 8;
	  return val & 0x8000 ? val | 0xFFFF0000 : val;
	};

	Buffer.prototype.readInt16BE = function readInt16BE(offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length);
	  var val = this[offset + 1] | this[offset] << 8;
	  return val & 0x8000 ? val | 0xFFFF0000 : val;
	};

	Buffer.prototype.readInt32LE = function readInt32LE(offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length);
	  return this[offset] | this[offset + 1] << 8 | this[offset + 2] << 16 | this[offset + 3] << 24;
	};

	Buffer.prototype.readInt32BE = function readInt32BE(offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length);
	  return this[offset] << 24 | this[offset + 1] << 16 | this[offset + 2] << 8 | this[offset + 3];
	};

	Buffer.prototype.readFloatLE = function readFloatLE(offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length);
	  return read(this, offset, true, 23, 4);
	};

	Buffer.prototype.readFloatBE = function readFloatBE(offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length);
	  return read(this, offset, false, 23, 4);
	};

	Buffer.prototype.readDoubleLE = function readDoubleLE(offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 8, this.length);
	  return read(this, offset, true, 52, 8);
	};

	Buffer.prototype.readDoubleBE = function readDoubleBE(offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 8, this.length);
	  return read(this, offset, false, 52, 8);
	};

	function checkInt(buf, value, offset, ext, max, min) {
	  if (!internalIsBuffer(buf)) throw new TypeError('"buffer" argument must be a Buffer instance');
	  if (value > max || value < min) throw new RangeError('"value" argument is out of bounds');
	  if (offset + ext > buf.length) throw new RangeError('Index out of range');
	}

	Buffer.prototype.writeUIntLE = function writeUIntLE(value, offset, byteLength, noAssert) {
	  value = +value;
	  offset = offset | 0;
	  byteLength = byteLength | 0;

	  if (!noAssert) {
	    var maxBytes = Math.pow(2, 8 * byteLength) - 1;
	    checkInt(this, value, offset, byteLength, maxBytes, 0);
	  }

	  var mul = 1;
	  var i = 0;
	  this[offset] = value & 0xFF;

	  while (++i < byteLength && (mul *= 0x100)) {
	    this[offset + i] = value / mul & 0xFF;
	  }

	  return offset + byteLength;
	};

	Buffer.prototype.writeUIntBE = function writeUIntBE(value, offset, byteLength, noAssert) {
	  value = +value;
	  offset = offset | 0;
	  byteLength = byteLength | 0;

	  if (!noAssert) {
	    var maxBytes = Math.pow(2, 8 * byteLength) - 1;
	    checkInt(this, value, offset, byteLength, maxBytes, 0);
	  }

	  var i = byteLength - 1;
	  var mul = 1;
	  this[offset + i] = value & 0xFF;

	  while (--i >= 0 && (mul *= 0x100)) {
	    this[offset + i] = value / mul & 0xFF;
	  }

	  return offset + byteLength;
	};

	Buffer.prototype.writeUInt8 = function writeUInt8(value, offset, noAssert) {
	  value = +value;
	  offset = offset | 0;
	  if (!noAssert) checkInt(this, value, offset, 1, 0xff, 0);
	  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
	  this[offset] = value & 0xff;
	  return offset + 1;
	};

	function objectWriteUInt16(buf, value, offset, littleEndian) {
	  if (value < 0) value = 0xffff + value + 1;

	  for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; ++i) {
	    buf[offset + i] = (value & 0xff << 8 * (littleEndian ? i : 1 - i)) >>> (littleEndian ? i : 1 - i) * 8;
	  }
	}

	Buffer.prototype.writeUInt16LE = function writeUInt16LE(value, offset, noAssert) {
	  value = +value;
	  offset = offset | 0;
	  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0);

	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = value & 0xff;
	    this[offset + 1] = value >>> 8;
	  } else {
	    objectWriteUInt16(this, value, offset, true);
	  }

	  return offset + 2;
	};

	Buffer.prototype.writeUInt16BE = function writeUInt16BE(value, offset, noAssert) {
	  value = +value;
	  offset = offset | 0;
	  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0);

	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = value >>> 8;
	    this[offset + 1] = value & 0xff;
	  } else {
	    objectWriteUInt16(this, value, offset, false);
	  }

	  return offset + 2;
	};

	function objectWriteUInt32(buf, value, offset, littleEndian) {
	  if (value < 0) value = 0xffffffff + value + 1;

	  for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; ++i) {
	    buf[offset + i] = value >>> (littleEndian ? i : 3 - i) * 8 & 0xff;
	  }
	}

	Buffer.prototype.writeUInt32LE = function writeUInt32LE(value, offset, noAssert) {
	  value = +value;
	  offset = offset | 0;
	  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0);

	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset + 3] = value >>> 24;
	    this[offset + 2] = value >>> 16;
	    this[offset + 1] = value >>> 8;
	    this[offset] = value & 0xff;
	  } else {
	    objectWriteUInt32(this, value, offset, true);
	  }

	  return offset + 4;
	};

	Buffer.prototype.writeUInt32BE = function writeUInt32BE(value, offset, noAssert) {
	  value = +value;
	  offset = offset | 0;
	  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0);

	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = value >>> 24;
	    this[offset + 1] = value >>> 16;
	    this[offset + 2] = value >>> 8;
	    this[offset + 3] = value & 0xff;
	  } else {
	    objectWriteUInt32(this, value, offset, false);
	  }

	  return offset + 4;
	};

	Buffer.prototype.writeIntLE = function writeIntLE(value, offset, byteLength, noAssert) {
	  value = +value;
	  offset = offset | 0;

	  if (!noAssert) {
	    var limit = Math.pow(2, 8 * byteLength - 1);
	    checkInt(this, value, offset, byteLength, limit - 1, -limit);
	  }

	  var i = 0;
	  var mul = 1;
	  var sub = 0;
	  this[offset] = value & 0xFF;

	  while (++i < byteLength && (mul *= 0x100)) {
	    if (value < 0 && sub === 0 && this[offset + i - 1] !== 0) {
	      sub = 1;
	    }

	    this[offset + i] = (value / mul >> 0) - sub & 0xFF;
	  }

	  return offset + byteLength;
	};

	Buffer.prototype.writeIntBE = function writeIntBE(value, offset, byteLength, noAssert) {
	  value = +value;
	  offset = offset | 0;

	  if (!noAssert) {
	    var limit = Math.pow(2, 8 * byteLength - 1);
	    checkInt(this, value, offset, byteLength, limit - 1, -limit);
	  }

	  var i = byteLength - 1;
	  var mul = 1;
	  var sub = 0;
	  this[offset + i] = value & 0xFF;

	  while (--i >= 0 && (mul *= 0x100)) {
	    if (value < 0 && sub === 0 && this[offset + i + 1] !== 0) {
	      sub = 1;
	    }

	    this[offset + i] = (value / mul >> 0) - sub & 0xFF;
	  }

	  return offset + byteLength;
	};

	Buffer.prototype.writeInt8 = function writeInt8(value, offset, noAssert) {
	  value = +value;
	  offset = offset | 0;
	  if (!noAssert) checkInt(this, value, offset, 1, 0x7f, -0x80);
	  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
	  if (value < 0) value = 0xff + value + 1;
	  this[offset] = value & 0xff;
	  return offset + 1;
	};

	Buffer.prototype.writeInt16LE = function writeInt16LE(value, offset, noAssert) {
	  value = +value;
	  offset = offset | 0;
	  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000);

	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = value & 0xff;
	    this[offset + 1] = value >>> 8;
	  } else {
	    objectWriteUInt16(this, value, offset, true);
	  }

	  return offset + 2;
	};

	Buffer.prototype.writeInt16BE = function writeInt16BE(value, offset, noAssert) {
	  value = +value;
	  offset = offset | 0;
	  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000);

	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = value >>> 8;
	    this[offset + 1] = value & 0xff;
	  } else {
	    objectWriteUInt16(this, value, offset, false);
	  }

	  return offset + 2;
	};

	Buffer.prototype.writeInt32LE = function writeInt32LE(value, offset, noAssert) {
	  value = +value;
	  offset = offset | 0;
	  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);

	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = value & 0xff;
	    this[offset + 1] = value >>> 8;
	    this[offset + 2] = value >>> 16;
	    this[offset + 3] = value >>> 24;
	  } else {
	    objectWriteUInt32(this, value, offset, true);
	  }

	  return offset + 4;
	};

	Buffer.prototype.writeInt32BE = function writeInt32BE(value, offset, noAssert) {
	  value = +value;
	  offset = offset | 0;
	  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);
	  if (value < 0) value = 0xffffffff + value + 1;

	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = value >>> 24;
	    this[offset + 1] = value >>> 16;
	    this[offset + 2] = value >>> 8;
	    this[offset + 3] = value & 0xff;
	  } else {
	    objectWriteUInt32(this, value, offset, false);
	  }

	  return offset + 4;
	};

	function checkIEEE754(buf, value, offset, ext, max, min) {
	  if (offset + ext > buf.length) throw new RangeError('Index out of range');
	  if (offset < 0) throw new RangeError('Index out of range');
	}

	function writeFloat(buf, value, offset, littleEndian, noAssert) {
	  if (!noAssert) {
	    checkIEEE754(buf, value, offset, 4, 3.4028234663852886e+38, -3.4028234663852886e+38);
	  }

	  write(buf, value, offset, littleEndian, 23, 4);
	  return offset + 4;
	}

	Buffer.prototype.writeFloatLE = function writeFloatLE(value, offset, noAssert) {
	  return writeFloat(this, value, offset, true, noAssert);
	};

	Buffer.prototype.writeFloatBE = function writeFloatBE(value, offset, noAssert) {
	  return writeFloat(this, value, offset, false, noAssert);
	};

	function writeDouble(buf, value, offset, littleEndian, noAssert) {
	  if (!noAssert) {
	    checkIEEE754(buf, value, offset, 8, 1.7976931348623157E+308, -1.7976931348623157E+308);
	  }

	  write(buf, value, offset, littleEndian, 52, 8);
	  return offset + 8;
	}

	Buffer.prototype.writeDoubleLE = function writeDoubleLE(value, offset, noAssert) {
	  return writeDouble(this, value, offset, true, noAssert);
	};

	Buffer.prototype.writeDoubleBE = function writeDoubleBE(value, offset, noAssert) {
	  return writeDouble(this, value, offset, false, noAssert);
	}; // copy(targetBuffer, targetStart=0, sourceStart=0, sourceEnd=buffer.length)


	Buffer.prototype.copy = function copy(target, targetStart, start, end) {
	  if (!start) start = 0;
	  if (!end && end !== 0) end = this.length;
	  if (targetStart >= target.length) targetStart = target.length;
	  if (!targetStart) targetStart = 0;
	  if (end > 0 && end < start) end = start; // Copy 0 bytes; we're done

	  if (end === start) return 0;
	  if (target.length === 0 || this.length === 0) return 0; // Fatal error conditions

	  if (targetStart < 0) {
	    throw new RangeError('targetStart out of bounds');
	  }

	  if (start < 0 || start >= this.length) throw new RangeError('sourceStart out of bounds');
	  if (end < 0) throw new RangeError('sourceEnd out of bounds'); // Are we oob?

	  if (end > this.length) end = this.length;

	  if (target.length - targetStart < end - start) {
	    end = target.length - targetStart + start;
	  }

	  var len = end - start;
	  var i;

	  if (this === target && start < targetStart && targetStart < end) {
	    // descending copy from end
	    for (i = len - 1; i >= 0; --i) {
	      target[i + targetStart] = this[i + start];
	    }
	  } else if (len < 1000 || !Buffer.TYPED_ARRAY_SUPPORT) {
	    // ascending copy from start
	    for (i = 0; i < len; ++i) {
	      target[i + targetStart] = this[i + start];
	    }
	  } else {
	    Uint8Array.prototype.set.call(target, this.subarray(start, start + len), targetStart);
	  }

	  return len;
	}; // Usage:
	//    buffer.fill(number[, offset[, end]])
	//    buffer.fill(buffer[, offset[, end]])
	//    buffer.fill(string[, offset[, end]][, encoding])


	Buffer.prototype.fill = function fill(val, start, end, encoding) {
	  // Handle string cases:
	  if (typeof val === 'string') {
	    if (typeof start === 'string') {
	      encoding = start;
	      start = 0;
	      end = this.length;
	    } else if (typeof end === 'string') {
	      encoding = end;
	      end = this.length;
	    }

	    if (val.length === 1) {
	      var code = val.charCodeAt(0);

	      if (code < 256) {
	        val = code;
	      }
	    }

	    if (encoding !== undefined && typeof encoding !== 'string') {
	      throw new TypeError('encoding must be a string');
	    }

	    if (typeof encoding === 'string' && !Buffer.isEncoding(encoding)) {
	      throw new TypeError('Unknown encoding: ' + encoding);
	    }
	  } else if (typeof val === 'number') {
	    val = val & 255;
	  } // Invalid ranges are not set to a default, so can range check early.


	  if (start < 0 || this.length < start || this.length < end) {
	    throw new RangeError('Out of range index');
	  }

	  if (end <= start) {
	    return this;
	  }

	  start = start >>> 0;
	  end = end === undefined ? this.length : end >>> 0;
	  if (!val) val = 0;
	  var i;

	  if (typeof val === 'number') {
	    for (i = start; i < end; ++i) {
	      this[i] = val;
	    }
	  } else {
	    var bytes = internalIsBuffer(val) ? val : utf8ToBytes(new Buffer(val, encoding).toString());
	    var len = bytes.length;

	    for (i = 0; i < end - start; ++i) {
	      this[i + start] = bytes[i % len];
	    }
	  }

	  return this;
	}; // HELPER FUNCTIONS
	// ================


	var INVALID_BASE64_RE = /[^+\/0-9A-Za-z-_]/g;

	function base64clean(str) {
	  // Node strips out invalid characters like \n and \t from the string, base64-js does not
	  str = stringtrim(str).replace(INVALID_BASE64_RE, ''); // Node converts strings with length < 2 to ''

	  if (str.length < 2) return ''; // Node allows for non-padded base64 strings (missing trailing ===), base64-js does not

	  while (str.length % 4 !== 0) {
	    str = str + '=';
	  }

	  return str;
	}

	function stringtrim(str) {
	  if (str.trim) return str.trim();
	  return str.replace(/^\s+|\s+$/g, '');
	}

	function toHex(n) {
	  if (n < 16) return '0' + n.toString(16);
	  return n.toString(16);
	}

	function utf8ToBytes(string, units) {
	  units = units || Infinity;
	  var codePoint;
	  var length = string.length;
	  var leadSurrogate = null;
	  var bytes = [];

	  for (var i = 0; i < length; ++i) {
	    codePoint = string.charCodeAt(i); // is surrogate component

	    if (codePoint > 0xD7FF && codePoint < 0xE000) {
	      // last char was a lead
	      if (!leadSurrogate) {
	        // no lead yet
	        if (codePoint > 0xDBFF) {
	          // unexpected trail
	          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
	          continue;
	        } else if (i + 1 === length) {
	          // unpaired lead
	          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
	          continue;
	        } // valid lead


	        leadSurrogate = codePoint;
	        continue;
	      } // 2 leads in a row


	      if (codePoint < 0xDC00) {
	        if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
	        leadSurrogate = codePoint;
	        continue;
	      } // valid surrogate pair


	      codePoint = (leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00) + 0x10000;
	    } else if (leadSurrogate) {
	      // valid bmp char, but last char was a lead
	      if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
	    }

	    leadSurrogate = null; // encode utf8

	    if (codePoint < 0x80) {
	      if ((units -= 1) < 0) break;
	      bytes.push(codePoint);
	    } else if (codePoint < 0x800) {
	      if ((units -= 2) < 0) break;
	      bytes.push(codePoint >> 0x6 | 0xC0, codePoint & 0x3F | 0x80);
	    } else if (codePoint < 0x10000) {
	      if ((units -= 3) < 0) break;
	      bytes.push(codePoint >> 0xC | 0xE0, codePoint >> 0x6 & 0x3F | 0x80, codePoint & 0x3F | 0x80);
	    } else if (codePoint < 0x110000) {
	      if ((units -= 4) < 0) break;
	      bytes.push(codePoint >> 0x12 | 0xF0, codePoint >> 0xC & 0x3F | 0x80, codePoint >> 0x6 & 0x3F | 0x80, codePoint & 0x3F | 0x80);
	    } else {
	      throw new Error('Invalid code point');
	    }
	  }

	  return bytes;
	}

	function asciiToBytes(str) {
	  var byteArray = [];

	  for (var i = 0; i < str.length; ++i) {
	    // Node's code seems to be doing this and not & 0x7F..
	    byteArray.push(str.charCodeAt(i) & 0xFF);
	  }

	  return byteArray;
	}

	function utf16leToBytes(str, units) {
	  var c, hi, lo;
	  var byteArray = [];

	  for (var i = 0; i < str.length; ++i) {
	    if ((units -= 2) < 0) break;
	    c = str.charCodeAt(i);
	    hi = c >> 8;
	    lo = c % 256;
	    byteArray.push(lo);
	    byteArray.push(hi);
	  }

	  return byteArray;
	}

	function base64ToBytes(str) {
	  return toByteArray(base64clean(str));
	}

	function blitBuffer(src, dst, offset, length) {
	  for (var i = 0; i < length; ++i) {
	    if (i + offset >= dst.length || i >= src.length) break;
	    dst[i + offset] = src[i];
	  }

	  return i;
	}

	function isnan(val) {
	  return val !== val; // eslint-disable-line no-self-compare
	} // the following is from is-buffer, also by Feross Aboukhadijeh and with same lisence
	// The _isBuffer check is for Safari 5-7 support, because it's missing
	// Object.prototype.constructor. Remove this eventually


	function isBuffer(obj) {
	  return obj != null && (!!obj._isBuffer || isFastBuffer(obj) || isSlowBuffer(obj));
	}

	function isFastBuffer(obj) {
	  return !!obj.constructor && typeof obj.constructor.isBuffer === 'function' && obj.constructor.isBuffer(obj);
	} // For Node v0.10 support. Remove this eventually.


	function isSlowBuffer(obj) {
	  return typeof obj.readFloatLE === 'function' && typeof obj.slice === 'function' && isFastBuffer(obj.slice(0, 0));
	}

	/**
	 * @license
	 * Copyright 2019 Google LLC. All Rights Reserved.
	 * Licensed under the Apache License, Version 2.0 (the "License");
	 * you may not use this file except in compliance with the License.
	 * You may obtain a copy of the License at
	 *
	 * http://www.apache.org/licenses/LICENSE-2.0
	 *
	 * Unless required by applicable law or agreed to in writing, software
	 * distributed under the License is distributed on an "AS IS" BASIS,
	 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	 * See the License for the specific language governing permissions and
	 * limitations under the License.
	 * =============================================================================
	 */var _t2=function t(e,n){return (_t2=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e;}||function(t,e){for(var n in e){e.hasOwnProperty(n)&&(t[n]=e[n]);}})(e,n);};function e(e,n){function r(){this.constructor=e;}_t2(e,n),e.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r());}function n(t,e,n,r){return new(n||(n=Promise))(function(o,a){function i(t){try{u(r.next(t));}catch(t){a(t);}}function s(t){try{u(r["throw"](t));}catch(t){a(t);}}function u(t){t.done?o(t.value):new n(function(e){e(t.value);}).then(i,s);}u((r=r.apply(t,e||[])).next());});}function r(t,e){var n,r,o,a,i={label:0,sent:function sent(){if(1&o[0])throw o[1];return o[1];},trys:[],ops:[]};return a={next:s(0),"throw":s(1),"return":s(2)},"function"==typeof Symbol&&(a[Symbol.iterator]=function(){return this;}),a;function s(a){return function(s){return function(a){if(n)throw new TypeError("Generator is already executing.");for(;i;){try{if(n=1,r&&(o=2&a[0]?r["return"]:a[0]?r["throw"]||((o=r["return"])&&o.call(r),0):r.next)&&!(o=o.call(r,a[1])).done)return o;switch(r=0,o&&(a=[2&a[0],o.value]),a[0]){case 0:case 1:o=a;break;case 4:return i.label++,{value:a[1],done:!1};case 5:i.label++,r=a[1],a=[0];continue;case 7:a=i.ops.pop(),i.trys.pop();continue;default:if(!(o=(o=i.trys).length>0&&o[o.length-1])&&(6===a[0]||2===a[0])){i=0;continue;}if(3===a[0]&&(!o||a[1]>o[0]&&a[1]<o[3])){i.label=a[1];break;}if(6===a[0]&&i.label<o[1]){i.label=o[1],o=a;break;}if(o&&i.label<o[2]){i.label=o[2],i.ops.push(a);break;}o[2]&&i.ops.pop(),i.trys.pop();continue;}a=e.call(t,i);}catch(t){a=[6,t],r=0;}finally{n=o=0;}}if(5&a[0])throw a[1];return {value:a[0]?a[1]:void 0,done:!0};}([a,s]);};}}var o=function(){function t(t){this.global=t,this.flags={},this.flagRegistry={},this.urlFlags={},this.populateURLFlags();}return t.prototype.setPlatform=function(t,e){null!=this.platform&&console.warn("Platform "+this.platformName+" has already been set. Overwriting the platform with "+e+"."),this.platformName=t,this.platform=e;},t.prototype.registerFlag=function(t,e,n){if(this.flagRegistry[t]={evaluationFn:e,setHook:n},null!=this.urlFlags[t]){var r=this.urlFlags[t];console.warn("Setting feature override from URL "+t+": "+r+"."),this.set(t,r);}},t.prototype.get=function(t){return t in this.flags?this.flags[t]:(this.flags[t]=this.evaluateFlag(t),this.flags[t]);},t.prototype.getNumber=function(t){return this.get(t);},t.prototype.getBool=function(t){return this.get(t);},t.prototype.getFlags=function(){return this.flags;},Object.defineProperty(t.prototype,"features",{get:function get(){return this.flags;},enumerable:!0,configurable:!0}),t.prototype.set=function(t,e){if(null==this.flagRegistry[t])throw new Error("Cannot set flag "+t+" as it has not been registered.");this.flags[t]=e,null!=this.flagRegistry[t].setHook&&this.flagRegistry[t].setHook(e);},t.prototype.evaluateFlag=function(t){if(null==this.flagRegistry[t])throw new Error("Cannot evaluate flag '"+t+"': no evaluation function found.");return this.flagRegistry[t].evaluationFn();},t.prototype.setFlags=function(t){this.flags=Object.assign({},t);},t.prototype.reset=function(){this.flags={},this.urlFlags={},this.populateURLFlags();},t.prototype.populateURLFlags=function(){var t=this;if(void 0!==this.global&&void 0!==this.global.location&&void 0!==this.global.location.search){var e=a(this.global.location.search);if("tfjsflags"in e)e.tfjsflags.split(",").forEach(function(e){var n=e.split(":"),r=n[0],o=n[1];t.urlFlags[r]=function(t,e){if("true"===(e=e.toLowerCase())||"false"===e)return "true"===e;if(""+ +e===e)return +e;throw new Error("Could not parse value flag value "+e+" for flag "+t+".");}(r,o);});}},t;}();function a(t){var e={};return t.replace(/[?&]([^=?&]+)(?:=([^&]*))?/g,function(t){for(var n=[],r=1;r<arguments.length;r++){n[r-1]=arguments[r];}return function(t,e,n){t[decodeURIComponent(e)]=decodeURIComponent(n||"");}(e,n[0],n[1]),n.join("=");}),e;}var i=null;function s(t){i=t;}var u=Object.freeze({Environment:o,getQueryParams:a,get ENV(){return i;},setEnvironmentGlobal:s});function l(t){for(var e=t.length,n=0,r=0;e>0;){r=Math.random()*e|0,n=t[--e],t[e]=t[r],t[r]=n;}}function c(t,e,n){return Math.max(t,Math.min(e,n));}function h(t){return t%2==0?t:t+1;}function f(t){for(var e=0,n=0;n<t.length;n++){e+=t[n];}return e;}function p(t,e){if(!t)throw new Error("string"==typeof e?e:e());}function d(t,e,n){void 0===n&&(n=""),p(y(t,e),function(){return n+" Shapes "+t+" and "+e+" must match";});}function v(t){p(null!=t,function(){return "The input to the tensor constructor must be a non-null value.";});}function m(t,e,n){if(void 0===e&&(e=[]),void 0===n&&(n=!1),null==e&&(e=[]),Array.isArray(t)||O(t)&&!n)for(var r=0;r<t.length;++r){m(t[r],e,n);}else e.push(t);return e;}function g(t){if(0===t.length)return 1;for(var e=t[0],n=1;n<t.length;n++){e*=t[n];}return e;}function y(t,e){if(t===e)return !0;if(null==t||null==e)return !1;if(t.length!==e.length)return !1;for(var n=0;n<t.length;n++){if(t[n]!==e[n])return !1;}return !0;}function _x(t){return t%1==0;}function b(t){if(null!=Math.tanh)return Math.tanh(t);if(t===1/0)return 1;if(t===-1/0)return -1;var e=Math.exp(2*t);return (e-1)/(e+1);}function w(t){var e=Math.ceil(Math.sqrt(t));return [e,Math.ceil(t/e)];}function C(t,e){return e<=t.length?t:t+" ".repeat(e-t.length);}function E(t,e,n){return void 0===e&&(e=function e(t){return 0;}),new Promise(function(r,o){var a=0,i=function i(){if(t())r();else{var s=e(++a);null!=n&&a>=n?o():setTimeout(i,s);}};i();});}function R(t,e){for(var n=1,r=-1,o=0;o<t.length;++o){if(t[o]>=0)n*=t[o];else if(-1===t[o]){if(-1!==r)throw Error("Shapes can only have 1 implicit size. Found -1 at dim "+r+" and dim "+o);r=o;}else if(t[o]<0)throw Error("Shapes can not be < 0. Found "+t[o]+" at dim "+o);}if(-1===r){if(e>0&&e!==n)throw Error("Size("+e+") must match the product of shape "+t);return t;}if(0===n)throw Error("Cannot infer the missing size in ["+t+"] when there are 0 elements");if(e%n!=0)throw Error("The implicit shape can't be a fractional number. Got "+e+" / "+n);var a=t.slice();return a[r]=e/n,a;}function I(t,e){var n=e.length;return p((t=null==t?e.map(function(t,e){return e;}):[].concat(t)).every(function(t){return t>=-n&&t<n;}),function(){return "All values in axis param must be in range [-"+n+", "+n+") but got axis "+t;}),p(t.every(function(t){return _x(t);}),function(){return "All values in axis param must be integers but got axis "+t;}),t.map(function(t){return t<0?n+t:t;});}function S(t,e){for(var n=[],r=[],o=null==e?null:I(e,t).sort(),a=0,i=0;i<t.length;++i){if(null!=o){if(o[a]===i&&1!==t[i])throw new Error("Can't squeeze axis "+i+" since its dim '"+t[i]+"' is not 1");(null==o[a]||o[a]>i)&&1===t[i]&&(n.push(t[i]),r.push(i)),o[a]<=i&&a++;}1!==t[i]&&(n.push(t[i]),r.push(i));}return {newShape:n,keptDims:r};}function N(t,e){var n=null;if(null==t||"float32"===t)n=new Float32Array(e);else if("int32"===t)n=new Int32Array(e);else{if("bool"!==t)throw new Error("Unknown data type "+t);n=new Uint8Array(e);}return n;}function k(t,e){var n=null;if(null==t||"float32"===t)n=new Float32Array(e);else if("int32"===t)n=new Int32Array(e);else if("bool"===t)n=new Uint8Array(e);else{if("string"!==t)throw new Error("Unknown data type "+t);n=new Array(e);}return n;}function A(t,e,n){if("float32"===e)for(var r=0;r<t.length;r++){var o=t[r];if(isNaN(o)||!isFinite(o))throw Error("The result of the '"+n+"' is "+o+".");}}function T(t,e){for(var n=0;n<t.length;n++){var r=t[n];if(isNaN(r)||!isFinite(r))throw Error("A tensor of type "+e+" being uploaded contains "+r+".");}}function D(t){return "bool"===t||"complex64"===t||"float32"===t||"int32"===t||"string"===t;}function _(t,e){return "complex64"!==e&&("float32"!==e||"complex64"===t)&&("int32"!==e||"float32"===t||"complex64"===t)&&("bool"!==e||"bool"!==t);}function O(t){return t instanceof Float32Array||t instanceof Int32Array||t instanceof Uint8Array;}function F(t){if("float32"===t||"int32"===t)return 4;if("complex64"===t)return 8;if("bool"===t)return 1;throw new Error("Unknown dtype "+t);}function M(t){if(null==t)return 0;var e=0;return t.forEach(function(t){return e+=t.length;}),e;}function B(t){return "string"==typeof t||t instanceof String;}function P(t){return "boolean"==typeof t;}function L(t){return "number"==typeof t;}function W(t){return Array.isArray(t)?W(t[0]):t instanceof Float32Array?"float32":t instanceof Int32Array||t instanceof Uint8Array?"int32":L(t)?"float32":B(t)?"string":P(t)?"bool":"float32";}function U(t){return !!(t&&t.constructor&&t.call&&t.apply);}function z(t,e){for(var n=e;n<t;++n){if(t%n==0)return n;}return t;}function V(t){var e=t.length;if(e<2)return [];var n=new Array(e-1);n[e-2]=t[e-1];for(var r=e-3;r>=0;--r){n[r]=n[r+1]*t[r+1];}return n;}function G(t,e,n){if("string"===e)throw new Error("Cannot convert a string[] to a TypedArray");if(Array.isArray(t)&&(t=m(t)),n&&T(t,e),function(t,e){return t instanceof Float32Array&&"float32"===e||t instanceof Int32Array&&"int32"===e||t instanceof Uint8Array&&"bool"===e;}(t,e))return t;if(null==e||"float32"===e||"complex64"===e)return new Float32Array(t);if("int32"===e)return new Int32Array(t);if("bool"===e){for(var r=new Uint8Array(t.length),o=0;o<r.length;++o){0!==Math.round(t[o])&&(r[o]=1);}return r;}throw new Error("Unknown data type "+e);}function H(t,e){if(0===t.length)return e[0];var n=t.reduce(function(t,e){return t*e;});if(0===n)return [];if(n!==e.length)throw new Error("["+t+"] does not match the input size.");return function t(e,n,r){var o=new Array();if(1===n.length)for(var a=n[0],i=0;i<a;i++){o[i]=r[e+i];}else{a=n[0];var s=n.slice(1),u=s.reduce(function(t,e){return t*e;});for(i=0;i<a;i++){o[i]=t(e+i*u,s,r);}}return o;}(0,t,e);}function q(t,e){for(var n=$(t,e),r=0;r<n.length;r++){n[r]=1;}return n;}function $(t,e){if(null==e||"float32"===e||"complex64"===e)return new Float32Array(t);if("int32"===e)return new Int32Array(t);if("bool"===e)return new Uint8Array(t);throw new Error("Unknown data type "+e);}function j(){return i.platform.now();}function K(t){t.forEach(function(e){p(Number.isInteger(e)&&e>=0,function(){return "Tensor must have a shape comprised of positive integers but got shape ["+t+"].";});});}function X(t,e){return void 0===e&&(e="utf-8"),e=e||"utf-8",i.platform.encode(t,e);}function Y(t,e){return void 0===e&&(e="utf-8"),e=e||"utf-8",i.platform.decode(t,e);}var Q=Object.freeze({shuffle:l,clamp:c,nearestLargerEven:h,sum:f,randUniform:function randUniform(t,e){var n=Math.random();return e*n+(1-n)*t;},distSquared:function distSquared(t,e){for(var n=0,r=0;r<t.length;r++){var o=Number(t[r])-Number(e[r]);n+=o*o;}return n;},assert:p,assertShapesMatch:d,assertNonNull:v,flatten:m,sizeFromShape:g,isScalarShape:function isScalarShape(t){return 0===t.length;},arraysEqual:y,isInt:_x,tanh:b,sizeToSquarishShape:w,createShuffledIndices:function createShuffledIndices(t){for(var e=new Uint32Array(t),n=0;n<t;++n){e[n]=n;}return l(e),e;},rightPad:C,repeatedTry:E,inferFromImplicitShape:R,parseAxisParam:I,squeezeShape:S,getTypedArrayFromDType:N,getArrayFromDType:k,checkComputationForErrors:A,checkConversionForErrors:T,isValidDtype:D,hasEncodingLoss:_,isTypedArray:O,bytesPerElement:F,bytesFromStringArray:M,isString:B,isBoolean:P,isNumber:L,inferDtype:W,isFunction:U,nearestDivisor:z,computeStrides:V,toTypedArray:G,toNestedArray:H,makeOnesTypedArray:q,makeZerosTypedArray:$,now:j,assertNonNegativeIntegerDimensions:K,fetch:function fetch(t,e){return i.platform.fetch(t,e);},encodeString:X,decodeString:Y}),J=function(){function t(t,e){this.backendTimer=t,this.logger=e,null==e&&(this.logger=new Z());}return t.prototype.profileKernel=function(t,e){var n,r=this,o=this.backendTimer.time(function(){n=e();});return (Array.isArray(n)?n:[n]).forEach(function(e){var n=e.dataSync();A(n,e.dtype,t),o.then(function(o){var a="";null!=o.getExtraProfileInfo&&(a=o.getExtraProfileInfo()),r.logger.logKernelProfile(t,e,n,o.kernelMs,a);});}),n;},t;}(),Z=function(){function t(){}return t.prototype.logKernelProfile=function(t,e,n,r,o){var a=C(r+"ms",9),i=C(t,25),s=e.rank,u=e.size,l=C(e.shape.toString(),14);console.log("%c"+i+"\t%c"+a+"\t%c"+s+"D "+l+"\t%c"+u+"\t%c"+o,"font-weight:bold","color:red","color:blue","color: orange","color: green");},t;}(),tt=20,et=3,nt=7;function rt(t,e,n,r){var o=V(e),a=function(t,e,n,r){var o=g(e),a=r[r.length-1],i=new Array(a).fill(0),s=e.length,u="complex64"===n?it(t):t;if(s>1)for(var l=0;l<o/a;l++){for(var c=l*a,h=0;h<a;h++){i[h]=Math.max(i[h],ot(u[c+h],0,n).length);}}return i;}(t,e,n,o),i=e.length,s=function t(e,n,r,o,a,i){void 0===i&&(i=!0);var s="complex64"===r?2:1;var u=n[0];var l=n.length;if(0===l){if("complex64"===r){var c=it(e);return [ot(c[0],0,r)];}return "bool"===r?[at(e[0])]:[e[0].toString()];}if(1===l){if(u>tt){var h=et*s,f=Array.from(e.slice(0,h)),p=Array.from(e.slice(u-et*s,u));return "complex64"===r&&(f=it(f),p=it(p)),["["+f.map(function(t,e){return ot(t,a[e],r);}).join(", ")+", ..., "+p.map(function(t,e){return ot(t,a[u-et+e],r);}).join(", ")+"]"];}var d="complex64"===r?it(e):Array.from(e);return ["["+d.map(function(t,e){return ot(t,a[e],r);}).join(", ")+"]"];}var v=n.slice(1);var m=o.slice(1);var g=o[0]*s;var y=[];if(u>tt){for(var x=0;x<et;x++){var b=x*g,w=b+g;y.push.apply(y,t(e.slice(b,w),v,r,m,a,!1));}y.push("...");for(var x=u-et;x<u;x++){var b=x*g,w=b+g;y.push.apply(y,t(e.slice(b,w),v,r,m,a,x===u-1));}}else for(var x=0;x<u;x++){var b=x*g,w=b+g;y.push.apply(y,t(e.slice(b,w),v,r,m,a,x===u-1));}var C=2===l?",":"";y[0]="["+y[0]+C;for(var x=1;x<y.length-1;x++){y[x]=" "+y[x]+C;}var E=",\n";for(var x=2;x<l;x++){E+="\n";}y[y.length-1]=" "+y[y.length-1]+"]"+(i?"":E);return y;}(t,e,n,o,a),u=["Tensor"];return r&&(u.push("  dtype: "+n),u.push("  rank: "+i),u.push("  shape: ["+e+"]"),u.push("  values:")),u.push(s.map(function(t){return "    "+t;}).join("\n")),u.join("\n");}function ot(t,e,n){return C(Array.isArray(t)?parseFloat(t[0].toFixed(nt))+" + "+parseFloat(t[1].toFixed(nt))+"j":B(t)?"'"+t+"'":"bool"===n?at(t):parseFloat(t.toFixed(nt)).toString(),e);}function at(t){return 0===t?"false":"true";}function it(t){for(var e=[],n=0;n<t.length;n+=2){e.push([t[n],t[n+1]]);}return e;}var st=function(){function t(t,e,n){var r=this;if(this.dtype=e,this.shape=t.slice(),this.size=g(t),null!=n){var o=n.length;p(o===this.size,function(){return "Length of values '"+o+"' does not match the size inferred by the shape '"+r.size+"'.";});}if("complex64"===e)throw new Error("complex64 dtype TensorBuffers are not supported. Please create a TensorBuffer for the real and imaginary parts separately and call tf.complex(real, imag).");this.values=n||k(e,this.size),this.strides=V(t);}return t.prototype.set=function(t){for(var e=this,n=[],r=1;r<arguments.length;r++){n[r-1]=arguments[r];}0===n.length&&(n=[0]),p(n.length===this.rank,function(){return "The number of provided coordinates ("+n.length+") must match the rank ("+e.rank+")";});var o=this.locToIndex(n);this.values[o]=t;},t.prototype.get=function(){for(var t=[],e=0;e<arguments.length;e++){t[e]=arguments[e];}0===t.length&&(t=[0]);for(var n=0,r=0,o=t;r<o.length;r++){var a=o[r];if(a<0||a>=this.shape[n]){var i="Requested out of range element at "+t+".   Buffer shape="+this.shape;throw new Error(i);}n++;}for(var s=t[t.length-1],u=0;u<t.length-1;++u){s+=this.strides[u]*t[u];}return this.values[s];},t.prototype.locToIndex=function(t){if(0===this.rank)return 0;if(1===this.rank)return t[0];for(var e=t[t.length-1],n=0;n<t.length-1;++n){e+=this.strides[n]*t[n];}return e;},t.prototype.indexToLoc=function(t){if(0===this.rank)return [];if(1===this.rank)return [t];for(var e=new Array(this.shape.length),n=0;n<e.length-1;++n){e[n]=Math.floor(t/this.strides[n]),t-=e[n]*this.strides[n];}return e[e.length-1]=t,e;},Object.defineProperty(t.prototype,"rank",{get:function get(){return this.shape.length;},enumerable:!0,configurable:!0}),t.prototype.toTensor=function(){return ht.make(this.shape,{values:this.values},this.dtype);},t;}(),ut=null,lt=null,ct=null;var ht=function(){function t(t,e,n,r,o){this.kept=!1,this.isDisposedInternal=!1,this.shape=t.slice(),this.dtype=e||"float32",this.size=g(t),this.strides=V(t),this.dataId=null!=r?r:{},this.id=ut().nextTensorId(),this.rankType=this.rank<5?this.rank.toString():"higher",ut().registerTensor(this,o),null!=n&&ut().write(o,this.dataId,n);}return t.make=function(e,n,r,o){var a=n.values;return null!=n.values&&"string"===r&&B(n.values[0])&&(a=n.values.map(function(t){return X(t);})),new t(e,r,a,n.dataId,o);},t.prototype.flatten=function(){return this.throwIfDisposed(),this.as1D();},t.prototype.asScalar=function(){return this.throwIfDisposed(),p(1===this.size,function(){return "The array must have only 1 element.";}),this.reshape([]);},t.prototype.as1D=function(){return this.throwIfDisposed(),this.reshape([this.size]);},t.prototype.as2D=function(t,e){return this.throwIfDisposed(),this.reshape([t,e]);},t.prototype.as3D=function(t,e,n){return this.throwIfDisposed(),this.reshape([t,e,n]);},t.prototype.as4D=function(t,e,n,r){return this.throwIfDisposed(),this.reshape([t,e,n,r]);},t.prototype.as5D=function(t,e,n,r,o){return this.throwIfDisposed(),this.reshape([t,e,n,r,o]);},t.prototype.asType=function(t){return this.throwIfDisposed(),lt.cast(this,t);},Object.defineProperty(t.prototype,"rank",{get:function get(){return this.shape.length;},enumerable:!0,configurable:!0}),t.prototype.buffer=function(){return n(this,void 0,void 0,function(){var t;return r(this,function(e){switch(e.label){case 0:return [4,this.data()];case 1:return t=e.sent(),[2,lt.buffer(this.shape,this.dtype,t)];}});});},t.prototype.bufferSync=function(){return lt.buffer(this.shape,this.dtype,this.dataSync());},t.prototype.array=function(){return n(this,void 0,void 0,function(){var t;return r(this,function(e){switch(e.label){case 0:return [4,this.data()];case 1:return t=e.sent(),[2,H(this.shape,t)];}});});},t.prototype.arraySync=function(){return H(this.shape,this.dataSync());},t.prototype.data=function(){return n(this,void 0,void 0,function(){var t,e;return r(this,function(n){switch(n.label){case 0:return this.throwIfDisposed(),t=ut().read(this.dataId),"string"!==this.dtype?[3,2]:[4,t];case 1:e=n.sent();try{return [2,e.map(function(t){return Y(t);})];}catch(t){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().");}n.label=2;case 2:return [2,t];}});});},t.prototype.dataSync=function(){this.throwIfDisposed();var t=ut().readSync(this.dataId);if("string"===this.dtype)try{return t.map(function(t){return Y(t);});}catch(t){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().");}return t;},t.prototype.bytes=function(){return n(this,void 0,void 0,function(){var t;return r(this,function(e){switch(e.label){case 0:return this.throwIfDisposed(),[4,ut().read(this.dataId)];case 1:return t=e.sent(),"string"===this.dtype?[2,t]:[2,new Uint8Array(t.buffer)];}});});},t.prototype.dispose=function(){this.isDisposed||(ut().disposeTensor(this),this.isDisposedInternal=!0);},Object.defineProperty(t.prototype,"isDisposed",{get:function get(){return this.isDisposedInternal;},enumerable:!0,configurable:!0}),t.prototype.throwIfDisposed=function(){if(this.isDisposed)throw new Error("Tensor is disposed.");},t.prototype.toFloat=function(){return this.asType("float32");},t.prototype.toInt=function(){return this.asType("int32");},t.prototype.toBool=function(){return this.asType("bool");},t.prototype.print=function(t){return void 0===t&&(t=!1),lt.print(this,t);},t.prototype.reshape=function(t){return this.throwIfDisposed(),lt.reshape(this,t);},t.prototype.reshapeAs=function(t){return this.throwIfDisposed(),this.reshape(t.shape);},t.prototype.expandDims=function(t){return void 0===t&&(t=0),lt.expandDims(this,t);},t.prototype.cumsum=function(t,e,n){return void 0===t&&(t=0),void 0===e&&(e=!1),void 0===n&&(n=!1),lt.cumsum(this,t,e,n);},t.prototype.squeeze=function(t){return this.throwIfDisposed(),lt.squeeze(this,t);},t.prototype.clone=function(){return this.throwIfDisposed(),lt.clone(this);},t.prototype.oneHot=function(t,e,n){return this.throwIfDisposed(),lt.oneHot(this,t,e,n);},t.prototype.toString=function(t){return void 0===t&&(t=!1),rt(this.dataSync(),this.shape,this.dtype,t);},t.prototype.tile=function(t){return this.throwIfDisposed(),lt.tile(this,t);},t.prototype.gather=function(t,e){return void 0===e&&(e=0),this.throwIfDisposed(),lt.gather(this,t,e);},t.prototype.matMul=function(t,e,n){return void 0===e&&(e=!1),void 0===n&&(n=!1),this.throwIfDisposed(),lt.matMul(this,t,e,n);},t.prototype.dot=function(t){return this.throwIfDisposed(),lt.dot(this,t);},t.prototype.norm=function(t,e,n){return void 0===t&&(t="euclidean"),void 0===e&&(e=null),void 0===n&&(n=!1),this.throwIfDisposed(),lt.norm(this,t,e,n);},t.prototype.slice=function(t,e){return this.throwIfDisposed(),lt.slice(this,t,e);},t.prototype.reverse=function(t){return this.throwIfDisposed(),lt.reverse(this,t);},t.prototype.concat=function(e,n){return void 0===n&&(n=0),this.throwIfDisposed(),e instanceof t&&(e=[e]),lt.concat([this].concat(e),n);},t.prototype.split=function(t,e){return void 0===e&&(e=0),this.throwIfDisposed(),lt.split(this,t,e);},t.prototype.stack=function(t,e){return void 0===e&&(e=0),lt.stack([this,t],e);},t.prototype.unstack=function(t){return void 0===t&&(t=0),lt.unstack(this,t);},t.prototype.pad=function(t,e){return void 0===e&&(e=0),lt.pad(this,t,e);},t.prototype.batchNormalization=function(t,e,n,r,o){return void 0===n&&(n=.001),ct("tf.batchNormalization() is going away. Use tf.batchNorm() instead, and note the positional argument change of scale, offset, and varianceEpsilon"),this.batchNorm(t,e,o,r,n);},t.prototype.batchNorm=function(t,e,n,r,o){return void 0===o&&(o=.001),this.throwIfDisposed(),lt.batchNorm(this,t,e,n,r,o);},t.prototype.all=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),lt.all(this,t,e);},t.prototype.any=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),lt.any(this,t,e);},t.prototype.logSumExp=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),lt.logSumExp(this,t,e);},t.prototype.sum=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),lt.sum(this,t,e);},t.prototype.prod=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),lt.prod(this,t,e);},t.prototype.mean=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),lt.mean(this,t,e);},t.prototype.min=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),lt.min(this,t,e);},t.prototype.max=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),lt.max(this,t,e);},t.prototype.argMin=function(t){return void 0===t&&(t=null),this.throwIfDisposed(),lt.argMin(this,t);},t.prototype.argMax=function(t){return void 0===t&&(t=null),this.throwIfDisposed(),lt.argMax(this,t);},t.prototype.cast=function(t){return this.throwIfDisposed(),lt.cast(this,t);},t.prototype.add=function(t){return this.throwIfDisposed(),lt.add(this,t);},t.prototype.addStrict=function(t){return this.throwIfDisposed(),lt.addStrict(this,t);},t.prototype.atan2=function(t){return this.throwIfDisposed(),lt.atan2(this,t);},t.prototype.sub=function(t){return this.throwIfDisposed(),lt.sub(this,t);},t.prototype.subStrict=function(t){return this.throwIfDisposed(),lt.subStrict(this,t);},t.prototype.pow=function(t){return this.throwIfDisposed(),lt.pow(this,t);},t.prototype.powStrict=function(t){return this.throwIfDisposed(),lt.powStrict(this,t);},t.prototype.mul=function(t){return this.throwIfDisposed(),lt.mul(this,t);},t.prototype.mulStrict=function(t){return this.throwIfDisposed(),lt.mulStrict(this,t);},t.prototype.div=function(t){return this.throwIfDisposed(),lt.div(this,t);},t.prototype.floorDiv=function(t){return this.throwIfDisposed(),lt.floorDiv(this,t);},t.prototype.divStrict=function(t){return this.throwIfDisposed(),lt.divStrict(this,t);},t.prototype.minimum=function(t){return this.throwIfDisposed(),lt.minimum(this,t);},t.prototype.minimumStrict=function(t){return this.throwIfDisposed(),lt.minimumStrict(this,t);},t.prototype.maximum=function(t){return this.throwIfDisposed(),lt.maximum(this,t);},t.prototype.maximumStrict=function(t){return this.throwIfDisposed(),lt.maximumStrict(this,t);},t.prototype.mod=function(t){return this.throwIfDisposed(),lt.mod(this,t);},t.prototype.modStrict=function(t){return this.throwIfDisposed(),lt.modStrict(this,t);},t.prototype.squaredDifference=function(t){return this.throwIfDisposed(),lt.squaredDifference(this,t);},t.prototype.squaredDifferenceStrict=function(t){return this.throwIfDisposed(),lt.squaredDifferenceStrict(this,t);},t.prototype.transpose=function(t){return this.throwIfDisposed(),lt.transpose(this,t);},t.prototype.notEqual=function(t){return this.throwIfDisposed(),lt.notEqual(this,t);},t.prototype.notEqualStrict=function(t){return this.throwIfDisposed(),lt.notEqualStrict(this,t);},t.prototype.less=function(t){return this.throwIfDisposed(),lt.less(this,t);},t.prototype.lessStrict=function(t){return this.throwIfDisposed(),lt.lessStrict(this,t);},t.prototype.equal=function(t){return this.throwIfDisposed(),lt.equal(this,t);},t.prototype.equalStrict=function(t){return this.throwIfDisposed(),lt.equalStrict(this,t);},t.prototype.lessEqual=function(t){return this.throwIfDisposed(),lt.lessEqual(this,t);},t.prototype.lessEqualStrict=function(t){return this.throwIfDisposed(),lt.lessEqualStrict(this,t);},t.prototype.greater=function(t){return this.throwIfDisposed(),lt.greater(this,t);},t.prototype.greaterStrict=function(t){return this.throwIfDisposed(),lt.greaterStrict(this,t);},t.prototype.greaterEqual=function(t){return this.throwIfDisposed(),lt.greaterEqual(this,t);},t.prototype.greaterEqualStrict=function(t){return this.throwIfDisposed(),lt.greaterEqualStrict(this,t);},t.prototype.logicalAnd=function(t){return this.throwIfDisposed(),lt.logicalAnd(this,t);},t.prototype.logicalOr=function(t){return this.throwIfDisposed(),lt.logicalOr(this,t);},t.prototype.logicalNot=function(){return this.throwIfDisposed(),lt.logicalNot(this);},t.prototype.logicalXor=function(t){return this.throwIfDisposed(),lt.logicalXor(this,t);},t.prototype.where=function(t,e){return this.throwIfDisposed(),lt.where(t,this,e);},t.prototype.neg=function(){return this.throwIfDisposed(),lt.neg(this);},t.prototype.ceil=function(){return this.throwIfDisposed(),lt.ceil(this);},t.prototype.floor=function(){return this.throwIfDisposed(),lt.floor(this);},t.prototype.sign=function(){return this.throwIfDisposed(),lt.sign(this);},t.prototype.isNaN=function(){return this.throwIfDisposed(),lt.isNaN(this);},t.prototype.isInf=function(){return this.throwIfDisposed(),lt.isInf(this);},t.prototype.isFinite=function(){return this.throwIfDisposed(),lt.isFinite(this);},t.prototype.exp=function(){return this.throwIfDisposed(),lt.exp(this);},t.prototype.expm1=function(){return this.throwIfDisposed(),lt.expm1(this);},t.prototype.log=function(){return this.throwIfDisposed(),lt.log(this);},t.prototype.log1p=function(){return this.throwIfDisposed(),lt.log1p(this);},t.prototype.sqrt=function(){return this.throwIfDisposed(),lt.sqrt(this);},t.prototype.rsqrt=function(){return this.throwIfDisposed(),lt.rsqrt(this);},t.prototype.square=function(){return this.throwIfDisposed(),lt.square(this);},t.prototype.reciprocal=function(){return this.throwIfDisposed(),lt.reciprocal(this);},t.prototype.abs=function(){return this.throwIfDisposed(),lt.abs(this);},t.prototype.clipByValue=function(t,e){return this.throwIfDisposed(),lt.clipByValue(this,t,e);},t.prototype.relu=function(){return this.throwIfDisposed(),lt.relu(this);},t.prototype.elu=function(){return this.throwIfDisposed(),lt.elu(this);},t.prototype.selu=function(){return this.throwIfDisposed(),lt.selu(this);},t.prototype.leakyRelu=function(t){return void 0===t&&(t=.2),this.throwIfDisposed(),lt.leakyRelu(this,t);},t.prototype.prelu=function(t){return this.throwIfDisposed(),lt.prelu(this,t);},t.prototype.sigmoid=function(){return this.throwIfDisposed(),lt.sigmoid(this);},t.prototype.logSigmoid=function(){return this.throwIfDisposed(),lt.logSigmoid(this);},t.prototype.softplus=function(){return this.throwIfDisposed(),lt.softplus(this);},t.prototype.zerosLike=function(){return this.throwIfDisposed(),lt.zerosLike(this);},t.prototype.onesLike=function(){return this.throwIfDisposed(),lt.onesLike(this);},t.prototype.sin=function(){return this.throwIfDisposed(),lt.sin(this);},t.prototype.cos=function(){return this.throwIfDisposed(),lt.cos(this);},t.prototype.tan=function(){return this.throwIfDisposed(),lt.tan(this);},t.prototype.asin=function(){return this.throwIfDisposed(),lt.asin(this);},t.prototype.acos=function(){return this.throwIfDisposed(),lt.acos(this);},t.prototype.atan=function(){return this.throwIfDisposed(),lt.atan(this);},t.prototype.sinh=function(){return this.throwIfDisposed(),lt.sinh(this);},t.prototype.cosh=function(){return this.throwIfDisposed(),lt.cosh(this);},t.prototype.tanh=function(){return this.throwIfDisposed(),lt.tanh(this);},t.prototype.asinh=function(){return this.throwIfDisposed(),lt.asinh(this);},t.prototype.acosh=function(){return this.throwIfDisposed(),lt.acosh(this);},t.prototype.atanh=function(){return this.throwIfDisposed(),lt.atanh(this);},t.prototype.erf=function(){return this.throwIfDisposed(),lt.erf(this);},t.prototype.round=function(){return this.throwIfDisposed(),lt.round(this);},t.prototype.step=function(t){return void 0===t&&(t=0),this.throwIfDisposed(),lt.step(this,t);},t.prototype.softmax=function(t){return void 0===t&&(t=-1),this.throwIfDisposed(),lt.softmax(this,t);},t.prototype.logSoftmax=function(t){return void 0===t&&(t=-1),this.throwIfDisposed(),lt.logSoftmax(this,t);},t.prototype.resizeBilinear=function(t,e){return void 0===e&&(e=!1),this.throwIfDisposed(),lt.image.resizeBilinear(this,t,e);},t.prototype.resizeNearestNeighbor=function(t,e){return void 0===e&&(e=!1),this.throwIfDisposed(),lt.image.resizeNearestNeighbor(this,t,e);},t.prototype.conv1d=function(t,e,n,r,o,a){return void 0===r&&(r="NWC"),void 0===o&&(o=1),this.throwIfDisposed(),lt.conv1d(this,t,e,n,r,o,a);},t.prototype.conv2d=function(t,e,n,r,o,a){return void 0===r&&(r="NHWC"),void 0===o&&(o=[1,1]),this.throwIfDisposed(),lt.conv2d(this,t,e,n,r,o,a);},t.prototype.conv2dTranspose=function(t,e,n,r,o){return this.throwIfDisposed(),lt.conv2dTranspose(this,t,e,n,r,o);},t.prototype.depthwiseConv2D=function(t,e,n,r,o,a){return void 0===r&&(r="NHWC"),void 0===o&&(o=[1,1]),this.throwIfDisposed(),lt.depthwiseConv2d(this,t,e,n,r,o,a);},t.prototype.separableConv2d=function(t,e,n,r,o,a){return void 0===o&&(o=[1,1]),void 0===a&&(a="NHWC"),this.throwIfDisposed(),lt.separableConv2d(this,t,e,n,r,o,a);},t.prototype.avgPool=function(t,e,n,r){return this.throwIfDisposed(),lt.avgPool(this,t,e,n,r);},t.prototype.maxPool=function(t,e,n,r){return this.throwIfDisposed(),lt.maxPool(this,t,e,n,r);},t.prototype.localResponseNormalization=function(t,e,n,r){return void 0===t&&(t=5),void 0===e&&(e=1),void 0===n&&(n=1),void 0===r&&(r=.5),lt.localResponseNormalization(this,t,e,n,r);},t.prototype.pool=function(t,e,n,r,o){return this.throwIfDisposed(),lt.pool(this,t,e,n,r,o);},t.prototype.variable=function(t,e,n){return void 0===t&&(t=!0),this.throwIfDisposed(),ft.variable(this,t,e,n);},t.prototype.unsortedSegmentSum=function(t,e){return this.throwIfDisposed(),lt.unsortedSegmentSum(this,t,e);},t.prototype.batchToSpaceND=function(t,e){return this.throwIfDisposed(),lt.batchToSpaceND(this,t,e);},t.prototype.spaceToBatchND=function(t,e){return this.throwIfDisposed(),lt.spaceToBatchND(this,t,e);},t.prototype.topk=function(t,e){return void 0===t&&(t=1),void 0===e&&(e=!0),this.throwIfDisposed(),lt.topk(this,t,e);},t.prototype.stridedSlice=function(t,e,n,r,o,a,i,s){return void 0===r&&(r=0),void 0===o&&(o=0),void 0===a&&(a=0),void 0===i&&(i=0),void 0===s&&(s=0),this.throwIfDisposed(),lt.stridedSlice(this,t,e,n,r,o,a,i,s);},t.prototype.depthToSpace=function(t,e){return this.throwIfDisposed(),lt.depthToSpace(this,t,e);},t.prototype.fft=function(){return this.throwIfDisposed(),lt.spectral.fft(this);},t.prototype.ifft=function(){return this.throwIfDisposed(),lt.spectral.ifft(this);},t.prototype.rfft=function(){return this.throwIfDisposed(),lt.spectral.rfft(this);},t.prototype.irfft=function(){return this.throwIfDisposed(),lt.spectral.irfft(this);},t;}();Object.defineProperty(ht,Symbol.hasInstance,{value:function value(t){return !!t&&null!=t.dataId&&null!=t.shape&&null!=t.dtype;}});var ft=function(t){function n(e,n,r){void 0===n&&(n=!0);var o=t.call(this,e.shape,e.dtype,null,e.dataId)||this;o.trainable=n,o.name=r,null==o.name&&(o.name=ut().nextVariableId().toString());try{ut().registerVariable(o);}catch(t){throw ut().disposeTensor(o),t;}return o;}return e(n,t),n.variable=function(t,e,r,o){return void 0===e&&(e=!0),null!=o&&o!==t.dtype&&(t=t.asType(o)),new n(t,e,r);},n.prototype.assign=function(t){if(t.dtype!==this.dtype)throw new Error("dtype of the new value ("+t.dtype+") and previous value ("+this.dtype+") must match");if(!y(t.shape,this.shape))throw new Error("shape of the new value ("+t.shape+") and previous value ("+this.shape+") must match");ut().disposeTensor(this),this.dataId=t.dataId,ut().registerTensor(this);},n.prototype.dispose=function(){ut().disposeVariable(this),this.isDisposedInternal=!0;},n;}(ht);Object.defineProperty(ft,Symbol.hasInstance,{value:function value(t){return t instanceof ht&&null!=t.assign&&t.assign instanceof Function;}});var pt,dt,vt,mt,gt,yt=ft.variable;!function(t){t.R0="R0",t.R1="R1",t.R2="R2",t.R3="R3",t.R4="R4",t.R5="R5",t.R6="R6";}(pt||(pt={})),function(t){t.float32="float32",t.int32="int32",t.bool="int32",t.complex64="complex64";}(dt||(dt={})),function(t){t.float32="float32",t.int32="int32",t.bool="bool",t.complex64="complex64";}(vt||(vt={})),function(t){t.float32="float32",t.int32="float32",t.bool="float32",t.complex64="complex64";}(mt||(mt={})),function(t){t.float32="complex64",t.int32="complex64",t.bool="complex64",t.complex64="complex64";}(gt||(gt={}));var xt={float32:mt,int32:dt,bool:vt,complex64:gt};function bt(t,e){if("string"===t||"string"===e){if("string"===t&&"string"===e)return "string";throw new Error("Can not upcast "+t+" with "+e);}return xt[t][e];}function wt(t){return bt(t,"int32");}function Ct(t,e){if(t.dtype===e.dtype)return [t,e];var n=bt(t.dtype,e.dtype);return [t.cast(n),e.cast(n)];}function Et(t,e){p(t.dtype===e.dtype,function(){return "The dtypes of the first("+t.dtype+") and second("+e.dtype+") input must match";});}function Rt(t){var e=[];return function t(e,n,r){if(null==e)return;if(e instanceof ht)return void n.push(e);if(o=e,!Array.isArray(o)&&"object"!=_typeof_1(o))return;var o;var a=e;for(var i in a){var s=a[i];r.has(s)||(r.add(s),t(s,n,r));}}(t,e,new Set()),e;}var It,St=Object.freeze({makeTypesMatch:Ct,assertTypesMatch:Et,isTensorInList:function isTensorInList(t,e){for(var n=0;n<e.length;n++){if(e[n].id===t.id)return !0;}return !1;},getTensorsInContainer:Rt}),Nt=function(){function t(){this.registeredVariables={},this.nextTapeNodeId=0,this.numBytes=0,this.numTensors=0,this.numStringTensors=0,this.numDataBuffers=0,this.gradientDepth=0,this.kernelDepth=0,this.scopeStack=[],this.nextScopeId=0,this.tensorInfo=new WeakMap(),this.profiling=!1,this.activeProfile={newBytes:0,newTensors:0,peakBytes:0,kernels:[],result:null};}return t.prototype.dispose=function(){for(var t in this.registeredVariables){this.registeredVariables[t].dispose();}},t;}(),kt=function(){function t(t){this.ENV=t,this.registry={},this.registryFactory={},this.pendingBackendInitId=0,this.state=new Nt();}return t.prototype.ready=function(){return n(this,void 0,void 0,function(){var t,e,n;return r(this,function(r){switch(r.label){case 0:if(null!=this.pendingBackendInit)return [2,this.pendingBackendInit.then(function(){})];if(null!=this.backendInstance)return [2];t=this.getSortedBackends(),e=0,r.label=1;case 1:return e<t.length?(n=t[e],[4,this.initializeBackend(n).success]):[3,5];case 2:return r.sent()?[4,this.setBackend(n)]:[3,4];case 3:return r.sent(),[2];case 4:return e++,[3,1];case 5:throw new Error("Could not initialize any backends, all backend initializations failed.");}});});},Object.defineProperty(t.prototype,"backend",{get:function get(){if(null!=this.pendingBackendInit)throw new Error("Backend '"+this.backendName+"' has not yet been initialized. Make sure to await tf.ready() before calling other methods");if(null==this.backendInstance){var t=this.initializeBackendsAndReturnBest(),e=t.name;if(t.asyncInit)throw new Error("The highest priority backend '"+e+"' has not yet been initialized. Make sure to await tf.ready() before calling other methods");this.setBackend(e);}return this.backendInstance;},enumerable:!0,configurable:!0}),t.prototype.backendNames=function(){return Object.keys(this.registryFactory);},t.prototype.findBackend=function(t){if(!(t in this.registry)){if(!(t in this.registryFactory))return null;if(this.initializeBackend(t).asyncInit)return null;}return this.registry[t];},t.prototype.findBackendFactory=function(t){return t in this.registryFactory?this.registryFactory[t].factory:null;},t.prototype.registerBackend=function(t,e,n){return void 0===n&&(n=1),t in this.registryFactory?(console.warn(t+" backend was already registered. Reusing existing backend factory."),!1):(this.registryFactory[t]={factory:e,priority:n},!0);},t.prototype.setBackend=function(t){return n(this,void 0,void 0,function(){var e,n,o;return r(this,function(r){switch(r.label){case 0:if(null==this.registryFactory[t])throw new Error("Backend name '"+t+"' not found in registry");return this.backendName=t,null!=this.registry[t]?[3,4]:(this.backendInstance=null,e=this.initializeBackend(t),n=e.success,e.asyncInit?[4,n]:[3,2]);case 1:return o=r.sent(),[3,3];case 2:o=n,r.label=3;case 3:if(!o)return [2,!1];r.label=4;case 4:return this.backendInstance=this.registry[t],this.profiler=new J(this.backendInstance),[2,!0];}});});},t.prototype.initializeBackend=function(t){var e=this,n=this.registryFactory[t];if(null==n)throw new Error("Cannot initialize backend "+t+", no registration found.");try{var r=n.factory();if(Promise.resolve(r)===r){var o=++this.pendingBackendInitId,a=r.then(function(n){return !(o<e.pendingBackendInitId)&&(e.registry[t]=n,e.pendingBackendInit=null,!0);})["catch"](function(n){return !(o<e.pendingBackendInitId)&&(e.pendingBackendInit=null,console.warn("Initialization of backend "+t+" failed"),console.warn(n.stack||n.message),!1);});return this.pendingBackendInit=a,{success:a,asyncInit:!0};}return this.registry[t]=r,{success:!0,asyncInit:!1};}catch(e){return console.warn("Initialization of backend "+t+" failed"),console.warn(e.stack||e.message),{success:!1,asyncInit:!1};}},t.prototype.removeBackend=function(t){if(!(t in this.registryFactory))throw new Error(t+" backend not found in registry");this.backendName===t&&null!=this.pendingBackendInit&&this.pendingBackendInitId++,t in this.registry&&(this.registry[t].dispose(),delete this.registry[t]),delete this.registryFactory[t],this.backendName===t&&(this.pendingBackendInit=null,this.backendName=null,this.backendInstance=null);},t.prototype.getSortedBackends=function(){var t=this;if(0===Object.keys(this.registryFactory).length)throw new Error("No backend found in registry.");return Object.keys(this.registryFactory).sort(function(e,n){return t.registryFactory[n].priority-t.registryFactory[e].priority;});},t.prototype.initializeBackendsAndReturnBest=function(){for(var t=this.getSortedBackends(),e=0;e<t.length;e++){var n=t[e],r=this.initializeBackend(n),o=r.success,a=r.asyncInit;if(a||o)return {name:n,asyncInit:a};}throw new Error("Could not initialize any backends, all backend initializations failed.");},t.prototype.moveData=function(t,e){this.write(t,e,this.readSync(e));},t.prototype.tidy=function(t,e){var n,r=this,o=null;if(null==e){if("function"!=typeof t)throw new Error("Please provide a function to tidy()");e=t;}else{if("string"!=typeof t&&!(t instanceof String))throw new Error("When calling with two arguments, the first argument to tidy() must be a string");if("function"!=typeof e)throw new Error("When calling with two arguments, the 2nd argument to tidy() must be a function");o=t;}return this.scopedRun(function(){return r.startScope(o);},function(){return r.endScope(n);},function(){return (n=e())instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),n;});},t.prototype.scopedRun=function(t,e,n){t();try{var r=n();return e(),r;}catch(t){throw e(),t;}},t.prototype.nextTensorId=function(){return t.nextTensorId++;},t.prototype.nextVariableId=function(){return t.nextVariableId++;},t.prototype.clone=function(t){var e=ht.make(t.shape,{dataId:t.dataId},t.dtype);return this.addTapeNode([t],e,function(t){return [t.toFloat()];}),e;},t.prototype.runKernel=function(t,e,n){var r,o=this,a=[],i=this.isTapeOn(),s=null!=this.state.activeScope?this.state.activeScope.name:"",u=function u(t){i&&(a=t.map(function(t){return o.keep(o.clone(t));}));},l=this.state.numBytes,c=this.state.numTensors;if(this.scopedRun(function(){return o.state.kernelDepth++;},function(){return o.state.kernelDepth--;},function(){r=o.ENV.getBool("DEBUG")?o.profiler.profileKernel(s,function(){return t(o.backend,u);}):t(o.backend,u);}),i){var h={id:this.state.nextTapeNodeId++,name:s,inputs:e,outputs:Array.isArray(r)?r:[r],saved:a};null!=n&&(h.gradient=function(t){return n(t,a);}),this.state.activeTape.push(h);}return this.state.profiling&&this.state.activeProfile.kernels.push({name:s,bytesAdded:this.state.numBytes-l,totalBytesSnapshot:this.state.numBytes,tensorsAdded:this.state.numTensors-c,totalTensorsSnapshot:this.state.numTensors,inputShapes:Object.keys(e).map(function(t){return e[t].shape;}),outputShape:Array.isArray(r)?r.map(function(t){return t.shape;}):r.shape}),r;},t.prototype.registerTensor=function(t,e){var n=this.state.tensorInfo.has(t.dataId)?this.state.tensorInfo.get(t.dataId).refCount:0;if(this.state.numTensors++,"string"===t.dtype&&this.state.numStringTensors++,0===n){this.state.numDataBuffers++;var r=0;"complex64"!==t.dtype&&"string"!==t.dtype&&(r=t.size*F(t.dtype)),this.state.tensorInfo.set(t.dataId,{backend:null!=e?e:this.backend,dtype:t.dtype,shape:t.shape,bytes:r,refCount:0}),this.state.numBytes+=r,null!=e?e.register(t.dataId,t.shape,t.dtype):this.backend.register(t.dataId,t.shape,t.dtype);}this.state.tensorInfo.get(t.dataId).refCount++,t instanceof ft||this.track(t);},t.prototype.registerVariable=function(t){if(null!=this.state.registeredVariables[t.name])throw new Error("Variable with name "+t.name+" was already registered");this.state.registeredVariables[t.name]=t;},t.prototype.disposeTensor=function(t){if(this.state.tensorInfo.has(t.dataId)){this.state.numTensors--,"string"===t.dtype&&this.state.numStringTensors--;var e=this.state.tensorInfo.get(t.dataId);e.refCount<=1?("complex64"!==t.dtype&&(this.state.numBytes-=e.bytes),this.state.numDataBuffers--,e.backend.disposeData(t.dataId),this.state.tensorInfo["delete"](t.dataId)):this.state.tensorInfo.get(t.dataId).refCount--;}},t.prototype.disposeVariables=function(){for(var t in this.state.registeredVariables){var e=this.state.registeredVariables[t];this.disposeVariable(e);}},t.prototype.disposeVariable=function(t){this.disposeTensor(t),null!=this.state.registeredVariables[t.name]&&delete this.state.registeredVariables[t.name];},t.prototype.memory=function(){var t=this.backend.memory();return t.numTensors=this.state.numTensors,t.numDataBuffers=this.state.numDataBuffers,t.numBytes=this.state.numBytes,this.state.numStringTensors>0&&(t.unreliable=!0,null==t.reasons&&(t.reasons=[]),t.reasons.push("Memory usage by string tensors is approximate (2 bytes per character)")),t;},t.prototype.profile=function(t){return n(this,void 0,void 0,function(){var e,n;return r(this,function(r){return this.state.profiling=!0,e=this.state.numBytes,n=this.state.numTensors,this.state.activeProfile.kernels=[],this.state.activeProfile.result=t(),this.state.profiling=!1,this.state.activeProfile.peakBytes=Math.max.apply(Math,this.state.activeProfile.kernels.map(function(t){return t.totalBytesSnapshot;})),this.state.activeProfile.newBytes=this.state.numBytes-e,this.state.activeProfile.newTensors=this.state.numTensors-n,[2,this.state.activeProfile];});});},t.prototype.isTapeOn=function(){return this.state.gradientDepth>0&&0===this.state.kernelDepth;},t.prototype.addTapeNode=function(t,e,n){var r={};t.forEach(function(t,e){r[e]=t;});var o={id:this.state.nextTapeNodeId++,name:this.state.activeScope.name,inputs:r,outputs:[e],gradient:function gradient(t){var e=n(t),r={};return e.forEach(function(t,e){r[e]=function(){return t;};}),r;}};this.state.activeTape.push(o);},t.prototype.keep=function(t){return t.kept=!0,t;},t.prototype.startTape=function(){0===this.state.gradientDepth&&(this.state.activeTape=[]),this.state.gradientDepth++;},t.prototype.endTape=function(){this.state.gradientDepth--;},t.prototype.startScope=function(t){var e={track:[],name:"unnamed scope",id:this.state.nextScopeId++};t&&(e.name=t),this.state.scopeStack.push(e),this.state.activeScope=e;},t.prototype.endScope=function(t){for(var e=this,n=Rt(t),r=new Set(n.map(function(t){return t.id;})),o=0;o<this.state.activeScope.track.length;o++){var a=this.state.activeScope.track[o];a.kept||r.has(a.id)||a.dispose();}var i=this.state.scopeStack.pop();this.state.activeScope=0===this.state.scopeStack.length?null:this.state.scopeStack[this.state.scopeStack.length-1],n.forEach(function(t){t.kept||t.scopeId!==i.id||e.track(t);});},t.prototype.gradients=function(t,e,n,r){var o=this;if(void 0===r&&(r=!1),p(e.length>0,function(){return "gradients() received an empty list of xs.";}),null!=n&&"float32"!==n.dtype)throw new Error("dy must have 'float32' dtype, but has '"+n.dtype+"'");var a=this.scopedRun(function(){return o.startTape();},function(){return o.endTape();},function(){return o.tidy("forward",t);});p(a instanceof ht,function(){return "The result y returned by f() must be a tensor.";});var i=function(t,e,n){for(var r={},o={},a=0;a<e.length;a++){r[e[a].id]=!0;}for(a=0;a<t.length;a++){var i=(d=t[a]).inputs;for(var s in i){for(var u=i[s],l=!1,c=0;c<e.length;c++){if(r[u.id]){d.outputs.forEach(function(t){return r[t.id]=!0;}),l=!0,o[d.id]=!0;break;}}if(l)break;}}var h={};h[n.id]=!0;var f={};for(a=t.length-1;a>=0;a--){for(i=(d=t[a]).inputs,c=0;c<d.outputs.length;c++){if(h[d.outputs[c].id]){for(var s in i){h[i[s].id]=!0,f[d.id]=!0;}break;}}}var p=[];for(a=0;a<t.length;a++){var d;if(o[(d=t[a]).id]&&f[d.id]){var v={};for(var s in d.inputs){var m=d.inputs[s];r[m.id]&&(v[s]=m);}var g=Object.assign({},d);g.inputs=v,g.outputs=d.outputs,p.push(g);}}return p;}(this.state.activeTape,e,a);if(!r&&0===i.length&&e.length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that the f you passed encloses all operations that lead from x to y.");return this.tidy("backward",function(){var t,r,s={};s[a.id]=null==n?(t=a.shape,r=q(g(t),"float32"),ht.make(t,{values:r})):n,function(t,e,n){for(var r=function r(_r2){var o=e[_r2],a=[];if(o.outputs.forEach(function(e){var n=t[e.id];if(null!=n)a.push(n);else{var r=ht.make(e.shape,{values:$(e.size,e.dtype)},e.dtype);a.push(r);}}),null==o.gradient)throw new Error("Cannot compute gradient: gradient function not found for "+o.name+".");var i=o.gradient(1===o.outputs.length?a[0]:a),s=function s(e){if(!(e in i))throw new Error("Cannot backprop through input "+e+". Available gradients found: "+Object.keys(i)+".");var r=n(function(){return i[e]();});if("float32"!==r.dtype)throw new Error("Error in gradient for op "+o.name+". The gradient of input "+e+" must have 'float32' dtype, but has '"+r.dtype+"'");var a=o.inputs[e];if(!y(r.shape,a.shape))throw new Error("Error in gradient for op "+o.name+". The gradient of input '"+e+"' has shape '"+r.shape+"', which does not match the shape of the input '"+a.shape+"'");if(null==t[a.id])t[a.id]=r;else{var s=t[a.id];t[a.id]=s.add(r),s.dispose();}};for(var u in o.inputs){s(u);}},o=e.length-1;o>=0;o--){r(o);}}(s,i,function(t){return o.tidy(t);});var u=e.map(function(t){return s[t.id];});return 0===o.state.gradientDepth&&(o.state.activeTape.forEach(function(t){for(var e in t.saved){t.saved[e].dispose();}}),o.state.activeTape=null),{value:a,grads:u};});},t.prototype.customGrad=function(t){var e=this;return p(U(t),function(){return "The f passed in customGrad(f) must be a function.";}),function(){for(var n,r=[],o=0;o<arguments.length;o++){r[o]=arguments[o];}p(r.every(function(t){return t instanceof ht;}),function(){return "The args passed in customGrad(f)(x1, x2,...) must all be tensors";});var a={};return r.forEach(function(t,e){a[e]=t;}),e.runKernel(function(e,o){return p((n=t.apply(void 0,r.concat([o]))).value instanceof ht,function(){return "The function f passed in customGrad(f) must return an object where `obj.value` is a tensor";}),p(U(n.gradFunc),function(){return "The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function.";}),n.value;},a,function(t,e){var o=n.gradFunc(t,e),a=Array.isArray(o)?o:[o];p(a.length===r.length,function(){return "The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns the same number of tensors as inputs passed to f(...).";}),p(a.every(function(t){return t instanceof ht;}),function(){return "The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns a list of only tensors.";});var i={};return a.forEach(function(t,e){i[e]=function(){return t;};}),i;});};},t.prototype.write=function(t,e,n){var r=this.state.tensorInfo.get(e),o=r.backend;if(t=t||this.backend,"string"===r.dtype){var a=M(n);this.state.numBytes+=a-r.bytes,r.bytes=a;}t!==o&&(o.disposeData(e),r.backend=t,t.register(e,r.shape,r.dtype)),t.write(e,n);},t.prototype.readSync=function(t){return this.state.tensorInfo.get(t).backend.readSync(t);},t.prototype.read=function(t){return this.state.tensorInfo.get(t).backend.read(t);},t.prototype.fromPixels=function(t,e){return this.backend.fromPixels(t,e);},t.prototype.time=function(t){return n(this,void 0,void 0,function(){var e,n;return r(this,function(r){switch(r.label){case 0:return e=j(),[4,this.backend.time(t)];case 1:return (n=r.sent()).wallMs=j()-e,[2,n];}});});},t.prototype.track=function(t){return null!=this.state.activeScope&&(t.scopeId=this.state.activeScope.id,this.state.activeScope.track.push(t)),t;},Object.defineProperty(t.prototype,"registeredVariables",{get:function get(){return this.state.registeredVariables;},enumerable:!0,configurable:!0}),t.prototype.reset=function(){for(var t in this.pendingBackendInitId++,this.state.dispose(),this.ENV.reset(),this.state=new Nt(),this.registry){this.registry[t].dispose(),delete this.registry[t];}this.backendName=null,this.backendInstance=null,this.pendingBackendInit=null;},t.nextTensorId=0,t.nextVariableId=0,t;}();var At=function(){var t=function(){if(null==It){var t=void 0;if("undefined"!=typeof window)t=window;else if("undefined"!=typeof global$1)t=global$1;else if("undefined"!=typeof process)t=process;else{if("undefined"==typeof self)throw new Error("Could not find a global object");t=self;}It=t;}return It;}();if(null==t._tfengine){var e=new o(t);t._tfengine=new kt(e);}return s(t._tfengine.ENV),ut=function ut(){return t._tfengine;},t._tfengine;}();function Tt(){return "undefined"!=typeof window&&null!=window.document||"undefined"!=typeof WorkerGlobalScope;}i.registerFlag("DEBUG",function(){return !1;},function(t){t&&console.warn("Debugging mode is ON. The output of every math call will be downloaded to CPU and checked for NaNs. This significantly impacts performance.");}),i.registerFlag("IS_BROWSER",function(){return Tt();}),i.registerFlag("IS_NODE",function(){return "undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.node;}),i.registerFlag("IS_CHROME",function(){return "undefined"!=typeof navigator&&null!=navigator&&null!=navigator.userAgent&&/Chrome/.test(navigator.userAgent)&&/Google Inc/.test(navigator.vendor);}),i.registerFlag("PROD",function(){return !1;}),i.registerFlag("TENSORLIKE_CHECK_SHAPE_CONSISTENCY",function(){return i.getBool("DEBUG");}),i.registerFlag("DEPRECATION_WARNINGS_ENABLED",function(){return !0;}),i.registerFlag("IS_TEST",function(){return !1;});var Dt,_t,Ot={},Ft={alpha:!1,antialias:!1,premultipliedAlpha:!1,preserveDrawingBuffer:!1,depth:!1,stencil:!1,failIfMajorPerformanceCaveat:!0};function Mt(t,e){Ot[t]=e;}function Bt(t){t in Ot||(Ot[t]=function(t){if(1!==t&&2!==t)throw new Error("Cannot get WebGL rendering context, WebGL is disabled.");var e=Pt(t);if(e.addEventListener("webglcontextlost",function(e){e.preventDefault(),delete Ot[t];},!1),1===t)return e.getContext("webgl",Ft)||e.getContext("experimental-webgl",Ft);return e.getContext("webgl2",Ft);}(t));var e=Ot[t];return e.isContextLost()?(delete Ot[t],Bt(t)):(e.disable(e.DEPTH_TEST),e.disable(e.STENCIL_TEST),e.disable(e.BLEND),e.disable(e.DITHER),e.disable(e.POLYGON_OFFSET_FILL),e.disable(e.SAMPLE_COVERAGE),e.enable(e.SCISSOR_TEST),e.enable(e.CULL_FACE),e.cullFace(e.BACK),Ot[t]);}function Pt(t){if("undefined"!=typeof OffscreenCanvas&&2===t)return new OffscreenCanvas(300,150);if("undefined"!=typeof document)return document.createElement("canvas");throw new Error("Cannot create a canvas in this context");}function Lt(t,e){return [e,t];}function Wt(t){var e=g(t);return w(Math.ceil(e/4));}function Ut(t,e){return [Math.max(1,Math.ceil(e/2)),Math.max(1,Math.ceil(t/2))];}function zt(t,e){var n,r,o,a,s,u,l,c,h,f=t;return 2===i.getNumber("WEBGL_VERSION")?(n=f.R32F,r=f.R16F,o=f.RGBA16F,a=f.RGBA32F,s=f.RED,u=4,l=1,c=f.HALF_FLOAT,h=f.FLOAT):(n=t.RGBA,r=t.RGBA,o=t.RGBA,a=f.RGBA,s=t.RGBA,u=4,l=4,c=null!=e?e.HALF_FLOAT_OES:null,h=t.FLOAT),{internalFormatFloat:n,internalFormatHalfFloat:r,internalFormatPackedHalfFloat:o,internalFormatPackedFloat:a,textureFormatFloat:s,downloadTextureFormat:t.RGBA,downloadUnpackNumChannels:u,defaultNumChannels:l,textureTypeHalfFloat:c,textureTypeFloat:h};}function Vt(t,e,n){var r=n();return e&&function(t){var e=t.getError();if(e!==t.NO_ERROR)throw new Error("WebGL Error: "+$t(t,e));}(t),r;}!function(t){t[t.RENDER=0]="RENDER",t[t.UPLOAD=1]="UPLOAD",t[t.PIXELS=2]="PIXELS",t[t.DOWNLOAD=3]="DOWNLOAD";}(Dt||(Dt={})),function(t){t[t.UNPACKED_FLOAT16=0]="UNPACKED_FLOAT16",t[t.UNPACKED_FLOAT32=1]="UNPACKED_FLOAT32",t[t.PACKED_4X1_UNSIGNED_BYTE=2]="PACKED_4X1_UNSIGNED_BYTE",t[t.PACKED_2X2_FLOAT32=3]="PACKED_2X2_FLOAT32",t[t.PACKED_2X2_FLOAT16=4]="PACKED_2X2_FLOAT16";}(_t||(_t={}));var Gt=5.96e-8,Ht=65504;function qt(t){return !!(i.getBool("WEBGL_RENDER_FLOAT32_ENABLED")||0===t||Gt<Math.abs(t)&&Math.abs(t)<Ht);}function $t(t,e){switch(e){case t.NO_ERROR:return "NO_ERROR";case t.INVALID_ENUM:return "INVALID_ENUM";case t.INVALID_VALUE:return "INVALID_VALUE";case t.INVALID_OPERATION:return "INVALID_OPERATION";case t.INVALID_FRAMEBUFFER_OPERATION:return "INVALID_FRAMEBUFFER_OPERATION";case t.OUT_OF_MEMORY:return "OUT_OF_MEMORY";case t.CONTEXT_LOST_WEBGL:return "CONTEXT_LOST_WEBGL";default:return "Unknown error code "+e;}}function jt(t,e,n){return me(t,e,function(){return t.getExtension(n);},'Extension "'+n+'" not supported on this browser.');}function Kt(t,e,n){var r=me(t,e,function(){return t.createShader(t.VERTEX_SHADER);},"Unable to create vertex WebGLShader.");if(Vt(t,e,function(){return t.shaderSource(r,n);}),Vt(t,e,function(){return t.compileShader(r);}),!1===t.getShaderParameter(r,t.COMPILE_STATUS))throw console.log(t.getShaderInfoLog(r)),new Error("Failed to compile vertex shader.");return r;}function Xt(t,e,n){var r=me(t,e,function(){return t.createShader(t.FRAGMENT_SHADER);},"Unable to create fragment WebGLShader.");if(Vt(t,e,function(){return t.shaderSource(r,n);}),Vt(t,e,function(){return t.compileShader(r);}),!1===t.getShaderParameter(r,t.COMPILE_STATUS))throw function(t,e){var n=Jt.exec(e);if(null==n)return console.log("Couldn't parse line number in error: "+e),void console.log(t);for(var r=+n[1],o=t.split("\n"),a=o.length.toString().length+2,i=o.map(function(t,e){return C((e+1).toString(),a)+t;}),s=0,u=0;u<i.length;u++){s=Math.max(i[u].length,s);}var l=i.slice(0,r-1),c=i.slice(r-1,r),h=i.slice(r);console.log(l.join("\n")),console.log(e.split("\n")[0]),console.log("%c "+C(c[0],s),"border:1px solid red; background-color:#e3d2d2; color:#a61717"),console.log(h.join("\n"));}(n,t.getShaderInfoLog(r)),new Error("Failed to compile fragment shader.");return r;}var Yt,Qt,Jt=/ERROR: [0-9]+:([0-9]+):/g;function Zt(t,e){return me(t,e,function(){return t.createProgram();},"Unable to create WebGLProgram.");}function te(t,e,n){if(Vt(t,e,function(){return t.linkProgram(n);}),!1===t.getProgramParameter(n,t.LINK_STATUS))throw console.log(t.getProgramInfoLog(n)),new Error("Failed to link vertex and fragment shaders.");}function ee(t,e,n){if(Vt(t,e,function(){return t.validateProgram(n);}),!1===t.getProgramParameter(n,t.VALIDATE_STATUS))throw console.log(t.getProgramInfoLog(n)),new Error("Shader program validation failed.");}function ne(t,e,n){var r=me(t,e,function(){return t.createBuffer();},"Unable to create WebGLBuffer");return Vt(t,e,function(){return t.bindBuffer(t.ARRAY_BUFFER,r);}),Vt(t,e,function(){return t.bufferData(t.ARRAY_BUFFER,n,t.STATIC_DRAW);}),r;}function re(t,e,n){var r=me(t,e,function(){return t.createBuffer();},"Unable to create WebGLBuffer");return Vt(t,e,function(){return t.bindBuffer(t.ELEMENT_ARRAY_BUFFER,r);}),Vt(t,e,function(){return t.bufferData(t.ELEMENT_ARRAY_BUFFER,n,t.STATIC_DRAW);}),r;}function oe(t,e){return me(t,e,function(){return t.createTexture();},"Unable to create WebGLTexture.");}function ae(t,e){var n=i.getNumber("WEBGL_MAX_TEXTURE_SIZE");if(t<=0||e<=0){var r="["+t+"x"+e+"]";throw new Error("Requested texture size "+r+" is invalid.");}if(t>n||e>n){r="["+t+"x"+e+"]";throw new Error("Requested texture size "+r+" greater than WebGL maximum on this browser / GPU "+("["+n+"x"+n+"]")+".");}}function ie(t,e){return me(t,e,function(){return t.createFramebuffer();},"Unable to create WebGLFramebuffer.");}function se(t,e,n,r,o,a,i,s){var u=t.getAttribLocation(n,r);return -1!==u&&(Vt(t,e,function(){return t.bindBuffer(t.ARRAY_BUFFER,o);}),Vt(t,e,function(){return t.vertexAttribPointer(u,a,t.FLOAT,!1,i,s);}),Vt(t,e,function(){return t.enableVertexAttribArray(u);}),!0);}function ue(t,e,n,r){ge(t,r),Vt(t,e,function(){return t.activeTexture(t.TEXTURE0+r);}),Vt(t,e,function(){return t.bindTexture(t.TEXTURE_2D,n);});}function le(t,e,n,r){return me(t,e,function(){return t.getUniformLocation(n,r);},'uniform "'+r+'" not present in program.');}function ce(t,e,n){return t.getUniformLocation(e,n);}function he(t,e,n,r,o,a){Vt(t,e,function(){return ue(t,e,r,a);}),Vt(t,e,function(){return t.uniform1i(o,a);});}function fe(t,e,n,r){Vt(t,e,function(){return t.bindFramebuffer(t.FRAMEBUFFER,r);}),Vt(t,e,function(){return t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,n,0);});}function pe(t,e,n){Vt(t,e,function(){return t.bindFramebuffer(t.FRAMEBUFFER,n);}),Vt(t,e,function(){return t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,null,0);});}function de(t){var e=t.checkFramebufferStatus(t.FRAMEBUFFER);if(e!==t.FRAMEBUFFER_COMPLETE)throw new Error("Error binding framebuffer: "+ve(t,e));}function ve(t,e){switch(e){case t.FRAMEBUFFER_INCOMPLETE_ATTACHMENT:return "FRAMEBUFFER_INCOMPLETE_ATTACHMENT";case t.FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT:return "FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT";case t.FRAMEBUFFER_INCOMPLETE_DIMENSIONS:return "FRAMEBUFFER_INCOMPLETE_DIMENSIONS";case t.FRAMEBUFFER_UNSUPPORTED:return "FRAMEBUFFER_UNSUPPORTED";default:return "unknown error "+e;}}function me(t,e,n,r){var o=Vt(t,e,function(){return n();});if(null==o)throw new Error(r);return o;}function ge(t,e){var n=t.MAX_COMBINED_TEXTURE_IMAGE_UNITS-1,r=e+t.TEXTURE0;if(r<t.TEXTURE0||r>n)throw new Error("textureUnit must be in "+("[gl.TEXTURE0, gl.TEXTURE"+n+"]")+".");}function ye(t,e){return void 0===e&&(e=2),g(t.slice(0,t.length-e));}function xe(t){if(0===t.length)throw Error("Cannot get rows and columns of an empty shape array.");return [t.length>1?t[t.length-2]:1,t[t.length-1]];}function be(t){var e=[1,1,1];return 0===t.length||1===t.length&&1===t[0]||(e=[ye(t)].concat(xe(t))),e;}function we(t,e){var n;void 0===e&&(e=!1);var r=i.getNumber("WEBGL_MAX_TEXTURE_SIZE");if(e&&(r*=2,1===(t=t.map(function(e,n){return n>=t.length-2?h(t[n]):t[n];})).length&&(t=[2,t[0]])),2!==t.length){var o=S(t);t=o.newShape;}var a=g(t);if(t.length<=1&&a<=r)return [1,a];if(2===t.length&&t[0]<=r&&t[1]<=r)return t;if(3===t.length&&t[0]*t[1]<=r&&t[2]<=r)return [t[0]*t[1],t[2]];if(3===t.length&&t[0]<=r&&t[1]*t[2]<=r)return [t[0],t[1]*t[2]];if(4===t.length&&t[0]*t[1]*t[2]<=r&&t[3]<=r)return [t[0]*t[1]*t[2],t[3]];if(4===t.length&&t[0]<=r&&t[1]*t[2]*t[3]<=r)return [t[0],t[1]*t[2]*t[3]];if(e){var s=ye(t),u=2,l=2;return t.length&&(u=(n=xe(t))[0],l=n[1]),w(a=s*(u/2)*(l/2)).map(function(t){return 2*t;});}return w(a);}function Ce(t){return t%2==0;}function Ee(t,e){if(y(t=t.slice(-2),e=e.slice(-2)))return !0;if(!t.length||!e.length)return !0;if(0===t[0]||0===t[1]||0===e[0]||0===e[1])return !0;if(t.length!==e.length){var n=t.slice(-1)[0],r=e.slice(-1)[0];if(n===r)return !0;if(Ce(n)&&Ce(r)&&(1===t[0]||1===e[0]))return !0;}return t[1]===e[1]&&Ce(t[0])&&Ce(e[0]);}function Re(t){if(null==Yt){var e=Bt(t);Yt=e.getParameter(e.MAX_TEXTURE_SIZE);}return Yt;}function Ie(t){if(null==Qt){var e=Bt(t);Qt=e.getParameter(e.MAX_TEXTURE_IMAGE_UNITS);}return Math.min(16,Qt);}function Se(t){if(0===t)return 0;var e=Bt(t);return Ne(e,"EXT_disjoint_timer_query_webgl2")&&2===t?2:Ne(e,"EXT_disjoint_timer_query")?1:0;}function Ne(t,e){return null!=t.getExtension(e);}function ke(t){try{if(null!=Bt(t))return !0;}catch(t){return !1;}return !1;}function Ae(t){if(0===t)return !1;var e=Bt(t);if(1===t){if(!Ne(e,"OES_texture_float"))return !1;}else if(!Ne(e,"EXT_color_buffer_float"))return !1;return De(e);}function Te(t){if(0===t)return !1;var e=Bt(t);if(1!==t){if(Ne(e,"EXT_color_buffer_float"))return De(e);if(Ne(e,"EXT_color_buffer_half_float")){var n=e.getExtension("EXT_color_buffer_half_float");return function(t,e){var n=zt(t,e),r=t.createTexture();t.bindTexture(t.TEXTURE_2D,r);t.texImage2D(t.TEXTURE_2D,0,n.internalFormatHalfFloat,1,1,0,n.textureFormatFloat,n.textureTypeHalfFloat,null);var o=t.createFramebuffer();t.bindFramebuffer(t.FRAMEBUFFER,o),t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,r,0);var a=t.checkFramebufferStatus(t.FRAMEBUFFER)===t.FRAMEBUFFER_COMPLETE;return t.bindTexture(t.TEXTURE_2D,null),t.bindFramebuffer(t.FRAMEBUFFER,null),t.deleteTexture(r),t.deleteFramebuffer(o),a;}(e,n);}return !1;}return !!Ne(e,"OES_texture_float")&&!!Ne(e,"WEBGL_color_buffer_float")&&De(e);}function De(t){var e=zt(t),n=t.createTexture();t.bindTexture(t.TEXTURE_2D,n);t.texImage2D(t.TEXTURE_2D,0,e.internalFormatFloat,1,1,0,e.textureFormatFloat,e.textureTypeFloat,null);var r=t.createFramebuffer();t.bindFramebuffer(t.FRAMEBUFFER,r),t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,n,0);var o=t.checkFramebufferStatus(t.FRAMEBUFFER)===t.FRAMEBUFFER_COMPLETE;return t.bindTexture(t.TEXTURE_2D,null),t.bindFramebuffer(t.FRAMEBUFFER,null),t.deleteTexture(n),t.deleteFramebuffer(r),o;}function _e(t){return 2===t&&null!=Bt(t).fenceSync;}var Oe=Object.freeze({callAndCheck:Vt,canBeRepresented:qt,getWebGLErrorMessage:$t,getExtensionOrThrow:jt,createVertexShader:Kt,createFragmentShader:Xt,createProgram:Zt,linkProgram:te,validateProgram:ee,createStaticVertexBuffer:ne,createStaticIndexBuffer:re,getNumChannels:function getNumChannels(){return 2===i.getNumber("WEBGL_VERSION")?1:4;},createTexture:oe,validateTextureSize:ae,createFramebuffer:ie,bindVertexBufferToProgramAttribute:se,bindTextureUnit:ue,unbindTextureUnit:function unbindTextureUnit(t,e,n){ge(t,n),Vt(t,e,function(){return t.activeTexture(t.TEXTURE0+n);}),Vt(t,e,function(){return t.bindTexture(t.TEXTURE_2D,null);});},getProgramUniformLocationOrThrow:le,getProgramUniformLocation:ce,bindTextureToProgramUniformSampler:he,bindCanvasToFramebuffer:function bindCanvasToFramebuffer(t,e){Vt(t,e,function(){return t.bindFramebuffer(t.FRAMEBUFFER,null);}),Vt(t,e,function(){return t.viewport(0,0,t.canvas.width,t.canvas.height);}),Vt(t,e,function(){return t.scissor(0,0,t.canvas.width,t.canvas.height);});},bindColorTextureToFramebuffer:fe,unbindColorTextureFromFramebuffer:pe,validateFramebuffer:de,getFramebufferErrorMessage:ve,getBatchDim:ye,getRowsCols:xe,getShapeAs3D:be,getTextureShapeFromLogicalShape:we,isReshapeFree:Ee,getWebGLMaxTextureSize:Re,resetMaxTextureSize:function resetMaxTextureSize(){Yt=null;},resetMaxTexturesInShader:function resetMaxTexturesInShader(){Qt=null;},getMaxTexturesInShader:Ie,getWebGLDisjointQueryTimerVersion:Se,hasExtension:Ne,isWebGLVersionEnabled:ke,isRenderToFloatTextureEnabled:Ae,isDownloadFloatTextureEnabled:Te,isWebGLFenceEnabled:_e});function Fe(){i.set("PROD",!0);}function Me(){i.set("DEBUG",!0);}function Be(){i.set("DEPRECATION_WARNINGS_ENABLED",!1),console.warn("TensorFlow.js deprecation warnings have been disabled.");}function Pe(t){i.getBool("DEPRECATION_WARNINGS_ENABLED")&&console.warn(t+" You can disable deprecation warnings with tf.disableDeprecationWarnings().");}function Le(){At.disposeVariables();}function We(){return At.memory();}function Ue(t){return At.profile(t);}function ze(t,e){return At.tidy(t,e);}function Ve(t){Rt(t).forEach(function(t){return t.dispose();});}function Ge(t){return At.keep(t);}function He(t){return At.time(t);}function qe(t){return At.setBackend(t);}function $e(){return At.ready();}function je(){return At.backendName;}function Ke(t){At.removeBackend(t);}function Xe(t){return At.findBackend(t);}function Ye(t){return At.findBackendFactory(t);}function Qe(t,e,n){return void 0===n&&(n=1),At.registerBackend(t,e,n);}function Je(){return At.backend;}function Ze(t,e){i.setPlatform(t,e);}function tn(){for(var t=[],e=0;e<arguments.length;e++){t[e]=arguments[e];}i.getBool("IS_TEST")||console.warn.apply(console,t);}function en(t,e){var n=t;if(O(t))return "string"===e?[]:[t.length];if(!Array.isArray(t))return [];for(var r=[];Array.isArray(n)||O(n)&&"string"!==e;){r.push(n.length),n=n[0];}return Array.isArray(t)&&i.getBool("TENSORLIKE_CHECK_SHAPE_CONSISTENCY")&&function t(e,n,r){r=r||[];if(!Array.isArray(e)&&!O(e))return void p(0===n.length,function(){return "Element arr["+r.join("][")+"] is a primitive, but should be an array/TypedArray of "+n[0]+" elements";});p(n.length>0,function(){return "Element arr["+r.join("][")+"] should be a primitive, but is an array of "+e.length+" elements";});p(e.length===n[0],function(){return "Element arr["+r.join("][")+"] should have "+n[0]+" elements, but has "+e.length+" elements";});var o=n.slice(1);for(var a=0;a<e.length;++a){t(e[a],o,r.concat(a));}}(t,r,[]),r;}function nn(t,e,n,r){if(null!=t&&("numeric"!==t&&t!==e||"numeric"===t&&"string"===e))throw new Error("Argument '"+n+"' passed to '"+r+"' must be "+t+" tensor, but got "+e+" tensor");}function rn(t,e,n,r){if(void 0===r&&(r="numeric"),t instanceof ht)return nn(r,t.dtype,e,n),t;var o=W(t);if("string"!==o&&["bool","int32","float32"].indexOf(r)>=0&&(o=r),nn(r,o,e,n),null==t||!O(t)&&!Array.isArray(t)&&"number"!=typeof t&&"boolean"!=typeof t&&"string"!=typeof t){var a=null==t?"null":t.constructor.name;throw new Error("Argument '"+e+"' passed to '"+n+"' must be a Tensor or TensorLike, but got '"+a+"'");}var s=en(t,o);O(t)||Array.isArray(t)||(t=[t]);var u="string"!==o?G(t,o,i.getBool("DEBUG")):m(t,[],!0);return ht.make(s,{values:u},o);}function on$1(t,e,n,r){if(void 0===r&&(r="numeric"),!Array.isArray(t))throw new Error("Argument "+e+" passed to "+n+" must be a `Tensor[]` or `TensorLike[]`");return t.map(function(t,r){return rn(t,e+"["+r+"]",n);},r);}function an(t,e){for(var n=0;n<t.length;++n){if(t[t.length-n-1]!==e-1-n)return !1;}return !0;}function sn(t,e,n){for(var r=t.length+e.length,o=[],a=0,i=0,s=0;s<r;s++){-1===n.indexOf(s)?o.push(t[a++]):o.push(e[i++]);}return o;}function un(t,e){for(var n=[],r=t.length,o=0;o<r;o++){-1===e.indexOf(o)&&n.push(t[o]);}return [n,e.map(function(e){return t[e];})];}function ln(t,e){return sn(t,e.map(function(t){return 1;}),e);}function cn(t,e,n){p(an(e,n),function(){return t+" supports only inner-most axes for now. Got axes "+e+" and rank-"+n+" input.";});}function hn(t,e){if(an(t,e))return null;for(var n=[],r=0;r<e;++r){-1===t.indexOf(r)&&n.push(r);}return t.forEach(function(t){return n.push(t);}),n;}function fn(t){return t.map(function(t,e){return [e,t];}).sort(function(t,e){return t[1]-e[1];}).map(function(t){return t[0];});}function pn(t,e){for(var n=[],r=e-t;r<e;++r){n.push(r);}return n;}function dn(t,e){var n=t[0].length;t.forEach(function(t,e){p(t.length===n,function(){return "Error in concat"+n+"D: rank of tensors["+e+"] must be the same as the rank of the rest ("+n+")";});}),p(e>=0&&e<n,function(){return "Error in concat"+n+"D: axis must be between 0 and "+(n-1)+".";});var r=t[0];t.forEach(function(t,o){for(var a=0;a<n;a++){p(a===e||t[a]===r[a],function(){return "Error in concat"+n+"D: Shape of tensors["+o+"] ("+t+") does not match the shape of the rest ("+r+") along the non-concatenated axis "+o+".";});}});}function vn(t,e){for(var n=t[0].slice(),r=1;r<t.length;r++){n[e]+=t[r][e];}return n;}function mn(t){var e=Object.keys(t);if(1!==e.length)throw new Error("Please provide an object with a single key (operation name) mapping to a function. Got an object with "+e.length+" keys.");var n=e[0],r=t[n];n.endsWith("_")&&(n=n.substring(0,n.length-1));var o=function o(){for(var t=[],e=0;e<arguments.length;e++){t[e]=arguments[e];}At.startScope(n);try{var o=r.apply(void 0,t);return o instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),At.endScope(o),o;}catch(t){throw At.endScope(null),t;}};return Object.defineProperty(o,"name",{value:n,configurable:!0}),o;}i.registerFlag("HAS_WEBGL",function(){return i.getNumber("WEBGL_VERSION")>0;}),i.registerFlag("WEBGL_VERSION",function(){return ke(2)?2:ke(1)?1:0;}),i.registerFlag("WEBGL_BUFFER_SUPPORTED",function(){return 2===i.get("WEBGL_VERSION");}),i.registerFlag("WEBGL_CPU_FORWARD",function(){return !0;}),i.registerFlag("WEBGL_PACK",function(){return i.getBool("HAS_WEBGL");}),i.registerFlag("WEBGL_PACK_NORMALIZATION",function(){return i.getBool("WEBGL_PACK");}),i.registerFlag("WEBGL_PACK_CLIP",function(){return i.getBool("WEBGL_PACK");}),i.registerFlag("WEBGL_PACK_DEPTHWISECONV",function(){return !1;}),i.registerFlag("WEBGL_PACK_BINARY_OPERATIONS",function(){return i.getBool("WEBGL_PACK");}),i.registerFlag("WEBGL_PACK_ARRAY_OPERATIONS",function(){return i.getBool("WEBGL_PACK");}),i.registerFlag("WEBGL_PACK_IMAGE_OPERATIONS",function(){return i.getBool("WEBGL_PACK");}),i.registerFlag("WEBGL_PACK_REDUCE",function(){return i.getBool("WEBGL_PACK");}),i.registerFlag("WEBGL_LAZILY_UNPACK",function(){return i.getBool("WEBGL_PACK");}),i.registerFlag("WEBGL_CONV_IM2COL",function(){return i.getBool("WEBGL_PACK");}),i.registerFlag("WEBGL_MAX_TEXTURE_SIZE",function(){return Re(i.getNumber("WEBGL_VERSION"));}),i.registerFlag("WEBGL_MAX_TEXTURES_IN_SHADER",function(){return Ie(i.getNumber("WEBGL_VERSION"));}),i.registerFlag("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION",function(){var t=i.getNumber("WEBGL_VERSION");return 0===t?0:Se(t);}),i.registerFlag("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_RELIABLE",function(){return i.getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")>0&&(t=navigator.userAgent||navigator.vendor||window.opera,!(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(t)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(t.substr(0,4))));var t;}),i.registerFlag("WEBGL_RENDER_FLOAT32_ENABLED",function(){return Ae(i.getNumber("WEBGL_VERSION"));}),i.registerFlag("WEBGL_DOWNLOAD_FLOAT_ENABLED",function(){return Te(i.getNumber("WEBGL_VERSION"));}),i.registerFlag("WEBGL_FENCE_API_ENABLED",function(){return _e(i.getNumber("WEBGL_VERSION"));}),i.registerFlag("WEBGL_SIZE_UPLOAD_UNIFORM",function(){return i.getBool("WEBGL_RENDER_FLOAT32_ENABLED")?4:0;}),ct=Pe;var gn=mn({complex_:function complex_(t,e){var n=rn(t,"real","complex"),r=rn(e,"imag","complex");return d(n.shape,r.shape,"real and imag shapes, "+n.shape+" and "+r.shape+", must match in call to tf.complex()."),At.runKernel(function(t){return t.complex(n,r);},{$real:n,$imag:r});}}),yn=mn({real_:function real_(t){var e=rn(t,"input","real");return At.runKernel(function(t){return t.real(e);},{$input:e});}}),xn=mn({imag_:function imag_(t){var e=rn(t,"input","imag");return At.runKernel(function(t){return t.imag(e);},{$input:e});}});function bn(t,e,n){return wn(t,e,en(t,n),n);}function wn(t,e,n,r){if(null==r&&(r=W(t)),"complex64"===r)throw new Error("Cannot construct a complex64 tensor directly. Please use tf.complex(real, imag).");if(!O(t)&&!Array.isArray(t)&&"number"!=typeof t&&"boolean"!=typeof t&&"string"!=typeof t)throw new Error("values passed to tensor(values) must be a number/boolean/string or an array of numbers/booleans/strings, or a TypedArray");if(null!=e){K(e);var o=g(e),a=g(n);p(o===a,function(){return "Based on the provided shape, ["+e+"], the tensor should have "+o+" values but has "+a;});for(var s=0;s<n.length;++s){var u=n[s],l=s!==n.length-1||u!==g(e.slice(s));p(n[s]===e[s]||!l,function(){return "Error creating a new Tensor. Inferred shape ("+n+") does not match the provided shape ("+e+"). ";});}}return O(t)||Array.isArray(t)||(t=[t]),e=e||n,t="string"!==r?G(t,r,i.getBool("DEBUG")):m(t,[],!0),ht.make(e,{values:t},r);}function Cn(t,e){if((O(t)&&"string"!==e||Array.isArray(t))&&"complex64"!==e)throw new Error("Error creating a new Scalar: value must be a primitive (number|boolean|string)");if("string"===e&&O(t)&&!(t instanceof Uint8Array))throw new Error("When making a scalar from encoded string, the value must be `Uint8Array`.");return wn(t,[],[],e);}function En(t,e){v(t);var n=en(t,e);if(1!==n.length)throw new Error("tensor1d() requires values to be a flat/TypedArray");return wn(t,null,n,e);}function Rn(t,e,n){if(v(t),null!=e&&2!==e.length)throw new Error("tensor2d() requires shape to have two numbers");var r=en(t,n);if(2!==r.length&&1!==r.length)throw new Error("tensor2d() requires values to be number[][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor2d() requires shape to be provided when `values` are a flat/TypedArray");return wn(t,e,r,n);}function In(t,e,n){if(v(t),null!=e&&3!==e.length)throw new Error("tensor3d() requires shape to have three numbers");var r=en(t,n);if(3!==r.length&&1!==r.length)throw new Error("tensor3d() requires values to be number[][][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor3d() requires shape to be provided when `values` are a flat array");return wn(t,e,r,n);}function Sn(t,e,n){if(v(t),null!=e&&4!==e.length)throw new Error("tensor4d() requires shape to have four numbers");var r=en(t,n);if(4!==r.length&&1!==r.length)throw new Error("tensor4d() requires values to be number[][][][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor4d() requires shape to be provided when `values` are a flat array");return wn(t,e,r,n);}function Nn(t,e,n){if(v(t),null!=e&&5!==e.length)throw new Error("tensor5d() requires shape to have five numbers");var r=en(t,n);if(5!==r.length&&1!==r.length)throw new Error("tensor5d() requires values to be number[][][][][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor5d() requires shape to be provided when `values` are a flat array");return wn(t,e,r,n);}function kn(t,e,n){if(v(t),null!=e&&6!==e.length)throw new Error("tensor6d() requires shape to have six numbers");var r=en(t,n);if(6!==r.length&&1!==r.length)throw new Error("tensor6d() requires values to be number[][][][][][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor6d() requires shape to be provided when `values` are a flat array");return wn(t,e=e||r,r,n);}function An(t,e){if(void 0===e&&(e="float32"),"complex64"===e){var n=An(t,"float32"),r=Tn(t,"float32");return gn(n,r);}var o=q(g(t),e);return ht.make(t,{values:o},e);}function Tn(t,e){if(void 0===e&&(e="float32"),"complex64"===e){var n=Tn(t,"float32"),r=Tn(t,"float32");return gn(n,r);}var o=$(g(t),e);return ht.make(t,{values:o},e);}function Dn(t,e,n){return At.runKernel(function(r){return r.fill(t,e,n);},{});}function _n(t,e,n){if(n<=0)throw new Error("The number of values should be positive.");return At.runKernel(function(r){return r.linspace(t,e,n);},{});}function On(t,e,n,r){if(void 0===n&&(n=1),void 0===r&&(r="float32"),0===n)throw new Error("Cannot have a step of zero");if(t===e||t<e&&n<0||e<t&&n>1)return Tn([0],r);var o=$(Math.abs(Math.ceil((e-t)/n)),r);e<t&&1===n&&(n=-1),o[0]=t;for(var a=1;a<o.length;a++){o[a]=o[a-1]+n;}return En(o,r);}var Fn=mn({onesLike_:function onesLike_(t){var e=rn(t,"x","onesLike");if("complex64"===e.dtype){var n=Fn(yn(e)),r=Mn(xn(e));return gn(n,r);}return At.runKernel(function(t){return t.onesLike(e);},{$x:e},function(t,e){return {$x:function $x(){return Mn(t);}};});}}),Mn=mn({zerosLike_:function zerosLike_(t){var e=rn(t,"x","zerosLike");return At.runKernel(function(t){return t.zerosLike(e);},{$x:e},function(t,e){return {$x:function $x(){return Mn(t);}};});}});var Bn=mn({concat_:function concat_(t,e){void 0===e&&(e=0),p(t.length>=1,function(){return "Pass at least one tensor to concat";});var n=on$1(t,"tensors","concat");e=I(e,n[0].shape)[0];var r=vn(n.map(function(t){return t.shape;}),e);if(0===g(r))return bn([],r);if(1===(n=n.filter(function(t){return t.size>0;})).length)return n[0];var o=n.map(function(t){return t.shape;});dn(o,e);var a=n;return At.runKernel(function(t){return t.concat(n,e);},a,function(t){var n=o.map(function(t){return t[e];});return zn(t,n,e).map(function(t){return function(){return t;};});});}}),Pn=mn({concat1d_:function concat1d_(t){return Bn(t,0);}}),Ln=mn({concat2d_:function concat2d_(t,e){return Bn(t,e);}}),Wn=mn({concat3d_:function concat3d_(t,e){return Bn(t,e);}}),Un=mn({concat4d_:function concat4d_(t,e){return Bn(t,e);}}),zn=mn({split_:function split_(t,e,n){void 0===n&&(n=0);var r,o=rn(t,"x","split");return n=I(n,o.shape)[0],"number"==typeof e?(p(o.shape[n]%e==0,function(){return "Number of splits must evenly divide the axis.";}),r=new Array(e).fill(o.shape[n]/e)):(p(o.shape[n]===e.reduce(function(t,e){return t+e;}),function(){return "The sum of sizes must match the size of the axis dimension.";}),r=e),At.runKernel(function(t){return t.split(o,r,n);},{$x:o},function(t){return {$x:function $x(){return Bn(t,n);}};});}});function Vn(t,e){return t(e={exports:{}},e.exports),e.exports;}var Gn=Vn(function(t){!function(t,e,n){function r(t){var e,n=this,r=(e=4022871197,function(t){t=t.toString();for(var n=0;n<t.length;n++){var r=.02519603282416938*(e+=t.charCodeAt(n));r-=e=r>>>0,e=(r*=e)>>>0,e+=4294967296*(r-=e);}return 2.3283064365386963e-10*(e>>>0);});n.next=function(){var t=2091639*n.s0+2.3283064365386963e-10*n.c;return n.s0=n.s1,n.s1=n.s2,n.s2=t-(n.c=0|t);},n.c=1,n.s0=r(" "),n.s1=r(" "),n.s2=r(" "),n.s0-=r(t),n.s0<0&&(n.s0+=1),n.s1-=r(t),n.s1<0&&(n.s1+=1),n.s2-=r(t),n.s2<0&&(n.s2+=1),r=null;}function o(t,e){return e.c=t.c,e.s0=t.s0,e.s1=t.s1,e.s2=t.s2,e;}function a(t,e){var n=new r(t),a=e&&e.state,i=n.next;return i.int32=function(){return 4294967296*n.next()|0;},i["double"]=function(){return i()+1.1102230246251565e-16*(2097152*i()|0);},i.quick=i,a&&("object"==_typeof_1(a)&&o(a,n),i.state=function(){return o(n,{});}),i;}e&&e.exports?e.exports=a:n&&n.amd?n(function(){return a;}):this.alea=a;}(0,t,!1);}),Hn=Vn(function(t){!function(t,e,n){function r(t){var e=this,n="";e.x=0,e.y=0,e.z=0,e.w=0,e.next=function(){var t=e.x^e.x<<11;return e.x=e.y,e.y=e.z,e.z=e.w,e.w^=e.w>>>19^t^t>>>8;},t===(0|t)?e.x=t:n+=t;for(var r=0;r<n.length+64;r++){e.x^=0|n.charCodeAt(r),e.next();}}function o(t,e){return e.x=t.x,e.y=t.y,e.z=t.z,e.w=t.w,e;}function a(t,e){var n=new r(t),a=e&&e.state,i=function i(){return (n.next()>>>0)/4294967296;};return i["double"]=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21);}while(0===t);return t;},i.int32=n.next,i.quick=i,a&&("object"==_typeof_1(a)&&o(a,n),i.state=function(){return o(n,{});}),i;}e&&e.exports?e.exports=a:n&&n.amd?n(function(){return a;}):this.xor128=a;}(0,t,!1);}),qn=Vn(function(t){!function(t,e,n){function r(t){var e=this,n="";e.next=function(){var t=e.x^e.x>>>2;return e.x=e.y,e.y=e.z,e.z=e.w,e.w=e.v,(e.d=e.d+362437|0)+(e.v=e.v^e.v<<4^t^t<<1)|0;},e.x=0,e.y=0,e.z=0,e.w=0,e.v=0,t===(0|t)?e.x=t:n+=t;for(var r=0;r<n.length+64;r++){e.x^=0|n.charCodeAt(r),r==n.length&&(e.d=e.x<<10^e.x>>>4),e.next();}}function o(t,e){return e.x=t.x,e.y=t.y,e.z=t.z,e.w=t.w,e.v=t.v,e.d=t.d,e;}function a(t,e){var n=new r(t),a=e&&e.state,i=function i(){return (n.next()>>>0)/4294967296;};return i["double"]=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21);}while(0===t);return t;},i.int32=n.next,i.quick=i,a&&("object"==_typeof_1(a)&&o(a,n),i.state=function(){return o(n,{});}),i;}e&&e.exports?e.exports=a:n&&n.amd?n(function(){return a;}):this.xorwow=a;}(0,t,!1);}),$n=Vn(function(t){!function(t,e,n){function r(t){var e=this;e.next=function(){var t,n,r=e.x,o=e.i;return t=r[o],n=(t^=t>>>7)^t<<24,n^=(t=r[o+1&7])^t>>>10,n^=(t=r[o+3&7])^t>>>3,n^=(t=r[o+4&7])^t<<7,t=r[o+7&7],n^=(t^=t<<13)^t<<9,r[o]=n,e.i=o+1&7,n;},function(t,e){var n,r=[];if(e===(0|e))r[0]=e;else for(e=""+e,n=0;n<e.length;++n){r[7&n]=r[7&n]<<15^e.charCodeAt(n)+r[n+1&7]<<13;}for(;r.length<8;){r.push(0);}for(n=0;n<8&&0===r[n];++n){}for(8==n?r[7]=-1:r[n],t.x=r,t.i=0,n=256;n>0;--n){t.next();}}(e,t);}function o(t,e){return e.x=t.x.slice(),e.i=t.i,e;}function a(t,e){null==t&&(t=+new Date());var n=new r(t),a=e&&e.state,i=function i(){return (n.next()>>>0)/4294967296;};return i["double"]=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21);}while(0===t);return t;},i.int32=n.next,i.quick=i,a&&(a.x&&o(a,n),i.state=function(){return o(n,{});}),i;}e&&e.exports?e.exports=a:n&&n.amd?n(function(){return a;}):this.xorshift7=a;}(0,t,!1);}),jn=Vn(function(t){!function(t,e,n){function r(t){var e=this;e.next=function(){var t,n,r=e.w,o=e.X,a=e.i;return e.w=r=r+1640531527|0,n=o[a+34&127],t=o[a=a+1&127],n^=n<<13,t^=t<<17,n^=n>>>15,t^=t>>>12,n=o[a]=n^t,e.i=a,n+(r^r>>>16)|0;},function(t,e){var n,r,o,a,i,s=[],u=128;for(e===(0|e)?(r=e,e=null):(e+="\0",r=0,u=Math.max(u,e.length)),o=0,a=-32;a<u;++a){e&&(r^=e.charCodeAt((a+32)%e.length)),0===a&&(i=r),r^=r<<10,r^=r>>>15,r^=r<<4,r^=r>>>13,a>=0&&(i=i+1640531527|0,o=0==(n=s[127&a]^=r+i)?o+1:0);}for(o>=128&&(s[127&(e&&e.length||0)]=-1),o=127,a=512;a>0;--a){r=s[o+34&127],n=s[o=o+1&127],r^=r<<13,n^=n<<17,r^=r>>>15,n^=n>>>12,s[o]=r^n;}t.w=i,t.X=s,t.i=o;}(e,t);}function o(t,e){return e.i=t.i,e.w=t.w,e.X=t.X.slice(),e;}function a(t,e){null==t&&(t=+new Date());var n=new r(t),a=e&&e.state,i=function i(){return (n.next()>>>0)/4294967296;};return i["double"]=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21);}while(0===t);return t;},i.int32=n.next,i.quick=i,a&&(a.X&&o(a,n),i.state=function(){return o(n,{});}),i;}e&&e.exports?e.exports=a:n&&n.amd?n(function(){return a;}):this.xor4096=a;}(0,t,!1);}),Kn=Vn(function(t){!function(t,e,n){function r(t){var e=this,n="";e.next=function(){var t=e.b,n=e.c,r=e.d,o=e.a;return t=t<<25^t>>>7^n,n=n-r|0,r=r<<24^r>>>8^o,o=o-t|0,e.b=t=t<<20^t>>>12^n,e.c=n=n-r|0,e.d=r<<16^n>>>16^o,e.a=o-t|0;},e.a=0,e.b=0,e.c=-1640531527,e.d=1367130551,t===Math.floor(t)?(e.a=t/4294967296|0,e.b=0|t):n+=t;for(var r=0;r<n.length+20;r++){e.b^=0|n.charCodeAt(r),e.next();}}function o(t,e){return e.a=t.a,e.b=t.b,e.c=t.c,e.d=t.d,e;}function a(t,e){var n=new r(t),a=e&&e.state,i=function i(){return (n.next()>>>0)/4294967296;};return i["double"]=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21);}while(0===t);return t;},i.int32=n.next,i.quick=i,a&&("object"==_typeof_1(a)&&o(a,n),i.state=function(){return o(n,{});}),i;}e&&e.exports?e.exports=a:n&&n.amd?n(function(){return a;}):this.tychei=a;}(0,t,!1);}),Xn=Vn(function(t){!function(e,n){var r,o=this,a=256,i=6,s="random",u=n.pow(a,i),l=n.pow(2,52),c=2*l,h=a-1;function f(t,h,f){var g=[],y=v(function t(e,n){var r,o=[],a=_typeof_1(e);if(n&&"object"==a)for(r in e){try{o.push(t(e[r],n-1));}catch(t){}}return o.length?o:"string"==a?e:e+"\0";}((h=1==h?{entropy:!0}:h||{}).entropy?[t,m(e)]:null==t?function(){try{var t;return r&&(t=r.randomBytes)?t=t(a):(t=new Uint8Array(a),(o.crypto||o.msCrypto).getRandomValues(t)),m(t);}catch(t){var n=o.navigator,i=n&&n.plugins;return [+new Date(),o,i,o.screen,m(e)];}}():t,3),g),x=new p(g),b=function b(){for(var t=x.g(i),e=u,n=0;t<l;){t=(t+n)*a,e*=a,n=x.g(1);}for(;t>=c;){t/=2,e/=2,n>>>=1;}return (t+n)/e;};return b.int32=function(){return 0|x.g(4);},b.quick=function(){return x.g(4)/4294967296;},b["double"]=b,v(m(x.S),e),(h.pass||f||function(t,e,r,o){return o&&(o.S&&d(o,x),t.state=function(){return d(x,{});}),r?(n[s]=t,e):t;})(b,y,"global"in h?h.global:this==n,h.state);}function p(t){var e,n=t.length,r=this,o=0,i=r.i=r.j=0,s=r.S=[];for(n||(t=[n++]);o<a;){s[o]=o++;}for(o=0;o<a;o++){s[o]=s[i=h&i+t[o%n]+(e=s[o])],s[i]=e;}(r.g=function(t){for(var e,n=0,o=r.i,i=r.j,s=r.S;t--;){e=s[o=h&o+1],n=n*a+s[h&(s[o]=s[i=h&i+e])+(s[i]=e)];}return r.i=o,r.j=i,n;})(a);}function d(t,e){return e.i=t.i,e.j=t.j,e.S=t.S.slice(),e;}function v(t,e){for(var n,r=t+"",o=0;o<r.length;){e[h&o]=h&(n^=19*e[h&o])+r.charCodeAt(o++);}return m(e);}function m(t){return String.fromCharCode.apply(0,t);}if(n["seed"+s]=f,v(n.random(),e),t.exports){t.exports=f;try{r=require("crypto");}catch(t){}}}([],Math);});Xn.alea=Gn,Xn.xor128=Hn,Xn.xorwow=qn,Xn.xorshift7=$n,Xn.xor4096=jn,Xn.tychei=Kn;var Yn=Xn.alea,Qn=function(){function t(t,e,n,r,o){this.mean=t,this.stdDev=e,this.dtype=n,this.nextVal=NaN,this.truncated=r,this.truncated&&(this.upper=this.mean+2*this.stdDev,this.lower=this.mean-2*this.stdDev);var a=o||Math.random();this.random=Yn(a.toString());}return t.prototype.nextValue=function(){if(!isNaN(this.nextVal)){var t=this.nextVal;return this.nextVal=NaN,t;}for(var e,n,r=!1;!r;){var o=void 0,a=void 0,i=void 0;do{i=(o=2*this.random()-1)*o+(a=2*this.random()-1)*a;}while(i>=1||0===i);var s=Math.sqrt(-2*Math.log(i)/i);e=this.mean+this.stdDev*o*s,n=this.mean+this.stdDev*a*s,this.truncated&&!this.isValidTruncated(e)||(r=!0);}return this.truncated&&!this.isValidTruncated(n)||(this.nextVal=this.convertValue(n)),this.convertValue(e);},t.prototype.convertValue=function(t){return null==this.dtype||"float32"===this.dtype?t:Math.round(t);},t.prototype.isValidTruncated=function(t){return t<=this.upper&&t>=this.lower;},t;}(),Jn=function(){function t(t,e,n,r){void 0===t&&(t=0),void 0===e&&(e=1);var o=this;if(this.canReturnFloat=function(){return null==o.dtype||"float32"===o.dtype;},this.min=t,this.range=e-t,this.dtype=n,null==r&&(r=Math.random()),"number"==typeof r&&(r=r.toString()),!this.canReturnFloat()&&this.range<=1)throw new Error("The difference between "+t+" - "+e+" <= 1 and dtype is not float");this.random=Yn(r);}return t.prototype.convertValue=function(t){return this.canReturnFloat()?t:Math.round(t);},t.prototype.nextValue=function(){return this.convertValue(this.min+this.range*this.random());},t;}();function Zn(t,e,n){return void 0===e&&(e="float32"),e=e||"float32",K(t),new st(t,e,n);}function tr(t,e){void 0===e&&(e=!1),console.log(t.toString(e));}var er=mn({batchToSpaceND_:function batchToSpaceND_(t,e,n){var r=rn(t,"x","batchToSpaceND"),o=e.reduce(function(t,e){return t*e;});return p(r.rank>=1+e.length,function(){return "input rank is "+r.rank+" but should be > than blockShape.length "+e.length;}),p(n.length===e.length,function(){return "crops.length is "+n.length+" but should be equal to blockShape.length  "+e.length;}),p(r.shape[0]%o==0,function(){return "input tensor batch is "+r.shape[0]+" but is not divisible by the product of the elements of blockShape "+e.join(" * ")+" === "+o;}),At.runKernel(function(t){return t.batchToSpaceND(r,e,n);},{$x:r},function(t){return {$x:function $x(){return t.spaceToBatchND(e,n);}};});}}),nr=mn({cast_:function cast_(t,e){var n=rn(t,"x","cast");if(!D(e))throw new Error("Failed to cast to unknown dtype "+e);if("string"===e&&"string"!==n.dtype||"string"!==e&&"string"===n.dtype)throw new Error("Only strings can be casted to strings");return At.runKernel(function(t){return t.cast(n,e);},{$x:n},function(t){return {$x:function $x(){return t.clone();}};});}}),rr=mn({clone_:function clone_(t){var e=rn(t,"x","clone",null);return At.runKernel(function(t){return ht.make(e.shape,{dataId:e.dataId},e.dtype);},{$x:e},function(t){return {$x:function $x(){return t.toFloat();}};});}}),or=mn({cumsum_:function cumsum_(t,e,n,r){void 0===e&&(e=0),void 0===n&&(n=!1),void 0===r&&(r=!1);var o=rn(t,"x","cumsum"),a=hn([e|=0],o.rank),i=o;null!=a&&(i=o.transpose(a));var s=pn(1,o.rank)[0],u=At.runKernel(function(t){return t.cumsum(i,s,n,r);},{permutedX:i},function(t){return {permutedX:function permutedX(){return t.cumsum(e,n,!r);}};});return null!=a&&(u=u.transpose(a)),u;}}),ar=mn({depthToSpace_:function depthToSpace_(t,e,n){void 0===n&&(n="NHWC");var r=rn(t,"x","depthToSpace"),o="NHWC"===n?r.shape[1]:r.shape[2],a="NHWC"===n?r.shape[2]:r.shape[3],i="NHWC"===n?r.shape[3]:r.shape[1];return p(o*e>=0,function(){return "Negative dimension size caused by overflow when multiplying\n      "+o+" and "+e+"  for depthToSpace with input shape\n      "+r.shape;}),p(a*e>=0,function(){return "Negative dimension size caused by overflow when multiplying\n      "+a+" and "+e+" for depthToSpace with input shape\n          "+r.shape;}),p(i%(e*e)==0,function(){return "Dimension size must be evenly divisible by "+e*e+" but is "+i+" for depthToSpace with input shape "+r.shape;}),At.runKernel(function(t){return t.depthToSpace(r,e,n);},{$x:r});}}),ir=mn({expandDims_:function expandDims_(t,e){void 0===e&&(e=0);var n=rn(t,"x","expandDims",null);p(e<=n.rank,function(){return "Axis must be <= rank of the tensor";});var r=n.shape.slice();return e<0&&(p(-(n.rank+1)<=e,function(){return "Axis must be in the interval ["+-(n.rank+1)+", "+n.rank+"]";}),e=n.rank+e+1),r.splice(e,0,1),yr(n,r);}}),sr=mn({eye_:function eye_(t,e,n,r){void 0===r&&(r="float32"),null==e&&(e=t);for(var o=Zn([t,e],r),a=t<=e?t:e,i=0;i<a;++i){o.set(1,i,i);}var s=o.toTensor().as2D(t,e);if(null==n)return s;if(1===n.length)return Cr(ir(s,0),[n[0],1,1]);if(2===n.length)return Cr(ir(ir(s,0),0),[n[0],n[1],1,1]);if(3===n.length)return Cr(ir(ir(ir(s,0),0),0),[n[0],n[1],n[2],1,1]);throw new Error("eye() currently supports only 1D and 2D batchShapes, but received "+n.length+"D.");}}),ur=mn({multinomial_:function multinomial_(t,e,n,r){void 0===r&&(r=!1);var o=rn(t,"logits","multinomial"),a=o.size,i=o.rank;if(a<2)throw new Error("Error in multinomial: you need at least 2 outcomes, but got "+a+".");if(i>2)throw new Error("Rank of probabilities must be 1 or 2, but is "+i);n=n||Math.random();var s=1===i?o.as2D(1,-1):o,u=At.runKernel(function(t){return t.multinomial(s,r,e,n);},{logits2D:s});return 1===i?u.as1D():u;}}),lr=mn({oneHot_:function oneHot_(t,e,n,r){if(void 0===n&&(n=1),void 0===r&&(r=0),e<2)throw new Error("Error in oneHot: depth must be >=2, but it is "+e);var o=rn(t,"indices","oneHot","int32"),a=o.shape.concat([e]);return o=o.flatten(),At.runKernel(function(t){return t.oneHot(o,e,n,r);},{$indices:o},function(t){return {$indices:function $indices(){return Tn(o.shape,"float32");}};}).reshape(a);}}),cr=mn({pad_:function pad_(t,e,n){void 0===n&&(n=0);var r=rn(t,"x","pad");if(0===r.rank)throw new Error("pad(scalar) is not defined. Pass non-scalar to pad");var o=e.map(function(t){return t[0];});return At.runKernel(function(t){return t.pad(r,e,n);},{$x:r},function(t){return {$x:function $x(){return t.slice(o,r.shape);}};});}}),hr=mn({pad1d_:function pad1d_(t,e,n){return void 0===n&&(n=0),p(2===e.length,function(){return "Invalid number of paddings. Must be length of 2.";}),cr(t,[e],n);}}),fr=mn({pad2d_:function pad2d_(t,e,n){return void 0===n&&(n=0),p(2===e.length&&2===e[0].length&&2===e[1].length,function(){return "Invalid number of paddings. Must be length of 2 each.";}),cr(t,e,n);}}),pr=mn({pad3d_:function pad3d_(t,e,n){return void 0===n&&(n=0),p(3===e.length&&2===e[0].length&&2===e[1].length&&2===e[2].length,function(){return "Invalid number of paddings. Must be length of 2 each.";}),cr(t,e,n);}}),dr=mn({pad4d_:function pad4d_(t,e,n){return void 0===n&&(n=0),p(4===e.length&&2===e[0].length&&2===e[1].length&&2===e[2].length&&2===e[3].length,function(){return "Invalid number of paddings. Must be length of 2 each.";}),cr(t,e,n);}}),vr=mn({rand_:function rand_(t,e,n){var r=g(t),o=null;if(null==n||"float32"===n)o=new Float32Array(r);else if("int32"===n)o=new Int32Array(r);else{if("bool"!==n)throw new Error("Unknown data type "+n);o=new Uint8Array(r);}for(var a=0;a<r;a++){o[a]=e();}return ht.make(t,{values:o},n);}}),mr=mn({randomNormal_:function randomNormal_(t,e,n,r,o){if(void 0===e&&(e=0),void 0===n&&(n=1),null!=r&&"bool"===r)throw new Error("Unsupported data type "+r);for(var a=new Qn(e,n,r,!1,o),i=Zn(t,r),s=0;s<i.values.length;s++){i.values[s]=a.nextValue();}return i.toTensor();}}),gr=mn({randomUniform_:function randomUniform_(t,e,n,r,o){void 0===e&&(e=0),void 0===n&&(n=1),void 0===r&&(r="float32");for(var a=Zn(t,r),i=new Jn(e,n,null,o),s=0;s<a.values.length;s++){a.values[s]=i.nextValue();}return a.toTensor();}}),yr=mn({reshape_:function reshape_(t,e){var n=rn(t,"x","reshape",null);return e=R(e,n.size),p(n.size===g(e),function(){return "new shape and old shape must have the same number of elements.";}),At.runKernel(function(t){return t.reshape(n,e);},{$x:n},function(t){return {$x:function $x(){return t.reshape(n.shape);}};});}}),xr=mn({spaceToBatchND_:function spaceToBatchND_(t,e,n){var r=rn(t,"x","spaceToBatchND");return p(r.rank>=1+e.length,function(){return "input rank "+r.rank+" should be > than [blockShape] "+e.length;}),p(n.length===e.length,function(){return "paddings.shape[0] "+n.length+" must be equal to [blockShape] "+e.length;}),p(r.shape.reduce(function(t,r,o){return o>0&&o<=e.length?t&&(r+n[o-1][0]+n[o-1][1])%e[o-1]==0:t;},!0),function(){return "input spatial dimensions "+r.shape.slice(1)+" with paddings "+n.toString()+" must be divisible by blockShapes "+e.toString();}),At.runKernel(function(t){return t.spaceToBatchND(r,e,n);},{$x:r},function(t){return {$x:function $x(){return t.batchToSpaceND(e,n);}};});}}),br=mn({squeeze_:function squeeze_(t,e){var n=rn(t,"x","squeeze");return yr(n,S(n.shape,e).newShape);}}),wr=mn({stack_:function stack_(t,e){void 0===e&&(e=0);var n=on$1(t,"tensors","stack");if(p(n.length>=1,function(){return "Pass at least one tensor to tf.stack";}),1===n.length)return n[0].expandDims(e);var r=n[0].rank,o=n[0].shape,a=n[0].dtype;p(e<=r,function(){return "Axis must be <= rank of the tensor";}),n.forEach(function(t){d(o,t.shape,"All tensors passed to stack must have matching shapes");}),n.forEach(function(t){p(a===t.dtype,function(){return "All tensors passed to stack must have matching dtypes";});});var i=n.map(function(t){return t.expandDims(e);});return Bn(i,e);}}),Cr=mn({tile_:function tile_(t,e){var n=rn(t,"x","tile",null);return p(n.rank===e.length,function(){return "Error in transpose: rank of input "+n.rank+" must match length of reps "+e+".";}),At.runKernel(function(t,r){var o=t.tile(n,e);return r([n]),o;},{$x:n},function(t,n){var r=n[0];return {$x:function $x(){var n=Mn(r);if(1===r.rank)for(var o=0;o<e[0];++o){n=n.add(t.slice([o*r.shape[0]],[r.shape[0]]));}else if(2===r.rank)for(o=0;o<e[0];++o){for(var a=0;a<e[1];++a){n=n.add(t.slice([o*r.shape[0],a*r.shape[1]],[r.shape[0],r.shape[1]]));}}else if(3===r.rank)for(o=0;o<e[0];++o){for(a=0;a<e[1];++a){for(var i=0;i<e[2];++i){n=n.add(t.slice([o*r.shape[0],a*r.shape[1],i*r.shape[2]],[r.shape[0],r.shape[1],r.shape[2]]));}}}else{if(4!==r.rank)throw new Error("Gradient for tile operation is not implemented for rank-"+r.rank+" tensors yet.");for(o=0;o<e[0];++o){for(a=0;a<e[1];++a){for(i=0;i<e[2];++i){for(var s=0;s<e[3];++s){n=n.add(t.slice([o*r.shape[0],a*r.shape[1],i*r.shape[2],s*r.shape[3]],[r.shape[0],r.shape[1],r.shape[2],r.shape[3]]));}}}}}return n;}};});}}),Er=mn({truncatedNormal_:function truncatedNormal_(t,e,n,r,o){if(void 0===e&&(e=0),void 0===n&&(n=1),null!=r&&"bool"===r)throw new Error("Unsupported data type "+r);for(var a=new Qn(e,n,r,!0,o),i=Zn(t,r),s=0;s<i.values.length;s++){i.values[s]=a.nextValue();}return i.toTensor();}}),Rr=mn({unstack_:function unstack_(t,e){void 0===e&&(e=0),e=e||0;var n=rn(t,"x","unstack");return p(e>=-n.shape.length&&e<n.shape.length,function(){return "Axis = "+e+" is not in [-"+n.shape.length+", "+n.shape.length+")";}),e<0&&(e+=n.shape.length),At.runKernel(function(t){return t.unstack(n,e);},{$x:n},function(t){return {$x:function $x(){return wr(t,e);}};});}}),Ir=function Ir(t,e){return n(this,void 0,void 0,function(){var n,o,a,i,s,u,l,c,h,f;return r(this,function(r){switch(r.label){case 0:return n=rn(t,"x","setdiff1d"),o=rn(e,"y","setdiff1d"),p(n.dtype===o.dtype,function(){return "x and y should have the same dtype, but got x ("+n.dtype+") and y ("+o.dtype+").";}),p(1===n.rank,function(){return "x should be 1D tensor, but got x ("+n.shape+").";}),p(1===o.rank,function(){return "y should be 1D tensor, but got y ("+o.shape+").";}),[4,n.data()];case 1:return a=r.sent(),[4,o.data()];case 2:for(i=r.sent(),s=new Set(i),u=0,h=0;h<a.length;h++){s.has(a[h])||u++;}for(l=new st([u],n.dtype),c=new st([u],"int32"),h=0,f=0;h<a.length;h++){s.has(a[h])||(l.values[f]=a[h],c.values[f]=h,f++);}return [2,[l.toTensor(),c.toTensor()]];}});});};function Sr(t,e,n,r){void 0===r&&(r=!0);var o=[];if(r)(o=o.concat(e.slice(0))).push(t[0]/n),o=o.concat(t.slice(1));else{o=o.concat(t[0]);for(var a=e.length,i=0;i<a;++i){o=o.concat([t[i+1]/e[i],e[i]]);}o=o.concat(t.slice(a+1));}return o;}function Nr(t,e,n){void 0===n&&(n=!0);var r=[];if(n){r.push(e);for(var o=e+1;o<t;++o){o<=2*e?(r.push(o),r.push(o-(e+1))):r.push(o);}}else{var a=[],i=[];for(o=1;o<t;++o){o>=2*e+1||o%2==1?i.push(o):a.push(o);}r.push.apply(r,a),r.push(0),r.push.apply(r,i);}return r;}function kr(t,e,n,r){void 0===r&&(r=!0);var o=[];r?o.push(t[0]/n):o.push(t[0]*n);for(var a=1;a<t.length;++a){a<=e.length?r?o.push(e[a-1]*t[a]):o.push(t[a]/e[a-1]):o.push(t[a]);}return o;}function Ar(t,e){for(var n=[0],r=0;r<e;++r){n.push(t[r][0]);}return n;}function Tr(t,e,n){for(var r=t.slice(0,1),o=0;o<n;++o){r.push(t[o+1]-e[o][0]-e[o][1]);}return r;}function Dr(t,e){if(t.rank<1)throw new Error("tf.gatherND() expects the input to be rank 1 or higher, but the rank was "+t.rank+".");if(e.rank<1)throw new Error("tf.gatherND() expects the indices to be rank 1 or higher, but the rank was "+e.rank+".");if("int32"!==e.dtype)throw new Error("tf.gatherND() expects the indices to be int32 type, but the dtype was "+e.dtype+".");if(e.shape[e.rank-1]>t.rank)throw new Error("index innermost dimension length must be <= tensor rank; saw: "+e.shape[e.rank-1]+" vs. "+t.rank);if(0===t.size)throw new Error("Requested more than 0 entries, but input is empty. Input shape: "+t.shape+".");for(var n=e.shape,r=n[n.length-1],o=1,a=0;a<n.length-1;++a){o*=n[a];}var i=t.shape,s=n.slice();s.pop();var u=1;for(a=r;a<t.rank;++a){u*=i[a],s.push(i[a]);}var l=V(t.shape).map(function(t){return t/u;}).concat([1]).slice(0,r);return [s,o,u,l];}var _r=30;function Or(t){return t<=_r?t:z(t,Math.floor(Math.sqrt(t)));}function Fr(t,e,n){if(e.rank<1)throw new Error("tf.scatterND() expects the indices to be rank 1 or higher, but the rank was "+e.rank+".");if(t.rank<1)throw new Error("tf.scatterND() expects the updates to be rank 1 or higher, but the rank was "+t.rank+".");if("int32"!==e.dtype)throw new Error("The dtype of 'indices' should be int32, but got dtype: "+e.dtype);if(n.length<1)throw new Error("Output rank must be greater or equal to 1, but got shape: "+n);if(0===n.length){if(0===e.size)throw new Error("Indices specified for empty output. indices shape: "+e.shape);if(0===t.size)throw new Error("Updates specified for empty output. updates shape: "+t.shape);}!function(t,e,n){var r=e.rank>1?e.shape[e.rank-1]:1,o=e.rank>1?e.rank-1:1,a="Must have updates.shape = indices.shape[:batchDim] + shape[sliceDim:], got updates.shape: "+n.shape+", indices.shape: "+e.shape+", shape: "+t+", sliceDim: "+r+", and batchDim: "+o+".";if(n.rank<o)throw new Error(a+" update.rank < "+o+". ");if(t.length<r+(n.rank-o))throw new Error(a+" Output shape length < "+(r+(n.rank-o)));if(n.rank!==o+t.length-r)throw new Error(a+" update.rank != "+(o+t.length-r));for(var i=0;i<o;++i){if(n.shape[i]!==e.shape[i])throw new Error(a+" updates.shape["+i+"] ("+n.shape[i]+") != indices.shape["+i+"] ("+e.shape[i]+").");}for(i=0;i<n.rank-o;++i){if(n.shape[i+o]!==t[i+r])throw new Error(a+" updates.shape["+(i+o)+"] ("+n.shape[i+o]+") != shape["+(i+o)+"] ("+t[i+o]+")");}}(n,e,t);}function Mr(t,e,n){for(var r=e.rank>1?e.shape[e.rank-1]:1,o=n.length,a=1,i=r;i<o;++i){a*=n[i];}var s=r<1?1:r;return {sliceRank:r,numUpdates:e.size/s,sliceSize:a,strides:V(n.slice(0,r)).concat([1]),outputSize:g(n)};}function Br(t,e,n,r,o,a,i,s,u){if(void 0===o&&(o=0),void 0===a&&(a=0),void 0===i&&(i=0),void 0===s&&(s=0),void 0===u&&(u=0),0!==i)throw new Error("ellipsis mask is not yet supported");if(0!==s)throw new Error("new axis mask is not yet supported");for(var l=[],c=[],h=[],f=0;f<t.length;f++){l[f]=Pr(o,e,r,t,f),c[f]=Lr(a,n,r,t,f),u&1<<f&&(c[f]=l[f]+1,h.push(f));}var p=new Array(t.length).fill(0);return p=p.map(function(t,e){for(var n=0,o=r[e]||1,a=l[e];!(o>0?a>=c[e]:a<=c[e]);a+=o){n+=1;}return n;}),[l,p,h];}function Pr(t,e,n,r,o){var a=e[o],i=n[o]||1;(t&1<<o||null==a)&&(a=i>0?Number.MIN_SAFE_INTEGER:Number.MAX_SAFE_INTEGER);var s=r[o];return a<0&&(a+=s),a=c(0,a,s-1);}function Lr(t,e,n,r,o){var a=e[o],i=n[o]||1;(t&1<<o||null==a)&&(a=i>0?Number.MAX_SAFE_INTEGER:Number.MIN_SAFE_INTEGER);var s=r[o];return a<0&&(a+=s),a=i>0?c(0,a,s):c(-1,a,s-1);}function Wr(t,e,n){for(var r=n.length,o=0;o<n.length;o++){if(n[o]>1){r=o;break;}}for(o=r+1;o<n.length;o++){if(e[o]>0||n[o]!==t[o])return !1;}return !0;}function Ur(t,e){for(var n=t.length>0?t[t.length-1]:1,r=0;r<t.length-1;r++){n+=t[r]*e[r];}return n;}function zr(t){return p(U(t),function(){return "The f passed in grad(f) must be a function";}),function(e,n){var r=rn(e,"x","tf.grad",null),o=null!=n?rn(n,"dy","tf.grad"):null;return At.tidy(function(){var e=At.gradients(function(){return t(r);},[r],o),n=e.value,a=e.grads;return null!=o&&d(n.shape,o.shape,"The shape of dy passed in grad(f)(x, dy) must match the shape returned by f(x)"),jr(a),a[0];});};}function Vr(t){return p(U(t),function(){return "The f passed in grads(f) must be a function";}),function(e,n){p(Array.isArray(e),function(){return "The args passed in grads(f)(args) must be an array of `Tensor`s or `TensorLike`s";});var r=on$1(e,"args","tf.grads",null),o=null!=n?rn(n,"dy","tf.grads"):null;return At.tidy(function(){var e=At.gradients(function(){return t.apply(void 0,r);},r,o),n=e.value,a=e.grads;return null!=o&&d(n.shape,o.shape,"The shape of dy passed in grads(f)([x1,...], dy) must match the shape returned by f([x1,...])"),jr(a),a;});};}function Gr(t){return p(U(t),function(){return "The f passed in valueAndGrad(f) must be a function";}),function(e,n){p(e instanceof ht,function(){return "The x passed in valueAndGrad(f)(x) must be a tensor";}),p(null==n||n instanceof ht,function(){return "The dy passed in valueAndGrad(f)(x, dy) must be a tensor";});var r=At.gradients(function(){return t(e);},[e],n),o=r.grads,a=r.value;return jr(o),{grad:o[0],value:a};};}function Hr(t){return p(U(t),function(){return "The f passed in valueAndGrads(f) must be a function";}),function(e,n){p(Array.isArray(e)&&e.every(function(t){return t instanceof ht;}),function(){return "The args passed in valueAndGrads(f)(args) must be array of tensors";}),p(null==n||n instanceof ht,function(){return "The dy passed in valueAndGrads(f)(args, dy) must be a tensor";});var r=At.gradients(function(){return t.apply(void 0,e);},e,n);return null!=n&&d(r.value.shape,n.shape,"The shape of dy passed in valueAndGrads(f)([x1,...], dy) must match the shape returned by f([x1,...])"),jr(r.grads),r;};}function qr(t,e){p(U(t),function(){return "The f passed in variableGrads(f) must be a function";}),p(null==e||Array.isArray(e)&&e.every(function(t){return t instanceof ft;}),function(){return "The varList passed in variableGrads(f, varList) must be an array of variables";});var n=null!=e;if(!n)for(var r in e=[],At.registeredVariables){e.push(At.registeredVariables[r]);}var o=n?e.filter(function(t){return !t.trainable;}):null,a=e.length;p((e=e.filter(function(t){return t.trainable;})).length>0,function(){return "variableGrads() expects at least one of the input variables to be trainable, but none of the "+a+" variables is trainable.";});var i=At.gradients(t,e,null,!0),s=i.value,u=i.grads;p(u.some(function(t){return null!=t;}),function(){return "Cannot find a connection between any variable and the result of the loss function y=f(x). Please make sure the operations that use variables are inside the function f passed to minimize().";}),p(0===s.rank,function(){return "The f passed in variableGrads(f) must return a scalar, but it returned a rank-"+s.rank+" tensor";});var l={};return e.forEach(function(t,e){null!=u[e]&&(l[t.name]=u[e]);}),null!=o&&o.forEach(function(t){return l[t.name]=null;}),{value:s,grads:l};}function $r(t){return At.customGrad(t);}function jr(t){if(t.filter(function(t){return null==t;}).length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that\n    the f you passed encloses all operations that lead from x to y.");}var Kr=mn({softmax_:function softmax_(t,e){void 0===e&&(e=-1);var n=rn(t,"logits","softmax");if(-1===e&&(e=n.rank-1),e!==n.rank-1)throw Error("Softmax along a non-last dimension is not yet supported. Logits was rank "+n.rank+" and dim was "+e);return $r(function(t,n){var r=t.logSumExp([e],!0),o=t.toFloat().sub(r).exp();return n([o]),{value:o,gradFunc:function gradFunc(t,n){var r=n[0],o=t.mul(r);return o.sub(o.sum([e],!0).mul(r));}};})(n);}}),Xr=mn({logSoftmax_:function logSoftmax_(t,e){void 0===e&&(e=-1);var n=rn(t,"logits","logSoftmax");if(-1===e&&(e=n.rank-1),e!==n.rank-1)throw Error("Log Softmax along a non-last dimension is not yet supported. Logits was rank "+n.rank+" and axis was "+e);return $r(function(t,n){var r=t.max(e,!0),o=t.sub(r),a=o.toFloat().sub(o.exp().sum(e,!0).log());return n([a]),{value:a,gradFunc:function gradFunc(t,n){var r=n[0].exp();return t.sub(t.sum(e,!0).mul(r));}};})(n);}}),Yr=function(){function t(t,e){this.backend=t,this.dataMover=e,this.data=new WeakMap();}return t.prototype.get=function(t){return this.data.has(t)||this.dataMover.moveData(this.backend,t),this.data.get(t);},t.prototype.set=function(t,e){this.data.set(t,e);},t.prototype.has=function(t){return this.data.has(t);},t.prototype["delete"]=function(t){return this.data["delete"](t);},t;}(),Qr=function(){function t(){}return t.prototype.time=function(t){throw new Error("Not yet implemented.");},t.prototype.read=function(t){throw new Error("Not yet implemented.");},t.prototype.readSync=function(t){throw new Error("Not yet implemented.");},t.prototype.disposeData=function(t){throw new Error("Not yet implemented.");},t.prototype.write=function(t,e){throw new Error("Not yet implemented.");},t.prototype.fromPixels=function(t,e){throw new Error("Not yet implemented.");},t.prototype.register=function(t,e,n){throw new Error("Not yet implemented.");},t.prototype.memory=function(){throw new Error("Not yet implemented.");},t.prototype.floatPrecision=function(){throw new Error("Not yet implemented");},t.prototype.epsilon=function(){return 32===this.floatPrecision()?1e-7:1e-4;},t.prototype.batchMatMul=function(t,e,n,r){throw new Error("Not yet implemented");},t.prototype.fusedBatchMatMul=function(t,e,n,r,o,a){throw new Error("Not yet implemented");},t.prototype.slice=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.stridedSlice=function(t,e,n,r,o,a,i,s,u){throw new Error("Not yet implemented");},t.prototype.unstack=function(t,e){throw new Error("Not yet implemented");},t.prototype.reverse=function(t,e){throw new Error("Not yet implemented");},t.prototype.concat=function(t,e){throw new Error("Not yet implemented");},t.prototype.neg=function(t){throw new Error("Not yet implemented");},t.prototype.add=function(t,e){throw new Error("Not yet implemented");},t.prototype.addN=function(t){throw new Error("Not yet implemented");},t.prototype.subtract=function(t,e){throw new Error("Not yet implemented");},t.prototype.multiply=function(t,e){throw new Error("Not yet implemented");},t.prototype.realDivide=function(t,e){throw new Error("Not yet implemented");},t.prototype.floorDiv=function(t,e){throw new Error("Not yet implemented");},t.prototype.sum=function(t,e){throw new Error("Not yet implemented");},t.prototype.prod=function(t,e){throw new Error("Not yet implemented");},t.prototype.unsortedSegmentSum=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.argMin=function(t,e){throw new Error("Not yet implemented");},t.prototype.argMax=function(t,e){throw new Error("Not yet implemented");},t.prototype.equal=function(t,e){throw new Error("Not yet implemented");},t.prototype.notEqual=function(t,e){throw new Error("Not yet implemented");},t.prototype.less=function(t,e){throw new Error("Not yet implemented");},t.prototype.lessEqual=function(t,e){throw new Error("Not yet implemented");},t.prototype.greater=function(t,e){throw new Error("Not yet implemented");},t.prototype.greaterEqual=function(t,e){throw new Error("Not yet implemented");},t.prototype.logicalNot=function(t){throw new Error("Not yet implemented");},t.prototype.logicalAnd=function(t,e){throw new Error("Not yet implemented");},t.prototype.logicalOr=function(t,e){throw new Error("Not yet implemented");},t.prototype.where=function(t){throw new Error("Not yet implemented");},t.prototype.select=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.topk=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.min=function(t,e){throw new Error("Not yet implemented");},t.prototype.minimum=function(t,e){throw new Error("Not yet implemented");},t.prototype.mod=function(t,e){throw new Error("Not yet implemented");},t.prototype.max=function(t,e){throw new Error("Not yet implemented");},t.prototype.maximum=function(t,e){throw new Error("Not yet implemented");},t.prototype.all=function(t,e){throw new Error("Not yet implemented");},t.prototype.any=function(t,e){throw new Error("Not yet implemented");},t.prototype.squaredDifference=function(t,e){throw new Error("Not yet implemented");},t.prototype.ceil=function(t){throw new Error("Not yet implemented");},t.prototype.floor=function(t){throw new Error("Not yet implemented");},t.prototype.round=function(t){throw new Error("Not yet implemented");},t.prototype.sign=function(t){throw new Error("Not yet implemented");},t.prototype.isNaN=function(t){throw new Error("Not yet implemented");},t.prototype.isInf=function(t){throw new Error("Not yet implemented");},t.prototype.isFinite=function(t){throw new Error("Not yet implemented");},t.prototype.pow=function(t,e){throw new Error("Not yet implemented");},t.prototype.exp=function(t){throw new Error("Not yet implemented");},t.prototype.expm1=function(t){throw new Error("Not yet implemented");},t.prototype.log=function(t){throw new Error("Not yet implemented");},t.prototype.log1p=function(t){throw new Error("Not yet implemented");},t.prototype.sqrt=function(t){throw new Error("Not yet implemented");},t.prototype.rsqrt=function(t){throw new Error("Not yet implemented");},t.prototype.square=function(t){throw new Error("Not yet implemented");},t.prototype.reciprocal=function(t){throw new Error("Not yet implemented");},t.prototype.relu=function(t){throw new Error("Not yet implemented");},t.prototype.prelu=function(t,e){throw new Error("Not yet implemented");},t.prototype.elu=function(t){throw new Error("Not yet implemented");},t.prototype.eluDer=function(t,e){throw new Error("Not yet implemented");},t.prototype.selu=function(t){throw new Error("Not yet implemented");},t.prototype["int"]=function(t){throw new Error("Not yet implemented");},t.prototype.clip=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.abs=function(t){throw new Error("Not yet implemented");},t.prototype.complexAbs=function(t){throw new Error("Not yet implemented");},t.prototype.sigmoid=function(t){throw new Error("Not yet implemented");},t.prototype.softplus=function(t){throw new Error("Not yet implemented");},t.prototype.sin=function(t){throw new Error("Not yet implemented");},t.prototype.cos=function(t){throw new Error("Not yet implemented");},t.prototype.tan=function(t){throw new Error("Not yet implemented");},t.prototype.asin=function(t){throw new Error("Not yet implemented");},t.prototype.acos=function(t){throw new Error("Not yet implemented");},t.prototype.atan=function(t){throw new Error("Not yet implemented");},t.prototype.atan2=function(t,e){throw new Error("Not yet implemented");},t.prototype.sinh=function(t){throw new Error("Not yet implemented");},t.prototype.cosh=function(t){throw new Error("Not yet implemented");},t.prototype.tanh=function(t){throw new Error("Not yet implemented");},t.prototype.asinh=function(t){throw new Error("Not yet implemented");},t.prototype.acosh=function(t){throw new Error("Not yet implemented");},t.prototype.atanh=function(t){throw new Error("Not yet implemented");},t.prototype.erf=function(t){throw new Error("Not yet implemented");},t.prototype.step=function(t,e){throw new Error("Not yet implemented");},t.prototype.fusedConv2d=function(t,e,n,r,o){throw new Error("Not yet implemented");},t.prototype.conv2d=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.conv2dDerInput=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.conv2dDerFilter=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.depthwiseConv2D=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.depthwiseConv2DDerInput=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.depthwiseConv2DDerFilter=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.conv3d=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.conv3dDerInput=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.conv3dDerFilter=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.maxPool=function(t,e){throw new Error("Not yet implemented");},t.prototype.maxPoolBackprop=function(t,e,n,r){throw new Error("Not yet implemented");},t.prototype.avgPool=function(t,e){throw new Error("Not yet implemented");},t.prototype.avgPoolBackprop=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.reshape=function(t,e){throw new Error("Not yet implemented");},t.prototype.cast=function(t,e){throw new Error("Not yet implemented");},t.prototype.tile=function(t,e){throw new Error("Not yet implemented");},t.prototype.pad=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.transpose=function(t,e){throw new Error("Not yet implemented");},t.prototype.gather=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.gatherND=function(t,e){throw new Error("Not yet implemented");},t.prototype.scatterND=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.batchToSpaceND=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.spaceToBatchND=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.resizeBilinear=function(t,e,n,r){throw new Error("Not yet implemented");},t.prototype.resizeBilinearBackprop=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.resizeNearestNeighbor=function(t,e,n,r){throw new Error("Not yet implemented");},t.prototype.resizeNearestNeighborBackprop=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.batchNormalization=function(t,e,n,r,o,a){throw new Error("Not yet implemented");},t.prototype.localResponseNormalization4D=function(t,e,n,r,o){throw new Error("Not yet implemented");},t.prototype.LRNGrad=function(t,e,n,r,o,a,i){throw new Error("Not yet implemented");},t.prototype.multinomial=function(t,e,n,r){throw new Error("Not yet implemented");},t.prototype.oneHot=function(t,e,n,r){throw new Error("Not yet implemented");},t.prototype.cumsum=function(t,e,n,r){throw new Error("Not yet implemented");},t.prototype.nonMaxSuppression=function(t,e,n,r,o){throw new Error("Not yet implemented");},t.prototype.fft=function(t){throw new Error("Not yet implemented");},t.prototype.ifft=function(t){throw new Error("Not yet implemented");},t.prototype.complex=function(t,e){throw new Error("Not yet implemented");},t.prototype.real=function(t){throw new Error("Not yet implemented");},t.prototype.imag=function(t){throw new Error("Not yet implemented");},t.prototype.cropAndResize=function(t,e,n,r,o,a){throw new Error("Not yet implemented");},t.prototype.depthToSpace=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.split=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.sparseToDense=function(t,e,n,r){throw new Error("Not yet implemented");},t.prototype.fill=function(t,e,n){throw new Error("Not yet implemented.");},t.prototype.onesLike=function(t){throw new Error("Not yet implemented");},t.prototype.zerosLike=function(t){throw new Error("Not yet implemented");},t.prototype.linspace=function(t,e,n){throw new Error("Not yet implemented");},t.prototype.dispose=function(){throw new Error("Not yet implemented");},t;}();function Jr(t,e){for(var n=t.length,r=[],o=0;o<n;o++){var a=n-1-o,i=t[a]||1;(e[e.length-1-o]||1)>1&&1===i&&r.unshift(a);}return r;}function Zr(t,e){for(var n=[],r=0;r<e.length;r++){var o=t[t.length-r-1],a=e.length-r-1,i=e[a];(null==o||1===o&&i>1)&&n.unshift(a);}return n;}function to(t,e){for(var n=[],r=Math.max(t.length,e.length),o=0;o<r;o++){var a=t[t.length-o-1];null==a&&(a=1);var i=e[e.length-o-1];if(null==i&&(i=1),1===a)n.unshift(i);else if(1===i)n.unshift(a);else{if(a!==i)throw Error("Operands could not be broadcast together with shapes "+t+" and "+e+".");n.unshift(a);}}return n;}function eo(t,e,n,r,o,a,i){void 0===i&&(i="channelsLast");var s,u=ao(e),l=u[0],c=u[1];if("channelsLast"===i)s=[l,c,t[3],t[3]];else{if("channelsFirst"!==i)throw new Error("Unknown dataFormat "+i);s=[l,c,t[1],t[1]];}return no(t,s,n,r,o,a,!1,i);}function no(t,e,n,r,o,a,i,s){void 0===i&&(i=!1),void 0===s&&(s="channelsLast");var u=[-1,-1,-1,-1],l=u[0],c=u[1],h=u[2],f=u[3];if("channelsLast"===s)l=t[0],c=t[1],h=t[2],f=t[3];else{if("channelsFirst"!==s)throw new Error("Unknown dataFormat "+s);l=t[0],f=t[1],c=t[2],h=t[3];}var d,v=e[0],m=e[1],g=e[3],y=ao(n),b=y[0],w=y[1],C=ao(r),E=C[0],R=C[1],I=so(v,E),S=so(m,R),N=function(t,e,n,r,o,a,i,s){var u,l,c;if("number"==typeof t){var h=0===t?"VALID":"NUMBER";u={top:t,bottom:t,left:t,right:t,type:h};var f=function(t,e,n,r,o){null==r&&(r=oo(t,e,n));var a=t[0],i=t[1],s=uo((a-e+2*r)/n+1,o);p(_x(s),function(){return "The output # of rows ("+s+") must be an integer. Change the stride and/or zero pad parameters";});var u=uo((i-e+2*r)/n+1,o);return p(_x(u),function(){return "The output # of columns ("+u+") must be an integer. Change the stride and/or zero pad parameters";}),[s,u];}([e,n],a,r,t,s);l=f[0],c=f[1];}else if("same"===t){l=Math.ceil(e/r),c=Math.ceil(n/o);var d=Math.max(0,(l-1)*r+a-e),v=Math.max(0,(c-1)*o+i-n),m=Math.floor(d/2),g=d-m,y=Math.floor(v/2),b=v-y;u={top:m,bottom:g,left:y,right:b,type:"SAME"};}else{if("valid"!==t)throw Error("Unknown padding parameter: "+t);u={top:0,bottom:0,left:0,right:0,type:"VALID"},l=Math.ceil((e-a+1)/r),c=Math.ceil((n-i+1)/o);}return {padInfo:u,outHeight:l,outWidth:c};}(o,c,h,b,w,I,S,a),k=N.padInfo,A=N.outHeight,T=N.outWidth,D=i?g*f:g;return "channelsFirst"===s?d=[l,D,A,T]:"channelsLast"===s&&(d=[l,A,T,D]),{batchSize:l,dataFormat:s,inHeight:c,inWidth:h,inChannels:f,outHeight:A,outWidth:T,outChannels:D,padInfo:k,strideHeight:b,strideWidth:w,filterHeight:v,filterWidth:m,effectiveFilterHeight:I,effectiveFilterWidth:S,dilationHeight:E,dilationWidth:R,inShape:t,outShape:d,filterShape:e};}function ro(t,e,n,r,o,a,i){void 0===a&&(a=!1),void 0===i&&(i="channelsLast");var s=[-1,-1,-1,-1,-1],u=s[0],l=s[1],c=s[2],h=s[3],f=s[4];if("channelsLast"===i)u=t[0],l=t[1],c=t[2],h=t[3],f=t[4];else{if("channelsFirst"!==i)throw new Error("Unknown dataFormat "+i);u=t[0],f=t[1],l=t[2],c=t[3],h=t[4];}var p,d=e[0],v=e[1],m=e[2],g=e[4],y=io(n),x=y[0],b=y[1],w=y[2],C=io(r),E=C[0],R=C[1],I=C[2],S=function(t,e,n,r,o,a,i,s,u,l){var c,h,f,p;if("same"===t){h=Math.ceil(e/o),f=Math.ceil(n/a),p=Math.ceil(r/i);var d=(h-1)*o+s-e,v=(f-1)*a+u-n,m=(p-1)*i+l-r,g=Math.floor(d/2),y=d-g,x=Math.floor(v/2),b=v-x,w=Math.floor(m/2),C=m-w;c={top:x,bottom:b,left:w,right:C,front:g,back:y,type:"SAME"};}else{if("valid"!==t)throw Error("Unknown padding parameter: "+t);c={top:0,bottom:0,left:0,right:0,front:0,back:0,type:"VALID"},h=Math.ceil((e-s+1)/o),f=Math.ceil((n-u+1)/a),p=Math.ceil((r-l+1)/i);}return {padInfo:c,outDepth:h,outHeight:f,outWidth:p};}(o,l,c,h,x,b,w,so(d,E),so(v,R),so(m,I)),N=S.padInfo,k=S.outDepth,A=S.outHeight,T=S.outWidth,D=a?g*f:g;return "channelsFirst"===i?p=[u,D,k,A,T]:"channelsLast"===i&&(p=[u,k,A,T,D]),{batchSize:u,dataFormat:i,inDepth:l,inHeight:c,inWidth:h,inChannels:f,outDepth:k,outHeight:A,outWidth:T,outChannels:D,padInfo:N,strideDepth:x,strideHeight:b,strideWidth:w,filterDepth:d,filterHeight:v,filterWidth:m,dilationDepth:E,dilationHeight:R,dilationWidth:I,inShape:t,outShape:p,filterShape:e};}function oo(t,e,n,r){void 0===r&&(r=1);var o=so(e,r);return Math.floor((t[0]*(n-1)-n+o)/2);}function ao(t){return "number"==typeof t?[t,t]:t;}function io(t){return "number"==typeof t?[t,t,t]:t;}function so(t,e){return e<=1?t:t+(t-1)*(e-1);}function uo(t,e){if(!e)return t;switch(e){case"round":return Math.round(t);case"ceil":return Math.ceil(t);case"floor":return Math.floor(t);default:throw new Error("Unknown roundingMode "+e);}}function lo(t){var e=ao(t),n=e[0],r=e[1];return 1===n&&1===r;}function co(t,e){return lo(t)||lo(e);}function ho(t,e,n){if("complex64"===e){if("complex64"===t.dtype)return t.clone();var r=Tn(t.shape),o=t.toFloat(),a=n.complex(o,r);return r.dispose(),o.dispose(),a;}if(!_(t.dtype,e))return ht.make(t.shape,{dataId:t.dataId},e);if("complex64"===t.dtype){var i=n.real(t);a=i.cast(e);return i.dispose(),a;}if("int32"===e)return n["int"](t);if("bool"===e){var s=Cn(0,t.dtype);a=n.notEqual(t,s);return s.dispose(),a;}throw new Error("Error in Cast: failed to cast "+t.dtype+" to "+e);}function fo(t,e){return ht.make(e,{dataId:t.dataId},t.dtype);}function po(t,e,n){var r=(e-t)/(n-1),o=$(n,"float32");o[0]=t;for(var a=1;a<o.length;a++){o[a]=o[a-1]+r;}return En(o,"float32");}var vo=Object.freeze({castTensor:ho,reshapeTensor:fo,linspaceImpl:po,upcastType:bt,axesAreInnerMostDims:an,combineLocations:sn,computeOutAndReduceShapes:un,expandShapeToKeepDim:ln,assertAxesAreInnerMostDims:cn,getAxesPermutation:hn,getUndoAxesPermutation:fn,getInnerMostAxes:pn,getBroadcastDims:Jr,getReductionAxes:Zr,assertAndGetBroadcastShape:to,assertParamsConsistent:dn,computeOutShape:vn,computePool2DInfo:eo,computeConv2DInfo:no,computeConv3DInfo:ro,computeDefaultPad:oo,tupleValuesAreOne:lo,eitherStridesOrDilationsAreOne:co});function mo(t,e){if(t.length!==e.length)throw new Error("Cannot merge real and imag arrays of different lengths. real:"+t.length+", imag: "+e.length+".");for(var n=new Float32Array(2*t.length),r=0;r<n.length;r+=2){n[r]=t[r/2],n[r+1]=e[r/2];}return n;}function go(t,e){return {real:t[2*e],imag:t[2*e+1]};}function yo(t,e,n,r){t[2*r]=e,t[2*r+1]=n;}function xo(t,e,n){var r=(n?2:-2)*Math.PI*(t/e);return {real:Math.cos(r),imag:Math.sin(r)};}function bo(t,e,n,r,o){for(var a=Array.from(e).map(function(t,e){return {score:t,boxIndex:e};}).filter(function(t){return t.score>o;}).sort(function(t,e){return e.score-t.score;}),i=[],s=0;s<a.length;s++){var u=a[s],l=u.score,c=u.boxIndex;if(l<o)break;for(var h=!1,f=i.length-1;f>=0;--f){if(wo(t,c,i[f])>=r){h=!0;break;}}if(!h&&(i.push(c),i.length>=n))break;}return En(i,"int32");}function wo(t,e,n){var r=t.subarray(4*e,4*e+4),o=t.subarray(4*n,4*n+4),a=Math.min(r[0],r[2]),i=Math.min(r[1],r[3]),s=Math.max(r[0],r[2]),u=Math.max(r[1],r[3]),l=Math.min(o[0],o[2]),c=Math.min(o[1],o[3]),h=Math.max(o[0],o[2]),f=Math.max(o[1],o[3]),p=(s-a)*(u-i),d=(h-l)*(f-c);if(p<=0||d<=0)return 0;var v=Math.max(a,l),m=Math.max(i,c),g=Math.min(s,h),y=Math.min(u,f),x=Math.max(g-v,0)*Math.max(y-m,0);return x/(p+d-x);}function Co(t,e,n){var r=new Array(t.rank).fill(0),o=t.shape.slice();return e.map(function(e){o[n]=e;var a=t.slice(r,o);return r[n]+=e,a;});}function Eo(t,e){for(var n=new Array(t.rank),r=0;r<n.length;r++){n[r]=t.shape[r]*e[r];}var o=Zn(n,t.dtype);for(r=0;r<o.values.length;++r){for(var a=o.indexToLoc(r),i=new Array(t.rank),s=0;s<i.length;s++){i[s]=a[s]%t.shape[s];}var u=t.locToIndex(i);o.values[r]=t.values[u];}return o.toTensor();}function Ro(t,e,n,r,o){for(var a=e[e.length-1],i=[t.length/a,a],s=i[0],u=i[1],l=N(n,s*r),c=N("int32",s*r),h=0;h<s;h++){for(var f=h*u,p=t.subarray(f,f+u),d=[],v=0;v<p.length;v++){d.push({value:p[v],index:v});}d.sort(function(t,e){return e.value-t.value;});var m=h*r,g=l.subarray(m,m+r),y=c.subarray(m,m+r);for(v=0;v<r;v++){g[v]=d[v].value,y[v]=d[v].index;}}var x=e.slice();return x[x.length-1]=r,[bn(l,x,n),bn(c,x,"int32")];}function Io(t,e){for(var n=[],r=0;r<e.length;r++){e[r]&&n.push(r);}var o=Zn(t,"int32"),a=Zn([n.length,t.length],"int32");for(r=0;r<n.length;r++){var i=o.indexToLoc(n[r]),s=r*t.length;a.values.set(i,s);}return a.toTensor();}var So=function(){return function(t,e){this.outputShape=[],this.outputShape=t,this.variableNames=e.map(function(t,e){return "T"+e;});var n=[];this.variableNames.forEach(function(t){n.push("float v"+t+" = get"+t+"AtOutCoords();");});var r=this.variableNames.map(function(t){return "v"+t;}).join(" + ");this.userCode="\n      void main() {\n        "+n.join("\n        ")+"\n\n        float result = "+r+";\n        setOutput(result);\n      }\n    ";};}(),No=function(){return function(t,e){this.outputShape=[],this.usesPackedTextures=!0,this.outputShape=t,this.variableNames=e.map(function(t,e){return "T"+e;});var n=[];this.variableNames.forEach(function(t){n.push("vec4 v"+t+" = get"+t+"AtOutCoords();");});var r=this.variableNames.map(function(t){return "v"+t;}).join(" + ");this.userCode="\n      void main() {\n        "+n.join("\n        ")+"\n\n        vec4 result = "+r+";\n        setOutput(result);\n      }\n    ";};}(),ko=function(){return function(t,e,n){this.variableNames=["A"];var r=t.windowSize,o=t.batchSize,a=t.inSize,i=Math.ceil(a/r);n||this.variableNames.push("bestIndicesA"),this.outputShape=[o,i];var s="max"===e?">":"<",u=n?"inOffset + i;":"round(getBestIndicesA(batch, inOffset + i));";this.userCode="\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int batch = coords[0];\n        int outIdx = coords[1];\n        int inOffset = outIdx * "+r+";\n\n        int bestIndex = inOffset;\n        float bestValue = getA(batch, bestIndex);\n\n        for (int i = 0; i < "+r+"; i++) {\n          int inIdx = "+u+";\n          float candidate = getA(batch, inIdx);\n          if (candidate "+s+" bestValue) {\n            bestValue = candidate;\n            bestIndex = inIdx;\n          }\n        }\n        setOutput(float(bestIndex));\n      }\n    ";};}();function Ao(t,e){return ["x","y","z","w","u","v"].slice(0,e).map(function(e){return t+"."+e;});}function To(t,e){return 1===e?[t]:Ao(t,e);}function Do(){var t,e,n,r,o,a,s,u,l,c;return 2===i.getNumber("WEBGL_VERSION")?(t="#version 300 es",e="in",n="out",r="in",o="texture",a="outputColor",s="out vec4 outputColor;",u="\n      bool isnan_custom(float val) {\n        return (val > 0. || val < 0. || val == 0.) ? false : true;\n      }\n    ",l="",c="\n      #define round(value) newRound(value)\n      int newRound(float value) {\n        return int(floor(value + 0.5));\n      }\n\n      ivec4 newRound(vec4 value) {\n        return ivec4(floor(value + vec4(0.5)));\n      }\n    "):(t="",e="attribute",n="varying",r="varying",o="texture2D",a="gl_FragColor",s="",u="\n      bool isnan_custom(float val) {\n        return (val > 0. || val < 1. || val == 0.) ? false : true;\n      }\n    ",l="\n      uniform float INFINITY;\n\n      bool isinf(float val) {\n        return abs(val) == INFINITY;\n      }\n      bvec4 isinf(vec4 val) {\n        return equal(abs(val), vec4(INFINITY));\n      }\n    ",c="\n      int round(float value) {\n        return int(floor(value + 0.5));\n      }\n\n      ivec4 round(vec4 value) {\n        return ivec4(floor(value + vec4(0.5)));\n      }\n    "),{version:t,attribute:e,varyingVs:n,varyingFs:r,texture2D:o,output:a,defineOutput:s,defineSpecialNaN:u,defineSpecialInf:l,defineRound:c};}function _o(t,e,n){void 0===n&&(n="index");var r=V(e);return r.map(function(e,o){return "int "+t[o]+" = "+n+" / "+e+"; "+(o===r.length-1?"int "+t[o+1]+" = "+n+" - "+t[o]+" * "+e:"index -= "+t[o]+" * "+e)+";";}).join("");}function Oo(t){var e=V(t).map(function(t){return t.toString();});return "\n  int getFlatIndex(ivec3 coords) {\n    return coords.x * "+e[0]+" + coords.y * "+e[1]+" + coords.z;\n  }\n";}var Fo="\n  const float FLOAT_MAX = 1.70141184e38;\n  const float FLOAT_MIN = 1.17549435e-38;\n\n  lowp vec4 encode_float(highp float v) {\n    if (isnan(v)) {\n      return vec4(255, 255, 255, 255);\n    }\n\n    highp float av = abs(v);\n\n    if(av < FLOAT_MIN) {\n      return vec4(0.0, 0.0, 0.0, 0.0);\n    } else if(v > FLOAT_MAX) {\n      return vec4(0.0, 0.0, 128.0, 127.0) / 255.0;\n    } else if(v < -FLOAT_MAX) {\n      return vec4(0.0, 0.0,  128.0, 255.0) / 255.0;\n    }\n\n    highp vec4 c = vec4(0,0,0,0);\n\n    highp float e = floor(log2(av));\n    highp float m = exp2(fract(log2(av))) - 1.0;\n\n    c[2] = floor(128.0 * m);\n    m -= c[2] / 128.0;\n    c[1] = floor(32768.0 * m);\n    m -= c[1] / 32768.0;\n    c[0] = floor(8388608.0 * m);\n\n    highp float ebias = e + 127.0;\n    c[3] = floor(ebias / 2.0);\n    ebias -= c[3] * 2.0;\n    c[2] += floor(ebias) * 128.0;\n\n    c[3] += 128.0 * step(0.0, -v);\n\n    return c / 255.0;\n  }\n";function Mo(t,e,n,r){var o=[];t.forEach(function(t){var e=g(t.shapeInfo.logicalShape);t.shapeInfo.isUniform?o.push("uniform float "+t.name+(e>1?"["+e+"]":"")+";"):(o.push("uniform sampler2D "+t.name+";"),o.push("uniform int offset"+t.name+";"));});var a,i,s=o.join("\n"),u=t.map(function(t){return function(t,e,n){void 0===n&&(n=!1);var r="";r+=n?Po(t):Bo(t);var o=t.shapeInfo.logicalShape,a=e.logicalShape;o.length<=a.length&&(r+=n?function(t,e){var n,r=t.name,o=r.charAt(0).toUpperCase()+r.slice(1),a="get"+o+"AtOutCoords",i=t.shapeInfo.logicalShape.length,s=e.logicalShape.length,u=Jr(t.shapeInfo.logicalShape,e.logicalShape),l=Ho(s),c=s-i,h=["x","y","z","w","u","v"];n=0===i?"":s<2&&u.length>=1?"coords = 0;":u.map(function(t){return "coords."+h[t+c]+" = 0;";}).join("\n");var f="";f=s<2&&i>0?"coords":t.shapeInfo.logicalShape.map(function(t,e){return "coords."+h[e+c];}).join(", ");var p="return outputValue;",d=1===g(t.shapeInfo.logicalShape),v=1===g(e.logicalShape);if(1!==i||d||v){if(d&&!v)p=1===s?"\n        return vec4(outputValue.x, outputValue.x, 0., 0.);\n      ":"\n        return vec4(outputValue.x);\n      ";else if(u.length){var m=i-2,y=i-1;u.indexOf(m)>-1&&u.indexOf(y)>-1?p="return vec4(outputValue.x);":u.indexOf(m)>-1?p="return vec4(outputValue.x, outputValue.y, outputValue.x, outputValue.y);":u.indexOf(y)>-1&&(p="return vec4(outputValue.xx, outputValue.zz);");}}else p="\n      return vec4(outputValue.xy, outputValue.xy);\n    ";return "\n    vec4 "+a+"() {\n      "+l+" coords = getOutputCoords();\n      "+n+"\n      vec4 outputValue = get"+o+"("+f+");\n      "+p+"\n    }\n  ";}(t,e):function(t,e){var n=t.name,r=n.charAt(0).toUpperCase()+n.slice(1),o="get"+r+"AtOutCoords",a=e.texShape,i=t.shapeInfo.texShape,s=t.shapeInfo.logicalShape.length,u=e.logicalShape.length;if(!t.shapeInfo.isUniform&&s===u&&null==t.shapeInfo.flatOffset&&y(i,a))return "\n      float "+o+"() {\n        return sampleTexture("+n+", resultUV);\n      }\n    ";var l,c=Ho(u),h=Jr(t.shapeInfo.logicalShape,e.logicalShape),f=u-s,p=["x","y","z","w","u","v"];l=0===s?"":u<2&&h.length>=1?"coords = 0;":h.map(function(t){return "coords."+p[t+f]+" = 0;";}).join("\n");var d="";d=u<2&&s>0?"coords":t.shapeInfo.logicalShape.map(function(t,e){return "coords."+p[e+f];}).join(", ");return "\n    float "+o+"() {\n      "+c+" coords = getOutputCoords();\n      "+l+"\n      return get"+r+"("+d+");\n    }\n  ";}(t,e));return r;}(t,e,r);}).join("\n"),l=e.texShape,c=Do(),h=function(t){return "\n    float sampleTexture(sampler2D textureSampler, vec2 uv) {\n      return "+t.texture2D+"(textureSampler, uv).r;\n    }\n  ";}(c),f=function(t){return t.version+"\n    precision highp float;\n    precision highp int;\n    precision highp sampler2D;\n    "+t.varyingFs+" vec2 resultUV;\n    "+t.defineOutput+"\n    const vec2 halfCR = vec2(0.5, 0.5);\n\n    struct ivec5\n    {\n      int x;\n      int y;\n      int z;\n      int w;\n      int u;\n    };\n\n    struct ivec6\n    {\n      int x;\n      int y;\n      int z;\n      int w;\n      int u;\n      int v;\n    };\n\n    uniform float NAN;\n    #define isnan(value) isnan_custom(value)\n    "+t.defineSpecialNaN+"\n    bvec4 isnan_custom(vec4 val) {\n      return bvec4(isnan(val.x), isnan(val.y), isnan(val.z), isnan(val.w));\n    }\n\n    "+t.defineSpecialInf+"\n    "+t.defineRound+"\n\n    int imod(int x, int y) {\n      return x - y * (x / y);\n    }\n\n    int idiv(int a, int b, float sign) {\n      int res = a / b;\n      int mod = imod(a, b);\n      if (sign < 0. && mod != 0) {\n        res -= 1;\n      }\n      return res;\n    }\n\n    //Based on the work of Dave Hoskins\n    //https://www.shadertoy.com/view/4djSRW\n    #define HASHSCALE1 443.8975\n    float random(float seed){\n      vec2 p = resultUV * seed;\n      vec3 p3  = fract(vec3(p.xyx) * HASHSCALE1);\n      p3 += dot(p3, p3.yzx + 19.19);\n      return fract((p3.x + p3.y) * p3.z);\n    }\n\n    "+Lo+"\n    "+Wo+"\n    "+Uo+"\n  ";}(c);return e.isPacked?(a=function(t,e){switch(t.length){case 0:return "\n    int getOutputCoords() {\n      return 0;\n    }\n  ";case 1:return function(t,e){var n=[Math.ceil(e[0]/2),Math.ceil(e[1]/2)];if(1===n[0])return "\n      int getOutputCoords() {\n        return 2 * int(resultUV.x * "+n[1]+".0);\n      }\n    ";if(1===n[1])return "\n      int getOutputCoords() {\n        return 2 * int(resultUV.y * "+n[0]+".0);\n      }\n    ";return "\n    int getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+n[0]+", "+n[1]+"));\n      return 2 * (resTexRC.x * "+n[1]+" + resTexRC.y);\n    }\n  ";}(0,e);case 2:return function(t,e){var n=[Math.ceil(e[0]/2),Math.ceil(e[1]/2)];if(y(t,e))return "\n      ivec2 getOutputCoords() {\n        return 2 * ivec2(resultUV.yx * vec2("+n[0]+", "+n[1]+"));\n      }\n    ";var r=Math.ceil(t[1]/2);return "\n    ivec2 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+n[0]+", "+n[1]+"));\n\n      int index = resTexRC.x * "+n[1]+" + resTexRC.y;\n      int r = 2 * (index / "+r+");\n      int c = imod(index, "+r+") * 2;\n\n      return ivec2(r, c);\n    }\n  ";}(t,e);case 3:return n=t,r=e,o=[Math.ceil(r[0]/2),Math.ceil(r[1]/2)],a=Math.ceil(n[2]/2),i=a*Math.ceil(n[1]/2),"\n    ivec3 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+o[0]+", "+o[1]+"));\n      int index = resTexRC.x * "+o[1]+" + resTexRC.y;\n\n      int b = index / "+i+";\n      index -= b * "+i+";\n\n      int r = 2 * (index / "+a+");\n      int c = imod(index, "+a+") * 2;\n\n      return ivec3(b, r, c);\n    }\n  ";default:return function(t,e){for(var n=[Math.ceil(e[0]/2),Math.ceil(e[1]/2)],r=Math.ceil(t[t.length-1]/2),o=r*Math.ceil(t[t.length-2]/2),a=o,i="",s="b, r, c",u=2;u<t.length-1;u++){a*=t[t.length-u-1],i="\n      int b"+u+" = index / "+a+";\n      index -= b"+u+" * "+a+";\n    "+i,s="b"+u+", "+s;}return "\n    ivec"+t.length+" getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+n[0]+", "+n[1]+"));\n      int index = resTexRC.x * "+n[1]+" + resTexRC.y;\n\n      "+i+"\n\n      int b = index / "+o+";\n      index -= b * "+o+";\n\n      int r = 2 * (index / "+r+");\n      int c = imod(index, "+r+") * 2;\n\n      return ivec"+t.length+"("+s+");\n    }\n  ";}(t,e);}var n,r,o,a,i;}(e.logicalShape,l),i=function(t){return "\n    void setOutput(vec4 val) {\n      "+t.output+" = val;\n    }\n  ";}(c)):(a=function(t,e){switch(t.length){case 0:return "\n    int getOutputCoords() {\n      return 0;\n    }\n  ";case 1:return function(t,e){if(1===e[0])return "\n      int getOutputCoords() {\n        return int(resultUV.x * "+e[1]+".0);\n      }\n    ";if(1===e[1])return "\n      int getOutputCoords() {\n        return int(resultUV.y * "+e[0]+".0);\n      }\n    ";return "\n    int getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+e[0]+", "+e[1]+"));\n      return resTexRC.x * "+e[1]+" + resTexRC.y;\n    }\n  ";}(0,e);case 2:return function(t,e){if(y(t,e))return "\n      ivec2 getOutputCoords() {\n        return ivec2(resultUV.yx * vec2("+e[0]+", "+e[1]+"));\n      }\n    ";if(1===t[1])return "\n      ivec2 getOutputCoords() {\n        ivec2 resTexRC = ivec2(resultUV.yx *\n                               vec2("+e[0]+", "+e[1]+"));\n        int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n        return ivec2(index, 0);\n      }\n    ";if(1===t[0])return "\n      ivec2 getOutputCoords() {\n        ivec2 resTexRC = ivec2(resultUV.yx *\n                               vec2("+e[0]+", "+e[1]+"));\n        int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n        return ivec2(0, index);\n      }\n    ";return "\n    ivec2 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+e[0]+", "+e[1]+"));\n      int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n      int r = index / "+t[1]+";\n      int c = index - r * "+t[1]+";\n      return ivec2(r, c);\n    }\n  ";}(t,e);case 3:return n=e,r=_o(["r","c","d"],t),"\n    ivec3 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+n[0]+", "+n[1]+"));\n      int index = resTexRC.x * "+n[1]+" + resTexRC.y;\n      "+r+"\n      return ivec3(r, c, d);\n    }\n  ";case 4:return function(t,e){var n=_o(["r","c","d","d2"],t);return "\n    ivec4 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n        vec2("+e[0]+", "+e[1]+"));\n      int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n      "+n+"\n      return ivec4(r, c, d, d2);\n    }\n  ";}(t,e);case 5:return function(t,e){var n=_o(["r","c","d","d2","d3"],t);return "\n    ivec5 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx * vec2("+e[0]+",\n                             "+e[1]+"));\n\n      int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n\n      "+n+"\n\n      ivec5 outShape = ivec5(r, c, d, d2, d3);\n      return outShape;\n    }\n  ";}(t,e);case 6:return function(t,e){var n=_o(["r","c","d","d2","d3","d4"],t);return "\n    ivec6 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n        vec2("+e[0]+", "+e[1]+"));\n      int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n\n      "+n+"\n\n      ivec6 result = ivec6(r, c, d, d2, d3, d4);\n      return result;\n    }\n  ";}(t,e);default:throw new Error(t.length+"-D output sampling is not yet supported");}var n,r;}(e.logicalShape,l),i=function(t){return "\n    void setOutput(float val) {\n      "+t.output+" = vec4(val, 0, 0, 0);\n    }\n  ";}(c)),r&&(f+=zo),[f,h,i,s,a,u,n].join("\n");}function Bo(t){var e=t.shapeInfo.logicalShape;switch(e.length){case 0:return function(t){var e=t.name,n="get"+e.charAt(0).toUpperCase()+e.slice(1);if(t.shapeInfo.isUniform)return "float "+n+"() {return "+e+";}";var r=t.shapeInfo.texShape,o=r[0],a=r[1];if(1===o&&1===a)return "\n      float "+n+"() {\n        return sampleTexture("+e+", halfCR);\n      }\n    ";var i=t.shapeInfo.texShape,s=i[0],u=i[1],l=Vo(e);return "\n    float "+n+"() {\n      vec2 uv = uvFromFlat("+s+", "+u+", "+l+");\n      return sampleTexture("+e+", uv);\n    }\n  ";}(t);case 1:return function(t){var e=t.name,n="get"+e.charAt(0).toUpperCase()+e.slice(1);if(t.shapeInfo.isUniform)return "\n      float "+n+"(int index) {\n        "+Go(t)+"\n      }\n    ";var r=t.shapeInfo.texShape,o=r[0],a=r[1];if(1===a&&1===o)return "\n      float "+n+"(int index) {\n        return sampleTexture("+e+", halfCR);\n      }\n    ";var i=Vo(e);if(1===a)return "\n      float "+n+"(int index) {\n        vec2 uv = vec2(0.5, (float(index + "+i+") + 0.5) / "+o+".0);\n        return sampleTexture("+e+", uv);\n      }\n    ";if(1===o)return "\n      float "+n+"(int index) {\n        vec2 uv = vec2((float(index + "+i+") + 0.5) / "+a+".0, 0.5);\n        return sampleTexture("+e+", uv);\n      }\n    ";return "\n    float "+n+"(int index) {\n      vec2 uv = uvFromFlat("+o+", "+a+", index + "+i+");\n      return sampleTexture("+e+", uv);\n    }\n  ";}(t);case 2:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=t.shapeInfo.texShape;if(null!=o&&y(e,o)){var a=o[0],i=o[1];return "\n    float "+r+"(int row, int col) {\n      vec2 uv = (vec2(col, row) + halfCR) / vec2("+i+".0, "+a+".0);\n      return sampleTexture("+n+", uv);\n    }\n  ";}var s=S(e),u=s.newShape,l=s.keptDims,c=u;if(c.length<e.length){var h=qo(t,c);return "\n      "+Bo(h)+"\n      float "+r+"(int row, int col) {\n        return "+r+"("+$o(["row","col"],l)+");\n      }\n    ";}if(t.shapeInfo.isUniform)return "\n      float "+r+"(int row, int col) {\n        int index = round(dot(vec2(row, col), vec2("+e[1]+", 1)));\n        "+Go(t)+"\n      }\n    ";var f=o[0],p=o[1],d=Vo(n);if(1===p)return "\n    float "+r+"(int row, int col) {\n      float index = dot(vec3(row, col, "+d+"), vec3("+e[1]+", 1, 1));\n      vec2 uv = vec2(0.5, (index + 0.5) / "+f+".0);\n      return sampleTexture("+n+", uv);\n    }\n  ";if(1===f)return "\n    float "+r+"(int row, int col) {\n      float index = dot(vec3(row, col, "+d+"), vec3("+e[1]+", 1, 1));\n      vec2 uv = vec2((index + 0.5) / "+p+".0, 0.5);\n      return sampleTexture("+n+", uv);\n    }\n  ";return "\n  float "+r+"(int row, int col) {\n    // Explicitly use integer operations as dot() only works on floats.\n    int index = row * "+e[1]+" + col + "+d+";\n    vec2 uv = uvFromFlat("+f+", "+p+", index);\n    return sampleTexture("+n+", uv);\n  }\n";}(t);case 3:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=e[1]*e[2],a=e[2],i=S(e),s=i.newShape,u=i.keptDims,l=s;if(l.length<e.length){var c=qo(t,l);return "\n        "+Bo(c)+"\n        float "+r+"(int row, int col, int depth) {\n          return "+r+"("+$o(["row","col","depth"],u)+");\n        }\n      ";}if(t.shapeInfo.isUniform)return "\n      float "+r+"(int row, int col, int depth) {\n        int index = round(dot(vec3(row, col, depth),\n                          vec3("+o+", "+a+", 1)));\n        "+Go(t)+"\n      }\n    ";var h=t.shapeInfo.texShape,f=h[0],p=h[1],d=t.shapeInfo.flatOffset;if(p===o&&null==d)return "\n        float "+r+"(int row, int col, int depth) {\n          float texR = float(row);\n          float texC = dot(vec2(col, depth), vec2("+a+", 1));\n          vec2 uv = (vec2(texC, texR) + halfCR) /\n                     vec2("+p+".0, "+f+".0);\n          return sampleTexture("+n+", uv);\n        }\n      ";if(p===a&&null==d)return "\n    float "+r+"(int row, int col, int depth) {\n      float texR = dot(vec2(row, col), vec2("+e[1]+", 1));\n      float texC = float(depth);\n      vec2 uv = (vec2(texC, texR) + halfCR) / vec2("+p+".0, "+f+".0);\n      return sampleTexture("+n+", uv);\n    }\n  ";var v=Vo(n);return "\n      float "+r+"(int row, int col, int depth) {\n        // Explicitly use integer operations as dot() only works on floats.\n        int index = row * "+o+" + col * "+a+" + depth + "+v+";\n        vec2 uv = uvFromFlat("+f+", "+p+", index);\n        return sampleTexture("+n+", uv);\n      }\n  ";}(t);case 4:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=e[3],a=e[2]*o,i=e[1]*a,s=S(e),u=s.newShape,l=s.keptDims;if(u.length<e.length){var c=qo(t,u);return "\n      "+Bo(c)+"\n      float "+r+"(int row, int col, int depth, int depth2) {\n        return "+r+"("+$o(["row","col","depth","depth2"],l)+");\n      }\n    ";}if(t.shapeInfo.isUniform)return "\n      float "+r+"(int row, int col, int depth, int depth2) {\n        int index = round(dot(vec4(row, col, depth, depth2),\n                          vec4("+i+", "+a+", "+o+", 1)));\n        "+Go(t)+"\n      }\n    ";var h=t.shapeInfo.flatOffset,f=t.shapeInfo.texShape,p=f[0],d=f[1];if(d===i&&null==h)return "\n      float "+r+"(int row, int col, int depth, int depth2) {\n        float texR = float(row);\n        float texC =\n            dot(vec3(col, depth, depth2),\n                vec3("+a+", "+o+", 1));\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                   vec2("+d+".0, "+p+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";if(d===o&&null==h)return "\n      float "+r+"(int row, int col, int depth, int depth2) {\n        float texR = dot(vec3(row, col, depth),\n                         vec3("+e[1]*e[2]+", "+e[2]+", 1));\n        float texC = float(depth2);\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                  vec2("+d+".0, "+p+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";var v=Vo(n);return "\n    float "+r+"(int row, int col, int depth, int depth2) {\n      // Explicitly use integer operations as dot() only works on floats.\n      int index = row * "+i+" + col * "+a+" +\n          depth * "+o+" + depth2;\n      vec2 uv = uvFromFlat("+p+", "+d+", index + "+v+");\n      return sampleTexture("+n+", uv);\n    }\n  ";}(t);case 5:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=e[4],a=e[3]*o,i=e[2]*a,s=e[1]*i,u=S(e),l=u.newShape,c=u.keptDims;if(l.length<e.length){var h=qo(t,l);return "\n      "+Bo(h)+"\n      float "+r+"(int row, int col, int depth, int depth2, int depth3) {\n        return "+r+"("+$o(["row","col","depth","depth2","depth3"],c)+");\n      }\n    ";}if(t.shapeInfo.isUniform)return "\n      float "+r+"(int row, int col, int depth, int depth2, int depth3) {\n        float index = dot(\n          vec4(row, col, depth, depth2),\n          vec4("+s+", "+i+", "+a+", "+o+")) +\n          depth3;\n        "+Go(t)+"\n      }\n    ";var f=t.shapeInfo.flatOffset,p=t.shapeInfo.texShape,d=p[0],v=p[1];if(v===s&&null==f)return "\n      float "+r+"(int row, int col, int depth, int depth2, int depth3) {\n        int texR = row;\n        float texC = dot(vec4(col, depth, depth2, depth3),\n                         vec4("+i+", "+a+", "+o+", 1));\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                   vec2("+v+".0, "+d+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";if(v===o&&null==f)return "\n      float "+r+"(int row, int col, int depth, int depth2, int depth3) {\n        float texR = dot(\n          vec4(row, col, depth, depth2),\n          vec4("+e[1]*e[2]*e[3]+",\n               "+e[2]*e[3]+", "+e[3]+", 1));\n        int texC = depth3;\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                  vec2("+v+".0, "+d+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";var m=Vo(n);return "\n    float "+r+"(int row, int col, int depth, int depth2, int depth3) {\n      // Explicitly use integer operations as dot() only works on floats.\n      int index = row * "+s+" + col * "+i+" + depth * "+a+" +\n          depth2 * "+o+" + depth3 + "+m+";\n      vec2 uv = uvFromFlat("+d+", "+v+", index);\n      return sampleTexture("+n+", uv);\n    }\n  ";}(t);case 6:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=S(e),a=o.newShape,i=o.keptDims;if(a.length<e.length){var s=qo(t,a);return "\n      "+Bo(s)+"\n      float "+r+"(int row, int col, int depth,\n                    int depth2, int depth3, int depth4) {\n        return "+r+"("+$o(["row","col","depth","depth2","depth3","depth4"],i)+");\n      }\n    ";}var u=e[5],l=e[4]*u,c=e[3]*l,h=e[2]*c,f=e[1]*h;if(t.shapeInfo.isUniform)return "\n      float "+r+"(int row, int col, int depth,\n                  int depth2, int depth3, int depth4) {\n        int index = round(dot(\n          vec4(row, col, depth, depth2),\n          vec4("+f+", "+h+", "+c+", "+l+")) +\n          dot(\n            vec2(depth3, depth4),\n            vec2("+u+", 1)));\n        "+Go(t)+"\n      }\n    ";var p=t.shapeInfo.flatOffset,d=t.shapeInfo.texShape,v=d[0],m=d[1];if(m===f&&null==p)return "\n      float "+r+"(int row, int col, int depth,\n                    int depth2, int depth3, int depth4) {\n        int texR = row;\n        float texC = dot(vec4(col, depth, depth2, depth3),\n          vec4("+h+", "+c+", "+l+", "+u+")) +\n               float(depth4);\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                   vec2("+m+".0, "+v+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";if(m===u&&null==p)return "\n      float "+r+"(int row, int col, int depth,\n                    int depth2, int depth3, int depth4) {\n        float texR = dot(vec4(row, col, depth, depth2),\n          vec4("+e[1]*e[2]*e[3]*e[4]+",\n               "+e[2]*e[3]*e[4]+",\n               "+e[3]*e[4]+",\n               "+e[4]+")) + float(depth3);\n        int texC = depth4;\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                  vec2("+m+".0, "+v+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";var g=Vo(n);return "\n    float "+r+"(int row, int col, int depth,\n                  int depth2, int depth3, int depth4) {\n      // Explicitly use integer operations as dot() only works on floats.\n      int index = row * "+f+" + col * "+h+" + depth * "+c+" +\n          depth2 * "+l+" + depth3 * "+u+" + depth4 + "+g+";\n      vec2 uv = uvFromFlat("+v+", "+m+", index);\n      return sampleTexture("+n+", uv);\n    }\n  ";}(t);default:throw new Error(e.length+"-D input sampling is not yet supported");}}function Po(t){var e,n,r;switch(t.shapeInfo.logicalShape.length){case 0:return e=t.name,n="get"+e.charAt(0).toUpperCase()+e.slice(1),r=Do(),"\n    vec4 "+n+"() {\n      return "+r.texture2D+"("+e+", halfCR);\n    }\n  ";case 1:return function(t){var e=t.name,n="get"+e.charAt(0).toUpperCase()+e.slice(1),r=t.shapeInfo.texShape,o=[Math.ceil(r[0]/2),Math.ceil(r[1]/2)],a=Do();return "\n    vec4 "+n+"(int index) {\n      vec2 uv = packedUVfrom1D(\n        "+o[0]+", "+o[1]+", index);\n      return "+a.texture2D+"("+e+", uv);\n    }\n  ";}(t);case 2:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=t.shapeInfo.texShape,a=o[0],i=o[1],s=Do();if(null!=o&&y(e,o))return "\n      vec4 "+r+"(int row, int col) {\n        vec2 uv = (vec2(col, row) + halfCR) / vec2("+i+".0, "+a+".0);\n\n        return "+s.texture2D+"("+n+", uv);\n      }\n    ";var u=[Math.ceil(o[0]/2),Math.ceil(o[1]/2)],l=Math.ceil(e[1]/2);return "\n    vec4 "+r+"(int row, int col) {\n      vec2 uv = packedUVfrom2D("+l+", "+u[0]+", "+u[1]+", row, col);\n      return "+s.texture2D+"("+n+", uv);\n    }\n  ";}(t);case 3:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=t.shapeInfo.texShape,a=[Math.ceil(o[0]/2),Math.ceil(o[1]/2)];if(1===e[0]){var i=e.slice(1),s=qo(t,i);return "\n        "+Po(s)+"\n        vec4 "+r+"(int b, int row, int col) {\n          return "+r+"("+$o(["b","row","col"],[1,2])+");\n        }\n      ";}var u=a[0],l=a[1],c=Math.ceil(e[2]/2),h=c*Math.ceil(e[1]/2),f=Do();return "\n    vec4 "+r+"(int b, int row, int col) {\n      vec2 uv = packedUVfrom3D(\n        "+u+", "+l+", "+h+", "+c+", b, row, col);\n      return "+f.texture2D+"("+n+", uv);\n    }\n  ";}(t);default:return function(t){for(var e=t.shapeInfo.logicalShape,n=e.length,r=t.name,o="get"+r.charAt(0).toUpperCase()+r.slice(1),a=t.shapeInfo.texShape,i=[Math.ceil(a[0]/2),Math.ceil(a[1]/2)],s=i[0],u=i[1],l=Math.ceil(e[n-1]/2),c=l*Math.ceil(e[n-2]/2),h="int b, int row, int col",f="b * "+c+" + (row / 2) * "+l+" + (col / 2)",p=2;p<n-1;p++){h="int b"+p+", "+h,c*=e[n-p-1],f="b"+p+" * "+c+" + "+f;}var d=Do();return "\n    vec4 "+o+"("+h+") {\n      int index = "+f+";\n      int texR = index / "+u+";\n      int texC = index - texR * "+u+";\n      vec2 uv = (vec2(texC, texR) + halfCR) / vec2("+u+", "+s+");\n      return "+d.texture2D+"("+r+", uv);\n    }\n  ";}(t);}}var Lo="\nvec2 uvFromFlat(int texNumR, int texNumC, int index) {\n  int texR = index / texNumC;\n  int texC = index - texR * texNumC;\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\n}\nvec2 packedUVfrom1D(int texNumR, int texNumC, int index) {\n  int texelIndex = index / 2;\n  int texR = texelIndex / texNumC;\n  int texC = texelIndex - texR * texNumC;\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\n}\n",Wo="\nvec2 packedUVfrom2D(int texelsInLogicalRow, int texNumR,\n  int texNumC, int row, int col) {\n  int texelIndex = (row / 2) * texelsInLogicalRow + (col / 2);\n  int texR = texelIndex / texNumC;\n  int texC = texelIndex - texR * texNumC;\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\n}\n",Uo="\nvec2 packedUVfrom3D(int texNumR, int texNumC,\n    int texelsInBatch, int texelsInLogicalRow, int b,\n    int row, int col) {\n  int index = b * texelsInBatch + (row / 2) * texelsInLogicalRow + (col / 2);\n  int texR = index / texNumC;\n  int texC = index - texR * texNumC;\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\n}\n",zo="\n  float getChannel(vec4 frag, vec2 innerDims) {\n    vec2 modCoord = mod(innerDims, 2.);\n    return modCoord.x == 0. ?\n      (modCoord.y == 0. ? frag.r : frag.g) :\n      (modCoord.y == 0. ? frag.b : frag.a);\n  }\n  float getChannel(vec4 frag, int dim) {\n    float modCoord = mod(float(dim), 2.);\n    return modCoord == 0. ? frag.r : frag.g;\n  }\n";function Vo(t){return "offset"+t;}function Go(t){var e=t.name,n=g(t.shapeInfo.logicalShape);return n<2?"return "+e+";":"\n    for (int i = 0; i < "+n+"; i++) {\n      if (i == index) {\n        return "+e+"[i];\n      }\n    }\n  ";}function Ho(t){if(t<=1)return "int";if(2===t)return "ivec2";if(3===t)return "ivec3";if(4===t)return "ivec4";if(5===t)return "ivec5";if(6===t)return "ivec6";throw Error("GPU for rank "+t+" is not yet supported");}function qo(t,e){var n=JSON.parse(JSON.stringify(t));return n.shapeInfo.logicalShape=e,n;}function $o(t,e){return e.map(function(e){return t[e];}).join(", ");}var jo=function(){return function(t,e,n,r){this.variableNames=["A"],this.usesPackedTextures=!0,p(t.length>2,function(){return "Packed arg"+(n.charAt(0).toUpperCase()+n.slice(1))+" supports only inputs with rank above 2.";});var o=t[t.length-1],a=Math.ceil(o/e);this.outputShape=t.slice(0,-1),a>1&&this.outputShape.push(a),r||this.variableNames.push("bestIndicesA");var i,s,u=this.outputShape,l=u.length,c=Ho(l),h=To("coords",l);if(1===a){var f=Ho(s=l+1);i="\n        "+f+" sourceLocR = "+f+"("+h.join()+", 0);\n        ++"+h[l-1]+";\n        "+f+" sourceLocG = "+f+"("+h.join()+", 0);\n        ++"+h[l-2]+";\n        "+f+" sourceLocA = "+f+"("+h.join()+", 0);\n        --"+h[l-1]+";\n        "+f+" sourceLocB = "+f+"("+h.join()+", 0);\n        --"+h[l-2]+";";}else s=l,i="\n        "+c+" sourceLocR = coords;\n        ++"+h[l-1]+";\n        "+c+" sourceLocG = coords;\n        ++"+h[l-2]+";\n        "+c+" sourceLocA = coords;\n        --"+h[l-1]+";\n        "+c+" sourceLocB = coords;\n        --"+h[l-2]+";";var d=["x","y","z","w","u","v"].slice(0,s),v="."+d[s-1],m=d.map(function(t){return "int "+t;}),g=To("sourceLocR",s-1).concat("inIdx.r"),y=To("sourceLocG",s-1).concat("inIdx.g"),x=To("sourceLocB",s-1).concat("inIdx.b"),b=To("sourceLocA",s-1).concat("inIdx.a"),w="max"===n?"greaterThan":"lessThan",C=r?"":"\n          inIdx = round(vec4(getBestIndicesAChannel("+g.join()+"),\n                             getBestIndicesAChannel("+y.join()+"),\n                             getBestIndicesAChannel("+x.join()+"),\n                             getBestIndicesAChannel("+b.join()+")));",E="vec4(\n            getAChannel("+g.join()+"),\n            hasNextCol ? getAChannel("+y.join()+") : 0.,\n            hasNextRow ? getAChannel("+x.join()+") : 0.,\n            hasNextRow && hasNextCol ? getAChannel("+b.join()+") : 0.)",R=r?"":"\n      float getBestIndicesAChannel("+m.join()+") {\n        return getChannel(getBestIndicesA("+d.join()+"),\n                                          vec2("+d.slice(-2).join()+"));\n      }";this.userCode="\n      float getAChannel("+m.join()+") {\n        return getChannel(getA("+d.join()+"),\n                               vec2("+d.slice(-2).join()+"));\n      }\n      "+R+"\n      void main() {\n        "+c+" coords = getOutputCoords();\n        bool hasNextCol = "+h[l-1]+" < "+(u[l-1]-1)+";\n        bool hasNextRow = "+h[l-2]+" < "+(u[l-2]-1)+";\n        "+i+"\n        ivec4 srcIdx = ivec4(sourceLocR"+v+", sourceLocG"+v+",\n          sourceLocB"+v+", sourceLocA"+v+") * "+e+";\n        ivec4 inIdx = srcIdx;\n        vec4 bestIndex = vec4(inIdx);\n        vec4 bestValue = "+E+";\n\n        for (int i = 0; i < "+e+"; i++) {\n          inIdx = srcIdx;\n          "+C+"\n          vec4 candidate = "+E+";\n          bvec4 nan = isnan(candidate);\n          bvec4 replace = bvec4(\n            vec4("+w+"(candidate, bestValue)) * (vec4(1.0) - vec4(nan)));\n\n          bestValue = vec4(replace.x  ? candidate.x : bestValue.x,\n                           replace.y  ? candidate.y : bestValue.y,\n                           replace.z  ? candidate.z : bestValue.z,\n                           replace.w  ? candidate.w : bestValue.w);\n          bestIndex = mix(bestIndex, vec4(inIdx), vec4(replace));\n          srcIdx++;\n        }\n        setOutput(bestIndex);\n      }\n    ";};}(),Ko=function(){return function(t){this.variableNames=["dy"],this.outputShape=t.inShape;var e=t.filterHeight,n=t.filterWidth,r=t.strideHeight,o=t.strideWidth,a=t.dilationHeight,i=t.dilationWidth,s=t.effectiveFilterHeight,u=t.effectiveFilterWidth,l=s-1-t.padInfo.top,c=u-1-t.padInfo.left,h=1/(e*n);this.userCode="\n      const ivec2 pads = ivec2("+l+", "+c+");\n      const float avgMultiplier = float("+h+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n\n        ivec2 dyRCCorner = coords.yz - pads;\n        int dyRCorner = dyRCCorner.x;\n        int dyCCorner = dyRCCorner.y;\n\n        // Convolve dy(?, ?, d) with pos mask(:, :, d) to get dx(xR, xC, d).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n        for (int wR = 0; wR < "+s+";\n            wR += "+a+") {\n          float dyR = float(dyRCorner + wR) / "+r+".0;\n\n          if (dyR < 0.0 || dyR >= "+t.outHeight+".0 || fract(dyR) > 0.0) {\n            continue;\n          }\n          int idyR = int(dyR);\n\n          for (int wC = 0; wC < "+u+";\n            wC+= "+i+") {\n            float dyC = float(dyCCorner + wC) / "+o+".0;\n\n            if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                fract(dyC) > 0.0) {\n              continue;\n            }\n            int idyC = int(dyC);\n\n            float dyValue = getDy(b, idyR, idyC, d);\n\n            dotProd += dyValue * avgMultiplier;\n          }\n        }\n        setOutput(dotProd);\n      }\n    ";};}(),Xo=function(){return function(t,e,n,r,o,a){this.outputShape=[],this.variableNames=["x","mean","variance"],to(t,e),to(t,n);var i="0.0";null!=r&&(to(t,r),this.variableNames.push("offset"),i="getOffsetAtOutCoords()");var s="1.0";null!=o&&(to(t,o),this.variableNames.push("scale"),s="getScaleAtOutCoords()"),this.outputShape=t,this.userCode="\n      void main() {\n        float x = getXAtOutCoords();\n        float mean = getMeanAtOutCoords();\n        float variance = getVarianceAtOutCoords();\n        float offset = "+i+";\n        float scale = "+s+";\n        float inv = scale * inversesqrt(variance + float("+a+"));\n        setOutput(dot(vec3(x, -mean, offset), vec3(inv, inv, 1)));\n      }\n    ";};}(),Yo=function(){return function(t,e,n,r,o,a){this.usesPackedTextures=!0,this.variableNames=["x","mean","variance"],to(t,e),to(t,n);var i="vec4(0.0)";null!=r&&(to(t,r),this.variableNames.push("offset"),i="getOffsetAtOutCoords()");var s="vec4(1.0)";null!=o&&(to(t,o),this.variableNames.push("scale"),s="getScaleAtOutCoords()"),this.outputShape=t,this.userCode="\n      void main() {\n        vec4 offset = "+i+";\n        vec4 scale = "+s+";\n\n        vec4 x = getXAtOutCoords();\n        vec4 mean = getMeanAtOutCoords();\n        vec4 variance = getVarianceAtOutCoords();\n\n        vec4 inv = scale * inversesqrt(variance + vec4("+a+"));\n\n        setOutput((x - mean) * inv + offset);\n      }\n    ";};}(),Qo="return areal * breal - aimag * bimag;",Jo="return areal * bimag + aimag * breal;",Zo=function(){return function(t,e,n){this.variableNames=["AReal","AImag","BReal","BImag"],this.outputShape=to(e,n),this.userCode="\n      float binaryOpComplex(\n          float areal, float aimag, float breal, float bimag) {\n        "+t+"\n      }\n\n      void main() {\n        float areal = getARealAtOutCoords();\n        float aimag = getAImagAtOutCoords();\n        float breal = getBRealAtOutCoords();\n        float bimag = getBImagAtOutCoords();\n        setOutput(binaryOpComplex(areal, aimag, breal, bimag));\n      }\n    ";};}(),ta="return a + b;",ea="return a - b;",na="return a * b;",ra=function(){return function(t,e,n){this.variableNames=["A","B"],this.outputShape=to(e,n),this.userCode="\n      float binaryOperation(float a, float b) {\n        "+t+"\n      }\n\n      void main() {\n        float a = getAAtOutCoords();\n        float b = getBAtOutCoords();\n        setOutput(binaryOperation(a, b));\n      }\n    ";};}(),oa=function(){return function(t,e,n,r){void 0===r&&(r=!1),this.variableNames=["A","B"],this.supportsBroadcasting=!0,this.usesPackedTextures=!0,this.outputShape=to(e,n);var o=this.outputShape.length,a="";if(r)if(0===o||1===g(this.outputShape))a="\n          result.y = 0.;\n          result.z = 0.;\n          result.w = 0.;\n        ";else if(a="\n          "+Ho(o)+" coords = getOutputCoords();\n        ",1===o)a+="\n            result.y = (coords + 1) >= "+this.outputShape[0]+" ? 0. : result.y;\n            result.z = 0.;\n            result.w = 0.;\n          ";else{var i=To("coords",o);a+="\n            bool nextRowOutOfBounds =\n              ("+i[o-2]+" + 1) >= "+this.outputShape[o-2]+";\n            bool nextColOutOfBounds =\n              ("+i[o-1]+" + 1) >= "+this.outputShape[o-1]+";\n            result.y = nextColOutOfBounds ? 0. : result.y;\n            result.z = nextRowOutOfBounds ? 0. : result.z;\n            result.w = nextColOutOfBounds || nextRowOutOfBounds ? 0. : result.w;\n          ";}this.userCode="\n      vec4 binaryOperation(vec4 a, vec4 b) {\n        "+t+"\n      }\n\n      void main() {\n        vec4 a = getAAtOutCoords();\n        vec4 b = getBAtOutCoords();\n\n        vec4 result = binaryOperation(a, b);\n        "+a+"\n\n        setOutput(result);\n      }\n    ";};}(),aa=function(){function t(t){this.variableNames=["A"],this.outputShape=t,this.userCode="\n      uniform float minVal;\n      uniform float maxVal;\n\n      void main() {\n        float value = getAAtOutCoords();\n        if (isnan(value)) {\n          setOutput(value);\n          return;\n        }\n\n        setOutput(clamp(value, minVal, maxVal));\n      }\n    ";}return t.prototype.getCustomSetupFunc=function(t,e){var n=this;return function(r,o){null==n.minLoc&&(n.minLoc=r.getUniformLocationNoThrow(o,"minVal"),n.maxLoc=r.getUniformLocationNoThrow(o,"maxVal")),r.gl.uniform1f(n.minLoc,t),r.gl.uniform1f(n.maxLoc,e);};},t;}(),ia=function(){function t(t){this.variableNames=["A"],this.usesPackedTextures=!0,this.outputShape=t,this.userCode="\n      uniform float minVal;\n      uniform float maxVal;\n\n      void main() {\n        vec4 value = getAAtOutCoords();\n\n        if (any(isnan(value))) {\n          setOutput(value);\n          return;\n        }\n\n        setOutput(clamp(value, vec4(minVal), vec4(maxVal)));\n      }\n    ";}return t.prototype.getCustomSetupFunc=function(t,e){var n=this;return function(r,o){null==n.minLoc&&(n.minLoc=r.getUniformLocationNoThrow(o,"minVal"),n.maxLoc=r.getUniformLocationNoThrow(o,"maxVal")),r.gl.uniform1f(n.minLoc,t),r.gl.uniform1f(n.maxLoc,e);};},t;}(),sa=function(){return function(t){this.variableNames=["real","imag"],this.outputShape=t,this.userCode="\n      void main() {\n        float re = abs(getRealAtOutCoords());\n        float im = abs(getImagAtOutCoords());\n        float mx = max(re, im);\n\n        // sadly the length function in glsl is not underflow-safe\n        // (at least not on Intel GPUs). So the safe solution is\n        // to ensure underflow-safety in all cases.\n        setOutput(\n          mx == 0.0 ? 0.0 : mx * length(vec2(1, min(re, im)/mx))\n        );\n      }\n    ";};}(),ua=function(){return function(t){this.outputShape=[],this.outputShape=vn(t,1),this.variableNames=t.map(function(t,e){return "T"+e;});var e=new Array(t.length-1);e[0]=t[0][1];for(var n=1;n<e.length;n++){e[n]=e[n-1]+t[n][1];}var r=["if (yC < "+e[0]+") setOutput(getT0(yR, yC));"];for(n=1;n<e.length;n++){var o=e[n-1];r.push("else if (yC < "+e[n]+") setOutput(getT"+n+"(yR, yC-"+o+"));");}var a=e.length,i=e[e.length-1];r.push("else setOutput(getT"+a+"(yR, yC-"+i+"));"),this.userCode="\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int yR = coords.x;\n        int yC = coords.y;\n\n        "+r.join("\n        ")+"\n      }\n    ";};}(),la=function(){return function(t,e){this.usesPackedTextures=!0,this.outputShape=[],this.outputShape=vn(t,e);var n=this.outputShape,r=n.length,o=Ho(r),a=To("coords",r),i=["x","y","z","w","u","v"].slice(0,r);this.variableNames=t.map(function(t,e){return "T"+e;});var s=new Array(t.length-1);s[0]=t[0][e];for(var u=1;u<s.length;u++){s[u]=s[u-1]+t[u][e];}var l=i[e],c="vec2("+i.slice(-2).join()+")",h=i.join(),f="if ("+l+" < "+s[0]+")\n          return getChannel(getT0("+h+"), "+c+");";for(u=1;u<s.length;u++){var p=s[u-1];f+="\n        else if ("+l+" < "+s[u]+") {\n          "+l+" -= "+p+";\n          return getChannel(getT"+u+"("+h+"), "+c+");\n        }";}var d=s.length;f+="\n        else {\n          "+l+" -= "+s[s.length-1]+";\n          return getChannel(getT"+d+"("+h+"), "+c+");\n        }",this.userCode="\n      float getValue("+i.map(function(t){return "int "+t;})+") {\n        "+f+"\n      }\n\n      void main() {\n        "+o+" coords = getOutputCoords();\n        vec4 result = vec4(getValue("+a+"), 0., 0., 0.);\n        if (++"+a[r-1]+" < "+n[r-1]+") {\n          result.g = getValue("+a+");\n        }\n        if (++"+a[r-2]+" < "+n[r-2]+") {\n          result.a = getValue("+a+");\n        }\n        if ("+a[r-2]+" < "+n[r-2]+" &&\n            --"+a[r-1]+" < "+n[r-1]+") {\n          result.b = getValue("+a+");\n        }\n        setOutput(result);\n      }\n    ";};}(),ca=function(){return function(t){this.variableNames=["x","dy"],this.outputShape=t.filterShape;var e=t.strideHeight,n=t.strideWidth,r=t.padInfo.top,o=t.padInfo.left;this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int wR = coords.x;\n        int wC = coords.y;\n        int d1 = coords.z;\n        int d2 = coords.w;\n\n        // Convolve x(?, ?, d1) with dy(:, :, d2) to get dw(wR, wC, d1, d2).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n\n        for (int b = 0; b < "+t.batchSize+"; b++) {\n          for (int yR = 0; yR < "+t.outHeight+"; yR++) {\n            int xR = wR + yR * "+e+" - "+r+";\n\n            if (xR < 0 || xR >= "+t.inHeight+") {\n              continue;\n            }\n\n            for (int yC = 0; yC < "+t.outWidth+"; yC++) {\n              int xC = wC + yC * "+n+" - "+o+";\n\n              if (xC < 0 || xC >= "+t.inWidth+") {\n                continue;\n              }\n\n              float dyValue = getDy(b, yR, yC, d2);\n              float xValue = getX(b, xR, xC, d1);\n              dotProd += (xValue * dyValue);\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    ";};}(),ha=function(){return function(t){this.variableNames=["dy","W"],this.outputShape=t.inShape;var e=t.filterHeight,n=t.filterWidth,r=t.strideHeight,o=t.strideWidth,a=e-1-t.padInfo.top,i=n-1-t.padInfo.left;this.userCode="\n      const ivec2 pads = ivec2("+a+", "+i+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int batch = coords[0];\n        int d1 = coords[3];\n\n        ivec2 dyCorner = coords.yz - pads;\n        int dyRCorner = dyCorner.x;\n        int dyCCorner = dyCorner.y;\n\n        // Convolve dy(?, ?, d2) with w(:, :, d1, d2) to compute dx(xR, xC, d1).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n        for (int wR = 0; wR < "+e+"; wR++) {\n          float dyR = float(dyRCorner + wR) / "+r+".0;\n\n          if (dyR < 0.0 || dyR >= "+t.outHeight+".0 || fract(dyR) > 0.0) {\n            continue;\n          }\n          int idyR = int(dyR);\n\n          int wRPerm = "+e+" - 1 - wR;\n\n          for (int wC = 0; wC < "+n+"; wC++) {\n            float dyC = float(dyCCorner + wC) / "+o+".0;\n\n            if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                fract(dyC) > 0.0) {\n              continue;\n            }\n            int idyC = int(dyC);\n\n            int wCPerm = "+n+" - 1 - wC;\n\n            for (int d2 = 0; d2 < "+t.outChannels+"; d2++) {\n              float xValue = getDy(batch, idyR, idyC, d2);\n              float wValue = getW(wRPerm, wCPerm, d1, d2);\n              dotProd += xValue * wValue;\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    ";};}(),fa=function(){return function(t){this.variableNames=["x","dy"],this.outputShape=t.filterShape;var e=t.strideDepth,n=t.strideHeight,r=t.strideWidth,o=t.padInfo.front,a=t.padInfo.top,i=t.padInfo.left;this.userCode="\n      void main() {\n        ivec5 coords = getOutputCoords();\n        int wF = coords.x;\n        int wR = coords.y;\n        int wC = coords.z;\n        int d1 = coords.w;\n        int d2 = coords.u;\n\n        float dotProd = 0.0;\n\n        for (int b = 0; b < "+t.batchSize+"; b++) {\n          for (int yF = 0; yF < "+t.outDepth+"; yF++) {\n            int xF = wF + yF * "+e+" - "+o+";\n\n            if (xF < 0 || xF >= "+t.inDepth+") {\n              continue;\n            }\n\n            for (int yR = 0; yR < "+t.outHeight+"; yR++) {\n              int xR = wR + yR * "+n+" - "+a+";\n\n              if (xR < 0 || xR >= "+t.inHeight+") {\n                continue;\n              }\n\n              for (int yC = 0; yC < "+t.outWidth+"; yC++) {\n                int xC = wC + yC * "+r+" - "+i+";\n\n                if (xC < 0 || xC >= "+t.inWidth+") {\n                  continue;\n                }\n\n                float dyValue = getDy(b, yF, yR, yC, d2);\n                float xValue = getX(b, xF, xR, xC, d1);\n                dotProd += (xValue * dyValue);\n              }\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    ";};}(),pa=function(){return function(t){this.variableNames=["dy","W"],this.outputShape=t.inShape;var e=t.filterDepth,n=t.filterHeight,r=t.filterWidth,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=e-1-t.padInfo.front,u=n-1-t.padInfo.top,l=r-1-t.padInfo.left;this.userCode="\n      const ivec3 pads = ivec3("+s+", "+u+", "+l+");\n\n      void main() {\n        ivec5 coords = getOutputCoords();\n        int batch = coords.x;\n        int d1 = coords.u;\n\n\n        ivec3 dyCorner = ivec3(coords.y, coords.z, coords.w) - pads;\n        int dyFCorner = dyCorner.x;\n        int dyRCorner = dyCorner.y;\n        int dyCCorner = dyCorner.z;\n\n        float dotProd = 0.0;\n        for (int wF = 0; wF < "+e+"; wF++) {\n          float dyF = float(dyFCorner + wF) / "+o+".0;\n\n          if (dyF < 0.0 || dyF >= "+t.outDepth+".0 || fract(dyF) > 0.0) {\n            continue;\n          }\n          int idyF = int(dyF);\n\n          int wFPerm = "+e+" - 1 - wF;\n\n          for (int wR = 0; wR < "+n+"; wR++) {\n            float dyR = float(dyRCorner + wR) / "+a+".0;\n\n            if (dyR < 0.0 || dyR >= "+t.outHeight+".0 ||\n              fract(dyR) > 0.0) {\n              continue;\n            }\n            int idyR = int(dyR);\n\n            int wRPerm = "+n+" - 1 - wR;\n\n            for (int wC = 0; wC < "+r+"; wC++) {\n              float dyC = float(dyCCorner + wC) / "+i+".0;\n\n              if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                  fract(dyC) > 0.0) {\n                continue;\n              }\n              int idyC = int(dyC);\n\n              int wCPerm = "+r+" - 1 - wC;\n\n              for (int d2 = 0; d2 < "+t.outChannels+"; d2++) {\n                float xValue = getDy(batch, idyF, idyR, idyC, d2);\n                float wValue = getW(wFPerm, wRPerm, wCPerm, d1, d2);\n                dotProd += xValue * wValue;\n              }\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    ";};}(),da=function(){return function(t){this.variableNames=["x","dy"],this.outputShape=t.filterShape;var e=t.strideHeight,n=t.strideWidth,r=t.padInfo.top,o=t.padInfo.left,a=t.outChannels/t.inChannels;this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int wR = coords.x;\n        int wC = coords.y;\n        int d1 = coords.z;\n        int dm = coords.w;\n        int d2 = d1 * "+a+" + dm;\n\n        float dotProd = 0.0;\n\n        // TODO: Vec4 over the batch size\n        for (int b = 0; b < "+t.batchSize+"; b++) {\n          for (int yR = 0; yR < "+t.outHeight+"; yR++) {\n            int xR = wR + yR * "+e+" - "+r+";\n\n            if (xR < 0 || xR >= "+t.inHeight+") {\n              continue;\n            }\n\n            for (int yC = 0; yC < "+t.outWidth+"; yC++) {\n              int xC = wC + yC * "+n+" - "+o+";\n\n              if (xC < 0 || xC >= "+t.inWidth+") {\n                continue;\n              }\n\n              float dyValue = getDy(b, yR, yC, d2);\n              float xValue = getX(b, xR, xC, d1);\n              dotProd += (xValue * dyValue);\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    ";};}(),va=function(){return function(t){this.variableNames=["dy","W"],this.outputShape=t.inShape;var e=t.filterHeight,n=t.filterWidth,r=t.strideHeight,o=t.strideWidth,a=e-1-t.padInfo.top,i=n-1-t.padInfo.left,s=t.outChannels/t.inChannels;this.userCode="\n      const ivec2 pads = ivec2("+a+", "+i+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int batch = coords[0];\n        int d1 = coords[3];\n        ivec2 dyCorner = coords.yz - pads;\n        int dyRCorner = dyCorner.x;\n        int dyCCorner = dyCorner.y;\n\n        float dotProd = 0.0;\n\n        for (int wR = 0; wR < "+e+"; wR++) {\n          float dyR = float(dyRCorner + wR) / "+r+".0;\n\n          if (dyR < 0.0 || dyR >= "+t.outHeight+".0 || fract(dyR) > 0.0) {\n            continue;\n          }\n          int idyR = int(dyR);\n\n          int wRPerm = "+e+" - 1 - wR;\n\n          for (int wC = 0; wC < "+n+"; wC++) {\n            float dyC = float(dyCCorner + wC) / "+o+".0;\n\n            if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                fract(dyC) > 0.0) {\n              continue;\n            }\n            int idyC = int(dyC);\n\n            int wCPerm = "+n+" - 1 - wC;\n\n            // TODO: Vec4 over the channelMul\n            for (int dm = 0; dm < "+s+"; dm++) {\n              int d2 = d1 * "+s+" + dm;\n              float xValue = getDy(batch, idyR, idyC, d2);\n              float wValue = getW(wRPerm, wCPerm, d1, dm);\n              dotProd += xValue * wValue;\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    ";};}(),ma=function(){return function(t,e,n){void 0===e&&(e=!1),void 0===n&&(n=null),this.variableNames=["x","W"],this.outputShape=t.outShape;var r=t.padInfo.top,o=t.padInfo.left,a=t.strideHeight,i=t.strideWidth,s=t.dilationHeight,u=t.dilationWidth,l=t.filterHeight,c=t.filterWidth,h=4*Math.floor(t.inChannels/4),f=t.inChannels%4,p="",d="";n&&(p="\n        float activation(float x) {\n          "+n+"\n        }\n      ",d="result = activation(result);");var v=e?"result += getBiasAtOutCoords();":"";e&&this.variableNames.push("bias"),this.userCode="\n      "+p+"\n\n      const ivec2 strides = ivec2("+a+", "+i+");\n      const ivec2 pads = ivec2("+r+", "+o+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int batch = coords[0];\n        int d2 = coords[3];\n\n        ivec2 xRCCorner = coords.yz * strides - pads;\n        int xRCorner = xRCCorner.x;\n        int xCCorner = xRCCorner.y;\n\n        // Convolve x(?, ?, d1) with w(:, :, d1, d2) to get y(yR, yC, d2).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n        for (int wR = 0; wR < "+l+"; wR++) {\n          int xR = xRCorner + wR * "+s+";\n\n          if (xR < 0 || xR >= "+t.inHeight+") {\n            continue;\n          }\n\n          for (int wC = 0; wC < "+c+"; wC++) {\n            int xC = xCCorner + wC * "+u+";\n\n            if (xC < 0 || xC >= "+t.inWidth+") {\n              continue;\n            }\n\n            for (int d1 = 0; d1 < "+h+"; d1 += 4) {\n              vec4 xValues = vec4(\n                getX(batch, xR, xC, d1),\n                getX(batch, xR, xC, d1 + 1),\n                getX(batch, xR, xC, d1 + 2),\n                getX(batch, xR, xC, d1 + 3)\n              );\n              vec4 wValues = vec4(\n                getW(wR, wC, d1, d2),\n                getW(wR, wC, d1 + 1, d2),\n                getW(wR, wC, d1 + 2, d2),\n                getW(wR, wC, d1 + 3, d2)\n              );\n\n              dotProd += dot(xValues, wValues);\n            }\n\n            if ("+(1===f)+") {\n              dotProd +=\n                getX(batch, xR, xC, "+h+") *\n                getW(wR, wC, "+h+", d2);\n            } else if ("+(2===f)+") {\n              vec2 xValues = vec2(\n                getX(batch, xR, xC, "+h+"),\n                getX(batch, xR, xC, "+h+" + 1)\n              );\n              vec2 wValues = vec2(\n                getW(wR, wC, "+h+", d2),\n                getW(wR, wC, "+h+" + 1, d2)\n              );\n              dotProd += dot(xValues, wValues);\n            } else if ("+(3===f)+") {\n              vec3 xValues = vec3(\n                getX(batch, xR, xC, "+h+"),\n                getX(batch, xR, xC, "+h+" + 1),\n                getX(batch, xR, xC, "+h+" + 2)\n              );\n              vec3 wValues = vec3(\n                getW(wR, wC, "+h+", d2),\n                getW(wR, wC, "+h+" + 1, d2),\n                getW(wR, wC, "+h+" + 2, d2)\n              );\n              dotProd += dot(xValues, wValues);\n            }\n          }\n        }\n\n        float result = dotProd;\n        "+v+"\n        "+d+"\n        setOutput(result);\n      }\n    ";};}(),ga=function(){return function(t){this.variableNames=["x","W"],this.outputShape=t.outShape;var e=t.padInfo.front,n=t.padInfo.top,r=t.padInfo.left,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=t.dilationDepth,u=t.dilationHeight,l=t.dilationWidth,c=t.filterDepth,h=t.filterHeight,f=t.filterWidth,p=4*Math.floor(t.inChannels/4),d=t.inChannels%4;this.userCode="\n      const ivec3 strides = ivec3("+o+", "+a+", "+i+");\n      const ivec3 pads = ivec3("+e+", "+n+", "+r+");\n\n      void main() {\n        ivec5 coords = getOutputCoords();\n        int batch = coords.x;\n        int d2 = coords.u;\n\n        ivec3 xFRCCorner = ivec3(coords.y, coords.z, coords.w) * strides - pads;\n        int xFCorner = xFRCCorner.x;\n        int xRCorner = xFRCCorner.y;\n        int xCCorner = xFRCCorner.z;\n\n        // Convolve x(?, ?, ?, d1) with w(:, :, :, d1, d2) to get\n        // y(yF, yR, yC, d2). ? = to be determined. : = across all\n        // values in that axis.\n        float dotProd = 0.0;\n        for (int wF = 0; wF < "+c+"; wF++) {\n          int xF = xFCorner + wF * "+s+";\n\n          if (xF < 0 || xF >= "+t.inDepth+") {\n            continue;\n          }\n\n          for (int wR = 0; wR < "+h+"; wR++) {\n            int xR = xRCorner + wR * "+u+";\n\n            if (xR < 0 || xR >= "+t.inHeight+") {\n              continue;\n            }\n\n            for (int wC = 0; wC < "+f+"; wC++) {\n              int xC = xCCorner + wC * "+l+";\n\n              if (xC < 0 || xC >= "+t.inWidth+") {\n                continue;\n              }\n\n              for (int d1 = 0; d1 < "+p+"; d1 += 4) {\n                vec4 xValues = vec4(\n                  getX(batch, xF, xR, xC, d1),\n                  getX(batch, xF, xR, xC, d1 + 1),\n                  getX(batch, xF, xR, xC, d1 + 2),\n                  getX(batch, xF, xR, xC, d1 + 3)\n                );\n                vec4 wValues = vec4(\n                  getW(wF, wR, wC, d1, d2),\n                  getW(wF, wR, wC, d1 + 1, d2),\n                  getW(wF, wR, wC, d1 + 2, d2),\n                  getW(wF, wR, wC, d1 + 3, d2)\n                );\n\n                dotProd += dot(xValues, wValues);\n              }\n\n              if ("+(1===d)+") {\n                dotProd +=\n                  getX(batch, xF, xR, xC, "+p+") *\n                  getW(wF, wR, wC, "+p+", d2);\n              } else if ("+(2===d)+") {\n                vec2 xValues = vec2(\n                  getX(batch, xF, xR, xC, "+p+"),\n                  getX(batch, xF, xR, xC, "+p+" + 1)\n                );\n                vec2 wValues = vec2(\n                  getW(wF, wR, wC, "+p+", d2),\n                  getW(wF, wR, wC, "+p+" + 1, d2)\n                );\n                dotProd += dot(xValues, wValues);\n              } else if ("+(3===d)+") {\n                vec3 xValues = vec3(\n                  getX(batch, xF, xR, xC, "+p+"),\n                  getX(batch, xF, xR, xC, "+p+" + 1),\n                  getX(batch, xF, xR, xC, "+p+" + 2)\n                );\n                vec3 wValues = vec3(\n                  getW(wF, wR, wC, "+p+", d2),\n                  getW(wF, wR, wC, "+p+" + 1, d2),\n                  getW(wF, wR, wC, "+p+" + 2, d2)\n                );\n                dotProd += dot(xValues, wValues);\n              }\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    ";};}(),ya=function(){return function(t){this.variableNames=["x","W"],this.outputShape=t.outShape;var e=t.inHeight,n=t.inWidth,r=t.padInfo.top,o=t.padInfo.left,a=t.strideHeight,i=t.strideWidth,s=t.dilationHeight,u=t.dilationWidth,l=t.filterHeight,c=t.filterWidth,h=t.outChannels/t.inChannels;this.userCode="\n      const ivec2 strides = ivec2("+a+", "+i+");\n      const ivec2 pads = ivec2("+r+", "+o+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int batch = coords.x;\n        ivec2 xRCCorner = coords.yz * strides - pads;\n        int d2 = coords.w;\n        int d1 = d2 / "+h+";\n        int q = d2 - d1 * "+h+";\n\n        int xRCorner = xRCCorner.x;\n        int xCCorner = xRCCorner.y;\n\n        // Convolve x(?, ?, d1) with w(:, :, d1, q) to get y(yR, yC, d2).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n        // TODO(dsmilkov): Flatten the two for loops and vec4 the operations.\n        for (int wR = 0; wR < "+l+"; wR++) {\n          int xR = xRCorner + wR * "+s+";\n\n          if (xR < 0 || xR >= "+e+") {\n            continue;\n          }\n\n          for (int wC = 0; wC < "+c+"; wC++) {\n            int xC = xCCorner + wC * "+u+";\n\n            if (xC < 0 || xC >= "+n+") {\n              continue;\n            }\n\n            float xVal = getX(batch, xR, xC, d1);\n            float wVal = getW(wR, wC, d1, q);\n            dotProd += xVal * wVal;\n          }\n        }\n        setOutput(dotProd);\n      }\n    ";};}(),xa=function(){return function(t){this.variableNames=["x","W"],this.usesPackedTextures=!0,this.outputShape=t.outShape;for(var e=t.inHeight,n=t.inWidth,r=t.padInfo.top,o=t.padInfo.left,a=t.strideHeight,i=t.strideWidth,s=t.dilationHeight,u=t.dilationWidth,l=t.filterHeight,c=t.filterWidth,f=c,p="int xR; int xC; int xCOffset;",d=0;d<l;d++){for(var v=0;v<c;v++){p+="\n          vec4 xTexelR"+d+"C"+2*v+" = vec4(0.);\n          vec4 wR"+d+"C"+v+" = vec4(0.);\n          vec4 xR"+d+"C"+v+" = vec4(0.);";}}for(d=0;d<l;d++){for(var m=0;m<f;m++){if(p+="\n          xR = xRCorner + "+d*s+";\n          xC = xCCorner + "+(v=2*m)*u+";\n        ",1===i){if(v<c&&(p+=o%2==1?"\n                xCOffset = xC + 1;\n                if(xR >= 0 && xR < "+e+" && xCOffset >= 0 && xCOffset < "+n+") {\n                  xTexelR"+d+"C"+v+" = getX(batch, xR, xCOffset, d1);\n                } else {\n                  xTexelR"+d+"C"+v+" = vec4(0.);\n                }\n\n                xCOffset = xC + 1 - 2;\n                if(xR >= 0 && xR < "+e+" && xCOffset >= 0 && xCOffset < "+n+") {\n                  vec4 previous = getX(batch, xR, xCOffset, d1);\n                  xR"+d+"C"+v+" = vec4(previous.zw, xTexelR"+d+"C"+v+".xy);\n                } else {\n                  xR"+d+"C"+v+" = vec4(0, 0, xTexelR"+d+"C"+v+".xy);\n                }\n              ":"\n                if(xR >= 0 && xR < "+e+" && xC >= 0 && xC < "+n+") {\n                  xTexelR"+d+"C"+v+" = getX(batch, xR, xC, d1);\n                } else {\n                  xTexelR"+d+"C"+v+" = vec4(0.);\n                }\n\n                xR"+d+"C"+v+" = xTexelR"+d+"C"+v+";\n              ",v+1<c)){var g=o%2==0?h(u):u;u%2==0&&o%2==1||u%2!=0&&o%2!=1?(p+="\n                  xCOffset = xC + "+o%2+" + "+g+";\n\n                  if(xR >= 0 && xR < "+e+" &&\n                    xCOffset >= 0 && xCOffset < "+n+") {\n                    xTexelR"+d+"C"+(v+2)+" = getX(batch, xR, xCOffset, d1);\n                  }\n                ",u>1&&(p+="\n                    xCOffset -= 2;\n                    if(xR >= 0 && xR < "+e+" &&\n                      xCOffset >= 0 && xCOffset < "+n+") {\n                      xTexelR"+d+"C"+v+" = getX(batch, xR, xCOffset, d1);\n                    } else {\n                      xTexelR"+d+"C"+v+" = vec4(0.);\n                    }\n                  "),p+="\n                  xR"+d+"C"+(v+1)+" = vec4(\n                    xTexelR"+d+"C"+v+".zw, xTexelR"+d+"C"+(v+2)+".xy);\n                "):p+="\n                  xCOffset = xC + "+g+";\n\n                  if(xR >= 0 && xR < "+e+" &&\n                    xCOffset >= 0 && xCOffset < "+n+") {\n                    xTexelR"+d+"C"+(v+2)+" = getX(batch, xR, xCOffset, d1);\n                  }\n\n                  xR"+d+"C"+(v+1)+" = xTexelR"+d+"C"+(v+2)+";\n                ";}}else v<c&&(p+="\n              if(xR >= 0 && xR < "+e+") {\n            ",o%2==1?(p+="\n                xCOffset = xC + 1 - "+i+";\n                if(xCOffset >= 0 && xCOffset < "+n+") {\n                  xTexelR"+d+"C"+v+" = getX(batch, xR, xCOffset, d1);\n                } else {\n                  xTexelR"+d+"C"+v+" = vec4(0.);\n                }\n\n                if(xC + 1 >= 0 && xC + 1 < "+n+") {\n                  xTexelR"+d+"C"+(v+2)+" = getX(batch, xR, xC + 1, d1);\n                } else {\n                  xTexelR"+d+"C"+(v+2)+" = vec4(0.);\n                }\n\n                xR"+d+"C"+v+" = vec4(\n                  xTexelR"+d+"C"+v+".zw, xTexelR"+d+"C"+(v+2)+".zw);\n              ",v+1<c&&(p+="\n                  vec4 final = vec4(0.);\n                  xCOffset = xC + 1 + "+i+";\n                  if(xCOffset >= 0 && xCOffset < "+n+") {\n                    final = getX(batch, xR, xCOffset, d1);\n                  }\n                  xR"+d+"C"+(v+1)+" = vec4(xTexelR"+d+"C"+(v+2)+".xy, final.xy);\n                ")):(p+="\n                if(xC >= 0 && xC < "+n+") {\n                  xTexelR"+d+"C"+v+" = getX(batch, xR, xC, d1);\n                } else {\n                  xTexelR"+d+"C"+v+" = vec4(0.);\n                }\n\n                xCOffset = xC + "+i+";\n                if(xCOffset >= 0 && xCOffset < "+n+") {\n                  xTexelR"+d+"C"+(v+2)+" = getX(batch, xR, xCOffset, d1);\n                } else {\n                  xTexelR"+d+"C"+(v+2)+" = vec4(0.);\n                }\n\n                xR"+d+"C"+v+" = vec4(\n                  xTexelR"+d+"C"+v+".xy, xTexelR"+d+"C"+(v+2)+".xy);\n              ",v+1<c&&(p+="\n                  xR"+d+"C"+(v+1)+" = vec4(\n                    xTexelR"+d+"C"+v+".zw, xTexelR"+d+"C"+(v+2)+".zw);\n                ")),p+="}");v<c&&(p+="\n            vec4 wTexelR"+d+"C"+v+" = getW("+d+", "+v+", d1, q);\n            wR"+d+"C"+v+" = vec4(wTexelR"+d+"C"+v+".xz, wTexelR"+d+"C"+v+".xz);\n          ",v+1<c&&(p+="\n              vec4 wTexelR"+d+"C"+(v+1)+" = getW("+d+", "+(v+1)+", d1, q);\n              wR"+d+"C"+(v+1)+" =\n                vec4(wTexelR"+d+"C"+(v+1)+".xz, wTexelR"+d+"C"+(v+1)+".xz);"));}}for(d=0;d<l;d++){for(v=0;v<c;v++){p+="result += xR"+d+"C"+v+" * wR"+d+"C"+v+";";}}this.userCode="\n      const ivec2 strides = ivec2("+a+", "+i+");\n      const ivec2 pads = ivec2("+r+", "+o+");\n\n      void main() {\n\n        ivec4 coords = getOutputCoords();\n        int batch = coords.x;\n        ivec2 xRCCorner = coords.yz * strides - pads;\n        int d2 = coords.w;\n        int d1 = d2;\n        int q = 0;\n        int xRCorner = xRCCorner.x;\n        int xCCorner = xRCCorner.y;\n\n        vec4 result = vec4(0.);\n\n        "+p+"\n\n        setOutput(result);\n      }\n    ";};}(),ba=function(){return function(t,e,n,r,o){this.variableNames=["Image","Boxes","BoxInd"],this.outputShape=[];var a=t[0],i=t[1],s=t[2],u=t[3],l=e[0],c=n[0],h=n[1];this.outputShape=[l,c,h,u];var f="bilinear"===r?1:0,p=[i-1+".0",s-1+".0"],d=p[0],v=p[1],m=c>1?[""+(i-1)/(c-1),"(y2-y1) * height_ratio","y1*"+d+" + float(y)*(height_scale)"]:["0.0","0.0","0.5 * (y1+y2) * "+d],g=m[0],y=m[1],x=m[2],b=h>1?[""+(s-1)/(h-1),"(x2-x1) * width_ratio","x1*"+v+" + float(x)*(width_scale)"]:["0.0","0.0","0.5 * (x1+x2) * "+v],w=b[0],C=b[1],E=b[2];this.userCode="\n      const float height_ratio = float("+g+");\n      const float width_ratio = float("+w+");\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int y = coords[1];\n        int x = coords[2];\n        int d = coords[3];\n\n        // get box vals\n        float y1 = getBoxes(b,0);\n        float x1 = getBoxes(b,1);\n        float y2 = getBoxes(b,2);\n        float x2 = getBoxes(b,3);\n\n        // get image in batch index\n        int bInd = round(getBoxInd(b));\n        if(bInd < 0 || bInd >= "+a+") {\n          return;\n        }\n\n        float height_scale = "+y+";\n        float width_scale = "+C+";\n\n        float in_y = "+x+";\n        if( in_y < 0.0 || in_y > "+d+" ) {\n          setOutput(float("+o+"));\n          return;\n        }\n        float in_x = "+E+";\n        if( in_x < 0.0 || in_x > "+v+" ) {\n          setOutput(float("+o+"));\n          return;\n        }\n\n        vec2 sourceFracIndexCR = vec2(in_x,in_y);\n        if("+f+" == 1) {\n          // Compute the four integer indices.\n          ivec2 sourceFloorCR = ivec2(sourceFracIndexCR);\n          ivec2 sourceCeilCR = ivec2(ceil(sourceFracIndexCR));\n\n          float topLeft = getImage(b, sourceFloorCR.y, sourceFloorCR.x, d);\n          float bottomLeft = getImage(b, sourceCeilCR.y, sourceFloorCR.x, d);\n          float topRight = getImage(b, sourceFloorCR.y, sourceCeilCR.x, d);\n          float bottomRight = getImage(b, sourceCeilCR.y, sourceCeilCR.x, d);\n\n          vec2 fracCR = sourceFracIndexCR - vec2(sourceFloorCR);\n\n          float top = topLeft + (topRight - topLeft) * fracCR.x;\n          float bottom = bottomLeft + (bottomRight - bottomLeft) * fracCR.x;\n          float newValue = top + (bottom - top) * fracCR.y;\n          setOutput(newValue);\n        } else {\n          // Compute the coordinators of nearest neighbor point.\n          ivec2 sourceNearestCR = ivec2(floor(\n            sourceFracIndexCR + vec2(0.5,0.5)));\n          float newValue = getImage(b, sourceNearestCR.y, sourceNearestCR.x, d);\n          setOutput(newValue);\n        }\n      }\n    ";};}(),wa=function(){return function(t,e,n){this.variableNames=["x"],this.outputShape=t;var r=t.length,o=t[t.length-1],a=n?"<":">";this.userCode="\n      int getIndex(int i) {\n        "+(n?"return "+o+" -i - 1;":"return i;")+"\n      }\n\n      void main() {\n        "+Ho(r)+" coords = getOutputCoords();\n        int end = "+Ca(r,"coords")+";\n        float val = 0.0;\n        for (int i = "+o+" - 1; i >= 0; i -= 1) {\n          int idx = getIndex(i);\n          if (idx "+a+" end) {\n            continue;\n          }\n          if (idx == end && "+e+") {\n            continue;\n          }\n          "+Ca(r,"coords")+" = idx;\n          val += getX("+function(t,e){if(1===t)return ""+e;if(2===t)return e+".x, "+e+".y";if(3===t)return e+".x, "+e+".y, "+e+".z";if(4===t)return e+".x, "+e+".y, "+e+".z, "+e+".w";throw Error("Cumulative sum for rank "+t+" is not yet supported");}(r,"coords")+");\n        }\n        setOutput(val);\n      }\n    ";};}();function Ca(t,e){if(1===t)return ""+e;if(2===t)return e+".y";if(3===t)return e+".z";if(4===t)return e+".w";throw Error("Cumulative sum for rank "+t+" is not yet supported");}var Ea=function(){return function(t,e){this.variableNames=["A"];var n=Do();this.outputShape=t,this.userCode="\n      ivec3 outCoordsFromFlatIndex(int index) {\n        "+_o(["r","c","d"],t)+"\n        return ivec3(r, c, d);\n      }\n\n      void main() {\n        ivec2 resTexRC = ivec2(resultUV.yx *\n          vec2("+e[0]+", "+e[1]+"));\n        int index = 4 * (resTexRC.x * "+e[1]+" + resTexRC.y);\n\n        vec4 result = vec4(0.);\n\n        for (int i=0; i<4; i++) {\n          int flatIndex = index + i;\n          ivec3 rc = outCoordsFromFlatIndex(flatIndex);\n          result[i] = getA(rc.x, rc.y, rc.z);\n        }\n\n        "+n.output+" = result;\n      }\n    ";};}(),Ra=function(){return function(t,e){this.variableNames=["A"],this.usesPackedTextures=!0;var n=Do();this.outputShape=t,this.userCode="\n      ivec3 outCoordsFromFlatIndex(int index) {\n        "+_o(["r","c","d"],t)+"\n        return ivec3(r, c, d);\n      }\n\n      void main() {\n        ivec2 resTexRC = ivec2(resultUV.yx *\n          vec2("+e[0]+", "+e[1]+"));\n        int index = 4 * (resTexRC.x * "+e[1]+" + resTexRC.y);\n\n        vec4 result = vec4(0.);\n\n        for (int i=0; i<4; i++) {\n          int flatIndex = index + i;\n          ivec3 rc = outCoordsFromFlatIndex(flatIndex);\n          result[i] = getChannel(getA(rc.x, rc.y, rc.z), vec2(rc.y, rc.z));\n        }\n\n        "+n.output+" = result;\n      }\n    ";};}(),Ia=function(){function t(t,e,n){this.variableNames=["x"],this.outputShape=[],this.outputShape=t,this.blockSize=e,this.dataFormat=n,this.userCode="\n    void main() {\n      ivec4 coords = getOutputCoords();\n      int b = coords[0];\n      int h = "+this.getHeightCoordString()+";\n      int w = "+this.getWidthCoordString()+";\n      int d = "+this.getDepthCoordString()+";\n\n      int in_h = h / "+e+";\n      int offset_h = imod(h, "+e+");\n      int in_w = w / "+e+";\n      int offset_w = imod(w, "+e+");\n      int offset_d = (offset_h * "+e+" + offset_w) *\n        "+this.getOutputDepthSize()+";\n      int in_d = d + offset_d;\n\n      float result = "+this.getInputSamplingString()+";\n      setOutput(result);\n    }\n  ";}return t.prototype.getHeightCoordString=function(){return "NHWC"===this.dataFormat?"coords[1]":"coords[2]";},t.prototype.getWidthCoordString=function(){return "NHWC"===this.dataFormat?"coords[2]":"coords[3]";},t.prototype.getDepthCoordString=function(){return "NHWC"===this.dataFormat?"coords[3]":"coords[1]";},t.prototype.getOutputDepthSize=function(){return "NHWC"===this.dataFormat?this.outputShape[3]:this.outputShape[1];},t.prototype.getInputSamplingString=function(){return "NHWC"===this.dataFormat?"getX(b, in_h, in_w, in_d)":"getX(b, in_d, in_h, in_w)";},t;}(),Sa=function(){return function(t){this.variableNames=["A"];var e=Do();this.outputShape=t,this.userCode="\n      "+Fo+"\n\n      void main() {\n        float x = getAAtOutCoords();\n        "+e.output+" = encode_float(x);\n      }\n    ";};}(),Na=function(){return function(t){this.variableNames=["A"],this.usesPackedTextures=!0;var e=Do();this.outputShape=t,this.userCode="\n      "+Fo+"\n\n      void main() {\n        ivec3 coords = getOutputCoords();\n        float x = getChannel(getAAtOutCoords(), vec2(coords.y, coords.z));\n        "+e.output+" = encode_float(x);\n      }\n    ";};}(),ka=function(){return function(t,e,n){void 0===n&&(n=!1),this.variableNames=["A"];var r=Do(),o=e[0],a=e[1];this.outputShape=t;var i="result";n&&(i="floor(result * 255. + 0.5)"),this.userCode="\n      "+Oo(t)+"\n\n      void main() {\n        ivec3 coords = getOutputCoords();\n\n        int flatIndex = getFlatIndex(coords);\n        int offset = imod(flatIndex, 4);\n\n        flatIndex = idiv(flatIndex, 4, 1.);\n        \n        int r = flatIndex / "+a+";\n        int c = imod(flatIndex, "+a+");\n        vec2 uv = (vec2(c, r) + halfCR) / vec2("+a+".0, "+o+".0);\n        vec4 values = "+r.texture2D+"(A, uv);\n\n        float result;\n\n        if(offset == 0) {\n          result = values[0];\n        } else if(offset == 1) {\n          result = values[1];\n        } else if(offset == 2) {\n          result = values[2];\n        } else {\n          result = values[3];\n        }\n\n        "+r.output+" = vec4("+i+", 0., 0., 0.);\n      }\n    ";};}(),Aa=function(){return function(t,e,n){void 0===n&&(n=!1),this.variableNames=["A"];var r=Do(),o=e[0],a=e[1];this.outputShape=t;var i="",s="result";n&&(s="floor(result * 255. + 0.5)");for(var u=0;u<=1;u++){for(var l=0;l<=1;l++){var c=2*u+l;i+="\n          localCoords = coords;\n          if(localCoords[2] + "+l+" < "+t[2]+") {\n            localCoords[2] += "+l+";\n            if(localCoords[1] + "+u+" < "+t[1]+") {\n              localCoords[1] += "+u+";\n\n              flatIndex = getFlatIndex(localCoords);\n              offset = imod(flatIndex, 4);\n    \n              flatIndex = idiv(flatIndex, 4, 1.);\n\n              r = flatIndex / "+a+";\n              c = imod(flatIndex, "+a+");\n              uv = (vec2(c, r) + halfCR) / vec2("+a+".0, "+o+".0);\n              values = "+r.texture2D+"(A, uv);\n\n              if(offset == 0) {\n                result["+c+"] = values[0];\n              } else if(offset == 1) {\n                result["+c+"] = values[1];\n              } else if(offset == 2) {\n                result["+c+"] = values[2];\n              } else {\n                result["+c+"] = values[3];\n              }\n            }\n          }\n        ";}}this.userCode="\n      "+Oo(t)+"\n\n      void main() {\n        ivec3 coords = getOutputCoords();\n\n        vec4 result = vec4(0.);\n        int flatIndex, r, c, offset;\n        ivec3 localCoords;\n        vec2 uv;\n        vec4 values;\n        \n        "+i+"\n\n        "+r.output+" = "+s+";\n      }\n    ";};}(),Ta="return real * expR - imag * expI;",Da="return real * expI + imag * expR;",_a=function(){return function(t,e,n){this.variableNames=["real","imag"];var r=e[1];this.outputShape=e;var o=n?"2.0 * "+Math.PI:"-2.0 * "+Math.PI,a=n?r+".0":"1.0";this.userCode="\n      const float exponentMultiplier = "+o+";\n\n      float unaryOpComplex(float real, float expR, float imag, float expI) {\n        "+t+"\n      }\n\n      float mulMatDFT(int batch, int index) {\n        float indexRatio = float(index) / float("+r+");\n        float exponentMultiplierTimesIndexRatio =\n            exponentMultiplier * indexRatio;\n\n        float result = 0.0;\n\n        for (int i = 0; i < "+r+"; i++) {\n          // x = (-2|2 * PI / N) * index * i;\n          float x = exponentMultiplierTimesIndexRatio * float(i);\n          float expR = cos(x);\n          float expI = sin(x);\n          float real = getReal(batch, i);\n          float imag = getImag(batch, i);\n\n          result +=\n              unaryOpComplex(real, expR, imag, expI) / "+a+";\n        }\n\n        return result;\n      }\n\n      void main() {\n        ivec2 coords = getOutputCoords();\n        setOutput(mulMatDFT(coords[0], coords[1]));\n      }\n    ";};}(),Oa=function(){function t(t,e){this.outputShape=[],this.variableNames=["x"],this.outputShape=t,this.userCode="\n      uniform float value;\n      void main() {\n        // Input can be obtained from uniform value.\n        setOutput(value);\n      }\n    ";}return t.prototype.getCustomSetupFunc=function(t){var e=this;return function(n,r){null==e.valueLoc&&(e.valueLoc=n.getUniformLocationNoThrow(r,"value")),n.gl.uniform1f(e.valueLoc,t);};},t;}(),Fa=function(){return function(t){this.variableNames=["A"];var e=Do(),n=t[0],r=t[1];this.outputShape=t,this.userCode="\n      void main() {\n        ivec3 coords = getOutputCoords();\n        int texR = coords[0];\n        int texC = coords[1];\n        int depth = coords[2];\n        vec2 uv = (vec2(texC, texR) + halfCR) / vec2("+r+".0, "+n+".0);\n\n        vec4 values = "+e.texture2D+"(A, uv);\n        float value;\n        if (depth == 0) {\n          value = values.r;\n        } else if (depth == 1) {\n          value = values.g;\n        } else if (depth == 2) {\n          value = values.b;\n        } else if (depth == 3) {\n          value = values.a;\n        }\n\n        setOutput(floor(value * 255.0 + 0.5));\n      }\n    ";};}(),Ma=function(){return function(t){this.variableNames=["A"];var e=Do(),n=t[0],r=t[1];this.outputShape=t,this.userCode="\n      void main() {\n        ivec3 coords = getOutputCoords();\n        int texR = coords[0];\n        int texC = coords[1];\n        int depth = coords[2];\n\n        vec4 result = vec4(0.);\n\n        for(int row=0; row<=1; row++) {\n          for(int col=0; col<=1; col++) {\n            texC = coords[1] + row;\n            depth = coords[2] + col;\n\n            vec2 uv = (vec2(texC, texR) + halfCR) / vec2("+r+".0, "+n+".0);\n            vec4 values = "+e.texture2D+"(A, uv);\n            float value;\n            if (depth == 0) {\n              value = values.r;\n            } else if (depth == 1) {\n              value = values.g;\n            } else if (depth == 2) {\n              value = values.b;\n            } else if (depth == 3) {\n              value = values.a;\n            }\n\n            result[row * 2 + col] = floor(value * 255.0 + 0.5);\n          }\n        }\n\n        "+e.output+" = result;\n      }\n    ";};}(),Ba=function(){return function(t,e,n){this.variableNames=["A","indices"];var r=t.slice();r[n]=e,this.outputShape=r,this.rank=r.length;var o=Ho(this.rank),a=function(t,e){var n=t.length;if(n>4)throw Error("Gather for rank "+n+" is not yet supported");if(1===n)return "int(getIndices(resRC))";for(var r=["resRC.x","resRC.y","resRC.z","resRC.w"],o=[],a=0;a<t.length;a++){a===e?o.push("int(getIndices("+r[a]+"))"):o.push(""+r[a]);}return o.join();}(t,n);this.userCode="\n      void main() {\n        "+o+" resRC = getOutputCoords();\n        setOutput(getA("+a+"));\n      }\n    ";};}();var Pa=function(){return function(t,e,n){this.sliceDim=t,this.strides=e,this.variableNames=["x","indices"],this.outputShape=n;var r=Ho(e.length),o=Ho(n.length),a=this.sliceDim>1?"strides[j]":"strides";this.userCode="\n        "+r+" strides = "+r+"("+this.strides+");\n         void main() {\n          "+o+" coords = getOutputCoords();\n          int flattenIndex = 0;\n          for (int j = 0; j < "+this.sliceDim+"; j++) {\n            int index = round(getIndices(coords[0], j));\n            flattenIndex += index * "+a+";\n          }\n          setOutput(getX(flattenIndex, coords[1]));\n        }\n      ";};}();function La(t,e){var n=Do();return Kt(t,e,n.version+"\n    precision highp float;\n    "+n.attribute+" vec3 clipSpacePos;\n    "+n.attribute+" vec2 uv;\n    "+n.varyingVs+" vec2 resultUV;\n\n    void main() {\n      gl_Position = vec4(clipSpacePos, 1);\n      resultUV = uv;\n    }");}function Wa(t,e){return ne(t,e,new Float32Array([-1,1,0,0,1,-1,-1,0,0,0,1,1,0,1,1,1,-1,0,1,0]));}function Ua(t,e){return re(t,e,new Uint16Array([0,1,2,2,1,3]));}function za(t,e,n,r,o,a,i){ae(n,r);var s=oe(t,e),u=t.TEXTURE_2D;return Vt(t,e,function(){return t.bindTexture(u,s);}),Vt(t,e,function(){return t.texParameteri(u,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE);}),Vt(t,e,function(){return t.texParameteri(u,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE);}),Vt(t,e,function(){return t.texParameteri(u,t.TEXTURE_MIN_FILTER,t.NEAREST);}),Vt(t,e,function(){return t.texParameteri(u,t.TEXTURE_MAG_FILTER,t.NEAREST);}),Vt(t,e,function(){return t.texImage2D(u,0,o,n,r,0,a,i,null);}),Vt(t,e,function(){return t.bindTexture(t.TEXTURE_2D,null);}),s;}function Va(t,e,n,r,o){var a=Lt(n,r);return za(t,e,a[0],a[1],o.internalFormatFloat,o.textureFormatFloat,t.FLOAT);}function Ga(t,e,n,r,o){var a=Lt(n,r);return za(t,e,a[0],a[1],o.internalFormatHalfFloat,o.textureFormatFloat,o.textureTypeHalfFloat);}function Ha(t,e,n,r,o){var a=Lt(n,r);return za(t,e,a[0],a[1],t.RGBA,t.RGBA,t.UNSIGNED_BYTE);}function qa(t,e,n,r,o){var a=Ut(n,r);return za(t,e,a[0],a[1],o.internalFormatPackedFloat,t.RGBA,t.FLOAT);}function $a(t,e,n,r,o){var a=Ut(n,r);return za(t,e,a[0],a[1],o.internalFormatPackedHalfFloat,t.RGBA,o.textureTypeHalfFloat);}function ja(t,e,n,r){return Vt(t,e,function(){return t.bindBuffer(t.ARRAY_BUFFER,r);}),se(t,e,n,"clipSpacePos",r,3,20,0)&&se(t,e,n,"uv",r,2,20,12);}function Ka(t,e,n,r,o,a,i){var s,u,l;Vt(t,e,function(){return t.bindTexture(t.TEXTURE_2D,n);}),a instanceof Uint8Array?(s=new Uint8Array(r*o*4),u=t.UNSIGNED_BYTE,l=t.RGBA):(s=new Float32Array(r*o*4),u=t.FLOAT,l=i.internalFormatPackedFloat),s.set(a),Vt(t,e,function(){return t.texImage2D(t.TEXTURE_2D,0,l,r,o,0,t.RGBA,u,s);}),Vt(t,e,function(){return t.bindTexture(t.TEXTURE_2D,null);});}function Xa(t,e,n,r){Vt(t,e,function(){return t.bindTexture(t.TEXTURE_2D,n);}),r.data instanceof Uint8Array?Vt(t,e,function(){return t.texImage2D(t.TEXTURE_2D,0,t.RGBA,r.width,r.height,0,t.RGBA,t.UNSIGNED_BYTE,r.data);}):Vt(t,e,function(){return t.texImage2D(t.TEXTURE_2D,0,t.RGBA,t.RGBA,t.UNSIGNED_BYTE,r);}),Vt(t,e,function(){return t.bindTexture(t.TEXTURE_2D,null);});}function Ya(t,e,n,r,o){var a=t.createBuffer();Vt(t,e,function(){return t.bindBuffer(t.PIXEL_PACK_BUFFER,a);});var i=16*n*r;return Vt(t,e,function(){return t.bufferData(t.PIXEL_PACK_BUFFER,i,t.STREAM_READ);}),Vt(t,e,function(){return t.readPixels(0,0,r,n,t.RGBA,t.FLOAT,0);}),Vt(t,e,function(){return t.bindBuffer(t.PIXEL_PACK_BUFFER,null);}),a;}function Qa(t,e,n){var r=t,o=new Float32Array(n);return r.bindBuffer(r.PIXEL_PACK_BUFFER,e),r.getBufferSubData(r.PIXEL_PACK_BUFFER,0,o),r.bindBuffer(r.PIXEL_PACK_BUFFER,null),o;}function Ja(t,e,n,r,o){var a=Lt(n,r),i=a[0],s=a[1],u=new Uint8Array(n*r*4);return Vt(t,e,function(){return t.readPixels(0,0,i,s,o.downloadTextureFormat,t.UNSIGNED_BYTE,u);}),new Float32Array(u.buffer);}function Za(t,e,n,r,o,a,i,s){var u=t,l=new Float32Array(function(t,e){var n=Ut(t,e);return n[0]*n[1]*4;}(a,i));return u.bindBuffer(u.PIXEL_PACK_BUFFER,e),u.getBufferSubData(u.PIXEL_PACK_BUFFER,0,l),u.bindBuffer(u.PIXEL_PACK_BUFFER,null),l;}function ti(t,e,n,r){var o=new Float32Array(n*r*4);return Vt(t,e,function(){return t.readPixels(0,0,r,n,t.RGBA,t.FLOAT,o);}),o;}var ei=Object.freeze({createVertexShader:La,createVertexBuffer:Wa,createIndexBuffer:Ua,createFloat32MatrixTexture:Va,createFloat16MatrixTexture:Ga,createUnsignedBytesMatrixTexture:Ha,createPackedMatrixTexture:qa,createFloat16PackedMatrixTexture:$a,bindVertexProgramAttributeStreams:ja,uploadDenseMatrixToTexture:Ka,uploadPixelDataToTexture:Xa,createBufferFromOutputTexture:Ya,downloadFloat32MatrixFromBuffer:Qa,downloadByteEncodedFloatMatrixFromOutputTexture:Ja,downloadPackedMatrixFromBuffer:Za,downloadMatrixFromPackedOutputTexture:ti}),ni=function(){function t(t){this.outputTexture=null,this.program=null,this.disposed=!1,this.vertexAttrsAreBound=!1,this.itemsToPoll=[];var e=i.getNumber("WEBGL_VERSION");if(null!=t?(this.gl=t,Mt(e,t)):this.gl=Bt(e),1===i.getNumber("WEBGL_VERSION"))this.textureFloatExtension=jt(this.gl,this.debug,"OES_texture_float"),this.colorBufferFloatExtension=this.gl.getExtension("WEBGL_color_buffer_float"),i.getBool("WEBGL_RENDER_FLOAT32_ENABLED")||(this.textureHalfFloatExtension=jt(this.gl,this.debug,"OES_texture_half_float"),this.colorBufferHalfFloatExtension=this.gl.getExtension("EXT_color_buffer_half_float"));else{if(Ne(this.gl,"EXT_color_buffer_float"))this.colorBufferFloatExtension=this.gl.getExtension("EXT_color_buffer_float");else{if(!Ne(this.gl,"EXT_color_buffer_half_float"))throw new Error("GL context does not support color renderable floats");this.colorBufferHalfFloatExtension=this.gl.getExtension("EXT_color_buffer_half_float");}}this.vertexBuffer=Wa(this.gl,this.debug),this.indexBuffer=Ua(this.gl,this.debug),this.framebuffer=ie(this.gl,this.debug),this.textureConfig=zt(this.gl,this.textureHalfFloatExtension);}return Object.defineProperty(t.prototype,"debug",{get:function get(){return i.getBool("DEBUG");},enumerable:!0,configurable:!0}),t.prototype.dispose=function(){var t=this;if(!this.disposed){null!=this.program&&console.warn("Disposing a GPGPUContext that still has a bound WebGLProgram. This is probably a resource leak, delete the program with GPGPUContext.deleteProgram before disposing."),null!=this.outputTexture&&console.warn("Disposing a GPGPUContext that still has a bound output matrix texture.  This is probably a resource leak, delete the output matrix texture with GPGPUContext.deleteMatrixTexture before disposing.");var e=this.gl;Vt(e,this.debug,function(){return e.finish();}),Vt(e,this.debug,function(){return e.bindFramebuffer(e.FRAMEBUFFER,null);}),Vt(e,this.debug,function(){return e.deleteFramebuffer(t.framebuffer);}),Vt(e,this.debug,function(){return e.bindBuffer(e.ARRAY_BUFFER,null);}),Vt(e,this.debug,function(){return e.bindBuffer(e.ELEMENT_ARRAY_BUFFER,null);}),Vt(e,this.debug,function(){return e.deleteBuffer(t.indexBuffer);}),this.disposed=!0;}},t.prototype.createFloat32MatrixTexture=function(t,e){return this.throwIfDisposed(),Va(this.gl,this.debug,t,e,this.textureConfig);},t.prototype.createFloat16MatrixTexture=function(t,e){return this.throwIfDisposed(),Ga(this.gl,this.debug,t,e,this.textureConfig);},t.prototype.createUnsignedBytesMatrixTexture=function(t,e){return this.throwIfDisposed(),Ha(this.gl,this.debug,t,e,this.textureConfig);},t.prototype.uploadPixelDataToTexture=function(t,e){this.throwIfDisposed(),Xa(this.gl,this.debug,t,e);},t.prototype.uploadDenseMatrixToTexture=function(t,e,n,r){this.throwIfDisposed(),Ka(this.gl,this.debug,t,e,n,r,this.textureConfig);},t.prototype.createFloat16PackedMatrixTexture=function(t,e){return this.throwIfDisposed(),$a(this.gl,this.debug,t,e,this.textureConfig);},t.prototype.createPackedMatrixTexture=function(t,e){return this.throwIfDisposed(),qa(this.gl,this.debug,t,e,this.textureConfig);},t.prototype.deleteMatrixTexture=function(t){var e=this;this.throwIfDisposed(),this.outputTexture===t&&(pe(this.gl,this.debug,this.framebuffer),this.outputTexture=null),Vt(this.gl,this.debug,function(){return e.gl.deleteTexture(t);});},t.prototype.downloadByteEncodedFloatMatrixFromOutputTexture=function(t,e,n){var r=this;return this.downloadMatrixDriver(t,function(){return Ja(r.gl,r.debug,e,n,r.textureConfig);});},t.prototype.downloadPackedMatrixFromBuffer=function(t,e,n,r,o,a){return Za(this.gl,t,0,0,0,o,a,this.textureConfig);},t.prototype.downloadFloat32MatrixFromBuffer=function(t,e){return Qa(this.gl,t,e);},t.prototype.createBufferFromTexture=function(t,e,n){this.bindTextureToFrameBuffer(t);var r=Ya(this.gl,this.debug,e,n,this.textureConfig);return this.unbindTextureToFrameBuffer(),r;},t.prototype.createAndWaitForFence=function(){var t=this.createFence(this.gl);return this.pollFence(t);},t.prototype.createFence=function(t){var e,n,r=this;if(i.getBool("WEBGL_FENCE_API_ENABLED")){var o=t,a=o.fenceSync(o.SYNC_GPU_COMMANDS_COMPLETE,0);t.flush(),n=function n(){var t=o.clientWaitSync(a,0,0);return t===o.ALREADY_SIGNALED||t===o.CONDITION_SATISFIED;},e=a;}else i.getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")>0?(e=this.beginQuery(),this.endQuery(),n=function n(){return r.isQueryAvailable(e,i.getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION"));}):n=function n(){return !0;};return {query:e,isFencePassed:n};},t.prototype.downloadMatrixFromPackedTexture=function(t,e,n){var r=this;return this.downloadMatrixDriver(t,function(){return ti(r.gl,r.debug,e,n);});},t.prototype.createProgram=function(t){this.throwIfDisposed();var e=this.gl,n=Xt(e,this.debug,t),r=La(e,this.debug),o=Zt(e,this.debug);return Vt(e,this.debug,function(){return e.attachShader(o,r);}),Vt(e,this.debug,function(){return e.attachShader(o,n);}),te(e,this.debug,o),this.debug&&ee(e,this.debug,o),this.vertexAttrsAreBound||(this.setProgram(o),this.vertexAttrsAreBound=ja(e,this.debug,this.program,this.vertexBuffer)),o;},t.prototype.deleteProgram=function(t){var e=this;this.throwIfDisposed(),t===this.program&&(this.program=null),null!=t&&Vt(this.gl,this.debug,function(){return e.gl.deleteProgram(t);});},t.prototype.setProgram=function(t){var e=this;this.throwIfDisposed(),this.program=t,null!=this.program&&this.debug&&ee(this.gl,this.debug,this.program),Vt(this.gl,this.debug,function(){return e.gl.useProgram(t);});},t.prototype.getUniformLocation=function(t,e,n){return void 0===n&&(n=!0),this.throwIfDisposed(),n?le(this.gl,this.debug,t,e):ce(this.gl,t,e);},t.prototype.getAttributeLocation=function(t,e){var n=this;return this.throwIfDisposed(),Vt(this.gl,this.debug,function(){return n.gl.getAttribLocation(t,e);});},t.prototype.getUniformLocationNoThrow=function(t,e){return this.throwIfDisposed(),this.gl.getUniformLocation(t,e);},t.prototype.setInputMatrixTexture=function(t,e,n){this.throwIfDisposed(),this.throwIfNoProgram(),he(this.gl,this.debug,this.program,t,e,n);},t.prototype.setOutputMatrixTexture=function(t,e,n){this.setOutputMatrixTextureDriver(t,n,e);},t.prototype.setOutputPackedMatrixTexture=function(t,e,n){this.throwIfDisposed();var r=Ut(e,n),o=r[0],a=r[1];this.setOutputMatrixTextureDriver(t,o,a);},t.prototype.setOutputMatrixWriteRegion=function(t,e,n,r){this.setOutputMatrixWriteRegionDriver(n,t,r,e);},t.prototype.setOutputPackedMatrixWriteRegion=function(t,e,n,r){throw new Error("setOutputPackedMatrixWriteRegion not implemented.");},t.prototype.debugValidate=function(){null!=this.program&&ee(this.gl,this.debug,this.program),de(this.gl);},t.prototype.executeProgram=function(){this.throwIfDisposed(),this.throwIfNoProgram();var t=this.gl;this.debug&&this.debugValidate(),Vt(t,this.debug,function(){return t.drawElements(t.TRIANGLES,6,t.UNSIGNED_SHORT,0);});},t.prototype.blockUntilAllProgramsCompleted=function(){var t=this;this.throwIfDisposed(),Vt(this.gl,this.debug,function(){return t.gl.finish();});},t.prototype.getQueryTimerExtension=function(){return null==this.disjointQueryTimerExtension&&(this.disjointQueryTimerExtension=jt(this.gl,this.debug,2===i.getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")?"EXT_disjoint_timer_query_webgl2":"EXT_disjoint_timer_query")),this.disjointQueryTimerExtension;},t.prototype.getQueryTimerExtensionWebGL2=function(){return this.getQueryTimerExtension();},t.prototype.getQueryTimerExtensionWebGL1=function(){return this.getQueryTimerExtension();},t.prototype.beginQuery=function(){if(2===i.getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")){var t=this.gl,e=this.getQueryTimerExtensionWebGL2(),n=t.createQuery();return t.beginQuery(e.TIME_ELAPSED_EXT,n),n;}var r=this.getQueryTimerExtensionWebGL1(),o=r.createQueryEXT();return r.beginQueryEXT(r.TIME_ELAPSED_EXT,o),o;},t.prototype.endQuery=function(){if(2!==i.getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")){var t=this.getQueryTimerExtensionWebGL1();t.endQueryEXT(t.TIME_ELAPSED_EXT);}else{var e=this.gl,n=this.getQueryTimerExtensionWebGL2();e.endQuery(n.TIME_ELAPSED_EXT);}},t.prototype.waitForQueryAndGetTime=function(t){return n(this,void 0,void 0,function(){var e=this;return r(this,function(n){switch(n.label){case 0:return [4,E(function(){return e.disposed||e.isQueryAvailable(t,i.getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION"));})];case 1:return n.sent(),[2,this.getQueryTime(t,i.getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION"))];}});});},t.prototype.getQueryTime=function(t,e){if(0===e)return null;if(2===e){var n=this.gl;return n.getQueryParameter(t,n.QUERY_RESULT)/1e6;}var r=this.getQueryTimerExtensionWebGL1();return r.getQueryObjectEXT(t,r.QUERY_RESULT_EXT)/1e6;},t.prototype.isQueryAvailable=function(t,e){if(0===e)return !0;if(2===e){var n=this.gl,r=this.getQueryTimerExtensionWebGL2(),o=n.getQueryParameter(t,n.QUERY_RESULT_AVAILABLE);return null==this.disjoint&&(this.disjoint=this.gl.getParameter(r.GPU_DISJOINT_EXT)),o&&!this.disjoint;}o=(r=this.getQueryTimerExtensionWebGL1()).getQueryObjectEXT(t,r.QUERY_RESULT_AVAILABLE_EXT);return null==this.disjoint&&(this.disjoint=this.gl.getParameter(r.GPU_DISJOINT_EXT)),o&&!this.disjoint;},t.prototype.pollFence=function(t){var e=this;return new Promise(function(n){e.addItemToPoll(function(){return t.isFencePassed();},function(){return n();});});},t.prototype.pollItems=function(){for(var t=function(t){for(var e=0;e<t.length;++e){var n=t[e]();if(!n)break;}return e-1;}(this.itemsToPoll.map(function(t){return t.isDoneFn;})),e=0;e<=t;++e){(0, this.itemsToPoll[e].resolveFn)();}this.itemsToPoll=this.itemsToPoll.slice(t+1);},t.prototype.addItemToPoll=function(t,e){var n=this;this.itemsToPoll.push({isDoneFn:t,resolveFn:e}),this.itemsToPoll.length>1||E(function(){return n.pollItems(),0===n.itemsToPoll.length;});},t.prototype.bindTextureToFrameBuffer=function(t){this.throwIfDisposed(),fe(this.gl,this.debug,t,this.framebuffer),this.debug&&de(this.gl);},t.prototype.unbindTextureToFrameBuffer=function(){null!=this.outputTexture?(fe(this.gl,this.debug,this.outputTexture,this.framebuffer),this.debug&&de(this.gl)):pe(this.gl,this.debug,this.framebuffer);},t.prototype.downloadMatrixDriver=function(t,e){this.bindTextureToFrameBuffer(t);var n=e();return this.unbindTextureToFrameBuffer(),n;},t.prototype.setOutputMatrixTextureDriver=function(t,e,n){this.throwIfDisposed();var r=this.gl;fe(r,this.debug,t,this.framebuffer),this.debug&&de(r),this.outputTexture=t,Vt(r,this.debug,function(){return r.viewport(0,0,e,n);}),Vt(r,this.debug,function(){return r.scissor(0,0,e,n);});},t.prototype.setOutputMatrixWriteRegionDriver=function(t,e,n,r){var o=this;this.throwIfDisposed(),Vt(this.gl,this.debug,function(){return o.gl.scissor(t,e,n,r);});},t.prototype.throwIfDisposed=function(){if(this.disposed)throw new Error("Attempted to use disposed GPGPUContext.");},t.prototype.throwIfNoProgram=function(){if(null==this.program)throw new Error("No GPU program is currently set.");},t;}();function ri(t,e){if(t.length!==e.length)throw Error("Binary was compiled with "+t.length+" inputs, but was executed with "+e.length+" inputs");t.forEach(function(t,n){var r=t.logicalShape,o=e[n],a=o.shape;if(!y(r,a))throw Error("Binary was compiled with different shapes than the current args. Shapes "+r+" and "+a+" must match");if(!t.isUniform||!o.isUniform){var i=t.texShape,s=o.isUniform?null:o.texData.texShape;if(!y(i,s))throw Error("Binary was compiled with different texture shapes than the current args. Shape "+i+" and "+s+" must match");}});}var oi=function(){return function(t,e,n){this.variableNames=["A"],this.usesPackedTextures=!0,this.outputShape=t;for(var r=n.filterWidth,o=n.inChannels,a=n.strideWidth,i=n.strideHeight,s=n.padInfo,u=n.outWidth,l=n.dilationWidth,c=n.dilationHeight,h=s.left,f=s.top,p=o*r,d=Do(),v="",m=0;m<=1;m++){for(var g=0;g<=1;g++){v+="\n          blockIndex = rc.y + "+g+";\n          pos = rc.x + "+m+";\n          \n          if(blockIndex < "+t[1]+" && pos < "+t[0]+") {\n            offsetY = int(blockIndex / ("+u+")) * "+i+" - "+f+";\n            d0 = offsetY + "+c+" * (pos / "+p+");\n  \n            if(d0 < "+e[0]+" && d0 >= 0) {\n              offsetX = int(mod(float(blockIndex), "+u+".) * "+a+". - "+h+".);\n              d1 = offsetX + "+l+" * (int(mod(float(pos), "+p+".) / "+o+".));\n    \n              if(d1 < "+e[1]+" && d1 >= 0) {\n                innerDims = vec2(d1, int(mod(float(pos), "+o+".)));\n                result["+(2*m+g)+"] = getChannel(getA(d0, int(innerDims.x),\n                                                  int(innerDims.y)), innerDims);\n              }\n            }\n  \n          }\n        ";}}this.userCode="\n      void main() {\n        ivec2 rc = getOutputCoords();\n\n        vec4 result = vec4(0);\n\n        int blockIndex, pos, offsetY, d0, offsetX, d1;\n        vec2 innerDims;\n\n        "+v+"\n\n        "+d.output+" = result;\n      }\n    ";};}(),ai=function(){return function(t,e,n,r,o){this.variableNames=["x"],this.outputShape=[];var a,i=e,s=t[3]-1;this.outputShape=t;var u="float("+n+") + float("+r+") * sum";a=.5===o?"inversesqrt("+u+")":1===o?"1.0/("+u+")":"exp(log("+u+") * float(-"+o+"));",this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int r = coords[1];\n        int c = coords[2];\n        int d = coords[3];\n        float x = getX(b, r, c, d);\n        float sum = 0.0;\n        for (int j = -"+i+"; j <= "+i+"; j++) {\n          int idx = d + j;\n          if (idx >= 0 && idx <=  "+s+") {\n            float z = getX(b, r, c, idx);\n            sum += z * z;\n          }\n        }\n        float val = x * "+a+";\n        setOutput(val);\n      }\n    ";};}(),ii=function(){return function(t,e,n,r,o){this.variableNames=["inputImage","outputImage","dy"],this.outputShape=[],this.outputShape=t,this.depth=t[3],this.depthRadius=e,this.bias=n,this.alpha=r,this.beta=o,this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int r = coords[1];\n        int c = coords[2];\n\n        float result = 0.0;\n        for (int d = 0; d < "+this.depth+"; ++d) {\n          int depthBegin = int(max(0.0, float(d - "+e+")));\n          int depthEnd = int(min(float("+this.depth+"),\n              float(d + "+e+" + 1)));\n\n          const int MIN_DEPTH_BEGIN = 0;\n          const int MAX_DEPTH_END = "+this.depth+";\n\n          float norm = 0.0;\n          for (int k = MIN_DEPTH_BEGIN; k < MAX_DEPTH_END; ++k) {\n            if (k < depthBegin){\n              continue;\n            }\n            else if (k >= depthBegin && k < depthEnd) {\n              norm += getInputImage(b, r, c, k) * getInputImage(b, r, c, k);\n            }\n            else {\n              break;\n            }\n          }\n\n          norm = float("+r+") * norm + float("+n+");\n\n          for(int k = MIN_DEPTH_BEGIN; k < MAX_DEPTH_END; ++k){\n            if (k < depthBegin){\n              continue;\n            }\n            else if (k >= depthBegin && k < depthEnd){\n              float dyi = -2.0 * float("+r+")\n                * float("+o+")\n                * getInputImage(b ,r ,c, k) * getOutputImage(b, r, c, d)\n                / norm;\n              if (k == d) {\n                dyi += pow(norm, -1.0 * "+o+");\n              }\n              if (k == coords[3]) {\n                dyi *= getDy(b, r, c, d);\n                result += dyi;\n              }\n            }\n            else {\n              break;\n            }\n          }\n      }\n      setOutput(result);\n      }\n    ";};}(),si=function(){return function(t,e,n,r,o){this.variableNames=["x"],this.outputShape=[],this.usesPackedTextures=!0;var a,i=e,s=t[3]-1;this.outputShape=t;var u="float("+n+") + float("+r+") * sum";a=.5===o?"inversesqrt("+u+")":1===o?"1.0/("+u+")":"exp(log("+u+") * float(-"+o+"));",this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords.x;\n        int r = coords.y;\n        int c = coords.z;\n        int d = coords.w;\n\n        bool hasNextCol = d < "+this.outputShape[3]+";\n        bool hasNextRow = c < "+this.outputShape[2]+";\n\n        vec4 sum = vec4(0.);\n        vec4 xFragAtOutputCoords = getX(b, r, c, d);\n\n        vec4 xAtOutputCoords = vec4(\n          getChannel(xFragAtOutputCoords, vec2(c, d)),\n          hasNextCol ?\n            getChannel(xFragAtOutputCoords, vec2(c, d + 1)) : 0.0,\n          hasNextRow ?\n            getChannel(xFragAtOutputCoords , vec2(c + 1, d)) : 0.0,\n          (hasNextRow && hasNextCol) ?\n            getChannel(xFragAtOutputCoords, vec2(c + 1, d + 1)) : 0.0\n        );\n\n        int firstChannel = d - "+i+";\n        vec2 cache = vec2(0.);\n        if(firstChannel >= 0){\n          vec4 firstChannelFrag = getX(b, r, c, firstChannel);\n          cache.x = getChannel(firstChannelFrag, vec2(c, firstChannel));\n            if(hasNextRow){\n              cache.y = getChannel(firstChannelFrag, vec2(c + 1, firstChannel));\n            }\n        }\n\n        ivec2 depth = ivec2(d, d + 1);\n        for (int j = - "+i+"; j <= "+i+"; j++) {\n          ivec2 idx = depth + j;\n          bvec2 aboveLowerBound = greaterThanEqual(idx, ivec2(0));\n          bvec2 belowUpperBound = lessThanEqual(idx, ivec2("+s+"));\n\n          bool depthInRange = aboveLowerBound.x && belowUpperBound.x;\n          bool depthPlusOneInRange = aboveLowerBound.y && belowUpperBound.y;\n\n          if(depthInRange || depthPlusOneInRange){\n            vec4 z = vec4(0.);\n            vec4 xFragAtCurrentDepth;\n            z.xz = cache.xy;\n            if(depthPlusOneInRange && hasNextCol){\n              xFragAtCurrentDepth = idx.y != d ?\n                getX(b, r, c, idx.y) : xFragAtOutputCoords;\n              z.y = getChannel(xFragAtCurrentDepth, vec2(c, idx.y));\n              if(hasNextRow){\n                z.w = getChannel(xFragAtCurrentDepth, vec2(c + 1, idx.y));\n              }\n            }\n            cache.xy = z.yw;\n            sum += z * z;\n          }\n        }\n        vec4 result = xAtOutputCoords * "+a+";\n        setOutput(result);\n      }\n    ";};}(),ui=function(){return function(t){this.variableNames=["dy","maxPos"],this.outputShape=t.inShape;var e=t.strideHeight,n=t.strideWidth,r=t.dilationHeight,o=t.effectiveFilterHeight,a=t.effectiveFilterWidth,i=o-1-t.padInfo.top,s=a-1-t.padInfo.left,u=o*a-1;this.userCode="\n      const ivec2 pads = ivec2("+i+", "+s+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n\n        ivec2 dyRCCorner = coords.yz - pads;\n        int dyRCorner = dyRCCorner.x;\n        int dyCCorner = dyRCCorner.y;\n\n        // Convolve dy(?, ?, d) with pos mask(:, :, d) to get dx(xR, xC, d).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n        for (int wR = 0; wR < "+o+";\n          wR += "+r+") {\n          float dyR = float(dyRCorner + wR) / "+e+".0;\n\n          if (dyR < 0.0 || dyR >= "+t.outHeight+".0 || fract(dyR) > 0.0) {\n            continue;\n          }\n          int idyR = int(dyR);\n\n          for (int wC = 0; wC < "+a+"; wC++) {\n            float dyC = float(dyCCorner + wC) / "+n+".0;\n\n            if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                fract(dyC) > 0.0) {\n              continue;\n            }\n            int idyC = int(dyC);\n\n            float dyValue = getDy(b, idyR, idyC, d);\n            int maxPosValue = "+u+" - int(getMaxPos(b, idyR, idyC, d));\n\n            // Get the current value, check it against the value from the\n            // position matrix.\n            int curPosValue = wR * "+a+" + wC;\n            float mask = float(maxPosValue == curPosValue ? 1.0 : 0.0);\n\n            dotProd += dyValue * mask;\n          }\n        }\n        setOutput(dotProd);\n      }\n    ";};}(),li=function(){return function(t,e,n,r,o,a){void 0===n&&(n=!1),void 0===r&&(r=!1),void 0===o&&(o=!1),void 0===a&&(a=null),this.variableNames=["matrixA","matrixB"],this.usesPackedTextures=!0,this.outputShape=e;var i=n?t[1]:t[2],s=Math.ceil(i/2),u=n?"i * 2, rc.y":"rc.y, i * 2",l=r?"rc.z, i * 2":"i * 2, rc.z",c=n?["a.xxyy","a.zzww"]:["a.xxzz","a.yyww"],h=r?["b.xzxz","b.ywyw"]:["b.xyxy","b.zwzw"],f="",p="";a&&(f="vec4 activation(vec4 x) {\n        "+a+"\n      }",p="result = activation(result);");var d=o?"result += getBiasAtOutCoords();":"";o&&this.variableNames.push("bias"),this.userCode="\n      "+f+"\n\n      const float sharedDimension = "+s+".0;\n\n      vec4 dot2x2ARowBCol(ivec3 rc) {\n        vec4 result = vec4(0);\n        for (int i = 0; i < "+s+"; i++) {\n          vec4 a = getMatrixA(rc.x, "+u+");\n          vec4 b = getMatrixB(rc.x, "+l+");\n\n          // These swizzled products need to be separately added.\n          // See: https://github.com/tensorflow/tfjs/issues/1735\n          result += ("+c[0]+" * "+h[0]+");\n          result += ("+c[1]+" * "+h[1]+");\n        }\n        return result;\n      }\n\n      void main() {\n        ivec3 rc = getOutputCoords();\n        vec4 result = dot2x2ARowBCol(rc);\n\n        "+d+"\n\n        "+p+"\n\n        setOutput(result);\n      }\n    ";};}(),ci=function(){function t(t,e,n){this.variableNames=["probs"],this.outputShape=[t,n],this.userCode="\n      uniform float seed;\n\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int batch = coords[0];\n\n        float r = random(seed);\n        float cdf = 0.0;\n\n        for (int i = 0; i < "+(e-1)+"; i++) {\n          cdf += getProbs(batch, i);\n\n          if (r < cdf) {\n            setOutput(float(i));\n            return;\n          }\n        }\n\n        // If no other event happened, last event happened.\n        setOutput(float("+(e-1)+"));\n      }\n    ";}return t.prototype.getCustomSetupFunc=function(t){var e=this;return function(n,r){null==e.seedLoc&&(e.seedLoc=n.getUniformLocation(r,"seed")),n.gl.uniform1f(e.seedLoc,t);};},t;}(),hi=function(){return function(t,e,n,r){this.variableNames=["indices"],this.outputShape=[t,e],this.userCode="\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int index = round(getIndices(coords.x));\n        setOutput(mix(float("+r+"), float("+n+"),\n                      float(index == coords.y)));\n      }\n    ";};}(),fi=function(){return function(t){this.variableNames=["A"],this.outputShape=t;var e=t.length;if(0===e)this.userCode="\n        void main() {\n          setOutput(vec4(getA(), 0., 0., 0.));\n        }\n      ";else{var n=To("rc",e),r=Ho(e),o=function(t,e,n){if(1===t)return "rc > "+e[0];for(var r="",o=t-2;o<t;o++){r+=n[o]+" >= "+e[o],o<t-1&&(r+="||");}return r;}(e,t,n),a=function(t,e,n,r){if(1===t)return "";var o=r.slice(-2);return "\n    int r = "+o[0]+";\n    int c = "+o[1]+";\n    int rp1 = r + 1;\n    int cp1 = c + 1;\n\n    bool cEdge = cp1 >= "+e+";\n    bool rEdge = rp1 >= "+n+";\n  ";}(e,t[t.length-1],t[t.length-2],n),i=function(t,e){var n=t.length,r=function(t,e){for(var n=[],r=0;r<=1;r++){for(var o=0;o<=1;o++){for(var a=(0===r?"r":"rp1")+", "+(0===o?"c":"cp1"),i=2;i<t;i++){a=e[e.length-1-i]+","+a;}n.push(a);}}return n;}(n,e);return 1===n?"getA(rc),\n            rc + 1 >= "+t[0]+" ? 0. : getA(rc + 1),\n            0, 0":"getA("+r[0]+"),\n          cEdge ? 0. : getA("+r[1]+"),\n          rEdge ? 0. : getA("+r[2]+"),\n          rEdge || cEdge ? 0. : getA("+r[3]+")";}(t,n);this.userCode="\n        void main() {\n          "+r+" rc = getOutputCoords();\n\n          if("+o+") {\n            setOutput(vec4(0));\n          } else {\n            "+a+"\n\n            setOutput(vec4("+i+"));\n          }\n        }\n      ";}};}();var pi=function(){return function(t,e,n){this.variableNames=["x"],this.outputShape=e.map(function(e,n){return e[0]+t[n]+e[1];});var r=t.length,o=Ho(r),a=e.map(function(t){return t[0];}).join(","),i=e.map(function(e,n){return e[0]+t[n];}).join(","),s=["coords[0]","coords[1]","coords[2]","coords[3]"].slice(0,r);this.userCode=1!==r?"\n      "+o+" start = "+o+"("+a+");\n      "+o+" end = "+o+"("+i+");\n\n      void main() {\n        "+o+" outC = getOutputCoords();\n        if (any(lessThan(outC, start)) || any(greaterThanEqual(outC, end))) {\n          setOutput(float("+n+"));\n        } else {\n          "+o+" coords = outC - start;\n          setOutput(getX("+s+"));\n        }\n      }\n    ":"\n        int start = "+a+";\n        int end = "+i+";\n\n        void main() {\n          int outC = getOutputCoords();\n          if (outC < start || outC >= end) {\n            setOutput(float("+n+"));\n          } else {\n            setOutput(getX(outC - start));\n          }\n        }\n      ";};}(),di=function(){return function(t,e,n){this.variableNames=["x"],this.usesPackedTextures=!0,this.outputShape=e.map(function(e,n){return e[0]+t[n]+e[1];});for(var r=t.length,o=Ho(r),a=e.map(function(t){return t[0];}).join(","),i=e.map(function(e,n){return e[0]+t[n];}).join(","),s=To("rc",r),u=To("source",r),l=s[r-1]+" < "+this.outputShape[r-1],c=1===r?"source":"vec2("+u.slice(-2).join()+")",h=[o+" rc = outputLoc;",s[r-1]+" += 1;\n       if("+l+") {\n      ",1===r?"":"}\n       rc = outputLoc;\n       "+s[r-2]+" += 1;\n       if("+s[r-2]+" < "+this.outputShape[r-2]+") {",1===r?"":"  "+s[r-1]+" += 1;\n         if("+l+") {"],f=1===r?"rc < start || rc >= end":"any(lessThan(rc, start)) || any(greaterThanEqual(rc, end))",p="",d=0,v=1===r?2:4;d<v;d++){p+="\n        "+h[d]+"\n        if ("+f+") {\n          result["+d+"] = float("+n+");\n        } else {\n          "+o+" source = rc - start;\n          result["+d+"] = getChannel(getX("+u.join()+"), "+c+");\n        }\n      ";}p+=1===r?"} ":"}}",this.userCode="\n      const "+o+" start = "+o+"("+a+");\n      const "+o+" end = "+o+"("+i+");\n\n      void main() {\n        "+o+" outputLoc = getOutputCoords();\n        vec4 result = vec4(0.);\n        "+p+"\n        setOutput(result);\n      }\n    ";};}(),vi=function(){return function(t,e,n){if(this.variableNames=["x"],"avg"===e&&n)throw new Error("Cannot compute positions for average pool.");var r=t.filterWidth,o=t.strideHeight,a=t.strideWidth,i=t.dilationHeight,s=t.dilationWidth,u=t.effectiveFilterHeight,l=t.effectiveFilterWidth,c=t.padInfo.top,h=t.padInfo.left;this.outputShape=t.outShape;var f="avg"===e,p="0.0";if(f||(p="-1.0 / 1e-20"),n)this.userCode="\n        const ivec2 strides = ivec2("+o+", "+a+");\n        const ivec2 pads = ivec2("+c+", "+h+");\n\n        void main() {\n          ivec4 coords = getOutputCoords();\n          int batch = coords[0];\n          int d = coords[3];\n\n          ivec2 xRCCorner = coords.yz * strides - pads;\n          int xRCorner = xRCCorner.x;\n          int xCCorner = xRCCorner.y;\n\n          // max/min x(?, ?, d) to get y(yR, yC, d).\n          // ? = to be determined\n          float minMaxValue = 0.0;\n          float minMaxValueFound = 0.0;\n          int minMaxPosition = 0;\n          float avgValue = 0.0;\n\n          for (int wR = 0; wR < "+u+";\n              wR += "+i+") {\n            int xR = xRCorner + wR;\n\n            if (xR < 0 || xR >= "+t.inHeight+") {\n              continue;\n            }\n\n            for (int wC = 0; wC < "+l+";\n                wC += "+s+") {\n              int xC = xCCorner + wC;\n\n              if (xC < 0 || xC >= "+t.inWidth+") {\n                continue;\n              }\n\n              float value = getX(batch, xR, xC, d);\n\n              // If a min / max value has already been found, use it. If not,\n              // use the current value.\n              float currMinMaxValue = mix(\n                  value, minMaxValue, minMaxValueFound);\n              if (value >= currMinMaxValue) {\n                minMaxValue = value;\n                minMaxValueFound = 1.0;\n                minMaxPosition = wR * "+l+" + wC;\n              }\n            }\n          }\n          setOutput(float(minMaxPosition));\n        }\n      ";else{var d=e+"("+e+"("+e+"(minMaxValue[0], minMaxValue[1]), minMaxValue[2]), minMaxValue[3])";"avg"===e&&(d="avgValue / count");var v=4*Math.floor(r/4),m=r%4,g="\n      if ("+f+") {\n        avgValue += dot(values, ones);\n      } else {\n        minMaxValue = max(values, minMaxValue);\n      }\n    ";this.userCode="\n      const ivec2 strides = ivec2("+o+", "+a+");\n      const ivec2 pads = ivec2("+c+", "+h+");\n      const float initializationValue = "+p+";\n      const vec4 ones = vec4(1.0, 1.0, 1.0, 1.0);\n\n      float count = 0.0;\n\n      float getValue(int batch, int xR, int xC, int d) {\n        if (xC < 0 || xC >= "+t.inWidth+") {\n          return initializationValue;\n        }\n        count += 1.0;\n        return getX(batch, xR, xC, d);\n      }\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int batch = coords[0];\n        int d = coords[3];\n\n        ivec2 xRCCorner = coords.yz * strides - pads;\n        int xRCorner = xRCCorner.x;\n        int xCCorner = xRCCorner.y;\n\n        // max/min x(?, ?, d) to get y(yR, yC, d).\n        // ? = to be determined\n        vec4 minMaxValue = vec4("+p+");\n        float avgValue = 0.0;\n        count = 0.0;\n\n        for (int wR = 0; wR < "+u+";\n            wR += "+i+") {\n          int xR = xRCorner + wR;\n\n          if (xR < 0 || xR >= "+t.inHeight+") {\n            continue;\n          }\n\n          for (int wC = 0; wC < "+v+"; wC += 4) {\n            int xC = xCCorner + wC * "+s+";\n\n            vec4 values = vec4(\n              getValue(batch, xR, xC, d),\n              getValue(batch, xR, xC + "+s+", d),\n              getValue(batch, xR, xC + 2 * "+s+", d),\n              getValue(batch, xR, xC + 3 * "+s+", d)\n            );\n\n            "+g+"\n          }\n\n          int xC = xCCorner + "+v+";\n          if ("+(1===m)+") {\n            vec4 values = vec4(\n              getValue(batch, xR, xC, d),\n              initializationValue,\n              initializationValue,\n              initializationValue\n            );\n\n            "+g+"\n          } else if ("+(2===m)+") {\n            vec4 values = vec4(\n              getValue(batch, xR, xC, d),\n              getValue(batch, xR, xC + "+s+", d),\n              initializationValue,\n              initializationValue\n            );\n\n            "+g+"\n          } else if ("+(3===m)+") {\n            vec4 values = vec4(\n              getValue(batch, xR, xC, d),\n              getValue(batch, xR, xC + "+s+", d),\n              getValue(batch, xR, xC + 2 * "+s+", d),\n              initializationValue\n            );\n\n            "+g+"\n          }\n        }\n        setOutput("+d+");\n      }\n    ";}};}(),mi=function(){return function(t,e){this.variableNames=["x"];var n=t.windowSize,r=t.batchSize,o=t.inSize,a=Math.ceil(o/n);this.outputShape=[r,a];var i="0.0",s="";"prod"===e?i="1.0":"min"===e?(i="1.0 / 1e-20",s="min"):"max"===e&&(i="-1.0 / 1e-20",s="max");var u=e+"("+e+"("+e+"(minMaxValue[0], minMaxValue[1]), minMaxValue[2]), minMaxValue[3])";"sum"===e?u="sumValue":"prod"===e?u="prodValue":"all"===e?u="allValue":"any"===e&&(u="anyValue");var l=4*Math.floor(n/4),c=n%4,h="\n      if ("+("sum"===e)+") {\n        sumValue += dot(values, ones);\n      } else if ("+("prod"===e)+") {\n        vec2 tmp = vec2(values[0], values[1]) * vec2(values[2], values[3]);\n        prodValue *= tmp[0] * tmp[1];\n      } else {\n        minMaxValue = "+s+"(values, minMaxValue);\n      }\n    ",f="vec4";"all"===e?(i="1.0",h="\n        bool reducedAllValue = all(values);\n        float floatedReducedAllValue = float(reducedAllValue);\n        allValue = float(allValue >= 1.0 && floatedReducedAllValue >= 1.0);\n      ",f="bvec4"):"any"===e&&(i="0.0",h="\n        bool reducedAnyValue = any(values);\n        float floatedReducedAnyValue = float(reducedAnyValue);\n        anyValue = float(anyValue >= 1.0 || floatedReducedAnyValue >= 1.0);\n      ",f="bvec4");var p="";o%n>0&&(p="\n        if (inIdx < 0 || inIdx >= "+o+") {\n          return initializationValue;\n        }\n      "),this.userCode="\n      const float initializationValue = "+i+";\n      const vec4 ones = vec4(1.0, 1.0, 1.0, 1.0);\n\n      float getValue(int batch, int inIdx) {\n        "+p+"\n        return getX(batch, inIdx);\n      }\n\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int batch = coords[0];\n        int outIdx = coords[1];\n        int inOffset = outIdx * "+n+";\n\n        vec4 minMaxValue = vec4("+i+");\n        float prodValue = 1.0;\n        float sumValue = 0.0;\n        float allValue = 1.0;\n        float anyValue = 0.0;\n\n        for (int i = 0; i < "+l+"; i += 4) {\n          int inIdx = inOffset + i;\n          "+f+" values = "+f+"(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            getValue(batch, inIdx + 2),\n            getValue(batch, inIdx + 3)\n          );\n\n          "+h+"\n        }\n\n        int inIdx = inOffset + "+l+";\n        if ("+(1===c)+") {\n          "+f+" values = "+f+"(\n            getValue(batch, inIdx),\n            initializationValue,\n            initializationValue,\n            initializationValue\n          );\n\n          "+h+"\n        } else if ("+(2===c)+") {\n          "+f+" values = "+f+"(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            initializationValue,\n            initializationValue\n          );\n\n          "+h+"\n        } else if ("+(3===c)+") {\n          "+f+" values = "+f+"(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            getValue(batch, inIdx + 2),\n            initializationValue\n          );\n\n          "+h+"\n        }\n        setOutput("+u+");\n      }\n    ";};}(),gi=function(){return function(t,e){this.variableNames=["A"],this.usesPackedTextures=!0,this.outputShape=t;for(var n="",r=0;r<4;r++){var o="thisRC = rc;";r%2==1&&(o+="thisRC.z += 1;"),r>1&&(o+="thisRC.y += 1;"),n+="\n        "+o+"\n        "+(r>0?"if(thisRC.y < rows && thisRC.z < cols){":"")+"\n          int flatIndex = getFlatIndex(thisRC);\n\n          ivec3 inputRC = inputCoordsFromReshapedOutCoords(flatIndex);\n          vec2 inputRCInnerDims = vec2(float(inputRC.y),float(inputRC.z));\n\n          result["+r+"] =\n            getChannel(getA(inputRC.x, inputRC.y, inputRC.z), inputRCInnerDims);\n        "+(r>0?"}":"")+"\n      ";}this.userCode="\n      \n    ivec3 inputCoordsFromReshapedOutCoords(int index) {\n      "+_o(["r","c","d"],e)+"\n      return ivec3(r, c, d);\n    }\n  \n      "+Oo(t)+"\n\n      void main() {\n        ivec3 rc = getOutputCoords();\n\n        vec4 result = vec4(0.);\n\n        ivec3 thisRC;\n        int rows = "+t[1]+";\n        int cols = "+t[2]+";\n\n        "+n+"\n\n        setOutput(result);\n      }\n    ";};}();var yi=function(){return function(t,e,n){this.variableNames=["dy"],this.outputShape=[],this.outputShape=e.shape;var r=e.shape,o=r[1],a=r[2],i=t.shape,s=i[1],u=i[2],l=[n&&s>1?o-1:o,n&&u>1?a-1:a],c=[n&&s>1?s-1:s,n&&u>1?u-1:u],h=l[0]/c[0],f=l[1]/c[1],p=1/h,d=1/f,v=2*Math.ceil(p)+2,m=2*Math.ceil(d)+2;this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n        int r = coords[1];\n        int c = coords[2];\n\n        float accumulator = 0.0;\n\n        const float heightScale = float("+h+");\n        const float widthScale = float("+f+");\n\n        const float invHeightScale = float("+p+");\n        const float invWidthScale = float("+d+");\n\n        const int winHeight = int("+v+");\n        const int winWidth = int("+m+");\n\n        // Compute bounds for where in dy we will look\n        float startRLerp = floor(float(r) * invHeightScale);\n        int startDyR = int(startRLerp - float(winHeight / 2));\n\n        float startCLerp = floor(float(c) * invWidthScale);\n        int startDyC = int(startCLerp - float(winWidth / 2));\n\n        // Loop over dy\n        for (int dyROffset = 0; dyROffset < winHeight; dyROffset++) {\n          int dyR = dyROffset + startDyR;\n\n          // Guard against the window exceeding the bounds of dy\n          if (dyR < 0 || dyR >= "+s+") {\n            continue;\n          }\n\n          for (int dyCOffset = 0; dyCOffset < winWidth; dyCOffset++) {\n            int dyC = dyCOffset + startDyC;\n\n            // Guard against the window exceeding the bounds of dy\n            if (dyC < 0 || dyC >= "+u+") {\n              continue;\n            }\n\n            float dxR = float(dyR) * heightScale;\n            int topDxRIndex = int(floor(dxR));\n            int bottomDxRIndex = int(min(ceil(dxR), "+(o-1)+".0));\n            float dxRLerp = dxR - float(topDxRIndex);\n            float inverseDxRLerp = 1.0 - dxRLerp;\n\n            float dxC = float(dyC) * widthScale;\n            int leftDxCIndex = int(floor(dxC));\n            int rightDxCIndex = int(min(ceil(dxC), "+(a-1)+".0));\n            float dxCLerp = dxC - float(leftDxCIndex);\n            float inverseDxCLerp = 1.0 - dxCLerp;\n\n            if (r == topDxRIndex && c == leftDxCIndex) {\n              // topLeft\n              accumulator +=\n                getDy(b, dyR, dyC, d) * inverseDxRLerp * inverseDxCLerp;\n            }\n\n            if (r == topDxRIndex && c == rightDxCIndex) {\n              // topRight\n              accumulator += getDy(b, dyR, dyC, d) * inverseDxRLerp * dxCLerp;\n            }\n\n            if (r == bottomDxRIndex && c == leftDxCIndex) {\n              // bottomLeft\n              accumulator += getDy(b, dyR, dyC, d) * dxRLerp * inverseDxCLerp;\n            }\n\n            if (r == bottomDxRIndex && c == rightDxCIndex) {\n              // bottomRight\n              accumulator += getDy(b, dyR, dyC, d) * dxRLerp * dxCLerp;\n            }\n          }\n        }\n        // End loop over dy\n\n        setOutput(accumulator);\n      }\n    ";};}(),xi=function(){return function(t,e,n,r){this.variableNames=["A"],this.outputShape=[];var o=t[0],a=t[1],i=t[2],s=t[3];this.outputShape=[o,e,n,s];var u=[r&&e>1?a-1:a,r&&n>1?i-1:i],l=[r&&e>1?e-1:e,r&&n>1?n-1:n];this.userCode="\n      const vec2 effectiveInputOverOutputRatioRC = vec2(\n          "+u[0]/l[0]+",\n          "+u[1]/l[1]+");\n      const vec2 inputShapeRC = vec2("+a+".0, "+i+".0);\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n        ivec2 yRC = coords.yz;\n\n        // Fractional source index.\n        vec2 sourceFracIndexRC = vec2(yRC) * effectiveInputOverOutputRatioRC;\n\n        // Compute the four integer indices.\n        ivec2 sourceFloorRC = ivec2(sourceFracIndexRC);\n        ivec2 sourceCeilRC = ivec2(\n          min(inputShapeRC - 1.0, ceil(sourceFracIndexRC)));\n\n        float topLeft = getA(b, sourceFloorRC.x, sourceFloorRC.y, d);\n        float bottomLeft = getA(b, sourceCeilRC.x, sourceFloorRC.y, d);\n        float topRight = getA(b, sourceFloorRC.x, sourceCeilRC.y, d);\n        float bottomRight = getA(b, sourceCeilRC.x, sourceCeilRC.y, d);\n\n        vec2 fracRC = sourceFracIndexRC - vec2(sourceFloorRC);\n\n        float top = topLeft + (topRight - topLeft) * fracRC.y;\n        float bottom = bottomLeft + (bottomRight - bottomLeft) * fracRC.y;\n        float newValue = top + (bottom - top) * fracRC.x;\n\n        setOutput(newValue);\n      }\n    ";};}(),bi=function(){return function(t,e,n,r){this.variableNames=["A"],this.usesPackedTextures=!0,this.outputShape=[];var o=t[0],a=t[1],i=t[2],s=t[3];this.outputShape=[o,e,n,s];var u=[r&&e>1?a-1:a,r&&n>1?i-1:i],l=[r&&e>1?e-1:e,r&&n>1?n-1:n];this.userCode="\n      const vec3 effectiveInputOverOutputRatioRC = vec3(\n          "+u[0]/l[0]+",\n          "+u[1]/l[1]+",\n          "+u[1]/l[1]+");\n      const vec3 inputShapeRC = vec3("+a+".0, "+i+".0,\n                                     "+i+".0);\n\n      float getAValue(int b, int r, int c, int d) {\n        return getChannel(getA(b, r, c, d), vec2(c, d));\n      }\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n        // Calculate values for next column in yRC.z.\n        ivec3 yRC = coords.yzz + ivec3(0, 0, 1);\n\n        // Fractional source index.\n        vec3 sourceFracIndexRC = vec3(yRC) * effectiveInputOverOutputRatioRC;\n\n        // Compute the four integer indices.\n        ivec3 sourceFloorRC = ivec3(sourceFracIndexRC);\n        ivec3 sourceCeilRC = ivec3(\n          min(inputShapeRC - 1.0, ceil(sourceFracIndexRC)));\n        \n        // Should we calculate next column and row elements in 2x2 packed cell.\n        bool hasNextCol = d < "+(s-1)+"; \n        bool hasNextRow = coords.z < "+(n-1)+";\n\n        // In parallel, construct four corners for all four components in\n        // packed 2x2 cell.\n        vec4 topLeft = vec4(\n          getAValue(b, sourceFloorRC.x, sourceFloorRC.y, d),\n          hasNextCol ? getAValue(b, sourceFloorRC.x, sourceFloorRC.y, d + 1)\n                     : 0.0,\n          hasNextRow ? getAValue(b, sourceFloorRC.x, sourceFloorRC.z, d)\n                     : 0.0,\n          (hasNextRow && hasNextCol) ?\n            getAValue(b, sourceFloorRC.x, sourceFloorRC.z, d + 1) : 0.0);\n\n        vec4 bottomLeft = vec4(\n          getAValue(b, sourceCeilRC.x, sourceFloorRC.y, d),\n          hasNextCol ? getAValue(b, sourceCeilRC.x, sourceFloorRC.y, d + 1)\n                     : 0.0,\n          hasNextRow ? getAValue(b, sourceCeilRC.x, sourceFloorRC.z, d)\n                     : 0.0,\n          (hasNextRow && hasNextCol) ?\n            getAValue(b, sourceCeilRC.x, sourceFloorRC.z, d + 1) : 0.0);\n\n        vec4 topRight = vec4(\n          getAValue(b, sourceFloorRC.x, sourceCeilRC.y, d),\n          hasNextCol ? getAValue(b, sourceFloorRC.x, sourceCeilRC.y, d + 1)\n                     : 0.0,\n          hasNextRow ? getAValue(b, sourceFloorRC.x, sourceCeilRC.z, d)\n                     : 0.0,\n          (hasNextRow && hasNextCol) ?\n            getAValue(b, sourceFloorRC.x, sourceCeilRC.z, d + 1) : 0.0);\n\n        vec4 bottomRight = vec4(\n          getAValue(b, sourceCeilRC.x, sourceCeilRC.y, d),\n          hasNextCol ? getAValue(b, sourceCeilRC.x, sourceCeilRC.y, d + 1)\n                     : 0.0,\n          hasNextRow ? getAValue(b, sourceCeilRC.x, sourceCeilRC.z, d)\n                     : 0.0,\n          (hasNextRow && hasNextCol) ?\n            getAValue(b, sourceCeilRC.x, sourceCeilRC.z, d + 1) : 0.0);\n\n        vec3 fracRC = sourceFracIndexRC - vec3(sourceFloorRC);\n\n        vec4 top = mix(topLeft, topRight, fracRC.yyzz);\n        vec4 bottom = mix(bottomLeft, bottomRight, fracRC.yyzz);\n        vec4 newValue = mix(top, bottom, fracRC.x);\n\n        setOutput(newValue);\n      }\n    ";};}(),wi=function(){return function(t,e,n){this.variableNames=["dy"],this.outputShape=[],this.outputShape=e.shape;var r=e.shape,o=r[1],a=r[2],i=t.shape,s=i[1],u=i[2],l=[n&&s>1?o-1:o,n&&u>1?a-1:a],c=[n&&s>1?s-1:s,n&&u>1?u-1:u],h=l[0]/c[0],f=l[1]/c[1],p=1/h,d=1/f,v=2*Math.ceil(p)+2,m=2*Math.ceil(d)+2;this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n        int r = coords[1];\n        int c = coords[2];\n\n        float accumulator = 0.0;\n\n        const float heightScale = float("+h+");\n        const float widthScale = float("+f+");\n\n        const float invHeightScale = float("+p+");\n        const float invWidthScale = float("+d+");\n\n        const int winHeight = int("+v+");\n        const int winWidth = int("+m+");\n\n        // Compute bounds for where in dy we will look\n        float startRLerp = floor(float(r) * invHeightScale);\n        int startDyR = int(floor(startRLerp - float(winHeight / 2)));\n\n        float startCLerp = floor(float(c) * invWidthScale);\n        int startDyC = int(floor(startCLerp - float(winWidth / 2)));\n\n        // Loop over dy\n        for (int dyROffset = 0; dyROffset < winHeight; dyROffset++) {\n          int dyR = dyROffset + startDyR;\n\n          // Guard against the window exceeding the bounds of dy\n          if (dyR < 0 || dyR >= "+s+") {\n            continue;\n          }\n\n          for (int dyCOffset = 0; dyCOffset < winWidth; dyCOffset++) {\n            int dyC = dyCOffset + startDyC;\n\n            // Guard against the window exceeding the bounds of dy\n            if (dyC < 0 || dyC >= "+u+") {\n              continue;\n            }\n\n            float sourceFracRow =\n              float("+l[0]+") *\n                (float(dyR) / float("+c[0]+"));\n\n            float sourceFracCol =\n                float("+l[1]+") *\n                  (float(dyC) / float("+c[1]+"));\n\n            int sourceNearestRow = int(min(\n                float(int("+o+") - 1),\n                "+n+" ? float(round(sourceFracRow)) :\n                                  float(floor(sourceFracRow))));\n\n            int sourceNearestCol = int(min(\n                float(int("+a+") - 1),\n                "+n+" ? float(round(sourceFracCol)) :\n                                  float(floor(sourceFracCol))));\n\n            if (r == sourceNearestRow && c == sourceNearestCol) {\n              accumulator += getDy(b, dyR, dyC, d);\n            }\n          }\n        }\n        // End loop over dy\n\n        setOutput(accumulator);\n      }\n    ";};}(),Ci=function(){return function(t,e,n,r){this.variableNames=["A"],this.outputShape=[];var o=t[0],a=t[1],i=t[2],s=t[3];this.outputShape=[o,e,n,s];var u=[r&&e>1?a-1:a,r&&n>1?i-1:i],l=[r&&e>1?e-1:e,r&&n>1?n-1:n],c=r?"0.5":"0.0";this.userCode="\n      const vec2 effectiveInputOverOutputRatioRC = vec2(\n          "+u[0]/l[0]+",\n          "+u[1]/l[1]+");\n      const vec2 inputShapeRC = vec2("+a+".0, "+i+".0);\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n        ivec2 yRC = coords.yz;\n\n        // Fractional source index.\n        vec2 sourceFracIndexRC = vec2(yRC) * effectiveInputOverOutputRatioRC;\n\n        // Compute the coordinators of nearest neighbor point.\n        ivec2 sourceNearestRC = ivec2(\n          min(inputShapeRC - 1.0, floor(sourceFracIndexRC + "+c+")));\n\n        float newValue = getA(b, sourceNearestRC.x, sourceNearestRC.y, d);\n\n        setOutput(newValue);\n      }\n    ";};}(),Ei=function(){return function(t,e){this.variableNames=["x"];var n=t.length;if(n>4)throw new Error("WebGL backend: Reverse of rank-"+n+" tensor is not yet supported");if(this.outputShape=t,1!==n){var r=t.map(function(n,r){return function(n){return -1!==e.indexOf(n)&&1!==t[n]?t[n]+" - coords["+n+"] - 1":"coords["+n+"]";}(r);}).join(","),o=Ho(n);this.userCode="\n      void main() {\n        "+o+" coords = getOutputCoords();\n        setOutput(getX("+r+"));\n      }\n    ";}else this.userCode="\n        void main() {\n          int coord = getOutputCoords();\n          setOutput(getX("+t[0]+" - coord - 1));\n        }\n      ";};}(),Ri=function(){return function(t,e){this.variableNames=["x"],this.usesPackedTextures=!0;var n=t.length;if(n>4)throw new Error("WebGL backend: Reverse of rank-"+n+" tensor is not yet supported");this.outputShape=t;var r=To("rc",n),o=r[n-1]+" + 1 < "+this.outputShape[n-1],a=r[n-2]+" + 1 < "+this.outputShape[n-2],i=Ho(n);function s(n){var r=t.map(function(r,o){return function(n,r){return -1!==e.indexOf(n)&&1!==t[n]?t[n]+" - "+r[n]+" - 1":""+r[n];}(o,n);});return "getChannel(getX("+r.join(",")+"), vec2("+r.slice(-2).join(",")+"))";}this.userCode=1===n?"\n        void main(){\n          int rc = getOutputCoords();\n          vec4 result = vec4(0.);\n          result.r = getChannel(getX("+t[0]+" - rc - 1),\n            "+t[0]+" - rc - 1);\n          if("+o+"){\n              result.g = getChannel(getX("+t[0]+" - (rc  + 1) - 1),\n                "+t[0]+" - (rc  + 1) - 1);\n          }\n          setOutput(result);\n        }\n      ":"\n        void main() {\n          "+i+" rc = getOutputCoords();\n          vec4 result = vec4(0.);\n          result.r = "+function(t){return s(t);}(r.slice())+";\n          if("+o+"){\n            result.g = "+function(t){return t[n-1]="("+t[n-1]+" + 1)",s(t);}(r.slice())+";\n          }\n          if("+a+") {\n            result.b = "+function(t){return t[n-2]="("+t[n-2]+" + 1)",s(t);}(r.slice())+";\n            if("+o+") {\n              result.a = "+function(t){return t[n-1]="("+t[n-1]+" + 1)",t[n-2]="("+t[n-2]+" + 1)",s(t);}(r.slice())+";\n            }\n          }\n          setOutput(result);\n        }\n    ";};}(),Ii=function(){return function(t,e,n,r,o,a,i){void 0===i&&(i=!0),this.variableNames=["updates","indices","defaultValue"],this.outputShape=a;var s=Ho(o.length),u=Ho(a.length),l="";1===n?l="i":2===n&&(l="i, j");var c="getIndices("+l+")",h="";1===r?h="i":2===r&&(h="i, coords[1]");var f="getUpdates("+h+")",p=e>1?"strides[j]":"strides";this.userCode="\n        "+s+" strides = "+s+"("+o+");\n\n        void main() {\n          "+u+" coords = getOutputCoords();\n          float sum = 0.0;\n          bool found = false;\n          for (int i = 0; i < "+t+"; i++) {\n            int flattenedIndex = 0;\n            for (int j = 0; j < "+e+"; j++) {\n              int index = round("+c+");\n              flattenedIndex += index * "+p+";\n            }\n            if (flattenedIndex == coords[0]) {\n              sum += "+f+";\n              found = true;\n            }\n          }\n          setOutput(mix(getDefaultValue(), sum, float(found)));\n        }\n      ";};}(),Si=function(){return function(t,e){this.variableNames=["x","segmentIds"];var n=t.windowSize,r=t.batchSize,o=t.inSize,a=t.numSegments,i=a*Math.ceil(o/n);this.outputShape=[r,i];var s=4*Math.floor(n/4),u=n%4,l="\n        sumValue += dot(values, segFilter);\n    ",c="";o%n>0&&(c="\n        if (inIdx < 0 || inIdx >= "+o+") {\n          return initializationValue;\n        }\n      ");var h="";o%n>0&&(h="\n        if (inIdx < 0 || inIdx >= "+o+") {\n          return -1.0;\n        }\n      "),this.userCode="\n      const float initializationValue = 0.0;\n\n      float getValue(int batch, int inIdx) {\n        "+c+"\n        return getX(batch, inIdx);\n      }\n\n      float getSegmentIdAtIndex(int inIdx) {\n        "+h+"\n        return getSegmentIds(inIdx);\n      }\n\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int batch = coords[0];\n        int outIdx = coords[1];\n        int inOffset = int(floor(float(outIdx) / float(\n          "+a+")) * float("+n+"));\n        int currentSeg = int(mod(float(outIdx), float("+a+")));\n\n        float sumValue = 0.0;\n\n        for (int i = 0; i < "+s+"; i += 4) {\n          int inIdx = inOffset + i;\n          vec4 values = vec4(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            getValue(batch, inIdx + 2),\n            getValue(batch, inIdx + 3)\n          );\n\n          vec4 segFilter = vec4(\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 1)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 2)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 3)) == currentSeg ? 1 : 0\n          );\n\n          "+l+"\n        }\n\n        int inIdx = inOffset + "+s+";\n        if ("+(1===u)+") {\n          vec4 values = vec4(\n            getValue(batch, inIdx),\n            initializationValue,\n            initializationValue,\n            initializationValue\n          );\n\n          int inIdxSeg = int(getSegmentIdAtIndex(inIdx));\n\n          vec4 segFilter = vec4(\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\n            0,\n            0,\n            0\n          );\n\n          "+l+"\n        } else if ("+(2===u)+") {\n          vec4 values = vec4(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            initializationValue,\n            initializationValue\n          );\n\n          vec4 segFilter = vec4(\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 1)) == currentSeg ? 1 : 0,\n              0,\n              0\n          );\n\n          "+l+"\n        } else if ("+(3===u)+") {\n          vec4 values = vec4(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            getValue(batch, inIdx + 2),\n            initializationValue\n          );\n\n          vec4 segFilter = vec4(\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 1)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 2)) == currentSeg ? 1 : 0,\n            0\n          );\n\n          "+l+"\n        }\n        setOutput(sumValue);\n      }\n    ";};}(),Ni=function(){return function(t,e,n){var r,o;if(this.variableNames=["c","a","b"],this.outputShape=e,n>4)throw Error("Where for rank "+n+" is not yet supported");if(1===n)o="resRC",r="resRC";else{for(var a=["resRC.x","resRC.y","resRC.z","resRC.w"],i=[],s=[],u=0;u<e.length;u++){s.push(""+a[u]),u<t&&i.push(""+a[u]);}r=i.join(),o=s.join();}var l=Ho(n);this.userCode="\n      void main() {\n        "+l+" resRC = getOutputCoords();\n        float cVal = getC("+r+");\n        if (cVal >= 1.0) {\n          setOutput(getA("+o+"));\n        } else {\n          setOutput(getB("+o+"));\n        }\n      }\n    ";};}(),ki=function(){function t(t){this.variableNames=["source"],this.outputShape=t,this.rank=t.length;var e,n=Ho(this.rank),r="uniform int start["+this.rank+"];",o=function(t){if(1===t)return "sourceLoc";if(t<=6)return Ai.slice(0,t).map(function(t){return "sourceLoc."+t;}).join(",");throw Error("Slicing for rank "+t+" is not yet supported");}(this.rank);e="\n        "+n+" sourceLoc;\n        "+n+" coords = getOutputCoords();\n        "+t.map(function(t,e){return "sourceLoc."+Ai[e]+" = start["+e+"] + coords."+Ai[e]+";";}).join("\n")+"\n      ",this.userCode="\n      "+r+"\n      void main() {\n        "+e+"\n        setOutput(getSource("+o+"));\n      }\n    ";}return t.prototype.getCustomSetupFunc=function(t){var e=this;if(t.length!==this.rank)throw Error("The rank ("+this.rank+") of the program must match the length of start ("+t.length+")");return function(n,r){null==e.startLoc&&(e.startLoc=n.getUniformLocationNoThrow(r,"start"),null==e.startLoc)||n.gl.uniform1iv(e.startLoc,t);};},t;}(),Ai=["x","y","z","w","u","v"];var Ti=function(){function t(t){this.variableNames=["source"],this.usesPackedTextures=!0,this.outputShape=t,this.rank=t.length;var e=Ho(this.rank),n=To("coords",this.rank),r=To("sourceLoc",this.rank),o=1===this.rank?"sourceLoc":"vec2("+r.slice(-2).join()+")",a="getChannel(getSource("+r.join()+"), "+o+")",i="\n      result.x = "+a+";\n      if (++"+n[this.rank-1]+" < "+t[this.rank-1]+") {\n        ++"+r[this.rank-1]+";\n        result.y = "+a+";\n        --"+r[this.rank-1]+";\n      }\n    ",s=1===this.rank?"":"\n      --"+n[this.rank-1]+";\n      if (++"+n[this.rank-2]+" < "+t[this.rank-2]+") {\n        ++"+r[this.rank-2]+";\n        result.z = "+a+";\n        if (++"+n[this.rank-1]+" < "+t[this.rank-1]+") {\n          ++"+r[this.rank-1]+";\n          result.w = "+a+";\n        }\n      }\n    ",u=this.rank<=4?"sourceLoc = coords +\n            "+e+"("+t.map(function(t,e){return "start["+e+"]";}).join()+");":t.map(function(t,e){return r[e]+" = "+n[e]+" + start["+e+"];";}).join("\n");this.userCode="\n      uniform int start["+this.rank+"];\n      void main() {\n        "+e+" coords = getOutputCoords();\n        "+e+" sourceLoc;\n        "+u+" \n        vec4 result = vec4(0.);\n        "+i+"\n        "+s+"\n        setOutput(result);\n      }\n    ";}return t.prototype.getCustomSetupFunc=function(t){var e=this;if(t.length!==this.rank)throw Error("The rank ("+this.rank+") of the program must match the length of start ("+t.length+")");return function(n,r){null==e.startLoc&&(e.startLoc=n.getUniformLocationNoThrow(r,"start"),null==e.startLoc)||n.gl.uniform1iv(e.startLoc,t);};},t;}(),Di=function(){return function(t,e,n,r){this.variableNames=["x"];var o=n.filter(function(t,e){return -1===r.indexOf(e);});this.outputShape=o;var a=n.length,i=Ho(n.length),s=Ho(o.length),u="";if(1===a)u="coords * strides + begin";else{var l=0;u=n.map(function(t,e){return -1===r.indexOf(e)?(l++,1===o.length?"coords * strides["+e+"] + begin["+e+"]":"coords["+(l-1)+"] * strides["+e+"] + begin["+e+"]"):"begin["+e+"]";}).join(",");}this.userCode="\n      "+i+" begin = "+i+"("+t+");\n      "+i+" strides = "+i+"("+e+");\n\n      void main() {\n        "+s+" coords = getOutputCoords();\n        setOutput(getX("+u+"));\n      }\n    ";};}(),_i=function(){function t(t){this.gpgpu=t,this.numUsedTextures=0,this.numFreeTextures=0,this.freeTextures={},this.logEnabled=!1,this.usedTextures={};}return t.prototype.acquireTexture=function(t,e,n){var r,o=Oi(e,n),a=Fi(t,o,n);if(a in this.freeTextures||(this.freeTextures[a]=[]),a in this.usedTextures||(this.usedTextures[a]=[]),this.freeTextures[a].length>0){this.numFreeTextures--,this.numUsedTextures++,this.log();var i=this.freeTextures[a].shift();return this.usedTextures[a].push(i),i;}return this.numUsedTextures++,this.log(),o===_t.PACKED_2X2_FLOAT32?r=this.gpgpu.createPackedMatrixTexture(t[0],t[1]):o===_t.PACKED_2X2_FLOAT16?r=this.gpgpu.createFloat16PackedMatrixTexture(t[0],t[1]):o===_t.UNPACKED_FLOAT32?r=this.gpgpu.createFloat32MatrixTexture(t[0],t[1]):o===_t.UNPACKED_FLOAT16?r=this.gpgpu.createFloat16MatrixTexture(t[0],t[1]):o===_t.PACKED_4X1_UNSIGNED_BYTE&&(r=this.gpgpu.createUnsignedBytesMatrixTexture(t[0],t[1])),this.usedTextures[a].push(r),r;},t.prototype.releaseTexture=function(t,e,n,r){if(null!=this.freeTextures){var o=Fi(e,Oi(n,r),r);o in this.freeTextures||(this.freeTextures[o]=[]),this.freeTextures[o].push(t),this.numFreeTextures++,this.numUsedTextures--;var a=this.usedTextures[o],i=a.indexOf(t);if(i<0)throw new Error("Cannot release a texture that was never provided by this texture manager");a.splice(i,1),this.log();}},t.prototype.log=function(){if(this.logEnabled){var t=this.numFreeTextures+this.numUsedTextures;console.log("Free/Used",this.numFreeTextures+" / "+this.numUsedTextures,"("+t+")");}},t.prototype.getNumUsedTextures=function(){return this.numUsedTextures;},t.prototype.getNumFreeTextures=function(){return this.numFreeTextures;},t.prototype.dispose=function(){var t=this;if(null!=this.freeTextures){for(var e in this.freeTextures){this.freeTextures[e].forEach(function(e){t.gpgpu.deleteMatrixTexture(e);});}for(var e in this.usedTextures){this.usedTextures[e].forEach(function(e){t.gpgpu.deleteMatrixTexture(e);});}this.freeTextures=null,this.usedTextures=null,this.numUsedTextures=0,this.numFreeTextures=0;}},t;}();function Oi(t,e){if(t===Dt.UPLOAD)return _t.PACKED_2X2_FLOAT32;if(t===Dt.RENDER||null==t)return e?i.getBool("WEBGL_RENDER_FLOAT32_ENABLED")?_t.PACKED_2X2_FLOAT32:_t.PACKED_2X2_FLOAT16:i.getBool("WEBGL_RENDER_FLOAT32_ENABLED")?_t.UNPACKED_FLOAT32:_t.UNPACKED_FLOAT16;if(t===Dt.DOWNLOAD||t===Dt.PIXELS)return _t.PACKED_4X1_UNSIGNED_BYTE;throw new Error("Unknown logical texture type "+t);}function Fi(t,e,n){return t[0]+"_"+t[1]+"_"+e+"_"+n;}var Mi=function(){return function(t,e){this.variableNames=["A"];for(var n=new Array(t.length),r=0;r<n.length;r++){n[r]=t[r]*e[r];}this.outputShape=n,this.rank=n.length;var o=Ho(this.rank),a=function(t){var e=t.length;if(e>5)throw Error("Tile for rank "+e+" is not yet supported");if(1===e)return "imod(resRC, "+t[0]+")";for(var n=["resRC.x","resRC.y","resRC.z","resRC.w","resRC.u"],r=[],o=0;o<t.length;o++){r.push("imod("+n[o]+", "+t[o]+")");}return r.join();}(t);this.userCode="\n      void main() {\n        "+o+" resRC = getOutputCoords();\n        setOutput(getA("+a+"));\n      }\n    ";};}();var Bi=function(){return function(t,e){this.variableNames=["A"];for(var n=new Array(t.length),r=0;r<n.length;r++){n[r]=t[e[r]];}this.outputShape=n,this.rank=n.length;var o=Ho(this.rank),a=function(t){var e=t.length;if(e>6)throw Error("Transpose for rank "+e+" is not yet supported");for(var n=["resRC.x","resRC.y","resRC.z","resRC.w","resRC.u","resRC.v"],r=new Array(e),o=0;o<t.length;o++){r[t[o]]=n[o];}return r.join();}(e);this.userCode="\n    void main() {\n      "+o+" resRC = getOutputCoords();\n      setOutput(getA("+a+"));\n    }\n    ";};}();var Pi=function(){return function(t,e){this.variableNames=["A"],this.usesPackedTextures=!0;for(var n=new Array(t.length),r=0;r<n.length;r++){n[r]=t[e[r]];}if(this.outputShape=n,this.rank=n.length,this.rank>6)throw Error("Packed transpose for rank "+this.rank+" is not yet supported.");var o=Ho(this.rank),a=Ao("rc",this.rank),i=new Array(this.rank);for(r=0;r<e.length;r++){i[e[r]]=a[r];}var s="vec2("+i.slice(-2).join()+")",u="++"+a[this.rank-1]+" < "+n[this.rank-1],l="getChannel(getA("+i.join()+"), "+s+")";this.userCode="\n    void main() {\n      "+o+" rc = getOutputCoords();\n      vec4 result = vec4(0.);\n      result[0] = "+l+";\n      if("+u+") {\n        result[1] = "+l+";\n      }\n      --"+a[this.rank-1]+";\n      if(++"+a[this.rank-2]+" < "+n[this.rank-2]+") {\n        result[2] = "+l+";\n        if("+u+") {\n          result[3] = "+l+";\n        }\n      }  \n      setOutput(result);\n    }\n    ";};}(),Li=1.7580993408473768,Wi=1.0507009873554805,Ui=function(){return function(t,e){this.variableNames=["A"],this.outputShape=t,this.userCode="\n      float unaryOperation(float x) {\n        "+e+"\n      }\n\n      void main() {\n        float x = getAAtOutCoords();\n        float y = unaryOperation(x);\n\n        setOutput(y);\n      }\n    ";};}(),zi="if (isnan(x)) return x;",Vi="return x;",Gi=zi+"\n  return (x < 0.0) ? 0.0 : x;\n",Hi="\n  // Stable and Attracting Fixed Point (0, 1) for Normalized Weights.\n  // see: https://arxiv.org/abs/1706.02515\n  float scaleAlpha = "+Li+";\n  float scale = "+Wi+";\n  return (x >= 0.0) ? scale * x : scaleAlpha * (exp(x) - 1.0);\n";var qi="return exp(x);",$i=zi+"\n  return sin(x);\n",ji=zi+"\n  return cos(x);\n",Ki=zi+"\n  return atan(x);\n",Xi=zi+"\n  if (x < 1.0) return NAN;\n  return log(x + sqrt(x * x - 1.0));",Yi=zi+"\n  if ((x < -1.0) || (x > 1.0)) return NAN;\n  return (log(1.0 + x) - log(1.0 - x)) / 2.0;",Qi="return x;",Ji="\n  vec4 result = x * vec4(greaterThanEqual(x, vec4(0.0)));\n  bvec4 isNaN = isnan(x);\n\n  result.r = isNaN.r ? x.r : result.r;\n  result.g = isNaN.g ? x.g : result.g;\n  result.b = isNaN.b ? x.b : result.b;\n  result.a = isNaN.a ? x.a : result.a;\n\n  return result;\n",Zi=function(){return function(t,e){this.variableNames=["A"],this.usesPackedTextures=!0,this.outputShape=t,this.userCode="\n      vec4 unaryOperation(vec4 x) {\n        "+e+"\n      }\n\n      void main() {\n        vec4 x = getAAtOutCoords();\n        vec4 y = unaryOperation(x);\n\n        setOutput(y);\n      }\n    ";};}(),ts=function(){return function(t){this.variableNames=["A"],this.usesPackedTextures=!0,this.outputShape=t;var e=t.length,n=To("rc",e),r=Ho(e),o=function(t,e){if(1===t)return "rc";for(var n="",r=0;r<t;r++){n+=e[r],r<t-1&&(n+=",");}return n;}(e,n),a=n.slice(-2),i=e<=1?"rc":"vec2("+a.join(",")+")";this.userCode="\n      void main() {\n        "+r+" rc = getOutputCoords();\n        vec4 packedInput = getA("+o+");\n\n        setOutput(getChannel(packedInput, "+i+"));\n      }\n    ";};}(),es={};function ns(t,e){if(void 0===e&&(e=!1),"linear"===t)return e?Qi:Vi;if("relu"===t)return e?Ji:Gi;throw new Error("Activation "+t+" has not been implemented for the WebGL backend.");}var rs=600;var os=function(){function t(t){if(this.gpgpu=t,this.pendingRead=new WeakMap(),this.pendingDisposal=new WeakSet(),this.dataRefCount=new WeakMap(),this.numBytesInGPU=0,this.uploadWaitMs=0,this.downloadWaitMs=0,this.warnedAboutMemory=!1,this.disposed=!1,!i.getBool("HAS_WEBGL"))throw new Error("WebGL is not supported on this device");if(null==t){var e=Bt(i.getNumber("WEBGL_VERSION"));this.binaryCache=(n=i.getNumber("WEBGL_VERSION"))in es?es[n]:(es[n]={},es[n]),this.gpgpu=new ni(e),this.canvas=e.canvas,this.gpgpuCreatedLocally=!0;}else this.binaryCache={},this.gpgpuCreatedLocally=!1,this.canvas=t.gl.canvas;var n;this.textureManager=new _i(this.gpgpu),this.numMBBeforeWarning=null==i.global.screen?1024:i.global.screen.height*i.global.screen.width*window.devicePixelRatio*rs/1024/1024,this.texData=new Yr(this,At);}return t.prototype.register=function(t,e,n){if(this.texData.has(t))throw new Error("Data buffer is already registered");this.texData.set(t,{shape:e,dtype:n});},t.prototype.fromPixels=function(t,e){if(null==t)throw new Error("pixels passed to tf.browser.fromPixels() can not be null");var n=[t.height,t.width],r=[t.height,t.width,e],o="undefined"!=typeof OffscreenCanvas&&t instanceof OffscreenCanvas||"undefined"!=typeof HTMLCanvasElement&&t instanceof HTMLCanvasElement,a=t.data instanceof Uint8Array,s="undefined"!=typeof ImageData&&t instanceof ImageData,u="undefined"!=typeof HTMLVideoElement&&t instanceof HTMLVideoElement,l="undefined"!=typeof HTMLImageElement&&t instanceof HTMLImageElement;if(!(o||a||s||u||l))throw new Error("pixels passed to tf.browser.fromPixels() must be either an HTMLVideoElement, HTMLImageElement, HTMLCanvasElement, ImageData in browser, or OffscreenCanvas, ImageData in webworker or {data: Uint32Array, width: number, height: number}, but was "+t.constructor.name);if(l||u){if(null==this.fromPixels2DContext){if("complete"!==document.readyState)throw new Error("The DOM is not ready yet. Please call tf.browser.fromPixels() once the DOM is ready. One way to do that is to add an event listener for `DOMContentLoaded` on the document object");this.fromPixels2DContext=Pt(i.getNumber("WEBGL_VERSION")).getContext("2d");}this.fromPixels2DContext.canvas.width=t.width,this.fromPixels2DContext.canvas.height=t.height,this.fromPixels2DContext.drawImage(t,0,0,t.width,t.height),t=this.fromPixels2DContext.canvas;}var c,h,f=this.makeTensorHandle(n,"int32");if(this.texData.get(f.dataId).usage=Dt.PIXELS,this.gpgpu.uploadPixelDataToTexture(this.getTexture(f.dataId),t),i.getBool("WEBGL_PACK")){c=new Ma(r);var p=this.makePackedTensor(c.outputShape,f.dtype);h=this.compileAndRun(c,[f],p);}else c=new Fa(r),h=this.compileAndRun(c,[f]);return this.disposeData(f.dataId),h;},t.prototype.makeTensorHandle=function(t,e){var n={};return this.register(n,t,e),{dataId:n,shape:t,dtype:e};},t.prototype.write=function(t,e){if(null==e)throw new Error("MathBackendWebGL.write(): values can not be null");if(i.getBool("DEBUG"))for(var n=0;n<e.length;n++){var r=e[n];if(!qt(r))throw Error("The value "+r+" cannot be represented on this device.");}var o=this.texData.get(t);if("complex64"===o.dtype)throw new Error("Cannot write to a complex64 dtype. Please use tf.complex(real, imag).");this.releaseGPUData(t),o.usage=Dt.UPLOAD,o.values=e;},t.prototype.readSync=function(t){var e=this.texData.get(t),n=e.values,r=e.dtype,o=e.complexTensors,a=e.slice,i=e.shape;if(null!=a){var s=new Ui(i,"return x;"),u=this.compileAndRun(s,[{dataId:t,shape:i,dtype:r}]),l=this.readSync(u.dataId);return u.dispose(),l;}if(null!=n)return this.convertAndCacheOnCPU(t);if("string"===r)return n;var c,h,f=null!=this.activeTimers;(f&&(c=j()),"complex64"===r)?h=mo(o.real.dataSync(),o.imag.dataSync()):h=this.getValuesFromTexture(t);return f&&(this.downloadWaitMs+=j()-c),this.convertAndCacheOnCPU(t,h);},t.prototype.read=function(t){return n(this,void 0,void 0,function(){var e,n,o,a,s,u,l,c,h,f,p,d,v,m,y,x,b,w,C,E,R;return r(this,function(r){switch(r.label){case 0:if(this.pendingRead.has(t))return n=this.pendingRead.get(t),[2,new Promise(function(t){return n.push(t);})];if(o=this.texData.get(t),a=o.values,s=o.shape,u=o.slice,l=o.dtype,c=o.complexTensors,null!=u)return h=new Ui(s,"return x;"),f=this.compileAndRun(h,[{dataId:t,shape:s,dtype:l}]),p=this.read(f.dataId),f.dispose(),[2,p];if(null!=a)return [2,this.convertAndCacheOnCPU(t)];if(!i.getBool("WEBGL_DOWNLOAD_FLOAT_ENABLED")&&2===i.getNumber("WEBGL_VERSION"))throw new Error("tensor.data() with WEBGL_DOWNLOAD_FLOAT_ENABLED=false and WEBGL_VERSION=2 not yet supported.");return d=null,"complex64"!==l&&i.get("WEBGL_BUFFER_SUPPORTED")&&(v=this.decode(t),t=v.dataId,m=this.texData.get(v.dataId),d=(e=this.gpgpu).createBufferFromTexture.apply(e,[m.texture].concat(Wt(s)))),this.pendingRead.set(t,[]),"complex64"===l?[3,2]:[4,this.gpgpu.createAndWaitForFence()];case 1:r.sent(),r.label=2;case 2:return "complex64"!==l?[3,4]:[4,Promise.all([c.real.data(),c.imag.data()])];case 3:return x=r.sent(),b=x[0],w=x[1],y=mo(b,w),[3,5];case 4:null==d?y=this.getValuesFromTexture(t):(C=g(s),y=this.gpgpu.downloadFloat32MatrixFromBuffer(d,C),this.disposeData(t)),r.label=5;case 5:return E=this.convertAndCacheOnCPU(t,y),R=this.pendingRead.get(t),this.pendingRead["delete"](t),R.forEach(function(t){return t(E);}),this.pendingDisposal.has(t)&&(this.pendingDisposal["delete"](t),this.disposeData(t)),[2,E];}});});},t.prototype.getValuesFromTexture=function(t){var e,n=this,r=this.texData.get(t),o=r.shape,a=r.dtype,s=r.isPacked,u=g(o);if(i.getBool("WEBGL_DOWNLOAD_FLOAT_ENABLED")){var l=this.decode(t),c=this.texData.get(l.dataId),h=(e=this.gpgpu).downloadMatrixFromPackedTexture.apply(e,[c.texture].concat(Wt(o))).subarray(0,u);return this.disposeData(l.dataId),h;}var f=i.getBool("WEBGL_PACK")&&!0===s,p=f?be(o):o,d=this.makeTensorHandle(p,"float32");d.size=g(o),this.texData.get(d.dataId).usage=Dt.DOWNLOAD;var v=ze(function(){var e=f?new Na(p):new Sa(p);return n.compileAndRun(e,[{shape:p,dtype:a,dataId:t}],d,null);}),m=this.texData.get(v.dataId),y=this.gpgpu.downloadByteEncodedFloatMatrixFromOutputTexture(m.texture,m.texShape[0],m.texShape[1]).subarray(0,u);return this.disposeData(d.dataId),y;},t.prototype.time=function(t){return n(this,void 0,void 0,function(){var e,n,o,a,i,s,u;return r(this,function(r){switch(r.label){case 0:return e=this.activeTimers,n=[],o=!1,null==this.programTimersStack?(this.programTimersStack=n,o=!0):this.activeTimers.push(n),this.activeTimers=n,t(),a=m(this.activeTimers.map(function(t){return t.query;})).filter(function(t){return null!=t;}),i=m(this.activeTimers.map(function(t){return t.name;})).filter(function(t){return null!=t;}),this.activeTimers=e,o&&(this.programTimersStack=null),[4,Promise.all(a)];case 1:return s=r.sent(),u={uploadWaitMs:this.uploadWaitMs,downloadWaitMs:this.downloadWaitMs,kernelMs:f(s),getExtraProfileInfo:function getExtraProfileInfo(){return s.map(function(t,e){return {name:i[e],ms:t};}).map(function(t){return t.name+": "+t.ms;}).join(", ");},wallMs:null},this.uploadWaitMs=0,this.downloadWaitMs=0,[2,u];}});});},t.prototype.memory=function(){return {unreliable:!1,numBytesInGPU:this.numBytesInGPU};},t.prototype.startTimer=function(){return i.getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")>0?this.gpgpu.beginQuery():{startMs:j(),endMs:null};},t.prototype.endTimer=function(t){return i.getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")>0?(this.gpgpu.endQuery(),t):(t.endMs=j(),t);},t.prototype.getQueryTime=function(t){return n(this,void 0,void 0,function(){var e;return r(this,function(n){return i.getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")>0?[2,this.gpgpu.waitForQueryAndGetTime(t)]:[2,(e=t).endMs-e.startMs];});});},t.prototype.disposeData=function(t){if(!this.pendingDisposal.has(t))if(this.pendingRead.has(t))this.pendingDisposal.add(t);else if(this.texData.has(t)){this.releaseGPUData(t);var e=this.texData.get(t).complexTensors;null!=e&&(e.real.dispose(),e.imag.dispose()),this.texData["delete"](t);}},t.prototype.releaseGPUData=function(t){var e=this.texData.get(t),n=e.texture,r=e.dtype,o=e.texShape,a=e.usage,i=e.isPacked,s=e.slice,u=s&&s.origDataId||t,l=this.dataRefCount.get(u);l>1?this.dataRefCount.set(u,l-1):(this.dataRefCount["delete"](u),null!=n&&(this.numBytesInGPU-=this.computeBytes(o,r),this.textureManager.releaseTexture(n,o,a,i)));var c=this.texData.get(t);c.texture=null,c.texShape=null,c.isPacked=!1,c.slice=null;},t.prototype.getTexture=function(t){return this.uploadToGPU(t),this.texData.get(t).texture;},t.prototype.getCPUBackend=function(){return i.getBool("WEBGL_CPU_FORWARD")?(null==this.cpuBackend&&(this.cpuBackend=At.findBackend("cpu")),this.cpuBackend):null;},t.prototype.shouldExecuteOnCPU=function(t,e){var n=this;return void 0===e&&(e=128),null!=this.getCPUBackend()&&t.every(function(t){return null==n.texData.get(t.dataId).texture&&t.size<e;});},t.prototype.getGPGPUContext=function(){return this.gpgpu;},t.prototype.complex=function(t,e){var n=this.makeOutputArray(t.shape,"complex64");return this.texData.get(n.dataId).complexTensors={real:At.keep(t.clone()),imag:At.keep(e.clone())},n;},t.prototype.real=function(t){return this.texData.get(t.dataId).complexTensors.real.clone();},t.prototype.imag=function(t){return this.texData.get(t.dataId).complexTensors.imag.clone();},t.prototype.slice=function(t,e,n){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.slice(t,e,n);if(0===g(n))return bn([],n,t.dtype);var r=this.texData.get(t.dataId).isPacked,o=Wr(t.shape,e,n);if(r||!o){var a=i.getBool("WEBGL_PACK_ARRAY_OPERATIONS")?new Ti(n):new ki(n),s=a.getCustomSetupFunc(e);return this.compileAndRun(a,[t],null,s);}return this.uploadToGPU(t.dataId),this.shallowSlice(t,e,n);},t.prototype.shallowSlice=function(t,e,n){var r=this.texData.get(t.dataId),o=ht.make(n,{},t.dtype,this),a=this.texData.get(o.dataId);Object.assign(a,r),a.shape=n,a.dtype=t.dtype;var i=Ur(e,t.strides);r.slice&&(i+=r.slice.flatOffset),a.slice={flatOffset:i,origDataId:r.slice&&r.slice.origDataId||t.dataId};var s=this.dataRefCount.get(a.slice.origDataId)||1;return this.dataRefCount.set(a.slice.origDataId,s+1),o;},t.prototype.stridedSlice=function(t,e,n,r,o,a,i,s,u){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.stridedSlice(t,e,n,r,o,a,i,s,u);var l=Br(t.shape,e,n,r,o,a,i,s,u),c=l[0],h=l[1],f=l[2],p=h.filter(function(t,e){return -1===f.indexOf(e);});if(p.some(function(t){return 0===t;}))return bn([],p);var d=new Di(c,r,h,f);return this.compileAndRun(d,[t]);},t.prototype.reverse=function(t,e){var n=i.getBool("WEBGL_PACK_ARRAY_OPERATIONS")?new Ri(t.shape,e):new Ei(t.shape,e);return this.compileAndRun(n,[t]);},t.prototype.concat=function(t,e){if(this.shouldExecuteOnCPU(t))return this.cpuBackend.concat(t,e);if(1===t.length)return t[0];if(t.length>i.getNumber("WEBGL_MAX_TEXTURES_IN_SHADER")){var n=Math.floor(t.length/2),r=this.concat(t.slice(0,n),e),o=this.concat(t.slice(n),e);return this.concat([r,o],e);}if(i.getBool("WEBGL_PACK_ARRAY_OPERATIONS")&&t[0].rank>1){var a=new la(t.map(function(t){return t.shape;}),e);return this.compileAndRun(a,t);}var s=vn(t.map(function(t){return t.shape;}),e),u=t.map(function(t){return t.as2D(-1,g(t.shape.slice(e)));}),l=new ua(u.map(function(t){return t.shape;}));return this.compileAndRun(l,u).reshape(s);},t.prototype.neg=function(t){var e=new Ui(t.shape,"return -x;");return this.compileAndRun(e,[t]);},t.prototype.batchMatMul=function(t,e,n,r){var o=n?t.shape[2]:t.shape[1],a=r?e.shape[1]:e.shape[2],i=n?t.shape[1]:t.shape[2],s=t.shape[0];if((1===o||1===a)&&i>1e3){n&&(t=t.transpose([0,2,1])),r&&(e=e.transpose([0,2,1]));var u=1===a?t:t.as3D(s,i,1),l=1===a?2:1,c=1===a?e.as3D(s,1,i):e;return this.multiply(u,c).sum(l,!0);}var h=bt(t.dtype,e.dtype),f=new li(t.shape,[s,o,a],n,r),p=this.makePackedTensor(f.outputShape,h);return this.compileAndRun(f,[t,e],p);},t.prototype.fusedBatchMatMul=function(t,e,n,r,o,a){var i=n?t.shape[2]:t.shape[1],s=r?e.shape[1]:e.shape[2],u=t.shape[0],l=bt(t.dtype,e.dtype),c=null!=o,h=a?ns(a,!0):null,f=new li(t.shape,[u,i,s],n,r,c,h),p=this.makePackedTensor(f.outputShape,l),d=[t,e];return o&&d.push(o),this.compileAndRun(f,d,p);},t.prototype.multiply=function(t,e){if("complex64"===t.dtype){var n=this.texData.get(t.dataId),r=this.texData.get(e.dataId),o=new Zo(Qo,t.shape,e.shape),a=new Zo(Jo,t.shape,e.shape),s=[this.makeComplexComponentTensorHandle(t,n.complexTensors.real),this.makeComplexComponentTensorHandle(t,n.complexTensors.imag),this.makeComplexComponentTensorHandle(e,r.complexTensors.real),this.makeComplexComponentTensorHandle(e,r.complexTensors.imag)],u=this.compileAndRun(o,s),l=this.compileAndRun(a,s),c=this.complex(u,l);return u.dispose(),l.dispose(),c;}if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.multiply(t,e);if(i.getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,na,t.dtype);var h=new ra(na,t.shape,e.shape),f=this.makeOutputArray(h.outputShape,t.dtype);return this.compileAndRun(h,[t,e],f);},t.prototype.batchNormalization=function(t,e,n,r,o,a){var s=[t,e,n],u=null;null!=a&&(u=a.shape,s.push(a));var l=null;if(null!=o&&(l=o.shape,s.push(o)),i.getBool("WEBGL_PACK_NORMALIZATION")){var c=new Yo(t.shape,e.shape,n.shape,u,l,r);return this.compileAndRun(c,s);}var h=new Xo(t.shape,e.shape,n.shape,u,l,r);return this.compileAndRun(h,s);},t.prototype.localResponseNormalization4D=function(t,e,n,r,o){var a=i.getBool("WEBGL_PACK_NORMALIZATION")?new si(t.shape,e,n,r,o):new ai(t.shape,e,n,r,o);return this.compileAndRun(a,[t]);},t.prototype.LRNGrad=function(t,e,n,r,o,a,i){var s=new ii(e.shape,r,o,a,i);return this.compileAndRun(s,[e,n,t]);},t.prototype.tile=function(t,e){if("string"===t.dtype){var n=this.readSync(t.dataId).map(function(t){return Y(t);});return Eo(Zn(t.shape,t.dtype,n),e);}var r=new Mi(t.shape,e);return this.compileAndRun(r,[t]);},t.prototype.pad=function(t,e,n){var r=i.getBool("WEBGL_PACK_ARRAY_OPERATIONS")?new di(t.shape,e,n):new pi(t.shape,e,n);return this.compileAndRun(r,[t]);},t.prototype.transpose=function(t,e){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.transpose(t,e);var n=i.getBool("WEBGL_PACK_ARRAY_OPERATIONS")?new Pi(t.shape,e):new Bi(t.shape,e);return this.compileAndRun(n,[t]);},t.prototype.gather=function(t,e,n){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.gather(t,e,n);var r=new Ba(t.shape,e.size,n);return this.compileAndRun(r,[t,e]);},t.prototype.batchToSpaceND=function(t,e,n){p(t.rank<=4,function(){return "batchToSpaceND for rank > 4 with a WebGL backend not implemented yet";});var r=e.reduce(function(t,e){return t*e;}),o=Sr(t.shape,e,r),a=Nr(o.length,e.length),i=kr(t.shape,e,r),s=Ar(n,e.length),u=Tr(i,n,e.length);return t.reshape(o).transpose(a).reshape(i).slice(s,u);},t.prototype.spaceToBatchND=function(t,e,n){p(t.rank<=4,function(){return "spaceToBatchND for rank > 4 with a WebGL backend not implemented yet";});var r=e.reduce(function(t,e){return t*e;}),o=[[0,0]];o.push.apply(o,n);for(var a=1+e.length;a<t.shape.length;++a){o.push([0,0]);}var i=t.pad(o),s=Sr(i.shape,e,r,!1),u=Nr(s.length,e.length,!1),l=kr(i.shape,e,r,!1);return i.reshape(s).transpose(u).reshape(l);},t.prototype.reduce=function(t,e,n){var r=t.shape[0],o=t.shape[1],a=Or(o),i=new mi({windowSize:a,inSize:o,batchSize:r},e),s=i.outputShape,u=s[0],l=s[1],c=this.makeOutputArray([u,l],n);return this.compileAndRun(i,[t],c),1===c.shape[1]?c:this.reduce(c,e,n);},t.prototype.argReduce=function(t,e,n){void 0===n&&(n=null);var r=t.shape[0],o=t.shape[1];null!=n&&(r=n.shape[0],o=n.shape[1]);var a=Or(o),i=new ko({windowSize:a,inSize:o,batchSize:r},e,null==n),s=i.outputShape,u=s[0],l=s[1],c=this.makeOutputArray([u,l],"int32"),h=[t];return null!=n&&h.push(n),this.compileAndRun(i,h,c),1===c.shape[1]?c:this.argReduce(t,e,c);},t.prototype.argReducePacked=function(t,e,n){void 0===n&&(n=null);var r=null!=n?n.shape:t.shape,o=Or(r[r.length-1]),a=new jo(r,o,e,null==n),i=this.makePackedTensor(a.outputShape,"int32"),s=null==n?[t]:[t,n];return this.compileAndRun(a,s,i),i.rank===t.rank?this.argReducePacked(t,e,i):i;},t.prototype.sum=function(t,e){cn("sum",e,t.rank);var n=un(t.shape,e),r=n[0],o=g(n[1]),a=t.as2D(-1,o),i=wt(t.dtype);return this.reduce(a,"sum",i).reshape(r);},t.prototype.prod=function(t,e){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.prod(t,e);var n=un(t.shape,e),r=n[0],o=g(n[1]),a=t.as2D(-1,o),i=wt(t.dtype);return this.reduce(a,"prod",i).reshape(r);},t.prototype.unsortedSegmentSum=function(t,e,n){var r=0,o=hn([r],t.rank),a=t;null!=o&&(a=t.transpose(o),r=pn(1,t.rank)[0]);var i=function(t,e,n){for(var r=[],o=t.length,a=0;a<o;a++){a!==e?r.push(t[a]):r.push(n);}return r;}(a.shape,r,n),s=g([a.shape[r]]),u=a.as2D(-1,s),l=wt(t.dtype),c=this.segOpCompute(u,"unsortedSegmentSum",e,l,n).reshape(i);return null!=o&&(c=c.transpose(fn(o))),c;},t.prototype.segOpCompute=function(t,e,n,r,o){var a=t.shape[0],i=t.shape[1],s=function(t,e){var n,r=!1;for(t<=_r?(n=t,r=!0):n=z(t,Math.floor(Math.sqrt(t)));!r;){n>e||n===t?r=!0:n=z(t,n+1);}return n;}(i,o),u=new Si({windowSize:s,inSize:i,batchSize:a,numSegments:o},e),l=u.outputShape,c=l[0],h=l[1],f=this.makeOutputArray([c,h],r);return this.compileAndRun(u,[t,n],f),f.shape[1]===o?f:(n=On(0,o).tile([i/s]),this.segOpCompute(f,e,n,r,o));},t.prototype.argMinMaxReduce=function(t,e,n){var r=[e];if(cn("arg"+n.charAt(0).toUpperCase()+n.slice(1),r,t.rank),!i.getBool("WEBGL_PACK_REDUCE")||t.rank<=2){var o=un(t.shape,r),a=o[0],s=g(o[1]),u=t.as2D(-1,s);return this.argReduce(u,n).reshape(a);}return this.argReducePacked(t,n);},t.prototype.argMin=function(t,e){return this.argMinMaxReduce(t,e,"min");},t.prototype.argMax=function(t,e){return this.argMinMaxReduce(t,e,"max");},t.prototype.cumsum=function(t,e,n,r){if(e!==t.rank-1)throw new Error("WebGL cumsum shader expects an inner-most axis="+(t.rank-1)+" but got axis="+e);var o=new wa(t.shape,n,r);return this.compileAndRun(o,[t]);},t.prototype.equal=function(t,e){if(i.getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(equal(a, b));\n","bool");var n=new ra("return float(a == b);",t.shape,e.shape),r=this.makeOutputArray(n.outputShape,"bool");return this.compileAndRun(n,[t,e],r);},t.prototype.notEqual=function(t,e){if(i.getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(notEqual(a, b));\n","bool");var n=new ra("return float(a != b);",t.shape,e.shape),r=this.makeOutputArray(n.outputShape,"bool");return this.compileAndRun(n,[t,e],r);},t.prototype.less=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.less(t,e);if(i.getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(lessThan(a, b));\n","bool");var n=new ra("return float(a < b);",t.shape,e.shape),r=this.makeOutputArray(n.outputShape,"bool");return this.compileAndRun(n,[t,e],r);},t.prototype.lessEqual=function(t,e){if(i.getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(lessThanEqual(a, b));\n","bool");var n=new ra("return float(a <= b);",t.shape,e.shape),r=this.makeOutputArray(n.outputShape,"bool");return this.compileAndRun(n,[t,e],r);},t.prototype.greater=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.greater(t,e);if(i.getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(greaterThan(a, b));\n","bool");var n=new ra("return float(a > b);",t.shape,e.shape),r=this.makeOutputArray(n.outputShape,"bool");return this.compileAndRun(n,[t,e],r);},t.prototype.greaterEqual=function(t,e){if(i.getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(greaterThanEqual(a, b));\n","bool");var n=new ra("return float(a >= b);",t.shape,e.shape),r=this.makeOutputArray(n.outputShape,"bool");return this.compileAndRun(n,[t,e],r);},t.prototype.logicalNot=function(t){var e=new Ui(t.shape,"return float(!(x >= 1.0));");return this.compileAndRun(e,[t]);},t.prototype.logicalAnd=function(t,e){if(i.getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(\n    vec4(greaterThanEqual(a, vec4(1.0))) *\n    vec4(greaterThanEqual(b, vec4(1.0))));\n","bool");var n=new ra("return float(a >= 1.0 && b >= 1.0);",t.shape,e.shape),r=this.makeOutputArray(n.outputShape,"bool");return this.compileAndRun(n,[t,e],r);},t.prototype.logicalOr=function(t,e){if(i.getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return min(\n    vec4(greaterThanEqual(a, vec4(1.0))) +\n    vec4(greaterThanEqual(b, vec4(1.0))),\n    vec4(1.0));\n","bool");var n=new ra("return float(a >= 1.0 || b >= 1.0);",t.shape,e.shape),r=this.makeOutputArray(n.outputShape,"bool");return this.compileAndRun(n,[t,e],r);},t.prototype.select=function(t,e,n){var r=new Ni(t.rank,e.shape,e.rank),o=this.makeOutputArray(r.outputShape,bt(e.dtype,n.dtype));return this.compileAndRun(r,[t,e,n],o);},t.prototype.where=function(t){tn("tf.where() in webgl locks the UI thread. Call tf.whereAsync() instead");var e=t.dataSync();return Io(t.shape,e);},t.prototype.topk=function(t,e,n){return Ro(t.dataSync(),t.shape,t.dtype,e);},t.prototype.min=function(t,e){cn("min",e,t.rank);var n=un(t.shape,e),r=n[0],o=g(n[1]),a=t.as2D(-1,o);return this.reduce(a,"min",a.dtype).reshape(r);},t.prototype.minimum=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.minimum(t,e);var n=i.getBool("WEBGL_PACK_BINARY_OPERATIONS")?new oa("\n  vec4 result = vec4(min(a, b));\n  vec4 isNaN = min(vec4(isnan(a)) + vec4(isnan(b)), vec4(1.0));\n  \n  result.r = isNaN.r > 0. ? NAN : result.r;\n  result.g = isNaN.g > 0. ? NAN : result.g;\n  result.b = isNaN.b > 0. ? NAN : result.b;\n  result.a = isNaN.a > 0. ? NAN : result.a;\n\n  return result;\n",t.shape,e.shape):new ra("\n  if (isnan(a)) return a;\n  if (isnan(b)) return b;\n\n  return min(a, b);\n",t.shape,e.shape);return this.compileAndRun(n,[t,e]);},t.prototype.mod=function(t,e){var n=i.getBool("WEBGL_PACK_BINARY_OPERATIONS")?new oa("\n  vec4 result = mod(a, b);\n  vec4 isNaN = vec4(equal(b, vec4(0.0)));\n  \n  result.r = isNaN.r > 0. ? NAN : result.r;\n  result.g = isNaN.g > 0. ? NAN : result.g;\n  result.b = isNaN.b > 0. ? NAN : result.b;\n  result.a = isNaN.a > 0. ? NAN : result.a;\n\n  return result;\n",t.shape,e.shape):new ra("if (b == 0.0) return NAN;\n  return mod(a, b);",t.shape,e.shape);return this.compileAndRun(n,[t,e]);},t.prototype.max=function(t,e){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.max(t,e);cn("max",e,t.rank);var n=un(t.shape,e),r=n[0],o=g(n[1]),a=t.as2D(-1,o);return this.reduce(a,"max",a.dtype).reshape(r);},t.prototype.maximum=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.maximum(t,e);var n=i.getBool("WEBGL_PACK_BINARY_OPERATIONS")?new oa("\n  vec4 result = vec4(max(a, b));\n  vec4 isNaN = min(vec4(isnan(a)) + vec4(isnan(b)), vec4(1.0));\n  \n  result.r = isNaN.r > 0. ? NAN : result.r;\n  result.g = isNaN.g > 0. ? NAN : result.g;\n  result.b = isNaN.b > 0. ? NAN : result.b;\n  result.a = isNaN.a > 0. ? NAN : result.a;\n\n  return result;\n",t.shape,e.shape):new ra("\n  if (isnan(a)) return a;\n  if (isnan(b)) return b;\n\n  return max(a, b);\n",t.shape,e.shape);return this.compileAndRun(n,[t,e]);},t.prototype.all=function(t,e){cn("all",e,t.rank);var n=un(t.shape,e),r=n[0],o=g(n[1]),a=t.as2D(-1,o);return this.reduce(a,"all",a.dtype).reshape(r);},t.prototype.any=function(t,e){cn("any",e,t.rank);var n=un(t.shape,e),r=n[0],o=g(n[1]),a=t.as2D(-1,o);return this.reduce(a,"any",a.dtype).reshape(r);},t.prototype.squaredDifference=function(t,e){var n=i.getBool("WEBGL_PACK_BINARY_OPERATIONS")?new oa("return (a - b) * (a - b);",t.shape,e.shape):new ra("return (a - b) * (a - b);",t.shape,e.shape);return this.compileAndRun(n,[t,e]);},t.prototype.realDivide=function(t,e){if(i.getBool("WEBGL_PACK_BINARY_OPERATIONS")){return this.packedBinaryOp(t,e,"\n  // vec4 one = vec4(equal(a, b));\n  // return one + (vec4(1.0) - one) * a / b;\n  vec4 result = a / b;\n  if(b.x == 0.0) {\n    result.x = NAN;\n  } else if(a.x == b.x) {\n    result.x = 1.;\n  }\n  if(b.y == 0.0) {\n    result.y = NAN;\n  } else if(a.y == b.y) {\n    result.y = 1.;\n  }\n  if(b.z == 0.0) {\n    result.z = NAN;\n  } else if(a.z == b.z) {\n    result.z = 1.;\n  }\n  if(b.w == 0.0) {\n    result.w = NAN;\n  } else if(a.w == b.w) {\n    result.w = 1.;\n  }\n\n  return result;\n","float32",!0);}var n=new ra("\nif (b == 0.0) {\n  return NAN;\n}\nif (a == b) {\n  return 1.0;\n};\nreturn a / b;",t.shape,e.shape),r=this.makeOutputArray(n.outputShape,"float32");return this.compileAndRun(n,[t,e],r);},t.prototype.floorDiv=function(t,e){if(i.getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  ivec4 ia = round(a);\n  ivec4 ib = round(b);\n  bvec4 cond = notEqual(ib, ivec4(0));\n  ivec4 result = ivec4(0);\n  vec4 s = sign(a) * sign(b);\n\n  // Windows (D3D) wants guaranteed non-zero int division at compile-time.\n  if (cond[0]) {\n    result[0] = idiv(ia[0], ib[0], s[0]);\n  }\n  if (cond[1]) {\n    result[1] = idiv(ia[1], ib[1], s[1]);\n  }\n  if (cond[2]) {\n    result[2] = idiv(ia[2], ib[2], s[2]);\n  }\n  if (cond[3]) {\n    result[3] = idiv(ia[3], ib[3], s[3]);\n  }\n  return vec4(result);\n","int32");var n=new ra("\n  float s = sign(a) * sign(b);\n  int ia = round(a);\n  int ib = round(b);\n  if (ib != 0) {\n    // Windows (D3D) wants guaranteed non-zero int division at compile-time.\n    return float(idiv(ia, ib, s));\n  } else {\n    return NAN;\n  }\n",t.shape,e.shape),r=this.makeOutputArray(n.outputShape,"int32");return this.compileAndRun(n,[t,e],r);},t.prototype.add=function(t,e){if("complex64"===t.dtype&&"complex64"===e.dtype)return this.complexSeparableBinaryOp(t,e,ta);if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.add(t,e);var n=bt(t.dtype,e.dtype);if(i.getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,ta,n);var r=new ra(ta,t.shape,e.shape),o=this.makeOutputArray(r.outputShape,n);return this.compileAndRun(r,[t,e],o);},t.prototype.packedBinaryOp=function(t,e,n,r,o){void 0===o&&(o=!1);var a=new oa(n,t.shape,e.shape,o),i=this.makePackedTensor(a.outputShape,r);return this.compileAndRun(a,[t,e],i);},t.prototype.complexSeparableBinaryOp=function(t,e,n){var r=this,o=this.texData.get(t.dataId),a=this.texData.get(e.dataId),i=[[o.complexTensors.real,a.complexTensors.real],[o.complexTensors.imag,a.complexTensors.imag]].map(function(o){var a=o[0],i=o[1],s=r.makeComplexComponentTensorHandle(t,a),u=r.makeComplexComponentTensorHandle(e,i),l=new ra(n,t.shape,e.shape),c=r.makeOutputArray(l.outputShape,bt(a.dtype,i.dtype));return r.compileAndRun(l,[s,u],c);}),s=i[0],u=i[1],l=this.complex(s,u);return s.dispose(),u.dispose(),l;},t.prototype.makeComplexComponentTensorHandle=function(t,e){return {dataId:e.dataId,dtype:e.dtype,shape:t.shape};},t.prototype.addN=function(t){if(1===t.length)return t[0];if(t.length>i.get("WEBGL_MAX_TEXTURES_IN_SHADER")){var e=Math.floor(t.length/2),n=this.addN(t.slice(0,e)),r=this.addN(t.slice(e));return this.addN([n,r]);}var o=t.map(function(t){return t.dtype;}).reduce(function(t,e){return bt(t,e);}),a=t.map(function(t){return t.shape;}),s=i.getBool("WEBGL_PACK"),u=s?new No(t[0].shape,a):new So(t[0].shape,a),l=s?this.makePackedTensor(u.outputShape,o):this.makeOutputArray(u.outputShape,o);return this.compileAndRun(u,t,l);},t.prototype.subtract=function(t,e){if("complex64"===t.dtype&&"complex64"===e.dtype)return this.complexSeparableBinaryOp(t,e,ea);if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.subtract(t,e);var n=bt(t.dtype,e.dtype);if(i.getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,ea,t.dtype);var r=new ra(ea,t.shape,e.shape),o=this.makeOutputArray(r.outputShape,n);return this.compileAndRun(r,[t,e],o);},t.prototype.pow=function(t,e){var n=i.getBool("WEBGL_PACK_BINARY_OPERATIONS"),r=n?new oa("\n  // isModRound1 has 1 for components with round(mod(b, 2.0)) == 1, 0 otherwise.\n  vec4 isModRound1 = vec4(equal(round(mod(b, 2.0)), ivec4(1)));\n  vec4 multiplier = sign(a) * isModRound1 + (vec4(1.0) - isModRound1);\n  vec4 result = multiplier * pow(abs(a), b);\n\n  // Ensure that a^0 = 1, including 0^0 = 1 as this correspond to TF and JS\n  bvec4 isExpZero = equal(b, vec4(0.0));\n  result.r = isExpZero.r ? 1.0 : result.r;\n  result.g = isExpZero.g ? 1.0 : result.g;\n  result.b = isExpZero.b ? 1.0 : result.b;\n  result.a = isExpZero.a ? 1.0 : result.a;\n\n  vec4 isNaN = vec4(lessThan(a, vec4(0.0))) * vec4(lessThan(floor(b), b));\n  \n  result.r = isNaN.r > 0. ? NAN : result.r;\n  result.g = isNaN.g > 0. ? NAN : result.g;\n  result.b = isNaN.b > 0. ? NAN : result.b;\n  result.a = isNaN.a > 0. ? NAN : result.a;\n\n  return result;\n",t.shape,e.shape):new ra("\nif(a < 0.0 && floor(b) < b){\n  return NAN;\n}\nif (b == 0.0) {\n  return 1.0;\n}\nreturn (round(mod(b, 2.0)) != 1) ?\n    pow(abs(a), b) : sign(a) * pow(abs(a), b);\n",t.shape,e.shape),o=bt(t.dtype,e.dtype),a=n?this.makePackedTensor(r.outputShape,o):this.makeOutputArray(r.outputShape,o);return this.compileAndRun(r,[t,e],a);},t.prototype.ceil=function(t){var e=new Ui(t.shape,"return ceil(x);");return this.compileAndRun(e,[t]);},t.prototype.floor=function(t){var e=new Ui(t.shape,"return floor(x);");return this.compileAndRun(e,[t]);},t.prototype.sign=function(t){var e=new Ui(t.shape,"\n  if (isnan(x)) { return 0.0; }\n  return sign(x);\n");return this.compileAndRun(e,[t]);},t.prototype.isNaN=function(t){var e=new Ui(t.shape,"return float(isnan(x));"),n=this.makeOutputArray(e.outputShape,"bool");return this.compileAndRun(e,[t],n);},t.prototype.isInf=function(t){var e=new Ui(t.shape,"return float(isinf(x));"),n=this.makeOutputArray(e.outputShape,"bool");return this.compileAndRun(e,[t],n);},t.prototype.isFinite=function(t){var e=new Ui(t.shape,"return float(!isnan(x) && !isinf(x));"),n=this.makeOutputArray(e.outputShape,"bool");return this.compileAndRun(e,[t],n);},t.prototype.round=function(t){var e=new Ui(t.shape,"\n  // OpenGL ES does not support round function.\n  // The algorithm is based on banker's rounding.\n  float base = floor(x);\n  if ((x - base) < 0.5) {\n    return floor(x);\n  } else if ((x - base) > 0.5) {\n    return ceil(x);\n  } else {\n    if (mod(base, 2.0) == 0.0) {\n      return base;\n    } else {\n      return base + 1.0;\n    }\n  }\n");return this.compileAndRun(e,[t]);},t.prototype.exp=function(t){var e;return e=i.getBool("WEBGL_PACK")?new Zi(t.shape,qi):new Ui(t.shape,qi),this.compileAndRun(e,[t]);},t.prototype.expm1=function(t){var e=new Ui(t.shape,"return exp(x) - 1.0;");return this.compileAndRun(e,[t]);},t.prototype.log=function(t){var e;return e=i.getBool("WEBGL_PACK")?new Zi(t.shape,"\n  vec4 result = log(x);\n  vec4 isNaN = vec4(lessThan(x, vec4(0.0)));\n  result.r = isNaN.r == 1.0 ? NAN : result.r;\n  result.g = isNaN.g == 1.0 ? NAN : result.g;\n  result.b = isNaN.b == 1.0 ? NAN : result.b;\n  result.a = isNaN.a == 1.0 ? NAN : result.a;\n\n  return result;\n"):new Ui(t.shape,"if (x < 0.0) return NAN;\n  return log(x);"),this.compileAndRun(e,[t]);},t.prototype.log1p=function(t){var e=new Ui(t.shape,"return log(1.0 + x);");return this.compileAndRun(e,[t]);},t.prototype.sqrt=function(t){var e=new Ui(t.shape,"return sqrt(x);");return this.compileAndRun(e,[t]);},t.prototype.rsqrt=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.rsqrt(t);var e=new Ui(t.shape,"return inversesqrt(x);");return this.compileAndRun(e,[t]);},t.prototype.square=function(t){var e=new Ui(t.shape,"return x * x;");return this.compileAndRun(e,[t]);},t.prototype.reciprocal=function(t){var e=new Ui(t.shape,"return 1.0 / x;");return this.compileAndRun(e,[t]);},t.prototype.relu=function(t){var e;return e=i.getBool("WEBGL_PACK")?new Zi(t.shape,Ji):new Ui(t.shape,Gi),this.compileAndRun(e,[t]);},t.prototype.prelu=function(t,e){var n=i.getBool("WEBGL_PACK_BINARY_OPERATIONS")?new oa("\n  vec4 aLessThanZero = vec4(lessThan(a, vec4(0.)));\n  return (aLessThanZero * (b * a)) + ((vec4(1.0) - aLessThanZero) * a);\n",t.shape,e.shape):new ra("return (a < 0.) ? b * a : a;",t.shape,e.shape);return this.compileAndRun(n,[t,e]);},t.prototype.elu=function(t){var e=new Ui(t.shape,"return (x >= 0.0) ? x : (exp(x) - 1.0);");return this.compileAndRun(e,[t]);},t.prototype.eluDer=function(t,e){var n=i.getBool("WEBGL_PACK_BINARY_OPERATIONS")?new oa("\n  vec4 bGTEZero = vec4(greaterThanEqual(b, vec4(0.)));\n  return (bGTEZero * a) + ((vec4(1.0) - bGTEZero) * (a * (b + vec4(1.0))));\n",t.shape,e.shape):new ra("return (b >= 1.0) ? a : a * (b + 1.0);",t.shape,e.shape);return this.compileAndRun(n,[t,e]);},t.prototype.selu=function(t){var e=new Ui(t.shape,Hi);return this.compileAndRun(e,[t]);},t.prototype["int"]=function(t){var e=new Ui(t.shape,"return float(int(x));"),n=this.makeOutputArray(e.outputShape,"int32");return this.compileAndRun(e,[t],n);},t.prototype.clip=function(t,e,n){var r,o=(r=i.getBool("WEBGL_PACK_CLIP")?new ia(t.shape):new aa(t.shape)).getCustomSetupFunc(e,n);return this.compileAndRun(r,[t],null,o);},t.prototype.abs=function(t){var e=new Ui(t.shape,"return abs(x);");return this.compileAndRun(e,[t]);},t.prototype.complexAbs=function(t){var e=this.texData.get(t.dataId),n=new sa(t.shape),r=[this.makeComplexComponentTensorHandle(t,e.complexTensors.real),this.makeComplexComponentTensorHandle(t,e.complexTensors.imag)];return this.compileAndRun(n,r);},t.prototype.sigmoid=function(t){var e=new Ui(t.shape,"return 1.0 / (1.0 + exp(-1.0 * x));");return this.compileAndRun(e,[t]);},t.prototype.softplus=function(t){var e=new Ui(t.shape,"\n  float epsilon = 1.1920928955078125e-7;\n  float threshold = log(epsilon) + 2.0;\n\n  bool too_large = x > -threshold;\n  bool too_small = x < threshold;\n\n  float result;\n  float exp_x = exp(x);\n\n  if (too_large){\n    result = x;\n  }\n  else if (too_small){\n    result = exp_x;\n  }\n  else{\n    result = log(exp_x + 1.0);\n  }\n  return result;\n");return this.compileAndRun(e,[t]);},t.prototype.sin=function(t){var e=new Ui(t.shape,$i);return this.compileAndRun(e,[t]);},t.prototype.cos=function(t){var e=new Ui(t.shape,ji);return this.compileAndRun(e,[t]);},t.prototype.tan=function(t){var e=new Ui(t.shape,"return tan(x);");return this.compileAndRun(e,[t]);},t.prototype.asin=function(t){var e=new Ui(t.shape,"return asin(x);");return this.compileAndRun(e,[t]);},t.prototype.acos=function(t){var e=new Ui(t.shape,"return acos(x);");return this.compileAndRun(e,[t]);},t.prototype.atan=function(t){var e=new Ui(t.shape,Ki);return this.compileAndRun(e,[t]);},t.prototype.atan2=function(t,e){var n=i.getBool("WEBGL_PACK_BINARY_OPERATIONS")?new oa("\n  vec4 result = atan(a, b);\n  vec4 isNaN = min(vec4(isnan(a)) + vec4(isnan(b)), vec4(1.0));\n  \n  result.r = isNaN.r > 0. ? NAN : result.r;\n  result.g = isNaN.g > 0. ? NAN : result.g;\n  result.b = isNaN.b > 0. ? NAN : result.b;\n  result.a = isNaN.a > 0. ? NAN : result.a;\n\n  return result;\n",t.shape,e.shape):new ra("\n  if (isnan(a)) return a;\n  if (isnan(b)) return b;\n\n  return atan(a, b);\n",t.shape,e.shape);return this.compileAndRun(n,[t,e]);},t.prototype.sinh=function(t){var e=new Ui(t.shape,"\n  float e2x = exp(x);\n  return (e2x - 1.0 / e2x) / 2.0;\n");return this.compileAndRun(e,[t]);},t.prototype.cosh=function(t){var e=new Ui(t.shape,"\n  float e2x = exp(-x);\n  return (e2x + 1.0 / e2x) / 2.0;\n");return this.compileAndRun(e,[t]);},t.prototype.tanh=function(t){var e=new Ui(t.shape,"\n  float e2x = exp(-2.0 * abs(x));\n  return sign(x) * (1.0 - e2x) / (1.0 + e2x);\n");return this.compileAndRun(e,[t]);},t.prototype.asinh=function(t){var e=new Ui(t.shape,"return log(x + sqrt(x * x + 1.0));");return this.compileAndRun(e,[t]);},t.prototype.acosh=function(t){var e=new Ui(t.shape,Xi);return this.compileAndRun(e,[t]);},t.prototype.atanh=function(t){var e=new Ui(t.shape,Yi);return this.compileAndRun(e,[t]);},t.prototype.erf=function(t){var e=new Ui(t.shape,'\n  // Error function is calculated approximately with elementary function.\n  // See "Handbook of Mathematical Functions with Formulas,\n  // Graphs, and Mathematical Tables", Abramowitz and Stegun.\n  float p = 0.3275911;\n  float a1 = 0.254829592;\n  float a2 = -0.284496736;\n  float a3 = 1.421413741;\n  float a4 = -1.453152027;\n  float a5 = 1.061405429;\n\n  float t = 1.0 / (1.0 + p * x);\n  return 1.0 - (((((a5*t + a4)*t) + a3)*t + a2)*t + a1)*t*exp(-x*x);\n');return this.compileAndRun(e,[t]);},t.prototype.step=function(t,e){var n=new Ui(t.shape,function(t){return void 0===t&&(t=0),zi+"\n    return x > 0.0 ? 1.0 : float("+t+");\n  ";}(e));return this.compileAndRun(n,[t]);},t.prototype.conv2dByMatMul=function(t,e,n,r,o){var a=t.shape,s=this.texData.get(t.dataId),u=n.inChannels,l=a[0]*a[1]*a[2],c=n.outChannels,h=(1===l||1===c)&&u>1e3,f=a[2]%2!=0&&!!s.isPacked;if(h||!i.getBool("WEBGL_LAZILY_UNPACK")||!i.getBool("WEBGL_PACK_BINARY_OPERATIONS")||!f){var d=this.reshape(t,[1,a[0]*a[1]*a[2],n.inChannels]),v=this.reshape(e,[1,n.inChannels,n.outChannels]);return this.reshape(this.fusedBatchMatMul(d,v,!1,!1,r,o),n.outShape);}var m=ht.make([1,a[0]*a[1]*(a[2]+1),n.inChannels],{dataId:t.dataId},t.dtype,this),g=s.shape;s.shape=s.shape.slice(),s.shape[s.shape.length-2]++,p(Ee(s.shape,m.shape),function(){return "packed reshape "+s.shape+" to "+m.shape+" isn't free";});var y=this.reshape(e,[1,n.inChannels,n.outChannels]),x=this.fusedBatchMatMul(m,y,!1,!1,r,o),b=this.texData.get(x.dataId);return p(b.isPacked,function(){return "batchMatMul result is expected to be packed";}),s.shape=g,b.shape=n.outShape,ht.make(n.outShape,{dataId:x.dataId},x.dtype,this);},t.prototype.conv2dWithIm2Row=function(t,e,n,r,o){var a=n.filterWidth,i=n.filterHeight,s=n.inChannels,u=n.outWidth,l=n.outHeight,c=a*i*s,h=l*u,f=[c,h],p=t.squeeze([0]),d=e.reshape([1,c,-1]),v=new oi(f,p.shape,n),m=this.compileAndRun(v,[p]).reshape([1,f[0],f[1]]),g=null!=r,y=o?ns(o,!0):null,x=new li(m.shape,[1,h,n.outChannels],!0,!1,g,y),b=[m,d];return r&&b.push(r),this.compileAndRun(x,b).reshape([1,l,u,n.outChannels]);},t.prototype.fusedConv2d=function(t,e,n,r,o){if(1===n.filterHeight&&1===n.filterWidth&&1===n.dilationHeight&&1===n.dilationWidth&&1===n.strideHeight&&1===n.strideWidth&&("SAME"===n.padInfo.type||"VALID"===n.padInfo.type))return this.conv2dByMatMul(t,e,n,r,o);if(i.getBool("WEBGL_CONV_IM2COL")&&1===t.shape[0])return this.conv2dWithIm2Row(t,e,n,r,o);var a=null!=r,s=o?ns(o,!1):null,u=new ma(n,a,s),l=[t,e];return r&&l.push(r),this.compileAndRun(u,l);},t.prototype.conv2d=function(t,e,n){if(1===n.filterHeight&&1===n.filterWidth&&1===n.dilationHeight&&1===n.dilationWidth&&1===n.strideHeight&&1===n.strideWidth&&("SAME"===n.padInfo.type||"VALID"===n.padInfo.type))return this.conv2dByMatMul(t,e,n);if(i.getBool("WEBGL_CONV_IM2COL")&&1===t.shape[0])return this.conv2dWithIm2Row(t,e,n);var r=new ma(n);return this.compileAndRun(r,[t,e]);},t.prototype.conv2dDerInput=function(t,e,n){var r=new ha(n);return this.compileAndRun(r,[t,e]);},t.prototype.conv2dDerFilter=function(t,e,n){var r=new ca(n);return this.compileAndRun(r,[t,e]);},t.prototype.depthwiseConv2D=function(t,e,n){var r;return i.getBool("WEBGL_PACK_DEPTHWISECONV")&&n.strideWidth<=2&&n.outChannels/n.inChannels==1?(r=new xa(n),this.compileAndRun(r,[t,e],this.makePackedTensor(n.outShape,t.dtype))):(r=new ya(n),this.compileAndRun(r,[t,e]));},t.prototype.depthwiseConv2DDerInput=function(t,e,n){var r=new va(n);return this.compileAndRun(r,[t,e]);},t.prototype.depthwiseConv2DDerFilter=function(t,e,n){var r=new da(n);return this.compileAndRun(r,[t,e]);},t.prototype.conv3d=function(t,e,n){var r=new ga(n);return this.compileAndRun(r,[t,e]);},t.prototype.conv3dDerInput=function(t,e,n){var r=new pa(n);return this.compileAndRun(r,[t,e]);},t.prototype.conv3dDerFilter=function(t,e,n){var r=new fa(n);return this.compileAndRun(r,[t,e]);},t.prototype.maxPool=function(t,e){var n=new vi(e,"max",!1),r=this.makeOutputArray(n.outputShape,t.dtype);return this.compileAndRun(n,[t],r);},t.prototype.avgPool=function(t,e){var n=new vi(e,"avg",!1),r=this.makeOutputArray(n.outputShape,"float32");return this.compileAndRun(n,[t],r);},t.prototype.maxPoolBackprop=function(t,e,n,r){var o=new vi(r,"max",!0),a=this.compileAndRun(o,[e]),i=new ui(r),s=this.makeOutputArray(i.outputShape,e.dtype),u=this.compileAndRun(i,[t,a],s);return a.dispose(),u;},t.prototype.avgPoolBackprop=function(t,e,n){var r=new Ko(n),o=this.makeOutputArray(r.outputShape,e.dtype);return this.compileAndRun(r,[t],o);},t.prototype.cast=function(t,e){return ho(t,e,this);},t.prototype.unstack=function(t,e){for(var n=t.shape[e],r=new Array(t.rank-1),o=0,a=0;a<t.rank;a++){a!==e&&(r[o++]=t.shape[a]);}var i=new Array(t.rank).fill(0),s=t.shape.slice();s[e]=1;var u=new Array(n);for(a=0;a<u.length;a++){i[e]=a,u[a]=this.slice(t,i,s).reshape(r);}return u;},t.prototype.reshape=function(t,e){var n=this.texData.get(t.dataId);return !n.isPacked||Ee(t.shape,e)||null!==n.texture&&Ee(n.shape,e)?fo(t,e):this.packedReshape(t,e);},t.prototype.resizeBilinear=function(t,e,n,r){var o=i.getBool("WEBGL_PACK_IMAGE_OPERATIONS")?new bi(t.shape,e,n,r):new xi(t.shape,e,n,r);return this.compileAndRun(o,[t]);},t.prototype.resizeBilinearBackprop=function(t,e,n){var r=new yi(t,e,n);return this.compileAndRun(r,[t]);},t.prototype.resizeNearestNeighbor=function(t,e,n,r){var o=new Ci(t.shape,e,n,r);return this.compileAndRun(o,[t]);},t.prototype.resizeNearestNeighborBackprop=function(t,e,n){var r=new wi(t,e,n);return this.compileAndRun(r,[t]);},t.prototype.multinomial=function(t,e,n,r){var o=e?t:Kr(t),a=o.shape[0],i=o.shape[1],s=new ci(a,i,n),u=this.makeOutputArray(s.outputShape,"int32"),l=s.getCustomSetupFunc(r);return this.compileAndRun(s,[o],u,l);},t.prototype.oneHot=function(t,e,n,r){var o=new hi(t.size,e,n,r);return this.compileAndRun(o,[t]);},t.prototype.nonMaxSuppression=function(t,e,n,r,o){return tn("tf.nonMaxSuppression() in webgl locks the UI thread. Call tf.nonMaxSuppressionAsync() instead"),bo(t.dataSync(),e.dataSync(),n,r,o);},t.prototype.cropAndResize=function(t,e,n,r,o,a){var i=new ba(t.shape,e.shape,r,o,a);return this.compileAndRun(i,[t,e,n]);},t.prototype.depthToSpace=function(t,e,n){p(e>1,function(){return "blockSize should be > 1 for depthToSpace, but was: "+e;});var r=t.shape[0],o="NHWC"===n?t.shape[1]:t.shape[2],a="NHWC"===n?t.shape[2]:t.shape[3],i="NHWC"===n?t.shape[3]:t.shape[1],s=o*e,u=a*e,l=i/(e*e),c=new Ia("NHWC"===n?[r,s,u,l]:[r,l,s,u],e,n);return this.compileAndRun(c,[t]);},t.prototype.split=function(t,e,n){return Co(t,e,n);},t.prototype.scatterND=function(t,e,n){var r=Mr(0,t,n),o=r.sliceRank,a=r.numUpdates,i=r.sliceSize,s=r.strides,u=r.outputSize,l=[u/i,i],c=t.reshape([a,o]),h=e.reshape([a,i]);if(0===u)return fo(bn([]),n);var f=Cn(0),p=new Ii(a,o,c.rank,h.rank,s,l);return this.compileAndRun(p,[h,c,f]).reshape(n);},t.prototype.sparseToDense=function(t,e,n,r){var o=Mr(0,t,n),a=o.sliceRank,i=o.numUpdates,s=o.strides,u=o.outputSize,l=new Ii(i,a,t.rank,e.rank,s,[u,1],!1);return this.compileAndRun(l,[e,t,r]).reshape(n);},t.prototype.fft=function(t){return this.fftImpl(t,!1);},t.prototype.ifft=function(t){return this.fftImpl(t,!0);},t.prototype.fftImpl=function(t,e){var n=this.texData.get(t.dataId),r=new _a(Ta,t.shape,e),o=new _a(Da,t.shape,e),a=[this.makeComplexComponentTensorHandle(t,n.complexTensors.real),this.makeComplexComponentTensorHandle(t,n.complexTensors.imag)],i=this.compileAndRun(r,a),s=this.compileAndRun(o,a),u=this.complex(i,s).as2D(t.shape[0],t.shape[1]);return i.dispose(),s.dispose(),u;},t.prototype.gatherND=function(t,e){var n=e.shape,r=n[n.length-1],o=Dr(t,e),a=o[0],i=o[1],s=o[2],u=o[3],l=e.reshape([i,r]),c=t.reshape([t.size/s,s]),h=new Pa(r,u,[i,s]);return this.compileAndRun(h,[c,l]).reshape(a);},t.prototype.fill=function(t,e,n){if("string"===(n=n||W(e))){var r=k(n,g(t));return r.fill(e),ht.make(t,{values:r},n);}var o=new Oa(t,e),a=o.getCustomSetupFunc(e),i=this.makeOutputArray(t,n);return this.compileAndRun(o,[],i,a);},t.prototype.onesLike=function(t){if("string"===t.dtype)throw new Error("onesLike is not supported under string dtype");return this.fill(t.shape,1,t.dtype);},t.prototype.zerosLike=function(t){return this.fill(t.shape,"string"===t.dtype?"":0,t.dtype);},t.prototype.linspace=function(t,e,n){return po(t,e,n);},t.prototype.makeOutputArray=function(t,e){return ht.make(t,{},e,this);},t.prototype.makePackedTensor=function(t,e){var n=ht.make(t,{},e,this);return this.texData.get(n.dataId).isPacked=!0,n;},t.prototype.unpackTensor=function(t){var e=new ts(t.shape);return this.compileAndRun(e,[t],ht.make(e.outputShape,{},t.dtype,this));},t.prototype.packTensor=function(t){var e=new fi(t.shape);return this.compileAndRun(e,[t],this.makePackedTensor(t.shape,t.dtype),null,!0);},t.prototype.packedReshape=function(t,e){var n=t.reshape([ye(t.shape)].concat(xe(t.shape))),r=[ye(e)].concat(xe(e)),o=new gi(r,n.shape);return this.compileAndRun(o,[n]).reshape(e);},t.prototype.decode=function(t){var e,n=this.texData.get(t),r=n.isPacked,o=n.shape,a=n.dtype,i=be(o),s=Wt(o),u=this.makeTensorHandle(o,"float32");return this.texData.get(u.dataId).isPacked=!0,this.texData.get(u.dataId).dtype=a,this.texData.get(u.dataId).texShape=s.map(function(t){return 2*t;}),e=r?new Ra(i,s):new Ea(i,s),this.compileAndRun(e,[{shape:i,dtype:a,dataId:t}],u,null,!0),u;},t.prototype.compileAndRun=function(t,e,n,r,o){var a=this;if(void 0===o&&(o=!1),null==n&&(n=t.usesPackedTextures?this.makePackedTensor(t.outputShape,e[0].dtype):this.makeOutputArray(t.outputShape,e[0].dtype)),0===n.size)return this.texData.get(n.dataId).values=N(n.dtype,0),n;var s=e.map(function(e){if("complex64"===e.dtype)throw new Error("GPGPUProgram does not support complex64 input. For complex64 dtypes, please separate the program into real and imaginary parts.");var n=a.texData.get(e.dataId);if(null==n.texture){if(!t.usesPackedTextures&&g(e.shape)<=i.getNumber("WEBGL_SIZE_UPLOAD_UNIFORM"))return {shape:e.shape,texData:null,isUniform:!0,uniformValues:n.values};t.usesPackedTextures&&(n.isPacked=!0,n.shape=e.shape);}else if(!!n.isPacked!=!!t.usesPackedTextures)e=n.isPacked?a.unpackTensor(e):a.packTensor(e),n=a.texData.get(e.dataId);else if(n.isPacked&&!Ee(n.shape,e.shape)){var r=e,o=e.shape;e.shape=n.shape,e=a.packedReshape(e,o),n=a.texData.get(e.dataId),r.shape=o;}return a.uploadToGPU(e.dataId),{shape:e.shape,texData:n,isUniform:!1};});this.uploadToGPU(n.dataId);var u,l={shape:n.shape,texData:this.texData.get(n.dataId),isUniform:!1},c=function(t,e,n){var r="";e.concat(n).forEach(function(t){var e=null!=t.texData&&null!=t.texData.slice&&t.texData.slice.flatOffset>0,n=t.isUniform?"uniform":t.texData.texShape;r+=t.shape+"_"+n+"_"+e;});var o=t.userCode,a=t.constructor.name;return a+="_"+r+"_"+o;}(t,s,l),h=this.getAndSaveBinary(c,function(){return function(t,e,n,r){var o=e.userCode,a=n.map(function(t,n){var r={logicalShape:t.shape,texShape:t.isUniform?null:t.texData.texShape,isUniform:t.isUniform,isPacked:!t.isUniform&&t.texData.isPacked,flatOffset:null};return null!=t.texData&&null!=t.texData.slice&&t.texData.slice.flatOffset>0&&(r.flatOffset=t.texData.slice.flatOffset),{name:e.variableNames[n],shapeInfo:r};}),s=a.map(function(t){return t.shapeInfo;}),u={logicalShape:r.shape,texShape:r.texData.texShape,isUniform:!1,isPacked:r.texData.isPacked,flatOffset:null},l=Mo(a,u,o,e.usesPackedTextures),c=t.createProgram(l),h=null,f=t.getUniformLocation(c,"NAN",!1);1===i.getNumber("WEBGL_VERSION")&&(h=t.getUniformLocation(c,"INFINITY",!1));for(var p={},d=0;d<e.variableNames.length;d++){var v=e.variableNames[d];p[v]=t.getUniformLocation(c,v,!1),p["offset"+v]=t.getUniformLocation(c,"offset"+v,!1);}return {program:e,source:l,webGLProgram:c,uniformLocations:p,inShapeInfos:s,outShapeInfo:u,infLoc:h,nanLoc:f};}(a.gpgpu,t,s,l);}),f=null!=this.activeTimers;return f&&(u=this.startTimer()),function(t,e,n,r,o){ri(e.inShapeInfos,n),ri([e.outShapeInfo],[r]);var a=r.texData.texture,s=r.texData.texShape;r.texData.isPacked?t.setOutputPackedMatrixTexture(a,s[0],s[1]):t.setOutputMatrixTexture(a,s[0],s[1]),t.setProgram(e.webGLProgram),1===i.getNumber("WEBGL_VERSION")&&null!==e.infLoc&&t.gl.uniform1f(e.infLoc,1/0),null!==e.nanLoc&&t.gl.uniform1f(e.nanLoc,NaN),n.forEach(function(n,r){var o=e.program.variableNames[r],a=e.uniformLocations[o],i=e.uniformLocations["offset"+o];if(null!=a)if(n.isUniform){if(g(n.shape)<2)t.gl.uniform1f(a,n.uniformValues[0]);else{var s=n.uniformValues;s instanceof Float32Array||(s=new Float32Array(s)),t.gl.uniform1fv(a,s);}}else null!=n.texData.slice&&null!=i&&t.gl.uniform1i(i,n.texData.slice.flatOffset),t.setInputMatrixTexture(n.texData.texture,a,r);}),null!=o&&o(t,e.webGLProgram),t.executeProgram();}(this.gpgpu,h,s,l,r),f&&(u=this.endTimer(u),this.activeTimers.push({name:t.constructor.name,query:this.getQueryTime(u)})),!i.getBool("WEBGL_LAZILY_UNPACK")&&this.texData.get(n.dataId).isPacked&&!1===o?this.unpackTensor(n):n;},t.prototype.getAndSaveBinary=function(t,e){return t in this.binaryCache||(this.binaryCache[t]=e()),this.binaryCache[t];},t.prototype.getTextureManager=function(){return this.textureManager;},t.prototype.dispose=function(){this.disposed||(this.textureManager.dispose(),null!=this.canvas&&null!=this.canvas.remove?this.canvas.remove():this.canvas=null,null!=this.fromPixels2DContext&&this.fromPixels2DContext.canvas.remove&&this.fromPixels2DContext.canvas.remove(),this.gpgpuCreatedLocally&&(this.gpgpu.program=null,this.gpgpu.dispose()),this.disposed=!0);},t.prototype.floatPrecision=function(){var t=this;return null==this.floatPrecisionValue&&(this.floatPrecisionValue=ze(function(){var e=i.getBool("DEBUG");i.set("DEBUG",!1);var n=t.abs(Cn(1e-8)).dataSync()[0];return i.set("DEBUG",e),n>0?32:16;})),this.floatPrecisionValue;},t.prototype.epsilon=function(){return 32===this.floatPrecision()?1e-7:1e-4;},t.prototype.uploadToGPU=function(t){var e,n=this.texData.get(t),r=n.shape,o=n.dtype,a=n.values,i=n.texture,s=n.usage,u=n.isPacked;if(null==i){var l,c=null!=this.activeTimers;c&&(l=j());var h=n.texShape;if(null==h&&(h=we(r,u),n.texShape=h),null!=a){var f=be(r),p=void 0,d=h[1],v=h[0],m=a instanceof Uint8Array;u?(d=(e=Ut(h[0],h[1]))[0],v=e[1],p=new Aa(f,[v,d],m)):p=new ka(f,[v,d],m);var y=this.makeTensorHandle([v,d],o);this.texData.get(y.dataId).usage=m?Dt.PIXELS:Dt.UPLOAD,this.gpgpu.uploadDenseMatrixToTexture(this.getTexture(y.dataId),d,v,a);var x=this.makeTensorHandle(p.outputShape,y.dtype);x.size=g(p.outputShape),this.texData.get(x.dataId).isPacked=u,this.compileAndRun(p,[y],x);var b=this.texData.get(x.dataId);n.texture=b.texture,n.texShape=b.texShape,n.isPacked=b.isPacked,n.usage=b.usage,this.disposeData(y.dataId),this.texData["delete"](x.dataId),n.values=null,c&&(this.uploadWaitMs+=j()-l);}else{var w=this.acquireTexture(h,s,o,u);n.texture=w;}}},t.prototype.convertAndCacheOnCPU=function(t,e){var n=this.texData.get(t),r=n.dtype;return this.releaseGPUData(t),null!=e&&(n.values=function(t,e){if("float32"===e||"complex64"===e)return t;if("int32"===e||"bool"===e){for(var n="int32"===e?new Int32Array(t.length):new Uint8Array(t.length),r=0;r<n.length;++r){n[r]=Math.round(t[r]);}return n;}throw new Error("Unknown dtype "+e);}(e,r)),n.values;},t.prototype.acquireTexture=function(t,e,n,r){if(this.numBytesInGPU+=this.computeBytes(t,n),!this.warnedAboutMemory&&this.numBytesInGPU>1024*this.numMBBeforeWarning*1024){var o=(this.numBytesInGPU/1024/1024).toFixed(2);this.warnedAboutMemory=!0,console.warn("High memory usage in GPU: "+o+" MB, most likely due to a memory leak");}return this.textureManager.acquireTexture(t,e,r);},t.prototype.computeBytes=function(t,e){return t[0]*t[1]*F(e);},t;}();Tt()&&At.registerBackend("webgl",function(){return new os();},2);var as=mn({abs_:function abs_(t){var e=rn(t,"x","abs");return "complex64"===e.dtype?At.runKernel(function(t){return t.complexAbs(e);},{$x:e}):At.runKernel(function(t,n){var r=t.abs(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.mul(n.toFloat().step(-1));}};});}}),is=mn({acos_:function acos_(t){var e=rn(t,"x","acos");return At.runKernel(function(t,n){var r=t.acos(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.divStrict(Cn(1).sub(n.toFloat().square()).sqrt()).neg();}};});}}),ss=mn({acosh_:function acosh_(t){var e=rn(t,"x","acosh");return At.runKernel(function(t,n){var r=t.acosh(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.divStrict(n.toFloat().square().sub(1).sqrt());}};});}}),us=mn({asin_:function asin_(t){var e=rn(t,"x","asin");return At.runKernel(function(t,n){var r=t.asin(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.divStrict(Cn(1).sub(n.toFloat().square()).sqrt());}};});}}),ls=mn({asinh_:function asinh_(t){var e=rn(t,"x","asinh");return At.runKernel(function(t,n){var r=t.asinh(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.divStrict(Cn(1).add(n.toFloat().square()).sqrt());}};});}}),cs=mn({atan_:function atan_(t){var e=rn(t,"x","atan");return At.runKernel(function(t,n){var r=t.atan(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.div(n.toFloat().square().add(1));}};});}}),hs=mn({atanh_:function atanh_(t){var e=rn(t,"x","atanh");return At.runKernel(function(t,n){var r=t.atanh(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.div(Cn(1).sub(n.toFloat().square()));}};});}}),fs=mn({ceil_:function ceil_(t){var e=rn(t,"x","ceil");return At.runKernel(function(t){return t.ceil(e);},{$x:e},function(t){return {$x:function $x(){return Mn(t);}};});}}),ps=mn({clipByValue_:function clipByValue_(t,e,n){var r=rn(t,"x","clipByValue");return p(e<=n,function(){return "Error in clip: min ("+e+") must be less than or equal to max ("+n+").";}),At.runKernel(function(t,o){var a=t.clip(r,e,n);return o([r]),a;},{$x:r},function(t,r){var o=r[0];return {$x:function $x(){return t.where(o.greaterEqual(e).logicalAnd(o.lessEqual(n)),Mn(t));}};});}}),ds=mn({cos_:function cos_(t){var e=rn(t,"x","cos");return At.runKernel(function(t,n){var r=t.cos(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return n.toFloat().sin().neg().mul(t);}};});}}),vs=mn({cosh_:function cosh_(t){var e=rn(t,"x","cosh");return At.runKernel(function(t,n){var r=t.cosh(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return n.toFloat().sinh().mulStrict(t);}};});}}),ms=mn({erf_:function erf_(t){var e=rn(t,"x","erf");return p("int32"===e.dtype||"float32"===e.dtype,function(){return "Input dtype must be `int32` or `float32`.";}),"int32"===e.dtype&&(e=e.toFloat()),At.runKernel(function(t,n){var r=t.erf(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.mul(n.square().neg().exp().mul(2/Math.sqrt(Math.PI)));}};});}}),gs=mn({exp_:function exp_(t){var e=rn(t,"x","exp");return At.runKernel(function(t,n){var r=t.exp(e);return n([r]),r;},{$x:e},function(t,e){return {$x:function $x(){return t.mulStrict(e[0]);}};});}}),ys=mn({expm1_:function expm1_(t){var e=rn(t,"x","expm1");return At.runKernel(function(t,n){var r=t.expm1(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.mul(n.exp());}};});}}),xs=mn({floor_:function floor_(t){var e=rn(t,"x","floor");return At.runKernel(function(t){return t.floor(e);},{$x:e},function(t){return {$x:function $x(){return Mn(t);}};});}}),bs=mn({log_:function log_(t){var e=rn(t,"x","log");return At.runKernel(function(t,n){var r=t.log(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.div(n.toFloat());}};});}}),ws=mn({log1p_:function log1p_(t){var e=rn(t,"x","log1p");return At.runKernel(function(t,n){var r=t.log1p(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.div(n.add(1));}};});}}),Cs=mn({logSigmoid_:function logSigmoid_(t){var e=rn(t,"x","logSigmoid");return At.runKernel(function(t,n){var r=t.softplus(e.neg()).neg();return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.mul(n.neg().sigmoid());}};});}}),Es=mn({neg_:function neg_(t){var e=rn(t,"x","neg");return At.runKernel(function(t){return t.neg(e);},{$x:e},function(t){return {$x:function $x(){return t.neg();}};});}}),Rs=mn({reciprocal_:function reciprocal_(t){var e=rn(t,"x","reciprocal");return At.runKernel(function(t,n){var r=t.reciprocal(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.div(n.square().neg());}};});}}),Is=mn({round_:function round_(t){var e=rn(t,"x","round");return At.runKernel(function(t){return t.round(e);},{$x:e},function(t){return {$x:function $x(){return Mn(t);}};});}}),Ss=mn({rsqrt_:function rsqrt_(t){var e=rn(t,"x","rsqrt");return At.runKernel(function(t,n){var r=t.rsqrt(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.div(n.pow(1.5).mul(2)).neg();}};});}}),Ns=mn({sigmoid_:function sigmoid_(t){var e=rn(t,"x","sigmoid");return At.runKernel(function(t,n){var r=t.sigmoid(e);return n([r]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.mul(n.mul(Cn(1).sub(n)));}};});}}),ks=mn({sign_:function sign_(t){var e=rn(t,"x","sign");return At.runKernel(function(t){return t.sign(e);},{$x:e},function(t){return {$x:function $x(){return Mn(t);}};});}}),As=mn({isNaN_:function isNaN_(t){var e=rn(t,"x","isNaN");return At.runKernel(function(t){return t.isNaN(e);},{$x:e},function(t){return {$x:function $x(){return Mn(t);}};});}}),Ts=mn({isInf_:function isInf_(t){var e=rn(t,"x","isInf");return At.runKernel(function(t){return t.isInf(e);},{$x:e},function(t){return {$x:function $x(){return Mn(t);}};});}}),Ds=mn({isFinite_:function isFinite_(t){var e=rn(t,"x","isFinite");return At.runKernel(function(t){return t.isFinite(e);},{$x:e},function(t){return {$x:function $x(){return Mn(t);}};});}}),_s=mn({sin_:function sin_(t){var e=rn(t,"x","sin");return At.runKernel(function(t,n){var r=t.sin(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return n.toFloat().cos().mul(t);}};});}}),Os=mn({sinh_:function sinh_(t){var e=rn(t,"x","sinh");return At.runKernel(function(t,n){var r=t.sinh(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return n.toFloat().cosh().mulStrict(t);}};});}}),Fs=mn({softplus_:function softplus_(t){var e=rn(t,"x","softplus");return At.runKernel(function(t,n){var r=t.softplus(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.mul(n.sigmoid());}};});}}),Ms=mn({sqrt_:function sqrt_(t){var e=rn(t,"x","sqrt");return At.runKernel(function(t,n){var r=t.sqrt(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.div(n.toFloat().sqrt().mul(2));}};});}}),Bs=mn({square_:function square_(t){var e=rn(t,"x","square");return At.runKernel(function(t,n){return n([e]),t.square(e);},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.mul(n.toFloat().mul(2));}};});}}),Ps=mn({step_:function step_(t,e){void 0===e&&(e=0);var n=rn(t,"x","step");return At.runKernel(function(t){return t.step(n,e);},{$x:n},function(t){return {$x:function $x(){return Mn(t);}};});}}),Ls=mn({tan_:function tan_(t){var e=rn(t,"x","tan");return At.runKernel(function(t,n){var r=t.tan(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.div(n.cos().square());}};});}}),Ws=mn({tanh_:function tanh_(t){var e=rn(t,"x","tanh");return At.runKernel(function(t,n){var r=t.tanh(e);return n([r]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return Cn(1).sub(n.square()).mulStrict(t);}};});}});function Us(t,e,n,r,o,a){var i,s,u=rn(t,"x","batchNorm"),l=rn(e,"mean","batchNorm"),c=rn(n,"variance","batchNorm");return null!=o&&(i=rn(o,"scale","batchNorm")),null!=r&&(s=rn(r,"offset","batchNorm")),p(2===u.rank,function(){return "Error in batchNorm3D: x must be rank 3 but got rank "+u.rank+".";}),p(2===l.rank||1===l.rank,function(){return "Error in batchNorm2D: mean must be rank 2 or rank 1 but got rank "+l.rank+".";}),p(2===c.rank||1===c.rank,function(){return "Error in batchNorm2D: variance must be rank 2 or rank 1 but got rank "+c.rank+".";}),null!=i&&p(2===i.rank||1===i.rank,function(){return "Error in batchNorm2D: scale must be rank 2 or rank 1 but got rank "+i.rank+".";}),null!=s&&p(2===s.rank||1===s.rank,function(){return "Error in batchNorm2D: offset must be rank 2 or rank 1 but got rank "+s.rank+".";}),Gs(u,l,c,s,i,a);}function zs(t,e,n,r,o,a){var i,s,u=rn(t,"x","batchNorm"),l=rn(e,"mean","batchNorm"),c=rn(n,"variance","batchNorm");return null!=o&&(i=rn(o,"scale","batchNorm")),null!=r&&(s=rn(r,"offset","batchNorm")),p(3===u.rank,function(){return "Error in batchNorm3D: x must be rank 3 but got rank "+u.rank+".";}),p(3===l.rank||1===l.rank,function(){return "Error in batchNorm3D: mean must be rank 3 or rank 1 but got rank "+l.rank+".";}),p(3===c.rank||1===c.rank,function(){return "Error in batchNorm3D: variance must be rank 3 or rank 1 but got rank "+c.rank+".";}),null!=i&&p(3===i.rank||1===i.rank,function(){return "Error in batchNorm3D: scale must be rank 3 or rank 1 but got rank "+i.rank+".";}),null!=s&&p(3===s.rank||1===s.rank,function(){return "Error in batchNorm3D: offset must be rank 3 or rank 1 but got rank "+s.rank+".";}),Gs(u,l,c,s,i,a);}function Vs(t,e,n,r,o,a){var i,s,u=rn(t,"x","batchNorm"),l=rn(e,"mean","batchNorm"),c=rn(n,"variance","batchNorm");return null!=o&&(i=rn(o,"scale","batchNorm")),null!=r&&(s=rn(r,"offset","batchNorm")),p(4===u.rank,function(){return "Error in batchNorm4D: x must be rank 4 but got rank "+u.rank+".";}),p(4===l.rank||1===l.rank,function(){return "Error in batchNorm4D: mean must be rank 4 or rank 1 but got rank "+l.rank+".";}),p(4===c.rank||1===c.rank,function(){return "Error in batchNorm4D: variance must be rank 4 or rank 1 but got rank "+c.rank+".";}),null!=i&&p(4===i.rank||1===i.rank,function(){return "Error in batchNorm4D: scale must be rank 4 or rank 1 but got rank "+i.rank+".";}),null!=s&&p(4===s.rank||1===s.rank,function(){return "Error in batchNorm4D: offset must be rank 4 or rank 1 but got rank "+s.rank+".";}),Gs(u,l,c,s,i,a);}function Gs(t,e,n,r,o,a){null==a&&(a=.001);var i,s,u,l=rn(t,"x","batchNorm"),c=rn(e,"mean","batchNorm"),h=rn(n,"variance","batchNorm");null!=o&&(i=rn(o,"scale","batchNorm")),null!=r&&(s=rn(r,"offset","batchNorm")),p(c.rank===h.rank,function(){return "Batch normalization gradient requires mean and variance to have equal ranks.";}),p(null==s||c.rank===s.rank,function(){return "Batch normalization gradient requires mean and offset to have equal ranks.";}),p(null==i||c.rank===i.rank,function(){return "Batch normalization gradient requires mean and scale to have equal ranks.";}),u=0===l.rank||1===l.rank?l.as4D(1,1,1,l.size):2===l.rank?l.as4D(1,1,l.shape[0],l.shape[1]):3===l.rank?l.as4D(1,l.shape[0],l.shape[1],l.shape[2]):l;return At.runKernel(function(t,e){var n=t.batchNormalization(u,Hs(c),Hs(h),a,Hs(i),Hs(s));return e([l,c,h,i]),n;},{$x:l,$mean:c,$variance:h,$scale:i,$offset:s},function(t,e){var n=e,r=n[0],o=n[1],i=n[2],s=n[3],l=null==s?Cn(1):s,c=Zr(o.shape,u.shape),h=[];if(1===o.rank){for(var f=0;f<u.shape.length-1;++f){h.push(u.shape[f]);}h.push(1);}var p=r.sub(o),d=t.mul(l),v=Ss(i.add(Cn(a))),m=v.mul(v).mul(v).mul(Cn(-.5));return {$x:function $x(){return 1===o.rank?t.mul(Cr(v.as4D(1,1,1,o.shape[0]),h)).mul(l).reshape(r.shape):t.mul(v).mul(l).reshape(r.shape);},$mean:function $mean(){var t=v.mul(Cn(-1)).mul(d);return 1===o.rank&&(t=t.sum(c)),t.reshape(o.shape);},$variance:function $variance(){var t=m.mul(p).mul(d);return 1===o.rank&&(t=t.sum(c)),t.reshape(o.shape);},$scale:function $scale(){var e=p.mul(v),n=t.mul(e);return 1===o.rank&&(n=n.sum(c)),n.reshape(o.shape);},$offset:function $offset(){var e=t;return 1===o.rank&&(e=e.sum(c)),e.reshape(o.shape);}};}).reshape(l.shape);}function Hs(t){return null==t?null:0===t.rank?t.as1D():1===t.rank?t:2===t.rank?t.as4D(1,1,t.shape[0],t.shape[1]):3===t.rank?t.as4D(1,t.shape[0],t.shape[1],t.shape[2]):t;}function qs(){Pe("tf.batchNormalization() is going away. Use tf.batchNorm() instead, and note the positional argument change of scale, offset, and varianceEpsilon");}var $s=mn({batchNormalization2d_:function batchNormalization2d_(t,e,n,r,o,a){return void 0===r&&(r=.001),qs(),Us(t,e,n,a,o,r);}}),js=mn({batchNormalization3d_:function batchNormalization3d_(t,e,n,r,o,a){return void 0===r&&(r=.001),qs(),zs(t,e,n,a,o,r);}}),Ks=mn({batchNormalization4d_:function batchNormalization4d_(t,e,n,r,o,a){return void 0===r&&(r=.001),qs(),Vs(t,e,n,a,o,r);}}),Xs=mn({batchNormalization_:function batchNormalization_(t,e,n,r,o,a){return void 0===r&&(r=.001),qs(),Gs(t,e,n,a,o,r);}}),Ys=mn({batchNorm_:Gs}),Qs=mn({batchNorm2d_:Us}),Js=mn({batchNorm3d_:zs}),Zs=mn({batchNorm4d_:Vs});function tu(t,e,n,r,o,a){p(t.length===e.rank,function(){return "Length of inShape ("+t.length+") and rank of dy ("+e.rank+") must match";});var i=t,s=e,u=!1;3===e.rank&&(u=!0,s=e.as4D(1,e.shape[0],e.shape[1],e.shape[2]),i=[1,t[0],t[1],t[2]]);var l=i[3],c=s.shape[3];p(4===i.length,function(){return "Error in conv2dDerInput: inShape must be length 4, but got length "+i.length+".";}),p(4===s.rank,function(){return "Error in conv2dDerInput: dy must be rank 4, but got rank "+s.rank;}),p(4===n.rank,function(){return "Error in conv2dDerInput: filter must be rank 4, but got rank "+n.rank;}),p(l===n.shape[2],function(){return "Error in conv2dDerInput: depth of input ("+l+") must match input depth for filter "+n.shape[2]+".";}),p(c===n.shape[3],function(){return "Error in conv2dDerInput: depth of output ("+c+") must match output depth for filter "+n.shape[3]+".";}),null!=a&&p(_x(o),function(){return "Error in conv2dDerInput: pad must be an integer when using, dimRoundingMode "+a+" but got pad "+o+".";});var h=no(i,n.shape,r,1,o,a),f=At.runKernel(function(t,e){var r=t.conv2dDerInput(s,n,h);return e([n,s]),r;},{dy4D:s,filter:n},function(t,e){var n=e[0],i=e[1];return {dy4D:function dy4D(){return ou(t,n,r,o,"NHWC",1,a);},filter:function filter(){return iu(t,i,n.shape,r,o,a);}};});return u?f.as3D(f.shape[1],f.shape[2],f.shape[3]):f;}function eu(t,e,n,r,o,a){var i=t;3===t.rank&&(i=t.as4D(1,t.shape[0],t.shape[1],t.shape[2]));var s=e;3===s.rank&&(s=e.as4D(1,e.shape[0],e.shape[1],e.shape[2])),p(4===i.rank,function(){return "Error in conv2dDerFilter: input must be rank 4, but got shape "+i.shape+".";}),p(4===s.rank,function(){return "Error in conv2dDerFilter: dy must be rank 4, but got shape "+s.shape+".";}),p(4===n.length,function(){return "Error in conv2dDerFilter: filterShape must be length 4, but got "+n+".";}),p(i.shape[3]===n[2],function(){return "Error in conv2dDerFilter: depth of input "+i.shape[3]+") must match input depth in filter ("+n[2]+".";}),p(s.shape[3]===n[3],function(){return "Error in conv2dDerFilter: depth of dy ("+s.shape[3]+") must match output depth for filter ("+n[3]+").";}),null!=a&&p(_x(o),function(){return "Error in conv2dDerFilter: pad must be an integer when using, dimRoundingMode "+a+" but got pad "+o+".";});var u=no(i.shape,n,r,1,o,a);return At.runKernel(function(t){return t.conv2dDerFilter(i,s,u);},{x4D:i,dy4D:s});}function nu(t){var e=function(t){return "number"==typeof t?[t,t,t]:2===t.length?[t[0],t[1],1]:t;}(t),n=e[0],r=e[1],o=e[2];return 1===n&&1===r&&1===o;}var ru=mn({conv1d_:function conv1d_(t,e,n,r,o,a,i){void 0===o&&(o="NWC"),void 0===a&&(a=1);var s=rn(t,"x","conv1d"),u=rn(e,"filter","conv1d"),l=s,c=!1;2===s.rank&&(c=!0,l=s.as3D(1,s.shape[0],s.shape[1])),p(3===l.rank,function(){return "Error in conv1d: input must be rank 3, but got rank "+l.rank+".";}),p(3===u.rank,function(){return "Error in conv1d: filter must be rank 3, but got rank "+u.rank+".";}),null!=i&&p(_x(r),function(){return "Error in conv1d: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+r+".";}),p(l.shape[2]===u.shape[1],function(){return "Error in conv1d: depth of input ("+l.shape[2]+") must match input depth for filter "+u.shape[1]+".";}),p(co(n,a),function(){return "Error in conv1D: Either stride or dilation must be 1. Got stride "+n+" and dilation '"+a+"'";}),p("NWC"===o,function(){return "Error in conv1d: got dataFormat of "+o+" but only NWC is currently supported.";});var h=u.as4D(1,u.shape[0],u.shape[1],u.shape[2]),f=l.as4D(l.shape[0],1,l.shape[1],l.shape[2]),d=ou(f,h,[1,n],r,"NHWC",[1,a],i);return c?d.as2D(d.shape[2],d.shape[3]):d.as3D(d.shape[0],d.shape[2],d.shape[3]);}}),ou=mn({conv2d_:function conv2d_(t,e,n,r,o,a,i){void 0===o&&(o="NHWC"),void 0===a&&(a=[1,1]);var s=rn(t,"x","conv2d"),u=rn(e,"filter","conv2d"),l=s,c=!1;3===s.rank&&(c=!0,l=s.as4D(1,s.shape[0],s.shape[1],s.shape[2])),p(4===l.rank,function(){return "Error in conv2d: input must be rank 4, but got rank "+l.rank+".";}),p(4===u.rank,function(){return "Error in conv2d: filter must be rank 4, but got rank "+u.rank+".";}),null!=i&&p(_x(r),function(){return "Error in conv2d: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+r+".";}),p(l.shape[3]===u.shape[2],function(){return "Error in conv2d: depth of input ("+l.shape[3]+") must match input depth for filter "+u.shape[2]+".";}),p(co(n,a),function(){return "Error in conv2D: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+a+"'";}),p("NHWC"===o,function(){return "Error in conv2d: got dataFormat of "+o+" but only NHWC is currently supported.";});var h=no(l.shape,u.shape,n,a,r,i),f=At.runKernel(function(t,e){var n=t.conv2d(l,u,h);return e([u,l]),n;},{x:l,$filter:u},function(t,e){var o=e,i=o[0],s=o[1];return p(lo(a),function(){return "Error in gradient of conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '"+a+"'";}),{x:function x(){return tu(s.shape,t,i,n,r);},$filter:function $filter(){return eu(s,t,i.shape,n,r);}};});return c?f.as3D(f.shape[1],f.shape[2],f.shape[3]):f;}}),au=mn({conv3d_:function conv3d_(t,e,n,r,o,a){void 0===o&&(o="NDHWC"),void 0===a&&(a=[1,1,1]);var i=rn(t,"x","conv3d"),s=rn(e,"filter","conv3d"),u=i,l=!1;4===i.rank&&(l=!0,u=i.as5D(1,i.shape[0],i.shape[1],i.shape[2],i.shape[3])),p(5===u.rank,function(){return "Error in conv3d: input must be rank 5, but got rank "+u.rank+".";}),p(5===s.rank,function(){return "Error in conv3d: filter must be rank 5, but got rank "+s.rank+".";}),p(u.shape[4]===s.shape[3],function(){return "Error in conv3d: depth of input ("+u.shape[4]+") must match input depth for filter "+s.shape[3]+".";}),p(function(t,e){return nu(t)||nu(e);}(n,a),function(){return "Error in conv3D: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+a+"'";}),p("NDHWC"===o,function(){return "Error in conv3d: got dataFormat of "+o+" but only NDHWC is currently supported.";});var c=ro(u.shape,s.shape,n,a,r),h=At.runKernel(function(t,e){var n=t.conv3d(u,s,c);return e([u,s]),n;},{x:u,$filter:s},function(t,e){p(nu(a),function(){return "Error in gradient of conv3D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '"+a+"'";});var o=e[0],i=e[1];return {x:function x(){return function(t,e,n,r,o){p(t.length===e.rank,function(){return "Length of inShape ("+t.length+") and rank of dy ("+e.rank+") must match";});var a=t,i=e,s=!1;4===e.rank&&(s=!0,i=e.as5D(1,e.shape[0],e.shape[1],e.shape[2],e.shape[3]),a=[1,t[0],t[1],t[2],t[3]]);var u=a[4],l=i.shape[4];p(5===a.length,function(){return "Error in conv3dDerInput: inShape must be length 5, but got length "+a.length+".";}),p(5===i.rank,function(){return "Error in conv3dDerInput: dy must be rank 5, but got rank "+i.rank;}),p(5===n.rank,function(){return "Error in conv3dDerInput: filter must be rank 5, but got rank "+n.rank;}),p(u===n.shape[3],function(){return "Error in conv3dDerInput: depth of input ("+u+") must match input depth for filter "+n.shape[3]+".";}),p(l===n.shape[4],function(){return "Error in conv3dDerInput: depth of output ("+l+") must match output depth for filter "+n.shape[4]+".";});var c=ro(a,n.shape,r,1,o),h=At.runKernel(function(t){return t.conv3dDerInput(i,n,c);},{dy5D:i});return s?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h;}(o.shape,t,i,n,r);},$filter:function $filter(){return function(t,e,n,r,o){var a=t;4===t.rank&&(a=t.as5D(1,t.shape[0],t.shape[1],t.shape[2],t.shape[3]));var i=e;4===i.rank&&(i=e.as5D(1,e.shape[0],e.shape[1],e.shape[2],e.shape[3])),p(5===a.rank,function(){return "Error in conv3dDerFilter: input must be rank 5, but got shape "+a.shape+".";}),p(5===i.rank,function(){return "Error in conv3dDerFilter: dy must be rank 5, but got shape "+i.shape+".";}),p(5===n.length,function(){return "Error in conv3dDerFilter: filterShape must be length 5, but got "+n+".";}),p(a.shape[4]===n[3],function(){return "Error in conv3dDerFilter: depth of input "+a.shape[4]+") must match input depth in filter ("+n[3]+".";}),p(i.shape[4]===n[4],function(){return "Error in conv3dDerFilter: depth of dy ("+i.shape[4]+") must match output depth for filter ("+n[4]+").";});var s=ro(a.shape,n,r,1,o);return At.runKernel(function(t){return t.conv3dDerFilter(a,i,s);},{x5D:a,dy5D:i});}(o,t,i.shape,n,r);}};});return l?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h;}}),iu=mn({conv2dDerFilter_:eu}),su=mn({conv2dDerInput_:tu}),uu=mn({depthwiseConv2d_:function depthwiseConv2d_(t,e,n,r,o,a,i){void 0===o&&(o="NHWC"),void 0===a&&(a=[1,1]);var s=rn(t,"x","depthwiseConv2d"),u=rn(e,"filter","depthwiseConv2d"),l=s,c=!1;3===s.rank&&(c=!0,l=s.as4D(1,s.shape[0],s.shape[1],s.shape[2])),p(4===l.rank,function(){return "Error in depthwiseConv2d: input must be rank 4, but got rank "+l.rank+".";}),p(4===u.rank,function(){return "Error in depthwiseConv2d: filter must be rank 4, but got rank "+u.rank+".";}),p(l.shape[3]===u.shape[2],function(){return "Error in depthwiseConv2d: number of input channels ("+l.shape[3]+") must match the inChannels dimension in filter "+u.shape[2]+".";}),null==a&&(a=[1,1]),p(co(n,a),function(){return "Error in depthwiseConv2d: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+a+"'";}),null!=i&&p(_x(r),function(){return "Error in depthwiseConv2d: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+r+".";});var h=no(l.shape,u.shape,n,a,r,i,!0),f=At.runKernel(function(t,e){var n=t.depthwiseConv2D(l,u,h);return e([l,u]),n;},{x:l,$filter:u},function(t,e){p(lo(a),function(){return "Error in gradient of depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations '"+a+"'";});var n=e[0],r=e[1];return {x:function x(){return function(t,e,n,r){var o=e,a=!1;3===e.rank&&(a=!0,o=e.as4D(1,e.shape[0],e.shape[1],e.shape[2]));var i=At.runKernel(function(t){return t.depthwiseConv2DDerInput(o,n,r);},{dy4D:o});return a?i.as3D(i.shape[1],i.shape[2],i.shape[3]):i;}(n.shape,t,r,h);},$filter:function $filter(){return function(t,e,n,r){var o=t;3===t.rank&&(o=t.as4D(1,t.shape[0],t.shape[1],t.shape[2]));var a=e;return 3===a.rank&&(a=e.as4D(1,e.shape[0],e.shape[1],e.shape[2])),At.runKernel(function(t){return t.depthwiseConv2DDerFilter(o,a,r);},{x4D:o,dy4D:a});}(n,t,r.shape,h);}};});return c?f.as3D(f.shape[1],f.shape[2],f.shape[3]):f;}}),lu=mn({separableConv2d_:function separableConv2d_(t,e,n,r,o,a,i){void 0===a&&(a=[1,1]),void 0===i&&(i="NHWC");var s=rn(t,"x","separableConv2d"),u=rn(e,"depthwiseFilter","separableConv2d"),l=rn(n,"pointwiseFilter","separableConv2d"),c=s,h=!1;if(3===s.rank&&(h=!0,c=s.as4D(1,s.shape[0],s.shape[1],s.shape[2])),"NCHW"===i)throw new Error("separableConv2d currently does not support dataFormat NCHW; only NHWC is supported");p(4===c.rank,function(){return "Error in separableConv2d: input must be rank 4, but got rank "+c.rank+".";}),p(4===u.rank,function(){return "Error in separableConv2d: depthwise filter must be rank 4, but got rank "+u.rank+".";}),p(4===l.rank,function(){return "Error in separableConv2d: pointwise filter must be rank 4, but got rank "+u.rank+".";}),p(1===l.shape[0],function(){return "Error in separableConv2d: the first dimension of pointwise filter  must be 1, but got "+l.shape[0]+".";}),p(1===l.shape[1],function(){return "Error in separableConv2d: the second dimension of pointwise filter must be 1, but got "+l.shape[1]+".";});var f=u.shape[2],d=u.shape[3];p(l.shape[2]===f*d,function(){return "Error in separableConv2d: the third dimension of pointwise filter must be "+f*d+", but got "+l.shape[2]+".";});var v=uu(c,u,r,o,i,a),m=ou(v,l,1,"valid",i);return h?m.as3D(m.shape[1],m.shape[2],m.shape[3]):m;}}),cu=mn({conv2dTranspose_:function conv2dTranspose_(t,e,n,r,o,a){return tu(n,rn(t,"x","conv2dTranspose"),rn(e,"filter","conv2dTranspose"),r,o,a);}});var hu=mn({matMul_:function matMul_(t,e,n,r){var o;void 0===n&&(n=!1),void 0===r&&(r=!1);var a=rn(t,"a","matMul"),i=rn(e,"b","matMul");o=Ct(a,i),a=o[0],i=o[1];var s=n?a.shape[a.rank-2]:a.shape[a.rank-1],u=r?i.shape[i.rank-1]:i.shape[i.rank-2],l=n?a.shape[a.rank-1]:a.shape[a.rank-2],c=r?i.shape[i.rank-2]:i.shape[i.rank-1],h=a.shape.slice(0,-2),f=i.shape.slice(0,-2),d=g(h),v=g(f);p(a.rank>=2&&i.rank>=2&&a.rank===i.rank,function(){return "Error in matMul: inputs must have the same rank of at least 2, got ranks "+a.rank+" and "+i.rank+".";}),p(y(h,f),function(){return "Error in matMul: outer dimensions ("+h+") and ("+f+") of Tensors with shapes "+a.shape+" and "+i.shape+" must match.";}),p(s===u,function(){return "Error in matMul: inner shapes ("+s+") and ("+u+") of Tensors with shapes "+a.shape+" and "+i.shape+" and transposeA="+n+" and transposeB="+r+" must match.";});var m=a.shape.slice(0,-2).concat([l,c]),x=n?a.as3D(d,s,l):a.as3D(d,l,s),b=r?i.as3D(v,c,u):i.as3D(v,u,c);return At.runKernel(function(t,e){var o=t.batchMatMul(x,b,n,r);return e([x,b]),o;},{$a:x,$b:b},function(t,e){var o=e,a=o[0],i=o[1];return n||r?!n&&r?{$a:function $a(){return t.matMul(i,!1,!1);},$b:function $b(){return t.matMul(a,!0,!1);}}:n&&!r?{$a:function $a(){return i.matMul(t,!1,!0);},$b:function $b(){return a.matMul(t,!1,!1);}}:{$a:function $a(){return i.matMul(t,!0,!0);},$b:function $b(){return t.matMul(a,!0,!0);}}:{$a:function $a(){return t.matMul(i,!1,!0);},$b:function $b(){return a.matMul(t,!0,!1);}};}).reshape(m);}}),fu=mn({dot_:function dot_(t,e){var n=rn(t,"t1","dot"),r=rn(e,"t2","dot");p(!(1!==n.rank&&2!==n.rank||1!==r.rank&&2!==r.rank),function(){return "Error in dot: inputs must all be rank 1 or 2, but got ranks "+n.rank+" and "+r.rank+".";});var o=1===n.rank?n.size:n.shape[1],a=1===r.rank?r.size:r.shape[0];return p(o===a,function(){return "Error in dot: inner dimensions of inputs must match, but got "+o+" and "+a+".";}),1===n.rank&&1===r.rank?n.as2D(1,-1).matMul(r.as2D(-1,1)).asScalar():1===n.rank&&2===r.rank?n.as2D(1,-1).matMul(r.as2D(r.shape[0],r.shape[1])).as1D():2===n.rank&&1===r.rank?n.matMul(r.as2D(-1,1)).as1D():n.matMul(r.as2D(r.shape[0],r.shape[1]));}}),pu=mn({outerProduct_:function outerProduct_(t,e){var n=rn(t,"v1","outerProduct"),r=rn(e,"v2","outerProduct");return p(1===n.rank&&1===r.rank,function(){return "Error in outerProduct: inputs must be rank 1, but got ranks "+n.rank+" and "+r.rank+".";}),n.as2D(-1,1).matMul(r.as2D(1,-1));}});var du=mn({reverse_:function reverse_(t,e){var n=rn(t,"x","reverse");if(0===n.rank)return n.clone();var r=I(e,n.shape);return At.runKernel(function(t){return t.reverse(n,r);},{$x:n},function(t){return {$x:function $x(){return t.reverse(r);}};}).reshapeAs(n);}}),vu=mn({reverse1d_:function reverse1d_(t){var e=rn(t,"x","reverse");return p(1===e.rank,function(){return "Error in reverse1D: x must be rank 1 but got rank "+e.rank+".";}),du(e,0);}}),mu=mn({reverse2d_:function reverse2d_(t,e){var n=rn(t,"x","reverse");return p(2===n.rank,function(){return "Error in reverse2D: x must be rank 2 but got rank "+n.rank+".";}),du(n,e);}}),gu=mn({reverse3d_:function reverse3d_(t,e){var n=rn(t,"x","reverse");return p(3===n.rank,function(){return "Error in reverse3D: x must be rank 3 but got rank "+n.rank+".";}),du(n,e);}}),yu=mn({reverse4d_:function reverse4d_(t,e){var n=rn(t,"x","reverse");return p(4===n.rank,function(){return "Error in reverse4D: x must be rank 4 but got rank "+n.rank+".";}),du(n,e);}});function xu(t,e,n,r,o,a){var i=rn(t,"x","maxPool"),s=i,u=!1;3===i.rank&&(u=!0,s=i.as4D(1,i.shape[0],i.shape[1],i.shape[2])),null==r&&(r=[1,1]),p(4===s.rank,function(){return "Error in maxPool: input must be rank 4 but got rank "+s.rank+".";}),p(co(n,r),function(){return "Error in maxPool: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+r+"'";}),null!=a&&p(_x(o),function(){return "Error in maxPool: pad must be an integer when using, dimRoundingMode "+a+" but got pad "+o+".";});var l=eo(s.shape,e,n,r,o,a),c=At.runKernel(function(t,e){var n=t.maxPool(s,l);return e([s,n]),n;},{x:s},function(t,a){var i=a[0],s=a[1];return {x:function x(){return function(t,e,n,r,o,a,i,s){var u=rn(t,"dy","maxPoolBackprop"),l=rn(e,"input","maxPoolBackprop"),c=rn(n,"output","maxPoolBackprop");p(l.rank===u.rank,function(){return "Rank of input ("+l.rank+") does not match rank of dy ("+u.rank+")";}),null==a&&(a=[1,1]),p(co(o,a),function(){return "Error in maxPoolBackProp: Either strides or dilations must be 1. Got strides "+o+" and dilations '"+a+"'";}),p(4===u.rank,function(){return "Error in maxPoolBackprop: dy must be rank 4 but got rank "+u.rank+".";}),p(4===l.rank,function(){return "Error in maxPoolBackprop: input must be rank 4 but got rank "+l.rank+".";}),null!=s&&p(_x(i),function(){return "Error in maxPoolBackprop: pad must be an integer when using, dimRoundingMode "+s+" but got pad "+i+".";});var h=eo(l.shape,r,o,a,i,s);return At.runKernel(function(t){return t.maxPoolBackprop(u,l,c,h);},{$dy:u,$input:l});}(t,i,s,e,n,r,o);}};});return u?c.as3D(c.shape[1],c.shape[2],c.shape[3]):c;}function bu(t,e,n,r,o,a){var i=rn(t,"x","avgPool","float32");null==r&&(r=[1,1]),p(co(n,r),function(){return "Error in avgPool: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+r+"'";});var s=i,u=!1;3===i.rank&&(u=!0,s=i.as4D(1,i.shape[0],i.shape[1],i.shape[2])),p(4===s.rank,function(){return "Error in avgPool: x must be rank 4 but got rank "+s.rank+".";}),null!=a&&p(_x(o),function(){return "Error in avgPool: pad must be an integer when using, dimRoundingMode "+a+" but got pad "+o+".";});var l=eo(s.shape,e,n,r,o,a),c=At.runKernel(function(t){return t.avgPool(s,l);},{x:s},function(t){return {x:function x(){return function(t,e,n,r,o,a){var i=rn(t,"dy","avgPoolBackprop"),s=rn(e,"input","avgPoolBackprop");p(s.rank===i.rank,function(){return "Rank of input ("+s.rank+") does not match rank of dy ("+i.rank+")";}),null==o&&(o=[1,1]),p(co(r,o),function(){return "Error in avgPoolBackprop: Either strides or dilations must be 1. Got strides "+r+" and dilations '"+o+"'";});var u=s,l=i,c=!1;3===s.rank&&(c=!0,u=s.as4D(1,s.shape[0],s.shape[1],s.shape[2]),l=i.as4D(1,i.shape[0],i.shape[1],i.shape[2])),p(4===l.rank,function(){return "Error in avgPoolBackprop: dy must be rank 4 but got rank "+l.rank+".";}),p(4===u.rank,function(){return "Error in avgPoolBackprop: input must be rank 4 but got rank "+u.rank+".";});var h=eo(u.shape,n,r,o,a),f=At.runKernel(function(t){return t.avgPoolBackprop(l,u,h);},{dy4D:l,input4D:u});return c?f.as3D(f.shape[1],f.shape[2],f.shape[3]):f;}(t,s,e,n,r,o);}};});return c=c.cast(i.dtype),u?c.as3D(c.shape[1],c.shape[2],c.shape[3]):c;}var wu=mn({maxPool_:function maxPool_(t,e,n,r,o){return xu(t,e,n,1,r,o);}}),Cu=mn({avgPool_:function avgPool_(t,e,n,r,o){return bu(t,e,n,1,r,o);}}),Eu=mn({pool_:function pool_(t,e,n,r,o,a){null==o&&(o=[1,1]),null==a&&(a=1),0===r&&(r="valid");var i=rn(t,"x","maxPool"),s=i,u=!1;3===i.rank&&(u=!0,s=i.as4D(1,i.shape[0],i.shape[1],i.shape[2])),p(co(a,o),function(){return "Error in pool: Either strides or dilations must be 1. Got strides "+a+" and dilations '"+o+"'";});var l,c=eo(s.shape,e,a,o,r),h=[c.dilationHeight,c.dilationWidth];l="same"===r?function(t,e){var n=t.map(function(t,n){return t+(t-1)*(e[n]-1);}).map(function(t){return t-1;}),r=n.map(function(t){return Math.floor(t/2);}),o=n.map(function(t,e){return t-r[e];});return n.map(function(t,e){return [r[e],o[e]];});}([c.filterHeight,c.filterWidth],h):[[0,0],[0,0]];var f=1===h[0]&&1===h[1],d=function(t,e,n){var r=n.map(function(t){return t[0];}),o=n.map(function(t){return t[1];}),a=t.concat(r,o),i=e.map(function(t,e){return (t-a[e]%t)%t;}),s=o.map(function(t,e){return t+i[e];}),u=e.map(function(t,e){return [r[e],s[e]];}),l=e.map(function(t,e){return [0,i[e]];});return [u,l];}([c.inHeight,c.inWidth],h,l),v=d[0],m=d[1],g=f?r:"valid",y=f?s:xr(s,h,v),x=("avg"===n?function(){return bu(y,e,a,1,g);}:function(){return xu(y,e,a,1,g);})(),b=f?x:er(x,h,m);return u?b.as3D(b.shape[1],b.shape[2],b.shape[3]):b;}});var Ru=mn({slice_:function slice_(t,e,n){var r,o,a=rn(t,"x","slice");if(0===a.rank)throw new Error("Slicing scalar is not possible");r="number"==typeof e?[e].concat(new Array(a.rank-1).fill(0)):e.length<a.rank?e.concat(new Array(a.rank-e.length).fill(0)):e.slice(),o=(o=null==n?new Array(a.rank).fill(-1):"number"==typeof n?[n].concat(new Array(a.rank-1).fill(-1)):n.length<a.rank?n.concat(new Array(a.rank-n.length).fill(-1)):n).map(function(t,e){return t>=0?t:(p(-1===t,function(){return "Bad value in size";}),a.shape[e]-r[e]);}),function(t,e,n){p(t.rank===e.length,function(){return "Error in slice"+t.rank+"D: Length of begin "+e+" must match the rank of the array ("+t.rank+").";}),p(t.rank===n.length,function(){return "Error in slice"+t.rank+"D: Length of size "+n+" must match the rank of the array ("+t.rank+").";});for(var r=function r(_r3){p(e[_r3]+n[_r3]<=t.shape[_r3],function(){return "Error in slice"+t.rank+"D: begin["+_r3+"] + size["+_r3+"] ("+(e[_r3]+n[_r3])+") would overflow input.shape["+_r3+"] ("+t.shape[_r3]+")";});},o=0;o<t.rank;++o){r(o);}}(a,r,o);var i=a.shape;return At.runKernel(function(t){return t.slice(a,r,o);},{$x:a},function(t){for(var e=[],n=0;n<t.rank;n++){e.push([r[n],i[n]-r[n]-o[n]]);}return {$x:function $x(){return t.pad(e);}};});}}),Iu=mn({slice1d_:function slice1d_(t,e,n){var r=rn(t,"x","slice1d");return p(1===r.rank,function(){return "slice1d expects a rank-1 tensor, but got a rank-"+r.rank+" tensor";}),Ru(r,[e],[n]);}}),Su=mn({slice2d_:function slice2d_(t,e,n){var r=rn(t,"x","slice2d");return p(2===r.rank,function(){return "slice2d expects a rank-2 tensor, but got a rank-"+r.rank+" tensor";}),Ru(r,e,n);}}),Nu=mn({slice3d_:function slice3d_(t,e,n){var r=rn(t,"x","slice3d");return p(3===r.rank,function(){return "slice3d expects a rank-3 tensor, but got a rank-"+r.rank+" tensor";}),Ru(r,e,n);}}),ku=mn({slice4d_:function slice4d_(t,e,n){var r=rn(t,"x","slice4d");return p(4===r.rank,function(){return "slice4d expects a rank-4 tensor, but got a rank-"+r.rank+" tensor";}),Ru(r,e,n);}});function Au(t,e,n,r,o){return e.rank<n.rank&&(e=e.reshape(ln(e.shape,r))),t.rank<n.rank&&(t=t.reshape(ln(t.shape,r))),{$x:function $x(){var r=t.mul(n.equal(e).cast(t.dtype));return null==o?r:r.transpose(o);}};}var Tu=mn({all_:function all_(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=rn(t,"x","all","bool"),o=I(e,r.shape),a=o,i=hn(a,r.rank);null!=i&&(r=r.transpose(i),a=pn(a.length,r.rank));var s=At.runKernel(function(t){return t.all(r,a);},{$x:r});if(n){var u=ln(s.shape,o);return s.reshape(u);}return s;}}),Du=mn({any_:function any_(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=rn(t,"x","any","bool"),o=I(e,r.shape),a=o,i=hn(a,r.rank);null!=i&&(r=r.transpose(i),a=pn(a.length,r.rank));var s=At.runKernel(function(t){return t.any(r,a);},{$x:r});if(n){var u=ln(s.shape,o);return s.reshape(u);}return s;}}),_u=mn({argMax_:function argMax_(t,e){void 0===e&&(e=0);var n=rn(t,"x","argMax");null==e&&(e=0);var r=I(e,n.shape),o=hn(r,n.rank);return null!=o&&(n=n.transpose(o),r=pn(r.length,n.rank)),At.runKernel(function(t,e){var o=t.argMax(n,r[0]);return e([n]),o;},{$x:n},function(t,e){var n=e[0];return {$x:function $x(){return Mn(n);}};});}}),Ou=mn({argMin_:function argMin_(t,e){void 0===e&&(e=0);var n=rn(t,"x","argMin");null==e&&(e=0);var r=I(e,n.shape),o=hn(r,n.rank);return null!=o&&(n=n.transpose(o),r=pn(r.length,n.rank)),At.runKernel(function(t,e){var o=t.argMin(n,r[0]);return e([n]),o;},{$x:n},function(t,e){var n=e[0];return {$x:function $x(){return Mn(n);}};});}}),Fu=mn({logSumExp_:function logSumExp_(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=rn(t,"x","logSumExp"),o=I(e,r.shape),a=r.max(o,!0),i=r.sub(a).exp().sum(o).log(),s=a.reshape(i.shape).add(i);if(n){var u=ln(s.shape,o);return s.reshape(u);}return s;}}),Mu=mn({max_:function max_(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=rn(t,"x","max"),o=r,a=I(e,r.shape),i=a,s=hn(i,r.rank);null!=s&&(r=r.transpose(s),i=pn(i.length,r.rank));var u=At.runKernel(function(t,e){var n=t.max(r,i);return e([o,n]),n;},{$x:r},function(t,e){return Au(t,e[1],e[0],a,s);});if(n){var l=ln(u.shape,a);u=u.reshape(l);}return u;}}),Bu=mn({mean_:function mean_(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=rn(t,"x","mean"),o=I(e,r.shape),a=g(un(r.shape,o)[1]);return $r(function(t){var r=Cn(a);return {value:(r.dtype===t.dtype?t:t.cast(r.dtype)).div(r).sum(e,n),gradFunc:function gradFunc(e){var n=t.shape.slice();return o.forEach(function(t){n[t]=1;}),e.reshape(n).mul(An(t.shape,"float32")).div(a);}};})(r);}}),Pu=mn({min_:function min_(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=rn(t,"x","min"),o=r,a=I(e,r.shape),i=a,s=hn(i,r.rank);null!=s&&(r=r.transpose(s),i=pn(i.length,r.rank));var u=At.runKernel(function(t,e){var n=t.min(r,i);return e([o,n]),n;},{$x:r},function(t,e){return Au(t,e[1],e[0],a,s);});if(n){var l=ln(u.shape,a);u=u.reshape(l);}return u;}}),Lu=mn({moments_:function moments_(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=I(e,(t=rn(t,"x","moments")).shape),o=t.mean(r,n),a=o.shape;n||(a=ln(o.shape,r));var i=t.toFloat().sub(o.reshape(a)).square();return {mean:o,variance:i.mean(r,n)};}}),Wu=mn({sum_:function sum_(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=rn(t,"x","sum");"bool"===r.dtype&&(r=r.toInt());var o=I(e,r.shape);return $r(function(t){var e=hn(o,t.rank),r=o,a=t;null!=e&&(a=t.transpose(e),r=pn(r.length,t.rank));var i=At.runKernel(function(t){return t.sum(a,r);},{permutedX:a});if(n){var s=ln(i.shape,o);i=i.reshape(s);}return {value:i,gradFunc:function gradFunc(e){var n=t.shape.slice();return o.forEach(function(t){n[t]=1;}),e.reshape(n).mul(An(t.shape,"float32"));}};})(r);}}),Uu=mn({prod_:function prod_(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=rn(t,"x","prod");"bool"===r.dtype&&(r=r.toInt());var o=I(e,r.shape),a=hn(o,r.rank),i=o,s=r;null!=a&&(s=r.transpose(a),i=pn(i.length,r.rank));var u=At.runKernel(function(t){return t.prod(s,i);},{permutedX:s});if(n){var l=ln(u.shape,o);u=u.reshape(l);}return u;}});var zu=mn({equal_:function equal_(t,e){var n,r=rn(t,"a","equal"),o=rn(e,"b","equal");return n=Ct(r,o),r=n[0],o=n[1],to(r.shape,o.shape),At.runKernel(function(t){return t.equal(r,o);},{$a:r,$b:o});}}),Vu=mn({equalStrict_:function equalStrict_(t,e){var n=rn(t,"a","equalStrict"),r=rn(e,"b","equalStrict");return d(n.shape,r.shape,"Error in equalStrict: "),n.equal(r);}}),Gu=mn({greater_:function greater_(t,e){var n,r=rn(t,"a","greater"),o=rn(e,"b","greater");return n=Ct(r,o),r=n[0],o=n[1],to(r.shape,o.shape),At.runKernel(function(t){return t.greater(r,o);},{$a:r,$b:o});}}),Hu=mn({greaterEqual_:function greaterEqual_(t,e){var n,r=rn(t,"a","greaterEqual"),o=rn(e,"b","greaterEqual");return n=Ct(r,o),r=n[0],o=n[1],to(r.shape,o.shape),At.runKernel(function(t,e){var n=t.greaterEqual(r,o);return e([r,o]),n;},{$a:r,$b:o},function(t,e){var n=e[0],r=e[1];return {$a:function $a(){return Mn(n);},$b:function $b(){return Mn(r);}};});}}),qu=mn({greaterEqualStrict_:function greaterEqualStrict_(t,e){var n=rn(t,"a","greaterEqualStrict"),r=rn(e,"b","greaterEqualStrict");return d(n.shape,r.shape,"Error in greaterEqualStrict: "),n.greaterEqual(r);}}),$u=mn({greaterStrict_:function greaterStrict_(t,e){var n=rn(t,"a","greaterStrict"),r=rn(e,"b","greaterStrict");return d(n.shape,r.shape,"Error in greaterStrict: "),n.greater(r);}}),ju=mn({less_:function less_(t,e){var n,r=rn(t,"a","less"),o=rn(e,"b","less");return n=Ct(r,o),r=n[0],o=n[1],to(r.shape,o.shape),At.runKernel(function(t){return t.less(r,o);},{$a:r,$b:o});}}),Ku=mn({lessEqual_:function lessEqual_(t,e){var n,r=rn(t,"a","lessEqual"),o=rn(e,"b","lessEqual");return n=Ct(r,o),r=n[0],o=n[1],to(r.shape,o.shape),At.runKernel(function(t){return t.lessEqual(r,o);},{$a:r,$b:o});}}),Xu=mn({lessEqualStrict_:function lessEqualStrict_(t,e){var n=rn(t,"a","lessEqualStrict"),r=rn(e,"b","lessEqualStrict");return d(n.shape,r.shape,"Error in lessEqualStrict: "),n.lessEqual(r);}}),Yu=mn({lessStrict_:function lessStrict_(t,e){var n=rn(t,"a","lessStrict"),r=rn(e,"b","lessStrict");return d(n.shape,r.shape,"Error in lessStrict: "),n.less(r);}}),Qu=mn({notEqual_:function notEqual_(t,e){var n,r=rn(t,"a","notEqual"),o=rn(e,"b","notEqual");return n=Ct(r,o),r=n[0],o=n[1],to(r.shape,o.shape),At.runKernel(function(t){return t.notEqual(r,o);},{$a:r,$b:o});}}),Ju=mn({notEqualStrict_:function notEqualStrict_(t,e){var n=rn(t,"a","notEqualStrict"),r=rn(e,"b","notEqualStrict");return d(n.shape,r.shape,"Error in notEqualStrict: "),n.notEqual(r);}});var Zu=mn({add_:function add_(t,e){var n,r=rn(t,"a","add"),o=rn(e,"b","add");n=Ct(r,o),r=n[0],o=n[1];var a=to(r.shape,o.shape);return At.runKernel(function(t){return t.add(r,o);},{$a:r,$b:o},function(t){return {$a:function $a(){var e=t,n=Zr(r.shape,a);return n.length>0&&(e=e.sum(n)),e.reshape(r.shape);},$b:function $b(){var e=t,n=Zr(o.shape,a);return n.length>0&&(e=e.sum(n)),e.reshape(o.shape);}};});}}),tl=mn({addN_:function addN_(t){p(Array.isArray(t),function(){return "The argument passed to tf.addN() must be a list of tensors";}),p(t.length>=1,function(){return "Must pass at least one tensor to tf.addN(), but got "+t.length;});var e=t.map(function(t,e){return rn(t,"tensors"+e,"addN");}),n=e[0];e.forEach(function(t){if(t.dtype!==n.dtype)throw new Error("All tensors passed to tf.addN() must have the same dtype");}),e.forEach(function(t){if(!y(t.shape,n.shape))throw new Error("All tensors passed to tf.addN() must have the same shape");});var r=e;return At.runKernel(function(t){return t.addN(e);},r,function(t){var n={};return e.forEach(function(e,r){n[r]=function(){return t.clone();};}),n;});}}),el=mn({addStrict_:function addStrict_(t,e){var n=rn(t,"a","addStrict"),r=rn(e,"b","addStrict");return d(n.shape,r.shape,"Error in addStrict: "),n.add(r);}}),nl=mn({atan2_:function atan2_(t,e){var n,r=rn(t,"a","atan2"),o=rn(e,"b","atan2");n=Ct(r,o),r=n[0],o=n[1];var a=to(r.shape,o.shape);return At.runKernel(function(t,e){var n=t.atan2(r,o);return e([r,o]),n;},{$a:r,$b:o},function(t,e){var n=e[0],r=e[1];return {$a:function $a(){var e=Zu(n.square(),r.square()),o=t.mul(r.div(e)),i=Zr(n.shape,a);return i.length>0&&(o=o.sum(i)),o.reshape(n.shape);},$b:function $b(){var e=Zu(n.square(),r.square()),o=Es(t.mul(n.div(e))),i=Zr(r.shape,a);return i.length>0&&(o=o.sum(i)),o.reshape(r.shape);}};});}}),rl=mn({div_:function div_(t,e){var n,r=rn(t,"a","div"),o=rn(e,"b","div");if(n=Ct(r,o),r=n[0],o=n[1],"int32"===r.dtype&&"int32"===o.dtype)return al(r,o);var a=to(r.shape,o.shape);return At.runKernel(function(t,e){var n=t.realDivide(r,o);return e([r,o]),n;},{$a:r,$b:o},function(t,e){var n=e[0],r=e[1];return {$a:function $a(){var e=t.div(r.toFloat()),o=Zr(n.shape,a);return o.length>0?e.sum(o).reshape(n.shape):e;},$b:function $b(){var e=t.mul(n.toFloat()),o=Zr(r.shape,a);o.length>0&&(e=e.sum(o).reshape(r.shape));var i=r.square();return e.div(i.toFloat()).neg();}};});}}),ol=mn({divStrict_:function divStrict_(t,e){var n=rn(t,"a","div"),r=rn(e,"b","div");return d(n.shape,r.shape,"Error in divideStrict: "),n.div(r);}}),al=mn({floorDiv_:function floorDiv_(t,e){var n,r=rn(t,"a","floorDiv"),o=rn(e,"b","floorDiv");n=Ct(r,o),r=n[0],o=n[1];var a=to(r.shape,o.shape);return At.runKernel(function(t,e){var n=t.floorDiv(r,o);return e([r,o]),n;},{$a:r,$b:o},function(t,e){var n=e[0],r=e[1];return {$a:function $a(){var e=t.div(r.toFloat()),o=Zr(n.shape,a);return o.length>0?e.sum(o).reshape(n.shape):e;},$b:function $b(){var e=t.mul(n.toFloat()),o=Zr(r.shape,a);o.length>0&&(e=e.sum(o).reshape(r.shape));var i=r.square();return e.div(i.toFloat()).neg();}};});}}),il=mn({maximum_:function maximum_(t,e){var n,r=rn(t,"a","maximum"),o=rn(e,"b","maximum");return n=Ct(r,o),r=n[0],o=n[1],"bool"===r.dtype&&(r=r.toInt(),o=o.toInt()),to(r.shape,o.shape),At.runKernel(function(t,e){var n=t.maximum(r,o);return e([r,o]),n;},{$a:r,$b:o},function(t,e){var n=e[0],r=e[1];return {$a:function $a(){return t.mul(n.greaterEqual(r).toFloat());},$b:function $b(){return t.mul(n.less(r).toFloat());}};});}}),sl=mn({maximumStrict_:function maximumStrict_(t,e){var n=rn(t,"a","maximumStrict"),r=rn(e,"b","maximumStrict");return d(n.shape,r.shape,"Error in maximumStrict: "),n.maximum(r);}}),ul=mn({minimum_:function minimum_(t,e){var n,r=rn(t,"a","minimum"),o=rn(e,"b","minimum");return n=Ct(r,o),r=n[0],o=n[1],"bool"===r.dtype&&(r=r.toInt(),o=o.toInt()),to(r.shape,o.shape),At.runKernel(function(t,e){var n=t.minimum(r,o);return e([r,o]),n;},{$a:r,$b:o},function(t,e){var n=e[0],r=e[1];return {$a:function $a(){return t.mul(n.lessEqual(r).toFloat());},$b:function $b(){return t.mul(n.greater(r).toFloat());}};});}}),ll=mn({minimumStrict_:function minimumStrict_(t,e){var n=rn(t,"a","minimumStrict"),r=rn(e,"b","minimumStrict");return d(n.shape,r.shape,"Error in minimumStrict: "),n.minimum(r);}}),cl=mn({mod_:function mod_(t,e){var n,r=rn(t,"a","mod"),o=rn(e,"b","mod");n=Ct(r,o),r=n[0],o=n[1];var a=to(r.shape,o.shape);return At.runKernel(function(t,e){var n=t.mod(r,o);return e([r,o]),n;},{$a:r,$b:o},function(t,e){var n=e[0],r=e[1];return {$a:function $a(){var e=Zr(n.shape,a);return e.length>0?t.sum(e).reshape(n.shape):t;},$b:function $b(){var e=t.mul(n.div(r).floor().neg()),o=Zr(r.shape,a);return o.length>0?e.sum(o).reshape(r.shape):e;}};});}}),hl=mn({modStrict_:function modStrict_(t,e){var n=rn(t,"a","modStrict"),r=rn(e,"b","modStrict");return d(n.shape,r.shape,"Error in modStrict: "),n.mod(r);}}),fl=mn({mul_:function mul_(t,e){var n,r=rn(t,"a","mul"),o=rn(e,"b","mul");n=Ct(r,o),r=n[0],o=n[1];var a=to(r.shape,o.shape);return At.runKernel(function(t,e){var n=t.multiply(r,o);return e([r,o]),n;},{$a:r,$b:o},function(t,e){var n=e[0],r=e[1];return {$a:function $a(){var e=t.mul(r.toFloat()),o=Zr(n.shape,a);return o.length>0?e.sum(o).reshape(n.shape):e;},$b:function $b(){var e=t.mul(n.toFloat()),o=Zr(r.shape,a);return o.length>0?e.sum(o).reshape(r.shape):e;}};});}}),pl=mn({mulStrict_:function mulStrict_(t,e){var n=rn(t,"a","mul"),r=rn(e,"b","mul");return d(n.shape,r.shape,"Error in multiplyStrict: "),n.mul(r);}}),dl=mn({pow_:function pow_(t,e){var n=rn(t,"base","pow"),r=rn(e,"exp","pow"),o=to(n.shape,r.shape);return t=n.cast(bt(n.dtype,r.dtype)),e=r.cast(bt(n.dtype,r.dtype)),At.runKernel(function(t,e){var o=t.pow(n,r);return e([n,r,o]),o;},{$base:n,$exp:r},function(t,e){var n=e[0],r=e[1],a=e[2];return {$base:function $base(){var e=r.toFloat(),a=t.mul(e.mul(n.pow(e.sub(Cn(1))))),i=Zr(n.shape,o);return i.length>0&&(a=a.sum(i)),a.reshape(n.shape);},$exp:function $exp(){var e=n.greater(0),i=n.log().where(e,Mn(n)),s=t.mul(a.mul(i)),u=Zr(r.shape,o);return u.length>0&&(s=s.sum(u)),s.reshape(r.shape);}};});}}),vl=mn({powStrict_:function powStrict_(t,e){return d(t.shape,e.shape,"Error in powStrict: "),t.pow(e);}}),ml=mn({squaredDifference_:function squaredDifference_(t,e){var n,r=rn(t,"a","squaredDifference"),o=rn(e,"b","squaredDifference");return n=Ct(r,o),r=n[0],o=n[1],to(r.shape,o.shape),At.runKernel(function(t,e){var n=t.squaredDifference(r,o);return e([r,o]),n;},{$a:r,$b:o},function(t,e){var n=e[0],r=e[1],o=Cn(2);return {$a:function $a(){return t.mul(n.sub(r).mul(o));},$b:function $b(){return t.mul(r.sub(n).mul(o));}};});}}),gl=mn({squaredDifferenceStrict_:function squaredDifferenceStrict_(t,e){var n=rn(t,"a","squaredDifferenceStrict"),r=rn(e,"b","squaredDifferenceStrict");return d(n.shape,r.shape,"Error in squaredDifferenceStrict: "),n.squaredDifference(r);}}),yl=mn({sub_:function sub_(t,e){var n,r=rn(t,"a","sub"),o=rn(e,"b","sub");n=Ct(r,o),r=n[0],o=n[1];var a=to(r.shape,o.shape);return At.runKernel(function(t){return t.subtract(r,o);},{$a:r,$b:o},function(t){return {$a:function $a(){var e=t,n=Zr(r.shape,a);return n.length>0&&(e=e.sum(n)),e.reshape(r.shape);},$b:function $b(){var e=t,n=Zr(o.shape,a);return n.length>0&&(e=e.sum(n)),e.neg().reshape(o.shape);}};});}}),xl=mn({subStrict_:function subStrict_(t,e){var n=rn(t,"a","subStrict"),r=rn(e,"b","subStrict");return d(n.shape,r.shape,"Error in subStrict: "),n.sub(r);}});var bl=mn({logicalAnd_:function logicalAnd_(t,e){var n=rn(t,"a","logicalAnd","bool"),r=rn(e,"b","logicalAnd","bool");return to(n.shape,r.shape),At.runKernel(function(t){return t.logicalAnd(n,r);},{$a:n,$b:r});}}),wl=mn({logicalNot_:function logicalNot_(t){var e=rn(t,"x","logicalNot","bool");return At.runKernel(function(t){return t.logicalNot(e);},{$x:e});}}),Cl=mn({logicalOr_:function logicalOr_(t,e){var n=rn(t,"a","logicalOr","bool"),r=rn(e,"b","logicalOr","bool");return to(n.shape,r.shape),At.runKernel(function(t){return t.logicalOr(n,r);},{$a:n,$b:r});}}),El=mn({logicalXor_:function logicalXor_(t,e){var n=rn(t,"a","logicalXor","bool"),r=rn(e,"b","logicalXor","bool");return to(n.shape,r.shape),Cl(t,e).logicalAnd(bl(t,e).logicalNot());}}),Rl=mn({where_:function where_(t,e,n){var r=rn(e,"a","where"),o=rn(n,"b","where"),a=rn(t,"condition","where","bool");return d(r.shape,o.shape,"Error in where: "),1===a.rank?p(a.shape[0]===r.shape[0],function(){return "The first dimension of `a` must match the size of `condition`.";}):d(a.shape,o.shape,"Error in where: "),At.runKernel(function(t,e){var n=t.select(a,r,o);return e([a]),n;},{$condition:a,$a:r,$b:o},function(t,e){var n=e[0];return {$condition:function $condition(){return Mn(n).toFloat();},$a:function $a(){return t.mul(n.cast(t.dtype));},$b:function $b(){return t.mul(n.logicalNot().cast(t.dtype));}};});}}),Il=function Il(t){return n(this,void 0,void 0,function(){var e,n,o;return r(this,function(r){switch(r.label){case 0:return [4,(e=rn(t,"condition","whereAsync","bool")).data()];case 1:return n=r.sent(),o=Io(e.shape,n),t!==e&&e.dispose(),[2,o];}});});};var Sl=mn({elu_:function elu_(t){var e=rn(t,"x","elu");return At.runKernel(function(t,n){var r=t.elu(e);return n([r]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return At.runKernel(function(e){return e.eluDer(t,n);},{dy:t,y:n});}};});}}),Nl=mn({leakyRelu_:function leakyRelu_(t,e){void 0===e&&(e=.2);var n=rn(t,"x","leakyRelu");return il(Cn(e).mul(n),n);}}),kl=mn({prelu_:function prelu_(t,e){var n=rn(t,"x","prelu"),r=rn(e,"alpha","prelu");return At.runKernel(function(t,e){var o=t.prelu(n,r);return e([n,r]),o;},{$x:n,$alpha:r},function(t,e){var n=e[0],r=e[1],o=n.greater(0);return {$x:function $x(){return Rl(o,t,t.mul(r));},$alpha:function $alpha(){var e=Rl(o,Mn(t),t.mul(n)),a=Zr(r.shape,t.shape);return a.length>0&&(e=e.sum(a)),e.reshape(r.shape);}};});}}),Al=mn({relu_:function relu_(t){var e=rn(t,"x","relu");return "bool"===e.dtype?e.toInt():At.runKernel(function(t,n){var r=t.relu(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){return t.mulStrict(n.step().toFloat());}};});}}),Tl=mn({selu_:function selu_(t){var e=rn(t,"x","selu");return At.runKernel(function(t,n){var r=t.selu(e);return n([e]),r;},{$x:e},function(t,e){var n=e[0];return {$x:function $x(){var e=n.greater(Cn(0)),r=Cn(Li),o=Cn(Wi),a=t.mul(o),i=t.mul(r).mul(n.toFloat().exp());return Rl(e,a,i);}};});}});var Dl=mn({transpose_:function transpose_(t,e){var n=rn(t,"x","transpose");return null==e&&(e=n.shape.map(function(t,e){return e;}).reverse()),p(n.rank===e.length,function(){return "Error in transpose: rank of input "+n.rank+" must match length of perm "+e+".";}),e.forEach(function(t){p(t>=0&&t<n.rank,function(){return "All entries in 'perm' must be between 0 and "+(n.rank-1)+" but got "+e;});}),n.rank<=1?n.clone():At.runKernel(function(t){return t.transpose(n,e);},{$x:n},function(t){var n=fn(e);return {$x:function $x(){return t.transpose(n);}};});}});var _l=mn({localResponseNormalization_:function localResponseNormalization_(t,e,n,r,o){void 0===e&&(e=5),void 0===n&&(n=1),void 0===r&&(r=1),void 0===o&&(o=.5);var a=rn(t,"x","localResponseNormalization");p(4===a.rank||3===a.rank,function(){return "Error in localResponseNormalization: x must be rank 3 or 4 but got\n               rank "+a.rank+".";}),p(_x(e),function(){return "Error in localResponseNormalization: depthRadius must be an integer but got depthRadius "+e+".";});var i=a,s=!1;3===a.rank&&(s=!0,i=a.as4D(1,a.shape[0],a.shape[1],a.shape[2]));var u=At.runKernel(function(t,a){var s=t.localResponseNormalization4D(i,e,n,r,o);return a([i,s]),s;},{x4D:i},function(t,a){var i=a[0],s=a[1];return {x4D:function x4D(){return At.runKernel(function(a){return a.LRNGrad(t,i,s,e,n,r,o);},{});}};});return s?u.as3D(u.shape[1],u.shape[2],u.shape[3]):u;}});var Ol=mn({norm_:function norm_(t,e,n,r){void 0===e&&(e="euclidean"),void 0===n&&(n=null),void 0===r&&(r=!1);var o=function t(e,n,r){if(void 0===r&&(r=null),0===e.rank)return e.abs();if(1!==e.rank&&null===r)return t(e.reshape([-1]),n,r);if(1===e.rank||"number"==typeof r||Array.isArray(r)&&1===r.length){if(1===n)return e.abs().sum(r);if(n===1/0)return e.abs().max(r);if(n===-1/0)return e.abs().min(r);if("euclidean"===n||2===n)return e.abs().pow(Cn(2,"int32")).sum(r).sqrt();throw new Error("Error in norm: invalid ord value: "+n);}if(Array.isArray(r)&&2===r.length){if(1===n)return e.abs().sum(r[0]).max(r[1]-1);if(n===1/0)return e.abs().sum(r[1]).max(r[0]);if(n===-1/0)return e.abs().sum(r[1]).min(r[0]);if("fro"===n||"euclidean"===n)return e.square().sum(r).sqrt();throw new Error("Error in norm: invalid ord value: "+n);}throw new Error("Error in norm: invalid axis: "+r);}(t=rn(t,"x","norm"),e,n),a=o.shape;if(r){var i=I(n,t.shape);a=ln(o.shape,i);}return o.reshape(a);}});function Fl(t,e){for(var n=[],r=t;r<e;++r){n.push(r);}return n;}function Ml(t){for(var e=[],n=0;n<t.length;++n){for(var r=0;r<t[n].length;++r){e.push(t[n][r]);}}return e;}var Bl=mn({gather_:function gather_(t,e,n){void 0===n&&(n=0);var r=rn(t,"x","gather"),o=rn(e,"indices","gather","int32");n=I(n,r.shape)[0];var a=function(t,e,n){for(var r=t.shape[n],o=[],a=1,i=1,s=0;s<n;s++){o.push(t.shape[s]),a*=t.shape[s];}for(s=0;s<e.rank;s++){o.push(e.shape[s]);}for(s=n+1;s<t.rank;s++){o.push(t.shape[s]),i*=t.shape[s];}return {batchSize:a,sliceSize:i,dimSize:r,outputShape:o};}(r,o,n);return At.runKernel(function(t,e){var a=t.gather(r,o.flatten(),n);return e([o]),a;},{$x:r},function(t,e){var o=e[0];return {$x:function $x(){var e=r.shape,a=o.size,i=e.slice(0,n),s=i.length,u=e.slice(n,e.length).slice(1),l=u.length,c=Fl(0,s),h=Fl(s+1,s+1+l),f=Ml([i,[a],u]),p=t.reshape(f),d=o.reshape([a]),v=Ml([[s],c,h]),m=p.transpose(v),g=Pl(m,d,r.shape[n]),y=fn(v);return g=g.transpose(y);}};}).reshape(a.outputShape);}}),Pl=mn({unsortedSegmentSum_:function unsortedSegmentSum_(t,e,n){var r=rn(t,"x","unsortedSegmentSum"),o=rn(e,"segmentIds","unsortedSegmentSum","int32");return p(_x(n),function(){return "numSegments must be of dtype int";}),At.runKernel(function(t,e){var a=t.unsortedSegmentSum(r,o,n);return e([o]),a;},{$x:r},function(t,e){var n=e[0];return {$x:function $x(){return function(t,e){for(var n=il(e,Mn(e)),r=Bl(t,n),o=Hu(e,Cn(0,"int32")),a=r.rank-o.rank,i=0;i<a;++i){o=ir(o,i+1);}o=bl(o,An(r.shape,"bool"));var s=Mn(r);return Rl(o,r,s);}(t,n);}};});}});var Ll=mn({basicLSTMCell_:function basicLSTMCell_(t,e,n,r,o,a){var i=rn(t,"forgetBias","basicLSTMCell"),s=rn(e,"lstmKernel","basicLSTMCell"),u=rn(n,"lstmBias","basicLSTMCell"),l=rn(r,"data","basicLSTMCell"),c=rn(o,"c","basicLSTMCell"),h=rn(a,"h","basicLSTMCell"),f=l.concat(h,1).matMul(s).add(u),p=f.shape[0],d=f.shape[1]/4,v=[p,d],m=f.slice([0,0],v),g=f.slice([0,d],v),y=f.slice([0,2*d],v),x=f.slice([0,3*d],v),b=m.sigmoid().mulStrict(g.tanh()).addStrict(c.mulStrict(i.add(y).sigmoid())),w=b.tanh().mulStrict(x.sigmoid());return [b,w];}}),Wl=mn({multiRNNCell_:function multiRNNCell_(t,e,n,r){for(var o=rn(e,"data","multiRNNCell"),a=on$1(n,"c","multiRNNCell"),i=on$1(r,"h","multiRNNCell"),s=o,u=[],l=0;l<t.length;l++){var c=t[l](s,a[l],i[l]);u.push(c[0]),u.push(c[1]),s=c[1];}var h=[],f=[];for(l=0;l<u.length;l+=2){h.push(u[l]),f.push(u[l+1]);}return [h,f];}});var Ul=mn({movingAverage_:function movingAverage_(t,e,n,r,o){void 0===o&&(o=!0);var a=rn(t,"v","movingAverage"),i=rn(e,"x","movingAverage"),s=rn(n,"decay","movingAverage");Et(a,i),p(y(a.shape,i.shape),function(){return "Shape mismatch in v and x";});var u=Cn(1),l=u.sub(s),c=i.sub(a).mul(l);if(o){p(null!=r,function(){return "When using zeroDebias: true, step is required.";});var h=rn(r,"step","movingAverage");c=c.div(u.sub(dl(s,h)));}return a.add(c);}});var zl=mn({stridedSlice_:function stridedSlice_(t,e,n,r,o,a,i,s,u){if(void 0===o&&(o=0),void 0===a&&(a=0),void 0===i&&(i=0),void 0===s&&(s=0),void 0===u&&(u=0),0!==i)throw new Error("ellipsis mask is not yet supported");if(0!==s)throw new Error("new axis mask is not yet supported");var l=rn(t,"x","stridedSlice");if(r.every(function(t){return 1===t;})){var c=Br(l.shape,e,n,r,o,a,i,s,u),h=c[0],f=c[1],p=c[2],d=f.filter(function(t,e){return -1===p.indexOf(e);});return Ru(l,h,f).reshape(d);}return At.runKernel(function(t){return t.stridedSlice(l,e,n,r,o,a,i,s,u);},{$x:l});}});var Vl=mn({topk_:function topk_(t,e,n){void 0===e&&(e=1),void 0===n&&(n=!0);var r=rn(t,"x","topk");if(0===r.rank)throw new Error("topk() expects the input to be of rank 1 or higher");var o=r.shape[r.shape.length-1];if(e>o)throw new Error("'k' passed to topk() must be <= the last dimension ("+o+") but got "+e);var a=At.runKernel(function(t){return t.topk(r,e,n);},{$x:r});return {values:a[0],indices:a[1]};}});var Gl=mn({scatterND_:function scatterND_(t,e,n){var r=rn(t,"indices","scatterND","int32"),o=rn(e,"updates","scatterND");return Fr(o,r,n),At.runKernel(function(t){return t.scatterND(r,o,n);},{$indices:r,$updates:o});}});var Hl=mn({fft_:function fft_(t){p("complex64"===t.dtype,function(){return "The dtype for tf.spectral.fft() must be complex64 but got "+t.dtype+".";});var e=t.shape[t.shape.length-1],n=t.size/e,r=t.as2D(n,e);return At.runKernel(function(t){return t.fft(r);},{input:t}).reshape(t.shape);}}),ql=mn({ifft_:function ifft_(t){p("complex64"===t.dtype,function(){return "The dtype for tf.spectral.ifft() must be complex64 but got "+t.dtype+".";});var e=t.shape[t.shape.length-1],n=t.size/e,r=t.as2D(n,e);return At.runKernel(function(t){return t.ifft(r);},{input:t}).reshape(t.shape);}}),$l=mn({rfft_:function rfft_(t,e){p("float32"===t.dtype,function(){return "The dtype for rfft() must be real value but got "+t.dtype;});var n,r=t.shape[t.shape.length-1],o=t.size/r;if(null!=e&&e<r){var a=t.shape.map(function(t){return 0;}),i=t.shape.map(function(t){return t;});i[t.shape.length-1]=e,n=t.slice(a,i),r=e;}else if(null!=e&&e>r){var s=t.shape.map(function(t){return t;});s[t.shape.length-1]=e-r,n=t.concat(Tn(s),t.shape.length-1),r=e;}else n=t;var u=n.zerosLike(),l=gn(n,u).as2D(o,r),c=Hl(l),h=Math.floor(r/2)+1,f=yn(c),d=xn(c),v=f.split([h,r-h],f.shape.length-1),m=d.split([h,r-h],d.shape.length-1),g=n.shape.slice();return g[n.shape.length-1]=h,gn(v[0],m[0]).reshape(g);}}),jl=mn({irfft_:function irfft_(t){var e=t.shape[t.shape.length-1],n=t.size/e;if(e<=2){var r=t.as2D(n,e),o=ql(r);return yn(o);}var a=[n,2*(e-1)],i=yn(t).as2D(n,e),s=xn(t).as2D(n,e),u=i.slice([0,1],[n,e-2]).reverse(1),l=s.slice([0,1],[n,e-2]).reverse(1).mul(Cn(-1)),c=i.concat(u,1),h=s.concat(l,1);return r=gn(c,h).as2D(a[0],a[1]),o=ql(r),yn(o);}}),Kl=Object.freeze({fft:Hl,ifft:ql,rfft:$l,irfft:jl});var Xl=mn({sparseToDense_:function sparseToDense_(t,e,n,r){void 0===r&&(r=0);var o=rn(t,"sparseIndices","sparseToDense","int32"),a=rn(e,"sparseValues","sparseToDense"),i=rn(r,"defaultValue","sparseToDense",a.dtype);return function(t,e,n,r){if("int32"!==t.dtype)throw new Error("tf.sparseToDense() expects the indices to be int32 type, but the dtype was "+t.dtype+".");if(t.rank>2)throw new Error("sparseIndices should be a scalar, vector, or matrix, but got shape "+t.shape+".");var o=t.rank>0?t.shape[0]:1,a=t.rank>1?t.shape[1]:1;if(n.length!==a)throw new Error("outputShape has incorrect number of elements:, "+n.length+", should be: "+a+".");var i=e.size;if(0!==e.rank&&(1!==e.rank||i!==o))throw new Error("sparseValues has incorrect shape "+e.shape+", should be [] or ["+o+"]");if(e.dtype!==r.dtype)throw new Error("sparseValues.dtype must match defaultValues.dtype");}(o,a,n,i),At.runKernel(function(t){return t.sparseToDense(o,a,n,i);},{$sparseIndices:o,$sparseValues:a,$defaultValue:i});}});var Yl=mn({gatherND_:function gatherND_(t,e){var n=rn(e,"indices","gatherND","int32"),r=rn(t,"x","gatherND");return At.runKernel(function(t){return t.gatherND(r,n);},{$x:r,$indices:n});}});var Ql=mn({dropout_:function dropout_(t,e,n,r){if(null!=n&&!y(t.shape,n))throw new Error("Non-default noise shape is not implemented yet: "+JSON.stringify(n));var o=gr(t.shape,0,1,"float32",r).greater(e);return o=o.div(yl(1,e)),t.mul(o);}});function Jl(t,e,n){for(var r=1-t%2,o=new Float32Array(t),a=0;a<t;++a){var i=2*Math.PI*a/(t+r-1);o[a]=e-n*Math.cos(i);}return En(o,"float32");}var Zl,tc=mn({hannWindow_:function hannWindow_(t){return Jl(t,.5,.5);}}),ec=mn({hammingWindow_:function hammingWindow_(t){return Jl(t,.54,.46);}}),nc=mn({frame_:function frame_(t,e,n,r,o){void 0===r&&(r=!1),void 0===o&&(o=0);for(var a=0,i=[];a+e<=t.size;){i.push(Ru(t,a,e)),a+=n;}if(r){var s=a+e-t.size,u=Bn([Ru(t,a,e-s),Dn([s],o)]);i.push(u);}return 0===i.length?Rn([],[0,e]):Bn(i).as2D(i.length,e);}}),rc=Object.freeze({hannWindow:tc,hammingWindow:ec,frame:nc});!function(t){t[t.NONE=0]="NONE",t[t.MEAN=1]="MEAN",t[t.SUM=2]="SUM",t[t.SUM_BY_NONZERO_WEIGHTS=3]="SUM_BY_NONZERO_WEIGHTS";}(Zl||(Zl={}));var oc=mn({absoluteDifference_:function absoluteDifference_(t,e,n,r){void 0===r&&(r=Zl.SUM_BY_NONZERO_WEIGHTS);var o=rn(t,"labels","absoluteDifference"),a=rn(e,"predictions","absoluteDifference"),i=null;null!=n&&(i=rn(n,"weights","absoluteDifference")),d(o.shape,a.shape,"Error in absoluteDifference: ");var s=o.sub(a).abs();return ac(s,i,r);}}),ac=mn({computeWeightedLoss_:function computeWeightedLoss_(t,e,n){void 0===n&&(n=Zl.SUM_BY_NONZERO_WEIGHTS);var r=rn(t,"losses","computeWeightedLoss"),o=null;null!=e&&(o=rn(e,"weights","computeWeightedLoss"));var a=null==o?r:r.mul(o);if(n===Zl.NONE)return a;if(n===Zl.SUM)return a.sum();if(n===Zl.MEAN){if(null==o)return a.mean();var i=r.size/o.size,s=a.sum().div(o.sum());return i>1?s.div(Cn(i)):s;}if(n===Zl.SUM_BY_NONZERO_WEIGHTS){if(null==o)return a.sum().div(Cn(r.size));var u=o.mul(An(r.shape)).notEqual(Cn(0)).sum().toFloat();return a.sum().div(u);}throw Error("Unknown reduction: "+n);}}),ic=mn({cosineDistance_:function cosineDistance_(t,e,n,r,o){void 0===o&&(o=Zl.SUM_BY_NONZERO_WEIGHTS);var a=rn(t,"labels","cosineDistance"),i=rn(e,"predictions","cosineDistance"),s=null;null!=r&&(s=rn(r,"weights","cosineDistance")),d(a.shape,i.shape,"Error in cosineDistance: ");var u=Cn(1).sub(a.mul(i).sum(n,!0));return ac(u,s,o);}}),sc=mn({hingeLoss_:function hingeLoss_(t,e,n,r){void 0===r&&(r=Zl.SUM_BY_NONZERO_WEIGHTS);var o=rn(t,"labels","hingeLoss"),a=rn(e,"predictions","hingeLoss"),i=null;null!=n&&(i=rn(n,"weights","hingeLoss")),d(o.shape,a.shape,"Error in hingeLoss: ");var s=Cn(1);o=Cn(2).mul(o).sub(s);var u=s.sub(o.mul(a)).relu();return ac(u,i,r);}}),uc=mn({huberLoss_:function huberLoss_(t,e,n,r,o){void 0===r&&(r=1),void 0===o&&(o=Zl.SUM_BY_NONZERO_WEIGHTS);var a=rn(t,"labels","huberLoss"),i=rn(e,"predictions","huberLoss"),s=null;null!=n&&(s=rn(n,"weights","huberLoss")),d(a.shape,i.shape,"Error in huberLoss: ");var u=Cn(r),l=i.sub(a).abs(),c=ul(l,u),h=l.sub(c),f=Cn(.5).mul(c.square()).add(u.mul(h));return ac(f,s,o);}}),lc=mn({logLoss_:function logLoss_(t,e,n,r,o){void 0===r&&(r=1e-7),void 0===o&&(o=Zl.SUM_BY_NONZERO_WEIGHTS);var a=rn(t,"labels","logLoss"),i=rn(e,"predictions","logLoss"),s=null;null!=n&&(s=rn(n,"weights","logLoss")),d(a.shape,i.shape,"Error in logLoss: ");var u=Cn(1),l=Cn(r),c=a.mul(i.add(l).log()).neg().sub(u.sub(a).mul(u.sub(i).add(l).log()));return ac(c,s,o);}}),cc=mn({meanSquaredError_:function meanSquaredError_(t,e,n,r){void 0===r&&(r=Zl.SUM_BY_NONZERO_WEIGHTS);var o=rn(t,"labels","meanSquaredError"),a=rn(e,"predictions","meanSquaredError"),i=null;null!=n&&(i=rn(n,"weights","meanSquaredError")),d(o.shape,a.shape,"Error in meanSquaredError: ");var s=o.squaredDifference(a);return ac(s,i,r);}}),hc=mn({sigmoidCrossEntropy_:function sigmoidCrossEntropy_(t,e,n,r,o){void 0===r&&(r=0),void 0===o&&(o=Zl.SUM_BY_NONZERO_WEIGHTS);var a=rn(t,"multiClassLabels","sigmoidCrossEntropy"),i=rn(e,"logits","sigmoidCrossEntropy"),s=null;if(null!=n&&(s=rn(n,"weights","sigmoidCrossEntropy")),d(a.shape,i.shape,"Error in sigmoidCrossEntropy: "),r>0){var u=Cn(r),l=Cn(1),c=Cn(.5);a=a.mul(l.sub(u)).add(c.mul(u));}var h=function(t,e){var n=rn(t,"labels","sigmoidCrossEntropyWithLogits"),r=rn(e,"logits","sigmoidCrossEntropyWithLogits");d(n.shape,r.shape,"Error in sigmoidCrossEntropyWithLogits: ");var o=r.relu(),a=r.mul(n),i=r.abs().neg().exp().log1p();return o.sub(a).add(i);}(a,i);return ac(h,s,o);}}),fc=mn({softmaxCrossEntropy_:function softmaxCrossEntropy_(t,e,n,r,o){void 0===r&&(r=0),void 0===o&&(o=Zl.SUM_BY_NONZERO_WEIGHTS);var a=rn(t,"onehotLabels","softmaxCrossEntropy"),i=rn(e,"logits","softmaxCrossEntropy"),s=null;if(null!=n&&(s=rn(n,"weights","softmaxCrossEntropy")),d(a.shape,i.shape,"Error in softmaxCrossEntropy: "),r>0){var u=Cn(r),l=Cn(1),c=Cn(a.shape[1]);a=a.mul(l.sub(u)).add(u.div(c));}var h=function(t,e,n){if(void 0===n&&(n=-1),-1===n&&(n=e.rank-1),n!==e.rank-1)throw Error("Softmax cross entropy along a non-last dimension is not yet supported. Labels / logits was rank "+e.rank+" and dim was "+n);return $r(function(t,e,r){var o=e.logSumExp([n],!0),a=e.toFloat().sub(o);return r([t,a]),{value:a.mul(t).neg().sum([n]),gradFunc:function gradFunc(t,e){var r=e[0],o=e[1],a=ln(t.shape,[n]);return [t.reshape(a).mul(r.toFloat().sub(o.exp())),t.reshape(a).mul(o.exp().sub(r.toFloat()))];}};})(t,e);}(a,i);return ac(h,s,o);}}),pc=Object.freeze({get Reduction(){return Zl;},absoluteDifference:oc,computeWeightedLoss:ac,cosineDistance:ic,hingeLoss:sc,huberLoss:uc,logLoss:lc,meanSquaredError:cc,sigmoidCrossEntropy:hc,softmaxCrossEntropy:fc});function dc(t,e){return void 0===e&&(e=!1),At.tidy(function(){if(2!==t.shape.length)throw new Error("qr2d() requires a 2D Tensor, but got a "+t.shape.length+"D Tensor.");for(var n=t.shape[0],r=t.shape[1],o=sr(n),a=t.clone(),i=Rn([[1]],[1,1]),s=i.clone(),u=n>=r?r:n,l=function l(t){var e,u=a,l=s,c=o;e=At.tidy(function(){var e=a.slice([t,t],[n-t,1]),u=e.norm(),l=a.slice([t,t],[1,1]),c=l.sign().neg(),h=l.sub(c.mul(u)),f=e.div(h);s=1===f.shape[0]?i.clone():i.concat(f.slice([1,0],[f.shape[0]-1,f.shape[1]]),0);var p=c.matMul(h).div(u).neg(),d=a.slice([t,0],[n-t,r]),v=p.mul(s);a=0===t?d.sub(v.matMul(s.transpose().matMul(d))):a.slice([0,0],[t,r]).concat(d.sub(v.matMul(s.transpose().matMul(d))),0);var m=o.slice([0,t],[n,o.shape[1]-t]);return o=0===t?m.sub(m.matMul(s).matMul(v.transpose())):o.slice([0,0],[n,t]).concat(m.sub(m.matMul(s).matMul(v.transpose())),1),[s,a,o];}),s=e[0],a=e[1],o=e[2],Ve([u,l,c]);},c=0;c<u;++c){l(c);}return !e&&n>r&&(o=o.slice([0,0],[n,r]),a=a.slice([0,0],[r,r])),[o,a];});}var vc=mn({gramSchmidt_:function gramSchmidt_(t){var e;if(Array.isArray(t)){e=!1,p(null!=t&&t.length>0,function(){return "Gram-Schmidt process: input must not be null, undefined, or empty";});for(var n=t[0].shape[0],r=function r(e){p(t[e].shape[0]===n,function(){return "Gram-Schmidt: Non-unique lengths found in the input vectors: ("+t[e].shape[0]+" vs. "+n+")";});},o=1;o<t.length;++o){r(o);}}else e=!0,t=zn(t,t.shape[0],0).map(function(t){return br(t,[0]);});p(t.length<=t[0].shape[0],function(){return "Gram-Schmidt: Number of vectors ("+t.length+") exceeds number of dimensions ("+t[0].shape[0]+").";});var a=[],i=t,s=function s(t){a.push(At.tidy(function(){var e=i[t];if(t>0)for(var n=0;n<t;++n){var r=Wu(a[n].mulStrict(e)).mul(a[n]);e=e.sub(r);}return e.div(Ol(e,"euclidean"));}));};for(o=0;o<t.length;++o){s(o);}return e?wr(a,0):a;}}),mc=mn({qr_:function qr_(t,e){if(void 0===e&&(e=!1),t.rank<2)throw new Error("qr() requires input tensor to have a rank >= 2, but got rank "+t.rank);if(2===t.rank)return dc(t,e);var n=t.shape.slice(0,t.shape.length-2).reduce(function(t,e){return t*e;}),r=Rr(t.reshape([n,t.shape[t.shape.length-2],t.shape[t.shape.length-1]]),0),o=[],a=[];return r.forEach(function(t){var n=dc(t,e),r=n[0],i=n[1];o.push(r),a.push(i);}),[wr(o,0).reshape(t.shape),wr(a,0).reshape(t.shape)];}}),gc=Object.freeze({gramSchmidt:vc,qr:mc});function yc(t,e,n,r,o){null==r&&(r=.5),null==o&&(o=Number.NEGATIVE_INFINITY);var a=t.shape[0];return n=Math.min(n,a),p(0<=r&&r<=1,function(){return "iouThreshold must be in [0, 1], but was '"+r+"'";}),p(2===t.rank,function(){return "boxes must be a 2D tensor, but was of rank '"+t.rank+"'";}),p(4===t.shape[1],function(){return "boxes must have 4 columns, but 2nd dimension was "+t.shape[1];}),p(1===e.rank,function(){return "scores must be a 1D tensor";}),p(e.shape[0]===a,function(){return "scores has incompatible shape with boxes. Expected "+a+", but was "+e.shape[0];}),{maxOutputSize:n,iouThreshold:r,scoreThreshold:o};}var xc=mn({resizeBilinear_:function resizeBilinear_(t,e,n){void 0===n&&(n=!1);var r=rn(t,"images","resizeBilinear");p(3===r.rank||4===r.rank,function(){return "Error in resizeBilinear: x must be rank 3 or 4, but got rank "+r.rank+".";}),p(2===e.length,function(){return "Error in resizeBilinear: new shape must 2D, but got shape "+e+".";});var o=r,a=!1;3===r.rank&&(a=!0,o=r.as4D(1,r.shape[0],r.shape[1],r.shape[2]));var i=e[0],s=e[1],u=At.runKernel(function(t,e){return e([o]),t.resizeBilinear(o,i,s,n);},{batchImages:o},function(t,e){return {batchImages:function batchImages(){return At.runKernel(function(r){return r.resizeBilinearBackprop(t,e[0],n);},{});}};});return a?u.as3D(u.shape[1],u.shape[2],u.shape[3]):u;}}),bc=mn({resizeNearestNeighbor_:function resizeNearestNeighbor_(t,e,n){void 0===n&&(n=!1);var r=rn(t,"images","resizeNearestNeighbor");p(3===r.rank||4===r.rank,function(){return "Error in resizeNearestNeighbor: x must be rank 3 or 4, but got rank "+r.rank+".";}),p(2===e.length,function(){return "Error in resizeNearestNeighbor: new shape must 2D, but got shape "+e+".";}),p("float32"===r.dtype||"int32"===r.dtype,function(){return "`images` must have `int32` or `float32` as dtype";});var o=r,a=!1;3===r.rank&&(a=!0,o=r.as4D(1,r.shape[0],r.shape[1],r.shape[2]));var i=e[0],s=e[1],u=At.runKernel(function(t,e){return e([o]),t.resizeNearestNeighbor(o,i,s,n);},{batchImages:o},function(t,e){return {batchImages:function batchImages(){return At.runKernel(function(r){return r.resizeNearestNeighborBackprop(t,e[0],n);},{});}};});return a?u.as3D(u.shape[1],u.shape[2],u.shape[3]):u;}}),wc=mn({nonMaxSuppression_:function nonMaxSuppression_(t,e,n,r,o){void 0===r&&(r=.5),void 0===o&&(o=Number.NEGATIVE_INFINITY);var a=rn(t,"boxes","nonMaxSuppression"),i=rn(e,"scores","nonMaxSuppression"),s=yc(a,i,n,r,o);return n=s.maxOutputSize,r=s.iouThreshold,o=s.scoreThreshold,At.runKernel(function(t){return t.nonMaxSuppression(a,i,n,r,o);},{$boxes:a});}}),Cc=function Cc(t,e,o,a,i){return void 0===a&&(a=.5),void 0===i&&(i=Number.NEGATIVE_INFINITY),n(this,void 0,void 0,function(){var n,s,u,l,c,h;return r(this,function(r){switch(r.label){case 0:return n=rn(t,"boxes","nonMaxSuppressionAsync"),s=rn(e,"scores","nonMaxSuppressionAsync"),u=yc(n,s,o,a,i),o=u.maxOutputSize,a=u.iouThreshold,i=u.scoreThreshold,[4,n.data()];case 1:return l=r.sent(),[4,s.data()];case 2:return c=r.sent(),h=bo(l,c,o,a,i),n!==t&&n.dispose(),s!==e&&s.dispose(),[2,h];}});});},Ec=mn({cropAndResize_:function cropAndResize_(t,e,n,r,o,a){var i=rn(t,"image","cropAndResize","float32"),s=rn(e,"boxes","cropAndResize","float32"),u=rn(n,"boxInd","cropAndResize","int32");o=o||"bilinear",a=a||0;var l=s.shape[0];return p(4===i.rank,function(){return "Error in cropAndResize: image must be rank 4,but got rank "+i.rank+".";}),p(2===s.rank&&4===s.shape[1],function(){return "Error in cropAndResize: boxes must be have size ["+l+",4] but had shape "+s.shape+".";}),p(1===u.rank&&u.shape[0]===l,function(){return "Error in cropAndResize: boxInd must be have size ["+l+"] but had shape "+s.shape+".";}),p(2===r.length,function(){return "Error in cropAndResize: cropSize must be of length 2, but got length "+r.length+".";}),p(r[0]>=1&&r[1]>=1,function(){return "cropSize must be atleast [1,1], but was "+r;}),p("bilinear"===o||"nearest"===o,function(){return "method must be bilinear or nearest, but was "+o;}),At.runKernel(function(t,e){return t.cropAndResize(i,s,u,r,o,a);},{$image:i,$boxes:s});}}),Rc=Object.freeze({resizeBilinear:xc,resizeNearestNeighbor:bc,nonMaxSuppression:wc,nonMaxSuppressionAsync:Cc,cropAndResize:Ec});var Ic=mn({matMul_:function matMul_(t,e,n,r,o,a){var i;void 0===n&&(n=!1),void 0===r&&(r=!1),void 0===a&&(a="linear");var s=rn(t,"a","fused matMul"),u=rn(e,"b","fused matMul");i=Ct(s,u),s=i[0],u=i[1];var l=n?s.shape[s.rank-2]:s.shape[s.rank-1],c=r?u.shape[u.rank-1]:u.shape[u.rank-2],h=n?s.shape[s.rank-1]:s.shape[s.rank-2],f=r?u.shape[u.rank-2]:u.shape[u.rank-1],d=s.shape.slice(0,-2),v=u.shape.slice(0,-2),m=g(d),x=g(v);p(s.rank>=2&&u.rank>=2&&s.rank===u.rank,function(){return "Error in fused matMul: inputs must have the same rank of at least 2, got ranks "+s.rank+" and "+u.rank+".";}),p(y(d,v),function(){return "Error in fused matMul: outer dimensions ("+d+") and ("+v+") of Tensors with shapes "+s.shape+" and "+u.shape+" must match.";}),p(l===c,function(){return "Error in fused matMul: inner shapes ("+l+") and ("+c+") of Tensors with shapes "+s.shape+" and "+u.shape+" and transposeA="+n+" and transposeB="+r+" must match.";});var b,w=s.shape.slice(0,-2).concat([h,f]),C=n?s.as3D(m,l,h):s.as3D(m,h,l),E=r?u.as3D(x,f,c):u.as3D(x,c,f);null!=o&&to(w,(b=Ct(b=rn(o,"bias","fused matMul"),s)[0]).shape);var R={$a:C,$b:E};return null!=o&&(R.$bias=b),At.runKernel(function(t,e){var o=t.fusedBatchMatMul(C,E,n,r,b,a);return e([C,E,o]),o;},R,function(t,e){var i,s=e[0],u=e[1],l=e[2];if(null==a||"linear"===a)i=t;else{if("relu"!==a)throw new Error("Gradient for activation "+a+" has not been implemented yet.");i=t.mul(l.step());}var c={};return null!=o&&(c={$bias:function $bias(){var t=i,e=Zr(b.shape,i.shape);return e.length>0&&(t=t.sum(e)),t.reshape(b.shape);}}),n||r?!n&&r?Object.assign({$a:function $a(){return i.matMul(u,!1,!1);},$b:function $b(){return i.matMul(s,!0,!1);}},c):n&&!r?Object.assign({$a:function $a(){return u.matMul(i,!1,!0);},$b:function $b(){return s.matMul(i,!1,!1);}},c):Object.assign({$a:function $a(){return u.matMul(i,!0,!0);},$b:function $b(){return i.matMul(s,!0,!0);}},c):Object.assign({$a:function $a(){return i.matMul(u,!1,!0);},$b:function $b(){return s.matMul(i,!0,!1);}},c);}).reshape(w);}}),Sc=mn({conv2d_:function conv2d_(t,e,n,r,o,a,i,s,u){void 0===o&&(o="NHWC"),void 0===a&&(a=[1,1]),void 0===u&&(u="linear");var l=rn(t,"x","conv2d"),c=rn(e,"filter","conv2d"),h=l,f=!1;3===l.rank&&(f=!0,h=l.as4D(1,l.shape[0],l.shape[1],l.shape[2])),p(4===h.rank,function(){return "Error in fused conv2d: input must be rank 4, but got rank "+h.rank+".";}),p(4===c.rank,function(){return "Error in fused conv2d: filter must be rank 4, but got rank "+c.rank+".";}),null!=i&&p(_x(r),function(){return "Error in fused conv2d: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+r+".";}),p(h.shape[3]===c.shape[2],function(){return "Error in conv2d: depth of input ("+h.shape[3]+") must match input depth for filter "+c.shape[2]+".";}),p(co(n,a),function(){return "Error in conv2D: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+a+"'";}),p("NHWC"===o,function(){return "Error in conv2d: got dataFormat of "+o+" but only NHWC is currently supported.";});var d,v=no(h.shape,c.shape,n,a,r,i);null!=s&&(d=Ct(d=rn(s,"bias","fused conv2d"),l)[0],to(v.outShape,d.shape));var m={x:h,$filter:c};null!=s&&(m.$bias=d);var g=At.runKernel(function(t,e){var n=t.fusedConv2d(h,c,v,d,u);return e([c,h,n]),n;},m,function(t,e){var o,i=e,l=i[0],c=i[1],h=i[2];if(null==u||"linear"===u)o=t;else{if("relu"!==u)throw new Error("Gradient for activation "+u+" has not been implemented yet.");o=t.mul(h.step());}p(lo(a),function(){return "Error in gradient of fused conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '"+a+"'";});var f={};return null!=s&&(f={$bias:function $bias(){var t=o,e=Zr(d.shape,o.shape);return e.length>0&&(t=t.sum(e)),t.reshape(d.shape);}}),Object.assign({x:function x(){return su(c.shape,o,l,n,r);},$filter:function $filter(){return iu(c,o,l.shape,n,r);}},f);});return f?g.as3D(g.shape[1],g.shape[2],g.shape[3]):g;}}),Nc=Object.freeze({matMul:Ic,conv2d:Sc}),kc=Object.freeze({image:Rc,linalg:gc,losses:pc,spectral:Kl,fused:Nc,signal:rc,op:mn,batchNormalization2d:$s,batchNormalization3d:js,batchNormalization4d:Ks,batchNormalization:Xs,batchNorm:Ys,batchNorm2d:Qs,batchNorm3d:Js,batchNorm4d:Zs,complex:gn,real:yn,imag:xn,concat:Bn,concat1d:Pn,concat2d:Ln,concat3d:Wn,concat4d:Un,split:zn,conv1d:ru,conv2d:ou,conv3d:au,conv2dDerFilter:iu,conv2dDerInput:su,depthwiseConv2d:uu,separableConv2d:lu,conv2dTranspose:cu,matMul:hu,dot:fu,outerProduct:pu,reverse:du,reverse1d:vu,reverse2d:mu,reverse3d:gu,reverse4d:yu,maxPool:wu,avgPool:Cu,pool:Eu,slice:Ru,slice1d:Iu,slice2d:Su,slice3d:Nu,slice4d:ku,abs:as,acos:is,acosh:ss,asin:us,asinh:ls,atan:cs,atanh:hs,ceil:fs,clipByValue:ps,cos:ds,cosh:vs,erf:ms,exp:gs,expm1:ys,floor:xs,log:bs,log1p:ws,logSigmoid:Cs,neg:Es,reciprocal:Rs,round:Is,rsqrt:Ss,sigmoid:Ns,sign:ks,isNaN:As,isInf:Ts,isFinite:Ds,sin:_s,sinh:Os,softplus:Fs,sqrt:Ms,square:Bs,step:Ps,tan:Ls,tanh:Ws,all:Tu,any:Du,argMax:_u,argMin:Ou,logSumExp:Fu,max:Mu,mean:Bu,min:Pu,moments:Lu,sum:Wu,prod:Uu,equal:zu,equalStrict:Vu,greater:Gu,greaterEqual:Hu,greaterEqualStrict:qu,greaterStrict:$u,less:ju,lessEqual:Ku,lessEqualStrict:Xu,lessStrict:Yu,notEqual:Qu,notEqualStrict:Ju,add:Zu,addN:tl,addStrict:el,atan2:nl,div:rl,divStrict:ol,floorDiv:al,maximum:il,maximumStrict:sl,minimum:ul,minimumStrict:ll,mod:cl,modStrict:hl,mul:fl,mulStrict:pl,pow:dl,powStrict:vl,squaredDifference:ml,squaredDifferenceStrict:gl,sub:yl,subStrict:xl,elu:Sl,leakyRelu:Nl,prelu:kl,relu:Al,selu:Tl,logicalAnd:bl,logicalNot:wl,logicalOr:Cl,logicalXor:El,where:Rl,whereAsync:Il,buffer:Zn,print:tr,batchToSpaceND:er,cast:nr,clone:rr,cumsum:or,depthToSpace:ar,expandDims:ir,eye:sr,multinomial:ur,oneHot:lr,pad:cr,pad1d:hr,pad2d:fr,pad3d:pr,pad4d:dr,rand:vr,randomNormal:mr,randomUniform:gr,reshape:yr,spaceToBatchND:xr,squeeze:br,stack:wr,tile:Cr,truncatedNormal:Er,unstack:Rr,setdiff1dAsync:Ir,fill:Dn,linspace:_n,ones:An,range:On,scalar:Cn,tensor:bn,tensor1d:En,tensor2d:Rn,tensor3d:In,tensor4d:Sn,tensor5d:Nn,tensor6d:kn,zeros:Tn,onesLike:Fn,zerosLike:Mn,transpose:Dl,softmax:Kr,logSoftmax:Xr,localResponseNormalization:_l,norm:Ol,gather:Bl,unsortedSegmentSum:Pl,basicLSTMCell:Ll,multiRNNCell:Wl,movingAverage:Ul,stridedSlice:zl,topk:Vl,scatterND:Gl,fft:Hl,ifft:ql,rfft:$l,irfft:jl,sparseToDense:Xl,gatherND:Yl,dropout:Ql,hannWindow:tc,hammingWindow:ec,frame:nc});function Ac(t,e,n){if("linear"===e)return t.linear(n);if("relu"===e)return t.relu(n);throw new Error("Activation "+e+" has not been implemented for the CPU backend.");}var Tc=function(){function t(){if(this.blockSize=48,this.firstUse=!0,i.get("IS_BROWSER")){var t="undefined"!=typeof OffscreenCanvas?new OffscreenCanvas(300,150):"undefined"!=typeof document?document.createElement("canvas"):null;null!==t&&(this.fromPixels2DContext=t.getContext("2d"));}this.data=new Yr(this,At);}return t.prototype.register=function(t,e,n){if(this.firstUse&&(this.firstUse=!1,i.get("IS_NODE")&&tn("\n============================\nHi there 👋. Looks like you are running TensorFlow.js in Node.js. To speed things up dramatically, install our node backend, which binds to TensorFlow C++, by running npm i @tensorflow/tfjs-node, or npm i @tensorflow/tfjs-node-gpu if you have CUDA. Then call require('@tensorflow/tfjs-node'); (-gpu suffix for CUDA) at the start of your program. Visit https://github.com/tensorflow/tfjs-node for more details.\n============================\n")),this.data.has(t))throw new Error("Data buffer is already registered");this.data.set(t,{dtype:n});},t.prototype.write=function(t,e){if(null==e)throw new Error("MathBackendCPU.write(): values can not be null");this.data.get(t).values=e;},t.prototype.fromPixels=function(t,e){if(null==t)throw new Error("pixels passed to tf.browser.fromPixels() can not be null");var n,r,o=t.data instanceof Uint8Array,a="undefined"!=typeof ImageData&&t instanceof ImageData,s="undefined"!=typeof HTMLVideoElement&&t instanceof HTMLVideoElement,u="undefined"!=typeof HTMLImageElement&&t instanceof HTMLImageElement;if(i.get("IS_NODE")&&null==t.getContext)throw new Error("When running in node, pixels must be an HTMLCanvasElement like the one returned by the `canvas` npm package");if(null!=t.getContext)n=t.getContext("2d").getImageData(0,0,t.width,t.height).data;else if(a||o)n=t.data;else{if(!u&&!s)throw new Error("pixels passed to tf.browser.fromPixels() must be either an HTMLVideoElement, HTMLImageElement, HTMLCanvasElement, ImageData or {data: Uint32Array, width: number, height: number}, but was "+t.constructor.name);if(null==this.fromPixels2DContext)throw new Error("Can't read pixels from HTMLImageElement outside the browser.");this.fromPixels2DContext.canvas.width=t.width,this.fromPixels2DContext.canvas.height=t.height,this.fromPixels2DContext.drawImage(t,0,0,t.width,t.height),n=this.fromPixels2DContext.getImageData(0,0,t.width,t.height).data;}if(4===e)r=new Int32Array(n);else{var l=t.width*t.height;r=new Int32Array(l*e);for(var c=0;c<l;c++){for(var h=0;h<e;++h){r[c*e+h]=n[4*c+h];}}}return In(r,[t.height,t.width,e],"int32");},t.prototype.read=function(t){return n(this,void 0,void 0,function(){return r(this,function(e){return [2,this.readSync(t)];});});},t.prototype.readSync=function(t){var e=this.data.get(t),n=e.dtype,r=e.complexTensors;return "complex64"===n?mo(this.readSync(r.real.dataId),this.readSync(r.imag.dataId)):this.data.get(t).values;},t.prototype.bufferSync=function(t){var e=this.readSync(t.dataId),n=e;if("string"===t.dtype)try{n=e.map(function(t){return Y(t);});}catch(t){throw new Error("Failed to decode encoded string bytes into utf-8");}return Zn(t.shape,t.dtype,n);},t.prototype.disposeData=function(t){if(this.data.has(t)){var e=this.data.get(t).complexTensors;null!=e&&(e.real.dispose(),e.imag.dispose()),this.data["delete"](t);}},t.prototype.time=function(t){return n(this,void 0,void 0,function(){var e;return r(this,function(n){return e=j(),t(),[2,{kernelMs:j()-e}];});});},t.prototype.memory=function(){return {unreliable:!0,reasons:["The reported memory is an upper bound. Due to automatic garbage collection, the true allocated memory may be less."]};},t.prototype.complex=function(t,e){var n=ht.make(t.shape,{},"complex64");return this.data.get(n.dataId).complexTensors={real:At.keep(t.clone()),imag:At.keep(e.clone())},n;},t.prototype.real=function(t){return this.data.get(t.dataId).complexTensors.real.clone();},t.prototype.imag=function(t){return this.data.get(t.dataId).complexTensors.imag.clone();},t.prototype.assertNotComplex=function(t,e){Array.isArray(t)||(t=[t]),t.forEach(function(t){null!=t&&p("complex64"!==t.dtype,function(){return e+" does not support complex64 tensors.";});});},t.prototype.slice=function(t,e,n){if(this.assertNotComplex(t,"slice"),Wr(t.shape,e,n)){var r=Ur(e,t.strides),o=g(n);return bn(this.readSync(t.dataId).subarray(r,r+o),n,t.dtype);}for(var a=Zn(n,t.dtype),i=this.bufferSync(t),s=0;s<a.size;++s){var u=a.indexToLoc(s).map(function(t,n){return t+e[n];});a.values[s]=i.get.apply(i,u);}return a.toTensor();},t.prototype.stridedSlice=function(t,e,n,r,o,a,i,s,u){this.assertNotComplex(t,"stridedSlice");var l=Br(t.shape,e,n,r,o,a,i,s,u),c=l[0],h=l[1],f=l[2],p=h.filter(function(t,e){return -1===f.indexOf(e);});if(p.some(function(t){return 0===t;}))return bn([],p);for(var d=Zn(h,t.dtype),v=this.bufferSync(t),m=0;m<d.size;m++){for(var g=d.indexToLoc(m),y=new Array(g.length),x=0;x<y.length;x++){y[x]=g[x]*r[x]+c[x];}d.set.apply(d,[v.get.apply(v,y)].concat(g));}return d.toTensor().reshape(p);},t.prototype.unstack=function(t,e){for(var n=t.shape[e],r=new Array(t.rank-1),o=0,a=0;a<t.rank;a++){a!==e&&(r[o++]=t.shape[a]);}var i=new Array(t.rank).fill(0),s=t.shape.slice();s[e]=1;var u=new Array(n);for(a=0;a<u.length;a++){i[e]=a,u[a]=this.slice(t,i,s).reshape(r);}return u;},t.prototype.reverse=function(t,e){this.assertNotComplex(t,"reverse");for(var n=Zn(t.shape,t.dtype),r=this.bufferSync(t),o=function o(_o2){var a=n.indexToLoc(_o2),i=a.slice();e.forEach(function(e){return i[e]=t.shape[e]-1-i[e];}),n.set.apply(n,[r.get.apply(r,i)].concat(a));},a=0;a<n.size;a++){o(a);}return n.toTensor();},t.prototype.concat=function(t,e){var n=this;this.assertNotComplex(t,"concat");var r=t.map(function(t){var n=g(t.shape.slice(e));return t.as2D(-1,n);}),o=vn(r.map(function(t){return t.shape;}),1),a=Zn(o,t[0].dtype).values;if(1===r[0].shape[0]){var i=0;r.forEach(function(t){a.set(n.readSync(t.dataId),i),i+=t.size;});}else{var s=0;r.forEach(function(t){for(var e=n.readSync(t.dataId),r=0,i=0;i<t.shape[0];++i){for(var u=i*o[1]+s,l=0;l<t.shape[1];++l){a[u+l]=e[r++];}}s+=t.shape[1];});}var u=vn(t.map(function(t){return t.shape;}),e);return bn(a,u,t[0].dtype);},t.prototype.neg=function(t){return this.assertNotComplex(t,"neg"),this.multiply(Cn(-1),t);},t.prototype.add=function(t,e){return "complex64"===t.dtype||"complex64"===e.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),e.cast("complex64"),function(t,e,n,r){return {real:t+n,imag:e+r};}):this.broadcastedBinaryOp(t,e,bt(t.dtype,e.dtype),function(t,e){return t+e;});},t.prototype.addN=function(t){var e=this;this.assertNotComplex(t,"addN");for(var n=t.map(function(t){return e.readSync(t.dataId);}),r=Zn(t[0].shape,t[0].dtype),o=r.values,a=0;a<t.length;a++){for(var i=n[a],s=0;s<o.length;s++){o[s]+=i[s];}}return r.toTensor();},t.prototype.subtract=function(t,e){return "complex64"===t.dtype||"complex64"===e.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),e.cast("complex64"),function(t,e,n,r){return {real:t-n,imag:e-r};}):this.broadcastedBinaryOp(t,e,bt(t.dtype,e.dtype),function(t,e){return t-e;});},t.prototype.pow=function(t,e){return this.assertNotComplex([t,e],"pow"),this.broadcastedBinaryOp(t,e,t.dtype,function(t,e){return Math.pow(t,e);});},t.prototype.batchMatMul=function(t,e,n,r){this.assertNotComplex([t,e],"matMul");for(var o=n?t.shape[1]:t.shape[2],a=n?t.shape[2]:t.shape[1],i=r?e.shape[1]:e.shape[2],s=t.shape[0],u=this.readSync(t.dataId),l=this.readSync(e.dataId),c=n?[t.strides[0],1,t.strides[1]]:[t.strides[0],t.strides[1],1],h=c[0],f=c[1],p=c[2],d=r?[1,e.strides[1],e.strides[0]]:[e.strides[1],1,e.strides[0]],v=d[0],m=d[1],g=d[2],y=a*i,x=Zn([s,a,i],t.dtype),b=x.values,w=this.blockSize,C=0;C<s;C++){for(var E=0;E<a;E+=w){for(var R=0;R<i;R+=w){for(var I=0;I<o;I+=w){for(var S=Math.min(E+w,a),N=Math.min(R+w,i),k=Math.min(I+w,o),A=E;A<S;A++){for(var T=R;T<N;T++){for(var D=0,_=I;_<k;_++){D+=u[C*h+A*f+_*p]*l[_*v+T*m+C*g];}b[C*y+(A*i+T)]+=D;}}}}}}return x.toTensor();},t.prototype.fusedBatchMatMul=function(t,e,n,r,o,a){var i=this.batchMatMul(t,e,n,r);return o&&(i=this.add(i,o)),a&&(i=Ac(this,a,i)),i;},t.prototype.multiply=function(t,e){return "complex64"===t.dtype||"complex64"===e.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),e.cast("complex64"),function(t,e,n,r){return {real:t*n-e*r,imag:t*r+e*n};}):this.broadcastedBinaryOp(t,e,bt(t.dtype,e.dtype),function(t,e){return t*e;});},t.prototype.realDivide=function(t,e){this.assertNotComplex([t,e],"realDivide");return this.broadcastedBinaryOp(t,e,"float32",function(t,e){return t/e;});},t.prototype.floorDiv=function(t,e){this.assertNotComplex([t,e],"floorDiv");return this.broadcastedBinaryOp(t,e,"int32",function(t,e){return Math.floor(t/e);});},t.prototype.sum=function(t,e){this.assertNotComplex(t,"sum"),cn("sum",e,t.rank);for(var n=un(t.shape,e),r=n[0],o=n[1],a=Tn(r,bt(t.dtype,"int32")),i=g(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),l=0;l<s.length;++l){for(var c=l*i,h=0,f=0;f<i;++f){h+=u[c+f];}s[l]=h;}return a;},t.prototype.prod=function(t,e){this.assertNotComplex(t,"sum");for(var n=un(t.shape,e),r=n[0],o=n[1],a=Tn(r,bt(t.dtype,"int32")),i=g(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),l=0;l<s.length;++l){for(var c=l*i,h=1,f=0;f<i;++f){h*=u[c+f];}s[l]=h;}return a;},t.prototype.unsortedSegmentSum=function(t,e,n){this.assertNotComplex(t,"unsortedSegmentSum");for(var r=[],o=t.rank-e.rank,a=0;a<o;++a){e=e.expandDims(a+1);}for(a=0;a<n;++a){var i=Cn(a,"int32"),s=zu(i,e).asType("float32").mul(t).sum(0);r.push(s);}return wr(r);},t.prototype.argMin=function(t,e){this.assertNotComplex(t,"argMin");var n=[e];cn("argMin",n,t.rank);for(var r=un(t.shape,n),o=r[0],a=r[1],i=Tn(o,"int32"),s=g(a),u=this.readSync(i.dataId),l=this.readSync(t.dataId),c=0;c<u.length;++c){for(var h=c*s,f=l[h],p=0,d=0;d<s;++d){var v=l[h+d];v<f&&(f=v,p=d);}u[c]=p;}return i;},t.prototype.argMax=function(t,e){this.assertNotComplex(t,"argMax");var n=[e];cn("argMax",n,t.rank);for(var r=un(t.shape,n),o=r[0],a=r[1],i=Tn(o,"int32"),s=g(a),u=this.readSync(i.dataId),l=this.readSync(t.dataId),c=0;c<u.length;++c){for(var h=c*s,f=l[h],p=0,d=0;d<s;++d){var v=l[h+d];v>f&&(f=v,p=d);}u[c]=p;}return i;},t.prototype.cumsum=function(t,e,n,r){if(this.assertNotComplex(t,"cumsum"),e!==t.rank-1)throw new Error("backend.cumsum in CPU expects an inner-most axis="+(t.rank-1)+" but got axis="+e);for(var o=bt(t.dtype,"int32"),a=Tn(t.shape,o),i=this.readSync(a.dataId),s=this.readSync(t.dataId),u=t.shape[t.rank-1],l=r?function(t,e){return t+u-e-1;}:function(t,e){return t+e;},c=0;c<s.length;c+=u){for(var h=0;h<u;h++){var f=l(c,h);if(0===h)i[f]=n?0:s[f];else{var p=l(c,h-1);i[f]=n?s[p]+i[p]:s[f]+i[p];}}}return a;},t.prototype.equal=function(t,e){return this.assertNotComplex([t,e],"equal"),this.broadcastedBinaryOp(t,e,"bool",function(t,e){return t===e?1:0;});},t.prototype.notEqual=function(t,e){return this.assertNotComplex([t,e],"notEqual"),this.broadcastedBinaryOp(t,e,"bool",function(t,e){return t!==e?1:0;});},t.prototype.less=function(t,e){return this.assertNotComplex([t,e],"less"),this.broadcastedBinaryOp(t,e,"bool",function(t,e){return t<e?1:0;});},t.prototype.lessEqual=function(t,e){return this.assertNotComplex([t,e],"lessEqual"),this.broadcastedBinaryOp(t,e,"bool",function(t,e){return t<=e?1:0;});},t.prototype.greater=function(t,e){return this.assertNotComplex([t,e],"greater"),this.broadcastedBinaryOp(t,e,"bool",function(t,e){return t>e?1:0;});},t.prototype.greaterEqual=function(t,e){return this.assertNotComplex([t,e],"greaterEqual"),this.broadcastedBinaryOp(t,e,"bool",function(t,e){return t>=e?1:0;});},t.prototype.logicalNot=function(t){this.assertNotComplex(t,"logicalNot");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r){n[r]=e[r]?0:1;}return ht.make(t.shape,{values:n},"bool");},t.prototype.logicalAnd=function(t,e){return this.assertNotComplex([t,e],"logicalAnd"),this.broadcastedBinaryOp(t,e,"bool",function(t,e){return t&&e;});},t.prototype.logicalOr=function(t,e){return this.assertNotComplex([t,e],"logicalOr"),this.broadcastedBinaryOp(t,e,"bool",function(t,e){return t||e;});},t.prototype.select=function(t,e,n){this.assertNotComplex([t,e,n],"select");for(var r=this.readSync(t.dataId),o=this.readSync(e.dataId),a=this.readSync(n.dataId),i=Tn(e.shape,bt(e.dtype,n.dtype)),s=this.readSync(i.dataId),u=0,l=0===t.rank||t.rank>1||1===e.rank?1:e.shape[1],c=0;c<r.length;c++){for(var h=0;h<l;h++){1===r[c]?s[u++]=o[c]:s[u++]=a[c];}}return i;},t.prototype.where=function(t){this.assertNotComplex([t],"where");var e=this.readSync(t.dataId);return Io(t.shape,e);},t.prototype.topk=function(t,e,n){return this.assertNotComplex(t,"topk"),Ro(this.readSync(t.dataId),t.shape,t.dtype,e);},t.prototype.min=function(t,e){this.assertNotComplex(t,"min"),cn("min",e,t.rank);for(var n=un(t.shape,e),r=n[0],o=n[1],a=Tn(r,t.dtype),i=g(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),l=0;l<s.length;++l){for(var c=l*i,h=u[c],f=0;f<i;++f){var p=u[c+f];p<h&&(h=p);}s[l]=h;}return a;},t.prototype.minimum=function(t,e){return this.assertNotComplex([t,e],"minimum"),this.broadcastedBinaryOp(t,e,t.dtype,function(t,e){return Math.min(t,e);});},t.prototype.mod=function(t,e){return this.assertNotComplex([t,e],"mod"),this.broadcastedBinaryOp(t,e,t.dtype,function(t,e){var n=t%e;return t<0&&e<0||t>=0&&e>=0?n:(n+e)%e;});},t.prototype.max=function(t,e){this.assertNotComplex(t,"max"),cn("max",e,t.rank);for(var n=un(t.shape,e),r=n[0],o=n[1],a=Tn(r,t.dtype),i=g(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),l=0;l<s.length;++l){for(var c=l*i,h=u[c],f=0;f<i;++f){var p=u[c+f];p>h&&(h=p);}s[l]=h;}return a;},t.prototype.maximum=function(t,e){return this.assertNotComplex([t,e],"maximum"),this.broadcastedBinaryOp(t,e,t.dtype,function(t,e){return Math.max(t,e);});},t.prototype.all=function(t,e){this.assertNotComplex(t,"all"),cn("all",e,t.rank);for(var n=un(t.shape,e),r=n[0],o=n[1],a=Tn(r,t.dtype),i=g(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),l=0;l<s.length;++l){for(var c=l*i,h=u[c],f=0;f<i;++f){var p=u[c+f];h=h&&p;}s[l]=h;}return a;},t.prototype.any=function(t,e){this.assertNotComplex(t,"any"),cn("any",e,t.rank);for(var n=un(t.shape,e),r=n[0],o=n[1],a=Tn(r,t.dtype),i=g(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),l=0;l<s.length;++l){for(var c=l*i,h=u[c],f=0;f<i;++f){var p=u[c+f];h=h||p;}s[l]=h;}return a;},t.prototype.squaredDifference=function(t,e){return this.assertNotComplex([t,e],"squaredDifference"),this.broadcastedBinaryOp(t,e,t.dtype,function(t,e){var n=t-e;return n*n;});},t.prototype.ceil=function(t){this.assertNotComplex(t,"ceil");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){n[r]=Math.ceil(e[r]);}return ht.make(t.shape,{values:n});},t.prototype.floor=function(t){this.assertNotComplex(t,"floor");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){n[r]=Math.floor(e[r]);}return ht.make(t.shape,{values:n});},t.prototype.sign=function(t){this.assertNotComplex(t,"x");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){e[r]<0?n[r]=-1:e[r]>0?n[r]=1:n[r]=0;}return ht.make(t.shape,{values:n});},t.prototype.isNaN=function(t){this.assertNotComplex(t,"x");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r){Number.isNaN(e[r])&&(n[r]=1);}return ht.make(t.shape,{values:n},"bool");},t.prototype.isInf=function(t){this.assertNotComplex(t,"x");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r){Math.abs(e[r])===1/0&&(n[r]=1);}return ht.make(t.shape,{values:n},"bool");},t.prototype.isFinite=function(t){this.assertNotComplex(t,"x");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r){Number.isFinite(e[r])&&(n[r]=1);}return ht.make(t.shape,{values:n},"bool");},t.prototype.round=function(t){this.assertNotComplex(t,"round");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=Math.floor(e[r]);e[r]-o<.5?n[r]=Math.floor(e[r]):e[r]-o>.5?n[r]=Math.ceil(e[r]):n[r]=o%2==0?o:o+1;}return ht.make(t.shape,{values:n});},t.prototype.exp=function(t){this.assertNotComplex(t,"exp");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){n[r]=Math.exp(e[r]);}return ht.make(t.shape,{values:n});},t.prototype.expm1=function(t){this.assertNotComplex(t,"expm1");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){n[r]=Math.expm1(e[r]);}return ht.make(t.shape,{values:n});},t.prototype.log=function(t){this.assertNotComplex(t,"log");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=Math.log(o);}return ht.make(t.shape,{values:n});},t.prototype.log1p=function(t){this.assertNotComplex(t,"log1p");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=Math.log1p(o);}return ht.make(t.shape,{values:n});},t.prototype.sqrt=function(t){this.assertNotComplex(t,"sqrt");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=Math.sqrt(o);}return ht.make(t.shape,{values:n});},t.prototype.rsqrt=function(t){this.assertNotComplex(t,"rsqrt");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=1/Math.sqrt(o);}return ht.make(t.shape,{values:n});},t.prototype.square=function(t){this.assertNotComplex(t,"square");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=o*o;}return ht.make(t.shape,{values:n});},t.prototype.reciprocal=function(t){this.assertNotComplex(t,"reciprocal");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){n[r]=1/e[r];}return ht.make(t.shape,{values:n});},t.prototype.linear=function(t){return t;},t.prototype.relu=function(t){this.assertNotComplex(t,"relu");for(var e=Tn(t.shape,t.dtype),n=this.readSync(e.dataId),r=this.readSync(t.dataId),o=0;o<r.length;++o){n[o]=Math.max(0,r[o]);}return e;},t.prototype.prelu=function(t,e){return this.assertNotComplex([t,e],"prelu"),this.broadcastedBinaryOp(t,e,t.dtype,function(t,e){return t<0?e*t:t;});},t.prototype.elu=function(t){this.assertNotComplex(t,"elu");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){var o=n[r];e[r]=o>=0?o:Math.exp(o)-1;}return ht.make(t.shape,{values:e});},t.prototype.eluDer=function(t,e){this.assertNotComplex([t,e],"eluDer");for(var n=new Float32Array(e.size),r=this.readSync(e.dataId),o=this.readSync(t.dataId),a=0;a<r.length;++a){var i=r[a];n[a]=i>=1?o[a]:o[a]*(i+1);}return ht.make(e.shape,{values:n});},t.prototype.selu=function(t){this.assertNotComplex(t,"selu");for(var e=Li,n=Wi,r=new Float32Array(t.size),o=this.readSync(t.dataId),a=0;a<o.length;++a){var i=o[a];r[a]=i>=0?n*i:e*(Math.exp(i)-1);}return ht.make(t.shape,{values:r});},t.prototype.clip=function(t,e,n){this.assertNotComplex(t,"clip");for(var r=new Float32Array(t.size),o=this.readSync(t.dataId),a=0;a<o.length;++a){var i=o[a];r[a]=i>n?n:i<e?e:i;}return ht.make(t.shape,{values:r});},t.prototype.abs=function(t){for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){e[r]=Math.abs(n[r]);}return ht.make(t.shape,{values:e});},t.prototype.complexAbs=function(t){for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<t.size;++r){var o=n[2*r],a=n[2*r+1];e[r]=Math.hypot(o,a);}return ht.make(t.shape,{values:e});},t.prototype["int"]=function(t){this.assertNotComplex(t,"int");for(var e=new Int32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){e[r]=n[r];}return ht.make(t.shape,{values:e},"int32");},t.prototype.sigmoid=function(t){this.assertNotComplex(t,"sigmoid");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){e[r]=1/(1+Math.exp(-n[r]));}return ht.make(t.shape,{values:e});},t.prototype.softplus=function(t){this.assertNotComplex(t,"softplus");for(var e=Math.log(1.1920928955078125e-7)+2,n=new Float32Array(t.size),r=this.readSync(t.dataId),o=0;o<r.length;++o){var a=r[o]>-e,i=r[o]<e,s=Math.exp(r[o]),u=void 0;u=i?s:a?r[o]:Math.log(1+s),n[o]=u;}return ht.make(t.shape,{values:n});},t.prototype.sin=function(t){this.assertNotComplex(t,"sin");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){e[r]=Math.sin(n[r]);}return ht.make(t.shape,{values:e});},t.prototype.cos=function(t){this.assertNotComplex(t,"cos");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){e[r]=Math.cos(n[r]);}return ht.make(t.shape,{values:e});},t.prototype.tan=function(t){this.assertNotComplex(t,"tan");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){e[r]=Math.tan(n[r]);}return ht.make(t.shape,{values:e});},t.prototype.asin=function(t){this.assertNotComplex(t,"asin");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){e[r]=Math.asin(n[r]);}return ht.make(t.shape,{values:e});},t.prototype.acos=function(t){this.assertNotComplex(t,"acos");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){e[r]=Math.acos(n[r]);}return ht.make(t.shape,{values:e});},t.prototype.atan=function(t){this.assertNotComplex(t,"atan");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){e[r]=Math.atan(n[r]);}return ht.make(t.shape,{values:e});},t.prototype.atan2=function(t,e){return this.assertNotComplex([t,e],"atan2"),this.broadcastedBinaryOp(t,e,t.dtype,function(t,e){return Math.atan2(t,e);});},t.prototype.sinh=function(t){this.assertNotComplex(t,"sinh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){e[r]=Math.sinh(n[r]);}return ht.make(t.shape,{values:e});},t.prototype.cosh=function(t){this.assertNotComplex(t,"cosh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){e[r]=Math.cosh(n[r]);}return ht.make(t.shape,{values:e});},t.prototype.tanh=function(t){this.assertNotComplex(t,"tanh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){e[r]=b(n[r]);}return ht.make(t.shape,{values:e});},t.prototype.asinh=function(t){this.assertNotComplex(t,"asinh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){e[r]=Math.asinh(n[r]);}return ht.make(t.shape,{values:e});},t.prototype.acosh=function(t){this.assertNotComplex(t,"acosh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){e[r]=Math.acosh(n[r]);}return ht.make(t.shape,{values:e});},t.prototype.atanh=function(t){this.assertNotComplex(t,"atanh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){e[r]=Math.atanh(n[r]);}return ht.make(t.shape,{values:e});},t.prototype.erf=function(t){this.assertNotComplex(t,"erf");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){var o=n[r],a=1/(1+.3275911*o);e[r]=1-((((1.061405429*a-1.453152027)*a+1.421413741)*a-.284496736)*a+.254829592)*a*Math.exp(-o*o);}return ht.make(t.shape,{values:e});},t.prototype.step=function(t,e){void 0===e&&(e=0),this.assertNotComplex(t,"step");for(var n=new Float32Array(t.size),r=this.readSync(t.dataId),o=0;o<r.length;++o){var a=r[o];isNaN(a)?n[o]=NaN:n[o]=a>0?1:e;}return ht.make(t.shape,{values:n});},t.prototype.fusedConv2d=function(t,e,n,r,o){var a=this.conv2d(t,e,n);return r&&(a=this.add(a,r)),o&&(a=Ac(this,o,a)),a;},t.prototype.conv2d=function(t,e,n){this.assertNotComplex([t,e],"conv2d");for(var r=n.filterHeight,o=n.filterWidth,a=n.dilationHeight,i=n.dilationWidth,s=n.padInfo.left,u=n.padInfo.top,l=Zn(n.outShape,t.dtype),c=this.readSync(t.dataId),h=this.readSync(e.dataId),f=l.values,p=0;p<n.batchSize;++p){for(var d=p*t.strides[0],v=p*l.strides[0],m=0;m<n.outHeight;++m){for(var g=v+m*l.strides[1],y=m*n.strideHeight-u,x=0;x<r;x++){var b=y+x*a;if(!(b<0||b>=n.inHeight))for(var w=x*e.strides[0],C=d+b*t.strides[1],E=0;E<n.outWidth;++E){for(var R=g+E*n.outChannels,I=E*n.strideWidth-s,S=0;S<o;S++){var N=I+S*i;if(!(N<0||N>=n.inWidth))for(var k=w+S*e.strides[1],A=C+N*n.inChannels,T=k,D=0;D<n.inChannels;++D){for(var _=c[A+D],O=0;O<n.outChannels;++O){f[R+O]+=_*h[T+O];}T+=n.outChannels;}}}}}}return l.toTensor();},t.prototype.conv3d=function(t,e,n){for(var r=n.filterDepth,o=n.filterHeight,a=n.filterWidth,i=n.dilationDepth,s=n.dilationHeight,u=n.dilationWidth,l=n.padInfo.front,c=n.padInfo.left,h=n.padInfo.top,f=Zn(n.outShape,t.dtype),p=this.readSync(t.dataId),d=this.readSync(e.dataId),v=f.values,m=0;m<n.batchSize;++m){for(var g=m*t.strides[0],y=m*f.strides[0],x=0;x<n.outDepth;++x){for(var b=y+x*f.strides[1],w=x*n.strideDepth-l,C=0;C<r;C++){var E=w+C*i;if(!(E<0||E>=n.inDepth))for(var R=C*e.strides[0],I=g+E*t.strides[1],S=0;S<n.outHeight;++S){for(var N=b+S*f.strides[2],k=S*n.strideHeight-h,A=0;A<o;A++){var T=k+A*s;if(!(T<0||T>=n.inHeight))for(var D=R+A*e.strides[1],_=I+T*t.strides[2],O=0;O<n.outWidth;++O){for(var F=N+O*n.outChannels,M=O*n.strideWidth-c,B=0;B<a;B++){var P=M+B*u;if(!(P<0||P>=n.inWidth))for(var L=D+B*e.strides[2],W=_+P*n.inChannels,U=L,z=0;z<n.inChannels;++z){for(var V=p[W+z],G=0;G<n.outChannels;++G){v[F+G]+=V*d[U+G];}U+=n.outChannels;}}}}}}}}return f.toTensor();},t.prototype.conv2dDerInput=function(t,e,n){this.assertNotComplex([t,e],"conv2dDerInput");for(var r=Zn(n.inShape,"float32"),o=r.values,a=r.strides,i=a[0],s=a[1],u=a[2],l=this.readSync(t.dataId),c=t.strides,h=c[0],f=c[1],p=c[2],d=this.readSync(e.dataId),v=e.strides,m=v[0],g=v[1],y=v[2],x=n.batchSize,b=n.filterHeight,w=n.filterWidth,C=n.inChannels,E=n.inHeight,R=n.inWidth,I=n.outChannels,S=n.outHeight,N=n.outWidth,k=n.strideHeight,A=n.strideWidth,T=b-1-n.padInfo.top,D=w-1-n.padInfo.left,_=0;_<x;++_){for(var O=0;O<C;++O){for(var F=0;F<E;++F){for(var M=F-T,B=Math.max(0,Math.ceil(M/k)),P=Math.min(S,(b+M)/k),L=0;L<R;++L){for(var W=L-D,U=Math.max(0,Math.ceil(W/A)),z=Math.min(N,(w+W)/A),V=0,G=B;G<P;++G){for(var H=G*k-M,q=U;q<z;++q){for(var $=h*_+f*G+p*q,j=m*(b-1-H)+g*(w-1-(q*A-W))+y*O,K=0;K<I;++K){V+=l[$+K]*d[j+K];}}}o[i*_+s*F+u*L+O]=V;}}}}return r.toTensor();},t.prototype.conv3dDerInput=function(t,e,n){for(var r=Zn(n.inShape,"float32"),o=r.values,a=r.strides,i=a[0],s=a[1],u=a[2],l=a[3],c=this.readSync(t.dataId),h=t.strides,f=h[0],p=h[1],d=h[2],v=h[3],m=this.readSync(e.dataId),g=e.strides,y=g[0],x=g[1],b=g[2],w=g[3],C=n.batchSize,E=n.filterDepth,R=n.filterHeight,I=n.filterWidth,S=n.inChannels,N=n.inDepth,k=n.inHeight,A=n.inWidth,T=n.outChannels,D=n.outDepth,_=n.outHeight,O=n.outWidth,F=n.strideDepth,M=n.strideHeight,B=n.strideWidth,P=E-1-n.padInfo.front,L=R-1-n.padInfo.top,W=I-1-n.padInfo.left,U=0;U<C;++U){for(var z=0;z<S;++z){for(var V=0;V<N;++V){for(var G=V-P,H=Math.max(0,Math.ceil(G/F)),q=Math.min(D,(E+G)/F),$=0;$<k;++$){for(var j=$-L,K=Math.max(0,Math.ceil(j/M)),X=Math.min(_,(R+j)/M),Y=0;Y<A;++Y){for(var Q=Y-W,J=Math.max(0,Math.ceil(Q/B)),Z=Math.min(O,(I+Q)/B),tt=0,et=H;et<q;++et){for(var nt=et*F-G,rt=K;rt<X;++rt){for(var ot=rt*M-j,at=J;at<Z;++at){for(var it=f*U+p*et+d*rt+v*at,st=y*(E-1-nt)+x*(R-1-ot)+b*(I-1-(at*B-Q))+w*z,ut=0;ut<T;++ut){tt+=c[it+ut]*m[st+ut];}}}}o[i*U+s*V+u*$+l*Y+z]=tt;}}}}}return r.toTensor();},t.prototype.conv2dDerFilter=function(t,e,n){this.assertNotComplex([t,e],"conv2dDerFilter");for(var r=n.strideHeight,o=n.strideWidth,a=n.filterHeight,i=n.filterWidth,s=Zn(n.filterShape,"float32"),u=n.padInfo.left,l=n.padInfo.top,c=this.bufferSync(t),h=this.bufferSync(e),f=0;f<a;++f){for(var p=Math.max(0,Math.ceil((l-f)/r)),d=Math.min(n.outHeight,(n.inHeight+l-f)/r),v=0;v<i;++v){for(var m=Math.max(0,Math.ceil((u-v)/o)),g=Math.min(n.outWidth,(n.inWidth+u-v)/o),y=0;y<n.inChannels;++y){for(var x=0;x<n.outChannels;++x){for(var b=0,w=0;w<n.batchSize;++w){for(var C=p;C<d;++C){for(var E=f+C*r-l,R=m;R<g;++R){var I=v+R*o-u;b+=c.get(w,E,I,y)*h.get(w,C,R,x);}}}s.set(b,f,v,y,x);}}}}return s.toTensor();},t.prototype.conv3dDerFilter=function(t,e,n){for(var r=n.strideDepth,o=n.strideHeight,a=n.strideWidth,i=n.filterDepth,s=n.filterHeight,u=n.filterWidth,l=Zn(n.filterShape,"float32"),c=l.values,h=l.strides,f=h[0],p=h[1],d=h[2],v=h[3],m=this.readSync(e.dataId),g=e.strides,y=g[0],x=g[1],b=g[2],w=g[3],C=this.readSync(t.dataId),E=t.strides,R=E[0],I=E[1],S=E[2],N=E[3],k=n.padInfo.front,A=n.padInfo.left,T=n.padInfo.top,D=0;D<i;++D){for(var _=Math.max(0,Math.ceil((k-D)/r)),O=Math.min(n.outDepth,(n.inDepth+k-D)/r),F=D*f,M=0;M<s;++M){for(var B=Math.max(0,Math.ceil((T-M)/o)),P=Math.min(n.outHeight,(n.inHeight+T-M)/o),L=M*p+F,W=0;W<u;++W){for(var U=Math.max(0,Math.ceil((A-W)/a)),z=Math.min(n.outWidth,(n.inWidth+A-W)/a),V=W*d+L,G=0;G<n.inChannels;++G){for(var H=G*v+V,q=0;q<n.outChannels;++q){for(var $=0,j=0;j<n.batchSize;++j){for(var K=j*R,X=j*y,Y=_;Y<O;++Y){for(var Q=(D+Y*r-k)*I+K,J=Y*x+X,Z=B;Z<P;++Z){for(var tt=(M+Z*o-T)*S+Q,et=Z*b+J,nt=U;nt<z;++nt){var rt=nt*w+et;$+=C[(W+nt*a-A)*N+tt+G]*m[rt+q];}}}}c[H+q]=$;}}}}}return l.toTensor();},t.prototype.depthwiseConv2D=function(t,e,n){this.assertNotComplex([t,e],"depthwiseConv2D");for(var r=n.filterHeight,o=n.filterWidth,a=n.dilationHeight,i=n.dilationWidth,s=n.padInfo.left,u=n.padInfo.top,l=n.outChannels/n.inChannels,c=Zn(n.outShape,t.dtype),h=this.readSync(t.dataId),f=this.readSync(e.dataId),p=c.values,d=0;d<n.batchSize;++d){for(var v=d*t.strides[0],m=d*c.strides[0],g=0;g<n.outHeight;++g){for(var y=m+g*c.strides[1],x=g*n.strideHeight-s,b=0;b<r;++b){var w=x+b*a;if(!(w<0||w>=n.inHeight))for(var C=b*e.strides[0],E=v+w*t.strides[1],R=0;R<n.outWidth;++R){for(var I=y+R*c.strides[2],S=R*n.strideWidth-u,N=0;N<o;++N){var k=S+N*i;if(!(k<0||k>=n.inWidth))for(var A=C+N*e.strides[1],T=E+k*n.inChannels,D=I,_=A,O=0;O<n.inChannels;++O){for(var F=h[T+O],M=0;M<l;++M){p[D+M]+=F*f[_+M];}D+=l,_+=l;}}}}}}return c.toTensor();},t.prototype.depthwiseConv2DDerInput=function(t,e,n){this.assertNotComplex([t,e],"depthwiseConv2DDerInput");for(var r=Zn(n.inShape,"float32"),o=r.values,a=r.strides,i=a[0],s=a[1],u=a[2],l=this.readSync(t.dataId),c=t.strides,h=c[0],f=c[1],p=c[2],d=this.readSync(e.dataId),v=e.strides,m=v[0],g=v[1],y=v[2],x=n.batchSize,b=n.filterHeight,w=n.filterWidth,C=n.inChannels,E=n.inHeight,R=n.inWidth,I=n.outChannels,S=n.outHeight,N=n.outWidth,k=n.strideHeight,A=n.strideWidth,T=b-1-n.padInfo.top,D=w-1-n.padInfo.left,_=I/C,O=0;O<x;++O){for(var F=0;F<C;++F){for(var M=0;M<E;++M){for(var B=M-T,P=Math.max(0,Math.ceil(B/k)),L=Math.min(S,(b+B)/k),W=0;W<R;++W){for(var U=W-D,z=Math.max(0,Math.ceil(U/A)),V=Math.min(N,(w+U)/A),G=0,H=P;H<L;++H){for(var q=H*k-B,$=z;$<V;++$){for(var j=h*O+f*H+p*$,K=m*(b-1-q)+g*(w-1-($*A-U))+y*F,X=0;X<_;++X){G+=l[j+(F*_+X)]*d[K+X];}}}o[i*O+s*M+u*W+F]=G;}}}}return r.toTensor();},t.prototype.depthwiseConv2DDerFilter=function(t,e,n){this.assertNotComplex([t,e],"depthwiseConv2DDerFilter");for(var r=n.strideHeight,o=n.strideWidth,a=n.filterHeight,i=n.filterWidth,s=Zn(n.filterShape,"float32"),u=n.padInfo.left,l=n.padInfo.top,c=n.outChannels/n.inChannels,h=this.bufferSync(t),f=this.bufferSync(e),p=0;p<a;++p){for(var d=Math.max(0,Math.ceil((l-p)/r)),v=Math.min(n.outHeight,(n.inHeight+l-p)/r),m=0;m<i;++m){for(var g=Math.max(0,Math.ceil((u-m)/o)),y=Math.min(n.outWidth,(n.inWidth+u-m)/o),x=0;x<n.outChannels;++x){for(var b=Math.trunc(x/c),w=x%c,C=0,E=0;E<n.batchSize;++E){for(var R=d;R<v;++R){for(var I=p+R*r-l,S=g;S<y;++S){var N=m+S*o-u;C+=h.get(E,I,N,b)*f.get(E,R,S,x);}}}s.set(C,p,m,b,w);}}}return s.toTensor();},t.prototype.tile=function(t,e){return this.assertNotComplex(t,"tile"),Eo(this.bufferSync(t),e);},t.prototype.pad=function(t,e,n){this.assertNotComplex(t,"pad");var r=e.map(function(e,n){return e[0]+t.shape[n]+e[1];}),o=e.map(function(t){return t[0];}),a=this.bufferSync(t),i=Zn(r,t.dtype);0!==n&&i.values.fill(n);for(var s=0;s<t.size;s++){var u=a.indexToLoc(s),l=u.map(function(t,e){return t+o[e];});i.set.apply(i,[a.get.apply(a,u)].concat(l));}return i.toTensor();},t.prototype.transpose=function(t,e){this.assertNotComplex(t,"transpose");for(var n=new Array(t.rank),r=0;r<n.length;r++){n[r]=t.shape[e[r]];}var o=this.readSync(t.dataId),a=Zn(n,t.dtype),i=this.bufferSync(t);for(r=0;r<t.size;++r){for(var s=i.indexToLoc(r),u=new Array(s.length),l=0;l<u.length;l++){u[l]=s[e[l]];}var c=a.locToIndex(u);a.values[c]=o[r];}return a.toTensor();},t.prototype.gather=function(t,e,n){this.assertNotComplex([t,e],"gather");var r=t.shape.slice(),o=this.readSync(e.dataId);r[n]=o.length;for(var a=Zn(r,t.dtype),i=this.bufferSync(t),s=0;s<a.size;++s){var u=a.indexToLoc(s),l=u.slice();l[n]=o[u[n]];var c=i.locToIndex(l);a.values[s]=i.values[c];}return a.toTensor();},t.prototype.batchToSpaceND=function(t,e,n){this.assertNotComplex([t],"batchToSpaceND");var r=e.reduce(function(t,e){return t*e;}),o=Sr(t.shape,e,r),a=Nr(o.length,e.length),i=kr(t.shape,e,r),s=Ar(n,e.length),u=Tr(i,n,e.length);return t.reshape(o).transpose(a).reshape(i).slice(s,u);},t.prototype.spaceToBatchND=function(t,e,n){this.assertNotComplex([t],"spaceToBatchND");var r=e.reduce(function(t,e){return t*e;}),o=[[0,0]];o.push.apply(o,n);for(var a=1+e.length;a<t.shape.length;++a){o.push([0,0]);}var i=t.pad(o),s=Sr(i.shape,e,r,!1),u=Nr(s.length,e.length,!1),l=kr(i.shape,e,r,!1);return i.reshape(s).transpose(u).reshape(l);},t.prototype.pool=function(t,e,n){this.assertNotComplex(t,"pool");for(var r=e.strideHeight,o=e.strideWidth,a=e.dilationHeight,i=e.dilationWidth,s=e.effectiveFilterHeight,u=e.effectiveFilterWidth,l=e.padInfo.top,c=e.padInfo.left,h="max"===n?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,f=this.readSync(t.dataId),p=Zn(e.outShape,t.dtype),d=p.values,v=e.outShape[1]*e.outShape[2]*e.outShape[3],m=e.outShape[2]*e.outShape[3],g=e.outShape[3],y=0;y<e.batchSize;++y){for(var x=y*v,b=y*t.strides[0],w=0;w<e.inChannels;++w){for(var C=0;C<e.outHeight;++C){for(var E=C*r-l,R=Math.max(0,E),I=Math.min(e.inHeight,s+E),S=x+C*m,N=0;N<e.outWidth;++N){for(var k=N*o-c,A=Math.max(0,k),T=Math.min(e.inWidth,u+k),D=h,_=0,O=0,F=R;F<I;F+=a){for(var M=b+F*t.strides[1],B=A;B<T;B+=i){var P=f[M+B*t.strides[2]+w];"max"===n&&P>D?D=P:"avg"===n&&(_+=P,O++);}if(isNaN(D))break;}d[S+N*g+w]="avg"===n?_/O:D;}}}}return p.toTensor();},t.prototype.maxPool=function(t,e){return this.pool(t,e,"max");},t.prototype.maxPoolPositions=function(t,e){for(var n=Zn(e.outShape,"int32"),r=e.strideHeight,o=e.strideWidth,a=e.dilationHeight,i=e.dilationWidth,s=e.effectiveFilterHeight,u=e.effectiveFilterWidth,l=e.padInfo.top,c=e.padInfo.left,h=this.bufferSync(t),f=0;f<e.batchSize;++f){for(var p=0;p<e.inChannels;++p){for(var d=0;d<e.outHeight;++d){for(var v=d*r-l,m=v;m<0;){m+=a;}for(var g=Math.min(e.inHeight,s+v),y=0;y<e.outWidth;++y){for(var x=y*o-c,b=x;b<0;){b+=i;}for(var w=Math.min(e.inWidth,u+x),C=Number.NEGATIVE_INFINITY,E=-1,R=m;R<g;R+=a){for(var I=R-v,S=b;S<w;S+=i){var N=S-x,k=h.get(f,R,S,p);k>C&&(C=k,E=I*u+N);}}n.set(E,f,d,y,p);}}}}return n.toTensor();},t.prototype.maxPoolBackprop=function(t,e,n,r){this.assertNotComplex([e,n],"maxPoolBackprop");for(var o=this.maxPoolPositions(e,r),a=r.strideHeight,i=r.strideWidth,s=r.dilationHeight,u=r.dilationWidth,l=r.effectiveFilterHeight,c=r.effectiveFilterWidth,h=c-1-r.padInfo.left,f=l-1-r.padInfo.top,p=Zn(e.shape,"float32"),d=this.bufferSync(o),v=this.bufferSync(t),m=0;m<r.batchSize;++m){for(var g=0;g<r.inChannels;++g){for(var y=0;y<r.inHeight;++y){for(var x=0;x<r.inWidth;++x){for(var b=y-f,w=x-h,C=0,E=0;E<l;E+=s){var R=(b+E)/a;if(!(R<0||R>=r.outHeight||Math.floor(R)!==R))for(var I=0;I<c;I+=u){var S=(w+I)/i;if(!(S<0||S>=r.outWidth||Math.floor(S)!==S)){var N=l*c-1-d.get(m,R,S,g)===E*c+I?1:0;if(0!==N)C+=v.get(m,R,S,g)*N;}}}p.set(C,m,y,x,g);}}}}return p.toTensor();},t.prototype.avgPoolBackprop=function(t,e,n){this.assertNotComplex([t,e],"avgPoolBackprop");for(var r=n.strideHeight,o=n.strideWidth,a=n.filterHeight,i=n.filterWidth,s=n.dilationHeight,u=n.dilationWidth,l=n.effectiveFilterHeight,c=n.effectiveFilterWidth,h=c-1-n.padInfo.left,f=l-1-n.padInfo.top,p=Zn(e.shape,"float32"),d=1/(a*i),v=this.bufferSync(t),m=0;m<n.batchSize;++m){for(var g=0;g<n.inChannels;++g){for(var y=0;y<n.inHeight;++y){for(var x=0;x<n.inWidth;++x){for(var b=y-f,w=x-h,C=0,E=0;E<l;E+=s){var R=(b+E)/r;if(!(R<0||R>=n.outHeight||Math.floor(R)!==R))for(var I=0;I<c;I+=u){var S=(w+I)/o;if(!(S<0||S>=n.outWidth||Math.floor(S)!==S))C+=v.get(m,R,S,g);}}p.set(C*d,m,y,x,g);}}}}return p.toTensor();},t.prototype.cast=function(t,e){return ho(t,e,this);},t.prototype.reshape=function(t,e){return fo(t,e);},t.prototype.avgPool=function(t,e){return this.assertNotComplex(t,"avgPool"),this.pool(t,e,"avg").toFloat();},t.prototype.resizeBilinear=function(t,e,n,r){this.assertNotComplex(t,"resizeBilinear");for(var o=t.shape,a=o[0],i=o[1],s=o[2],u=o[3],l=this.readSync(t.dataId),c=new Float32Array(g([a,e,n,u])),h=[r&&e>1?i-1:i,r&&n>1?s-1:s],f=[r&&e>1?e-1:e,r&&n>1?n-1:n],p=0,d=h[0]/f[0],v=h[1]/f[1],m=0;m<a;m++){for(var y=0;y<e;y++){for(var x=d*y,b=Math.floor(x),w=x-b,C=Math.min(i-1,Math.ceil(x)),E=m*t.strides[0]+b*t.strides[1],R=m*t.strides[0]+C*t.strides[1],I=0;I<n;I++){for(var S=v*I,N=Math.floor(S),k=S-N,A=Math.min(s-1,Math.ceil(S)),T=E+N*t.strides[2],D=R+N*t.strides[2],_=E+ +A*t.strides[2],O=R+A*t.strides[2],F=0;F<u;F++){var M=l[T+F],B=l[D+F],P=M+(l[_+F]-M)*k,L=P+(B+(l[O+F]-B)*k-P)*w;c[p++]=L;}}}}return bn(c,[a,e,n,u]);},t.prototype.resizeBilinearBackprop=function(t,e,n){this.assertNotComplex([t,e],"resizeBilinearBackprop");for(var r=e.shape,o=r[0],a=r[1],i=r[2],s=r[3],u=t.shape,l=u[1],c=u[2],h=new Float32Array(o*a*i*s),f=[n&&l>1?a-1:a,n&&c>1?i-1:i],p=[n&&l>1?l-1:l,n&&c>1?c-1:c],d=f[0]/p[0],v=f[1]/p[1],m=this.readSync(t.dataId),g=0,y=0;y<o;y++){for(var x=y*e.strides[0],b=0;b<l;b++){for(var w=b*d,C=Math.floor(w),E=Math.min(Math.ceil(w),a-1),R=x+C*e.strides[1],I=x+E*e.strides[1],S=w-C,N=1-S,k=0;k<c;k++){for(var A=k*v,T=Math.floor(A),D=Math.min(Math.ceil(A),i-1),_=A-T,O=1-_,F=R+T*e.strides[2],M=R+D*e.strides[2],B=I+T*e.strides[2],P=I+D*e.strides[2],L=N*O,W=N*_,U=S*O,z=S*_,V=0;V<s;V++){var G=m[g++];h[F+V]+=G*L,h[M+V]+=G*W,h[B+V]+=G*U,h[P+V]+=G*z;}}}}return Sn(h,[o,i,a,s],e.dtype);},t.prototype.resizeNearestNeighbor=function(t,e,n,r){this.assertNotComplex(t,"resizeNearestNeighbor");for(var o=t.shape,a=o[0],i=o[1],s=o[2],u=o[3],l=this.readSync(t.dataId),c=new Float32Array(a*e*n*u),h=[r&&e>1?i-1:i,r&&n>1?s-1:s],f=[r&&e>1?e-1:e,r&&n>1?n-1:n],p=h[0]/f[0],d=h[1]/f[1],v=0,m=0;m<a;m++){for(var g=m*t.strides[0],y=0;y<e;y++){for(var x=p*y,b=g+Math.min(i-1,r?Math.round(x):Math.floor(x))*t.strides[1],w=0;w<n;w++){for(var C=d*w,E=b+Math.min(s-1,r?Math.round(C):Math.floor(C))*t.strides[2],R=0;R<u;R++){var I=l[E+R];c[v++]=I;}}}}return bn(c,[a,e,n,u],t.dtype);},t.prototype.resizeNearestNeighborBackprop=function(t,e,n){this.assertNotComplex([t,e],"resizeNearestNeighborBackprop");for(var r=e.shape,o=r[0],a=r[1],i=r[2],s=r[3],u=t.shape,l=u[1],c=u[2],h=new Float32Array(o*a*i*s),f=this.readSync(t.dataId),p=[n&&l>1?a-1:a,n&&c>1?i-1:i],d=[n&&l>1?l-1:l,n&&c>1?c-1:c],v=p[0]/d[0],m=p[1]/d[1],g=1/v,y=1/m,x=2*Math.ceil(g)+2,b=2*Math.ceil(y)+2,w=0;w<o;w++){for(var C=w*e.strides[0],E=0;E<a;E++){for(var R=C+E*e.strides[1],I=Math.floor(E*g),S=Math.floor(I-x/2),N=0;N<i;N++){for(var k=R+N*e.strides[2],A=Math.floor(N*y),T=Math.floor(A-b/2),D=0;D<s;D++){for(var _=0,O=0;O<x;O++){var F=O+S;if(!(F<0||F>=l)){var M=C+F*t.strides[1],B=F*v;if(E===Math.min(a-1,n?Math.round(B):Math.floor(B)))for(var P=0;P<b;P++){var L=P+T;if(!(L<0||L>=c)){var W=M+L*t.strides[2],U=L*m;N===Math.min(i-1,n?Math.round(U):Math.floor(U))&&(_+=f[W+D]);}}}}h[k+D]=_;}}}}return Sn(h,e.shape,e.dtype);},t.prototype.batchNormalization=function(t,e,n,r,o,a){this.assertNotComplex([t,e,n,o,a],"batchNorm");for(var i=this.readSync(t.dataId),s=this.readSync(e.dataId),u=this.readSync(n.dataId),l=o?this.readSync(o.dataId):new Float32Array([1]),c=a?this.readSync(a.dataId):new Float32Array([0]),h=new Float32Array(i.length),f=c.length,p=l.length,d=u.length,v=s.length,m=0,g=0,y=0,x=0,b=0;b<i.length;++b){h[b]=c[m++]+(i[b]-s[g++])*l[y++]/Math.sqrt(u[x++]+r),m>=f&&(m=0),g>=v&&(g=0),y>=p&&(y=0),x>=d&&(x=0);}return Sn(h,t.shape);},t.prototype.localResponseNormalization4D=function(t,e,n,r,o){this.assertNotComplex(t,"localResponseNormalization4D");var a=t.shape[3],i=a-1,s=this.readSync(t.dataId),u=t.size,l=new Float32Array(u);function c(t){for(var n=t%a,r=t-n+Math.max(0,n-e),o=t-n+Math.min(n+e,i),u=0;r<=o;r++){var l=s[r];u+=l*l;}return u;}for(var h=0;h<u;h++){var f=c(h),p=s[h]*Math.pow(n+r*f,-o);l[h]=p;}return Sn(l,t.shape);},t.prototype.LRNGrad=function(t,e,n,r,o,a,i){this.assertNotComplex(t,"LRNGrad");for(var s=t.shape[3],u=this.readSync(t.dataId),l=this.readSync(e.dataId),c=this.readSync(n.dataId),h=new Float32Array(t.size),f=t.size,p=0;p<f;p++){for(var d=p%s,v=p-d+Math.max(0,d-r),m=p-d+Math.min(s,d+r+1),g=0,y=v;y<m;y++){g+=Math.pow(l[y],2);}g=a*g+o;for(y=v;y<m;y++){var x=-2*a*i*l[y]*c[p]/g;p===y&&(x+=Math.pow(g,-i)),x*=u[p],h[y]+=x;}}return Sn(h,t.shape);},t.prototype.multinomial=function(t,e,n,r){this.assertNotComplex(t,"multinomial");for(var o=e?t:Kr(t),a=o.shape[0],i=o.shape[1],s=Tn([a,n],"int32"),u=this.readSync(s.dataId),l=this.readSync(o.dataId),c=0;c<a;++c){var h=c*i,f=new Float32Array(i-1);f[0]=l[h];for(var p=1;p<f.length;++p){f[p]=f[p-1]+l[h+p];}for(var d=Yn(r.toString()),v=c*n,m=0;m<n;++m){var g=d();u[v+m]=f.length;for(var y=0;y<f.length;y++){if(g<f[y]){u[v+m]=y;break;}}}}return s;},t.prototype.oneHot=function(t,e,n,r){this.assertNotComplex(t,"oneHot");var o=new Float32Array(t.size*e);o.fill(r);for(var a=this.readSync(t.dataId),i=0;i<t.size;++i){a[i]>=0&&a[i]<e&&(o[i*e+a[i]]=n);}return Rn(o,[t.size,e],"int32");},t.prototype.nonMaxSuppression=function(t,e,n,r,o){return this.assertNotComplex(t,"nonMaxSuppression"),bo(this.readSync(t.dataId),this.readSync(e.dataId),n,r,o);},t.prototype.fft=function(t){return this.fftBatch(t,!1);},t.prototype.ifft=function(t){return this.fftBatch(t,!0);},t.prototype.fftBatch=function(t,e){for(var n=t.shape[0],r=t.shape[1],o=Zn(t.shape,"float32"),a=Zn(t.shape,"float32"),i=yn(t).as2D(n,r),s=xn(t).as2D(n,r),u=0;u<n;u++){for(var l=i.slice([u,0],[1,r]),c=s.slice([u,0],[1,r]),h=gn(l,c),f=this.readSync(this.fftImpl(h,e).dataId),p=0;p<r;p++){var d=go(f,p);o.values[u*r+p]=d.real,a.values[u*r+p]=d.imag;}}return gn(o.toTensor(),a.toTensor()).as2D(n,r);},t.prototype.fftImpl=function(t,e){var n=t.as1D(),r=n.size;if(this.isExponentOf2(r)){var o=this.fftRadix2(n,r,e).as2D(t.shape[0],t.shape[1]);return e&&(o=gn(yn(o).div(Cn(r)),xn(o).div(Cn(r)))),o;}var a=this.readSync(t.dataId),i=function(t){for(var e=new Float32Array(t.length/2),n=new Float32Array(t.length/2),r=0;r<t.length;r+=2){e[r/2]=t[r],n[r/2]=t[r+1];}return {real:e,imag:n};}(this.fourierTransformByMatmul(a,r,e));return gn(i.real,i.imag).as2D(t.shape[0],t.shape[1]);},t.prototype.isExponentOf2=function(t){return 0==(t&t-1);},t.prototype.fftRadix2=function(t,e,n){if(1===e)return t;var r=this.readSync(t.dataId),o=e/2,a=function(t){for(var e=Math.ceil(t.length/4),n=new Float32Array(e),r=new Float32Array(e),o=0;o<t.length;o+=4){n[Math.floor(o/4)]=t[o],r[Math.floor(o/4)]=t[o+1];}return {real:n,imag:r};}(r),i=gn(a.real,a.imag).as1D(),s=function(t){for(var e=Math.floor(t.length/4),n=new Float32Array(e),r=new Float32Array(e),o=2;o<t.length;o+=4){n[Math.floor(o/4)]=t[o],r[Math.floor(o/4)]=t[o+1];}return {real:n,imag:r};}(r),u=gn(s.real,s.imag).as1D();i=this.fftRadix2(i,o,n),u=this.fftRadix2(u,o,n);var l=function(t,e){for(var n=new Float32Array(t/2),r=new Float32Array(t/2),o=0;o<Math.ceil(t/2);o++){var a=(e?2:-2)*Math.PI*(o/t);n[o]=Math.cos(a),r[o]=Math.sin(a);}return {real:n,imag:r};}(e,n),c=gn(l.real,l.imag).mul(u),h=i.add(c),f=i.sub(c),p=yn(h).concat(yn(f)),d=xn(h).concat(xn(f));return gn(p,d).as1D();},t.prototype.fourierTransformByMatmul=function(t,e,n){for(var r=new Float32Array(2*e),o=0;o<e;o++){for(var a=0,i=0,s=0;s<e;s++){var u=xo(o*s,e,n),l=go(t,s);a+=l.real*u.real-l.imag*u.imag,i+=l.real*u.imag+l.imag*u.real;}n&&(a/=e,i/=e),yo(r,a,i,o);}return r;},t.prototype.depthToSpace=function(t,e,n){p("NHWC"===n,function(){return "Only NHWC dataFormat supported on CPU for depthToSpace. Got "+n;}),p(e>1,function(){return "blockSize should be > 1 for depthToSpace, but was: "+e;});for(var r=t.shape[0],o=t.shape[1],a=t.shape[2],i=t.shape[3],s=o*e,u=a*e,l=i/(e*e),c=this.readSync(t.dataId),h=new Float32Array(r*s*u*l),f=0,d=0;d<r;++d){for(var v=0;v<s;++v){for(var m=Math.floor(v/e),g=v%e,y=0;y<u;++y){for(var x=Math.floor(y/e),b=(g*e+y%e)*l,w=0;w<l;++w){var C=w+b+i*(x+a*(m+o*d));h[f++]=c[C];}}}}return Sn(h,[r,s,u,l]);},t.prototype.broadcastedBinaryOp=function(t,e,n,r){var o=to(t.shape,e.shape),a=Zn(o,n),i=this.readSync(t.dataId),s=this.readSync(e.dataId),u=Jr(t.shape,o),l=Jr(e.shape,o),c=a.values;if(u.length+l.length===0)for(var h=0;h<c.length;++h){c[h]=r(i[h%i.length],s[h%s.length]);}else{var f=this.bufferSync(t),p=this.bufferSync(e),d=function d(n){var o=a.indexToLoc(n),h=o.slice(-t.rank);u.forEach(function(t){return h[t]=0;});var d=f.locToIndex(h),v=o.slice(-e.rank);l.forEach(function(t){return v[t]=0;});var m=p.locToIndex(v);c[n]=r(i[d],s[m]);};for(h=0;h<c.length;++h){d(h);}}return a.toTensor();},t.prototype.broadcastedBinaryComplexOp=function(t,e,n){var r=to(t.shape,e.shape),o=Zn(r,"float32"),a=Zn(r,"float32"),i=this.readSync(t.dataId),s=this.readSync(e.dataId),u=Jr(t.shape,r),l=Jr(e.shape,r),c=o.values,h=a.values;if(u.length+l.length===0)for(var f=0;f<c.length;f++){var p=f%i.length,d=f%s.length,v=n(i[2*p],i[2*p+1],s[2*d],s[2*d+1]);c[f]=v.real,h[f]=v.imag;}else{var m=this.bufferSync(this.data.get(t.dataId).complexTensors.real),g=this.bufferSync(this.data.get(e.dataId).complexTensors.real),y=function y(r){var a=o.indexToLoc(r),f=a.slice(-t.rank);u.forEach(function(t){return f[t]=0;});var p=m.locToIndex(f),d=a.slice(-e.rank);l.forEach(function(t){return d[t]=0;});var v=g.locToIndex(d),y=n(i[2*p],i[2*p+1],s[2*v],s[2*v+1]);c[r]=y.real,h[r]=y.imag;};for(f=0;f<c.length;f++){y(f);}}return this.complex(o.toTensor(),a.toTensor());},t.prototype.split=function(t,e,n){return Co(t,e,n);},t.prototype.dispose=function(){},t.prototype.floatPrecision=function(){return 32;},t.prototype.epsilon=function(){return 1e-7;},t.prototype.cropAndResize=function(t,e,n,r,o,a){for(var i=t.shape,s=i[0],u=i[1],l=i[2],c=i[3],h=e.shape[0],f=r[0],p=r[1],d=Zn([h,f,p,c],t.dtype),v=this.readSync(e.dataId),m=this.readSync(n.dataId),g=this.readSync(t.dataId),y=t.strides,x=d.strides,b=0;b<h;b++){var w=4*b,C=v[w],E=v[w+1],R=v[w+2],I=v[w+3],S=m[b];if(!(S>=s))for(var N=f>1?(R-C)*(u-1)/(f-1):0,k=p>1?(I-E)*(l-1)/(p-1):0,A=0;A<f;A++){var T=f>1?C*(u-1)+A*N:.5*(C+R)*(u-1);if(T<0||T>u-1)for(var D=0;D<p;D++){for(var _=0;_<c;_++){var O=_+D*x[2]+A*x[1]+b*x[0];d.values[O]=a;}}else if("bilinear"===o){var F=Math.floor(T),M=Math.ceil(T),B=T-F;for(D=0;D<p;D++){if((q=p>1?E*(l-1)+D*k:.5*(E+I)*(l-1))<0||q>l-1)for(_=0;_<c;_++){O=_+D*x[2]+A*x[1]+b*x[0];d.values[O]=a;}else{var P=Math.floor(q),L=Math.ceil(q),W=q-P;for(_=0;_<c;_++){var U=g[O=_+P*y[2]+F*y[1]+S*y[0]],z=g[O=_+L*y[2]+F*y[1]+S*y[0]],V=g[O=_+P*y[2]+M*y[1]+S*y[0]],G=U+(z-U)*W,H=V+(g[O=_+L*y[2]+M*y[1]+S*y[0]]-V)*W;O=_+D*x[2]+A*x[1]+b*x[0],d.values[O]=G+(H-G)*B;}}}}else for(D=0;D<p;++D){var q;if((q=p>1?E*(l-1)+D*k:.5*(E+I)*(l-1))<0||q>l-1)for(_=0;_<c;_++){O=_+D*x[2]+A*x[1]+b*x[0];d.values[O]=a;}else{var $=Math.round(q),j=Math.round(T);for(_=0;_<c;_++){var K=_+$*y[2]+j*y[1]+S*y[0],X=_+D*x[2]+A*x[1]+b*x[0];d.values[X]=g[K];}}}}}return d.toTensor();},t.prototype.sparseToDense=function(t,e,n,r){var o=Mr(0,t,n),a=o.sliceRank,i=o.numUpdates,s=o.sliceSize,u=o.strides,l=o.outputSize;return this.scatter(t,e,n,l,s,i,a,u,r,!1);},t.prototype.gatherND=function(t,e){var n=e.shape,r=n[n.length-1],o=Dr(t,e),a=o[0],i=o[1],s=o[2],u=o[3];if(0===i)return bn([],a,t.dtype);for(var l=new st([i,s],t.dtype),c=this.readSync(e.dataId),h=this.readSync(t.dataId),f=0;f<i;f++){for(var p=[],d=0,v=0;v<r;v++){var m=c[f*r+v];d+=m*u[v],p.push(m);}if(d<0||d>=t.size/s)throw new Error("Invalid indices: "+p+" does not index into "+t.shape);for(var g=0;g<s;g++){l.values[f*s+g]=h[d*s+g];}}return l.toTensor().reshape(a);},t.prototype.scatterND=function(t,e,n){var r=Mr(0,t,n),o=r.sliceRank,a=r.numUpdates,i=r.sliceSize,s=r.strides,u=r.outputSize,l=Cn(0);return this.scatter(t,e,n,u,i,a,o,s,l,!0);},t.prototype.fill=function(t,e,n){var r=k(n=n||W(e),g(t));return r.fill(e),ht.make(t,{values:r},n);},t.prototype.onesLike=function(t){if("string"===t.dtype)throw new Error("onesLike is not supported for string tensors");return this.fill(t.shape,1,t.dtype);},t.prototype.zerosLike=function(t){var e=k(t.dtype,g(t.shape));return ht.make(t.shape,{values:e},t.dtype);},t.prototype.linspace=function(t,e,n){return po(t,e,n);},t.prototype.scatter=function(t,e,n,r,o,a,i,s,u,l){var c=[r/o,o],h=this.readSync(t.dataId),f=this.readSync(e.dataId);if(0===r)return bn([],n,e.dtype);var p=new st(c,e.dtype);p.values.fill(this.readSync(u.dataId)[0]);for(var d=0;d<a;d++){for(var v=[],m=0,g=0;g<i;g++){var y=h[d*i+g];v.push(y),m+=y*s[g];}if(m<0||m>=r/o)throw new Error("Invalid indices: "+v+" does not index into "+n);for(var x=0;x<o;x++){l?p.values[m*o+x]+=f[d*o+x]:p.values[m*o+x]=0===e.rank?f[0]:f[d*o+x];}}return p.toTensor().reshape(n);},t;}();At.registerBackend("cpu",function(){return new Tc();},1);var Dc=function(){function t(){this.textEncoder=new TextEncoder();}return t.prototype.fetch=function(t,e){return fetch(t,e);},t.prototype.now=function(){return performance.now();},t.prototype.encode=function(t,e){if("utf-8"!==e&&"utf8"!==e)throw new Error("Browser's encoder only supports utf-8, but got "+e);return this.textEncoder.encode(t);},t.prototype.decode=function(t,e){return new TextDecoder(e).decode(t);},t;}();i.get("IS_BROWSER")&&i.setPlatform("browser",new Dc());var _c,Oc=function Oc(){return require("node-fetch");},Fc=function(){function t(){this.util=require("util"),this.textEncoder=new this.util.TextEncoder();}return t.prototype.fetch=function(t,e){return null!=i.global.fetch?i.global.fetch(t,e):(null==_c&&(_c=Oc()),_c(t,e));},t.prototype.now=function(){var t=process.hrtime();return 1e3*t[0]+t[1]/1e6;},t.prototype.encode=function(t,e){if("utf-8"!==e&&"utf8"!==e)throw new Error("Node built-in encoder only supports utf-8, but got "+e);return this.textEncoder.encode(t);},t.prototype.decode=function(t,e){return 0===t.length?"":new this.util.TextDecoder(e).decode(t);},t;}();i.get("IS_NODE")&&i.setPlatform("node",new Fc());var Mc={float32:4,int32:4,uint16:2,uint8:1,bool:1},Bc=4;function Pc(t,e){for(var n={},r=0,o=function o(e){var o=e.name,a=e.dtype,i=e.shape,s=g(i),u=void 0;if(("quantization"in e)){var l=e.quantization;if("uint8"!==l.dtype&&"uint16"!==l.dtype)throw new Error("Weight "+e.name+" has unknown quantization dtype "+l.dtype+". Supported quantization dtypes are: 'uint8' and 'uint16'.");var c=Mc[l.dtype],h=t.slice(r,r+s*c),f="uint8"===l.dtype?new Uint8Array(h):new Uint16Array(h);if("float32"===a)u=Float32Array.from(f,function(t){return t*l.scale+l.min;});else{if("int32"!==a)throw new Error("Unsupported dtype in weight '"+o+"': "+a);u=Int32Array.from(f,function(t){return Math.round(t*l.scale+l.min);});}r+=s*c;}else if("string"===a){var p=g(e.shape);u=[];for(var d=0;d<p;d++){var v=new Uint32Array(t.slice(r,r+Bc))[0];r+=Bc;var m=new Uint8Array(t.slice(r,r+v));u.push(m),r+=v;}}else{var y=Mc[a];h=t.slice(r,r+s*y);if("float32"===a)u=new Float32Array(h);else if("int32"===a)u=new Int32Array(h);else{if("bool"!==a)throw new Error("Unsupported dtype in weight '"+o+"': "+a);u=new Uint8Array(h);}r+=s*y;}n[o]=bn(u,i,a);},a=0,i=e;a<i.length;a++){o(i[a]);}return n;}function Lc(t){if(null===t)throw new Error("Invalid input value: "+JSON.stringify(t));var e=0,n=[];t.forEach(function(t){if(e+=t.byteLength,n.push(t.byteLength===t.buffer.byteLength?t:new t.constructor(t)),!(t instanceof Float32Array||t instanceof Int32Array||t instanceof Uint8Array))throw new Error("Unsupported TypedArray subtype: "+t.constructor.name);});var r=new Uint8Array(e),o=0;return n.forEach(function(t){r.set(new Uint8Array(t.buffer),o),o+=t.byteLength;}),r.buffer;}var Wc="undefined"!=typeof Buffer&&("undefined"==typeof Blob||"undefined"==typeof atob||"undefined"==typeof btoa);function Uc(t){return Wc?Buffer.byteLength(t):new Blob([t]).size;}function zc(t){var e=0;t.forEach(function(t){e+=t.byteLength;});var n=new Uint8Array(e),r=0;return t.forEach(function(t){n.set(new Uint8Array(t),r),r+=t.byteLength;}),n.buffer;}function Vc(t){for(t=t.trim();t.endsWith("/");){t=t.slice(0,t.length-1);}var e=t.split("/");return e[e.length-1];}function Gc(t){if(t.modelTopology instanceof ArrayBuffer)throw new Error("Expected JSON model topology, received ArrayBuffer.");return {dateSaved:new Date(),modelTopologyType:"JSON",modelTopologyBytes:null==t.modelTopology?0:Uc(JSON.stringify(t.modelTopology)),weightSpecsBytes:null==t.weightSpecs?0:Uc(JSON.stringify(t.weightSpecs)),weightDataBytes:null==t.weightData?0:t.weightData.byteLength};}var Hc=function(){function t(){this.saveRouters=[],this.loadRouters=[];}return t.getInstance=function(){return null==t.instance&&(t.instance=new t()),t.instance;},t.registerSaveRouter=function(e){t.getInstance().saveRouters.push(e);},t.registerLoadRouter=function(e){t.getInstance().loadRouters.push(e);},t.getSaveHandlers=function(e){return t.getHandlers(e,"save");},t.getLoadHandlers=function(e,n){return t.getHandlers(e,"load",n);},t.getHandlers=function(e,n,r){var o=[];return ("load"===n?t.getInstance().loadRouters:t.getInstance().saveRouters).forEach(function(t){var n=t(e,r);null!==n&&o.push(n);}),o;},t;}(),qc="://",$c=function(){function t(){this.managers={};}return t.getInstance=function(){return null==t.instance&&(t.instance=new t()),t.instance;},t.registerManager=function(e,n){p(null!=e,function(){return "scheme must not be undefined or null.";}),e.endsWith(qc)&&(e=e.slice(0,e.indexOf(qc))),p(e.length>0,function(){return "scheme must not be an empty string.";});var r=t.getInstance();p(null==r.managers[e],function(){return "A model store manager is already registered for scheme '"+e+"'.";}),r.managers[e]=n;},t.getManager=function(t){var e=this.getInstance().managers[t];if(null==e)throw new Error("Cannot find model manager for scheme '"+t+"'");return e;},t.getSchemes=function(){return Object.keys(this.getInstance().managers);},t;}();function jc(t){if(-1===t.indexOf(qc))throw new Error("The url string provided does not contain a scheme. Supported schemes are: "+$c.getSchemes().join(","));return {scheme:t.split(qc)[0],path:t.split(qc)[1]};}function Kc(t,e,o){return void 0===o&&(o=!1),n(this,void 0,void 0,function(){var n,a,i,s,u,l,c,h,f;return r(this,function(r){switch(r.label){case 0:return p(t!==e,function(){return "Old path and new path are the same: '"+t+"'";}),p((n=Hc.getLoadHandlers(t)).length>0,function(){return "Copying failed because no load handler is found for source URL "+t+".";}),p(n.length<2,function(){return "Copying failed because more than one ("+n.length+") load handlers for source URL "+t+".";}),a=n[0],p((i=Hc.getSaveHandlers(e)).length>0,function(){return "Copying failed because no save handler is found for destination URL "+e+".";}),p(i.length<2,function(){return "Copying failed because more than one ("+n.length+") save handlers for destination URL "+e+".";}),s=i[0],u=jc(t).scheme,l=jc(t).path,c=u===jc(t).scheme,[4,a.load()];case 1:return h=r.sent(),o&&c?[4,$c.getManager(u).removeModel(l)]:[3,3];case 2:r.sent(),r.label=3;case 3:return [4,s.save(h)];case 4:return f=r.sent(),!o||c?[3,6]:[4,$c.getManager(u).removeModel(l)];case 5:r.sent(),r.label=6;case 6:return [2,f.modelArtifactsInfo];}});});}var Xc="models_store",Yc="model_info_store";function Qc(){if(!i.getBool("IS_BROWSER"))throw new Error("Failed to obtain IndexedDB factory because the current environmentis not a web browser.");var t=window,e=t.indexedDB||t.mozIndexedDB||t.webkitIndexedDB||t.msIndexedDB||t.shimIndexedDB;if(null==e)throw new Error("The current browser does not appear to support IndexedDB.");return e;}function Jc(t){var e=t.result;e.createObjectStore(Xc,{keyPath:"modelPath"}),e.createObjectStore(Yc,{keyPath:"modelPath"});}var Zc=function(){function t(t){if(this.indexedDB=Qc(),null==t||!t)throw new Error("For IndexedDB, modelPath must not be null, undefined or empty.");this.modelPath=t;}return t.prototype.save=function(t){return n(this,void 0,void 0,function(){return r(this,function(e){if(t.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");return [2,this.databaseAction(this.modelPath,t)];});});},t.prototype.load=function(){return n(this,void 0,void 0,function(){return r(this,function(t){return [2,this.databaseAction(this.modelPath)];});});},t.prototype.databaseAction=function(t,e){var n=this;return new Promise(function(t,r){var o=n.indexedDB.open("tensorflowjs",1);o.onupgradeneeded=function(){return Jc(o);},o.onsuccess=function(){var a=o.result;if(null==e){var i=a.transaction(Xc,"readonly"),s=i.objectStore(Xc).get(n.modelPath);s.onsuccess=function(){if(null==s.result)return a.close(),r(new Error("Cannot find model with path '"+n.modelPath+"' in IndexedDB."));t(s.result.modelArtifacts);},s.onerror=function(t){return a.close(),r(s.error);},i.oncomplete=function(){return a.close();};}else{var u,l=Gc(e),c=a.transaction(Yc,"readwrite"),h=c.objectStore(Yc),f=h.put({modelPath:n.modelPath,modelArtifactsInfo:l});f.onsuccess=function(){var o=(u=a.transaction(Xc,"readwrite")).objectStore(Xc).put({modelPath:n.modelPath,modelArtifacts:e,modelArtifactsInfo:l});o.onsuccess=function(){return t({modelArtifactsInfo:l});},o.onerror=function(t){var e=(h=c.objectStore(Yc))["delete"](n.modelPath);e.onsuccess=function(){return a.close(),r(o.error);},e.onerror=function(t){return a.close(),r(o.error);};};},f.onerror=function(t){return a.close(),r(f.error);},c.oncomplete=function(){null==u?a.close():u.oncomplete=function(){return a.close();};};}},o.onerror=function(t){return r(o.error);};});},t.URL_SCHEME="indexeddb://",t;}(),th=function th(t){return i.getBool("IS_BROWSER")&&!Array.isArray(t)&&t.startsWith(Zc.URL_SCHEME)?(e=t.slice(Zc.URL_SCHEME.length),new Zc(e)):null;var e;};Hc.registerSaveRouter(th),Hc.registerLoadRouter(th);var eh=function(){function t(){this.indexedDB=Qc();}return t.prototype.listModels=function(){return n(this,void 0,void 0,function(){var t=this;return r(this,function(e){return [2,new Promise(function(e,n){var r=t.indexedDB.open("tensorflowjs",1);r.onupgradeneeded=function(){return Jc(r);},r.onsuccess=function(){var t=r.result,o=t.transaction(Yc,"readonly"),a=o.objectStore(Yc).getAll();a.onsuccess=function(){for(var t={},n=0,r=a.result;n<r.length;n++){var o=r[n];t[o.modelPath]=o.modelArtifactsInfo;}e(t);},a.onerror=function(e){return t.close(),n(a.error);},o.oncomplete=function(){return t.close();};},r.onerror=function(t){return n(r.error);};})];});});},t.prototype.removeModel=function(t){return n(this,void 0,void 0,function(){var e=this;return r(this,function(n){var r;return t=(r=t).startsWith(Zc.URL_SCHEME)?r.slice(Zc.URL_SCHEME.length):r,[2,new Promise(function(n,r){var o=e.indexedDB.open("tensorflowjs",1);o.onupgradeneeded=function(){return Jc(o);},o.onsuccess=function(){var e,a=o.result,i=a.transaction(Yc,"readwrite"),s=i.objectStore(Yc),u=s.get(t);u.onsuccess=function(){if(null==u.result)return a.close(),r(new Error("Cannot find model with path '"+t+"' in IndexedDB."));var o=s["delete"](t),i=function i(){var o=(e=a.transaction(Xc,"readwrite")).objectStore(Xc)["delete"](t);o.onsuccess=function(){return n(u.result.modelArtifactsInfo);},o.onerror=function(t){return r(u.error);};};o.onsuccess=i,o.onerror=function(t){return i(),a.close(),r(u.error);};},u.onerror=function(t){return a.close(),r(u.error);},i.oncomplete=function(){null==e?a.close():e.oncomplete=function(){return a.close();};};},o.onerror=function(t){return r(o.error);};})];});});},t;}();if(i.getBool("IS_BROWSER"))try{$c.registerManager(Zc.URL_SCHEME,new eh());}catch(t){}var nh="/",rh="tensorflowjs_models",oh="info",ah="model_topology",ih="weight_specs",sh="weight_data",uh="model_metadata";function lh(t){return {info:[rh,t,oh].join(nh),topology:[rh,t,ah].join(nh),weightSpecs:[rh,t,ih].join(nh),weightData:[rh,t,sh].join(nh),modelMetadata:[rh,t,uh].join(nh)};}function ch(t){var e=t.split(nh);if(e.length<3)throw new Error("Invalid key format: "+t);return e.slice(1,e.length-1).join(nh);}var hh=function(){function t(t){if(!i.getBool("IS_BROWSER")||void 0===window.localStorage)throw new Error("The current environment does not support local storage.");if(this.LS=window.localStorage,null==t||!t)throw new Error("For local storage, modelPath must not be null, undefined or empty.");this.modelPath=t,this.keys=lh(this.modelPath);}return t.prototype.save=function(t){return n(this,void 0,void 0,function(){var e,n,o;return r(this,function(r){if(t.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");e=JSON.stringify(t.modelTopology),n=JSON.stringify(t.weightSpecs),o=Gc(t);try{return this.LS.setItem(this.keys.info,JSON.stringify(o)),this.LS.setItem(this.keys.topology,e),this.LS.setItem(this.keys.weightSpecs,n),this.LS.setItem(this.keys.weightData,(a=t.weightData,Wc?Buffer.from(a).toString("base64"):btoa(String.fromCharCode.apply(null,new Uint8Array(a))))),this.LS.setItem(this.keys.modelMetadata,JSON.stringify({format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy})),[2,{modelArtifactsInfo:o}];}catch(t){throw this.LS.removeItem(this.keys.info),this.LS.removeItem(this.keys.topology),this.LS.removeItem(this.keys.weightSpecs),this.LS.removeItem(this.keys.weightData),this.LS.removeItem(this.keys.modelMetadata),new Error("Failed to save model '"+this.modelPath+"' to local storage: size quota being exceeded is a possible cause of this failure: modelTopologyBytes="+o.modelTopologyBytes+", weightSpecsBytes="+o.weightSpecsBytes+", weightDataBytes="+o.weightDataBytes+".");}var a;return [2];});});},t.prototype.load=function(){return n(this,void 0,void 0,function(){var t,e,n,o,a,i,s;return r(this,function(r){if(null==(t=JSON.parse(this.LS.getItem(this.keys.info))))throw new Error("In local storage, there is no model with name '"+this.modelPath+"'");if("JSON"!==t.modelTopologyType)throw new Error("BrowserLocalStorage does not support loading non-JSON model topology yet.");if(e={},null==(n=JSON.parse(this.LS.getItem(this.keys.topology))))throw new Error("In local storage, the topology of model '"+this.modelPath+"' is missing.");if(e.modelTopology=n,null==(o=JSON.parse(this.LS.getItem(this.keys.weightSpecs))))throw new Error("In local storage, the weight specs of model '"+this.modelPath+"' are missing.");if(e.weightSpecs=o,null!=(a=this.LS.getItem(this.keys.modelMetadata))&&(i=JSON.parse(a),e.format=i.format,e.generatedBy=i.generatedBy,e.convertedBy=i.convertedBy),null==(s=this.LS.getItem(this.keys.weightData)))throw new Error("In local storage, the binary weight values of model '"+this.modelPath+"' are missing.");return e.weightData=function(t){if(Wc){var e=Buffer.from(t,"base64");return e.buffer.slice(e.byteOffset,e.byteOffset+e.byteLength);}for(var n=atob(t),r=new Uint8Array(n.length),o=0;o<n.length;++o){r.set([n.charCodeAt(o)],o);}return r.buffer;}(s),[2,e];});});},t.URL_SCHEME="localstorage://",t;}(),fh=function fh(t){return i.getBool("IS_BROWSER")&&!Array.isArray(t)&&t.startsWith(hh.URL_SCHEME)?(e=t.slice(hh.URL_SCHEME.length),new hh(e)):null;var e;};Hc.registerSaveRouter(fh),Hc.registerLoadRouter(fh);var ph=function(){function t(){p(i.getBool("IS_BROWSER"),function(){return "Current environment is not a web browser";}),p(void 0!==window.localStorage,function(){return "Current browser does not appear to support localStorage";}),this.LS=window.localStorage;}return t.prototype.listModels=function(){return n(this,void 0,void 0,function(){var t,e,n,o,a,i;return r(this,function(r){for(t={},e=rh+nh,n=nh+oh,o=0;o<this.LS.length;++o){(a=this.LS.key(o)).startsWith(e)&&a.endsWith(n)&&(i=ch(a),t[i]=JSON.parse(this.LS.getItem(a)));}return [2,t];});});},t.prototype.removeModel=function(t){return n(this,void 0,void 0,function(){var e,n;return r(this,function(r){var o;if(t=(o=t).startsWith(hh.URL_SCHEME)?o.slice(hh.URL_SCHEME.length):o,e=lh(t),null==this.LS.getItem(e.info))throw new Error("Cannot find model at path '"+t+"'");return n=JSON.parse(this.LS.getItem(e.info)),this.LS.removeItem(e.info),this.LS.removeItem(e.topology),this.LS.removeItem(e.weightSpecs),this.LS.removeItem(e.weightData),[2,n];});});},t;}();if(i.getBool("IS_BROWSER"))try{$c.registerManager(hh.URL_SCHEME,new ph());}catch(t){}var dh="model",vh=".json",mh=".weights.bin";function gh(t){return new Promise(function(t){return setTimeout(t);}).then(t);}var yh=function(){function t(e){if(!i.getBool("IS_BROWSER"))throw new Error("browserDownloads() cannot proceed because the current environment is not a browser.");e.startsWith(t.URL_SCHEME)&&(e=e.slice(t.URL_SCHEME.length)),null!=e&&0!==e.length||(e=dh),this.modelTopologyFileName=e+vh,this.weightDataFileName=e+mh;}return t.prototype.save=function(t){return n(this,void 0,void 0,function(){var e,n,o,a,i,s;return r(this,function(r){switch(r.label){case 0:if("undefined"==typeof document)throw new Error("Browser downloads are not supported in this environment since `document` is not present");if(e=window.URL.createObjectURL(new Blob([t.weightData],{type:"application/octet-stream"})),!(t.modelTopology instanceof ArrayBuffer))return [3,1];throw new Error("BrowserDownloads.save() does not support saving model topology in binary formats yet.");case 1:return n=[{paths:["./"+this.weightDataFileName],weights:t.weightSpecs}],o={modelTopology:t.modelTopology,format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy,weightsManifest:n},a=window.URL.createObjectURL(new Blob([JSON.stringify(o)],{type:"application/json"})),(i=null==this.jsonAnchor?document.createElement("a"):this.jsonAnchor).download=this.modelTopologyFileName,i.href=a,[4,gh(function(){return i.dispatchEvent(new MouseEvent("click"));})];case 2:return r.sent(),null==t.weightData?[3,4]:((s=null==this.weightDataAnchor?document.createElement("a"):this.weightDataAnchor).download=this.weightDataFileName,s.href=e,[4,gh(function(){return s.dispatchEvent(new MouseEvent("click"));})]);case 3:r.sent(),r.label=4;case 4:return [2,{modelArtifactsInfo:Gc(t)}];}});});},t.URL_SCHEME="downloads://",t;}(),xh=function(){function t(t){if(null==t||t.length<1)throw new Error("When calling browserFiles, at least 1 file is required, but received "+t);this.files=t;}return t.prototype.load=function(){return n(this,void 0,void 0,function(){var t,e,n=this;return r(this,function(r){return t=this.files[0],e=this.files.slice(1),[2,new Promise(function(r,o){var a=new FileReader();a.onload=function(a){var i=JSON.parse(a.target.result),s=i.modelTopology;if(null!=s){0===e.length&&r({modelTopology:s});var u=i.weightsManifest;if(null!=u){var l;try{l=n.checkManifestAndWeightFiles(u,e);}catch(t){return void o(t);}var c=[],h=[],f=[];u.forEach(function(t){t.paths.forEach(function(t){h.push(t),f.push(null);}),c.push.apply(c,t.weights);}),u.forEach(function(t){t.paths.forEach(function(t){var e=new FileReader();e.onload=function(e){var n=e.target.result,o=h.indexOf(t);f[o]=n,-1===f.indexOf(null)&&r({modelTopology:s,weightSpecs:c,weightData:zc(f)});},e.onerror=function(e){return o("Failed to weights data from file of path '"+t+"'.");},e.readAsArrayBuffer(l[t]);});});}else o(new Error("weightManifest field is missing from file "+t.name));}else o(new Error("modelTopology field is missing from file "+t.name));},a.onerror=function(e){return o("Failed to read model topology and weights manifest JSON from file '"+t.name+"'. BrowserFiles supports loading Keras-style tf.Model artifacts only.");},a.readAsText(t);})];});});},t.prototype.checkManifestAndWeightFiles=function(t,e){for(var n=[],r=e.map(function(t){return Vc(t.name);}),o={},a=0,i=t;a<i.length;a++){i[a].paths.forEach(function(t){var a=Vc(t);if(-1!==n.indexOf(a))throw new Error("Duplicate file basename found in weights manifest: '"+a+"'");if(n.push(a),-1===r.indexOf(a))throw new Error("Weight file with basename '"+a+"' is not provided.");o[t]=e[r.indexOf(a)];});}if(n.length!==e.length)throw new Error("Mismatch in the number of files in weights manifest ("+n.length+") and the number of weight files provided ("+e.length+").");return o;},t;}();function bh(t,e,n,r){!function(t){p(null!=t&&Array.isArray(t)&&t.length>0,function(){return "promises must be a none empty array";});}(t),function(t,e){p(t>=0&&t<=1,function(){return "Progress fraction must be in range [0, 1], but got startFraction "+t;}),p(e>=0&&e<=1,function(){return "Progress fraction must be in range [0, 1], but got endFraction "+e;}),p(e>=t,function(){return "startFraction must be no more than endFraction, but got startFraction "+t+" and endFraction "+e;});}(n=null==n?0:n,r=null==r?1:r);var o=0;return Promise.all(t.map(function(a){return a.then(function(a){var i=n+ ++o/t.length*(r-n);return e(i),a;}),a;}));}function wh(t,e){return n(this,void 0,void 0,function(){var n,o,a,s,u,l,c,h,f;return r(this,function(r){switch(r.label){case 0:return null==e&&(e={}),n=null==e.fetchFunc?i.platform.fetch:e.fetchFunc,o=t.map(function(t){return n(t,e.requestInit,{isBinary:!0});}),a=0,s=.5,null!=e.onProgress?[3,2]:[4,Promise.all(o)];case 1:return u=r.sent(),[3,4];case 2:return [4,bh(o,e.onProgress,a,s)];case 3:u=r.sent(),r.label=4;case 4:return l=u.map(function(t){return t.arrayBuffer();}),c=.5,h=1,null!=e.onProgress?[3,6]:[4,Promise.all(l)];case 5:return f=r.sent(),[3,8];case 6:return [4,bh(l,e.onProgress,c,h)];case 7:f=r.sent(),r.label=8;case 8:return [2,f];}});});}function Ch(t){var e=this;return function(o,a,i){return void 0===a&&(a=""),n(e,void 0,void 0,function(){var e,n,s,u,l,c,h,f,p,d;return r(this,function(r){switch(r.label){case 0:if(e=o.map(function(){return !1;}),n={},s=null!=i?i.map(function(){return !1;}):[],u=[],o.forEach(function(t,r){var o=0;t.weights.forEach(function(t){var a="quantization"in t?t.quantization.dtype:t.dtype,l=Mc[a]*g(t.shape),c=function c(){e[r]=!0,null==n[r]&&(n[r]=[]),n[r].push({manifestEntry:t,groupOffset:o,sizeBytes:l});};null!=i?i.forEach(function(e,n){e===t.name&&(c(),s[n]=!0);}):c(),u.push(t.name),o+=l;});}),!s.every(function(t){return t;}))throw l=i.filter(function(t,e){return !s[e];}),new Error("Could not find weights in manifest with names: "+l.join(", ")+". \nManifest JSON has weights with names: "+u.join(", ")+".");return c=e.reduce(function(t,e,n){return e&&t.push(n),t;},[]),h=[],c.forEach(function(t){o[t].paths.forEach(function(t){var e=a+(a.endsWith("/")?"":"/")+t;h.push(e);});}),[4,t(h)];case 1:return f=r.sent(),p={},d=0,c.forEach(function(t){for(var e=o[t].paths.length,r=0,a=0;a<e;a++){r+=f[d+a].byteLength;}for(var i=new ArrayBuffer(r),s=new Uint8Array(i),u=0,l=0;l<e;l++){var c=new Uint8Array(f[d+l]);s.set(c,u),u+=c.byteLength;}n[t].forEach(function(t){var e=Pc(i.slice(t.groupOffset,t.groupOffset+t.sizeBytes),[t.manifestEntry]);for(var n in e){p[n]=e[n];}}),d+=e;}),[2,p];}});});};}Hc.registerSaveRouter(function(t){return i.getBool("IS_BROWSER")&&!Array.isArray(t)&&t.startsWith(yh.URL_SCHEME)?(e=t.slice(yh.URL_SCHEME.length),void 0===e&&(e="model"),new yh(e)):null;var e;});var Eh=function(){function t(t,e){if(this.DEFAULT_METHOD="POST",null==e&&(e={}),this.weightPathPrefix=e.weightPathPrefix,this.onProgress=e.onProgress,null!=e.fetchFunc?(p("function"==typeof e.fetchFunc,function(){return "Must pass a function that matches the signature of `fetch` (see https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API)";}),this.fetch=e.fetchFunc):this.fetch=i.platform.fetch,p(null!=t&&t.length>0,function(){return "URL path for http must not be null, undefined or empty.";}),Array.isArray(t)&&p(2===t.length,function(){return "URL paths for http must have a length of 2, (actual length is "+t.length+").";}),this.path=t,null!=e.requestInit&&null!=e.requestInit.body)throw new Error("requestInit is expected to have no pre-existing body, but has one.");this.requestInit=e.requestInit||{};}return t.prototype.save=function(t){return n(this,void 0,void 0,function(){var e,n,o,a;return r(this,function(r){switch(r.label){case 0:if(t.modelTopology instanceof ArrayBuffer)throw new Error("BrowserHTTPRequest.save() does not support saving model topology in binary formats yet.");return (e=Object.assign({method:this.DEFAULT_METHOD},this.requestInit)).body=new FormData(),n=[{paths:["./model.weights.bin"],weights:t.weightSpecs}],o={modelTopology:t.modelTopology,format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy,weightsManifest:n},e.body.append("model.json",new Blob([JSON.stringify(o)],{type:"application/json"}),"model.json"),null!=t.weightData&&e.body.append("model.weights.bin",new Blob([t.weightData],{type:"application/octet-stream"}),"model.weights.bin"),[4,this.fetch(this.path,e)];case 1:if((a=r.sent()).ok)return [2,{modelArtifactsInfo:Gc(t),responses:[a]}];throw new Error("BrowserHTTPRequest.save() failed due to HTTP response status "+a.status+".");}});});},t.prototype.load=function(){return n(this,void 0,void 0,function(){var t,e,n,o,a,i,s,u;return r(this,function(r){switch(r.label){case 0:return [4,this.fetch(this.path,this.requestInit)];case 1:if(!(t=r.sent()).ok)throw new Error("Request to "+this.path+" failed with status code "+t.status+". Please verify this URL points to the model JSON of the model to load.");r.label=2;case 2:return r.trys.push([2,4,,5]),[4,t.json()];case 3:return e=r.sent(),[3,5];case 4:throw r.sent(),n="Failed to parse model JSON of response from "+this.path+".",this.path.endsWith(".pb")?n+=" Your path contains a .pb file extension. Support for .pb models have been removed in TensorFlow.js 1.0 in favor of .json models. You can re-convert your Python TensorFlow model using the TensorFlow.js 1.0 conversion scripts or you can convert your.pb models with the 'pb2json'NPM script in the tensorflow/tfjs-converter repository.":n+=" Please make sure the server is serving valid JSON for this request.",new Error(n);case 5:if(o=e.modelTopology,a=e.weightsManifest,null==o&&null==a)throw new Error("The JSON from HTTP path "+this.path+" contains neither model topology or manifest for weights.");return null==a?[3,7]:[4,this.loadWeights(a)];case 6:u=r.sent(),i=u[0],s=u[1],r.label=7;case 7:return [2,{modelTopology:o,weightSpecs:i,weightData:s}];}});});},t.prototype.loadWeights=function(t){return n(this,void 0,void 0,function(){var e,n,o,a,i,s,u,l,c,h,f;return r(this,function(r){switch(r.label){case 0:for(e=Array.isArray(this.path)?this.path[1]:this.path,n=function(t){var e=t.lastIndexOf("/"),n=t.lastIndexOf("?"),r=t.substring(0,e),o=n>e?t.substring(n):"";return [r+"/",o];}(e),o=n[0],a=n[1],i=this.weightPathPrefix||o,s=[],u=0,l=t;u<l.length;u++){c=l[u],s.push.apply(s,c.weights);}return h=[],t.forEach(function(t){t.paths.forEach(function(t){h.push(i+t+a);});}),[4,wh(h,{requestInit:this.requestInit,fetchFunc:this.fetch,onProgress:this.onProgress})];case 1:return f=r.sent(),[2,[s,zc(f)]];}});});},t.URL_SCHEME_REGEX=/^https?:\/\//,t;}();function Rh(t){return null!=t.match(Eh.URL_SCHEME_REGEX);}var Ih=function Ih(t,e){if("undefined"==typeof fetch)return null;return (Array.isArray(t)?t.every(function(t){return Rh(t);}):Rh(t))?Sh(t,{onProgress:e}):null;};function Sh(t,e){return new Eh(t,e);}Hc.registerSaveRouter(Ih),Hc.registerLoadRouter(Ih);var Nh=function(){function t(t){this.modelArtifacts=t;}return t.prototype.load=function(){return n(this,void 0,void 0,function(){return r(this,function(t){return [2,this.modelArtifacts];});});},t;}(),kh=function(){function t(t){this.saveHandler=t;}return t.prototype.save=function(t){return n(this,void 0,void 0,function(){return r(this,function(e){return [2,this.saveHandler(t)];});});},t;}();var Ah=Object.freeze({browserFiles:function browserFiles(t){return new xh(t);},browserHTTPRequest:function browserHTTPRequest(t,e){return Sh(t,e);},concatenateArrayBuffers:zc,decodeWeights:Pc,encodeWeights:function encodeWeights(t,e){return n(this,void 0,void 0,function(){var o,a,i,s,u,l=this;return r(this,function(c){switch(c.label){case 0:for(o=[],a=[],i=Array.isArray(t)?t.map(function(t){return t.name;}):Object.keys(t),s=function s(_s2){var u=i[_s2],c=Array.isArray(t)?t[_s2].tensor:t[u];if("float32"!==c.dtype&&"int32"!==c.dtype&&"bool"!==c.dtype&&"string"!==c.dtype)throw new Error("Unsupported dtype in weight '"+u+"': "+c.dtype);var h={name:u,shape:c.shape,dtype:c.dtype};if("string"===c.dtype){var f=new Promise(function(t){return n(l,void 0,void 0,function(){var e,n,o,a,i,s,u;return r(this,function(r){switch(r.label){case 0:return [4,c.bytes()];case 1:for(e=r.sent(),n=e.reduce(function(t,e){return t+e.length;},0)+Bc*e.length,o=new Uint8Array(n),a=0,i=0;i<e.length;i++){s=e[i],u=new Uint8Array(new Uint32Array([s.length]).buffer),o.set(u,a),a+=Bc,o.set(s,a),a+=s.length;}return t(o),[2];}});});});a.push(f);}else a.push(c.data());null!=e&&(h.group=e),o.push(h);},u=0;u<i.length;++u){s(u);}return [4,Promise.all(a)];case 1:return [2,{data:Lc(c.sent()),specs:o}];}});});},fromMemory:function fromMemory(t,e,n,r){return 1===arguments.length?null!=t.modelTopology||null!=t.weightSpecs?new Nh(t):(console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new Nh({modelTopology:t})):(console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new Nh({modelTopology:t,weightSpecs:e,weightData:n,trainingConfig:r}));},getLoadHandlers:function getLoadHandlers(t,e){return Hc.getLoadHandlers(t,e);},getModelArtifactsInfoForJSON:Gc,getSaveHandlers:function getSaveHandlers(t){return Hc.getSaveHandlers(t);},http:Sh,isHTTPScheme:Rh,loadWeights:function loadWeights(t,e,o,a){return void 0===e&&(e=""),n(this,void 0,void 0,function(){return r(this,function(n){return [2,Ch(function(t){return wh(t,{requestInit:a});})(t,e,o)];});});},registerLoadRouter:function registerLoadRouter(t){return Hc.registerLoadRouter(t);},registerSaveRouter:function registerSaveRouter(t){return Hc.registerSaveRouter(t);},weightsLoaderFactory:Ch,withSaveHandler:function withSaveHandler(t){return new kh(t);},copyModel:function copyModel(t,e){return n(this,void 0,void 0,function(){return r(this,function(n){return [2,Kc(t,e,!1)];});});},listModels:function listModels(){return n(this,void 0,void 0,function(){var t,e,n,o,a,i,s;return r(this,function(r){switch(r.label){case 0:t=$c.getSchemes(),e={},n=0,o=t,r.label=1;case 1:return n<o.length?(a=o[n],[4,$c.getManager(a).listModels()]):[3,4];case 2:for(s in i=r.sent()){e[a+qc+s]=i[s];}r.label=3;case 3:return n++,[3,1];case 4:return [2,e];}});});},moveModel:function moveModel(t,e){return n(this,void 0,void 0,function(){return r(this,function(n){return [2,Kc(t,e,!0)];});});},removeModel:function removeModel(t){return n(this,void 0,void 0,function(){var e;return r(this,function(n){return e=jc(t),[2,$c.getManager(e.scheme).removeModel(e.path)];});});}});var Th=mn({confusionMatrix_:function confusionMatrix_(t,e,n){var r=rn(t,"labels","confusionMatrix"),o=rn(e,"predictions","confusionMatrix");p(null==n||n>0&&Number.isInteger(n),function(){return "If provided, numClasses must be a positive integer, but got "+n;}),p(1===r.rank,function(){return "Expected the rank of labels to be 1, but got "+r.rank;}),p(1===o.rank,function(){return "Expected the rank of predictions to be 1, but got "+o.rank;}),p(r.shape[0]===o.shape[0],function(){return "Mismatch in the number of examples: "+r.shape[0]+" vs. "+o.shape[0]+". Labels and predictions should have the same number of elements.";}),p(n>0&&Number.isInteger(n),function(){return "numClasses is required to be a positive integer, but got "+n;});var a=lr(r.asType("int32"),n),i=lr(o.asType("int32"),n);return a.transpose().matMul(i).asType("int32");}}),Dh=Object.freeze({confusionMatrix:Th});var _h=mn({fromPixels_:function fromPixels_(t,e){if(void 0===e&&(e=3),e>4)throw new Error("Cannot construct Tensor with more than 4 channels from pixels.");return At.fromPixels(t,e);}}),Oh=Object.freeze({toPixels:function toPixels(t,e){return n(this,void 0,void 0,function(){var n,o,a,i,s,u,l,c,h,f,p,d,v,m,g,y,x,b,w,C,E,R,I;return r(this,function(r){switch(r.label){case 0:if(n=rn(t,"img","toPixels"),t instanceof ht||(n=n.toInt()),2!==n.rank&&3!==n.rank)throw new Error("toPixels only supports rank 2 or 3 tensors, got rank "+n.rank+".");if(o=n.shape.slice(0,2),a=o[0],i=o[1],(s=2===n.rank?1:n.shape[2])>4||2===s)throw new Error("toPixels only supports depth of size 1, 3 or 4 but got "+s);return [4,n.data()];case 1:return u=r.sent(),l=n.min(),c=n.max(),[4,Promise.all([l.data(),c.data()])];case 2:if(h=r.sent(),f=h[0],p=h[1],d=f[0],v=p[0],l.dispose(),c.dispose(),"float32"===n.dtype){if(d<0||v>1)throw new Error("Tensor values for a float32 Tensor must be in the range [0 - 1] but got range ["+d+" - "+v+"].");}else{if("int32"!==n.dtype)throw new Error("Unsupported type for toPixels: "+n.dtype+". Please use float32 or int32 tensors.");if(d<0||v>255)throw new Error("Tensor values for a int32 Tensor must be in the range [0 - 255] but got range ["+d+" - "+v+"].");}for(m="float32"===n.dtype?255:1,g=new Uint8ClampedArray(i*a*4),y=0;y<a*i;++y){x=void 0,b=void 0,w=void 0,C=void 0,1===s?(x=u[y]*m,b=u[y]*m,w=u[y]*m,C=255):3===s?(x=u[3*y]*m,b=u[3*y+1]*m,w=u[3*y+2]*m,C=255):4===s&&(x=u[4*y]*m,b=u[4*y+1]*m,w=u[4*y+2]*m,C=u[4*y+3]*m),g[0+(E=4*y)]=Math.round(x),g[E+1]=Math.round(b),g[E+2]=Math.round(w),g[E+3]=Math.round(C);}return null!=e&&(e.width=i,e.height=a,R=e.getContext("2d"),I=new ImageData(g,i,a),R.putImageData(I,0,0)),n!==t&&n.dispose(),[2,g];}});});},fromPixels:_h}),Fh=function(){function t(){}return t.prototype.getClassName=function(){return this.constructor.className;},t.fromConfig=function(t,e){return new t(e);},t;}(),Mh=function(){function t(){this.classNameMap={};}return t.getMap=function(){return null==t.instance&&(t.instance=new t()),t.instance;},t.register=function(e){t.getMap().classNameMap[e.className]=[e,e.fromConfig];},t;}();function Bh(t){p(null!=t.className,function(){return "Class being registered does not have the static className property defined.";}),p("string"==typeof t.className,function(){return "className is required to be a string, but got type "+_typeof_1(t.className);}),p(t.className.length>0,function(){return "Class being registered has an empty-string as its className, which is disallowed.";}),Mh.register(t);}var Ph=Object.freeze({Serializable:Fh,SerializationMap:Mh,registerClass:Bh}),Lh=.001,Wh=.1;function Uh(){return 32===At.backend.floatPrecision()?Lh:Wh;}function zh(t,e,n){var r=!0;if((O(t)||O(e))&&(r=!1),O(t)&&O(e)&&(r=!0),r){var o=t.constructor.name,a=e.constructor.name;if(o!==a)throw new Error("Arrays are of different type. Actual: "+o+". Expected: "+a);}if(Array.isArray(t)&&Array.isArray(e)){var i=en(t),s=en(e);if(!y(i,s))throw new Error("Arrays have different shapes. Actual: ["+i+"]. Expected: ["+s+"]");}var u=O(t)?t:m(t),l=O(e)?e:m(e);if(u.length!==l.length)throw new Error("Arrays have different lengths actual: "+u.length+" vs expected: "+l.length+".\nActual:   "+u+".\nExpected: "+l+".");for(var c=0;c<l.length;++c){var h=u[c],f=l[c];if(!n(h,f))throw new Error("Arrays differ: actual["+c+"] = "+h+", expected["+c+"] = "+f+".\nActual:   "+u+".\nExpected: "+l+".");}}function Vh(t,e,n){return !isFinite(t)&&!isFinite(e)||!(isNaN(t)||isNaN(e)||Math.abs(t-e)>n);}var Gh=Object.freeze({TEST_EPSILON_FLOAT16:Wh,expectArraysClose:function expectArraysClose(t,e,n){return null==n&&(n=Uh()),zh(t,e,function(t,e){return Vh(t,e,n);});},testEpsilon:Uh,expectPromiseToFail:function expectPromiseToFail(t,e){t().then(function(){return e.fail();},function(){return e();});},expectArraysEqual:function expectArraysEqual(t,e){var n="string"==typeof e||"number"==typeof e||"boolean"==typeof e?[e]:e;return B(t)||B(t[0])||B(e)||B(e[0])?zh(t,n,function(t,e){return t==e;}):zh(t,e,function(t,e){return Vh(t,e,0);});},expectNumbersClose:function expectNumbersClose(t,e,n){if(null==n&&(n=Uh()),!Vh(t,e,n))throw new Error("Numbers differ: actual === "+t+", expected === "+e);},expectValuesInRange:function expectValuesInRange(t,e,n){for(var r=0;r<t.length;r++){if(t[r]<e||t[r]>n)throw new Error("Value out of range:"+t[r]+" low: "+e+", high: "+n);}},expectArrayBuffersEqual:function expectArrayBuffersEqual(t,e){expect(new Float32Array(t)).toEqual(new Float32Array(e));}}),Hh="1.2.7",qh=Object.freeze({gpgpu_util:ei,webgl_util:Oe,MathBackendWebGL:os,setWebGLContext:Mt,GPGPUContext:ni}),$h=function(t){function o(){return null!==t&&t.apply(this,arguments)||this;}return e(o,t),o.prototype.minimize=function(t,e,n){void 0===e&&(e=!1);var r=this.computeGradients(t,n),o=r.value,a=r.grads;if(null!=n){var i=n.map(function(t){return {name:t.name,tensor:a[t.name]};});this.applyGradients(i);}else this.applyGradients(a);return Ve(a),e?o:(o.dispose(),null);},Object.defineProperty(o.prototype,"iterations",{get:function get(){return null==this.iterations_&&(this.iterations_=0),this.iterations_;},enumerable:!0,configurable:!0}),o.prototype.incrementIterations=function(){this.iterations_=this.iterations+1;},o.prototype.computeGradients=function(t,e){return qr(t,e);},o.prototype.dispose=function(){null!=this.iterations_&&Ve(this.iterations_);},o.prototype.saveIterations=function(){return n(this,void 0,void 0,function(){return r(this,function(t){return null==this.iterations_&&(this.iterations_=0),[2,{name:"iter",tensor:Cn(this.iterations_,"int32")}];});});},o.prototype.getWeights=function(){return n(this,void 0,void 0,function(){return r(this,function(t){throw new Error("getWeights() is not implemented for this optimizer yet.");});});},o.prototype.setWeights=function(t){return n(this,void 0,void 0,function(){return r(this,function(t){throw new Error("setWeights() is not implemented for this optimizer class "+this.getClassName());});});},o.prototype.extractIterations=function(t){return n(this,void 0,void 0,function(){var e;return r(this,function(n){switch(n.label){case 0:return e=this,[4,t[0].tensor.data()];case 1:return e.iterations_=n.sent()[0],[2,t.slice(1)];}});});},o;}(Fh);Object.defineProperty($h,Symbol.hasInstance,{value:function value(t){return null!=t.minimize&&null!=t.computeGradients&&null!=t.applyGradients;}});var jh=function(t){function o(e,n,r){void 0===r&&(r=null);var o=t.call(this)||this;return o.learningRate=e,o.rho=n,o.epsilon=r,o.accumulatedGrads=[],o.accumulatedUpdates=[],null==r&&(o.epsilon=At.backend.epsilon()),o;}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map(function(t){return t.name;}):Object.keys(t)).forEach(function(n,r){var o=At.registeredVariables[n];null==e.accumulatedGrads[r]&&(e.accumulatedGrads[r]={originalName:n+"/accum_grad",variable:ze(function(){return Mn(o).variable(!1);})}),null==e.accumulatedUpdates[r]&&(e.accumulatedUpdates[r]={originalName:n+"/accum_var",variable:ze(function(){return Mn(o).variable(!1);})});var a=Array.isArray(t)?t[r].tensor:t[n];if(null!=a){var i=e.accumulatedGrads[r].variable,s=e.accumulatedUpdates[r].variable;ze(function(){var t=i.mul(e.rho).add(a.square().mul(1-e.rho)),n=s.add(e.epsilon).sqrt().div(i.add(e.epsilon).sqrt()).mul(a),r=s.mul(e.rho).add(n.square().mul(1-e.rho));i.assign(t),s.assign(r);var u=n.mul(-e.learningRate).add(o);o.assign(u);});}}),this.incrementIterations();},o.prototype.dispose=function(){null!=this.accumulatedUpdates&&(Ve(this.accumulatedGrads.map(function(t){return t.variable;})),Ve(this.accumulatedUpdates.map(function(t){return t.variable;})));},o.prototype.getWeights=function(){return n(this,void 0,void 0,function(){var t;return r(this,function(e){switch(e.label){case 0:return t=this.accumulatedGrads.concat(this.accumulatedUpdates),[4,this.saveIterations()];case 1:return [2,[e.sent()].concat(t.map(function(t){return {name:t.originalName,tensor:t.variable};}))];}});});},o.prototype.setWeights=function(t){return n(this,void 0,void 0,function(){var e;return r(this,function(n){switch(n.label){case 0:return [4,this.extractIterations(t)];case 1:return t=n.sent(),e=t.length/2,this.accumulatedGrads=t.slice(0,e).map(function(t){return {originalName:t.name,variable:t.tensor.variable(!1)};}),this.accumulatedUpdates=t.slice(e,2*e).map(function(t){return {originalName:t.name,variable:t.tensor.variable(!1)};}),[2];}});});},o.prototype.getConfig=function(){return {learningRate:this.learningRate,rho:this.rho,epsilon:this.epsilon};},o.fromConfig=function(t,e){return new t(e.learningRate,e.rho,e.epsilon);},o.className="Adadelta",o;}($h);Bh(jh);var Kh=function(t){function o(e,n){void 0===n&&(n=.1);var r=t.call(this)||this;return r.learningRate=e,r.initialAccumulatorValue=n,r.accumulatedGrads=[],r;}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map(function(t){return t.name;}):Object.keys(t)).forEach(function(n,r){var o=At.registeredVariables[n];if(null==e.accumulatedGrads[r]){e.accumulatedGrads[r]={originalName:n+"/accumulator",variable:ze(function(){return Dn(o.shape,e.initialAccumulatorValue).variable(!1);})};}var a=Array.isArray(t)?t[r].tensor:t[n];if(null!=a){var i=e.accumulatedGrads[r].variable;ze(function(){var t=i.add(a.square());i.assign(t);var n=a.div(t.add(At.backend.epsilon()).sqrt()).mul(-e.learningRate).add(o);o.assign(n);});}}),this.incrementIterations();},o.prototype.dispose=function(){null!=this.accumulatedGrads&&Ve(this.accumulatedGrads.map(function(t){return t.variable;}));},o.prototype.getWeights=function(){return n(this,void 0,void 0,function(){return r(this,function(t){switch(t.label){case 0:return [4,this.saveIterations()];case 1:return [2,[t.sent()].concat(this.accumulatedGrads.map(function(t){return {name:t.originalName,tensor:t.variable};}))];}});});},o.prototype.setWeights=function(t){return n(this,void 0,void 0,function(){return r(this,function(e){switch(e.label){case 0:return [4,this.extractIterations(t)];case 1:return t=e.sent(),this.accumulatedGrads=t.map(function(t){return {originalName:t.name,variable:t.tensor.variable(!1)};}),[2];}});});},o.prototype.getConfig=function(){return {learningRate:this.learningRate,initialAccumulatorValue:this.initialAccumulatorValue};},o.fromConfig=function(t,e){return new t(e.learningRate,e.initialAccumulatorValue);},o.className="Adagrad",o;}($h);Bh(Kh);var Xh=function(t){function o(e,n,r,o){void 0===o&&(o=null);var a=t.call(this)||this;return a.learningRate=e,a.beta1=n,a.beta2=r,a.epsilon=o,a.accumulatedFirstMoment=[],a.accumulatedSecondMoment=[],ze(function(){a.accBeta1=Cn(n).variable(),a.accBeta2=Cn(r).variable();}),null==o&&(a.epsilon=At.backend.epsilon()),a;}return e(o,t),o.prototype.applyGradients=function(t){var e=this,n=Array.isArray(t)?t.map(function(t){return t.name;}):Object.keys(t);ze(function(){var r=yl(1,e.accBeta1),o=yl(1,e.accBeta2);n.forEach(function(n,a){var i=At.registeredVariables[n];null==e.accumulatedFirstMoment[a]&&(e.accumulatedFirstMoment[a]={originalName:n+"/m",variable:ze(function(){return Mn(i).variable(!1);})}),null==e.accumulatedSecondMoment[a]&&(e.accumulatedSecondMoment[a]={originalName:n+"/v",variable:ze(function(){return Mn(i).variable(!1);})});var s=Array.isArray(t)?t[a].tensor:t[n];if(null!=s){var u=e.accumulatedFirstMoment[a].variable,l=e.accumulatedSecondMoment[a].variable,c=u.mul(e.beta1).add(s.mul(1-e.beta1)),h=l.mul(e.beta2).add(s.square().mul(1-e.beta2)),f=c.div(r),p=h.div(o);u.assign(c),l.assign(h);var d=f.div(p.sqrt().add(e.epsilon)).mul(-e.learningRate).add(i);i.assign(d);}}),e.accBeta1.assign(e.accBeta1.mul(e.beta1)),e.accBeta2.assign(e.accBeta2.mul(e.beta2));}),this.incrementIterations();},o.prototype.dispose=function(){this.accBeta1.dispose(),this.accBeta2.dispose(),null!=this.accumulatedFirstMoment&&Ve(this.accumulatedFirstMoment.map(function(t){return t.variable;})),null!=this.accumulatedSecondMoment&&Ve(this.accumulatedSecondMoment.map(function(t){return t.variable;}));},o.prototype.getWeights=function(){return n(this,void 0,void 0,function(){var t;return r(this,function(e){switch(e.label){case 0:return t=this.accumulatedFirstMoment.concat(this.accumulatedSecondMoment),[4,this.saveIterations()];case 1:return [2,[e.sent()].concat(t.map(function(t){return {name:t.originalName,tensor:t.variable};}))];}});});},o.prototype.setWeights=function(t){return n(this,void 0,void 0,function(){var e,n=this;return r(this,function(r){switch(r.label){case 0:return [4,this.extractIterations(t)];case 1:return t=r.sent(),ze(function(){n.accBeta1.assign(dl(n.beta1,n.iterations_+1)),n.accBeta2.assign(dl(n.beta2,n.iterations_+1));}),e=t.length/2,this.accumulatedFirstMoment=t.slice(0,e).map(function(t){return {originalName:t.name,variable:t.tensor.variable(!1)};}),this.accumulatedSecondMoment=t.slice(e,2*e).map(function(t){return {originalName:t.name,variable:t.tensor.variable(!1)};}),[2];}});});},o.prototype.getConfig=function(){return {learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon};},o.fromConfig=function(t,e){return new t(e.learningRate,e.beta1,e.beta2,e.epsilon);},o.className="Adam",o;}($h);Bh(Xh);var Yh=function(t){function o(e,n,r,o,a){void 0===o&&(o=null),void 0===a&&(a=0);var i=t.call(this)||this;return i.learningRate=e,i.beta1=n,i.beta2=r,i.epsilon=o,i.decay=a,i.accumulatedFirstMoment=[],i.accumulatedWeightedInfNorm=[],ze(function(){i.iteration=Cn(0).variable(),i.accBeta1=Cn(n).variable();}),null==o&&(i.epsilon=At.backend.epsilon()),i;}return e(o,t),o.prototype.applyGradients=function(t){var e=this,n=Array.isArray(t)?t.map(function(t){return t.name;}):Object.keys(t);ze(function(){var r=yl(1,e.accBeta1),o=rl(-e.learningRate,e.iteration.mul(e.decay).add(1));n.forEach(function(n,a){var i=At.registeredVariables[n];null==e.accumulatedFirstMoment[a]&&(e.accumulatedFirstMoment[a]={originalName:n+"/m",variable:Mn(i).variable(!1)}),null==e.accumulatedWeightedInfNorm[a]&&(e.accumulatedWeightedInfNorm[a]={originalName:n+"/v",variable:Mn(i).variable(!1)});var s=Array.isArray(t)?t[a].tensor:t[n];if(null!=s){var u=e.accumulatedFirstMoment[a].variable,l=e.accumulatedWeightedInfNorm[a].variable,c=u.mul(e.beta1).add(s.mul(1-e.beta1)),h=l.mul(e.beta2),f=s.abs(),p=h.maximum(f);u.assign(c),l.assign(p);var d=o.div(r).mul(c.div(p.add(e.epsilon))).add(i);i.assign(d);}}),e.iteration.assign(e.iteration.add(1)),e.accBeta1.assign(e.accBeta1.mul(e.beta1));}),this.incrementIterations();},o.prototype.dispose=function(){this.accBeta1.dispose(),this.iteration.dispose(),null!=this.accumulatedFirstMoment&&Ve(this.accumulatedFirstMoment.map(function(t){return t.variable;})),null!=this.accumulatedWeightedInfNorm&&Ve(this.accumulatedWeightedInfNorm.map(function(t){return t.variable;}));},o.prototype.getWeights=function(){return n(this,void 0,void 0,function(){return r(this,function(t){throw new Error("getWeights() is not implemented for Adamax yet.");});});},o.prototype.setWeights=function(t){return n(this,void 0,void 0,function(){return r(this,function(t){throw new Error("setWeights() is not implemented for Adamax yet.");});});},o.prototype.getConfig=function(){return {learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon,decay:this.decay};},o.fromConfig=function(t,e){return new t(e.learningRate,e.beta1,e.beta2,e.epsilon,e.decay);},o.className="Adamax",o;}($h);Bh(Yh);var Qh=function(t){function o(e){var n=t.call(this)||this;return n.learningRate=e,n.setLearningRate(e),n;}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map(function(t){return t.name;}):Object.keys(t)).forEach(function(n,r){var o=Array.isArray(t)?t[r].tensor:t[n];if(null!=o){var a=At.registeredVariables[n];ze(function(){var t=e.c.mul(o).add(a);a.assign(t);});}}),this.incrementIterations();},o.prototype.setLearningRate=function(t){this.learningRate=t,null!=this.c&&this.c.dispose(),this.c=Ge(Cn(-t));},o.prototype.dispose=function(){this.c.dispose();},o.prototype.getWeights=function(){return n(this,void 0,void 0,function(){return r(this,function(t){switch(t.label){case 0:return [4,this.saveIterations()];case 1:return [2,[t.sent()]];}});});},o.prototype.setWeights=function(t){return n(this,void 0,void 0,function(){return r(this,function(e){switch(e.label){case 0:return [4,this.extractIterations(t)];case 1:if(0!==(t=e.sent()).length)throw new Error("SGD optimizer does not have settable weights.");return [2];}});});},o.prototype.getConfig=function(){return {learningRate:this.learningRate};},o.fromConfig=function(t,e){return new t(e.learningRate);},o.className="SGD",o;}($h);Bh(Qh);var Jh=function(t){function o(e,n,r){void 0===r&&(r=!1);var o=t.call(this,e)||this;return o.learningRate=e,o.momentum=n,o.useNesterov=r,o.accumulations=[],o.m=Cn(o.momentum),o;}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map(function(t){return t.name;}):Object.keys(t)).forEach(function(n,r){var o=At.registeredVariables[n];if(null==e.accumulations[r]){e.accumulations[r]={originalName:n+"/momentum",variable:ze(function(){return Mn(o).variable(!1);})};}var a=e.accumulations[r].variable,i=Array.isArray(t)?t[r].tensor:t[n];null!=i&&ze(function(){var t,n=e.m.mul(a).add(i);t=e.useNesterov?e.c.mul(i.add(n.mul(e.m))).add(o):e.c.mul(n).add(o),a.assign(n),o.assign(t);});}),this.incrementIterations();},o.prototype.dispose=function(){this.m.dispose(),null!=this.accumulations&&Ve(this.accumulations.map(function(t){return t.variable;}));},o.prototype.setMomentum=function(t){this.momentum=t;},o.prototype.getWeights=function(){return n(this,void 0,void 0,function(){return r(this,function(t){switch(t.label){case 0:return [4,this.saveIterations()];case 1:return [2,[t.sent()].concat(this.accumulations.map(function(t){return {name:t.originalName,tensor:t.variable};}))];}});});},o.prototype.setWeights=function(t){return n(this,void 0,void 0,function(){return r(this,function(e){switch(e.label){case 0:return [4,this.extractIterations(t)];case 1:return t=e.sent(),this.accumulations=t.map(function(t){return {originalName:t.name,variable:t.tensor.variable(!1)};}),[2];}});});},o.prototype.getConfig=function(){return {learningRate:this.learningRate,momentum:this.momentum,useNesterov:this.useNesterov};},o.fromConfig=function(t,e){return new t(e.learningRate,e.momentum,e.useNesterov);},o.className="Momentum",o;}(Qh);Bh(Jh);var Zh=function(t){function o(e,n,r,o,a){void 0===n&&(n=.9),void 0===r&&(r=0),void 0===o&&(o=null),void 0===a&&(a=!1);var i=t.call(this)||this;return i.learningRate=e,i.decay=n,i.momentum=r,i.epsilon=o,i.accumulatedMeanSquares=[],i.accumulatedMoments=[],i.accumulatedMeanGrads=[],i.centered=a,null==o&&(i.epsilon=At.backend.epsilon()),i;}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map(function(t){return t.name;}):Object.keys(t)).forEach(function(n,r){var o=At.registeredVariables[n];null==e.accumulatedMeanSquares[r]&&(e.accumulatedMeanSquares[r]={originalName:n+"/rms",variable:ze(function(){return Mn(o).variable(!1);})}),null==e.accumulatedMoments[r]&&(e.accumulatedMoments[r]={originalName:n+"/momentum",variable:ze(function(){return Mn(o).variable(!1);})}),null==e.accumulatedMeanGrads[r]&&e.centered&&(e.accumulatedMeanGrads[r]={originalName:n+"/mg",variable:ze(function(){return Mn(o).variable(!1);})});var a=Array.isArray(t)?t[r].tensor:t[n];if(null!=a){var i=e.accumulatedMeanSquares[r].variable,s=e.accumulatedMoments[r].variable;ze(function(){var t=i.mul(e.decay).add(a.square().mul(1-e.decay));if(e.centered){var n=e.accumulatedMeanGrads[r].variable,u=n.mul(e.decay).add(a.mul(1-e.decay)),l=s.mul(e.momentum).add(a.mul(e.learningRate).div(t.sub(u.square().add(e.epsilon)).sqrt()));i.assign(t),n.assign(u),s.assign(l);var c=o.sub(l);o.assign(c);}else{var h=i.mul(e.decay).add(a.square().mul(1-e.decay));l=s.mul(e.momentum).add(a.mul(e.learningRate).div(h.add(e.epsilon).sqrt()));i.assign(h),s.assign(l);c=o.sub(l);o.assign(c);}});}}),this.incrementIterations();},o.prototype.dispose=function(){null!=this.accumulatedMeanSquares&&Ve(this.accumulatedMeanSquares.map(function(t){return t.variable;})),null!=this.accumulatedMeanGrads&&this.centered&&Ve(this.accumulatedMeanGrads.map(function(t){return t.variable;})),null!=this.accumulatedMoments&&Ve(this.accumulatedMoments.map(function(t){return t.variable;}));},o.prototype.getWeights=function(){return n(this,void 0,void 0,function(){var t;return r(this,function(e){switch(e.label){case 0:return t=this.accumulatedMeanSquares.concat(this.accumulatedMoments),this.centered&&t.push.apply(t,this.accumulatedMeanGrads),[4,this.saveIterations()];case 1:return [2,[e.sent()].concat(t.map(function(t){return {name:t.originalName,tensor:t.variable};}))];}});});},o.prototype.setWeights=function(t){return n(this,void 0,void 0,function(){var e;return r(this,function(n){switch(n.label){case 0:return [4,this.extractIterations(t)];case 1:return t=n.sent(),e=this.centered?t.length/3:t.length/2,this.accumulatedMeanSquares=t.slice(0,e).map(function(t){return {originalName:t.name,variable:t.tensor.variable(!1)};}),this.accumulatedMoments=t.slice(e,2*e).map(function(t){return {originalName:t.name,variable:t.tensor.variable(!1)};}),this.centered&&(this.accumulatedMeanGrads=t.slice(2*e,3*e).map(function(t){return {originalName:t.name,variable:t.tensor.variable(!1)};})),[2];}});});},o.prototype.getConfig=function(){return {learningRate:this.learningRate,decay:this.decay,momentum:this.momentum,epsilon:this.epsilon,centered:this.centered};},o.fromConfig=function(t,e){return new t(e.learningRate,e.decay,e.momentum,e.epsilon,e.centered);},o.className="RMSProp",o;}($h);Bh(Zh);var tf=function(){function t(){}return t.sgd=function(t){return new Qh(t);},t.momentum=function(t,e,n){return void 0===n&&(n=!1),new Jh(t,e,n);},t.rmsprop=function(t,e,n,r,o){return void 0===e&&(e=.9),void 0===n&&(n=0),void 0===r&&(r=null),void 0===o&&(o=!1),new Zh(t,e,n,r,o);},t.adam=function(t,e,n,r){return void 0===t&&(t=.001),void 0===e&&(e=.9),void 0===n&&(n=.999),void 0===r&&(r=null),new Xh(t,e,n,r);},t.adadelta=function(t,e,n){return void 0===t&&(t=.001),void 0===e&&(e=.95),void 0===n&&(n=null),new jh(t,e,n);},t.adamax=function(t,e,n,r,o){return void 0===t&&(t=.002),void 0===e&&(e=.9),void 0===n&&(n=.999),void 0===r&&(r=null),void 0===o&&(o=0),new Yh(t,e,n,r,o);},t.adagrad=function(t,e){return void 0===e&&(e=.1),new Kh(t,e);},t;}(),ef={sgd:tf.sgd,momentum:tf.momentum,adadelta:tf.adadelta,adagrad:tf.adagrad,rmsprop:tf.rmsprop,adamax:tf.adamax,adam:tf.adam},nf="undefined"!=typeof requestAnimationFrame?requestAnimationFrame:"undefined"!=typeof setImmediate?setImmediate:function(t){return t();};function rf(){return new Promise(function(t){return nf(function(){return t();});});}lt=kc;

	var _extendStatics = function extendStatics(e, t) {
	  return (_extendStatics = Object.setPrototypeOf || {
	    __proto__: []
	  } instanceof Array && function (e, t) {
	    e.__proto__ = t;
	  } || function (e, t) {
	    for (var n in t) {
	      t.hasOwnProperty(n) && (e[n] = t[n]);
	    }
	  })(e, t);
	};

	function __extends(e, t) {
	  function n() {
	    this.constructor = e;
	  }

	  _extendStatics(e, t), e.prototype = null === t ? Object.create(t) : (n.prototype = t.prototype, new n());
	}

	var _epsilon,
	    _assign = function __assign() {
	  return (_assign = Object.assign || function (e) {
	    for (var t, n = 1, r = arguments.length; n < r; n++) {
	      for (var i in t = arguments[n]) {
	        Object.prototype.hasOwnProperty.call(t, i) && (e[i] = t[i]);
	      }
	    }

	    return e;
	  }).apply(this, arguments);
	};

	function __awaiter(e, t, n, r) {
	  return new (n || (n = Promise))(function (i, a) {
	    function o(e) {
	      try {
	        l(r.next(e));
	      } catch (e) {
	        a(e);
	      }
	    }

	    function s(e) {
	      try {
	        l(r["throw"](e));
	      } catch (e) {
	        a(e);
	      }
	    }

	    function l(e) {
	      e.done ? i(e.value) : new n(function (t) {
	        t(e.value);
	      }).then(o, s);
	    }

	    l((r = r.apply(e, t || [])).next());
	  });
	}

	function __generator(e, t) {
	  var n,
	      r,
	      i,
	      a,
	      o = {
	    label: 0,
	    sent: function sent() {
	      if (1 & i[0]) throw i[1];
	      return i[1];
	    },
	    trys: [],
	    ops: []
	  };
	  return a = {
	    next: s(0),
	    "throw": s(1),
	    "return": s(2)
	  }, "function" == typeof Symbol && (a[Symbol.iterator] = function () {
	    return this;
	  }), a;

	  function s(a) {
	    return function (s) {
	      return function (a) {
	        if (n) throw new TypeError("Generator is already executing.");

	        for (; o;) {
	          try {
	            if (n = 1, r && (i = 2 & a[0] ? r["return"] : a[0] ? r["throw"] || ((i = r["return"]) && i.call(r), 0) : r.next) && !(i = i.call(r, a[1])).done) return i;

	            switch (r = 0, i && (a = [2 & a[0], i.value]), a[0]) {
	              case 0:
	              case 1:
	                i = a;
	                break;

	              case 4:
	                return o.label++, {
	                  value: a[1],
	                  done: !1
	                };

	              case 5:
	                o.label++, r = a[1], a = [0];
	                continue;

	              case 7:
	                a = o.ops.pop(), o.trys.pop();
	                continue;

	              default:
	                if (!(i = (i = o.trys).length > 0 && i[i.length - 1]) && (6 === a[0] || 2 === a[0])) {
	                  o = 0;
	                  continue;
	                }

	                if (3 === a[0] && (!i || a[1] > i[0] && a[1] < i[3])) {
	                  o.label = a[1];
	                  break;
	                }

	                if (6 === a[0] && o.label < i[1]) {
	                  o.label = i[1], i = a;
	                  break;
	                }

	                if (i && o.label < i[2]) {
	                  o.label = i[2], o.ops.push(a);
	                  break;
	                }

	                i[2] && o.ops.pop(), o.trys.pop();
	                continue;
	            }

	            a = t.call(e, o);
	          } catch (e) {
	            a = [6, e], r = 0;
	          } finally {
	            n = i = 0;
	          }
	        }

	        if (5 & a[0]) throw a[1];
	        return {
	          value: a[0] ? a[1] : void 0,
	          done: !0
	        };
	      }([a, s]);
	    };
	  }
	}

	function epsilon() {
	  return null == _epsilon && (_epsilon = Je().epsilon()), _epsilon;
	}

	function imageDataFormat() {
	  return "channelsLast";
	}

	var AttributeError = function (e) {
	  function t(n) {
	    var r = e.call(this, n) || this;
	    return Object.setPrototypeOf(r, t.prototype), r;
	  }

	  return __extends(t, e), t;
	}(Error),
	    RuntimeError = function (e) {
	  function t(n) {
	    var r = e.call(this, n) || this;
	    return Object.setPrototypeOf(r, t.prototype), r;
	  }

	  return __extends(t, e), t;
	}(Error),
	    ValueError = function (e) {
	  function t(n) {
	    var r = e.call(this, n) || this;
	    return Object.setPrototypeOf(r, t.prototype), r;
	  }

	  return __extends(t, e), t;
	}(Error),
	    NotImplementedError = function (e) {
	  function t(n) {
	    var r = e.call(this, n) || this;
	    return Object.setPrototypeOf(r, t.prototype), r;
	  }

	  return __extends(t, e), t;
	}(Error),
	    AssertionError = function (e) {
	  function t(n) {
	    var r = e.call(this, n) || this;
	    return Object.setPrototypeOf(r, t.prototype), r;
	  }

	  return __extends(t, e), t;
	}(Error),
	    IndexError = function (e) {
	  function t(n) {
	    var r = e.call(this, n) || this;
	    return Object.setPrototypeOf(r, t.prototype), r;
	  }

	  return __extends(t, e), t;
	}(Error);

	function pyListRepeat(e, t) {
	  if (Array.isArray(e)) {
	    for (var n = [], r = 0; r < t; r++) {
	      n = n.concat(e);
	    }

	    return n;
	  }

	  return (n = new Array(t)).fill(e), n;
	}

	function assert(e, t) {
	  if (!e) throw new AssertionError(t);
	}

	function count(e, t) {
	  for (var n = 0, r = 0, i = e; r < i.length; r++) {
	    i[r] === t && n++;
	  }

	  return n;
	}

	function singletonOrArray(e) {
	  return 1 === e.length ? e[0] : e;
	}

	function toList(e) {
	  return Array.isArray(e) ? e : [e];
	}

	function toSnakeCase(e) {
	  var t = e.replace(/(.)([A-Z][a-z0-9]+)/g, "$1_$2").replace(/([a-z])([A-Z])/g, "$1_$2").toLowerCase();
	  return "_" !== t[0] ? t : "private" + t;
	}

	function toCamelCase(e) {
	  return e.length <= 1 ? e : -1 === e.indexOf("_") ? e : e.replace(/[_]+(\w|$)/g, function (e, t) {
	    return t.toUpperCase();
	  });
	}

	var _GLOBAL_CUSTOM_OBJECTS = {};

	function serializeKerasObject(e) {
	  if (null === e || void 0 === e) return null;
	  var t = {};
	  return t.className = e.getClassName(), t.config = e.getConfig(), t;
	}

	function convertNDArrayScalarsInConfig(e) {
	  if (null != e && "object" == _typeof_1(e)) if (Array.isArray(e)) e.forEach(function (e) {
	    return convertNDArrayScalarsInConfig(e);
	  });else for (var t = 0, n = Object.keys(e); t < n.length; t++) {
	    var r = n[t],
	        i = e[r];
	    null != i && "object" == _typeof_1(i) && (Array.isArray(i) || "ndarray" !== i.type || "number" != typeof i.value ? convertNDArrayScalarsInConfig(i) : e[r] = i.value);
	  }
	}

	function deserializeKerasObject(e, t, n, r, i) {
	  var a, o, s;

	  if (void 0 === t && (t = {}), void 0 === n && (n = {}), void 0 === r && (r = "object"), void 0 === i && (i = !1), "string" == typeof e) {
	    var l = e,
	        u = void 0;
	    if (l in n) u = n[l];else if (l in _GLOBAL_CUSTOM_OBJECTS) u = _GLOBAL_CUSTOM_OBJECTS[l];else if (null == (u = t[l])) throw new ValueError("Unknown " + r + ": " + e + ". This may be due to one of the following reasons:\n1. The " + r + " is defined in Python, in which case it needs to be ported to TensorFlow.js or your JavaScript code.\n2. The custom " + r + " is defined in JavaScript, but is not registered properly with tf.serialization.registerClass().");
	    return u;
	  }

	  var c = e;
	  if (null == c.className || null == c.config) throw new ValueError(r + ": Improper config format: " + JSON.stringify(c) + ".\n'className' and 'config' must set.");
	  var p = c.className,
	      h = void 0,
	      d = void 0;
	  if (p in n ? (h = (a = n[p])[0], d = a[1]) : p in _GLOBAL_CUSTOM_OBJECTS ? (h = (o = _GLOBAL_CUSTOM_OBJECTS.className)[0], d = o[1]) : p in t && (h = (s = t[p])[0], d = s[1]), null == h) throw new ValueError("Unknown " + r + ": " + p + ". This may be due to one of the following reasons:\n1. The " + r + " is defined in Python, in which case it needs to be ported to TensorFlow.js or your JavaScript code.\n2. The custom " + r + " is defined in JavaScript, but is not registered properly with tf.serialization.registerClass().");

	  if (null != d) {
	    for (var f = {}, g = 0, m = Object.keys(_GLOBAL_CUSTOM_OBJECTS); g < m.length; g++) {
	      f[S = m[g]] = _GLOBAL_CUSTOM_OBJECTS[S];
	    }

	    for (var y = 0, v = Object.keys(n); y < v.length; y++) {
	      f[S = v[y]] = n[S];
	    }

	    c.config.customObjects = f;

	    for (var b = _assign({}, _GLOBAL_CUSTOM_OBJECTS), w = 0, z = Object.keys(n); w < z.length; w++) {
	      var S = z[w];
	      _GLOBAL_CUSTOM_OBJECTS[S] = n[S];
	    }

	    convertNDArrayScalarsInConfig(c.config);
	    var A = d(h, c.config, n, i);
	    return _GLOBAL_CUSTOM_OBJECTS = _assign({}, b), A;
	  }

	  b = _assign({}, _GLOBAL_CUSTOM_OBJECTS);

	  for (var _ = 0, C = Object.keys(n); _ < C.length; _++) {
	    S = C[_];
	    _GLOBAL_CUSTOM_OBJECTS[S] = n[S];
	  }

	  A = new h(c.config);
	  return _GLOBAL_CUSTOM_OBJECTS = _assign({}, b), A;
	}

	function numberCompare(e, t) {
	  return e < t ? -1 : e > t ? 1 : 0;
	}

	function reverseNumberCompare(e, t) {
	  return -1 * numberCompare(e, t);
	}

	function unique(e) {
	  if (null == e) return e;

	  for (var t = [], n = 0, r = e; n < r.length; n++) {
	    var i = r[n];
	    -1 === t.indexOf(i) && t.push(i);
	  }

	  return t;
	}

	function isObjectEmpty(e) {
	  if (null == e) throw new ValueError("Invalid value in obj: " + JSON.stringify(e));

	  for (var t in e) {
	    if (e.hasOwnProperty(t)) return !1;
	  }

	  return !0;
	}

	function checkStringTypeUnionValue(e, t, n) {
	  if (null != n && e.indexOf(n) < 0) throw new ValueError(n + " is not a valid " + t + ".  Valid values are " + e + " or null/undefined.");
	}

	function checkArrayTypeAndLength(e, t, n, r) {
	  return void 0 === n && (n = 0), void 0 === r && (r = 1 / 0), assert(n >= 0), assert(r >= n), Array.isArray(e) && e.length >= n && e.length <= r && e.every(function (e) {
	    return _typeof_1(e) === t;
	  });
	}

	function assertPositiveInteger(e, t) {
	  Array.isArray(e) ? (Q.assert(e.length > 0, function () {
	    return t + " is unexpectedly an empty array.";
	  }), e.forEach(function (e, n) {
	    return assertPositiveInteger(e, "element " + (n + 1) + " of " + t);
	  })) : Q.assert(Number.isInteger(e) && e > 0, function () {
	    return "Expected " + t + " to be a positive integer, but got " + formatAsFriendlyString(e) + ".";
	  });
	}

	function formatAsFriendlyString(e) {
	  return null === e ? "null" : Array.isArray(e) ? "[" + e.map(function (e) {
	    return formatAsFriendlyString(e);
	  }).join(",") + "]" : "string" == typeof e ? '"' + e + '"' : "" + e;
	}

	function debounce(e, t) {
	  var n,
	      r = Q.now();
	  return function () {
	    for (var i = [], a = 0; a < arguments.length; a++) {
	      i[a] = arguments[a];
	    }

	    var o = Q.now();
	    return o - r < t ? n : (r = o, n = e.apply(void 0, i));
	  };
	}

	function calcL2Norms(e, t) {
	  return ze(function () {
	    return Ms(Wu(pl(e, e), t, !0));
	  });
	}

	var Constraint = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.getConfig = function () {
	    return {};
	  }, t;
	}(Ph.Serializable),
	    MaxNorm = function (e) {
	  function t(t) {
	    var n = e.call(this) || this;
	    return n.defaultMaxValue = 2, n.defaultAxis = 0, n.maxValue = null != t.maxValue ? t.maxValue : n.defaultMaxValue, n.axis = null != t.axis ? t.axis : n.defaultAxis, n;
	  }

	  return __extends(t, e), t.prototype.apply = function (e) {
	    var t = this;
	    return ze(function () {
	      var n = calcL2Norms(e, t.axis),
	          r = ps(n, 0, t.maxValue);
	      return fl(e, rl(r, Zu(epsilon(), n)));
	    });
	  }, t.prototype.getConfig = function () {
	    return {
	      maxValue: this.maxValue,
	      axis: this.axis
	    };
	  }, t.className = "MaxNorm", t;
	}(Constraint);

	Ph.registerClass(MaxNorm);

	var UnitNorm = function (e) {
	  function t(t) {
	    var n = e.call(this) || this;
	    return n.defaultAxis = 0, n.axis = null != t.axis ? t.axis : n.defaultAxis, n;
	  }

	  return __extends(t, e), t.prototype.apply = function (e) {
	    var t = this;
	    return ze(function () {
	      return rl(e, Zu(epsilon(), calcL2Norms(e, t.axis)));
	    });
	  }, t.prototype.getConfig = function () {
	    return {
	      axis: this.axis
	    };
	  }, t.className = "UnitNorm", t;
	}(Constraint);

	Ph.registerClass(UnitNorm);

	var NonNeg = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.apply = function (e) {
	    return Al(e);
	  }, t.className = "NonNeg", t;
	}(Constraint);

	Ph.registerClass(NonNeg);

	var MinMaxNorm = function (e) {
	  function t(t) {
	    var n = e.call(this) || this;
	    return n.defaultMinValue = 0, n.defaultMaxValue = 1, n.defaultRate = 1, n.defaultAxis = 0, n.minValue = null != t.minValue ? t.minValue : n.defaultMinValue, n.maxValue = null != t.maxValue ? t.maxValue : n.defaultMaxValue, n.rate = null != t.rate ? t.rate : n.defaultRate, n.axis = null != t.axis ? t.axis : n.defaultAxis, n;
	  }

	  return __extends(t, e), t.prototype.apply = function (e) {
	    var t = this;
	    return ze(function () {
	      var n = calcL2Norms(e, t.axis),
	          r = Zu(fl(t.rate, ps(n, t.minValue, t.maxValue)), fl(1 - t.rate, n));
	      return fl(e, rl(r, Zu(epsilon(), n)));
	    });
	  }, t.prototype.getConfig = function () {
	    return {
	      minValue: this.minValue,
	      maxValue: this.maxValue,
	      rate: this.rate,
	      axis: this.axis
	    };
	  }, t.className = "MinMaxNorm", t;
	}(Constraint);

	Ph.registerClass(MinMaxNorm);
	var CONSTRAINT_IDENTIFIER_REGISTRY_SYMBOL_MAP = {
	  maxNorm: "MaxNorm",
	  minMaxNorm: "MinMaxNorm",
	  nonNeg: "NonNeg",
	  unitNorm: "UnitNorm"
	};

	function serializeConstraint(e) {
	  return serializeKerasObject(e);
	}

	function deserializeConstraint(e, t) {
	  return void 0 === t && (t = {}), deserializeKerasObject(e, Ph.SerializationMap.getMap().classNameMap, t, "constraint");
	}

	function getConstraint(e) {
	  return null == e ? null : "string" == typeof e ? deserializeConstraint({
	    className: e in CONSTRAINT_IDENTIFIER_REGISTRY_SYMBOL_MAP ? CONSTRAINT_IDENTIFIER_REGISTRY_SYMBOL_MAP[e] : e,
	    config: {}
	  }) : e instanceof Constraint ? e : deserializeConstraint(e);
	}

	function maxNorm(e) {
	  return new MaxNorm(e);
	}

	function unitNorm(e) {
	  return new UnitNorm(e);
	}

	function nonNeg() {
	  return new NonNeg();
	}

	function minMaxNorm(e) {
	  return new MinMaxNorm(e);
	}

	var exports_constraints = Object.freeze({
	  maxNorm: maxNorm,
	  unitNorm: unitNorm,
	  nonNeg: nonNeg,
	  minMaxNorm: minMaxNorm
	}),
	    VALID_DATA_FORMAT_VALUES = ["channelsFirst", "channelsLast"],
	    VALID_PADDING_MODE_VALUES = ["valid", "same", "causal"],
	    VALID_POOL_MODE_VALUES = ["max", "avg"],
	    VALID_BIDIRECTIONAL_MERGE_MODES = ["sum", "mul", "concat", "ave"],
	    nameMap = new Map();

	function checkDataFormat(e) {
	  checkStringTypeUnionValue(VALID_DATA_FORMAT_VALUES, "DataFormat", e);
	}

	function checkPaddingMode(e) {
	  checkStringTypeUnionValue(VALID_PADDING_MODE_VALUES, "PaddingMode", e);
	}

	function checkPoolMode(e) {
	  checkStringTypeUnionValue(VALID_POOL_MODE_VALUES, "PoolMode", e);
	}

	var _nameScopeStack = [],
	    _nameScopeDivider = "/";

	function nameScope(e, t) {
	  _nameScopeStack.push(e);

	  try {
	    var n = t();
	    return _nameScopeStack.pop(), n;
	  } catch (e) {
	    throw _nameScopeStack.pop(), e;
	  }
	}

	function currentNameScopePrefix() {
	  return 0 === _nameScopeStack.length ? "" : _nameScopeStack.join(_nameScopeDivider) + _nameScopeDivider;
	}

	function getScopedTensorName(e) {
	  if (!isValidTensorName(e)) throw new Error("Not a valid tensor name: '" + e + "'");
	  return currentNameScopePrefix() + e;
	}

	function getUniqueTensorName(e) {
	  if (!isValidTensorName(e)) throw new Error("Not a valid tensor name: '" + e + "'");
	  nameMap.has(e) || nameMap.set(e, 0);
	  var t = nameMap.get(e);

	  if (nameMap.set(e, nameMap.get(e) + 1), t > 0) {
	    var n = e + "_" + t;
	    return nameMap.set(n, 1), n;
	  }

	  return e;
	}

	var tensorNameRegex = new RegExp(/^[A-Za-z0-9][-A-Za-z0-9\._\/]*$/);

	function isValidTensorName(e) {
	  return !!e.match(tensorNameRegex);
	}

	function isInteger(e) {
	  return e === parseInt(e.toString(), 10);
	}

	function arrayProd(e, t, n) {
	  null == t && (t = 0), null == n && (n = e.length);

	  for (var r = 1, i = t; i < n; ++i) {
	    r *= e[i];
	  }

	  return r;
	}

	function toArray1D(e) {
	  return e = Array.isArray(e) ? new Float32Array(e) : e, En(e);
	}

	function min$1(e) {
	  return Pu(toArray1D(e)).dataSync()[0];
	}

	function max$1(e) {
	  return Mu(toArray1D(e)).dataSync()[0];
	}

	function range(e, t) {
	  if (t < e) throw new ValueError("end (" + t + ") < begin (" + e + ") is forbidden.");

	  for (var n = [], r = e; r < t; ++r) {
	    n.push(r);
	  }

	  return n;
	}

	function cast$1(e, t) {
	  return e.asType(t);
	}

	function expandDims$1(e, t) {
	  void 0 === t && (t = -1);
	  var n = e.shape.slice();
	  return t < 0 && (t = n.length + t + 1), n.splice(t, 0, 1), e.reshape(n);
	}

	function repeat(e, t) {
	  return ze(function () {
	    if (2 !== e.shape.length) throw new ValueError("repeat() expects a rank-2 tensor, but received a rank-" + e.shape.length + " tensor.");
	    return tile$1(expandDims$1(e, 1), [1, t, 1]);
	  });
	}

	function flatten(e) {
	  var t = [arrayProd(e.shape)];
	  return e.reshape(t);
	}

	function batchFlatten(e) {
	  if (e.rank <= 1) throw new ValueError("batchFlatten requires a minimum rank of 2. Got rank: " + e.rank + ".");
	  var t = [e.shape[0], arrayProd(e.shape, 1)];
	  return e.reshape(t);
	}

	function sliceAlongFirstAxis(e, t, n) {
	  return ze(function () {
	    switch (e.rank) {
	      case 1:
	        return Iu(e, t, n);

	      case 2:
	        return Su(e, [t, 0], [n, e.shape[1]]);

	      case 3:
	        return Nu(e, [t, 0, 0], [n, e.shape[1], e.shape[2]]);

	      case 4:
	        return ku(e, [t, 0, 0, 0], [n, e.shape[1], e.shape[2], e.shape[3]]);

	      default:
	        throw new ValueError("sliceAlongFirstAxis() received an unsupported tensor rank: " + e.rank);
	    }
	  });
	}

	function sliceAlongLastAxis(e, t, n) {
	  return ze(function () {
	    switch (e.rank) {
	      case 1:
	        return Iu(e, t, n);

	      case 2:
	        return Su(e, [0, t], [e.shape[0], n]);

	      case 3:
	        return Nu(e, [0, 0, t], [e.shape[0], e.shape[1], n]);

	      case 4:
	        return ku(e, [0, 0, 0, t], [e.shape[0], e.shape[1], e.shape[2], n]);

	      default:
	        throw new ValueError("sliceAlongLastAxis() received an unsupported tensor rank: " + e.rank);
	    }
	  });
	}

	function sliceAlongAxis(e, t, n, r) {
	  return ze(function () {
	    switch (e.rank) {
	      case 1:
	        return Iu(e, t, n);

	      case 2:
	        switch (r) {
	          case 1:
	            return sliceAlongFirstAxis(e, t, n);

	          case 2:
	            return sliceAlongLastAxis(e, t, n);

	          default:
	            throw new ValueError("The axis is not within the rank of the tensor " + r);
	        }

	      case 3:
	        switch (r) {
	          case 1:
	            return sliceAlongFirstAxis(e, t, n);

	          case 2:
	            return Nu(e, [0, t, 0], [e.shape[0], n, e.shape[2]]);

	          case 3:
	            return sliceAlongLastAxis(e, t, n);

	          default:
	            throw new ValueError("The axis is not within the rank of the tensor " + r);
	        }

	      case 4:
	        switch (r) {
	          case 1:
	            return sliceAlongFirstAxis(e, t, n);

	          case 2:
	            return ku(e, [0, t, 0, 0], [e.shape[0], n, e.shape[2], e.shape[3]]);

	          case 3:
	            return ku(e, [0, 0, t, 0], [e.shape[0], e.shape[1], n, e.shape[3]]);

	          case 4:
	            return sliceAlongLastAxis(e, t, n);

	          default:
	            throw new ValueError("The axis is not within the rank of the tensor " + r);
	        }

	      default:
	        throw new ValueError("sliceAlongLastAxis() received an unsupported tensor rank: " + e.rank);
	    }
	  });
	}

	function concatenate(e, t) {
	  var n;
	  return void 0 === t && (t = -1), t < 0 && (t = 0 !== (n = e[0].rank) ? n : 0), t === e[0].rank && (t = -1), Bn(e, t);
	}

	function concatAlongFirstAxis(e, t) {
	  switch (e.rank) {
	    case 1:
	      return Pn([e, t]);

	    case 2:
	      return Ln([e, t], 0);

	    case 3:
	      return Wn([e, t], 0);

	    case 4:
	      return Un([e, t], 0);

	    default:
	      throw new ValueError("concatAlongFirstAxis() received an unsupported tensor rank: " + e.rank);
	  }
	}

	function tile$1(e, t) {
	  if (Array.isArray(t) || (t = [t]), e.rank !== t.length) throw new ValueError("The length of input n (" + t.length + ") does not match the number of dimensions in input x (" + e.rank + ")");
	  return Cr(e, t);
	}

	function randomNormal$1(e, t, n, r, i) {
	  return void 0 === t && (t = 0), void 0 === n && (n = 1), mr(e, t, n, r, i);
	}

	function dot(e, t, n, r) {
	  if (e.rank < 2 || t.rank < 2) throw new NotImplementedError("dot requires both inputs to be rank >= 2 but got x shape = " + e.shape + " and y shape = " + t.shape);
	  if (t.rank >= 3 && (s = e.shape.slice(-1)[0]) !== (c = t.shape.slice(-2)[0])) throw new NotImplementedError("If rank y >= 3, then the second last dim of y must equal the last dim of x but got x shape = " + e.shape + " and  y shape = " + t.shape);

	  if (2 === e.rank && 2 === t.rank) {
	    var i = !1,
	        a = !1;
	    return Nc.matMul(e, t, i, a, r ? reshapeBias(e.rank, r, imageDataFormat()) : null, n);
	  }

	  var o = e.shape.slice(),
	      s = o.pop();
	  e = e.reshape([-1, s]);
	  var l = t.shape.slice(),
	      u = l.pop(),
	      c = l.pop(),
	      p = l.concat([u]),
	      h = Array.from({
	    length: t.rank
	  }, function (e, n) {
	    return 0 === n ? t.rank - 2 : n <= t.rank - 2 ? n - 1 : n;
	  });
	  t = t.transpose(h).reshape([c, -1]);
	  var d = o.concat(p);
	  i = !1, a = !1;
	  return Nc.matMul(e, t, i, a, r ? reshapeBias(e.rank, r, imageDataFormat()) : null, n).reshape(d);
	}

	function gather$1(e, t, n) {
	  return ze(function () {
	    return t = Array.isArray(t) ? En(t, "int32") : t.toInt(), Bl(e, t, n);
	  });
	}

	function square(e) {
	  return pl(e, e);
	}

	function reshapeBias(e, t, n) {
	  var r = t.shape;
	  if (1 !== t.rank && t.rank !== e) throw new ValueError("Unexpected bias dimensions: " + t.rank + "; expected it to be 1 or " + e);

	  if (5 === e) {
	    if ("channelsFirst" === n) return 1 === r.length ? t.reshape([1, r[0], 1, 1, 1]) : t.reshape([1, r[3], r[0], r[1], r[2]]);
	    if ("channelsLast" === n) return 1 === r.length ? t.reshape([1, 1, 1, 1, r[0]]) : t.reshape([1].concat(r));
	  } else if (4 === e) {
	    if ("channelsFirst" === n) return 1 === r.length ? t.reshape([1, r[0], 1, 1]) : t.reshape([1, r[2], r[0], r[1]]);
	    if ("channelsLast" === n) return 1 === r.length ? t.reshape([1, 1, 1, r[0]]) : t.reshape([1].concat(r));
	  } else if (3 === e) {
	    if ("channelsFirst" === n) return 1 === r.length ? t.reshape([1, r[0], 1]) : t.reshape([1, r[1], r[0]]);
	    if ("channelsLast" === n) return 1 === r.length ? t.reshape([1, 1, r[0]]) : t.reshape([1].concat(r));
	  } else if (e < 3) return t;

	  throw new ValueError("Unsupported input rank by biasAdd: " + t.rank);
	}

	function biasAdd(e, t, n) {
	  return ze(function () {
	    return null == n && (n = imageDataFormat()), checkDataFormat(n), e.add(reshapeBias(e.rank, t, n));
	  });
	}

	function elu$1(e, t) {
	  if (void 0 === t && (t = 1), 1 !== t) throw new NotImplementedError("Support for alpha values other than 1 (" + t + ") is not implemented yet.");
	  return Sl(e);
	}

	function softsign(e) {
	  return ze(function () {
	    return rl(e, as(e).add(1));
	  });
	}

	function dropout$1(e, t, n, r) {
	  return ze(function () {
	    return Ql(e, t, n, r);
	  });
	}

	function hardSigmoid(e) {
	  return ze(function () {
	    var t = Zu(.5, fl(.2, e));
	    return ps(t, 0, 1);
	  });
	}

	function inTrainPhase(e, t, n) {
	  return void 0 === n && (n = !1), n ? e() : t();
	}

	var VALID_FAN_MODE_VALUES = ["fanIn", "fanOut", "fanAvg"],
	    VALID_DISTRIBUTION_VALUES = ["normal", "uniform", "truncatedNormal"];

	function checkFanMode(e) {
	  checkStringTypeUnionValue(VALID_FAN_MODE_VALUES, "FanMode", e);
	}

	function checkDistribution(e) {
	  checkStringTypeUnionValue(VALID_DISTRIBUTION_VALUES, "Distribution", e);
	}

	var Initializer = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.fromConfigUsesCustomObjects = function () {
	    return !1;
	  }, t.prototype.getConfig = function () {
	    return {};
	  }, t;
	}(Ph.Serializable),
	    Zeros = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.apply = function (e, t) {
	    return Tn(e, t);
	  }, t.className = "Zeros", t;
	}(Initializer);

	Ph.registerClass(Zeros);

	var Ones = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.apply = function (e, t) {
	    return An(e, t);
	  }, t.className = "Ones", t;
	}(Initializer);

	Ph.registerClass(Ones);

	var Constant = function (e) {
	  function t(t) {
	    var n = e.call(this) || this;
	    if ("object" != _typeof_1(t)) throw new ValueError("Expected argument of type ConstantConfig but got " + t);
	    if (void 0 === t.value) throw new ValueError("config must have value set but got " + t);
	    return n.value = t.value, n;
	  }

	  return __extends(t, e), t.prototype.apply = function (e, t) {
	    var n = this;
	    return ze(function () {
	      return fl(Cn(n.value), An(e, t));
	    });
	  }, t.prototype.getConfig = function () {
	    return {
	      value: this.value
	    };
	  }, t.className = "Constant", t;
	}(Initializer);

	Ph.registerClass(Constant);

	var RandomUniform = function (e) {
	  function t(t) {
	    var n = e.call(this) || this;
	    return n.DEFAULT_MINVAL = -.05, n.DEFAULT_MAXVAL = .05, n.minval = t.minval || n.DEFAULT_MINVAL, n.maxval = t.maxval || n.DEFAULT_MAXVAL, n.seed = t.seed, n;
	  }

	  return __extends(t, e), t.prototype.apply = function (e, t) {
	    return gr(e, this.minval, this.maxval, t);
	  }, t.prototype.getConfig = function () {
	    return {
	      minval: this.minval,
	      maxval: this.maxval,
	      seed: this.seed
	    };
	  }, t.className = "RandomUniform", t;
	}(Initializer);

	Ph.registerClass(RandomUniform);

	var RandomNormal = function (e) {
	  function t(t) {
	    var n = e.call(this) || this;
	    return n.DEFAULT_MEAN = 0, n.DEFAULT_STDDEV = .05, n.mean = t.mean || n.DEFAULT_MEAN, n.stddev = t.stddev || n.DEFAULT_STDDEV, n.seed = t.seed, n;
	  }

	  return __extends(t, e), t.prototype.apply = function (e, t) {
	    if ("float32" !== (t = t || "float32") && "int32" !== t) throw new NotImplementedError("randomNormal does not support dType " + t + ".");
	    return randomNormal$1(e, this.mean, this.stddev, t, this.seed);
	  }, t.prototype.getConfig = function () {
	    return {
	      mean: this.mean,
	      stddev: this.stddev,
	      seed: this.seed
	    };
	  }, t.className = "RandomNormal", t;
	}(Initializer);

	Ph.registerClass(RandomNormal);

	var TruncatedNormal = function (e) {
	  function t(t) {
	    var n = e.call(this) || this;
	    return n.DEFAULT_MEAN = 0, n.DEFAULT_STDDEV = .05, n.mean = t.mean || n.DEFAULT_MEAN, n.stddev = t.stddev || n.DEFAULT_STDDEV, n.seed = t.seed, n;
	  }

	  return __extends(t, e), t.prototype.apply = function (e, t) {
	    if ("float32" !== (t = t || "float32") && "int32" !== t) throw new NotImplementedError("truncatedNormal does not support dType " + t + ".");
	    return Er(e, this.mean, this.stddev, t, this.seed);
	  }, t.prototype.getConfig = function () {
	    return {
	      mean: this.mean,
	      stddev: this.stddev,
	      seed: this.seed
	    };
	  }, t.className = "TruncatedNormal", t;
	}(Initializer);

	Ph.registerClass(TruncatedNormal);

	var Identity = function (e) {
	  function t(t) {
	    var n = e.call(this) || this;
	    return n.gain = null != t.gain ? t.gain : 1, n;
	  }

	  return __extends(t, e), t.prototype.apply = function (e, t) {
	    var n = this;
	    return ze(function () {
	      if (2 !== e.length || e[0] !== e[1]) throw new ValueError("Identity matrix initializer can only be used for 2D square matrices.");
	      return fl(n.gain, sr(e[0]));
	    });
	  }, t.prototype.getConfig = function () {
	    return {
	      gain: this.gain
	    };
	  }, t.className = "Identity", t;
	}(Initializer);

	function computeFans(e, t) {
	  var n, r;
	  if (void 0 === t && (t = "channelsLast"), checkDataFormat(t), 2 === e.length) n = e[0], r = e[1];else if (-1 !== [3, 4, 5].indexOf(e.length)) {
	    if ("channelsFirst" === t) {
	      var i = arrayProd(e, 2);
	      n = e[1] * i, r = e[0] * i;
	    } else if ("channelsLast" === t) {
	      i = arrayProd(e, 0, e.length - 2);
	      n = e[e.length - 2] * i, r = e[e.length - 1] * i;
	    }
	  } else {
	    var a = arrayProd(e);
	    n = Math.sqrt(a), r = Math.sqrt(a);
	  }
	  return [n, r];
	}

	Ph.registerClass(Identity);

	var VarianceScaling = function (e) {
	  function t(t) {
	    var n = e.call(this) || this;
	    if (t.scale < 0) throw new ValueError("scale must be a positive float. Got: " + t.scale);
	    return n.scale = null == t.scale ? 1 : t.scale, n.mode = null == t.mode ? "fanIn" : t.mode, checkFanMode(n.mode), n.distribution = null == t.distribution ? "normal" : t.distribution, checkDistribution(n.distribution), n.seed = t.seed, n;
	  }

	  return __extends(t, e), t.prototype.apply = function (e, t) {
	    var n = computeFans(e),
	        r = n[0],
	        i = n[1],
	        a = this.scale;

	    if ("fanIn" === this.mode ? a /= Math.max(1, r) : "fanOut" === this.mode ? a /= Math.max(1, i) : a /= Math.max(1, (r + i) / 2), "normal" === this.distribution) {
	      var o = Math.sqrt(a);
	      if ("float32" !== (t = t || "float32") && "int32" !== t) throw new NotImplementedError(this.getClassName() + " does not support dType " + t + ".");
	      return Er(e, 0, o, t, this.seed);
	    }

	    var s = Math.sqrt(3 * a);
	    return gr(e, -s, s, t);
	  }, t.prototype.getConfig = function () {
	    return {
	      scale: this.scale,
	      mode: this.mode,
	      distribution: this.distribution,
	      seed: this.seed
	    };
	  }, t.className = "VarianceScaling", t;
	}(Initializer);

	Ph.registerClass(VarianceScaling);

	var GlorotUniform = function (e) {
	  function t(t) {
	    return e.call(this, {
	      scale: 1,
	      mode: "fanAvg",
	      distribution: "uniform",
	      seed: null == t ? null : t.seed
	    }) || this;
	  }

	  return __extends(t, e), t.prototype.getClassName = function () {
	    return VarianceScaling.className;
	  }, t.className = "GlorotUniform", t;
	}(VarianceScaling);

	Ph.registerClass(GlorotUniform);

	var GlorotNormal = function (e) {
	  function t(t) {
	    return e.call(this, {
	      scale: 1,
	      mode: "fanAvg",
	      distribution: "normal",
	      seed: null == t ? null : t.seed
	    }) || this;
	  }

	  return __extends(t, e), t.prototype.getClassName = function () {
	    return VarianceScaling.className;
	  }, t.className = "GlorotNormal", t;
	}(VarianceScaling);

	Ph.registerClass(GlorotNormal);

	var HeNormal = function (e) {
	  function t(t) {
	    return e.call(this, {
	      scale: 2,
	      mode: "fanIn",
	      distribution: "normal",
	      seed: null == t ? null : t.seed
	    }) || this;
	  }

	  return __extends(t, e), t.prototype.getClassName = function () {
	    return VarianceScaling.className;
	  }, t.className = "HeNormal", t;
	}(VarianceScaling);

	Ph.registerClass(HeNormal);

	var HeUniform = function (e) {
	  function t(t) {
	    return e.call(this, {
	      scale: 2,
	      mode: "fanIn",
	      distribution: "uniform",
	      seed: null == t ? null : t.seed
	    }) || this;
	  }

	  return __extends(t, e), t.prototype.getClassName = function () {
	    return VarianceScaling.className;
	  }, t.className = "HeUniform", t;
	}(VarianceScaling);

	Ph.registerClass(HeUniform);

	var LeCunNormal = function (e) {
	  function t(t) {
	    return e.call(this, {
	      scale: 1,
	      mode: "fanIn",
	      distribution: "normal",
	      seed: null == t ? null : t.seed
	    }) || this;
	  }

	  return __extends(t, e), t.prototype.getClassName = function () {
	    return VarianceScaling.className;
	  }, t.className = "LeCunNormal", t;
	}(VarianceScaling);

	Ph.registerClass(LeCunNormal);

	var LeCunUniform = function (e) {
	  function t(t) {
	    return e.call(this, {
	      scale: 1,
	      mode: "fanIn",
	      distribution: "uniform",
	      seed: null == t ? null : t.seed
	    }) || this;
	  }

	  return __extends(t, e), t.prototype.getClassName = function () {
	    return VarianceScaling.className;
	  }, t.className = "LeCunNormal", t;
	}(VarianceScaling);

	Ph.registerClass(LeCunUniform);

	var Orthogonal = function (e) {
	  function t(t) {
	    var n = e.call(this) || this;
	    if (n.DEFAULT_GAIN = 1, n.gain = null == t.gain ? n.DEFAULT_GAIN : t.gain, n.seed = t.seed, null != n.seed) throw new NotImplementedError("Random seed is not implemented for Orthogonal Initializer yet.");
	    return n;
	  }

	  return __extends(t, e), t.prototype.apply = function (e, t) {
	    var n = this;
	    return ze(function () {
	      if (2 !== e.length) throw new NotImplementedError("The Orthogonal Initializer does not support non-2D shapes yet.");
	      e[0] * e[1] > 2e3 && console.warn("Orthogonal initializer is being called on a matrix with more than 2000 (" + e[0] * e[1] + ") elements: Slowness may result.");
	      var t = randomNormal$1(e[0] > e[1] ? [e[1], e[0]] : e, 0, 1, "float32"),
	          r = gc.gramSchmidt(t);
	      return e[0] > e[1] && (r = r.transpose()), fl(n.gain, r);
	    });
	  }, t.prototype.getConfig = function () {
	    return {
	      gain: this.gain,
	      seed: this.seed
	    };
	  }, t.className = "Orthogonal", t;
	}(Initializer);

	Ph.registerClass(Orthogonal);
	var INITIALIZER_IDENTIFIER_REGISTRY_SYMBOL_MAP = {
	  constant: "Constant",
	  glorotNormal: "GlorotNormal",
	  glorotUniform: "GlorotUniform",
	  heNormal: "HeNormal",
	  heUniform: "HeUniform",
	  identity: "Identity",
	  leCunNormal: "LeCunNormal",
	  leCunUniform: "LeCunUniform",
	  ones: "Ones",
	  orthogonal: "Orthogonal",
	  randomNormal: "RandomNormal",
	  randomUniform: "RandomUniform",
	  truncatedNormal: "TruncatedNormal",
	  varianceScaling: "VarianceScaling",
	  zeros: "Zeros"
	};

	function deserializeInitializer(e, t) {
	  return void 0 === t && (t = {}), deserializeKerasObject(e, Ph.SerializationMap.getMap().classNameMap, t, "initializer");
	}

	function serializeInitializer(e) {
	  return serializeKerasObject(e);
	}

	function getInitializer(e) {
	  if ("string" == typeof e) {
	    var t = e in INITIALIZER_IDENTIFIER_REGISTRY_SYMBOL_MAP ? INITIALIZER_IDENTIFIER_REGISTRY_SYMBOL_MAP[e] : e;
	    if ("GlorotNormal" === t) return new GlorotNormal();
	    if ("GlorotUniform" === t) return new GlorotUniform();
	    if ("HeNormal" === t) return new HeNormal();
	    if ("HeUniform" === t) return new HeUniform();
	    if ("LeCunNormal" === t) return new LeCunNormal();
	    if ("LeCunUniform" === t) return new LeCunUniform();
	    var n = {};
	    return n.className = t, n.config = {}, deserializeInitializer(n);
	  }

	  return e instanceof Initializer ? e : deserializeInitializer(e);
	}

	function zeros$1() {
	  return new Zeros();
	}

	function ones$1() {
	  return new Ones();
	}

	function constant(e) {
	  return new Constant(e);
	}

	function randomUniform$1(e) {
	  return new RandomUniform(e);
	}

	function randomNormal$2(e) {
	  return new RandomNormal(e);
	}

	function truncatedNormal$1(e) {
	  return new TruncatedNormal(e);
	}

	function identity(e) {
	  return new Identity(e);
	}

	function varianceScaling(e) {
	  return new VarianceScaling(e);
	}

	function glorotUniform(e) {
	  return new GlorotUniform(e);
	}

	function glorotNormal(e) {
	  return new GlorotNormal(e);
	}

	function heNormal(e) {
	  return new HeNormal(e);
	}

	function heUniform(e) {
	  return new HeUniform(e);
	}

	function leCunNormal(e) {
	  return new LeCunNormal(e);
	}

	function leCunUniform(e) {
	  return new LeCunUniform(e);
	}

	function orthogonal(e) {
	  return new Orthogonal(e);
	}

	var exports_initializers = Object.freeze({
	  zeros: zeros$1,
	  ones: ones$1,
	  constant: constant,
	  randomUniform: randomUniform$1,
	  randomNormal: randomNormal$2,
	  truncatedNormal: truncatedNormal$1,
	  identity: identity,
	  varianceScaling: varianceScaling,
	  glorotUniform: glorotUniform,
	  glorotNormal: glorotNormal,
	  heNormal: heNormal,
	  heUniform: heUniform,
	  leCunNormal: leCunNormal,
	  leCunUniform: leCunUniform,
	  orthogonal: orthogonal
	}),
	    _nextUniqueTensorId = 0;

	function getNextUniqueTensorId() {
	  return _nextUniqueTensorId++;
	}

	var _uidPrefixes = {};

	function getUid(e) {
	  return void 0 === e && (e = ""), e in _uidPrefixes || (_uidPrefixes[e] = 0), _uidPrefixes[e] += 1, e + _uidPrefixes[e].toString();
	}

	function isArrayOfShapes(e) {
	  return Array.isArray(e) && Array.isArray(e[0]);
	}

	function normalizeShapeList(e) {
	  return 0 === e.length ? [] : Array.isArray(e[0]) ? e : [e];
	}

	function getExactlyOneTensor(e) {
	  var t;

	  if (Array.isArray(e)) {
	    if (1 !== e.length) throw new ValueError("Expected Tensor length to be 1; got " + e.length);
	    t = e[0];
	  } else t = e;

	  return t;
	}

	function getExactlyOneShape(e) {
	  if (Array.isArray(e) && Array.isArray(e[0])) {
	    if (1 === e.length) return (e = e)[0];
	    throw new ValueError("Expected exactly 1 Shape; got " + e.length);
	  }

	  return e;
	}

	function countParamsInWeights(e) {
	  for (var t = 0, n = 0, r = e; n < r.length; n++) {
	    var i = r[n];
	    0 === i.shape.length ? t += 1 : t += i.shape.reduce(function (e, t) {
	      return e * t;
	    });
	  }

	  return t;
	}

	var DEFAULT_VARIABLE_NAME_PREFIX = "Variable",
	    LayerVariable = function () {
	  function e(e, t, n, r, i) {
	    void 0 === t && (t = "float32"), void 0 === n && (n = DEFAULT_VARIABLE_NAME_PREFIX), void 0 === r && (r = !0), void 0 === i && (i = null), this.dtype = null == t ? "float32" : t, this.shape = e.shape, this.id = getNextUniqueTensorId(), n = null == n ? DEFAULT_VARIABLE_NAME_PREFIX : n, this.originalName = getScopedTensorName(n), this.name = getUniqueTensorName(this.originalName), this.trainable_ = r, this.constraint = i, this.val = yt(e, this.trainable_, this.name, this.dtype);
	  }

	  return e.prototype.read = function () {
	    return this.assertNotDisposed(), this.val;
	  }, e.prototype.write = function (e) {
	    return this.assertNotDisposed(), checkShapesMatch(this.val, e), this.val.id !== e.id && (this.val.assign(e), null != this.constraint && this.val.assign(this.constraint.apply(this.val))), this;
	  }, e.prototype.dispose = function () {
	    this.assertNotDisposed(), this.val.dispose();
	  }, e.prototype.assertNotDisposed = function () {
	    if (this.val.isDisposed) throw new Error("LayersVariable " + this.name + " is already disposed.");
	  }, Object.defineProperty(e.prototype, "trainable", {
	    get: function get() {
	      return this.trainable_;
	    },
	    set: function set(e) {
	      this.trainable_ = e, this.val.trainable = e;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), e;
	}();

	function checkShapesMatch(e, t) {
	  if (e.shape.toString() !== t.shape.toString()) throw new Error("Shape mismatch: " + JSON.stringify(e.shape) + " vs. " + JSON.stringify(t.shape));
	}

	function batchGetValue(e) {
	  return e.map(function (e) {
	    return e.read();
	  });
	}

	function batchSetValue(e) {
	  e.forEach(function (e) {
	    e[0].write(e[1]);
	  });
	}

	var InputSpec = function () {
	  return function (e) {
	    this.dtype = e.dtype, this.shape = e.shape, null != e.shape ? this.ndim = e.shape.length : this.ndim = e.ndim, this.maxNDim = e.maxNDim, this.minNDim = e.minNDim, this.axes = e.axes || {};
	  };
	}(),
	    SymbolicTensor = function () {
	  return function (e, t, n, r, i, a, o) {
	    this.dtype = e, this.shape = t, this.sourceLayer = n, this.inputs = r, this.callArgs = i, this.outputTensorIndex = o, this.id = getNextUniqueTensorId(), null != a && (this.originalName = getScopedTensorName(a), this.name = getUniqueTensorName(this.originalName)), this.rank = t.length;
	  };
	}(),
	    _nextNodeID = 0,
	    Node = function () {
	  function e(e, t) {
	    this.callArgs = t, this.id = _nextNodeID++, this.outboundLayer = e.outboundLayer, this.inboundLayers = e.inboundLayers, this.nodeIndices = e.nodeIndices, this.tensorIndices = e.tensorIndices, this.inputTensors = e.inputTensors, this.outputTensors = e.outputTensors, this.inputMasks = e.inputMasks, this.outputMasks = e.outputMasks, this.inputShapes = e.inputShapes, this.outputShapes = e.outputShapes;

	    for (var n = 0, r = e.inboundLayers; n < r.length; n++) {
	      var i = r[n];
	      null != i && i.outboundNodes.push(this);
	    }

	    e.outboundLayer.inboundNodes.push(this);
	  }

	  return e.prototype.getConfig = function () {
	    for (var e = [], t = 0, n = this.inboundLayers; t < n.length; t++) {
	      var r = n[t];
	      null != r ? e.push(r.name) : e.push(null);
	    }

	    return {
	      outboundLayer: this.outboundLayer ? this.outboundLayer.name : null,
	      inboundLayers: e,
	      nodeIndices: this.nodeIndices,
	      tensorIndices: this.tensorIndices
	    };
	  }, e;
	}(),
	    _nextLayerID = 0,
	    Layer = function (e) {
	  function t(t) {
	    var n = e.call(this) || this;
	    n._callHook = null, n._addedWeightNames = [], n._stateful = !1, n.id = _nextLayerID++, n.activityRegularizer = null, n.inputSpec = null, n.supportsMasking = !1, n._trainableWeights = [], n._nonTrainableWeights = [], n._losses = [], n._updates = [], n._built = !1, n.inboundNodes = [], n.outboundNodes = [];
	    var r = t.name;

	    if (!r) {
	      var i = n.getClassName();
	      r = toSnakeCase(i) + "_" + getUid(i);
	    }

	    if (n.name = r, n.trainable_ = null == t.trainable || t.trainable, null != t.inputShape || null != t.batchInputShape) {
	      var a = void 0;
	      if (null != t.batchInputShape) a = t.batchInputShape;else if (null != t.inputShape) {
	        var o = null;
	        null != t.batchSize && (o = t.batchSize), a = [o].concat(t.inputShape);
	      }
	      n.batchInputShape = a;
	      var s = t.dtype;
	      null == s && (s = t.inputDType), null == s && (s = "float32"), n.dtype = s;
	    }

	    return null != t.weights ? n.initialWeights = t.weights : n.initialWeights = null, n._refCount = null, n.fastWeightInitDuringBuild = !1, n;
	  }

	  return __extends(t, e), t.nodeKey = function (e, t) {
	    return e.name + "_ib-" + t.toString();
	  }, t.prototype.getNodeAtIndex = function (e, t) {
	    if (0 === this.inboundNodes.length) throw new RuntimeError("The layer has never been called and thus has no defined " + t + ".");
	    if (this.inboundNodes.length <= e) throw new ValueError("Asked to get " + t + " at node " + e + ", but the layer has only " + this.inboundNodes.length + " inbound nodes.");
	    return this.inboundNodes[e];
	  }, t.prototype.getInputAt = function (e) {
	    return singletonOrArray(this.getNodeAtIndex(e, "input").inputTensors);
	  }, t.prototype.getOutputAt = function (e) {
	    return singletonOrArray(this.getNodeAtIndex(e, "output").outputTensors);
	  }, Object.defineProperty(t.prototype, "input", {
	    get: function get() {
	      if (this.inboundNodes.length > 1) throw new AttributeError("Layer " + this.name + ' has multiple inbound nodes, hence the notion of "layer input" is ill-defined. Use `getInputAt(nodeIndex)` instead.');
	      if (0 === this.inboundNodes.length) throw new AttributeError("Layer " + this.name + " is not connected, no input to return.");
	      return singletonOrArray(this.getNodeAtIndex(0, "input").inputTensors);
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "output", {
	    get: function get() {
	      if (0 === this.inboundNodes.length) throw new AttributeError("Layer " + this.name + " has no inbound nodes.");
	      if (this.inboundNodes.length > 1) throw new AttributeError("Layer " + this.name + ' has multiple inbound nodes, hence the notion of "layer output" is ill-defined. Use `getOutputAt(nodeIndex)` instead.');
	      return singletonOrArray(this.getNodeAtIndex(0, "output").outputTensors);
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "losses", {
	    get: function get() {
	      return this._losses;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.calculateLosses = function () {
	    return this.losses.map(function (e) {
	      return e();
	    });
	  }, Object.defineProperty(t.prototype, "updates", {
	    get: function get() {
	      return this._updates;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "built", {
	    get: function get() {
	      return this._built;
	    },
	    set: function set(e) {
	      this._built = e;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "trainable", {
	    get: function get() {
	      return this.trainable_;
	    },
	    set: function set(e) {
	      this._trainableWeights.forEach(function (t) {
	        return t.trainable = e;
	      }), this.trainable_ = e;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "trainableWeights", {
	    get: function get() {
	      return this.trainable_ ? this._trainableWeights.filter(function (e) {
	        return e.trainable;
	      }) : [];
	    },
	    set: function set(e) {
	      this._trainableWeights = e;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "nonTrainableWeights", {
	    get: function get() {
	      return this.trainable ? this._trainableWeights.filter(function (e) {
	        return !e.trainable;
	      }).concat(this._nonTrainableWeights) : this._trainableWeights.concat(this._nonTrainableWeights);
	    },
	    set: function set(e) {
	      this._nonTrainableWeights = e;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "weights", {
	    get: function get() {
	      return this.trainableWeights.concat(this.nonTrainableWeights);
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "stateful", {
	    get: function get() {
	      return this._stateful;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.resetStates = function () {
	    if (!this.stateful) throw new Error("Cannot call the resetStates() method of a non-stateful Layer object.");
	  }, t.prototype.assertInputCompatibility = function (e) {
	    if (e = toList(e), null != this.inputSpec && 0 !== this.inputSpec.length) {
	      var t = toList(this.inputSpec);
	      if (e.length !== t.length) throw new ValueError("Layer " + this.name + " expects " + t.length + " inputs, but it received " + e.length + " input tensors. Input received: " + e);

	      for (var n = 0; n < e.length; n++) {
	        var r = e[n],
	            i = t[n];

	        if (null != i) {
	          var a = r.rank;
	          if (null != i.ndim && a !== i.ndim) throw new ValueError("Input " + n + " is incompatible with layer " + this.name + ": expected ndim=" + i.ndim + ", found ndim=" + a);
	          if (null != i.maxNDim && a > i.maxNDim) throw new ValueError("Input " + n + " is incompatible with layer " + this.name + ": expected max_ndim=" + i.maxNDim + ", found ndim=" + a);
	          if (null != i.minNDim && a < i.minNDim) throw new ValueError("Input " + n + " is incompatible with layer " + this.name + ": expected min_ndim=" + i.minNDim + ", found ndim=" + a + ".");
	          if (null != i.dtype && r.dtype !== i.dtype) throw new ValueError("Input " + n + " is incompatible with layer " + this.name + " : expected dtype=" + i.dtype + ", found dtype=" + r.dtype + ".");

	          if (i.axes) {
	            var o = r.shape;

	            for (var s in i.axes) {
	              var l = Number(s),
	                  u = i.axes[s],
	                  c = l >= 0 ? o[l] : o[o.length + l];
	              if (null != u && -1 === [u, null].indexOf(c)) throw new ValueError("Input " + n + " is incompatible with layer " + this.name + ": expected axis " + l + " of input shape to have value " + u + " but got shape " + o + ".");
	            }
	          }

	          if (null != i.shape) for (var p = 0; p < i.shape.length; ++p) {
	            var h = i.shape[p],
	                d = r.shape[p];
	            if (null != h && null != d && h !== d) throw new ValueError("Input " + n + " is incompatible with layer " + this.name + ": expected shape=" + i.shape + ", found shape=" + r.shape + ".");
	          }
	        }
	      }
	    }
	  }, t.prototype.call = function (e, t) {
	    return e;
	  }, t.prototype.invokeCallHook = function (e, t) {
	    null != this._callHook && this._callHook(e, t);
	  }, t.prototype.setCallHook = function (e) {
	    this._callHook = e;
	  }, t.prototype.clearCallHook = function () {
	    this._callHook = null;
	  }, t.prototype.apply = function (e, t) {
	    var n = this;
	    t = t || {}, this.assertNotDisposed();

	    for (var r = toList(e), i = !0, a = 0, o = r; a < o.length; a++) {
	      if (!(o[a] instanceof SymbolicTensor)) {
	        i = !1;
	        break;
	      }
	    }

	    for (var s = !0, l = 0, u = r; l < u.length; l++) {
	      if (u[l] instanceof SymbolicTensor) {
	        s = !1;
	        break;
	      }
	    }

	    if (i === s) throw new ValueError("Arguments to apply() must be all SymbolicTensors or all Tensors");
	    return nameScope(this.name, function () {
	      if (!n.built) {
	        n.assertInputCompatibility(e);

	        for (var i = [], a = 0, o = toList(e); a < o.length; a++) {
	          var l = o[a];
	          i.push(l.shape);
	        }

	        n.build(singletonOrArray(i)), n.built = !0, n.initialWeights && n.setWeights(n.initialWeights), null === n._refCount && s && (n._refCount = 1);
	      }

	      if (n.assertInputCompatibility(e), s) {
	        for (var u = [], c = 0, p = toList(g = n.call(e, t)); c < p.length; c++) {
	          var h = p[c];
	          -1 !== r.indexOf(h) && (h = h.clone()), u.push(h);
	        }

	        if (g = singletonOrArray(u), null != n.activityRegularizer) throw new NotImplementedError("Layer invocation in the presence of activity regularizer(s) is not supported yet.");
	        return g;
	      }

	      var d = collectInputShape(e),
	          f = n.computeOutputShape(d),
	          g = void 0,
	          m = guessOutputDType(e);
	      if (n.warnOnIncompatibleInputShape(Array.isArray(e) ? d[0] : d), g = null != f && f.length > 0 && Array.isArray(f[0]) ? f.map(function (r, i) {
	        return new SymbolicTensor(m, r, n, toList(e), t, n.name, i);
	      }) : new SymbolicTensor(m, f, n, toList(e), t, n.name), n.addInboundNode(e, g, null, null, d, f, t), n._refCount++, null != n.activityRegularizer) throw new NotImplementedError("Layer invocation in the presence of activity regularizer(s) is not supported yet.");
	      return g;
	    });
	  }, t.prototype.warnOnIncompatibleInputShape = function (e) {
	    if (null != this.batchInputShape) if (e.length !== this.batchInputShape.length) console.warn("The rank of the input tensor provided (shape: " + JSON.stringify(e) + ") does not match that of the batchInputShape (" + JSON.stringify(this.batchInputShape) + ") of the layer " + this.name);else {
	      var t = !1;
	      this.batchInputShape.forEach(function (n, r) {
	        null != n && null != e[r] && e[r] !== n && (t = !0);
	      }), t && console.warn("The shape of the input tensor (" + JSON.stringify(e) + ") does not match the expectation of layer " + this.name + ": " + JSON.stringify(this.batchInputShape));
	    }
	  }, Object.defineProperty(t.prototype, "outputShape", {
	    get: function get() {
	      if (null == this.inboundNodes || 0 === this.inboundNodes.length) throw new AttributeError("The layer " + this.name + " has never been called and thus has no defined output shape.");

	      for (var e = [], t = 0, n = this.inboundNodes; t < n.length; t++) {
	        var r = n[t],
	            i = JSON.stringify(r.outputShapes);
	        -1 === e.indexOf(i) && e.push(i);
	      }

	      if (1 === e.length) {
	        var a = this.inboundNodes[0].outputShapes;
	        return Array.isArray(a) && Array.isArray(a[0]) && 1 === a.length ? a[0] : a;
	      }

	      throw new AttributeError("The layer " + this.name + ' has multiple inbound nodes with different output shapes. Hence the notion of "outut shape" is ill-defined for the layer.');
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.countParams = function () {
	    if (!this.built) throw new RuntimeError("You tried to call countParams() on " + this.name + ", but the layer is not built yet. Build it first by calling build(batchInputShape).");
	    return countParamsInWeights(this.weights);
	  }, t.prototype.build = function (e) {
	    this.built = !0;
	  }, t.prototype.getWeights = function (e) {
	    return void 0 === e && (e = !1), batchGetValue(e ? this.trainableWeights : this.weights);
	  }, t.prototype.setWeights = function (e) {
	    var t = this;
	    ze(function () {
	      var n = t.weights;
	      if (n.length !== e.length) throw new ValueError('You called setWeights(weights) on layer "' + t.name + '" with a weight list of length ' + e.length + ", but the layer was expecting " + n.length + " weights. Provided weights: " + e + "...");

	      if (0 !== n.length) {
	        for (var r = [], i = batchGetValue(n), a = 0; a < i.length; ++a) {
	          var o = i[a],
	              s = n[a],
	              l = e[a];
	          if (!Q.arraysEqual(o.shape, l.shape)) throw new ValueError("Layer weight shape " + o.shape + " not compatible with provided weight shape " + l.shape);
	          r.push([s, l]);
	        }

	        batchSetValue(r);
	      }
	    });
	  }, t.prototype.addWeight = function (e, t, n, r, i, a, o) {
	    if (-1 !== this._addedWeightNames.indexOf(e)) throw new ValueError("Duplicate weight name " + e + " for layer " + this.name);
	    this._addedWeightNames.push(e), null == n && (n = "float32"), this.fastWeightInitDuringBuild && (r = getInitializer("zeros"));
	    var s = r.apply(t, n),
	        l = new LayerVariable(s, n, e, a, o);
	    return s.dispose(), null != i && this.addLoss(function () {
	      return i.apply(l.read());
	    }), null == a && (a = !0), a ? this._trainableWeights.push(l) : this._nonTrainableWeights.push(l), l;
	  }, t.prototype.setFastWeightInitDuringBuild = function (e) {
	    this.fastWeightInitDuringBuild = e;
	  }, t.prototype.addLoss = function (e) {
	    var t;
	    null == e || Array.isArray(e) && 0 === e.length || (e = toList(e), void 0 !== this._losses && null !== this._losses && (t = this.losses).push.apply(t, e));
	  }, t.prototype.computeOutputShape = function (e) {
	    return e;
	  }, t.prototype.computeMask = function (e, t) {
	    var n = this;

	    if (!this.supportsMasking) {
	      if (null != t) {
	        if (!Array.isArray(t)) throw new TypeError("Layer " + this.name + " does not support masking, but was passed an inputMask.");
	        t.forEach(function (e) {
	          if (null != e) throw new TypeError("Layer " + n.name + " does not support masking, but was passed an inputMask.");
	        });
	      }

	      return null;
	    }

	    return t;
	  }, t.prototype.addInboundNode = function (e, t, n, r, i, a, o) {
	    void 0 === o && (o = null);
	    var s = toList(e);
	    t = toList(t), n = toList(n), r = toList(r), i = normalizeShapeList(i), a = normalizeShapeList(a);

	    for (var l = [], u = [], c = [], p = 0, h = s; p < h.length; p++) {
	      var d = h[p];
	      l.push(d.sourceLayer), u.push(d.nodeIndex), c.push(d.tensorIndex);
	    }

	    new Node({
	      outboundLayer: this,
	      inboundLayers: l,
	      nodeIndices: u,
	      tensorIndices: c,
	      inputTensors: s,
	      outputTensors: t,
	      inputMasks: n,
	      outputMasks: r,
	      inputShapes: i,
	      outputShapes: a
	    }, o);

	    for (var f = 0; f < t.length; f++) {
	      t[f].sourceLayer = this, t[f].nodeIndex = this.inboundNodes.length - 1, t[f].tensorIndex = f;
	    }
	  }, t.prototype.getConfig = function () {
	    var e = {
	      name: this.name,
	      trainable: this.trainable
	    };
	    return null != this.batchInputShape && (e.batchInputShape = this.batchInputShape), null != this.dtype && (e.dtype = this.dtype), e;
	  }, t.prototype.disposeWeights = function () {
	    return this.weights.forEach(function (e) {
	      return e.dispose();
	    }), this.weights.length;
	  }, t.prototype.assertNotDisposed = function () {
	    if (0 === this._refCount) throw new Error("Layer '" + this.name + "' is already disposed.");
	  }, t.prototype.dispose = function () {
	    if (!this.built) throw new Error("Cannot dispose Layer " + this.name + " because it has not been built yet.");
	    if (null === this._refCount) throw new Error("Cannot dispose Layer " + this.name + " because it has not been used yet.");
	    this.assertNotDisposed();
	    var e = 0;
	    return 0 == --this._refCount && (e = this.disposeWeights()), {
	      refCountAfterDispose: this._refCount,
	      numDisposedVariables: e
	    };
	  }, t;
	}(Ph.Serializable);

	function collectInputShape(e) {
	  for (var t = [], n = 0, r = e = toList(e); n < r.length; n++) {
	    var i = r[n];
	    t.push(i.shape);
	  }

	  return singletonOrArray(t);
	}

	function guessOutputDType(e) {
	  return "float32";
	}

	function getSourceInputs(e, t, n) {
	  if ((null == t || null != n && n > 0) && (t = e.sourceLayer, n = e.nodeIndex), 0 === t.inboundNodes.length) return [e];
	  var r = t.inboundNodes[n];
	  if (0 === r.inboundLayers.length) return r.inputTensors;

	  for (var i = [], a = 0; a < r.inboundLayers.length; a++) {
	    for (var o = 0, s = getSourceInputs(r.inputTensors[a], r.inboundLayers[a], r.nodeIndices[a]); o < s.length; o++) {
	      var l = s[o];
	      -1 === i.indexOf(l) && i.push(l);
	    }
	  }

	  return i;
	}

	var ModelLoggingVerbosity,
	    InputLayer = function (e) {
	  function t(t) {
	    var n = e.call(this, {
	      dtype: t.dtype,
	      name: null != t.name ? t.name : getUid("input").toString()
	    }) || this;
	    if (null == t.batchSize && (t.batchSize = null), null == t.sparse && (t.sparse = !1), n.trainable = !1, n.built = !0, n.sparse = t.sparse, null != t.inputShape && null != t.batchInputShape) throw new ValueError("Only provide the inputShape OR batchInputShape argument to inputLayer, not both at the same time.");
	    var r = t.batchInputShape;

	    if (null == r) {
	      if (null == t.inputShape) throw new ValueError("An InputLayer should be passed either a `batchInputShape` or an `inputShape`.");
	      r = [t.batchSize].concat(t.inputShape);
	    } else if (null != t.batchSize) throw new ValueError("Cannot specify batchSize if batchInputShape is specified when creating an InputLayer.");

	    var i = t.dtype || "float32";
	    n.batchInputShape = r, n.dtype = i, n.inputSpec = [{
	      shape: r
	    }];
	    var a = new SymbolicTensor(n.dtype, n.batchInputShape, n, [], {}, n.name);
	    return a.nodeIndex = 0, a.tensorIndex = 0, new Node({
	      outboundLayer: n,
	      inboundLayers: [],
	      nodeIndices: [],
	      tensorIndices: [],
	      inputTensors: [a],
	      outputTensors: [a],
	      inputMasks: [null],
	      outputMasks: [null],
	      inputShapes: [r],
	      outputShapes: [r]
	    }), n;
	  }

	  return __extends(t, e), t.prototype.apply = function (e, t) {
	    throw new ValueError("Cannot pass any input to an InputLayer's apply() method. InputLayer name: " + this.name);
	  }, t.prototype.dispose = function () {
	    return {
	      refCountAfterDispose: this._refCount,
	      numDisposedVariables: 0
	    };
	  }, t.prototype.getConfig = function () {
	    return {
	      batchInputShape: this.batchInputShape,
	      dtype: this.dtype,
	      sparse: this.sparse,
	      name: this.name
	    };
	  }, t.className = "InputLayer", t;
	}(Layer);

	function Input(e) {
	  if (null == e.batchShape && null == e.shape) throw new Error("Please provide to Input either a `shape` or a `batchShape` argument. Note that `shape` does not include the batch dimension.");
	  if (null != e.batchShape && null != e.shape) throw new ValueError("Please provide either a `shape` or `batchShape` argument to Input, but not both.");
	  var t = e.batchShape;
	  null != e.shape && null == t && (t = [null].concat(e.shape));
	  var n = e.dtype;
	  return null == n && (n = "float32"), new InputLayer({
	    batchInputShape: t,
	    name: e.name,
	    dtype: n,
	    sparse: e.sparse
	  }).inboundNodes[0].outputTensors[0];
	}

	function resolveScalarsInLogs(e) {
	  return __awaiter(this, void 0, void 0, function () {
	    var t, n, r, i, a, o, s, l;
	    return __generator(this, function (u) {
	      switch (u.label) {
	        case 0:
	          if (null == e) return [2];

	          for (i in t = [], n = [], r = [], e) {
	            "number" != typeof (a = e[i]) && (o = a, t.push(o.data()), n.push(i), r.push(o));
	          }

	          return t.length > 0 ? [4, Promise.all(t)] : [3, 2];

	        case 1:
	          for (s = u.sent(), l = 0; l < s.length; ++l) {
	            e[n[l]] = s[l][0];
	          }

	          Ve(r), u.label = 2;

	        case 2:
	          return [2];
	      }
	    });
	  });
	}

	function disposeTensorsInLogs(e) {
	  if (null != e) for (var t in e) {
	    var n = e[t];
	    "number" != typeof n && n.dispose();
	  }
	}

	Ph.registerClass(InputLayer), function (e) {
	  e[e.SILENT = 0] = "SILENT", e[e.VERBOSE = 1] = "VERBOSE";
	}(ModelLoggingVerbosity || (ModelLoggingVerbosity = {}));

	var DEFAULT_YIELD_EVERY_MS = 125,
	    BaseCallback = function () {
	  function e() {
	    this.validationData = null;
	  }

	  return e.prototype.setParams = function (e) {
	    this.params = e;
	  }, e.prototype.onEpochBegin = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (e) {
	        return [2];
	      });
	    });
	  }, e.prototype.onEpochEnd = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (e) {
	        return [2];
	      });
	    });
	  }, e.prototype.onBatchBegin = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (e) {
	        return [2];
	      });
	    });
	  }, e.prototype.onBatchEnd = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (e) {
	        return [2];
	      });
	    });
	  }, e.prototype.onTrainBegin = function (e) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (e) {
	        return [2];
	      });
	    });
	  }, e.prototype.onTrainEnd = function (e) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (e) {
	        return [2];
	      });
	    });
	  }, e.prototype.setModel = function (e) {}, e;
	}(),
	    CallbackList = function () {
	  function e(e, t) {
	    void 0 === t && (t = 10), null == e && (e = []), this.callbacks = e, this.queueLength = t;
	  }

	  return e.prototype.append = function (e) {
	    this.callbacks.push(e);
	  }, e.prototype.setParams = function (e) {
	    for (var t = 0, n = this.callbacks; t < n.length; t++) {
	      n[t].setParams(e);
	    }
	  }, e.prototype.setModel = function (e) {
	    for (var t = 0, n = this.callbacks; t < n.length; t++) {
	      n[t].setModel(e);
	    }
	  }, e.prototype.onEpochBegin = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      var n, r;
	      return __generator(this, function (i) {
	        switch (i.label) {
	          case 0:
	            null == t && (t = {}), n = 0, r = this.callbacks, i.label = 1;

	          case 1:
	            return n < r.length ? [4, r[n].onEpochBegin(e, t)] : [3, 4];

	          case 2:
	            i.sent(), i.label = 3;

	          case 3:
	            return n++, [3, 1];

	          case 4:
	            return [2];
	        }
	      });
	    });
	  }, e.prototype.onEpochEnd = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      var n, r;
	      return __generator(this, function (i) {
	        switch (i.label) {
	          case 0:
	            null == t && (t = {}), n = 0, r = this.callbacks, i.label = 1;

	          case 1:
	            return n < r.length ? [4, r[n].onEpochEnd(e, t)] : [3, 4];

	          case 2:
	            i.sent(), i.label = 3;

	          case 3:
	            return n++, [3, 1];

	          case 4:
	            return [2];
	        }
	      });
	    });
	  }, e.prototype.onBatchBegin = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      var n, r;
	      return __generator(this, function (i) {
	        switch (i.label) {
	          case 0:
	            null == t && (t = {}), n = 0, r = this.callbacks, i.label = 1;

	          case 1:
	            return n < r.length ? [4, r[n].onBatchBegin(e, t)] : [3, 4];

	          case 2:
	            i.sent(), i.label = 3;

	          case 3:
	            return n++, [3, 1];

	          case 4:
	            return [2];
	        }
	      });
	    });
	  }, e.prototype.onBatchEnd = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      var n, r;
	      return __generator(this, function (i) {
	        switch (i.label) {
	          case 0:
	            null == t && (t = {}), n = 0, r = this.callbacks, i.label = 1;

	          case 1:
	            return n < r.length ? [4, r[n].onBatchEnd(e, t)] : [3, 4];

	          case 2:
	            i.sent(), i.label = 3;

	          case 3:
	            return n++, [3, 1];

	          case 4:
	            return [2];
	        }
	      });
	    });
	  }, e.prototype.onTrainBegin = function (e) {
	    return __awaiter(this, void 0, void 0, function () {
	      var t, n;
	      return __generator(this, function (r) {
	        switch (r.label) {
	          case 0:
	            null == e && (e = {}), t = 0, n = this.callbacks, r.label = 1;

	          case 1:
	            return t < n.length ? [4, n[t].onTrainBegin(e)] : [3, 4];

	          case 2:
	            r.sent(), r.label = 3;

	          case 3:
	            return t++, [3, 1];

	          case 4:
	            return [2];
	        }
	      });
	    });
	  }, e.prototype.onTrainEnd = function (e) {
	    return __awaiter(this, void 0, void 0, function () {
	      var t, n;
	      return __generator(this, function (r) {
	        switch (r.label) {
	          case 0:
	            null == e && (e = {}), t = 0, n = this.callbacks, r.label = 1;

	          case 1:
	            return t < n.length ? [4, n[t].onTrainEnd(e)] : [3, 4];

	          case 2:
	            r.sent(), r.label = 3;

	          case 3:
	            return t++, [3, 1];

	          case 4:
	            return [2];
	        }
	      });
	    });
	  }, e;
	}(),
	    BaseLogger = function (e) {
	  function t() {
	    return e.call(this) || this;
	  }

	  return __extends(t, e), t.prototype.onEpochBegin = function (e) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (e) {
	        return this.seen = 0, this.totals = {}, [2];
	      });
	    });
	  }, t.prototype.onBatchEnd = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      var e,
	          n,
	          r,
	          i,
	          a = this;
	      return __generator(this, function (o) {
	        for (i in null == t && (t = {}), e = null == t.size ? 0 : t.size, this.seen += e, n = function n(_n) {
	          var i = t[_n];
	          if ("number" == typeof i) r.totals.hasOwnProperty(_n) || (r.totals[_n] = 0), r.totals[_n] = r.totals[_n] + i * e;else {
	            var o = void 0;
	            _n in r.totals ? o = r.totals[_n] : r.totals[_n] = 0, r.totals[_n] = ze(function () {
	              return Zu(a.totals[_n], fl(i, e));
	            }), null != o && o.dispose();
	          }
	        }, r = this, t) {
	          n(i);
	        }

	        return [2];
	      });
	    });
	  }, t.prototype.onEpochEnd = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      var e,
	          n,
	          r,
	          i,
	          a,
	          o = this;
	      return __generator(this, function (s) {
	        if (null != t) for (e = function e(_e) {
	          if (null == n.totals[_e]) return "continue";
	          "number" == typeof n.totals[_e] ? t[_e] = n.totals[_e] / n.seen : ze(function () {
	            t[_e] = fl(rl(1, o.seen), o.totals[_e]), o.totals[_e].dispose(), Ge(t[_e]);
	          });
	        }, n = this, r = 0, i = this.params.metrics; r < i.length; r++) {
	          a = i[r], e(a);
	        }
	        return [2];
	      });
	    });
	  }, t;
	}(BaseCallback),
	    History = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.onTrainBegin = function (e) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (e) {
	        return this.epoch = [], this.history = {}, [2];
	      });
	    });
	  }, t.prototype.onEpochEnd = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      var n;
	      return __generator(this, function (r) {
	        for (n in null == t && (t = {}), this.epoch.push(e), t) {
	          null == this.history[n] && (this.history[n] = []), this.history[n].push(t[n]);
	        }

	        return [2];
	      });
	    });
	  }, t.prototype.syncData = function () {
	    return __awaiter(this, void 0, void 0, function () {
	      var e, t, n, r, i, a, o, s, l;
	      return __generator(this, function (u) {
	        switch (u.label) {
	          case 0:
	            for (r in e = [], t = [], n = [], this.history) {
	              for (i = this.history[r], a = 0; a < i.length; ++a) {
	                "number" != typeof i[a] && (o = i[a], e.push(o.data()), t.push(r), n.push(a));
	              }
	            }

	            return [4, Promise.all(e)];

	          case 1:
	            for (s = u.sent(), l = 0; l < s.length; ++l) {
	              this.history[t[l]][n[l]].dispose(), this.history[t[l]][n[l]] = s[l][0];
	            }

	            return [2];
	        }
	      });
	    });
	  }, t;
	}(BaseCallback),
	    CustomCallback = function (e) {
	  function t(t, n) {
	    var r = e.call(this) || this;
	    if (r.currentEpoch = 0, r.yieldEvery = n || "auto", "auto" === r.yieldEvery && (r.yieldEvery = DEFAULT_YIELD_EVERY_MS), "never" === r.yieldEvery && null != t.onYield) throw new Error("yieldEvery is `never` but you provided an `onYield` callback. Either change `yieldEvery` or remove the callback");
	    return Q.isNumber(r.yieldEvery) && (r.maybeWait = debounce(r.maybeWait.bind(r), r.yieldEvery)), r.trainBegin = t.onTrainBegin, r.trainEnd = t.onTrainEnd, r.epochBegin = t.onEpochBegin, r.epochEnd = t.onEpochEnd, r.batchBegin = t.onBatchBegin, r.batchEnd = t.onBatchEnd, r["yield"] = t.onYield, r;
	  }

	  return __extends(t, e), t.prototype.maybeWait = function (e, t, n) {
	    return __awaiter(this, void 0, void 0, function () {
	      var r;
	      return __generator(this, function (i) {
	        switch (i.label) {
	          case 0:
	            return r = [], null == this["yield"] ? [3, 2] : [4, resolveScalarsInLogs(n)];

	          case 1:
	            i.sent(), r.push(this["yield"](e, t, n)), i.label = 2;

	          case 2:
	            return r.push(rf()), [4, Promise.all(r)];

	          case 3:
	            return i.sent(), [2];
	        }
	      });
	    });
	  }, t.prototype.onEpochBegin = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (n) {
	        switch (n.label) {
	          case 0:
	            return this.currentEpoch = e, null == this.epochBegin ? [3, 3] : [4, resolveScalarsInLogs(t)];

	          case 1:
	            return n.sent(), [4, this.epochBegin(e, t)];

	          case 2:
	            n.sent(), n.label = 3;

	          case 3:
	            return [2];
	        }
	      });
	    });
	  }, t.prototype.onEpochEnd = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      var n;
	      return __generator(this, function (r) {
	        switch (r.label) {
	          case 0:
	            return n = [], null == this.epochEnd ? [3, 2] : [4, resolveScalarsInLogs(t)];

	          case 1:
	            r.sent(), n.push(this.epochEnd(e, t)), r.label = 2;

	          case 2:
	            return "epoch" === this.yieldEvery && n.push(rf()), [4, Promise.all(n)];

	          case 3:
	            return r.sent(), [2];
	        }
	      });
	    });
	  }, t.prototype.onBatchBegin = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (n) {
	        switch (n.label) {
	          case 0:
	            return null == this.batchBegin ? [3, 3] : [4, resolveScalarsInLogs(t)];

	          case 1:
	            return n.sent(), [4, this.batchBegin(e, t)];

	          case 2:
	            n.sent(), n.label = 3;

	          case 3:
	            return [2];
	        }
	      });
	    });
	  }, t.prototype.onBatchEnd = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      var n;
	      return __generator(this, function (r) {
	        switch (r.label) {
	          case 0:
	            return n = [], null == this.batchEnd ? [3, 2] : [4, resolveScalarsInLogs(t)];

	          case 1:
	            r.sent(), n.push(this.batchEnd(e, t)), r.label = 2;

	          case 2:
	            return "batch" === this.yieldEvery ? n.push(rf()) : Q.isNumber(this.yieldEvery) && n.push(this.maybeWait(this.currentEpoch, e, t)), [4, Promise.all(n)];

	          case 3:
	            return r.sent(), [2];
	        }
	      });
	    });
	  }, t.prototype.onTrainBegin = function (e) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (t) {
	        switch (t.label) {
	          case 0:
	            return null == this.trainBegin ? [3, 3] : [4, resolveScalarsInLogs(e)];

	          case 1:
	            return t.sent(), [4, this.trainBegin(e)];

	          case 2:
	            t.sent(), t.label = 3;

	          case 3:
	            return [2];
	        }
	      });
	    });
	  }, t.prototype.onTrainEnd = function (e) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (t) {
	        switch (t.label) {
	          case 0:
	            return null == this.trainEnd ? [3, 3] : [4, resolveScalarsInLogs(e)];

	          case 1:
	            return t.sent(), [4, this.trainEnd(e)];

	          case 2:
	            t.sent(), t.label = 3;

	          case 3:
	            return [2];
	        }
	      });
	    });
	  }, t;
	}(BaseCallback);

	function standardizeCallbacks(e, t) {
	  return null == e && (e = {}), e instanceof BaseCallback ? [e] : Array.isArray(e) && e[0] instanceof BaseCallback ? e : toList(e).map(function (e) {
	    return new CustomCallback(e, t);
	  });
	}

	var CallbackConstructorRegistry = function () {
	  function e() {}

	  return e.registerCallbackConstructor = function (t, n) {
	    Q.assert(t >= 0 && Number.isInteger(t), function () {
	      return "Verbosity level is expected to be an integer >= 0, but got " + t;
	    }), e.checkForDuplicate(n), null == e.constructors[t] && (e.constructors[t] = []), e.constructors[t].push(n);
	  }, e.checkForDuplicate = function (t) {
	    for (var n in e.constructors) {
	      e.constructors[+n].forEach(function (e) {
	        if (e === t) throw new ValueError("Duplicate callback constructor.");
	      });
	    }
	  }, e.clear = function () {
	    e.constructors = {};
	  }, e.createCallbacks = function (t) {
	    var n = [];

	    for (var r in e.constructors) {
	      var i = +r;
	      t >= i && n.push.apply(n, e.constructors[i]);
	    }

	    return n.map(function (e) {
	      return new e();
	    });
	  }, e.constructors = {}, e;
	}();

	function configureCallbacks(e, t, n, r, i, a, o, s, l) {
	  var u = new History(),
	      c = [new BaseLogger()].concat(CallbackConstructorRegistry.createCallbacks(t));
	  null != e && c.push.apply(c, e), c.push(u);
	  var p = new CallbackList(c);
	  return p.setParams({
	    epochs: n,
	    initialEpoch: r,
	    samples: i,
	    steps: a,
	    batchSize: o,
	    verbose: t,
	    doValidation: s,
	    metrics: l
	  }), {
	    callbackList: p,
	    history: u
	  };
	}

	function deserialize(e, t, n) {
	  return void 0 === t && (t = {}), void 0 === n && (n = !1), deserializeKerasObject(e, Ph.SerializationMap.getMap().classNameMap, t, "layer", n);
	}

	function l2Normalize(e, t) {
	  return ze(function () {
	    "float32" !== e.dtype && (e = e.asType("float32"));
	    var n = Wu(square(e), t, !0),
	        r = Dn(n.shape, epsilon()),
	        i = Ms(il(n, r));
	    return rl(e, i);
	  });
	}

	function meanSquaredError(e, t) {
	  return ze(function () {
	    return Bu(square(yl(t, e)), -1);
	  });
	}

	function meanAbsoluteError(e, t) {
	  return ze(function () {
	    return Bu(as(yl(t, e)), -1);
	  });
	}

	function meanAbsolutePercentageError(e, t) {
	  return ze(function () {
	    var n = yl(e, t),
	        r = ps(as(e), epsilon(), Number.MAX_VALUE),
	        i = as(rl(n, r));
	    return fl(100, Bu(i, -1));
	  });
	}

	function meanSquaredLogarithmicError(e, t) {
	  return ze(function () {
	    var n = ps(t, epsilon(), Number.MAX_VALUE),
	        r = bs(Zu(1, n)),
	        i = ps(e, epsilon(), Number.MAX_VALUE),
	        a = bs(Zu(1, i));
	    return Bu(square(yl(r, a)), -1);
	  });
	}

	function squaredHinge(e, t) {
	  return ze(function () {
	    var n = il(0, yl(1, fl(e, t)));
	    return Bu(square(n), -1);
	  });
	}

	function hinge(e, t) {
	  return ze(function () {
	    var n = il(0, yl(1, fl(e, t)));
	    return Bu(n, -1);
	  });
	}

	function categoricalHinge(e, t) {
	  return ze(function () {
	    var n = Wu(fl(e, t), -1),
	        r = Mu(fl(yl(1, e), t), -1);
	    return il(0, Zu(1, yl(r, n)));
	  });
	}

	function logcosh(e, t) {
	  return ze(function () {
	    var n = Math.log(2),
	        r = yl(t, e),
	        i = yl(Zu(r, Fs(fl(-2, r))), n);
	    return Bu(i, -1);
	  });
	}

	function categoricalCrossentropy(e, t, n) {
	  return void 0 === n && (n = !1), ze(function () {
	    if (n) t = Kr(t);else {
	      var r = Wu(t, t.shape.length - 1, !0);
	      t = rl(t, r);
	    }
	    return t = ps(t, epsilon(), 1 - epsilon()), Es(Wu(fl(e.toFloat(), bs(t)), t.shape.length - 1));
	  });
	}

	function sparseCategoricalCrossentropy(e, t) {
	  return ze(function () {
	    var n = xs(flatten(e)).toInt(),
	        r = (t = ps(t, epsilon(), 1 - epsilon())).shape;
	    return categoricalCrossentropy(lr(n, r[r.length - 1]).reshape(r), t, !1);
	  });
	}

	function sigmoidCrossEntropyWithLogits(e, t) {
	  if (!Q.arraysEqual(e.shape, t.shape)) throw new ValueError("logits and labels must have the same shape, but got shapes " + JSON.stringify(e.shape) + " and " + JSON.stringify(t.shape));
	  return ze(function () {
	    var n = t.relu(),
	        r = t.abs().neg();
	    return n.sub(t.mul(e)).add(r.exp().log1p());
	  });
	}

	function binaryCrossentropy(e, t) {
	  return ze(function () {
	    var n;
	    return n = ps(t, epsilon(), 1 - epsilon()), n = bs(rl(n, yl(1, n))), Bu(sigmoidCrossEntropyWithLogits(e, n), -1);
	  });
	}

	function kullbackLeiblerDivergence(e, t) {
	  return ze(function () {
	    var n = ps(e, epsilon(), 1),
	        r = ps(t, epsilon(), 1);
	    return Wu(fl(e, bs(rl(n, r))), -1);
	  });
	}

	function poisson(e, t) {
	  return ze(function () {
	    var n = bs(Zu(epsilon(), t));
	    return Bu(yl(t, fl(e, n)), -1);
	  });
	}

	function cosineProximity(e, t) {
	  return ze(function () {
	    var n = l2Normalize(e, -1),
	        r = l2Normalize(t, -1),
	        i = fl(n, r);
	    return Es(Wu(i, -1));
	  });
	}

	var lossesMap = {
	  meanSquaredError: meanSquaredError,
	  meanAbsoluteError: meanAbsoluteError,
	  meanAbsolutePercentageError: meanAbsolutePercentageError,
	  meanSquaredLogarithmicError: meanSquaredLogarithmicError,
	  squaredHinge: squaredHinge,
	  hinge: hinge,
	  categoricalHinge: categoricalHinge,
	  logcosh: logcosh,
	  categoricalCrossentropy: categoricalCrossentropy,
	  sparseCategoricalCrossentropy: sparseCategoricalCrossentropy,
	  binaryCrossentropy: binaryCrossentropy,
	  kullbackLeiblerDivergence: kullbackLeiblerDivergence,
	  poisson: poisson,
	  cosineProximity: cosineProximity
	};

	function get(e) {
	  if ("string" == typeof e) {
	    if (e in lossesMap) return lossesMap[e];
	    var t = "Unknown loss " + e;
	    throw e.toLowerCase().includes("softmaxcrossentropy") && (t = "Unknown loss " + e + '. Use "categoricalCrossentropy" as the string name for tf.losses.softmaxCrossEntropy'), new ValueError(t);
	  }

	  return e;
	}

	function binaryAccuracy(e, t) {
	  return ze(function () {
	    var n = fl(.5, Fn(t)),
	        r = cast$1(Gu(t, n), e.dtype);
	    return Bu(zu(e, r), -1);
	  });
	}

	function categoricalAccuracy(e, t) {
	  return ze(function () {
	    return cast$1(zu(_u(e, -1), _u(t, -1)), "float32");
	  });
	}

	function truePositives(e, t) {
	  return ze(function () {
	    return bl(e.equal(1), t.equal(1)).sum().cast("float32");
	  });
	}

	function falseNegatives(e, t) {
	  return ze(function () {
	    return bl(e.equal(1), t.equal(0)).sum().cast("float32");
	  });
	}

	function falsePositives(e, t) {
	  return ze(function () {
	    return bl(e.equal(0), t.equal(1)).sum().cast("float32");
	  });
	}

	function precision(e, t) {
	  return ze(function () {
	    var n = truePositives(e, t),
	        r = falsePositives(e, t),
	        i = n.add(r);
	    return Rl(Gu(i, 0), n.div(i), 0).cast("float32");
	  });
	}

	function recall(e, t) {
	  return ze(function () {
	    var n = truePositives(e, t),
	        r = falseNegatives(e, t),
	        i = n.add(r);
	    return Rl(Gu(i, 0), n.div(i), 0).cast("float32");
	  });
	}

	function binaryCrossentropy$1(e, t) {
	  return binaryCrossentropy(e, t);
	}

	function sparseCategoricalAccuracy(e, t) {
	  return e.rank === t.rank && (e = e.squeeze([e.rank - 1])), (t = t.argMax(-1)).dtype !== e.dtype && (t = t.asType(e.dtype)), zu(e, t).asType("float32");
	}

	var mse$1 = meanSquaredError,
	    MSE$1 = meanSquaredError,
	    mae$1 = meanAbsoluteError,
	    MAE$1 = meanAbsoluteError,
	    mape$1 = meanAbsolutePercentageError,
	    MAPE$1 = meanAbsolutePercentageError,
	    categoricalCrossentropy$1 = categoricalCrossentropy,
	    cosine$1 = cosineProximity,
	    sparseCategoricalCrossentropy$1 = sparseCategoricalCrossentropy,
	    metricsMap = {
	  binaryAccuracy: binaryAccuracy,
	  categoricalAccuracy: categoricalAccuracy,
	  precision: precision,
	  categoricalCrossentropy: categoricalCrossentropy$1,
	  sparseCategoricalCrossentropy: sparseCategoricalCrossentropy$1,
	  mse: mse$1,
	  MSE: MSE$1,
	  mae: mae$1,
	  MAE: MAE$1,
	  mape: mape$1,
	  MAPE: MAPE$1,
	  cosine: cosine$1
	};

	function get$1(e) {
	  if ("string" == typeof e && e in metricsMap) return metricsMap[e];
	  if ("string" != typeof e && null != e) return e;
	  throw new ValueError("Unknown metric " + e);
	}

	function getLossOrMetricName(e) {
	  if (assert(null !== e, "Unknown LossOrMetricFn " + e), "string" == typeof e) return e;

	  for (var t = void 0, n = 0, r = Object.keys(lossesMap); n < r.length; n++) {
	    var i = r[n];

	    if (lossesMap[i] === e) {
	      t = i;
	      break;
	    }
	  }

	  if (void 0 !== t) return t;

	  for (var a = 0, o = Object.keys(metricsMap); a < o.length; a++) {
	    i = o[a];

	    if (metricsMap[i] === e) {
	      t = i;
	      break;
	    }
	  }

	  return void 0 !== t ? t : e.name;
	}

	function getOptimizer(e) {
	  var t = {
	    Adagrad: function Adagrad() {
	      return ef.adagrad(.01);
	    },
	    Adadelta: function Adadelta() {
	      return ef.adadelta(1, .95, epsilon());
	    },
	    Adam: function Adam() {
	      return ef.adam(.001, .9, .999, epsilon());
	    },
	    Adamax: function Adamax() {
	      return ef.adamax(.002, .9, .999, epsilon(), 0);
	    },
	    RMSProp: function RMSProp() {
	      return ef.rmsprop(.001, .9, 0, epsilon());
	    },
	    SGD: function SGD() {
	      return ef.sgd(.01);
	    }
	  };
	  if (t.adagrad = t.Adagrad, t.adadelta = t.Adadelta, t.adam = t.Adam, t.adamax = t.Adamax, t.rmsprop = t.RMSProp, t.sgd = t.SGD, e in t) return t[e]();
	  throw new ValueError("Unknown Optimizer " + e);
	}

	function printSummary(e, t, n, r) {
	  void 0 === r && (r = console.log);
	  var i,
	      a = isModelSequentialLike(e),
	      o = ["Layer (type)", "Output shape", "Param #"];
	  if (a ? (t = t || 65, n = n || [.45, .85, 1]) : (t = t || 98, n = n || [.33, .55, .67, 1]), n[n.length - 1] <= 1 && (n = n.map(function (e) {
	    return Math.floor(t * e);
	  })), !a) for (var s in o.push("Receives inputs"), i = [], e.nodesByDepth) {
	    i.push.apply(i, e.nodesByDepth[s]);
	  }
	  r("_".repeat(t)), printRow(o, n, r), r("=".repeat(t));

	  for (var l = e.layers, u = 0; u < l.length; ++u) {
	    a ? printLayerSummary(l[u], n, r) : printLayerSummaryWithConnections(l[u], n, i, r), r((u === l.length - 1 ? "=" : "_").repeat(t));
	  }

	  e.checkTrainableWeightsConsistency();
	  var c = countTrainableParams(e),
	      p = countParamsInWeights(e.nonTrainableWeights);
	  r("Total params: " + (c + p)), r("Trainable params: " + c), r("Non-trainable params: " + p), r("_".repeat(t));
	}

	function countTrainableParams(e) {
	  return null != e.collectedTrainableWeights ? countParamsInWeights(e.collectedTrainableWeights) : countParamsInWeights(e.trainableWeights);
	}

	function isModelSequentialLike(e) {
	  var t = !0,
	      n = [],
	      r = [];

	  for (var i in e.nodesByDepth) {
	    n.push(e.nodesByDepth[i]);
	  }

	  for (var a = 0, o = n; a < o.length; a++) {
	    var s = o[a];

	    if (s.length > 1 || 1 === s.length && s[0].inboundLayers.length > 1) {
	      t = !1;
	      break;
	    }

	    r.push.apply(r, s);
	  }

	  if (t) for (var l = 0, u = e.layers; l < u.length; l++) {
	    for (var c = !1, p = 0, h = u[l].inboundNodes; p < h.length; p++) {
	      var d = h[p];

	      if (-1 !== r.indexOf(d)) {
	        if (c) {
	          t = !1;
	          break;
	        }

	        c = !0;
	      }
	    }

	    if (!t) break;
	  }
	  return t;
	}

	function printRow(e, t, n) {
	  void 0 === n && (n = console.log);

	  for (var r = "", i = 0; i < e.length; ++i) {
	    i > 0 && (r = r.slice(0, r.length - 1) + " "), r = (r += e[i]).slice(0, t[i]), r += " ".repeat(t[i] - r.length);
	  }

	  n(r);
	}

	function printLayerSummary(e, t, n) {
	  var r;

	  try {
	    r = JSON.stringify(e.outputShape);
	  } catch (e) {
	    r = "multiple";
	  }

	  printRow([e.name + " (" + e.getClassName() + ")", r, e.countParams().toString()], t, n);
	}

	function printLayerSummaryWithConnections(e, t, n, r) {
	  var i;

	  try {
	    i = JSON.stringify(e.outputShape);
	  } catch (e) {
	    i = "multiple";
	  }

	  for (var a = [], o = 0, s = e.inboundNodes; o < s.length; o++) {
	    var l = s[o];
	    if (!(null != n && n.length > 0 && -1 === n.indexOf(l))) for (var u = 0; u < l.inboundLayers.length; ++u) {
	      var c = l.inboundLayers[u].name,
	          p = l.nodeIndices[u],
	          h = l.tensorIndices[u];
	      a.push(c + "[" + p + "][" + h + "]");
	    }
	  }

	  var d = e.name,
	      f = e.getClassName(),
	      g = 0 === a.length ? "" : a[0];
	  printRow([d + " (" + f + ")", i, e.countParams().toString(), g], t, r);

	  for (u = 1; u < a.length; ++u) {
	    printRow(["", "", "", a[u]], t, r);
	  }
	}

	function isArrayItemInputOrOutputName(e, t, n) {
	  return ("inboundNodes" === e || "outputLayers" === e || "inputLayers" === e) && 0 === t && "string" == typeof n;
	}

	function convertPythonicToTs(e, t) {
	  if (null === e) return null;
	  if ("string" == typeof e) return toCamelCase(e);
	  if ("number" == typeof e || "boolean" == typeof e) return e;

	  if (e instanceof Array) {
	    for (var n = [], r = e.length, i = 0; i < r; ++i) {
	      var a = e[i];
	      isArrayItemInputOrOutputName(t, i, a) ? n.push(a) : n.push(convertPythonicToTs(a, t));
	    }

	    return n;
	  }

	  for (var o = {}, s = 0, l = Object.keys(e); s < l.length; s++) {
	    var u = l[s],
	        c = e[u];
	    if ("name" === u && "string" == typeof c) o[u] = c;else {
	      var p = toCamelCase(u);
	      o[p] = convertPythonicToTs(c, p);
	    }
	  }

	  return o;
	}

	function convertTsToPythonic(e, t) {
	  if (null === e || void 0 === e) return null;
	  if ("string" == typeof e) return toSnakeCase(e);
	  if ("number" == typeof e || "boolean" == typeof e) return e;

	  if (e instanceof Array) {
	    for (var n = [], r = e.length, i = 0; i < r; ++i) {
	      var a = e[i];
	      isArrayItemInputOrOutputName(t, i, a) ? n.push(a) : n.push(convertTsToPythonic(a, t));
	    }

	    return n;
	  }

	  for (var o = {}, s = 0, l = Object.keys(e); s < l.length; s++) {
	    var u = l[s],
	        c = e[u],
	        p = toSnakeCase(u);
	    o[p] = "name" !== u && "className" !== u || "string" != typeof c ? convertTsToPythonic(c, u) : c;
	  }

	  return o;
	}

	var version$1 = "1.2.7";

	function assertFeedCompatibility(e, t) {
	  if (null == e.dtype || e.dtype === t.dtype) return t;

	  try {
	    return nr(t, e.dtype);
	  } catch (n) {
	    throw new ValueError("The dtype of the feed (" + t.dtype + ") can not be cast to the dtype of the key '" + e.name + "' (" + e.dtype + ").");
	  }
	}

	var FeedDict = function () {
	  function e(t) {
	    if (this.id2Value = {}, this.id2Mask = {}, this.name2Id = {}, t instanceof e) for (var n in t.id2Value) {
	      this.id2Value[n] = t.id2Value[n], n in t.id2Mask && (this.id2Mask[n] = t.id2Mask[n]);
	    } else {
	      if (null == t) return;

	      for (var r = 0, i = t; r < i.length; r++) {
	        var a = i[r];
	        this.add(a.key, a.value);
	      }
	    }
	  }

	  return e.prototype.add = function (e, t, n) {
	    if (null != this.id2Value[e.id]) throw new ValueError("Duplicate key: name=" + e.name + ", id=" + e.id);
	    return this.id2Value[e.id] = assertFeedCompatibility(e, t), this.name2Id[e.name] = e.id, null != n && (this.id2Mask[e.id] = n), this;
	  }, e.prototype.addFeed = function (e) {
	    this.add(e.key, e.value);
	  }, e.prototype.hasKey = function (e) {
	    return null != this.id2Value[e.id];
	  }, e.prototype.names = function () {
	    return Object.keys(this.name2Id);
	  }, e.prototype.getValue = function (e) {
	    if (e instanceof SymbolicTensor) {
	      if (null == this.id2Value[e.id]) throw new ValueError("Nonexistent key: " + e.name);
	      return this.id2Value[e.id];
	    }

	    var t = this.name2Id[e];
	    if (null == t) throw new ValueError("Feed dict has no SymbolicTensor name: " + e);
	    return this.id2Value[t];
	  }, e.prototype.getMask = function (e) {
	    if (e instanceof SymbolicTensor) {
	      if (null == this.id2Value[e.id]) throw new ValueError("Nonexistent key: " + e.name);
	      return this.id2Mask[e.id];
	    }

	    var t = this.name2Id[e];
	    if (null == t) throw new ValueError("Feed dict has no SymbolicTensor name: " + e);
	    return this.id2Mask[t];
	  }, e.prototype.disposeMasks = function () {
	    null != this.id2Mask && Ve(this.id2Mask);
	  }, e;
	}(),
	    cachedSorted = {},
	    cachedRecipientCounts = {};

	function execute(e, t, n, r) {
	  for (var i = null != n && n.training, a = Array.isArray(e), o = a ? e : [e], s = o.map(function (e) {
	    return e.name;
	  }), l = [], u = t.names(), c = 0, p = s; c < p.length; c++) {
	    var h = p[c];
	    -1 !== u.indexOf(h) ? l.push(t.getValue(h)) : l.push(null);
	  }

	  null != r && (r.maxNumTensors = -1 / 0, r.minNumTensors = 1 / 0);
	  var d,
	      f,
	      g = s.join(",") + "|" + t.names().join(",");

	  if (null == cachedSorted[g]) {
	    var m = getTopologicalSortAndRecipientCounts(o, t);
	    d = m.sorted, f = m.recipientCounts, cachedSorted[g] = d, cachedRecipientCounts[g] = f;
	  }

	  d = cachedSorted[g], f = {}, i || Object.assign(f, cachedRecipientCounts[g]);

	  for (var y = new FeedDict(t), v = 0; v < d.length; ++v) {
	    if (null != r) {
	      var b = We().numTensors;
	      b > r.maxNumTensors && (r.maxNumTensors = b), b < r.minNumTensors && (r.minNumTensors = b);
	    }

	    var w = d[v],
	        z = w.sourceLayer;

	    if (!(z instanceof InputLayer)) {
	      for (var S = [], A = [], _ = [], C = !1, I = 0, E = w.inputs; I < E.length; I++) {
	        var N = E[I],
	            k = y.getValue(N),
	            L = y.getMask(N);
	        S.push(k), A.push(L), null != L && (C = !0), i || (f[N.name]--, 0 !== f[N.name] || t.hasKey(N) || -1 !== s.indexOf(N.name) || k.isDisposed || !0 === N.sourceLayer.stateful || _.push(k));
	      }

	      C && ((n = n || {}).mask = A[0]);
	      var x = toList(z.apply(S, n)),
	          T = null;
	      z.supportsMasking && (T = z.computeMask(S, A));

	      for (var D = getNodeOutputs(w), O = Array.isArray(D) ? D : [D], R = 0; R < O.length; ++R) {
	        y.hasKey(O[R]) || y.add(O[R], x[R], Array.isArray(T) ? T[0] : T);
	        var M = s.indexOf(O[R].name);
	        -1 !== M && (l[M] = x[R]);
	      }

	      i || Ve(_);
	    }
	  }

	  return y.disposeMasks(), a ? l : l[0];
	}

	function getTopologicalSortAndRecipientCounts(e, t) {
	  Q.assert(null != e && e.length > 0, function () {
	    return "Expected at least one fetch, got none";
	  });
	  var n = [],
	      r = {};

	  if (1 === e.length) {
	    var i = getTopologicalSortAndRecipientCountsForOneFetch(e[0], t);
	    n = i.sorted, r = i.recipientMap;
	  } else for (var a = new Set(), o = 0, s = e; o < s.length; o++) {
	    for (var l = getTopologicalSortAndRecipientCountsForOneFetch(s[o], t), u = l.sorted, c = l.recipientMap, p = 0, h = u; p < h.length; p++) {
	      var d = h[p];
	      a.has(d.name) || (n.push(d), a.add(d.name));
	    }

	    var f = function f(e) {
	      null == r[e] && (r[e] = new Set()), c[e].forEach(function (t) {
	        return r[e].add(t);
	      });
	    };

	    for (var g in c) {
	      f(g);
	    }
	  }

	  return {
	    sorted: n,
	    recipientCounts: recipientMap2Counts(r)
	  };
	}

	function recipientMap2Counts(e) {
	  var t = {};

	  for (var n in e) {
	    t[n] = e[n].size;
	  }

	  return t;
	}

	function getTopologicalSortAndRecipientCountsForOneFetch(e, t) {
	  for (var n = new Set(), r = [], i = {}, a = 0, o = t.names(); a < o.length; a++) {
	    var s = o[a];
	    n.add(s);
	  }

	  var l = [],
	      u = [];

	  for (l.push(e); l.length > 0;) {
	    var c = l[l.length - 1];
	    if (n.has(c.name)) l.pop();else {
	      var p = u[u.length - 1] === l.length - 1;
	      if (0 === c.inputs.length || p) l.pop(), r.push(c), n.add(c.name), p && u.pop();else {
	        u.push(l.length - 1);

	        for (var h = 0, d = c.inputs; h < d.length; h++) {
	          var f = d[h];
	          null == i[f.name] && (i[f.name] = new Set()), i[f.name].add(c.name), n.has(f.name) || l.push(f);
	        }
	      }
	    }
	  }

	  return {
	    sorted: r,
	    recipientMap: i
	  };
	}

	function getNodeOutputs(e) {
	  var t;
	  if (1 === e.sourceLayer.inboundNodes.length) t = e.sourceLayer.output;else {
	    for (var n = null, r = 0; r < e.sourceLayer.inboundNodes.length; ++r) {
	      for (var i = 0, a = e.sourceLayer.inboundNodes[r].outputTensors; i < a.length; i++) {
	        if (a[i].id === e.id) {
	          n = r;
	          break;
	        }
	      }
	    }

	    t = e.sourceLayer.getOutputAt(n);
	  }
	  return t;
	}

	var Container = function (e) {
	  function t(n) {
	    var r = e.call(this, {}) || this;

	    if (r.containerNodes = new Set(), r.name = n.name, null == r.name) {
	      var i = r.getClassName().toLowerCase();
	      r.name = getUid(i);
	    }

	    if (r.supportsMasking = !1, r.trainable_ = !0, Array.isArray(n.inputs) ? r.inputs = n.inputs.slice() : r.inputs = [n.inputs], Array.isArray(n.outputs) ? r.outputs = n.outputs.slice() : r.outputs = [n.outputs], unique(r.inputs).length !== r.inputs.length) throw new ValueError("The list of inputs passed to the model is redundant. All inputs should only appear once. Found: " + r.inputs.map(function (e) {
	      return e.name;
	    }));
	    unique(r.outputs).length !== r.outputs.length && console.warn("The list of outputs passed to the model is redundant. All outputs should only appear once. Found: " + r.outputs.map(function (e) {
	      return e.name;
	    })), r.inputLayers = [], r.inputLayersNodeIndices = [], r.inputLayersTensorIndices = [], r.outputLayers = [], r.outputLayersNodeIndices = [], r.outputLayersTensorIndices = [], r.layers = [];

	    for (var a = 0, o = r.outputs; a < o.length; a++) {
	      var s = (I = o[a]).sourceLayer,
	          l = I.nodeIndex,
	          u = I.tensorIndex;
	      r.outputLayers.push(s), r.outputLayersNodeIndices.push(l), r.outputLayersTensorIndices.push(u);
	    }

	    for (var c = 0, p = r.inputs; c < p.length; c++) {
	      s = (I = p[c]).sourceLayer, l = I.nodeIndex, u = I.tensorIndex;
	      assert(0 === l, "input layer has >1 nodes"), assert(0 === u, "input layer has >1 tensors"), r.inputLayers.push(s), r.inputLayersNodeIndices.push(l), r.inputLayersTensorIndices.push(u);
	    }

	    r.inputNames = [], r.outputNames = [], r.feedInputShapes = [], r.feedInputNames = [], r.feedOutputNames = [];

	    for (var h = 0; h < r.inputLayers.length; h++) {
	      if (!((s = r.inputLayers[h]) instanceof InputLayer)) throw new TypeError("Input layers to a LayersModel must be InputLayer objects. Received inputs: " + n.inputs + ". Input " + h + " (0-based) originates from layer type " + s.getClassName() + ".");
	      r.inputNames.push(s.name), r.feedInputShapes.push(s.batchInputShape), r.feedInputNames.push(s.name);
	    }

	    for (var d = 0, f = r.outputLayers; d < f.length; d++) {
	      s = f[d];
	      r.outputNames.push(s.name);
	    }

	    r.internalInputShapes = r.inputs.map(function (e) {
	      return e.shape;
	    }), r.internalOutputShapes = r.outputs.map(function (e) {
	      return e.shape;
	    });

	    for (var g = {}, m = {}, y = {}, v = {}, b = {}, w = [], z = function z(e, n, i, a, o, s) {
	      null != a && null != o && null != s || (a = e.sourceLayer, o = e.nodeIndex, s = e.tensorIndex);
	      var l = a.inboundNodes[o];
	      if (-1 !== i.indexOf(l)) throw new RuntimeError("The tensor " + e.name + ' at layer "' + a.name + '" is part of a cycle.');

	      if (-1 === n.indexOf(l)) {
	        r.containerNodes.add(t.nodeKey(a, o)), (a.id in b) || (b[a.id] = Object.keys(b).length), -1 === i.indexOf(l) && i.push(l);

	        for (var u = l.inboundLayers.length, c = 0; c < u; c++) {
	          var p = l.inputTensors[c],
	              h = l.inboundLayers[c],
	              d = l.nodeIndices[c],
	              f = l.tensorIndices[c];
	          z(p, n, i, h, d, f);
	        }

	        for (n.push(l); i.indexOf(l) >= 0;) {
	          i.splice(i.indexOf(l), 1);
	        }

	        w.push(l);
	      }
	    }, S = [], A = [], _ = 0, C = r.outputs; _ < C.length; _++) {
	      var I = C[_];
	      z(I, S, A);
	    }

	    for (var E = 0, N = w.slice().reverse(); E < N.length; E++) {
	      m[(K = N[E]).id] = K, K.id in g || (g[K.id] = 0);
	      var k = g[K.id],
	          L = null == y[K.outboundLayer.id] ? 0 : y[K.outboundLayer.id];
	      k = Math.max(k, L), y[K.outboundLayer.id] = k, v[K.outboundLayer.id] = K.outboundLayer, g[K.id] = k;

	      for (h = 0; h < K.inboundLayers.length; h++) {
	        var x = K.inboundLayers[h],
	            T = (l = K.nodeIndices[h], x.inboundNodes[l]),
	            D = null == g[T.id] ? 0 : g[T.id];
	        g[T.id] = Math.max(k + 1, D), m[T.id] = T;
	      }
	    }

	    var O = {};

	    for (var R in g) {
	      (k = g[R]) in O || (O[k] = []), O[k].push(m[R]);
	    }

	    var M = {};

	    for (var P in y) {
	      (k = y[P]) in M || (M[k] = []), M[k].push(v[P]);
	    }

	    var F = Object.keys(M).map(function (e) {
	      return parseInt(e, 10);
	    }).sort(reverseNumberCompare);
	    r.layers = [];

	    for (var V = 0, B = F; V < B.length; V++) {
	      var U = M[k = B[V]];
	      U.sort(function (e, t) {
	        var n = b[e.id],
	            r = b[t.id];
	        return n < r ? -1 : n > r ? 1 : 0;
	      });

	      for (var W = 0, j = U; W < j.length; W++) {
	        s = j[W];
	        r.layers.push(s);
	      }
	    }

	    r.layersByDepth = M, F = Object.keys(O).map(function (e) {
	      return parseInt(e, 10);
	    }).sort(reverseNumberCompare);

	    for (var $ = r.inputs.slice(), q = [], G = 0, H = F; G < H.length; G++) {
	      for (var J = 0, Z = O[k = H[G]]; J < Z.length; J++) {
	        var K;

	        if (null != (s = (K = Z[J]).outboundLayer)) {
	          for (var Y = 0, X = K.inputTensors; Y < X.length; Y++) {
	            I = X[Y];
	            if (-1 === $.indexOf(I)) throw new RuntimeError("Graph disconnected: cannot obtain value for tensor " + I + ' at layer "' + s.name + '". The following previous layers were accessed without issue: ' + q);
	          }

	          for (var Q = 0, ee = K.outputTensors; Q < ee.length; Q++) {
	            I = ee[Q];
	            $.push(I);
	          }

	          q.push(s.name);
	        }
	      }
	    }

	    r.nodesByDepth = O;

	    for (var te = r.layers.map(function (e) {
	      return e.name;
	    }), ne = function ne(e) {
	      var t = te.filter(function (t) {
	        return t === e;
	      }).length;
	      if (1 !== t) throw new RuntimeError('The name "' + e + '" is used ' + t + " times in the model. All layer names should be unique. Layer names: " + JSON.stringify(te));
	    }, re = 0, ie = te; re < ie.length; re++) {
	      ne(ie[re]);
	    }

	    return r.outboundNodes = [], r.inboundNodes = [], new Node({
	      outboundLayer: r,
	      inboundLayers: [],
	      nodeIndices: [],
	      tensorIndices: [],
	      inputTensors: r.inputs,
	      outputTensors: r.outputs,
	      inputMasks: r.inputs.map(function (e) {
	        return null;
	      }),
	      outputMasks: r.outputs.map(function (e) {
	        return null;
	      }),
	      inputShapes: r.inputs.map(function (e) {
	        return e.shape;
	      }),
	      outputShapes: r.outputs.map(function (e) {
	        return e.shape;
	      })
	    }), r.built = !0, r._refCount = 1, r;
	  }

	  return __extends(t, e), t.prototype.assertNotDisposed = function () {
	    if (0 === this._refCount) throw new Error("Container '" + this.name + "' is already disposed.");
	  }, t.prototype.dispose = function () {
	    this.assertNotDisposed();
	    var e = {
	      refCountAfterDispose: null,
	      numDisposedVariables: 0
	    };
	    if (0 == --this._refCount) for (var t = 0, n = this.layers; t < n.length; t++) {
	      var r = n[t];
	      e.numDisposedVariables += r.dispose().numDisposedVariables;
	    }
	    return e.refCountAfterDispose = this._refCount, e;
	  }, Object.defineProperty(t.prototype, "trainable", {
	    get: function get() {
	      return this.trainable_;
	    },
	    set: function set(e) {
	      this.layers.forEach(function (t) {
	        t._trainableWeights.forEach(function (t) {
	          return t.trainable = e;
	        });
	      }), this.trainable_ = e;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "trainableWeights", {
	    get: function get() {
	      if (this._trainableWeights.length > 0) throw new ValueError("Container instance unexpectedly contains _trainableWeights.The trainable weights of a Container are a union of the trainable weights of its consituent Layers. Its own _trainableWeights must remain an empty Array.");
	      if (!this.trainable) return [];

	      for (var e = [], t = 0, n = this.layers; t < n.length; t++) {
	        var r = n[t];
	        e = e.concat(r.trainableWeights);
	      }

	      return e;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "nonTrainableWeights", {
	    get: function get() {
	      for (var e = [], t = 0, n = this.layers; t < n.length; t++) {
	        var r = n[t];
	        e.push.apply(e, r.nonTrainableWeights);
	      }

	      if (!this.trainable) {
	        for (var i = [], a = 0, o = this.layers; a < o.length; a++) {
	          r = o[a];
	          i.push.apply(i, r.trainableWeights);
	        }

	        return i.concat(e);
	      }

	      return e;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "weights", {
	    get: function get() {
	      return this.trainableWeights.concat(this.nonTrainableWeights);
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.loadWeights = function (e, t) {
	    void 0 === t && (t = !0);

	    for (var n = {}, r = 0, i = 0, a = this.layers; i < a.length; i++) {
	      for (var o = 0, s = a[i].weights; o < s.length; o++) {
	        var l = s[o];
	        if (null != n[l.originalName]) throw new ValueError("Duplicate weight name: " + l.originalName);
	        n[l.originalName] = l, r++;
	      }
	    }

	    var u = [];

	    for (var c in e) {
	      if (null != n[c]) u.push([n[c], e[c]]);else if (t) throw new ValueError("Provided weight data has no target variable: " + c);
	      delete n[c];
	    }

	    if (t) {
	      var p = [];

	      for (var h in n) {
	        p.push(h);
	      }

	      if (p.length > 0) throw new ValueError(p.length + " of " + r + " weights are not set: " + p);
	    }

	    batchSetValue(u);
	  }, t.prototype.updatedConfig = function () {
	    var e = this.getConfig(),
	        t = {};
	    return t.className = this.getClassName(), t.config = e, t.kerasVersion = "tfjs-layers " + version$1, t.backend = "TensorFlow.js", t;
	  }, t.prototype.toJSON = function (e, t) {
	    void 0 === t && (t = !0);
	    var n = convertTsToPythonic(this.updatedConfig());
	    return t ? JSON.stringify(n) : n;
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      e = toList(e);

	      for (var r = new FeedDict(), i = 0; i < n.inputs.length; ++i) {
	        r.add(n.inputs[i], e[i]);
	      }

	      return execute(n.outputs, r, t);
	    });
	  }, t.prototype.computeMask = function (e, t) {
	    var n = this;
	    return ze(function () {
	      var r;
	      return e = toList(e), r = null == t ? pyListRepeat(null, e.length) : toList(t), n.runInternalGraph(e, r)[1];
	    });
	  }, t.prototype.computeOutputShape = function (e) {
	    var t = normalizeShapeList(e);
	    if (t.length !== this.inputLayers.length) throw new ValueError("Invalid inputShape argument " + e + ": model has " + this.inputLayers.length + " tensor inputs.");

	    for (var n = {}, r = 0; r < t.length; r++) {
	      var i = this.inputLayers[r],
	          a = t[r];
	      n[A = i.name + "_0_0"] = a;
	    }

	    var o = Object.keys(this.nodesByDepth).map(function (e) {
	      return parseInt(e, 10);
	    }).sort(reverseNumberCompare);
	    if (o.length > 1) for (var s = 0, l = o; s < l.length; s++) {
	      for (var u = l[s], c = 0, p = this.nodesByDepth[u]; c < p.length; c++) {
	        var h = p[c];
	        i = h.outboundLayer;

	        if (-1 === this.inputLayers.map(function (e) {
	          return e.id;
	        }).indexOf(i.id)) {
	          for (var d = [], f = 0; f < h.inboundLayers.length; f++) {
	            var g = h.inboundLayers[f],
	                m = h.nodeIndices[f],
	                y = h.tensorIndices[f],
	                v = n[A = g.name + "_" + m + "_" + y];
	            d.push(v);
	          }

	          var b = normalizeShapeList(i.computeOutputShape(singletonOrArray(d))),
	              w = i.inboundNodes.indexOf(h);

	          for (f = 0; f < b.length; f++) {
	            n[A = i.name + "_" + w + "_" + f] = b[f];
	          }
	        }
	      }
	    }
	    var z = [],
	        S = [];

	    for (r = 0; r < this.outputLayers.length; r++) {
	      i = this.outputLayers[r], w = this.outputLayersNodeIndices[r], y = this.outputLayersTensorIndices[r];
	      var A = i.name + "_" + w + "_" + y;
	      S.push(A);
	    }

	    for (r = 0; r < S.length; r++) {
	      var _ = S[r];
	      assert(_ in n), z.push(n[_]);
	    }

	    return singletonOrArray(z);
	  }, t.prototype.runInternalGraph = function (e, t) {
	    null == t && (t = pyListRepeat(null, e.length));

	    for (var n = {}, r = 0; r < this.inputs.length; ++r) {
	      var i = this.inputs[r],
	          a = e[r],
	          o = t[r];
	      n[i.id] = [a, o];
	    }

	    for (var s = 0, l = Object.keys(this.nodesByDepth).map(function (e) {
	      return parseInt(e, 10);
	    }).sort(reverseNumberCompare); s < l.length; s++) {
	      for (var u = l[s], c = 0, p = this.nodesByDepth[u]; c < p.length; c++) {
	        for (var h = p[c], d = h.outboundLayer, f = h.inputTensors, g = h.outputTensors, m = new Array(), y = 0, v = f; y < v.length; y++) {
	          (i = v[y]).id in n && m.push(n[i.id]);
	        }

	        if (m.length === f.length) {
	          var b = {},
	              w = void 0,
	              z = void 0,
	              S = void 0,
	              A = void 0;

	          if (null != h.callArgs && (b = h.callArgs), 1 === m.length) {
	            var _ = m[0],
	                C = _[0],
	                I = _[1];
	            null == b.mask && (b.mask = I), S = toList(d.call(C, b)), A = toList(d.computeMask(C, I)), w = [C], z = [I];
	          } else w = m.map(function (e) {
	            return e[0];
	          }), z = m.map(function (e) {
	            return e[1];
	          }), null == b.mask && (b.mask = z), S = toList(d.call(w, b)), A = toList(d.computeMask(w, z));

	          if (d.activityRegularizer) throw new NotImplementedError("LayersModel invocation with concrete Tensor value(s) in the presence of activity regularizer(s) is not supported yet.");

	          for (r = 0; r < g.length; ++r) {
	            i = g[r], a = S[r], o = A[r];
	            n[i.id] = [a, o];
	          }
	        }
	      }
	    }

	    for (var E = [], N = [], k = [], L = 0, x = this.outputs; L < x.length; L++) {
	      assert((i = x[L]).id in n, "Could not compute output " + i.name + " : " + i.id);
	      var T = n[i.id],
	          D = T[0];
	      o = T[1];
	      k.push(D.shape), E.push(D), N.push(o);
	    }

	    return [E, N, k];
	  }, t.prototype.buildNodeConversionMap = function (e) {
	    for (var n, r = {}, i = 0, a = this.layers; i < a.length; i++) {
	      var o = a[i];
	      n = o instanceof t ? 1 : 0;

	      for (var s = 0; s < o.inboundNodes.length; s++) {
	        var l = t.nodeKey(o, s);
	        this.containerNodes.has(l) && (r[l] = n, n += 1);
	      }
	    }

	    return r;
	  }, t.prototype.getLayer = function (e, t) {
	    if (null != t) {
	      if (this.layers.length <= t) throw new ValueError("Was asked to retrieve layer at index " + t + ", but model only has " + this.layers.length + " layer(s).");
	      return this.layers[t];
	    }

	    if (null == e) throw new ValueError("Provide either a layer name or layer index");

	    for (var n = 0, r = this.layers; n < r.length; n++) {
	      var i = r[n];
	      if (i.name === e) return i;
	    }

	    throw new ValueError("No such layer: " + e);
	  }, t.prototype.calculateLosses = function () {
	    var e = this;
	    return ze(function () {
	      for (var n = [], r = 0, i = e.layers; r < i.length; r++) {
	        for (var a = i[r], o = 0; o < a.inboundNodes.length; ++o) {
	          var s = t.nodeKey(a, o);
	          e.containerNodes.has(s) && n.push.apply(n, a.calculateLosses());
	        }
	      }

	      return n;
	    });
	  }, t.prototype.getConfig = function () {
	    for (var e = {
	      name: this.name
	    }, n = this.buildNodeConversionMap(this.layers), r = [], i = 0, a = this.layers; i < a.length; i++) {
	      for (var o = (w = a[i]).getClassName(), s = w.getConfig(), l = [], u = 0; u < w.inboundNodes.length; u++) {
	        var c = w.inboundNodes[u],
	            p = t.nodeKey(w, u),
	            h = {};

	        if (this.containerNodes.has(p)) {
	          if (c.callArgs) try {
	            JSON.stringify(c.callArgs), h = c.callArgs;
	          } catch (e) {
	            console.warn("Layer " + w.name + " was passed non-serializable keyword arguments: " + c.callArgs + ". They will not be included in the serialized model (and thus will be missing at deserialization time)."), h = {};
	          }

	          if (c.inboundLayers.length > 0) {
	            for (var d = [], f = 0; f < c.inboundLayers.length; f++) {
	              var g = c.inboundLayers[f],
	                  m = c.nodeIndices[f],
	                  y = c.tensorIndices[f];
	              null == (S = n[t.nodeKey(g, m)]) && (S = 0), d.push([g.name, S, y, h]);
	            }

	            l.push(d);
	          }
	        }
	      }

	      var v = {};
	      v.name = w.name, v.className = o, v.config = s, v.inboundNodes = l, r.push(v);
	    }

	    e.layers = r;
	    var b = [];

	    for (f = 0; f < this.inputLayers.length; f++) {
	      var w = this.inputLayers[f];
	      m = this.inputLayersNodeIndices[f], p = t.nodeKey(w, m);

	      if (this.containerNodes.has(p)) {
	        null !== (S = n[p]) && void 0 !== S || (S = 0);
	        y = this.inputLayersTensorIndices[f];
	        b.push([w.name, S, y]);
	      }
	    }

	    e.inputLayers = b;
	    var z = [];

	    for (f = 0; f < this.outputLayers.length; f++) {
	      w = this.outputLayers[f], m = this.outputLayersNodeIndices[f], p = t.nodeKey(w, m);

	      if (this.containerNodes.has(p)) {
	        var S;
	        null !== (S = n[p]) && void 0 !== S || (S = 0);
	        y = this.outputLayersTensorIndices[f];
	        z.push([w.name, S, y]);
	      }
	    }

	    return e.outputLayers = z, e;
	  }, t.fromConfig = function (e, t, n, r) {
	    void 0 === n && (n = {}), void 0 === r && (r = !1);
	    var i = {},
	        a = {};

	    function o(e, t) {
	      e.name in a ? a[e.name].push(t) : a[e.name] = [t];
	    }

	    function s(e, t) {
	      for (var n, r = [], a = 0, s = t; a < s.length; a++) {
	        var l = s[a],
	            u = l[0],
	            c = l[1],
	            p = l[2];
	        if (n = null == l[3] ? {} : l[3], !(u in i)) return void o(e, t);
	        var h = i[u];
	        if (h.inboundNodes.length <= c) return void o(e, t);
	        var d = h.inboundNodes[c];
	        r.push(d.outputTensors[p]);
	      }

	      r.length > 0 && e.apply(singletonOrArray(r), n);
	    }

	    function l(e) {
	      var n = e.name,
	          a = deserialize(e, null != t.customObjects ? t.customObjects : {});
	      a.setFastWeightInitDuringBuild(r), i[n] = a, e.inboundNodes.forEach(function (e) {
	        if (!(e instanceof Array)) throw new ValueError("Corrupted configuration, expected array for nodeData: " + e);
	        o(a, e);
	      });
	    }

	    for (var u = t.name, c = t.layers, p = 0, h = c; p < h.length; p++) {
	      l(g = h[p]);
	    }

	    for (; !isObjectEmpty(a);) {
	      for (var d = 0, f = c; d < f.length; d++) {
	        var g = f[d];

	        if ((k = i[g.name]).name in a) {
	          var m = a[k.name];
	          delete a[k.name];

	          for (var y = 0, v = m; y < v.length; y++) {
	            s(k, v[y]);
	          }
	        }
	      }
	    }

	    for (var b = [], w = [], z = 0, S = t.inputLayers; z < S.length; z++) {
	      var A = (g = S[z])[0],
	          _ = g[1],
	          C = g[2];
	      assert(A in i);
	      var I = (k = i[A]).inboundNodes[_].outputTensors;
	      b.push(I[C]);
	    }

	    for (var E = 0, N = t.outputLayers; E < N.length; E++) {
	      A = (g = N[E])[0], _ = g[1], C = g[2];
	      assert(A in i);
	      var k;
	      I = (k = i[A]).inboundNodes[_].outputTensors;
	      w.push(I[C]);
	    }

	    return new e({
	      inputs: b,
	      outputs: w,
	      name: u
	    });
	  }, Object.defineProperty(t.prototype, "stateful", {
	    get: function get() {
	      if (this._stateful) throw new ValueError("Container instance unexpectedly has _stateful = true. The statefulness of a Container is determined by the Layers it contains. Its _stateful property must remain the default false.");

	      for (var e = 0, t = this.layers; e < t.length; e++) {
	        if (t[e].stateful) return !0;
	      }

	      return !1;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.resetStates = function () {
	    var e = this;
	    ze(function () {
	      e.layers.forEach(function (e) {
	        e.stateful && e.resetStates();
	      });
	    });
	  }, t;
	}(Layer);

	function standardizeSampleOrClassWeights(e, t, n) {
	  var r = t.length;
	  if (null == e || Array.isArray(e) && 0 === e.length) return t.map(function (e) {
	    return null;
	  });
	  if (1 === r) return Array.isArray(e) && 1 === e.length ? e : "object" == _typeof_1(e) && t[0] in e ? [e[t[0]]] : [e];

	  if (Array.isArray(e)) {
	    if (e.length !== r) throw new Error("Provided " + n + " is an array of " + e.length + " element(s), but the model has " + r + " outputs. Make sure a set of weights is provided for each model output.");
	    return e;
	  }

	  if ("object" == _typeof_1(e) && Object.keys(e).length > 0 && "object" == _typeof_1(e[Object.keys(e)[0]])) {
	    var i = [];
	    return t.forEach(function (t) {
	      t in e ? i.push(e[t]) : i.push(null);
	    }), i;
	  }

	  throw new Error("The model has multiple (" + r + ") outputs, so " + n + " must be either an array with " + r + " elements or an object with " + t + " keys. Provided " + n + " not understood: " + JSON.stringify(e));
	}

	function standardizeClassWeights(e, t) {
	  return standardizeSampleOrClassWeights(e, t, "classWeight");
	}

	function standardizeWeights(e, t, n, r) {
	  return __awaiter(this, void 0, void 0, function () {
	    var i, a, o, s, l;
	    return __generator(this, function (u) {
	      switch (u.label) {
	        case 0:
	          if (null != t || null != r) throw new Error("Support sampleWeight is not implemented yet");
	          return null == n ? [3, 2] : (i = ze(function () {
	            if (1 === e.shape.length) return e.clone();

	            if (2 === e.shape.length) {
	              if (e.shape[1] > 1) {
	                return e.argMax(1);
	              }

	              if (1 === e.shape[1]) return e.reshape([e.shape[0]]);
	              throw new Error("Encountered unexpected last-dimension size (" + e.shape[1] + ") during handling of class weights. The size is expected to be >= 1.");
	            }

	            throw new Error("Unexpected rank of target (y) tensor (" + e.rank + ") during handling of class weights. The rank is expected to be 1 or 2.");
	          }), s = (o = Array).from, [4, i.data()]);

	        case 1:
	          return a = s.apply(o, [u.sent()]), Ve(i), l = [], a.forEach(function (e) {
	            if (null == n[e]) throw new Error("classWeight must contain all classes in the training data. The class " + e + " exists in the data but not in classWeight");
	            l.push(n[e]);
	          }), [2, En(l, "float32")];

	        case 2:
	          return [2, null];
	      }
	    });
	  });
	}

	function computeWeightedLoss(e, t) {
	  return fl(e, t);
	}

	var DEFAULT_VALIDATION_BATCH_SIZE = 32;

	function standardizeDataIteratorOutput(e, t) {
	  var n,
	      r,
	      i = t;
	  n = i.xs, r = i.ys, Q.assert(null != n && null != r, function () {
	    return "A Dataset iterator for fitDataset() is expected to generate objects of the form `{xs: xVal, ys: yVal}`, where the two values may be `tf.Tensor`, an array of Tensors, or a map of string to Tensor.  The provided Dataset instead generates " + t;
	  });
	  var a = flattenTensorOrArrayOrMap("input", e.inputNames, n),
	      o = flattenTensorOrArrayOrMap("output", e.outputNames, r),
	      s = a[0].shape[0];
	  Q.assert(a.length === e.inputs.length, function () {
	    return "LayersModel has " + e.inputs.length + " inputs, but the dataset provides " + a.length + " inputs.  (Expected input keys: " + JSON.stringify(e.inputNames) + ")";
	  }), Q.assert(o.length === e.outputs.length, function () {
	    return "LayersModel has " + e.outputs.length + " outputs, but the dataset provides " + o.length + " outputs.  (Expected output keys: " + JSON.stringify(e.outputNames) + ")";
	  });

	  var l = function l(t) {
	    Q.assert(a[t].shape[0] === s, function () {
	      return "Batch size mismatch: input " + e.inputNames[t] + " has " + a[t].shape[0] + "; expected  " + s + " based on input " + e.inputNames[0] + ".";
	    });
	  };

	  for (var u in a) {
	    l(u);
	  }

	  var c = function c(t) {
	    Q.assert(o[t].shape[0] === s, function () {
	      return "Batch size mismatch: output " + e.outputNames[t] + " has " + o[t].shape[0] + "; expected  " + s + " based on input " + e.inputNames[0] + ".";
	    });
	  };

	  for (var p in o) {
	    c(p);
	  }

	  return {
	    xs: a,
	    ys: o
	  };
	}

	function flattenTensorOrArrayOrMap(e, t, n) {
	  if (n instanceof ht) return [n];
	  if (Array.isArray(n)) return Q.assert(n.length === t.length, function () {
	    return "Received an array of " + n.length + " Tensors, but expected " + t.length + " to match the " + e + " keys " + t + ".";
	  }), n;

	  for (var r = [], i = 0, a = t; i < a.length; i++) {
	    var o = a[i];
	    if (null == n[o]) throw new ValueError("The feature data generated by the dataset lacks the required " + e + " key '" + o + "'.");
	    r.push(n[o]);
	  }

	  return r;
	}

	function standardizeTensorValidationData(e) {
	  if (3 === e.length) throw new NotImplementedError("Validation with sample weights is not implemented yet.");
	  return {
	    xs: e[0],
	    ys: e[1]
	  };
	}

	function fitDataset(e, t, n) {
	  return __awaiter(this, void 0, void 0, function () {
	    var r, i, a, o, s, l, u, c, p, h, d, f, g, m, y, v, b, w, z, S, A, _, C, I, E, N, k, L, x, T, D, O, R, M;

	    return __generator(this, function (P) {
	      switch (P.label) {
	        case 0:
	          if (r = null != n.batchesPerEpoch, Q.assert(null != e.optimizer, function () {
	            return "You must compile a model before training/testing. Use LayersModel.compile(modelCompileConfig).";
	          }), Q.assert(null != n, function () {
	            return "For fitDataset(), the 2nd argument (config) is required, but it is not provided in this call.";
	          }), Q.assert(null != n.epochs && n.epochs > 0 && Number.isInteger(n.epochs), function () {
	            return "For fitDataset(), config.epochs is expected to be a positive integer, but got " + n.epochs;
	          }), Q.assert(!r || n.batchesPerEpoch > 0 && Number.isInteger(n.batchesPerEpoch), function () {
	            return "For fitDataset(), config.batchesPerEpoch is expected to be a positive integer if specified, but got " + n.batchesPerEpoch;
	          }), Q.assert(null == n.validationSplit, function () {
	            return "`validationSplit` is not supported by `fitDataset()`. Use validationData instead.";
	          }), e.isTraining) throw new Error("Cannot start training because another fit() call is ongoing.");
	          e.isTraining = !0, P.label = 1;

	        case 1:
	          return P.trys.push([1,, 26, 27]), i = null != n.validationData, a = void 0, o = void 0, i && (isDatasetObject(n.validationData) ? Q.assert(null == n.validationBatches || n.validationBatches > 0 && Number.isInteger(n.validationBatches), function () {
	            return "For fitDataset() with dataset-based validation, config.validationBatches is expected not to be provided, or to be a positive integer, but got " + n.validationBatches;
	          }) : (s = standardizeTensorValidationData(n.validationData), a = s.xs, o = s.ys)), l = e.makeTrainFunction(), u = e.getDedupedMetricsNames(), c = void 0, c = i ? u.slice().concat(u.map(function (e) {
	            return "val_" + e;
	          })) : u.slice(), p = standardizeCallbacks(n.callbacks, n.yieldEvery), h = null == n.verbose ? 1 : n.verbose, d = configureCallbacks(p, h, n.epochs, null, null, getStepsPerEpoch(t, n), null, i, c), f = d.callbackList, g = d.history, f.setModel(e), e.history = g, [4, f.onTrainBegin()];

	        case 2:
	          return P.sent(), e.stopTraining_ = !1, m = null == n.initialEpoch ? 0 : n.initialEpoch, [4, t.iterator()];

	        case 3:
	          y = P.sent(), P.label = 4;

	        case 4:
	          return m < n.epochs ? (v = {}, [4, f.onEpochBegin(m)]) : [3, 23];

	        case 5:
	          return P.sent(), b = 0, w = 0, r ? [3, 7] : [4, t.iterator()];

	        case 6:
	          y = P.sent(), P.label = 7;

	        case 7:
	          return !r || b < n.batchesPerEpoch ? [4, y.next()] : [3, 21];

	        case 8:
	          return z = P.sent(), r && z.done ? (console.warn("You provided `batchesPerEpoch` as " + n.batchesPerEpoch + ", but your dataset iterator ran out of data after " + b + " batches; interrupting training. Make sure that your dataset can generate at least `batchesPerEpoch * epochs` batches (in this case, " + n.batchesPerEpoch * n.epochs + " batches). You may need to use the repeat() function when building your dataset."), [3, 21]) : null == z.value ? [3, 15] : (S = standardizeDataIteratorOutput(e, z.value), A = S.xs, _ = S.ys, (C = {}).batch = w, C.size = A[0].shape[0], [4, f.onBatchBegin(w, C)]);

	        case 9:
	          if (P.sent(), I = [], null == n.classWeight) return [3, 13];
	          E = standardizeClassWeights(n.classWeight, e.outputNames), M = 0, P.label = 10;

	        case 10:
	          return M < E.length ? (k = (N = I).push, [4, standardizeWeights(_[M], null, E[M])]) : [3, 13];

	        case 11:
	          k.apply(N, [P.sent()]), P.label = 12;

	        case 12:
	          return ++M, [3, 10];

	        case 13:
	          for (L = A.concat(_).concat(I), x = l(L), Ve(L), M = 0; M < u.length; ++M) {
	            T = u[M], D = x[M], C[T] = D, Ge(D);
	          }

	          return [4, f.onBatchEnd(w, C)];

	        case 14:
	          P.sent(), disposeTensorsInLogs(C), w++, b++, P.label = 15;

	        case 15:
	          return (r ? b >= n.batchesPerEpoch : z.done) ? i ? (O = void 0, isDatasetObject(n.validationData) ? (R = toList, [4, e.evaluateDataset(n.validationData, {
	            batches: n.validationBatches
	          })]) : [3, 17]) : [3, 19] : [3, 20];

	        case 16:
	          return O = R.apply(void 0, [P.sent()]), [3, 18];

	        case 17:
	          O = toList(e.evaluate(a, o, {
	            batchSize: null == n.validationBatchSize ? DEFAULT_VALIDATION_BATCH_SIZE : n.validationBatchSize,
	            verbose: 0
	          })), P.label = 18;

	        case 18:
	          for (M = 0; M < e.metricsNames.length; ++M) {
	            v["val_" + e.metricsNames[M]] = O[M];
	          }

	          P.label = 19;

	        case 19:
	          return [3, 21];

	        case 20:
	          return e.stopTraining_ ? [3, 21] : [3, 7];

	        case 21:
	          return [4, f.onEpochEnd(m, v)];

	        case 22:
	          return P.sent(), m++, e.stopTraining_ ? [3, 23] : [3, 4];

	        case 23:
	          return [4, f.onTrainEnd()];

	        case 24:
	          return P.sent(), [4, e.history.syncData()];

	        case 25:
	          return P.sent(), [2, e.history];

	        case 26:
	          return e.isTraining = !1, [7];

	        case 27:
	          return [2];
	      }
	    });
	  });
	}

	function getStepsPerEpoch(e, t) {
	  var n = null;
	  return null != t.batchesPerEpoch ? n = t.batchesPerEpoch : Number.isFinite(e.size) && (n = e.size), n;
	}

	function isDatasetObject(e) {
	  return "function" == typeof e.iterator;
	}

	function isLazyIteratorObject(e) {
	  return "function" == typeof e.next;
	}

	function evaluateDataset(e, t, n) {
	  return __awaiter(this, void 0, void 0, function () {
	    var r, i, a, o, s, l, u, c, p, h;
	    return __generator(this, function (d) {
	      switch (d.label) {
	        case 0:
	          if (r = null != (n = n || {}).batches, i = e.testFunction, a = [], n.verbose > 0) throw new NotImplementedError("Verbose mode is not implemented yet.");
	          return Q.assert(!r || n.batches > 0 && Number.isInteger(n.batches), function () {
	            return "Test loop expects `batches` to be a positive integer, but received " + JSON.stringify(n.batches);
	          }), isLazyIteratorObject(t) ? (s = t, [3, 3]) : [3, 1];

	        case 1:
	          return [4, t.iterator()];

	        case 2:
	          s = d.sent(), d.label = 3;

	        case 3:
	          o = s, l = 0, u = 0, c = function c() {
	            var t;
	            return __generator(this, function (s) {
	              switch (s.label) {
	                case 0:
	                  return [4, o.next()];

	                case 1:
	                  return t = s.sent(), a = ze(function () {
	                    if (t.value) {
	                      var n = standardizeDataIteratorOutput(e, t.value),
	                          r = n.xs,
	                          o = n.ys,
	                          s = r.concat(o),
	                          c = ze(function () {
	                        return i(s);
	                      });
	                      if (Ve(s), 0 === u) for (var p = 0; p < c.length; ++p) {
	                        a.push(Cn(0));
	                      }

	                      var h = s[0].shape[0],
	                          d = function d(e) {
	                        var t = c[e],
	                            n = a[e];
	                        a[e] = ze(function () {
	                          return Zu(a[e], fl(h, t));
	                        }), u > 0 && Ve(n);
	                      };

	                      for (p = 0; p < c.length; ++p) {
	                        d(p);
	                      }

	                      Ve(c), l += h, ++u;
	                    }

	                    return a;
	                  }), t.done ? (r && console.warn("Your dataset iterator ran out of data during evaluateDataset(). Interrupting evalution. Make sure that your dataset can generate at least `batches` batches (in this case, " + n.batches + " batches). You may need to use the repeat() function when building your dataset."), [2, "break"]) : [2];
	              }
	            });
	          }, d.label = 4;

	        case 4:
	          return !r || u < n.batches ? [5, c()] : [3, 6];

	        case 5:
	          return "break" === d.sent() ? [3, 6] : [3, 4];

	        case 6:
	          for (p = 0; p < a.length; ++p) {
	            h = a[p], a[p] = rl(a[p], l), Ve(h);
	          }

	          return [2, singletonOrArray(a)];
	      }
	    });
	  });
	}

	function checkBatchSize(e) {
	  Q.assert(e > 0 && Number.isInteger(e), function () {
	    return "batchSize is required to be a positive integer, but got " + e;
	  });
	}

	function sliceArrays(e, t, n) {
	  return null == e ? [null] : Array.isArray(e) ? e.map(function (e) {
	    return sliceAlongFirstAxis(e, t, n - t);
	  }) : sliceAlongFirstAxis(e, t, n - t);
	}

	function sliceArraysByIndices(e, t) {
	  return ze(function () {
	    return null == e ? null : Array.isArray(e) ? e.map(function (e) {
	      return sliceArraysByIndices(e, t);
	    }) : gather$1(e, "int32" === t.dtype ? t : t.toInt());
	  });
	}

	function makeBatches(e, t) {
	  for (var n = [], r = 0, i = null; r < e;) {
	    (i = r + t) >= e && (i = e), n.push([r, i]), r = i;
	  }

	  return n;
	}

	function fitLoop(e, t, n, r, i, a, o, s, l, u, c, p, h, d, f) {
	  return __awaiter(this, void 0, void 0, function () {
	    var g, m, y, v, b, w, z, S;
	    return __generator(this, function (A) {
	      switch (A.label) {
	        case 0:
	          if (null == i && (i = 32), null == a && (a = 1), null == c && (c = !0), null == h && (h = 0), g = !1, null != l && null != u && (g = !0), null != f && (g = !0, null == d)) throw new ValueError("Can only use `validationSteps` when doing step-wise training, i.e., `stepsPerEpoch` must be set.");
	          return null != (m = e.checkNumSamples(n, i, d, "steps_per_epoch")) && (y = range(0, m)), null == o && (o = 1), v = configureCallbacks(s, o, a, h, m, d, i, g, p), b = v.callbackList, w = v.history, b.setModel(e), e.history = w, [4, b.onTrainBegin()];

	        case 1:
	          A.sent(), e.stopTraining_ = !1, z = function z(a) {
	            var o, s, p, h, f;
	            return __generator(this, function (v) {
	              switch (v.label) {
	                case 0:
	                  return [4, b.onEpochBegin(a)];

	                case 1:
	                  if (v.sent(), o = {}, null == d) return [3, 2];
	                  throw new NotImplementedError("stepsPerEpoch mode is not implemented yet.");

	                case 2:
	                  if ("batch" === c) throw new NotImplementedError("batch shuffling is not implemneted yet");
	                  c && Q.shuffle(y), s = En(y), p = makeBatches(m, i), h = function h(a) {
	                    var c;
	                    return __generator(this, function (h) {
	                      switch (h.label) {
	                        case 0:
	                          return c = {}, [4, b.onBatchBegin(a, c)];

	                        case 1:
	                          return h.sent(), ze(function () {
	                            var h = p[a][0],
	                                d = p[a][1],
	                                f = sliceAlongFirstAxis(s, h, d - h);
	                            c.batch = a, c.size = d - h;

	                            for (var m = sliceArraysByIndices(n, f), y = t(m), v = 0; v < r.length; ++v) {
	                              var b = r[v],
	                                  w = y[v];
	                              c[b] = w, Ge(w);
	                            }

	                            if (a === p.length - 1 && g) {
	                              var z = e.testLoop(l, u, i);

	                              for (v = 0; v < r.length; ++v) {
	                                b = r[v], w = z[v];
	                                Ge(w), o["val_" + b] = w;
	                              }
	                            }
	                          }), [4, b.onBatchEnd(a, c)];

	                        case 2:
	                          return h.sent(), disposeTensorsInLogs(c), e.stopTraining_ ? [2, "break"] : [2];
	                      }
	                    });
	                  }, f = 0, v.label = 3;

	                case 3:
	                  return f < p.length ? [5, h(f)] : [3, 6];

	                case 4:
	                  if ("break" === v.sent()) return [3, 6];
	                  v.label = 5;

	                case 5:
	                  return ++f, [3, 3];

	                case 6:
	                  s.dispose(), v.label = 7;

	                case 7:
	                  return [4, b.onEpochEnd(a, o)];

	                case 8:
	                  return v.sent(), e.stopTraining_ ? [2, "break"] : [2];
	              }
	            });
	          }, S = h, A.label = 2;

	        case 2:
	          return S < a ? [5, z(S)] : [3, 5];

	        case 3:
	          if ("break" === A.sent()) return [3, 5];
	          A.label = 4;

	        case 4:
	          return ++S, [3, 2];

	        case 5:
	          return [4, b.onTrainEnd()];

	        case 6:
	          return A.sent(), [4, e.history.syncData()];

	        case 7:
	          return A.sent(), [2, e.history];
	      }
	    });
	  });
	}

	function fitTensors(e, t, n, r) {
	  return void 0 === r && (r = {}), __awaiter(this, void 0, void 0, function () {
	    var i, a, o, s, l, u, c, p, h, d, f, g, m, y, v, b, w, z, S, A, _, C;

	    return __generator(this, function (I) {
	      switch (I.label) {
	        case 0:
	          if (e.isTraining) throw new Error("Cannot start training because another fit() call is ongoing.");
	          e.isTraining = !0, I.label = 1;

	        case 1:
	          return I.trys.push([1,, 7, 8]), checkBatchSize(p = null == r.batchSize ? 32 : r.batchSize), h = !1, [4, e.standardizeUserData(t, n, r.sampleWeight, r.classWeight, h, p)];

	        case 2:
	          if (d = I.sent(), i = d[0], a = d[1], c = d[2], f = !1, g = void 0, !(null != r.validationData && r.validationData.length > 0)) return [3, 4];
	          if (f = !0, 2 !== r.validationData.length) throw 3 === r.validationData.length ? new NotImplementedError("validationData including sample weights is not supported yet.") : new ValueError("When passing validation data, it must contain 2 (valX, valY) or 3 (valX, valY, valSampleWeight) items; " + r.validationData + " is invalid.");
	          return o = r.validationData[0], s = r.validationData[1], m = !0, [4, e.standardizeUserData(o, s, null, null, m, p)];

	        case 3:
	          return y = I.sent(), l = y[0], u = y[1], g = l.concat(u), [3, 5];

	        case 4:
	          null != r.validationSplit && r.validationSplit > 0 && r.validationSplit < 1 ? (f = !0, v = Math.floor(i[0].shape[0] * (1 - r.validationSplit)), b = i[0].shape[0], l = sliceArrays(i, v, b), i = sliceArrays(i, 0, v), u = sliceArrays(a, v, b), a = sliceArrays(a, 0, v), g = l.concat(u)) : null != r.validationSteps && (f = !0), I.label = 5;

	        case 5:
	          return w = i.concat(a).concat(c), e.checkTrainableWeightsConsistency(), z = e.makeTrainFunction(), S = e.getDedupedMetricsNames(), A = void 0, _ = void 0, f ? (e.makeTestFunction(), A = e.testFunction, _ = S.slice().concat(S.map(function (e) {
	            return "val_" + e;
	          }))) : (A = null, g = [], _ = S.slice()), C = standardizeCallbacks(r.callbacks, r.yieldEvery), [4, fitLoop(e, z, w, S, p, r.epochs, r.verbose, C, A, g, r.shuffle, _, r.initialEpoch, null, null)];

	        case 6:
	          return [2, I.sent()];

	        case 7:
	          return e.isTraining = !1, disposeNewTensors(i, t), disposeNewTensors(a, n), disposeNewTensors(l, o), disposeNewTensors(u, s), null != c && Ve(c), [7];

	        case 8:
	          return [2];
	      }
	    });
	  });
	}

	function ensureTensorsRank2OrHigher(e) {
	  var t = [];
	  e instanceof ht && (e = [e]);

	  for (var n = 0; n < e.length; ++n) {
	    var r = e[n];
	    if (1 === r.rank) t.push(expandDims$1(r, 1));else {
	      if (0 === r.rank) throw new Error("Expected tensor to be at least 1D, but received a 0D tensor (scalar).");
	      t.push(r);
	    }
	  }

	  return t;
	}

	function disposeNewTensors(e, t) {
	  if (null != e) {
	    var n = [];
	    if (t instanceof ht) n.push(t.id);else if (Array.isArray(t)) t.forEach(function (e) {
	      return n.push(e.id);
	    });else if (null != t) for (var r in t) {
	      var i = t[r];
	      n.push(i.id);
	    }
	    var a = [];
	    if (e instanceof ht) -1 === n.indexOf(e.id) && a.push(e);else if (Array.isArray(e)) e.forEach(function (e) {
	      -1 === n.indexOf(e.id) && a.push(e);
	    });else if (null != e) for (var o in e) {
	      var s = e[o];
	      -1 === n.indexOf(s.id) && a.push(s);
	    }
	    a.forEach(function (e) {
	      e.isDisposed || e.dispose();
	    });
	  }
	}

	function isDataTensor(e) {
	  return e instanceof ht;
	}

	function isDataArray(e) {
	  return Array.isArray(e);
	}

	function isDataDict(e) {
	  return !isDataTensor(e) && !isDataArray(e);
	}

	function standardizeInputData(e, t, n, r, i) {
	  if (void 0 === r && (r = !0), void 0 === i && (i = ""), null == t || 0 === t.length) {
	    if (null != e) {
	      var a = !1;
	      if (isDataArray(e) && e.length > 0) a = !0;else if (isDataDict(e)) {
	        for (var o in e) {
	          if (e.hasOwnProperty(o)) {
	            a = !0;
	            break;
	          }
	        }
	      } else a = !0;
	      if (a) throw new ValueError("Error when checking model " + i + " expected no data, but got " + e);
	    }

	    return [];
	  }

	  if (null == e) return t.map(function (e) {
	    return null;
	  });
	  var s;

	  if (isDataDict(e)) {
	    e = e, s = [];

	    for (var l = 0, u = t; l < u.length; l++) {
	      var c = u[l];
	      if (null == e[c]) throw new ValueError('No data provided for "' + c + '". Need data for each key in: ' + t);
	      s.push(e[c]);
	    }
	  } else if (isDataArray(e)) {
	    if ((e = e).length !== t.length) throw new ValueError("Error when checking model " + i + ": the Array of Tensors that you are passing to your model is not the size the model expected. Expected to see " + t.length + " Tensor(s), but instead got the following list of Tensor(s): " + e);
	    s = e;
	  } else {
	    if (e = e, t.length > 1) throw new ValueError("The model " + i + " expects " + t.length + " Tensor(s), but only received one Tensor. Found: Tensor with shape " + e.shape);
	    s = [e];
	  }

	  if (s = ensureTensorsRank2OrHigher(s), null != n) for (var p = 0; p < t.length; ++p) {
	    if (null != n[p]) {
	      var h = s[p];
	      if (h.shape.length !== n[p].length) throw new ValueError("Error when checking " + i + ": expected " + t[p] + " to have " + n[p].length + " dimension(s). but got array with shape " + h.shape);

	      for (var d = 0; d < n[p].length; ++d) {
	        if (0 !== d || r) {
	          var f = h.shape[d],
	              g = n[p][d];
	          if (null != g && g >= 0 && f !== g) throw new ValueError("Error when checking " + i + ": expected " + t[p] + " to have shape [" + n[p] + "], but got array with shape [" + h.shape + "].");
	        }
	      }
	    }
	  }
	  return s;
	}

	function checkArrayLengths(e, t, n) {
	  var r = unique(e.map(function (e) {
	    return e.shape[0];
	  }));
	  r.sort();
	  var i = unique(t.map(function (e) {
	    return e.shape[0];
	  }));
	  if (i.sort(), r.length > 1) throw new ValueError("All input Tensors (x) should have the same number of samples. Got array shapes: " + JSON.stringify(e.map(function (e) {
	    return e.shape;
	  })));
	  if (i.length > 1) throw new ValueError("All target Tensors (y) should have the same number of samples. Got array shapes: " + JSON.stringify(t.map(function (e) {
	    return e.shape;
	  })));
	  if (r.length > 0 && i.length > 0 && !Q.arraysEqual(r, i)) throw new ValueError("Input Tensors should have the same number of samples as target Tensors. Found " + r[0] + " input sample(s) and " + i[0] + " target sample(s).");
	}

	function checkLossAndTargetCompatibility(e, t, n) {
	  for (var r = [meanSquaredError, binaryCrossentropy, categoricalCrossentropy], i = 0; i < e.length; ++i) {
	    var a = e[i],
	        o = t[i],
	        s = n[i];

	    if (null != o) {
	      if (o === categoricalCrossentropy && 1 === a.shape[a.shape.length - 1]) throw new ValueError("You are passing a target array of shape " + a.shape + " while using a loss 'categorical_crossentropy'. 'categorical_crossentropy'expects targets to be binary matrices (1s and 0s) of shape [samples, classes].");
	      if (-1 !== r.indexOf(o)) for (var l = a.shape.slice(1), u = s.slice(1), c = 0; c < l.length; ++c) {
	        var p = l[c],
	            h = u[c];
	        if (null != h && p !== h) throw new ValueError("A target Tensor with shape " + a.shape + " was passed for an output of shape " + s + ", while using a loss function that expects targets to have the same shape as the output.");
	      }
	    }
	  }
	}

	function checkInputData(e, t, n, r, i) {
	  var a;

	  if (void 0 === r && (r = !0), void 0 === i && (i = ""), Array.isArray(e)) {
	    if (e.length !== t.length) throw new ValueError("Error when checking model " + i + ": the Array of Tensors that you are passing to your model is not the size the the model expected. Expected to see " + t.length + " Tensor(s), but instead got " + e.length + " Tensors(s).");
	    a = e;
	  } else {
	    if (t.length > 1) throw new ValueError("The model expects " + t.length + " " + i + " Tensors, but only received one Tensor. Found: array with shape " + JSON.stringify(e.shape) + ".");
	    a = [e];
	  }

	  if (null != n) for (var o = 0; o < t.length; ++o) {
	    if (null != n[o]) {
	      var s = a[o];
	      if (s.shape.length !== n[o].length) throw new ValueError("Error when checking " + i + ": expected " + t[o] + " to have " + n[o].length + " dimension(s), but got array with shape " + JSON.stringify(s.shape));

	      for (var l = 0; l < n[o].length; ++l) {
	        if (0 !== l || r) {
	          var u = s.shape[l],
	              c = n[o][l];
	          if (null != c && c !== u) throw new ValueError("Error when checking " + i + ": expected " + t[o] + " to have shape " + JSON.stringify(n[o]) + " but got array with shape " + JSON.stringify(s.shape) + ".");
	        }
	      }
	    }
	  }
	}

	function collectMetrics(e, t) {
	  if (null == e || Array.isArray(e) && 0 === e.length) return t.map(function (e) {
	    return [];
	  });
	  var n;
	  if ("string" == typeof e || "function" == typeof e) n = [e];else {
	    if (!Array.isArray(e) && "object" != _typeof_1(e)) throw new TypeError("Type of metrics argument not understood. Expected an string,function, Array, or Object, found: " + e);
	    n = e;
	  }
	  if (Array.isArray(n)) return t.map(function (e) {
	    return n;
	  });

	  for (var r = [], i = 0, a = t; i < a.length; i++) {
	    var o = a[i],
	        s = n.hasOwnProperty(o) ? n[o] : [];
	    Array.isArray(s) || (s = [s]), r.push(s);
	  }

	  return r;
	}

	var LAYERS_MODEL_FORMAT_NAME = "layers-model",
	    LayersModel = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return n.isTraining = !1, n;
	  }

	  return __extends(t, e), t.prototype.summary = function (e, t, n) {
	    if (void 0 === n && (n = console.log), !this.built) throw new ValueError("This model has never been called, thus its weights have not been created yet. So no summary can be displayed. Build the model first (e.g., by calling it on some test data).");
	    printSummary(this, e, t, n);
	  }, t.prototype.compile = function (e) {
	    var t = this;
	    if (null == e.loss && (e.loss = []), this.loss = e.loss, "string" == typeof e.optimizer) this.optimizer_ = getOptimizer(e.optimizer), this.isOptimizerOwned = !0;else {
	      if (!(e.optimizer instanceof $h)) throw new ValueError("User-defined optimizer must be an instance of tf.Optimizer.");
	      this.optimizer_ = e.optimizer, this.isOptimizerOwned = !1;
	    }
	    var n = [];
	    if (Array.isArray(e.loss) || "string" == typeof e.loss || "function" == typeof e.loss) {
	      if (Array.isArray(e.loss)) {
	        if (e.loss.length !== this.outputs.length) throw new ValueError("When passing an Array as loss, it should have one entry per model output. The model has " + this.outputs.length + " output(s), but you passed loss=" + e.loss + ".");
	        var r = e.loss;
	        n = r.map(function (e) {
	          return get(e);
	        });
	      } else {
	        var i = get(e.loss);
	        this.outputs.forEach(function (e) {
	          n.push(i);
	        });
	      }
	    } else {
	      for (var a in e.loss = e.loss, e.loss) {
	        if (-1 === this.outputNames.indexOf(a)) throw new ValueError('Unknown entry in loss dictionary: "' + a + '". Only expected the following keys: ' + this.outputNames);
	      }

	      for (var o = 0, s = this.outputNames; o < s.length; o++) {
	        var l = s[o];
	        null == e.loss[l] && console.warn('Output "' + l + '" is missing from loss dictionary. We assume this was done on purpose, and we will not be expecting data to be passed to ' + l + " during training"), n.push(get(e.loss[l]));
	      }
	    }
	    this.lossFunctions = n, this.feedOutputNames = [], this.feedOutputShapes = [], this.feedLossFns = [];

	    for (var u = 0; u < this.outputs.length; ++u) {
	      var c = this.internalOutputShapes[u],
	          p = this.outputNames[u];
	      this.feedOutputNames.push(p), this.feedOutputShapes.push(c), this.feedLossFns.push(this.lossFunctions[u]);
	    }

	    var h = [];
	    this.metrics = e.metrics, this.metricsNames = ["loss"], this.metricsTensors = [], nameScope("loss", function () {
	      for (var e = 0; e < t.outputs.length; ++e) {
	        if (-1 === h.indexOf(e)) {
	          var n = t.lossFunctions[e];
	          t.outputs.length > 1 && (t.metricsTensors.push([n, e]), t.metricsNames.push(t.outputNames[e] + "_loss"));
	        }
	      }
	    });
	    var d = collectMetrics(e.metrics, this.outputNames);
	    nameScope("metric", function () {
	      for (var e = function e(_e2) {
	        if (-1 !== h.indexOf(_e2)) return "continue";
	        !function (n) {
	          for (var r, i, a, o = function o(n) {
	            if ("string" == typeof n && -1 !== ["accuracy", "acc", "crossentropy", "ce"].indexOf(n)) {
	              var o = t.internalOutputShapes[_e2];
	              1 === o[o.length - 1] || t.lossFunctions[_e2] === binaryCrossentropy ? -1 !== ["accuracy", "acc"].indexOf(n) ? i = binaryAccuracy : -1 !== ["crossentropy", "ce"].indexOf(n) && (i = binaryCrossentropy$1) : t.lossFunctions[_e2] === sparseCategoricalCrossentropy ? -1 !== ["accuracy", "acc"].indexOf(n) ? i = sparseCategoricalAccuracy : -1 !== ["crossentropy", "ce"].indexOf(n) && (i = sparseCategoricalCrossentropy$1) : -1 !== ["accuracy", "acc"].indexOf(n) ? i = categoricalAccuracy : -1 !== ["crossentropy", "ce"].indexOf(n) && (i = categoricalCrossentropy$1);
	              var s = void 0;
	              -1 !== ["accuracy", "acc"].indexOf(n) ? s = "acc" : -1 !== ["crossentropy", "ce"].indexOf(n) && (s = "ce"), a = i, r = "" + s;
	            } else {
	              var l = get$1(n);
	              a = l, r = "" + getLossOrMetricName(n);
	            }

	            var u;
	            nameScope(r, function () {
	              u = a;
	            }), function (e, n, r) {
	              t.outputNames.length > 1 && (n = t.outputNames[e] + "_" + n), t.metricsNames.push(n), t.metricsTensors.push([r, e]);
	            }(_e2, r, u);
	          }, s = 0, l = n; s < l.length; s++) {
	            o(l[s]);
	          }
	        }(d[_e2]);
	      }, n = 0; n < t.outputs.length; ++n) {
	        e(n);
	      }
	    }), this.collectedTrainableWeights = this.trainableWeights;
	  }, t.prototype.checkTrainableWeightsConsistency = function () {
	    null != this.collectedTrainableWeights && this.trainableWeights.length !== this.collectedTrainableWeights.length && console.warn("Discrepancy between trainableweights and collected trainable weights. Did you set `model.trainable` without calling `model.compile()` afterwards?");
	  }, t.prototype.evaluate = function (e, t, n) {
	    void 0 === n && (n = {});
	    var r = null == n.batchSize ? 32 : n.batchSize;
	    checkBatchSize(r);
	    var i = this.standardizeUserDataXY(e, t, !0, r);

	    try {
	      var a = i[0].concat(i[1]);
	      this.makeTestFunction();
	      var o = this.testFunction;
	      return singletonOrArray(this.testLoop(o, a, r, n.verbose, n.steps));
	    } finally {
	      disposeNewTensors(i[0], e), disposeNewTensors(i[1], t);
	    }
	  }, t.prototype.evaluateDataset = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (n) {
	        return this.makeTestFunction(), [2, evaluateDataset(this, e, t)];
	      });
	    });
	  }, t.prototype.checkNumSamples = function (e, t, n, r) {
	    var i;

	    if (void 0 === r && (r = "steps"), null != n) {
	      if (i = null, null != t) throw new ValueError("If " + r + " is set, batchSize must be null or undefined.Got batchSize = " + t);
	    } else {
	      if (null == e) throw new ValueError("Either the input data should have a defined shape, or " + r + " shoud be specified.");
	      i = Array.isArray(e) ? e[0].shape[0] : e.shape[0];
	    }

	    return i;
	  }, t.prototype.execute = function (e, t) {
	    if (Array.isArray(t) && 0 === t.length) throw new ValueError("`outputs` is an empty Array, which is not allowed.");
	    var n = Array.isArray(t),
	        r = n ? t : [t],
	        i = this.retrieveSymbolicTensors(r),
	        a = new FeedDict();

	    if (e instanceof ht && (e = [e]), Array.isArray(e)) {
	      if (e.length !== this.inputs.length) throw new ValueError("The number of inputs provided (" + e.length + ") does not match the number of inputs of this model (" + this.inputs.length + ").");

	      for (var o = 0; o < this.inputs.length; ++o) {
	        a.add(this.inputs[o], e[o]);
	      }
	    } else for (var s = 0, l = this.inputs; s < l.length; s++) {
	      var u = l[s],
	          c = e[u.name];
	      if (null == c) throw new ValueError("No value is provided for the model's input " + u.name);
	      a.add(u, c);
	    }

	    var p = execute(i, a);
	    return n ? p : p[0];
	  }, t.prototype.retrieveSymbolicTensors = function (e) {
	    for (var t = pyListRepeat(null, e.length), n = e.length, r = 0, i = this.layers; r < i.length; r++) {
	      for (var a = i[r], o = Array.isArray(a.output) ? a.output : [a.output], s = o.map(function (e) {
	        return e.name;
	      }), l = 0; l < e.length; ++l) {
	        var u = s.indexOf(e[l]);
	        if (-1 !== u && (t[l] = o[u], n--), 0 === n) break;
	      }

	      if (0 === n) break;
	    }

	    if (n > 0) {
	      var c = [];
	      throw t.forEach(function (t, n) {
	        null == t && c.push(e[n]);
	      }), new ValueError("Cannot find SymbolicTensors for output name(s): " + JSON.stringify(c));
	    }

	    return t;
	  }, t.prototype.predictLoop = function (e, t, n) {
	    var r = this;
	    return void 0 === t && (t = 32), void 0 === n && (n = !1), ze(function () {
	      var i = r.checkNumSamples(e);
	      if (n) throw new NotImplementedError("Verbose predictLoop() is not implemented yet.");

	      for (var a = makeBatches(i, t), o = r.outputs.map(function (e) {
	        return [];
	      }), s = function s(t) {
	        ze(function () {
	          var n = a[t][0],
	              i = a[t][1],
	              o = sliceArrays(e, n, i),
	              s = [];
	          if (Array.isArray(o)) for (var l = 0; l < o.length; ++l) {
	            s.push({
	              key: r.inputs[l],
	              value: o[l]
	            });
	          } else s.push({
	            key: r.inputs[0],
	            value: o
	          });
	          var u = new FeedDict(s);
	          return execute(r.outputs, u);
	        }).forEach(function (e, t) {
	          return o[t].push(e);
	        });
	      }, l = 0; l < a.length; ++l) {
	        s(l);
	      }

	      return singletonOrArray(o.map(function (e) {
	        return Bn(e, 0);
	      }));
	    });
	  }, t.prototype.predict = function (e, t) {
	    void 0 === t && (t = {});
	    var n = ensureTensorsRank2OrHigher(e);
	    checkInputData(n, this.inputNames, this.feedInputShapes, !1);

	    try {
	      var r = null == t.batchSize ? 32 : t.batchSize;
	      return checkBatchSize(r), this.predictLoop(n, r);
	    } finally {
	      disposeNewTensors(n, e);
	    }
	  }, t.prototype.predictOnBatch = function (e) {
	    checkInputData(e, this.inputNames, this.feedInputShapes, !0);
	    var t = (Array.isArray(e) ? e[0] : e).shape[0];
	    return this.predictLoop(e, t);
	  }, t.prototype.standardizeUserDataXY = function (e, t, n, r) {
	    if (void 0 === n && (n = !0), null == this.optimizer_) throw new RuntimeError("You must compile a model before training/testing. Use LayersModel.compile(modelCompileArgs).");

	    for (var i = [], a = 0; a < this.feedOutputShapes.length; ++a) {
	      var o = this.feedOutputShapes[a];
	      this.feedLossFns[a] === sparseCategoricalCrossentropy ? i.push(o.slice(0, o.length - 1).concat([1])) : i.push(o);
	    }

	    if (checkArrayLengths(e = standardizeInputData(e, this.feedInputNames, this.feedInputShapes, !1, "input"), t = standardizeInputData(t, this.feedOutputNames, i, !1, "target"), null), checkLossAndTargetCompatibility(t, this.feedLossFns, this.feedOutputShapes), this.stateful && null != r && r > 0 && e[0].shape[0] % r != 0) throw new ValueError("In a stateful network, you should only pass inputs with a number of samples that is divisible by the batch size " + r + ". Found: " + e[0].shape[0] + " sample(s).");
	    return [e, t];
	  }, t.prototype.standardizeUserData = function (e, t, n, r, i, a) {
	    return void 0 === i && (i = !0), __awaiter(this, void 0, void 0, function () {
	      var o, s, l, u, c, p, h, d;
	      return __generator(this, function (f) {
	        switch (f.label) {
	          case 0:
	            if (o = this.standardizeUserDataXY(e, t, i, a), s = o[0], l = o[1], null != n) throw new Error("sample weight is not supported yet.");
	            if (u = null, null == r) return [3, 4];
	            c = standardizeClassWeights(r, this.outputNames), u = [], p = 0, f.label = 1;

	          case 1:
	            return p < c.length ? (d = (h = u).push, [4, standardizeWeights(l[p], null, c[p])]) : [3, 4];

	          case 2:
	            d.apply(h, [f.sent()]), f.label = 3;

	          case 3:
	            return ++p, [3, 1];

	          case 4:
	            return [2, [s, l, u]];
	        }
	      });
	    });
	  }, t.prototype.testLoop = function (e, t, n, r, i) {
	    var a = this;
	    return void 0 === r && (r = 0), ze(function () {
	      var o = a.checkNumSamples(t, n, i, "steps"),
	          s = [];
	      if (r > 0) throw new NotImplementedError("Verbose mode is not implemented yet.");
	      if (null != i) throw new NotImplementedError("steps mode in testLoop() is not implemented yet");

	      for (var l = makeBatches(o, n), u = En(range(0, o)), c = 0; c < l.length; ++c) {
	        var p = l[c][0],
	            h = l[c][1],
	            d = sliceAlongFirstAxis(u, p, h - p),
	            f = sliceArraysByIndices(t, d),
	            g = e(f);
	        if (0 === c) for (var m = 0; m < g.length; ++m) {
	          s.push(Cn(0));
	        }

	        for (m = 0; m < g.length; ++m) {
	          var y = g[m];
	          s[m] = Zu(s[m], fl(h - p, y));
	        }
	      }

	      for (m = 0; m < s.length; ++m) {
	        s[m] = rl(s[m], o);
	      }

	      return s;
	    });
	  }, t.prototype.getDedupedMetricsNames = function () {
	    for (var e = this.metricsNames, t = [], n = 0; n < e.length; ++n) {
	      var r = e[n],
	          i = r;
	      if (count(e, r) > 1) i += "_" + count(e.slice(0, n), r);
	      t.push(i);
	    }

	    return t;
	  }, t.prototype.makeTrainFunction = function () {
	    var e = this;
	    return function (t) {
	      var n = [],
	          r = t.slice(0, e.inputs.length),
	          i = t.slice(e.inputs.length, e.inputs.length + e.outputs.length),
	          a = t.slice(e.inputs.length + e.outputs.length, e.inputs.length + 2 * e.outputs.length),
	          o = [],
	          s = e.collectedTrainableWeights.map(function (e) {
	        return e.read();
	      });
	      return [e.optimizer_.minimize(function () {
	        for (var t = [], s = 0; s < e.inputs.length; ++s) {
	          t.push({
	            key: e.inputs[s],
	            value: r[s]
	          });
	        }

	        var l,
	            u = new FeedDict(t),
	            c = execute(e.outputs, u, {
	          training: !0
	        });

	        for (s = 0; s < e.lossFunctions.length; ++s) {
	          var p = (0, e.lossFunctions[s])(i[s], c[s]);
	          null != a[s] && (p = computeWeightedLoss(p, a[s]));
	          var h = Bu(p);
	          n.push(h), l = 0 === s ? p : Zu(l, p);
	        }

	        for (s = 0; s < e.metricsTensors.length; ++s) {
	          var d = void 0;
	          if (e.outputs.length > 1 && s < e.outputs.length) d = n[s];else {
	            var f = e.metricsTensors[s][0],
	                g = e.metricsTensors[s][1];
	            d = Bu(f(i[g], c[g]));
	          }
	          Ge(d), o.push(d);
	        }

	        return l = Bu(l), e.calculateLosses().forEach(function (e) {
	          l = Zu(l, e);
	        }), l;
	      }, !0, s)].concat(o);
	    };
	  }, t.prototype.makeTestFunction = function () {
	    var e = this;

	    this.testFunction = function (t) {
	      return ze(function () {
	        for (var n, r = [], i = t.slice(0, e.inputs.length), a = t.slice(e.inputs.length, e.inputs.length + e.outputs.length), o = [], s = 0; s < e.inputs.length; ++s) {
	          o.push({
	            key: e.inputs[s],
	            value: i[s]
	          });
	        }

	        var l = new FeedDict(o),
	            u = execute(e.outputs, l);

	        for (s = 0; s < e.lossFunctions.length; ++s) {
	          var c = e.lossFunctions[s],
	              p = Bu(c(a[s], u[s]));
	          n = 0 === s ? p : Zu(n, p), r.push(n);
	        }

	        for (s = 0; s < e.metricsTensors.length; ++s) {
	          var h = e.metricsTensors[s][0],
	              d = e.metricsTensors[s][1],
	              f = Bu(h(a[d], u[d]));
	          r.push(f);
	        }

	        return r;
	      });
	    };
	  }, t.prototype.fit = function (e, t, n) {
	    return void 0 === n && (n = {}), __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (r) {
	        return [2, fitTensors(this, e, t, n)];
	      });
	    });
	  }, t.prototype.fitDataset = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (n) {
	        return [2, fitDataset(this, e, t)];
	      });
	    });
	  }, t.prototype.trainOnBatch = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      var n, r, i, a, o, s, l, u, c;
	      return __generator(this, function (p) {
	        switch (p.label) {
	          case 0:
	            return [4, this.standardizeUserData(e, t)];

	          case 1:
	            n = p.sent(), r = n[0], i = n[1], a = this.makeTrainFunction(), o = a(r.concat(i)), s = [], l = 0, u = o, p.label = 2;

	          case 2:
	            return l < u.length ? [4, u[l].data()] : [3, 5];

	          case 3:
	            c = p.sent(), s.push(c[0]), p.label = 4;

	          case 4:
	            return l++, [3, 2];

	          case 5:
	            return Ve(o), [2, singletonOrArray(s)];
	        }
	      });
	    });
	  }, t.prototype.getNamedWeights = function (e) {
	    for (var t = [], n = null != e && e.trainableOnly, r = n ? this.trainableWeights : this.weights, i = this.getWeights(n), a = 0; a < r.length; ++a) {
	      n && !r[a].trainable || t.push({
	        name: r[a].originalName,
	        tensor: i[a]
	      });
	    }

	    return t;
	  }, Object.defineProperty(t.prototype, "stopTraining", {
	    get: function get() {
	      return this.stopTraining_;
	    },
	    set: function set(e) {
	      this.stopTraining_ = e;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "optimizer", {
	    get: function get() {
	      return this.optimizer_;
	    },
	    set: function set(e) {
	      this.optimizer_ !== e && (this.optimizer_ = e, this.isOptimizerOwned = !1);
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.dispose = function () {
	    var t = e.prototype.dispose.call(this);

	    if (0 === t.refCountAfterDispose && null != this.optimizer && this.isOptimizerOwned) {
	      var n = We().numTensors;
	      this.optimizer_.dispose(), t.numDisposedVariables += n - We().numTensors;
	    }

	    return t;
	  }, t.prototype.getLossIdentifiers = function () {
	    var e;
	    if ("string" == typeof this.loss) e = toSnakeCase(this.loss);else if (Array.isArray(this.loss)) {
	      for (var t = 0, n = this.loss; t < n.length; t++) {
	        if ("string" != typeof n[t]) throw new Error("Serialization of non-string loss is not supported.");
	      }

	      e = this.loss.map(function (e) {
	        return toSnakeCase(e);
	      });
	    } else {
	      var r = Object.keys(this.loss);
	      e = {};

	      for (var i = this.loss, a = 0, o = r; a < o.length; a++) {
	        var s = o[a];
	        if ("string" != typeof i[s]) throw new Error("Serialization of non-string loss is not supported.");
	        e[s] = toSnakeCase(i[s]);
	      }
	    }
	    return e;
	  }, t.prototype.getMetricIdentifiers = function () {
	    if ("string" == typeof this.metrics || "function" == typeof this.metrics) return [toSnakeCase(getLossOrMetricName(this.metrics))];
	    if (Array.isArray(this.metrics)) return this.metrics.map(function (e) {
	      return toSnakeCase(getLossOrMetricName(e));
	    });
	    var e = {};

	    for (var t in this.metrics) {
	      e[t] = toSnakeCase(getLossOrMetricName(this.metrics[t]));
	    }

	    return e;
	  }, t.prototype.getTrainingConfig = function () {
	    return {
	      loss: this.getLossIdentifiers(),
	      metrics: this.getMetricIdentifiers(),
	      optimizer_config: {
	        class_name: this.optimizer.getClassName(),
	        config: this.optimizer.getConfig()
	      }
	    };
	  }, t.prototype.loadTrainingConfig = function (e) {
	    if (null != e.weighted_metrics) throw new Error("Loading weight_metrics is not supported yet.");
	    if (null != e.loss_weights) throw new Error("Loading loss_weights is not supported yet.");
	    if (null != e.sample_weight_mode) throw new Error("Loading sample_weight_mode is not supported yet.");
	    var t,
	        n,
	        r = deserialize(convertPythonicToTs(e.optimizer_config));
	    if ("string" == typeof e.loss) t = toCamelCase(e.loss);else if (Array.isArray(e.loss)) t = e.loss.map(function (e) {
	      return toCamelCase(e);
	    });else if (null != e.loss) for (var i in t = {}, e.loss) {
	      t[i] = toCamelCase(e.loss[i]);
	    }
	    if (Array.isArray(e.metrics)) n = e.metrics.map(function (e) {
	      return toCamelCase(e);
	    });else if (null != e.metrics) for (var i in n = {}, e.metrics) {
	      n[i] = toCamelCase(e.metrics[i]);
	    }
	    this.compile({
	      loss: t,
	      metrics: n,
	      optimizer: r
	    });
	  }, t.prototype.save = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      var n, r, i, a, o, s, l, u, c, p, h, d, f;
	      return __generator(this, function (g) {
	        switch (g.label) {
	          case 0:
	            if ("string" == typeof e) {
	              if (0 === (r = Ah.getSaveHandlers(e)).length) throw new ValueError("Cannot find any save handlers for URL '" + e + "'");
	              if (r.length > 1) throw new ValueError("Found more than one (" + r.length + ") save handlers for URL '" + e + "'");
	              e = r[0];
	            }

	            if (null == e.save) throw new ValueError("LayersModel.save() cannot proceed because the IOHandler provided does not have the `save` attribute defined.");
	            return [4, Ah.encodeWeights(this.getNamedWeights(t))];

	          case 1:
	            return i = g.sent(), a = !1, o = null, s = this.toJSON(o, a), l = {
	              modelTopology: s,
	              format: LAYERS_MODEL_FORMAT_NAME,
	              generatedBy: "TensorFlow.js tfjs-layers v" + version$1,
	              convertedBy: null
	            }, null != t && t.includeOptimizer && null != this.optimizer ? (l.trainingConfig = this.getTrainingConfig(), u = "optimizer", f = (d = Ah).encodeWeights, [4, this.optimizer.getWeights()]) : [3, 4];

	          case 2:
	            return [4, f.apply(d, [g.sent(), u])];

	          case 3:
	            c = g.sent(), p = c.data, h = c.specs, (n = i.specs).push.apply(n, h), i.data = Ah.concatenateArrayBuffers([i.data, p]), g.label = 4;

	          case 4:
	            return l.weightData = i.data, l.weightSpecs = i.specs, [2, e.save(l)];
	        }
	      });
	    });
	  }, t.className = "Model", t;
	}(Container);

	function modelFromJSON(e, t) {
	  return __awaiter(this, void 0, void 0, function () {
	    var n, r, i, a, o, s, l, u;
	    return __generator(this, function (c) {
	      switch (c.label) {
	        case 0:
	          return "modelTopology" in e || (e = {
	            modelTopology: e
	          }), null != (n = (e = e).modelTopology).model_config && (n = n.model_config), r = convertPythonicToTs(n), i = deserialize(r, t), null == e.weightsManifest ? [3, 2] : [4, Ah.loadWeights(e.weightsManifest, e.pathPrefix, i.weights.map(function (e) {
	            return e.originalName;
	          }))];

	        case 1:
	          for (a = c.sent(), o = {}, s = 0, l = i.weights; s < l.length; s++) {
	            u = l[s], o[u.originalName] = a[u.originalName];
	          }

	          i.loadWeights(o), Ve(a), c.label = 2;

	        case 2:
	          return [2, i];
	      }
	    });
	  });
	}

	function loadLayersModelInternal(e, t) {
	  return __awaiter(this, void 0, void 0, function () {
	    var n;
	    return __generator(this, function (r) {
	      if (null == t && (t = {}), "string" == typeof e) {
	        if (0 === (n = Ah.getLoadHandlers(e, t.onProgress)).length) n.push(Ah.browserHTTPRequest(e, t));else if (n.length > 1) throw new ValueError("Found more than one (" + n.length + ") load handlers for URL '" + e + "'");
	        e = n[0];
	      }

	      return [2, loadLayersModelFromIOHandler(e, void 0, t)];
	    });
	  });
	}

	function loadLayersModelFromIOHandler(e, t, n) {
	  return __awaiter(this, void 0, void 0, function () {
	    var r, i, a, o, s, l, u, c, p;
	    return __generator(this, function (h) {
	      switch (h.label) {
	        case 0:
	          if (null == n && (n = {}), null == e.load) throw new ValueError("Cannot proceed with model loading because the IOHandler provided does not have the `load` method implemented.");
	          return [4, e.load()];

	        case 1:
	          if (r = h.sent(), null != (i = r.modelTopology).model_config && (i = i.model_config), a = null == n.strict || n.strict, o = null != r.weightData && null != r.weightSpecs && a, s = deserialize(convertPythonicToTs(i), t, o), null != (l = r.trainingConfig) && s.loadTrainingConfig(l), null == r.weightData) return [3, 4];
	          if (null == r.weightSpecs) throw new ValueError("LayersModel artifacts contains weight data, but not weight specs. Therefore loading of weights cannot proceed.");
	          return u = decodeModelAndOptimizerWeights(r.weightData, r.weightSpecs), c = u.modelWeights, p = u.optimizerWeights, s.loadWeights(c, a), null != s.optimizer && p.length > 0 ? [4, s.optimizer.setWeights(p)] : [3, 3];

	        case 2:
	          h.sent(), h.label = 3;

	        case 3:
	          Ve(c), Ve(p.map(function (e) {
	            return e.tensor;
	          })), h.label = 4;

	        case 4:
	          return [2, s];
	      }
	    });
	  });
	}

	function decodeModelAndOptimizerWeights(e, t) {
	  var n = Ah.decodeWeights(e, t),
	      r = {},
	      i = [];
	  return t.forEach(function (e) {
	    "optimizer" === e.group ? i.push({
	      name: e.name,
	      tensor: n[e.name]
	    }) : r[e.name] = n[e.name];
	  }), {
	    modelWeights: r,
	    optimizerWeights: i
	  };
	}

	Ph.registerClass(LayersModel);

	var Sequential = function (e) {
	  function t(t) {
	    var n = e.call(this, {
	      inputs: [],
	      outputs: []
	    }) || this;
	    if (t = t || {}, n.trainable = !0, n.built = !1, n.name = null != t.name ? t.name : getUid("sequential_"), null != t.layers) for (var r = 0, i = t.layers; r < i.length; r++) {
	      var a = i[r];
	      n.add(a);
	    }
	    return n;
	  }

	  return __extends(t, e), t.prototype.checkShape = function (e) {
	    if (e.inboundNodes[0].outputTensors[0].shape.some(function (e) {
	      return e < 0;
	    })) throw new ValueError("Negative dimension size caused by adding layer " + e.name + " with input shape [" + e.inboundNodes[0].inputTensors[0].shape + "]");
	  }, t.prototype.add = function (e) {
	    var n,
	        r = e instanceof t || e instanceof LayersModel;

	    if (r) {
	      if (1 !== (n = e).outputs.length) throw new ValueError("All layers in a Sequential model should have a single output tensor. For multi-output layers, use the functional API.");
	      if (1 !== n.inputs.length) throw new ValueError("All layers in a Sequential model should have a single input tensor. For multi-input layers, use the functional API.");
	    }

	    if (0 === this.outputs.length) {
	      if (0 === e.inboundNodes.length) {
	        if (null == e.batchInputShape) throw new ValueError("The first layer in a Sequential model must get an `inputShape` or `batchInputShape` argument.");
	        var i = Input({
	          batchShape: e.batchInputShape,
	          dtype: e.dtype,
	          name: e.name + "_input"
	        });
	        e.apply(i);
	      }

	      if (r) this.outputs = n.outputs, this.inputs = n.inputs;else {
	        if (1 !== e.inboundNodes.length) throw new ValueError("A layer added to a Sequential model must not already be connected somewhere else. LayersModel received layer " + e.name + " which has " + e.inboundNodes.length + " pre-existing inbound connections.");
	        if (1 !== e.inboundNodes[0].outputTensors.length) throw new ValueError("All layers in a Sequential model should have a single output tensor. For multi-output layers, use the functional API.");
	        this.checkShape(e), this.outputs = [e.inboundNodes[0].outputTensors[0]], this.inputs = getSourceInputs(this.outputs[0]);
	      }
	      this.inboundNodes = [], new Node({
	        outboundLayer: this,
	        inboundLayers: [],
	        nodeIndices: [],
	        tensorIndices: [],
	        inputTensors: this.inputs,
	        outputTensors: this.outputs,
	        inputMasks: pyListRepeat(null, this.inputs.length),
	        outputMasks: [null],
	        inputShapes: this.inputs.map(function (e) {
	          return e.shape;
	        }),
	        outputShapes: this.outputs[0].shape
	      });
	    } else {
	      var a = e.apply(this.outputs[0]);
	      if (Array.isArray(a)) throw new TypeError("All layers in a Sequential model should have a single output tensor. For multi-output layers, use the functional API.");
	      this.checkShape(e), this.outputs = [a], this.inboundNodes[0].outputTensors = this.outputs, this.inboundNodes[0].outputShapes = [this.outputs[0].shape];
	    }

	    this.layers.push(e), this.built = !1;
	  }, t.prototype.pop = function () {
	    if (0 === this.layers.length) throw new TypeError("There are no layers in the model.");
	    if (this.layers.pop(), 0 === this.layers.length) this.outputs = [], this.inboundNodes = [], this.outboundNodes = [];else {
	      var e = this.layers.length - 1;
	      this.layers[e].outboundNodes = [], this.outputs = [this.layers[e].output], this.inboundNodes[0].outputTensors = this.outputs, this.inboundNodes[0].outputShapes = [this.outputs[0].shape];
	    }
	  }, t.prototype.call = function (e, t) {
	    return null == this.model && this.build(), this.model.call(e, t);
	  }, t.prototype.build = function (e) {
	    if (getExactlyOneShape(e), 0 === this.inputs.length || 0 === this.outputs.length) throw new TypeError("Sequential model cannot be built: model is empty. Add some layers first.");
	    this.model = new LayersModel({
	      inputs: this.inputs,
	      outputs: this.outputs[0],
	      name: this.name + "_model"
	    }), this.model.trainable = this.trainable, this.supportsMasking = this.model.supportsMasking, this.inputLayers = this.model.inputLayers, this.inputLayersNodeIndices = this.model.inputLayersNodeIndices, this.inputLayersTensorIndices = this.model.inputLayersTensorIndices, this.outputLayers = this.model.outputLayers, this.outputLayersNodeIndices = this.model.outputLayersNodeIndices, this.outputLayersTensorIndices = this.model.outputLayersTensorIndices, this.nodesByDepth = this.model.nodesByDepth, this.containerNodes = this.model.containerNodes, this.outputNames = this.model.outputNames, this.inputNames = this.model.inputNames, this.built = !0;
	  }, t.prototype.countParams = function () {
	    return this.built || this.build(), e.prototype.countParams.call(this);
	  }, t.prototype.summary = function (t, n, r) {
	    void 0 === r && (r = console.log), this.built || this.build(), e.prototype.summary.call(this, t, n, r);
	  }, t.prototype.setWeights = function (e) {
	    null == this.model && this.build(), this.model.setWeights(e);
	  }, t.prototype.evaluate = function (e, t, n) {
	    if (void 0 === n && (n = {}), !this.built) throw new RuntimeError("The model needs to be compiled before being used.");
	    return this.model.evaluate(e, t, n);
	  }, t.prototype.evaluateDataset = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (n) {
	        if (!this.built) throw new RuntimeError("The model needs to be compiled before being used.");
	        return [2, this.model.evaluateDataset(e, t)];
	      });
	    });
	  }, t.prototype.predict = function (e, t) {
	    return void 0 === t && (t = {}), null == this.model && this.build(), this.model.predict(e, t);
	  }, t.prototype.predictOnBatch = function (e) {
	    return null == this.model && this.build(), this.model.predictOnBatch(e);
	  }, t.prototype.compile = function (e) {
	    this.build(), this.model.compile(e), this.optimizer_ = this.model.optimizer, this.isOptimizerOwned = this.model.isOptimizerOwned, this.loss = this.model.loss, this.metrics = this.model.metrics, this.metricsTensors = this.model.metricsTensors, this.metricsNames = this.model.metricsNames;
	  }, Object.defineProperty(t.prototype, "optimizer", {
	    get: function get() {
	      return null == this.model ? void 0 : this.model.optimizer;
	    },
	    set: function set(e) {
	      this.model.optimizer = e;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.fit = function (e, t, n) {
	    return void 0 === n && (n = {}), __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (r) {
	        if (!this.built) throw new RuntimeError("The model needs to be compiled before being used.");
	        return [2, this.model.fit(e, t, n)];
	      });
	    });
	  }, t.prototype.fitDataset = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (n) {
	        if (!this.built) throw new RuntimeError("The model needs to be compiled before being used.");
	        return [2, this.model.fitDataset(e, t)];
	      });
	    });
	  }, t.prototype.trainOnBatch = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (n) {
	        return [2, this.model.trainOnBatch(e, t)];
	      });
	    });
	  }, t.fromConfig = function (e, n, r, i) {
	    var a;
	    void 0 === r && (r = {}), void 0 === i && (i = !1);
	    var o = {};

	    if (n instanceof Array) {
	      if (null == n[0].className || "Merge" === n[0].className) throw new ValueError("Legacy serialization format not supported yet.");
	      a = n;
	    } else Q.assert(null != n.layers, function () {
	      return "When the config data for a Sequential model is not an Array, it must be an Object that contains the 'layers' field.";
	    }), a = n.layers, delete n.layers, o = n;

	    var s = new e(o);
	    if (!(s instanceof t)) throw new NotImplementedError("Sequential.fromConfig called on non-Sequential input: " + s);

	    for (var l = 0, u = a; l < u.length; l++) {
	      var c = deserialize(u[l], void 0, i);
	      i && c.setFastWeightInitDuringBuild(!0), s.add(c);
	    }

	    return s;
	  }, Object.defineProperty(t.prototype, "stopTraining", {
	    get: function get() {
	      if (null == this.model) throw new ValueError("Cannot get the stopTraining property of a sequential model before it is compiled.");
	      return this.model.stopTraining;
	    },
	    set: function set(e) {
	      if (null == this.model) throw new ValueError("Cannot set the stopTraining property of a sequential model before it is compiled.");
	      this.model.stopTraining = e;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.getConfig = function () {
	    for (var e = [], t = 0, n = this.layers; t < n.length; t++) {
	      var r = n[t],
	          i = {};
	      i.className = r.getClassName(), i.config = r.getConfig(), e.push(i);
	    }

	    return e;
	  }, t.className = "Sequential", t;
	}(LayersModel);

	function model(e) {
	  return new LayersModel(e);
	}

	function sequential(e) {
	  return new Sequential(e);
	}

	function loadLayersModel(e, t) {
	  return null == t && (t = {}), loadLayersModelInternal(e, t);
	}

	function input(e) {
	  return Input(e);
	}

	function registerCallbackConstructor(e, t) {
	  CallbackConstructorRegistry.registerCallbackConstructor(e, t);
	}

	Ph.registerClass(Sequential);

	var Activation = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.getConfig = function () {
	    return {};
	  }, t;
	}(Ph.Serializable),
	    Elu = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.apply = function (e, t) {
	    return void 0 === t && (t = 1), elu$1(e, t);
	  }, t.className = "elu", t;
	}(Activation);

	Ph.registerClass(Elu);

	var Selu = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.apply = function (e) {
	    return Tl(e);
	  }, t.className = "selu", t;
	}(Activation);

	Ph.registerClass(Selu);

	var Relu = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.apply = function (e) {
	    return Al(e);
	  }, t.className = "relu", t;
	}(Activation);

	Ph.registerClass(Relu);

	var Relu6 = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.apply = function (e) {
	    return ze(function () {
	      return ul(6, Al(e));
	    });
	  }, t.className = "relu6", t;
	}(Activation);

	Ph.registerClass(Relu6);

	var Linear = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.apply = function (e) {
	    return e;
	  }, t.className = "linear", t;
	}(Activation);

	Ph.registerClass(Linear);

	var Sigmoid = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.apply = function (e) {
	    return Ns(e);
	  }, t.className = "sigmoid", t;
	}(Activation);

	Ph.registerClass(Sigmoid);

	var HardSigmoid = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.apply = function (e) {
	    return hardSigmoid(e);
	  }, t.className = "hardSigmoid", t;
	}(Activation);

	Ph.registerClass(HardSigmoid);

	var Softplus = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.apply = function (e) {
	    return Fs(e);
	  }, t.className = "softplus", t;
	}(Activation);

	Ph.registerClass(Softplus);

	var Softsign = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.apply = function (e) {
	    return softsign(e);
	  }, t.className = "softsign", t;
	}(Activation);

	Ph.registerClass(Softsign);

	var Tanh = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.apply = function (e) {
	    return Ws(e);
	  }, t.className = "tanh", t;
	}(Activation);

	Ph.registerClass(Tanh);

	var Softmax = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.apply = function (e, t) {
	    return void 0 === t && (t = -1), Kr(e, t);
	  }, t.className = "softmax", t;
	}(Activation);

	Ph.registerClass(Softmax);

	var LogSoftmax = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.apply = function (e, t) {
	    return void 0 === t && (t = -1), Xr(e, t);
	  }, t.className = "logSoftmax", t;
	}(Activation);

	function serializeActivation(e) {
	  return e.getClassName();
	}

	function deserializeActivation(e, t) {
	  return void 0 === t && (t = {}), deserializeKerasObject(e, Ph.SerializationMap.getMap().classNameMap, t, "activation");
	}

	function getActivation(e) {
	  var t;
	  return null == e ? deserializeActivation(t = {
	    className: "linear",
	    config: {}
	  }) : "string" == typeof e ? ((t = {}).className = e, t.config = {}, deserializeActivation(t)) : e instanceof Activation ? e : deserializeActivation(e);
	}

	Ph.registerClass(LogSoftmax);

	var Regularizer = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t;
	}(Ph.Serializable),
	    L1L2 = function (e) {
	  function t(t) {
	    var n = e.call(this) || this;
	    return n.l1 = null == t || null == t.l1 ? .01 : t.l1, n.l2 = null == t || null == t.l2 ? .01 : t.l2, n.hasL1 = 0 !== n.l1, n.hasL2 = 0 !== n.l2, n;
	  }

	  return __extends(t, e), t.prototype.apply = function (e) {
	    var t = this;
	    return ze(function () {
	      var n = Tn([1]);
	      return t.hasL1 && (n = Zu(n, Wu(fl(t.l1, as(e))))), t.hasL2 && (n = Zu(n, Wu(fl(t.l2, square(e))))), n.asScalar();
	    });
	  }, t.prototype.getConfig = function () {
	    return {
	      l1: this.l1,
	      l2: this.l2
	    };
	  }, t.fromConfig = function (e, t) {
	    return new e({
	      l1: t.l1,
	      l2: t.l2
	    });
	  }, t.className = "L1L2", t;
	}(Regularizer);

	function l1(e) {
	  return new L1L2({
	    l1: null != e ? e.l1 : null,
	    l2: 0
	  });
	}

	function l2(e) {
	  return new L1L2({
	    l2: null != e ? e.l2 : null,
	    l1: 0
	  });
	}

	Ph.registerClass(L1L2);
	var REGULARIZER_IDENTIFIER_REGISTRY_SYMBOL_MAP = {
	  l1l2: "L1L2"
	};

	function serializeRegularizer(e) {
	  return serializeKerasObject(e);
	}

	function deserializeRegularizer(e, t) {
	  return void 0 === t && (t = {}), deserializeKerasObject(e, Ph.SerializationMap.getMap().classNameMap, t, "regularizer");
	}

	function getRegularizer(e) {
	  return null == e ? null : "string" == typeof e ? deserializeRegularizer({
	    className: e in REGULARIZER_IDENTIFIER_REGISTRY_SYMBOL_MAP ? REGULARIZER_IDENTIFIER_REGISTRY_SYMBOL_MAP[e] : e,
	    config: {}
	  }) : e instanceof Regularizer ? e : deserializeRegularizer(e);
	}

	var ReLU = function (e) {
	  function t(t) {
	    var n = e.call(this, null == t ? {} : t) || this;
	    return n.supportsMasking = !0, null != t && (n.maxValue = t.maxValue), n;
	  }

	  return __extends(t, e), t.prototype.call = function (e, t) {
	    e = getExactlyOneTensor(e);
	    var n = Al(e);
	    return null != this.maxValue && (n = ps(n, 0, this.maxValue)), n;
	  }, t.prototype.computeOutputShape = function (e) {
	    return e;
	  }, t.prototype.getConfig = function () {
	    var t = {
	      maxValue: this.maxValue
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "ReLU", t;
	}(Layer);

	Ph.registerClass(ReLU);

	var LeakyReLU = function (e) {
	  function t(t) {
	    var n = e.call(this, null == t ? {} : t) || this;
	    return n.DEFAULT_ALPHA = .3, null == t && (t = {}), n.alpha = null == t.alpha ? n.DEFAULT_ALPHA : t.alpha, n;
	  }

	  return __extends(t, e), t.prototype.call = function (e, t) {
	    var n = getExactlyOneTensor(e);
	    return Nl(n, this.alpha);
	  }, t.prototype.computeOutputShape = function (e) {
	    return e;
	  }, t.prototype.getConfig = function () {
	    var t = {
	      alpha: this.alpha
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "LeakyReLU", t;
	}(Layer);

	Ph.registerClass(LeakyReLU);

	var PReLU = function (e) {
	  function t(t) {
	    var n = e.call(this, null == t ? {} : t) || this;
	    if (n.DEFAULT_ALPHA_INITIALIZER = "zeros", null == t && (t = {}), n.supportsMasking = !0, n.alphaInitializer = getInitializer(t.alphaInitializer || n.DEFAULT_ALPHA_INITIALIZER), n.alphaRegularizer = getRegularizer(t.alphaRegularizer), n.alphaConstraint = getConstraint(t.alphaConstraint), null == t.sharedAxes) n.sharedAxes = null;else if (Array.isArray(t.sharedAxes)) n.sharedAxes = t.sharedAxes;else {
	      if ("number" != typeof t.sharedAxes) throw new ValueError("Expected sharedAxes to be a number or an array of numbers, but got " + t.sharedAxes);
	      n.sharedAxes = [t.sharedAxes];
	    }
	    return n;
	  }

	  return __extends(t, e), t.prototype.build = function (e) {
	    var t = (e = getExactlyOneShape(e)).slice(1);
	    if (null != this.sharedAxes) for (var n = 0, r = this.sharedAxes; n < r.length; n++) {
	      t[(a = r[n]) - 1] = 1;
	    }
	    this.alpha = this.addWeight("alpha", t, "float32", this.alphaInitializer, this.alphaRegularizer, !0, this.alphaConstraint);
	    var i = {};
	    if (null != this.sharedAxes) for (var a = 1; a < e.length; ++a) {
	      i[a] = e[a];
	    }
	    this.inputSpec = [new InputSpec({
	      ndim: e.length,
	      axes: i
	    })], this.built = !0;
	  }, t.prototype.call = function (e, t) {
	    return e = getExactlyOneTensor(e), kl(e, this.alpha.read());
	  }, t.prototype.getConfig = function () {
	    var t = {
	      alphaInitializer: serializeInitializer(this.alphaInitializer),
	      alphaRegularizer: serializeRegularizer(this.alphaRegularizer),
	      alphaConstraint: serializeConstraint(this.alphaConstraint),
	      sharedAxes: this.sharedAxes
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "PReLU", t;
	}(Layer);

	Ph.registerClass(PReLU);

	var ELU = function (e) {
	  function t(t) {
	    var n = e.call(this, null == t ? {} : t) || this;
	    if (n.DEFAULT_ALPHA = 1, null == t && (t = {}), null != t.alpha && t.alpha !== n.DEFAULT_ALPHA) throw new NotImplementedError("Non-default alpha value (" + t.alpha + ") is not supported by the ELU layer yet.");
	    return n.alpha = null == t.alpha ? n.DEFAULT_ALPHA : t.alpha, n;
	  }

	  return __extends(t, e), t.prototype.call = function (e, t) {
	    var n = getExactlyOneTensor(e);
	    return Sl(n);
	  }, t.prototype.computeOutputShape = function (e) {
	    return e;
	  }, t.prototype.getConfig = function () {
	    var t = {
	      alpha: this.alpha
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "ELU", t;
	}(Layer);

	Ph.registerClass(ELU);

	var ThresholdedReLU = function (e) {
	  function t(t) {
	    var n = e.call(this, null == t ? {} : t) || this;
	    return n.DEFAULT_THETA = 1, null == t && (t = {}), n.theta = null == t.theta ? n.DEFAULT_THETA : t.theta, n;
	  }

	  return __extends(t, e), t.prototype.call = function (e, t) {
	    var n = getExactlyOneTensor(e);
	    return n.mul(cast$1(n.greater(this.theta), "float32"));
	  }, t.prototype.computeOutputShape = function (e) {
	    return e;
	  }, t.prototype.getConfig = function () {
	    var t = {
	      theta: this.theta
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "ThresholdedReLU", t;
	}(Layer);

	Ph.registerClass(ThresholdedReLU);

	var Softmax$1 = function (e) {
	  function t(t) {
	    var n = e.call(this, null == t ? {} : t) || this;
	    return n.DEFAULT_AXIS = 1, null == t && (t = {}), n.softmax = new Softmax().apply, n.axis = null == t.axis ? n.DEFAULT_AXIS : t.axis, n;
	  }

	  return __extends(t, e), t.prototype.call = function (e, t) {
	    var n = getExactlyOneTensor(e);
	    return this.softmax(n, this.axis);
	  }, t.prototype.computeOutputShape = function (e) {
	    return e;
	  }, t.prototype.getConfig = function () {
	    var t = {
	      axis: this.axis
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "Softmax", t;
	}(Layer);

	function normalizeArray(e, t, n) {
	  if ("number" == typeof e) return pyListRepeat(e, t);
	  if (e.length !== t) throw new ValueError("The " + n + " argument must be an integer or tuple of " + t + " integers. Received: " + e.length + " elements.");

	  for (var r = 0; r < t; ++r) {
	    var i = e[r];
	    if (!isInteger(i)) throw new ValueError("The " + n + " argument must be an integer or tuple of " + t + " integers. Received: " + JSON.stringify(e) + " including a non-integer number " + i);
	  }

	  return e;
	}

	function convOutputLength(e, t, n, r, i) {
	  return void 0 === i && (i = 1), null == e ? e : (a = "same" === n ? e : e - (t + (t - 1) * (i - 1)) + 1, Math.floor((a + r - 1) / r));
	  var a;
	}

	function deconvLength(e, t, n, r) {
	  if (null == e) return null;
	  if ("valid" === r) e = e * t + max$1([n - t, 0]);else {
	    if ("same" !== r) throw new ValueError("Unsupport padding mode: " + r + ".");
	    e *= t;
	  }
	  return e;
	}

	function preprocessConv2DInput(e, t) {
	  return ze(function () {
	    return checkDataFormat(t), "channelsFirst" === t ? Dl(e, [0, 2, 3, 1]) : e;
	  });
	}

	function preprocessConv3DInput(e, t) {
	  return ze(function () {
	    return checkDataFormat(t), "channelsFirst" === t ? Dl(e, [0, 2, 3, 4, 1]) : e;
	  });
	}

	function conv1dWithBias(e, t, n, r, i, a, o) {
	  return void 0 === r && (r = 1), void 0 === i && (i = "valid"), void 0 === o && (o = 1), ze(function () {
	    if (null == a && (a = imageDataFormat()), checkDataFormat(a), 3 !== e.shape.length) throw new ValueError("The input of a conv1dWithBias operation should be 3, but is " + e.shape.length + " instead.");
	    if (3 !== t.shape.length) throw new ValueError("The kernel for a conv1dWithBias operation should be 3, but is " + t.shape.length + " instead");
	    if (null != n && 1 !== n.shape.length) throw new ValueError("The bias for a conv1dWithBias operation should be 1, but is " + t.shape.length + " instead");
	    if ("channelsFirst" === a && (e = Dl(e, [0, 2, 1])), "causal" === i) throw new NotImplementedError("The support for CAUSAL padding mode in conv1dWithBias is not implemented yet.");
	    var s = ru(e, t, r, "same" === i ? "same" : "valid", "NWC", o);
	    return null != n && (s = biasAdd(s, n)), s;
	  });
	}

	function conv2dWithBias(e, t, n, r, i, a, o) {
	  return void 0 === r && (r = [1, 1]), void 0 === i && (i = "valid"), ze(function () {
	    if (null == a && (a = imageDataFormat()), checkDataFormat(a), 3 !== e.rank && 4 !== e.rank) throw new ValueError("conv2dWithBias expects input to be of rank 3 or 4, but received " + e.rank + ".");
	    if (3 !== t.rank && 4 !== t.rank) throw new ValueError("conv2dWithBias expects kernel to be of rank 3 or 4, but received " + e.rank + ".");
	    var s = preprocessConv2DInput(e, a);
	    if ("causal" === i) throw new NotImplementedError("The support for CAUSAL padding mode in conv1dWithBias is not implemented yet.");
	    return s = ou(s, t, r, "same" === i ? "same" : "valid", "NHWC", o), null != n && (s = biasAdd(s, n)), "channelsFirst" === a && (s = Dl(s, [0, 3, 1, 2])), s;
	  });
	}

	function conv3dWithBias(e, t, n, r, i, a, o) {
	  return void 0 === r && (r = [1, 1, 1]), void 0 === i && (i = "valid"), ze(function () {
	    if (null == a && (a = imageDataFormat()), checkDataFormat(a), 4 !== e.rank && 5 !== e.rank) throw new ValueError("conv3dWithBias expects input to be of rank 4 or 5, but received " + e.rank + ".");
	    if (4 !== t.rank && 5 !== t.rank) throw new ValueError("conv3dWithBias expects kernel to be of rank 4 or 5, but received " + e.rank + ".");
	    var s = preprocessConv3DInput(e, a);
	    if ("causal" === i) throw new NotImplementedError("The support for CAUSAL padding mode in conv3dWithBias is not implemented yet.");
	    return s = au(s, t, r, "same" === i ? "same" : "valid", "NDHWC", o), null != n && (s = biasAdd(s, n)), "channelsFirst" === a && (s = Dl(s, [0, 4, 1, 2, 3])), s;
	  });
	}

	Ph.registerClass(Softmax$1);

	var BaseConv = function (e) {
	  function t(n, r) {
	    var i = e.call(this, r) || this;
	    if (i.bias = null, i.DEFAULT_KERNEL_INITIALIZER = "glorotNormal", i.DEFAULT_BIAS_INITIALIZER = "zeros", t.verifyArgs(r), i.rank = n, assertPositiveInteger(i.rank, "rank"), 1 !== i.rank && 2 !== i.rank && 3 !== i.rank) throw new NotImplementedError("Convolution layer for rank other than 1, 2, or 3 (" + i.rank + ") is not implemented yet.");
	    if (i.kernelSize = normalizeArray(r.kernelSize, n, "kernelSize"), i.strides = normalizeArray(null == r.strides ? 1 : r.strides, n, "strides"), i.padding = null == r.padding ? "valid" : r.padding, checkPaddingMode(i.padding), i.dataFormat = null == r.dataFormat ? "channelsLast" : r.dataFormat, checkDataFormat(i.dataFormat), i.activation = getActivation(r.activation), i.useBias = null == r.useBias || r.useBias, i.biasInitializer = getInitializer(r.biasInitializer || i.DEFAULT_BIAS_INITIALIZER), i.biasConstraint = getConstraint(r.biasConstraint), i.biasRegularizer = getRegularizer(r.biasRegularizer), i.activityRegularizer = getRegularizer(r.activityRegularizer), i.dilationRate = normalizeArray(null == r.dilationRate ? 1 : r.dilationRate, n, "dilationRate"), 1 === i.rank && Array.isArray(i.dilationRate) && 1 !== i.dilationRate.length) throw new ValueError("dilationRate must be a number or an array of a single number for 1D convolution, but received " + JSON.stringify(i.dilationRate));

	    if (2 === i.rank) {
	      if ("number" == typeof i.dilationRate) i.dilationRate = [i.dilationRate, i.dilationRate];else if (2 !== i.dilationRate.length) throw new ValueError("dilationRate must be a number or array of two numbers for 2D convolution, but received " + JSON.stringify(i.dilationRate));
	    } else if (3 === i.rank) if ("number" == typeof i.dilationRate) i.dilationRate = [i.dilationRate, i.dilationRate, i.dilationRate];else if (3 !== i.dilationRate.length) throw new ValueError("dilationRate must be a number or array of three numbers for 3D convolution, but received " + JSON.stringify(i.dilationRate));

	    return i;
	  }

	  return __extends(t, e), t.verifyArgs = function (e) {
	    if (assert("kernelSize" in e, "required key 'kernelSize' not in config"), "number" != typeof e.kernelSize && !checkArrayTypeAndLength(e.kernelSize, "number", 1, 3)) throw new ValueError("BaseConv expects config.kernelSize to be number or number[] with length 1, 2, or 3, but received " + JSON.stringify(e.kernelSize) + ".");
	  }, t.prototype.getConfig = function () {
	    var t = {
	      kernelSize: this.kernelSize,
	      strides: this.strides,
	      padding: this.padding,
	      dataFormat: this.dataFormat,
	      dilationRate: this.dilationRate,
	      activation: serializeActivation(this.activation),
	      useBias: this.useBias,
	      biasInitializer: serializeInitializer(this.biasInitializer),
	      biasRegularizer: serializeRegularizer(this.biasRegularizer),
	      activityRegularizer: serializeRegularizer(this.activityRegularizer),
	      biasConstraint: serializeConstraint(this.biasConstraint)
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t;
	}(Layer),
	    Conv = function (e) {
	  function t(n, r) {
	    var i = e.call(this, n, r) || this;
	    return i.kernel = null, t.verifyArgs(r), i.filters = r.filters, assertPositiveInteger(i.filters, "filters"), i.kernelInitializer = getInitializer(r.kernelInitializer || i.DEFAULT_KERNEL_INITIALIZER), i.kernelConstraint = getConstraint(r.kernelConstraint), i.kernelRegularizer = getRegularizer(r.kernelRegularizer), i;
	  }

	  return __extends(t, e), t.prototype.build = function (e) {
	    var t;
	    e = getExactlyOneShape(e);
	    var n = "channelsFirst" === this.dataFormat ? 1 : e.length - 1;
	    if (null == e[n]) throw new ValueError("The channel dimension of the input should be defined. Found " + e[n]);
	    var r = e[n],
	        i = this.kernelSize.concat([r, this.filters]);
	    this.kernel = this.addWeight("kernel", i, null, this.kernelInitializer, this.kernelRegularizer, !0, this.kernelConstraint), this.useBias && (this.bias = this.addWeight("bias", [this.filters], null, this.biasInitializer, this.biasRegularizer, !0, this.biasConstraint)), this.inputSpec = [{
	      ndim: this.rank + 2,
	      axes: (t = {}, t[n] = r, t)
	    }], this.built = !0;
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      var t;
	      e = getExactlyOneTensor(e);
	      var r = null == n.bias ? null : n.bias.read();
	      if (1 === n.rank) t = conv1dWithBias(e, n.kernel.read(), r, n.strides[0], n.padding, n.dataFormat, n.dilationRate[0]);else if (2 === n.rank) t = conv2dWithBias(e, n.kernel.read(), r, n.strides, n.padding, n.dataFormat, n.dilationRate);else {
	        if (3 !== n.rank) throw new NotImplementedError("convolutions greater than 3D are not implemented yet.");
	        t = conv3dWithBias(e, n.kernel.read(), r, n.strides, n.padding, n.dataFormat, n.dilationRate);
	      }
	      return null != n.activation && (t = n.activation.apply(t)), t;
	    });
	  }, t.prototype.computeOutputShape = function (e) {
	    e = getExactlyOneShape(e);

	    for (var t = [], n = "channelsLast" === this.dataFormat ? e.slice(1, e.length - 1) : e.slice(2), r = 0; r < n.length; ++r) {
	      var i = convOutputLength(n[r], this.kernelSize[r], this.padding, this.strides[r], "number" == typeof this.dilationRate ? this.dilationRate : this.dilationRate[r]);
	      t.push(i);
	    }

	    var a = [e[0]];
	    return "channelsLast" === this.dataFormat ? (a = a.concat(t)).push(this.filters) : (a.push(this.filters), a = a.concat(t)), a;
	  }, t.prototype.getConfig = function () {
	    var t = {
	      filters: this.filters,
	      kernelInitializer: serializeInitializer(this.kernelInitializer),
	      kernelRegularizer: serializeRegularizer(this.kernelRegularizer),
	      kernelConstraint: serializeConstraint(this.kernelConstraint)
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.verifyArgs = function (e) {
	    if (!("filters" in e) || "number" != typeof e.filters || e.filters < 1) throw new ValueError("Convolution layer expected config.filters to be a 'number' > 0 but got " + JSON.stringify(e.filters));
	  }, t;
	}(BaseConv),
	    Conv2D = function (e) {
	  function t(n) {
	    var r = e.call(this, 2, n) || this;
	    return t.verifyArgs(n), r;
	  }

	  return __extends(t, e), t.prototype.getConfig = function () {
	    var t = e.prototype.getConfig.call(this);
	    return delete t.rank, t;
	  }, t.verifyArgs = function (e) {
	    if ("number" != typeof e.kernelSize && !checkArrayTypeAndLength(e.kernelSize, "number", 1, 2)) throw new ValueError("Conv2D expects config.kernelSize to be number or number[] with length 1 or 2, but received " + JSON.stringify(e.kernelSize) + ".");
	  }, t.className = "Conv2D", t;
	}(Conv);

	Ph.registerClass(Conv2D);

	var Conv3D = function (e) {
	  function t(n) {
	    var r = e.call(this, 3, n) || this;
	    return t.verifyArgs(n), r;
	  }

	  return __extends(t, e), t.prototype.getConfig = function () {
	    var t = e.prototype.getConfig.call(this);
	    return delete t.rank, t;
	  }, t.verifyArgs = function (e) {
	    if ("number" != typeof e.kernelSize && (!Array.isArray(e.kernelSize) || 1 !== e.kernelSize.length && 3 !== e.kernelSize.length)) throw new ValueError("Conv3D expects config.kernelSize to be number or [number, number, number], but received " + JSON.stringify(e.kernelSize) + ".");
	  }, t.className = "Conv3D", t;
	}(Conv);

	Ph.registerClass(Conv3D);

	var Conv2DTranspose = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    if (n.inputSpec = [new InputSpec({
	      ndim: 4
	    })], "same" !== n.padding && "valid" !== n.padding) throw new ValueError("Conv2DTranspose currently supports only padding modes 'same' and 'valid', but received padding mode " + n.padding);
	    return n;
	  }

	  return __extends(t, e), t.prototype.build = function (e) {
	    var t;
	    if (4 !== (e = getExactlyOneShape(e)).length) throw new ValueError("Input should have rank 4; Received input shape: " + JSON.stringify(e));
	    var n = "channelsFirst" === this.dataFormat ? 1 : e.length - 1;
	    if (null == e[n]) throw new ValueError("The channel dimension of the inputs should be defined. Found `None`.");
	    var r = e[n],
	        i = this.kernelSize.concat([this.filters, r]);
	    this.kernel = this.addWeight("kernel", i, "float32", this.kernelInitializer, this.kernelRegularizer, !0, this.kernelConstraint), this.useBias && (this.bias = this.addWeight("bias", [this.filters], "float32", this.biasInitializer, this.biasRegularizer, !0, this.biasConstraint)), this.inputSpec = [new InputSpec({
	      ndim: 4,
	      axes: (t = {}, t[n] = r, t)
	    })], this.built = !0;
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      var t = getExactlyOneTensor(e);
	      if (4 !== t.shape.length) throw new ValueError("Conv2DTranspose.call() expects input tensor to be rank-4, but received a tensor of rank-" + t.shape.length);
	      var r,
	          i,
	          a = t.shape,
	          o = a[0];
	      "channelsFirst" === n.dataFormat ? (r = 2, i = 3) : (r = 1, i = 2);
	      var s = a[r],
	          l = a[i],
	          u = n.kernelSize[0],
	          c = n.kernelSize[1],
	          p = n.strides[0],
	          h = n.strides[1],
	          d = [o, deconvLength(s, p, u, n.padding), deconvLength(l, h, c, n.padding), n.filters];
	      "channelsLast" !== n.dataFormat && (t = Dl(t, [0, 2, 3, 1]));
	      var f = cu(t, n.kernel.read(), d, n.strides, n.padding);
	      return "channelsLast" !== n.dataFormat && (f = Dl(f, [0, 3, 1, 2])), null != n.bias && (f = biasAdd(f, n.bias.read(), n.dataFormat)), null != n.activation && (f = n.activation.apply(f)), f;
	    });
	  }, t.prototype.computeOutputShape = function (e) {
	    var t,
	        n,
	        r,
	        i = (e = getExactlyOneShape(e)).slice();
	    "channelsFirst" === this.dataFormat ? (t = 1, n = 2, r = 3) : (t = 3, n = 1, r = 2);
	    var a = this.kernelSize[0],
	        o = this.kernelSize[1],
	        s = this.strides[0],
	        l = this.strides[1];
	    return i[t] = this.filters, i[n] = deconvLength(i[n], s, a, this.padding), i[r] = deconvLength(i[r], l, o, this.padding), i;
	  }, t.prototype.getConfig = function () {
	    var t = e.prototype.getConfig.call(this);
	    return delete t.dilationRate, t;
	  }, t.className = "Conv2DTranspose", t;
	}(Conv2D);

	Ph.registerClass(Conv2DTranspose);

	var SeparableConv = function (e) {
	  function t(t, n) {
	    var r = e.call(this, t, n) || this;
	    if (r.DEFAULT_DEPTHWISE_INITIALIZER = "glorotUniform", r.DEFAULT_POINTWISE_INITIALIZER = "glorotUniform", r.depthwiseKernel = null, r.pointwiseKernel = null, null == n.filters) throw new ValueError("The `filters` configuration field is required by SeparableConv, but is unspecified.");
	    if (null != n.kernelInitializer || null != n.kernelRegularizer || null != n.kernelConstraint) throw new ValueError("Fields kernelInitializer, kernelRegularizer and kernelConstraint are invalid for SeparableConv2D. Use depthwiseInitializer, depthwiseRegularizer, depthwiseConstraint, pointwiseInitializer, pointwiseRegularizer and pointwiseConstraint instead.");
	    if (null != n.padding && "same" !== n.padding && "valid" !== n.padding) throw new ValueError("SeparableConv" + r.rank + "D supports only padding modes: 'same' and 'valid', but received " + JSON.stringify(n.padding));
	    return r.depthMultiplier = null == n.depthMultiplier ? 1 : n.depthMultiplier, r.depthwiseInitializer = getInitializer(n.depthwiseInitializer || r.DEFAULT_DEPTHWISE_INITIALIZER), r.depthwiseRegularizer = getRegularizer(n.depthwiseRegularizer), r.depthwiseConstraint = getConstraint(n.depthwiseConstraint), r.pointwiseInitializer = getInitializer(n.depthwiseInitializer || r.DEFAULT_POINTWISE_INITIALIZER), r.pointwiseRegularizer = getRegularizer(n.pointwiseRegularizer), r.pointwiseConstraint = getConstraint(n.pointwiseConstraint), r;
	  }

	  return __extends(t, e), t.prototype.build = function (e) {
	    var t;
	    if ((e = getExactlyOneShape(e)).length < this.rank + 2) throw new ValueError("Inputs to SeparableConv" + this.rank + "D should have rank " + (this.rank + 2) + ", but received input shape: " + JSON.stringify(e));
	    var n = "channelsFirst" === this.dataFormat ? 1 : e.length - 1;
	    if (null == e[n] || e[n] < 0) throw new ValueError("The channel dimension of the inputs should be defined, but found " + JSON.stringify(e[n]));

	    for (var r = e[n], i = this.kernelSize.concat([r, this.depthMultiplier]), a = [], o = 0; o < this.rank; ++o) {
	      a.push(1);
	    }

	    a.push(r * this.depthMultiplier, this.filters);
	    this.depthwiseKernel = this.addWeight("depthwise_kernel", i, "float32", this.depthwiseInitializer, this.depthwiseRegularizer, !0, this.depthwiseConstraint), this.pointwiseKernel = this.addWeight("pointwise_kernel", a, "float32", this.pointwiseInitializer, this.pointwiseRegularizer, !0, this.pointwiseConstraint), this.useBias ? this.bias = this.addWeight("bias", [this.filters], "float32", this.biasInitializer, this.biasRegularizer, !0, this.biasConstraint) : this.bias = null, this.inputSpec = [new InputSpec({
	      ndim: this.rank + 2,
	      axes: (t = {}, t[n] = r, t)
	    })], this.built = !0;
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      var t;
	      if (e = getExactlyOneTensor(e), 1 === n.rank) throw new NotImplementedError("1D separable convolution is not implemented yet.");
	      return 2 === n.rank && ("channelsFirst" === n.dataFormat && (e = Dl(e, [0, 2, 3, 1])), t = lu(e, n.depthwiseKernel.read(), n.pointwiseKernel.read(), n.strides, n.padding, n.dilationRate, "NHWC")), n.useBias && (t = biasAdd(t, n.bias.read(), n.dataFormat)), null != n.activation && (t = n.activation.apply(t)), "channelsFirst" === n.dataFormat && (t = Dl(t, [0, 3, 1, 2])), t;
	    });
	  }, t.prototype.getConfig = function () {
	    var t = e.prototype.getConfig.call(this);
	    return delete t.rank, delete t.kernelInitializer, delete t.kernelRegularizer, delete t.kernelConstraint, t.depthwiseInitializer = serializeInitializer(this.depthwiseInitializer), t.pointwiseInitializer = serializeInitializer(this.pointwiseInitializer), t.depthwiseRegularizer = serializeRegularizer(this.depthwiseRegularizer), t.pointwiseRegularizer = serializeRegularizer(this.pointwiseRegularizer), t.depthwiseConstraint = serializeConstraint(this.depthwiseConstraint), t.pointwiseConstraint = serializeConstraint(this.pointwiseConstraint), t;
	  }, t.className = "SeparableConv", t;
	}(Conv),
	    SeparableConv2D = function (e) {
	  function t(t) {
	    return e.call(this, 2, t) || this;
	  }

	  return __extends(t, e), t.className = "SeparableConv2D", t;
	}(SeparableConv);

	Ph.registerClass(SeparableConv2D);

	var Conv1D = function (e) {
	  function t(n) {
	    var r = e.call(this, 1, n) || this;
	    return t.verifyArgs(n), r.inputSpec = [{
	      ndim: 3
	    }], r;
	  }

	  return __extends(t, e), t.prototype.getConfig = function () {
	    var t = e.prototype.getConfig.call(this);
	    return delete t.rank, delete t.dataFormat, t;
	  }, t.verifyArgs = function (e) {
	    if ("number" != typeof e.kernelSize && !checkArrayTypeAndLength(e.kernelSize, "number", 1, 1)) throw new ValueError("Conv1D expects config.kernelSize to be number or number[] with length 1, but received " + JSON.stringify(e.kernelSize) + ".");
	  }, t.className = "Conv1D", t;
	}(Conv);

	Ph.registerClass(Conv1D);

	var Cropping2D = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return "number" == typeof t.cropping ? n.cropping = [[t.cropping, t.cropping], [t.cropping, t.cropping]] : "number" == typeof t.cropping[0] ? n.cropping = [[t.cropping[0], t.cropping[0]], [t.cropping[1], t.cropping[1]]] : n.cropping = t.cropping, n.dataFormat = void 0 === t.dataFormat ? "channelsLast" : t.dataFormat, n.inputSpec = [{
	      ndim: 4
	    }], n;
	  }

	  return __extends(t, e), t.prototype.computeOutputShape = function (e) {
	    return "channelsFirst" === this.dataFormat ? [e[0], e[1], e[2] - this.cropping[0][0] - this.cropping[0][1], e[3] - this.cropping[1][0] - this.cropping[1][1]] : [e[0], e[1] - this.cropping[0][0] - this.cropping[0][1], e[2] - this.cropping[1][0] - this.cropping[1][1], e[3]];
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      return e = getExactlyOneTensor(e), "channelsLast" === n.dataFormat ? sliceAlongAxis(sliceAlongAxis(e, n.cropping[0][0], e.shape[1] - n.cropping[0][0] - n.cropping[0][1], 2), n.cropping[1][0], e.shape[2] - n.cropping[1][1] - n.cropping[1][0], 3) : sliceAlongAxis(sliceAlongAxis(e, n.cropping[0][0], e.shape[2] - n.cropping[0][0] - n.cropping[0][1], 3), n.cropping[1][0], e.shape[3] - n.cropping[1][1] - n.cropping[1][0], 4);
	    });
	  }, t.prototype.getConfig = function () {
	    var t = {
	      cropping: this.cropping,
	      dataFormat: this.dataFormat
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "Cropping2D", t;
	}(Layer);

	Ph.registerClass(Cropping2D);

	var UpSampling2D = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return n.DEFAULT_SIZE = [2, 2], n.inputSpec = [{
	      ndim: 4
	    }], n.size = null == t.size ? n.DEFAULT_SIZE : t.size, n.dataFormat = null == t.dataFormat ? "channelsLast" : t.dataFormat, n;
	  }

	  return __extends(t, e), t.prototype.computeOutputShape = function (e) {
	    if ("channelsFirst" === this.dataFormat) {
	      var t = null == e[2] ? null : this.size[0] * e[2],
	          n = null == e[3] ? null : this.size[1] * e[3];
	      return [e[0], e[1], t, n];
	    }

	    t = null == e[1] ? null : this.size[0] * e[1], n = null == e[2] ? null : this.size[1] * e[2];
	    return [e[0], t, n, e[3]];
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      var t = getExactlyOneTensor(e),
	          r = t.shape;

	      if ("channelsFirst" === n.dataFormat) {
	        t = Dl(t, [0, 2, 3, 1]);
	        var i = n.size[0] * r[2],
	            a = n.size[1] * r[3],
	            o = t.resizeNearestNeighbor([i, a]);
	        return Dl(o, [0, 3, 1, 2]);
	      }

	      i = n.size[0] * r[1], a = n.size[1] * r[2];
	      return t.resizeNearestNeighbor([i, a]);
	    });
	  }, t.prototype.getConfig = function () {
	    var t = {
	      size: this.size,
	      dataFormat: this.dataFormat
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "UpSampling2D", t;
	}(Layer);

	function depthwiseConv2d$1(e, t, n, r, i, a) {
	  return void 0 === n && (n = [1, 1]), void 0 === r && (r = "valid"), ze(function () {
	    null == i && (i = imageDataFormat()), checkDataFormat(i);
	    var o = preprocessConv2DInput(e, i);
	    if (4 !== e.rank) throw new ValueError("Input for depthwiseConv2d is required to be 4-D, but is instead " + e.rank + "-D");
	    if (4 !== t.rank) throw new ValueError("depthwiseKernel is required to be 4-D, but is instead " + t.rank + "-D");
	    return o = uu(o, t, n, "same" === r ? "same" : "valid", "NHWC", a), "channelsFirst" === i && (o = Dl(o, [0, 3, 1, 2])), o;
	  });
	}

	Ph.registerClass(UpSampling2D);

	var DepthwiseConv2D = function (e) {
	  function t(t) {
	    var n = e.call(this, 2, t) || this;
	    return n.depthwiseKernel = null, n.depthMultiplier = null == t.depthMultiplier ? 1 : t.depthMultiplier, n.depthwiseInitializer = getInitializer(t.depthwiseInitializer || n.DEFAULT_KERNEL_INITIALIZER), n.depthwiseConstraint = getConstraint(t.depthwiseConstraint), n.depthwiseRegularizer = getRegularizer(t.depthwiseRegularizer), n;
	  }

	  return __extends(t, e), t.prototype.build = function (e) {
	    if ((e = getExactlyOneShape(e)).length < 4) throw new ValueError("Inputs to DepthwiseConv2D should have rank 4. Received input shape: " + JSON.stringify(e) + ".");
	    var t = "channelsFirst" === this.dataFormat ? 1 : 3;
	    if (null == e[t] || e[t] < 0) throw new ValueError("The channel dimension of the inputs to DepthwiseConv2D should be defined, but is not (" + e[t] + ").");
	    var n = e[t],
	        r = [this.kernelSize[0], this.kernelSize[1], n, this.depthMultiplier];
	    this.depthwiseKernel = this.addWeight("depthwise_kernel", r, null, this.depthwiseInitializer, this.depthwiseRegularizer, !0, this.depthwiseConstraint), this.useBias ? this.bias = this.addWeight("bias", [n * this.depthMultiplier], null, this.biasInitializer, this.biasRegularizer, !0, this.biasConstraint) : this.bias = null, this.built = !0;
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      var t = depthwiseConv2d$1(e = getExactlyOneTensor(e), n.depthwiseKernel.read(), n.strides, n.padding, n.dataFormat, null);
	      return n.useBias && (t = biasAdd(t, n.bias.read(), n.dataFormat)), null != n.activation && (t = n.activation.apply(t)), t;
	    });
	  }, t.prototype.computeOutputShape = function (e) {
	    e = getExactlyOneShape(e);
	    var t = "channelsFirst" === this.dataFormat ? e[2] : e[1],
	        n = "channelsFirst" === this.dataFormat ? e[3] : e[2],
	        r = "channelsFirst" === this.dataFormat ? e[1] * this.depthMultiplier : e[3] * this.depthMultiplier,
	        i = convOutputLength(t, this.kernelSize[0], this.padding, this.strides[0]),
	        a = convOutputLength(n, this.kernelSize[1], this.padding, this.strides[1]);
	    return "channelsFirst" === this.dataFormat ? [e[0], r, i, a] : [e[0], i, a, r];
	  }, t.prototype.getConfig = function () {
	    var t = e.prototype.getConfig.call(this);
	    return t.depthMultiplier = this.depthMultiplier, t.depthwiseInitializer = serializeInitializer(this.depthwiseInitializer), t.depthwiseRegularizer = serializeRegularizer(this.depthwiseRegularizer), t.depthwiseConstraint = serializeConstraint(this.depthwiseRegularizer), t;
	  }, t.className = "DepthwiseConv2D", t;
	}(BaseConv);

	function mapActivationToFusedKernel(e) {
	  return "relu" === e ? "relu" : "linear" === e ? "linear" : null;
	}

	Ph.registerClass(DepthwiseConv2D);

	var Dropout = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    if (n.rate = Math.max(Math.min(t.rate, 1), 0), n.noiseShape = t.noiseShape, n.seed = t.seed, null != n.seed) throw new NotImplementedError("Non-default seed is not implemented in Dropout layer yet: " + n.seed);
	    return n.supportsMasking = !0, n;
	  }

	  return __extends(t, e), t.prototype.getNoiseShape = function (e) {
	    if (null == this.noiseShape) return this.noiseShape;

	    for (var t = e.shape, n = [], r = 0; r < this.noiseShape.length; ++r) {
	      n.push(null == this.noiseShape[r] ? t[r] : this.noiseShape[r]);
	    }

	    return n;
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      n.invokeCallHook(e, t);
	      var r = getExactlyOneTensor(e);
	      if (null != n.noiseShape && !Q.arraysEqual(r.shape, n.noiseShape)) throw new NotImplementedError("Non-default noise shape is not implemented in Dropout layer yet: " + JSON.stringify(n.noiseShape));

	      if (0 < n.rate && n.rate < 1) {
	        var i = null != t.training && t.training,
	            a = n.getNoiseShape(r);
	        return inTrainPhase(function () {
	          return dropout$1(r, n.rate, a, n.seed);
	        }, function () {
	          return r;
	        }, i);
	      }

	      return e;
	    });
	  }, t.prototype.getConfig = function () {
	    var t = {
	      rate: this.rate,
	      noiseShape: this.noiseShape,
	      seed: this.seed
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.prototype.dispose = function () {
	    return e.prototype.dispose.call(this);
	  }, t.className = "Dropout", t;
	}(Layer);

	Ph.registerClass(Dropout);

	var Dense = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;

	    if (n.activation = null, n.useBias = !0, n.kernel = null, n.bias = null, n.DEFAULT_KERNEL_INITIALIZER = "glorotNormal", n.DEFAULT_BIAS_INITIALIZER = "zeros", null == t.batchInputShape && null == t.inputShape && null != t.inputDim) {
	      var r = null;
	      null != t.batchSize && (r = t.batchSize), n.batchInputShape = [r, t.inputDim];
	    }

	    return n.units = t.units, assertPositiveInteger(n.units, "units"), n.activation = getActivation(t.activation), null != t.useBias && (n.useBias = t.useBias), n.kernelInitializer = getInitializer(t.kernelInitializer || n.DEFAULT_KERNEL_INITIALIZER), n.biasInitializer = getInitializer(t.biasInitializer || n.DEFAULT_BIAS_INITIALIZER), n.kernelConstraint = getConstraint(t.kernelConstraint), n.biasConstraint = getConstraint(t.biasConstraint), n.kernelRegularizer = getRegularizer(t.kernelRegularizer), n.biasRegularizer = getRegularizer(t.biasRegularizer), n.activityRegularizer = getRegularizer(t.activityRegularizer), n.supportsMasking = !0, n.inputSpec = [{
	      minNDim: 2
	    }], n;
	  }

	  return __extends(t, e), t.prototype.build = function (e) {
	    var t,
	        n = (e = getExactlyOneShape(e))[e.length - 1];
	    null == this.kernel && (this.kernel = this.addWeight("kernel", [n, this.units], null, this.kernelInitializer, this.kernelRegularizer, !0, this.kernelConstraint), this.useBias && (this.bias = this.addWeight("bias", [this.units], null, this.biasInitializer, this.biasRegularizer, !0, this.biasConstraint))), this.inputSpec = [{
	      minNDim: 2,
	      axes: (t = {}, t[-1] = n, t)
	    }], this.built = !0;
	  }, t.prototype.computeOutputShape = function (e) {
	    var t = (e = getExactlyOneShape(e)).slice();
	    return t[t.length - 1] = this.units, t;
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      n.invokeCallHook(e, t);
	      var r,
	          i = getExactlyOneTensor(e),
	          a = mapActivationToFusedKernel(n.activation.getClassName());
	      return null != a ? r = dot(i, n.kernel.read(), a, n.bias ? n.bias.read() : null) : (r = dot(i, n.kernel.read()), null != n.bias && (r = biasAdd(r, n.bias.read())), null != n.activation && (r = n.activation.apply(r))), r;
	    });
	  }, t.prototype.getConfig = function () {
	    var t = {
	      units: this.units,
	      activation: serializeActivation(this.activation),
	      useBias: this.useBias,
	      kernelInitializer: serializeInitializer(this.kernelInitializer),
	      biasInitializer: serializeInitializer(this.biasInitializer),
	      kernelRegularizer: serializeRegularizer(this.kernelRegularizer),
	      biasRegularizer: serializeRegularizer(this.biasRegularizer),
	      activityRegularizer: serializeRegularizer(this.activityRegularizer),
	      kernelConstraint: serializeConstraint(this.kernelConstraint),
	      biasConstraint: serializeConstraint(this.biasConstraint)
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "Dense", t;
	}(Layer);

	Ph.registerClass(Dense);

	var Flatten = function (e) {
	  function t(t) {
	    var n = e.call(this, t || {}) || this;
	    return n.inputSpec = [{
	      minNDim: 3
	    }], n;
	  }

	  return __extends(t, e), t.prototype.computeOutputShape = function (e) {
	    for (var t = 0, n = (e = getExactlyOneShape(e)).slice(1); t < n.length; t++) {
	      if (null == n[t]) throw new ValueError('The shape of the input to "Flatten" is not fully defined (got ' + e.slice(1) + '). Make sure to pass a complete "input_shape" or "batch_input_shape" argument to the first layer in your model.');
	    }

	    return [e[0], arrayProd(e, 1)];
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      return n.invokeCallHook(e, t), batchFlatten(getExactlyOneTensor(e));
	    });
	  }, t.className = "Flatten", t;
	}(Layer);

	Ph.registerClass(Flatten);

	var Activation$1 = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return n.supportsMasking = !0, n.activation = getActivation(t.activation), n;
	  }

	  return __extends(t, e), t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      n.invokeCallHook(e, t);
	      var r = getExactlyOneTensor(e);
	      return n.activation.apply(r);
	    });
	  }, t.prototype.getConfig = function () {
	    var t = {
	      activation: serializeActivation(this.activation)
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "Activation", t;
	}(Layer);

	Ph.registerClass(Activation$1);

	var RepeatVector = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return n.n = t.n, n.inputSpec = [{
	      ndim: 2
	    }], n;
	  }

	  return __extends(t, e), t.prototype.computeOutputShape = function (e) {
	    return [e[0], this.n, e[1]];
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      return repeat(e = getExactlyOneTensor(e), n.n);
	    });
	  }, t.prototype.getConfig = function () {
	    var t = {
	      n: this.n
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "RepeatVector", t;
	}(Layer);

	Ph.registerClass(RepeatVector);

	var Reshape = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    n.targetShape = t.targetShape;

	    for (var r = 0; r < n.targetShape.length; ++r) {
	      n.isUnknown(n.targetShape[r]) && (n.targetShape[r] = null);
	    }

	    return n;
	  }

	  return __extends(t, e), t.prototype.isUnknown = function (e) {
	    return e < 0 || null == e;
	  }, t.prototype.fixUnknownDimension = function (e, t) {
	    for (var n = "Total size of new array must be unchanged.", r = t.slice(), i = 1, a = null, o = 0; o < r.length; ++o) {
	      var s = r[o];

	      if (this.isUnknown(s)) {
	        if (null !== a) throw new ValueError("Can only specifiy one unknown dimension.");
	        a = o;
	      } else i *= s;
	    }

	    var l = arrayProd(e);

	    if (null !== a) {
	      if (0 === i || l % i != 0) throw new ValueError(n);
	      r[a] = l / i;
	    } else if (l !== i) throw new ValueError(n);

	    return r;
	  }, t.prototype.computeOutputShape = function (e) {
	    for (var t = !1, n = 0; n < e.length; ++n) {
	      if (this.isUnknown(e[n])) {
	        t = !0;
	        break;
	      }
	    }

	    return t ? e.slice(0, 1).concat(this.targetShape) : e.slice(0, 1).concat(this.fixUnknownDimension(e.slice(1), this.targetShape));
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      n.invokeCallHook(e, t);
	      var r = getExactlyOneTensor(e),
	          i = r.shape,
	          a = i.slice(0, 1).concat(n.fixUnknownDimension(i.slice(1), n.targetShape));
	      return r.reshape(a);
	    });
	  }, t.prototype.getConfig = function () {
	    var t = {
	      targetShape: this.targetShape
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "Reshape", t;
	}(Layer);

	Ph.registerClass(Reshape);

	var Permute = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    if (null == t.dims) throw new Error("Required configuration field `dims` is missing during Permute constructor call.");
	    if (!Array.isArray(t.dims)) throw new Error("Permute constructor requires `dims` to be an Array, but received " + t.dims + " instead.");
	    var r = range(1, t.dims.length + 1);
	    if (!Q.arraysEqual(t.dims.slice().sort(), r)) throw new Error("Invalid permutation `dims`: " + JSON.stringify(t.dims) + " `dims` must contain consecutive integers starting from 1.");
	    return n.dims = t.dims, n.dimsIncludingBatch = [0].concat(n.dims), n.inputSpec = [new InputSpec({
	      ndim: n.dims.length + 1
	    })], n;
	  }

	  return __extends(t, e), t.prototype.computeOutputShape = function (e) {
	    var t = (e = getExactlyOneShape(e)).slice();
	    return this.dims.forEach(function (n, r) {
	      t[r + 1] = e[n];
	    }), t;
	  }, t.prototype.call = function (e, t) {
	    return Dl(getExactlyOneTensor(e), this.dimsIncludingBatch);
	  }, t.prototype.getConfig = function () {
	    var t = {
	      dims: this.dims
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "Permute", t;
	}(Layer);

	Ph.registerClass(Permute);

	var Masking = function (e) {
	  function t(t) {
	    var n = e.call(this, null == t ? {} : t) || this;
	    return n.supportsMasking = !0, n.maskValue = null != t ? null == t.maskValue ? 0 : t.maskValue : 0, n;
	  }

	  return __extends(t, e), t.prototype.computeOutputShape = function (e) {
	    return e;
	  }, t.prototype.getConfig = function () {
	    var t = e.prototype.getConfig.call(this),
	        n = {
	      maskValue: this.maskValue
	    };
	    return Object.assign(n, t), n;
	  }, t.prototype.computeMask = function (e, t) {
	    var n = getExactlyOneTensor(e);
	    return Du(Qu(n, this.maskValue), -1);
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      n.invokeCallHook(e, t);
	      var r = getExactlyOneTensor(e),
	          i = Du(Qu(r, n.maskValue), -1, !0);
	      return r.mul(i.asType(r.dtype));
	    });
	  }, t.className = "Masking", t;
	}(Layer);

	Ph.registerClass(Masking);

	var Embedding = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;

	    if (n.embeddings = null, n.DEFAULT_EMBEDDINGS_INITIALIZER = "randomUniform", null == t.batchInputShape && null == t.inputShape) {
	      var r = null;
	      null != t.batchSize && (r = t.batchSize), null == t.inputLength ? n.batchInputShape = [r, null] : n.batchInputShape = [r].concat(toList(t.inputLength));
	    }

	    return n.inputDim = t.inputDim, assertPositiveInteger(n.inputDim, "inputDim"), n.outputDim = t.outputDim, assertPositiveInteger(n.outputDim, "outputDim"), n.embeddingsInitializer = getInitializer(t.embeddingsInitializer || n.DEFAULT_EMBEDDINGS_INITIALIZER), n.embeddingsRegularizer = getRegularizer(t.embeddingsRegularizer), n.activityRegularizer = getRegularizer(t.activityRegularizer), n.embeddingsConstraint = getConstraint(t.embeddingsConstraint), n.maskZero = t.maskZero, n.supportsMasking = t.maskZero, n.inputLength = t.inputLength, n;
	  }

	  return __extends(t, e), t.prototype.build = function (e) {
	    this.embeddings = this.addWeight("embeddings", [this.inputDim, this.outputDim], this.dtype, this.embeddingsInitializer, this.embeddingsRegularizer, !0, this.embeddingsConstraint), this.built = !0;
	  }, t.prototype.warnOnIncompatibleInputShape = function (e) {}, t.prototype.computeMask = function (e, t) {
	    var n = this;
	    return ze(function () {
	      return n.maskZero ? (e = getExactlyOneTensor(e), Qu(e, Mn(e))) : null;
	    });
	  }, t.prototype.computeOutputShape = function (e) {
	    if (e = getExactlyOneShape(e), null == this.inputLength) return e.concat([this.outputDim]);
	    var t = toList(this.inputLength);
	    if (t.length !== e.length - 1) throw new ValueError('"inputLength" is ' + this.inputLength + ", but received input shape has shape " + e);

	    for (var n = 0, r = 0; r < t.length; ++r) {
	      var i = t[r],
	          a = e[r + 1];
	      if (null != i && null != a && i !== a) throw new ValueError('"inputLength" is ' + this.inputLength + ", but received input shape has shape " + e);
	      null == i && (t[n] = a), n++;
	    }

	    return [e[0]].concat(t, [this.outputDim]);
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      n.invokeCallHook(e, t);
	      var r = getExactlyOneTensor(e);
	      return "int32" !== r.dtype && (r = cast$1(r, "int32")), gather$1(n.embeddings.read(), r.as1D()).reshape(getExactlyOneShape(n.computeOutputShape(r.shape)));
	    });
	  }, t.prototype.getConfig = function () {
	    var t = {
	      inputDim: this.inputDim,
	      outputDim: this.outputDim,
	      embeddingsInitializer: serializeInitializer(this.embeddingsInitializer),
	      embeddingsRegularizer: serializeRegularizer(this.embeddingsRegularizer),
	      activityRegularizer: serializeRegularizer(this.activityRegularizer),
	      embeddingsConstraint: serializeConstraint(this.embeddingsConstraint),
	      maskZero: this.maskZero,
	      inputLength: this.inputLength
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "Embedding", t;
	}(Layer);

	Ph.registerClass(Embedding);

	var Merge = function (e) {
	  function t(t) {
	    var n = e.call(this, t || {}) || this;
	    return n.supportsMasking = !0, n;
	  }

	  return __extends(t, e), t.prototype.mergeFunction = function (e) {
	    throw new NotImplementedError();
	  }, t.prototype.computeElementwiseOpOutputShape = function (e, t) {
	    if (null == e || null == t) return null;
	    if (e.length < t.length) return this.computeElementwiseOpOutputShape(t, e);
	    if (0 === t.length) return e;

	    for (var n = e.slice(0, e.length - t.length), r = 0; r < t.length; ++r) {
	      var i = e[e.length - t.length + r],
	          a = t[r];
	      if (null == i || null == a || i < 0 || a < 0) n.push(null);else if (1 === i) n.push(a);else if (1 === a) n.push(i);else {
	        if (i !== a) throw new ValueError("Operands could not be broadcast together with shapes " + JSON.stringify(e) + " " + JSON.stringify(t));
	        n.push(i);
	      }
	    }

	    return n;
	  }, t.prototype.build = function (e) {
	    if (Array.isArray(e) && !Array.isArray(e[0]) && (e = [getExactlyOneShape(e)]), (e = e).length < 2) throw new ValueError("A merge layer should be called on an Array of at least 2 inputs. Got " + e.length + " input(s).");

	    for (var t = [], n = 0, r = e; n < r.length; n++) {
	      null != (o = r[n]) && null !== o[0] && t.push(o[0]);
	    }

	    if ((t = unique(t)).length > 1) throw new ValueError("Can not merge tensors with different batch sizes. Got tensors with shapes: " + JSON.stringify(e) + ".");

	    for (var i = null == e[0] ? null : e[0].slice(1), a = 1; a < e.length; ++a) {
	      var o = null == e[a] ? null : e[a].slice(1);
	      i = this.computeElementwiseOpOutputShape(i, o);
	    }

	    var s = e.map(function (e) {
	      return e.length;
	    });
	    -1 === e.indexOf(null) && 1 === unique(s).length ? this.reshapeRequired = !1 : this.reshapeRequired = !0;
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      if (e = e, n.reshapeRequired) {
	        var t = [],
	            r = e.map(function (e) {
	          return e.rank;
	        });

	        if (-1 === r.indexOf(null)) {
	          for (var i = max$1(r), a = 0, o = e; a < o.length; a++) {
	            for (var s = (h = o[a]).rank, l = 0; l < i - s; ++l) {
	              h = expandDims$1(h, 1);
	            }

	            t.push(h);
	          }

	          return n.mergeFunction(t);
	        }

	        for (var u = !1, c = 0, p = e; c < p.length; c++) {
	          var h;

	          if (null == (s = (h = p[c]).rank)) {
	            var d = h.shape,
	                f = d[0],
	                g = d.slice(1).concat([f]),
	                m = h.reshape([f].concat(arrayProd(d.slice(1))));
	            m = (m = Dl(m, [1, 0])).reshape(g), t.push(m), u = !0;
	          } else if (s > 1) {
	            var y = range(1, s).concat([0]);
	            t.push(Dl(h, y)), u = !0;
	          } else t.push(h);
	        }

	        var v = n.mergeFunction(t),
	            b = v.rank;
	        if (u) if (null == b) {
	          var w = v.shape;
	          g = [f = w[w.length - 1]].concat(w.slice(0, w.length - 1));
	          v = Dl(v.reshape([-1, f]), [1, 0]).reshape(g);
	        } else if (b > 1) {
	          y = [b - 1].concat(range(0, b - 1));
	          v = Dl(v, y);
	        }
	        return v;
	      }

	      return n.mergeFunction(e);
	    });
	  }, t.prototype.computeOutputShape = function (e) {
	    var t;
	    t = null == (e = e)[0] ? null : e[0].slice(1);

	    for (var n = 1; n < e.length; ++n) {
	      var r = null == e[n] ? null : e[n].slice(1);
	      t = this.computeElementwiseOpOutputShape(t, r);
	    }

	    for (var i = [], a = 0, o = e; a < o.length; a++) {
	      null != (r = o[a]) && null !== r[0] && i.push(r[0]);
	    }

	    return t = 1 === (i = unique(i)).length ? i.concat(t) : [null].concat(t);
	  }, t.prototype.computeMask = function (e, t) {
	    return ze(function () {
	      if (null == t) return null;
	      if (!Array.isArray(t)) throw new ValueError("`mask` should be an Array");
	      if (!Array.isArray(e)) throw new ValueError("`inputs` should be an Array");
	      if (t.length !== e.length) throw new ValueError("The Array 'inputs' and 'mask' are expected to have the same length, but have different lengths (" + e.length + " vs " + t.length + ")");
	      if (t.every(function (e) {
	        return null == e;
	      })) return null;

	      for (var n = (t = t.map(function (e) {
	        return null == e ? e : ir(e, 0);
	      }))[0], r = 1; r < t.length - 1; ++r) {
	        n = bl(n, t[r]);
	      }

	      return n;
	    });
	  }, t;
	}(Layer),
	    Add = function (e) {
	  function t(t) {
	    return e.call(this, t) || this;
	  }

	  return __extends(t, e), t.prototype.mergeFunction = function (e) {
	    return ze(function () {
	      for (var t = e[0].clone(), n = 1; n < e.length; ++n) {
	        t = Zu(t, e[n]);
	      }

	      return t;
	    });
	  }, t.className = "Add", t;
	}(Merge);

	Ph.registerClass(Add);

	var Multiply = function (e) {
	  function t(t) {
	    return e.call(this, t) || this;
	  }

	  return __extends(t, e), t.prototype.mergeFunction = function (e) {
	    return ze(function () {
	      for (var t = e[0].clone(), n = 1; n < e.length; ++n) {
	        t = fl(t, e[n]);
	      }

	      return t;
	    });
	  }, t.className = "Multiply", t;
	}(Merge);

	Ph.registerClass(Multiply);

	var Average = function (e) {
	  function t(t) {
	    return e.call(this, t) || this;
	  }

	  return __extends(t, e), t.prototype.mergeFunction = function (e) {
	    return ze(function () {
	      for (var t = e[0].clone(), n = 1; n < e.length; ++n) {
	        t = Zu(t, e[n]);
	      }

	      return fl(1 / e.length, t);
	    });
	  }, t.className = "Average", t;
	}(Merge);

	Ph.registerClass(Average);

	var Maximum = function (e) {
	  function t(t) {
	    return e.call(this, t) || this;
	  }

	  return __extends(t, e), t.prototype.mergeFunction = function (e) {
	    return ze(function () {
	      for (var t = e[0], n = 1; n < e.length; ++n) {
	        t = il(t, e[n]);
	      }

	      return t;
	    });
	  }, t.className = "Maximum", t;
	}(Merge);

	Ph.registerClass(Maximum);

	var Minimum = function (e) {
	  function t(t) {
	    return e.call(this, t) || this;
	  }

	  return __extends(t, e), t.prototype.mergeFunction = function (e) {
	    return ze(function () {
	      for (var t = e[0], n = 1; n < e.length; ++n) {
	        t = ul(t, e[n]);
	      }

	      return t;
	    });
	  }, t.className = "Minimum", t;
	}(Merge);

	Ph.registerClass(Minimum);

	var Concatenate = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return n.DEFAULT_AXIS = -1, null == t && (t = {}), n.axis = null == t.axis ? n.DEFAULT_AXIS : t.axis, n.supportsMasking = !0, n.reshapeRequired = !1, n;
	  }

	  return __extends(t, e), t.prototype.build = function (e) {
	    if (!Array.isArray(e) || !Array.isArray(e[0]) || 1 === e.length) throw new ValueError("A `Concatenate` layer should be called on a list of at least 2 inputs");

	    for (var t = !0, n = 0, r = e = e; n < r.length; n++) {
	      if (null != (c = r[n])) {
	        t = !1;
	        break;
	      }
	    }

	    if (!t) {
	      for (var i = [], a = 0; a < e.length; ++a) {
	        var o = e[a].slice();
	        o.splice(this.axis, 1);

	        for (var s = !1, l = 0, u = i; l < u.length; l++) {
	          var c = u[l];

	          if (Q.arraysEqual(c, o)) {
	            s = !0;
	            break;
	          }
	        }

	        s || i.push(o);
	      }

	      if (i.length > 1) throw new ValueError("A `Concatenate` layer requires inputs with matching shapes except for the concat axis. Got input shapes: " + JSON.stringify(e));
	    }
	  }, t.prototype.mergeFunction = function (e) {
	    var t = this;
	    return ze(function () {
	      return concatenate(e, t.axis);
	    });
	  }, t.prototype.computeOutputShape = function (e) {
	    if (!Array.isArray(e) || !Array.isArray(e[0])) throw new ValueError("A `Concatenate` layer should be called on a list of inputs.");

	    for (var t = e, n = t[0].slice(), r = this.axis < 0 ? n.length + this.axis : this.axis, i = 0, a = t.slice(1); i < a.length; i++) {
	      var o = a[i];

	      if (null == n[r] || null == o[r]) {
	        n[r] = null;
	        break;
	      }

	      n[r] += o[r];
	    }

	    return n;
	  }, t.prototype.computeMask = function (e, t) {
	    var n = this;
	    if (null == t) return null;
	    if (!Array.isArray(t)) throw new ValueError("`mask` should be an array for Concatenate");
	    if (!Array.isArray(e)) throw new ValueError("`inputs` should be an array for Concatenate");
	    if (t.length !== e.length) throw new ValueError("Mismatch in the length of mask (" + t.length + ") and the legnth of inputs (" + e.length + ")");
	    return ze(function () {
	      var r = !0;
	      if (t.forEach(function (e) {
	        null == e || (r = !1);
	      }), r) return null;

	      for (var i = [], a = 0; a < e.length; ++a) {
	        null == t[a] ? i.push(Fn(e[a]).asType("bool")) : t[a].rank < e[a].rank ? i.push(ir(t[a], -1)) : i.push(t[a]);
	      }

	      var o = Bn(i, n.axis);
	      return Tu(o, -1, !1);
	    });
	  }, t.prototype.getConfig = function () {
	    var t = {
	      axis: this.axis
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "Concatenate", t;
	}(Merge);

	function interpretAxis(e, t) {
	  for (; e < 0;) {
	    e += t;
	  }

	  return e;
	}

	function batchDot(e, t, n) {
	  if (e.shape.length > 3 || t.shape.length > 3) throw new NotImplementedError("batchDot is not implemented for tensors of 4D or higher rank yet");
	  if (Q.assert(e.shape.length >= 2, function () {
	    return "batchDot requires the rank of x to be >= 2, but got " + e.shape.length;
	  }), Q.assert(e.shape.length >= 2, function () {
	    return "batchDot requires the rank of y to be >= 2, but got " + t.shape.length;
	  }), "number" == typeof n && (n = [n, n]), "complex64" === e.dtype || "complex64" === t.dtype) throw new NotImplementedError("batchDot is not implemented for complex64-type Tensors yet.");
	  var r = e.shape.length,
	      i = t.shape.length;
	  null == n && (n = [r - 1, i - 2]);
	  var a = n;
	  return ze(function () {
	    var n, o;

	    if (r > i) {
	      n = r - i;

	      for (var s = [], l = 0; l < n; ++l) {
	        s.push(1);
	      }

	      t = t.reshape(t.shape.concat(s));
	    } else if (i > r) {
	      n = i - r;

	      for (s = [], l = 0; l < n; ++l) {
	        s.push(1);
	      }

	      e = e.reshape(e.shape.concat(s));
	    } else n = 0;

	    if (2 === e.shape.length && 2 === t.shape.length) o = a[0] === a[1] ? e.mulStrict(t).sum(a[0]) : e.transpose([1, 0]).mulStrict(t).sum(a[1]);else {
	      var u = a[0] !== e.shape.length - 1,
	          c = a[1] === t.shape.length - 1;
	      o = e.matMul(t, u, c);
	    }

	    if (n > 0) {
	      var p = void 0,
	          h = [];

	      for (l = p = r > i ? r + i - 3 : r - 1; l < p + n; ++l) {
	        h.push(l);
	      }

	      o = o.squeeze(h);
	    }

	    return 1 === o.shape.length && (o = o.expandDims(1)), o;
	  });
	}

	Ph.registerClass(Concatenate);

	var Dot = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return n.axes = t.axes, n.normalize = null != t.normalize && t.normalize, n.supportsMasking = !0, n.reshapeRequired = !1, n;
	  }

	  return __extends(t, e), t.prototype.build = function (e) {
	    Q.assert(Array.isArray(e) && 2 === e.length && Array.isArray(e[0]) && Array.isArray(e[1]), function () {
	      return "A `Dot` layer should be called on a list of exactly 2 inputs.";
	    });
	    var t = e[0],
	        n = e[1];
	    if (t.length > 3 || n.length > 3) throw new NotImplementedError("Dot layer does not support tensors of 4D or higher rank yet.");
	    var r = this.interpretAxes(t, n);
	    if (t[r[0]] !== n[r[1]]) throw new ValueError("Dimension incompatibility: " + t[r[0]] + " !== " + n[r[1]]);
	  }, t.prototype.mergeFunction = function (e) {
	    if (2 !== e.length) throw new ValueError("A `Dot` layer must be called on exactly 2 inputs, but received " + e.length + " input(s).");
	    var t,
	        n = e[0],
	        r = e[1];
	    return t = Array.isArray(this.axes) ? this.axes.map(function (t, n) {
	      return interpretAxis(t, e[n].shape.length);
	    }) : [interpretAxis(this.axes, n.shape.length), interpretAxis(this.axes, r.shape.length)], this.normalize && (n = l2Normalize(n, t[0]), r = l2Normalize(r, t[1])), batchDot(n, r, t);
	  }, t.prototype.interpretAxes = function (e, t) {
	    return Array.isArray(this.axes) ? this.axes : [interpretAxis(this.axes, e.length), interpretAxis(this.axes, t.length)];
	  }, t.prototype.computeOutputShape = function (e) {
	    Q.assert(Array.isArray(e) && 2 === e.length && Array.isArray(e[0]) && Array.isArray(e[1]), function () {
	      return "A `Dot` layer should be called on a list of exactly 2 inputs.";
	    });
	    var t = e[0].slice(),
	        n = e[1].slice();
	    if (t.length > 3 || n.length > 3) throw new NotImplementedError("Dot layer does not support tensors of 4D or higher rank yet.");
	    var r = this.interpretAxes(t, n);
	    t.splice(r[0], 1), n.splice(r[1], 1), n.splice(0, 1);
	    var i = t.concat(n);
	    return 1 === i.length && i.push(1), i;
	  }, t.prototype.computeMask = function (e, t) {
	    return null;
	  }, t.prototype.getConfig = function () {
	    var t = {
	      axes: this.axes,
	      normalize: this.normalize
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "Dot", t;
	}(Merge);

	Ph.registerClass(Dot);

	var GaussianNoise = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return n.supportsMasking = !0, n.stddev = t.stddev, n;
	  }

	  return __extends(t, e), t.prototype.computeOutputShape = function (e) {
	    return e;
	  }, t.prototype.getConfig = function () {
	    var t = e.prototype.getConfig.call(this),
	        n = {
	      stddev: this.stddev
	    };
	    return Object.assign(n, t), n;
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      n.invokeCallHook(e, t);
	      var r = getExactlyOneTensor(e);
	      return inTrainPhase(function () {
	        return randomNormal$1(r.shape, 0, n.stddev).add(r);
	      }, function () {
	        return r;
	      }, t.training || !1);
	    });
	  }, t.className = "GaussianNoise", t;
	}(Layer);

	Ph.registerClass(GaussianNoise);

	var GaussianDropout = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return n.supportsMasking = !0, n.rate = t.rate, n;
	  }

	  return __extends(t, e), t.prototype.computeOutputShape = function (e) {
	    return e;
	  }, t.prototype.getConfig = function () {
	    var t = e.prototype.getConfig.call(this),
	        n = {
	      rate: this.rate
	    };
	    return Object.assign(n, t), n;
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      n.invokeCallHook(e, t);
	      var r = getExactlyOneTensor(e);

	      if (n.rate > 0 && n.rate < 1) {
	        return inTrainPhase(function () {
	          var e = Math.sqrt(n.rate / (1 - n.rate));
	          return r.mul(randomNormal$1(r.shape, 1, e));
	        }, function () {
	          return r;
	        }, t.training || !1);
	      }

	      return r;
	    });
	  }, t.className = "GaussianDropout", t;
	}(Layer);

	Ph.registerClass(GaussianDropout);

	var AlphaDropout = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return n.supportsMasking = !0, n.rate = t.rate, n.noiseShape = t.noiseShape, n;
	  }

	  return __extends(t, e), t.prototype._getNoiseShape = function (e) {
	    return this.noiseShape || getExactlyOneTensor(e).shape;
	  }, t.prototype.computeOutputShape = function (e) {
	    return e;
	  }, t.prototype.getConfig = function () {
	    var t = e.prototype.getConfig.call(this),
	        n = {
	      rate: this.rate
	    };
	    return Object.assign(n, t), n;
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      if (n.rate < 1 && n.rate > 0) {
	        var r = n._getNoiseShape(e);

	        return inTrainPhase(function () {
	          var t = getExactlyOneTensor(e),
	              i = -1.7580993408473766,
	              a = Hu(gr(r), n.rate);
	          a = cast$1(a, "float32");
	          var o = Math.pow((1 - n.rate) * (1 + n.rate * Math.pow(i, 2)), -.5),
	              s = -o * i * n.rate;
	          return t.mul(a).add(a.add(-1).mul(i)).mul(o).add(s);
	        }, function () {
	          return getExactlyOneTensor(e);
	        }, t.training || !1);
	      }

	      return e;
	    });
	  }, t.className = "AlphaDropout", t;
	}(Layer);

	function batchNormalization(e, t, n, r, i, a) {
	  var o;
	  if (void 0 === a && (a = .001), 2 === e.rank) o = Qs(e, t, n, r, i, a);else if (3 === e.rank) o = Js(e, t, n, r, i, a);else {
	    if (4 !== e.rank) throw new NotImplementedError("batchNormalization is not implemented for array of rank " + e.rank + " yet");
	    o = Zs(e, t, n, r, i, a);
	  }
	  return o;
	}

	function regularNormalizeBatchInTraining(e, t, n, r, i) {
	  return void 0 === i && (i = .001), ze(function () {
	    var a = Lu(e, r),
	        o = a.mean,
	        s = a.variance;
	    return [batchNormalization(e, o, s, n, t, i), o, s];
	  });
	}

	function broadcastNormalizeBatchInTraining(e, t, n, r, i) {
	  return void 0 === i && (i = .001), ze(function () {
	    for (var a = Lu(e, r), o = a.mean, s = a.variance, l = [], u = 0, c = range(0, e.rank); u < c.length; u++) {
	      var p = c[u];
	      -1 !== r.indexOf(p) ? l.push(1) : l.push(e.shape[p]);
	    }

	    var h = o.reshape(l),
	        d = s.reshape(l),
	        f = null == t ? null : t.reshape(l),
	        g = null == n ? null : n.reshape(l);
	    return [batchNormalization(e, h, d, g, f, i), o, s];
	  });
	}

	function normalizeBatchInTraining(e, t, n, r, i) {
	  return void 0 === i && (i = .001), Q.arraysEqual(r.slice().sort(), range(0, e.rank - 1)) ? regularNormalizeBatchInTraining(e, t, n, r, i) : broadcastNormalizeBatchInTraining(e, t, n, r, i);
	}

	Ph.registerClass(AlphaDropout);

	var BatchNormalization = function (e) {
	  function t(t) {
	    var n = this;
	    return null == t && (t = {}), (n = e.call(this, t) || this).supportsMasking = !0, n.axis = null == t.axis ? -1 : t.axis, n.momentum = null == t.momentum ? .99 : t.momentum, n.epsilon = null == t.epsilon ? .001 : t.epsilon, n.center = null == t.center || t.center, n.scale = null == t.scale || t.scale, n.betaInitializer = getInitializer(t.betaInitializer || "zeros"), n.gammaInitializer = getInitializer(t.gammaInitializer || "ones"), n.movingMeanInitializer = getInitializer(t.movingMeanInitializer || "zeros"), n.movingVarianceInitializer = getInitializer(t.movingVarianceInitializer || "ones"), n.betaConstraint = getConstraint(t.betaConstraint), n.gammaConstraint = getConstraint(t.gammaConstraint), n.betaRegularizer = getRegularizer(t.betaRegularizer), n.gammaRegularizer = getRegularizer(t.gammaRegularizer), n;
	  }

	  return __extends(t, e), t.prototype.build = function (e) {
	    var t;
	    e = getExactlyOneShape(e);
	    var n = this.axis >= 0 ? this.axis : this.axis + e.length,
	        r = e[n];
	    if (null == r) throw new ValueError("Axis " + n + " of input tensor should have a defined dimension but the layer received an input with shape " + JSON.stringify(e) + ".");
	    this.inputSpec = [new InputSpec({
	      ndim: e.length,
	      axes: (t = {}, t[n] = r, t)
	    })];
	    var i = [r];
	    this.scale && (this.gamma = this.addWeight("gamma", i, null, this.gammaInitializer, this.gammaRegularizer, !0, this.gammaConstraint)), this.center && (this.beta = this.addWeight("beta", i, null, this.betaInitializer, this.betaRegularizer, !0, this.betaConstraint)), this.movingMean = this.addWeight("moving_mean", i, null, this.movingMeanInitializer, null, !1), this.movingVariance = this.addWeight("moving_variance", i, null, this.movingVarianceInitializer, null, !1), this.built = !0;
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      var r = null != t.training && t.training,
	          i = getExactlyOneTensor(e),
	          a = i.shape,
	          o = a.length,
	          s = range(0, o),
	          l = n.axis >= 0 ? n.axis : n.axis + o;
	      s.splice(l, 1);
	      var u = pyListRepeat(1, o);
	      u[l] = a[l];
	      var c = s.slice();
	      c.sort();
	      var p = !Q.arraysEqual(c, range(0, o).slice(0, o - 1));
	      if (!r) return function () {
	        if (p) {
	          var e = n.movingMean.read().reshape(u),
	              t = n.movingVariance.read().reshape(u),
	              r = n.center ? n.beta.read().reshape(u) : null,
	              a = n.scale ? n.gamma.read().reshape(u) : null;
	          return batchNormalization(i, e, t, r, a, n.epsilon);
	        }

	        return batchNormalization(i, n.movingMean.read(), n.movingVariance.read(), null == n.beta ? null : n.beta.read(), null == n.gamma ? null : n.gamma.read(), n.epsilon);
	      }();

	      var h = normalizeBatchInTraining(i, n.gamma.read(), n.beta.read(), s, n.epsilon),
	          d = h[0],
	          f = h[1],
	          g = h[2],
	          m = function m(e, t, n) {
	        ze(function () {
	          var r = 1 - n,
	              i = e.read(),
	              a = i.sub(t).mul(r);
	          e.write(i.sub(a));
	        });
	      };

	      return m(n.movingMean, f, n.momentum), m(n.movingVariance, g, n.momentum), d;
	    });
	  }, t.prototype.getConfig = function () {
	    var t = {
	      axis: this.axis,
	      momentum: this.momentum,
	      epsilon: this.epsilon,
	      center: this.center,
	      scale: this.scale,
	      betaInitializer: serializeInitializer(this.betaInitializer),
	      gammaInitializer: serializeInitializer(this.gammaInitializer),
	      movingMeanInitializer: serializeInitializer(this.movingMeanInitializer),
	      movingVarianceInitializer: serializeInitializer(this.movingVarianceInitializer),
	      betaRegularizer: serializeRegularizer(this.betaRegularizer),
	      gammaRegularizer: serializeRegularizer(this.gammaRegularizer),
	      betaConstraint: serializeConstraint(this.betaConstraint),
	      gammaConstraint: serializeConstraint(this.gammaConstraint)
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "BatchNormalization", t;
	}(Layer);

	function spatial2dPadding(e, t, n) {
	  return ze(function () {
	    if (4 !== e.rank) throw new ValueError("temporalPadding expects input tensor to be 4-D, but received a " + e.rank + "-D tensor.");
	    if (null == t && (t = [[1, 1], [1, 1]]), 2 !== t.length || 2 !== t[0].length || 2 !== t[1].length) throw new ValueError("spatial2dPadding expects `padding` to be an Array of two Arrays, each of which is an Array of two integers.");
	    if (null == n && (n = imageDataFormat()), "channelsLast" !== n && "channelsFirst" !== n) throw new ValueError("Unknown data format: " + n + ". Supported data formats are 'channelsLast' and 'channelsFirst.");
	    var r;
	    return r = "channelsFirst" === n ? [[0, 0], [0, 0], t[0], t[1]] : [[0, 0], t[0], t[1], [0, 0]], cr(e, r);
	  });
	}

	Ph.registerClass(BatchNormalization);

	var ZeroPadding2D = function (e) {
	  function t(t) {
	    var n = this;
	    if (null == t && (t = {}), (n = e.call(this, t) || this).dataFormat = null == t.dataFormat ? imageDataFormat() : t.dataFormat, null == t.padding) n.padding = [[1, 1], [1, 1]];else if ("number" == typeof t.padding) n.padding = [[t.padding, t.padding], [t.padding, t.padding]];else {
	      if (t.padding = t.padding, 2 !== t.padding.length) throw new ValueError("ZeroPadding2D expects padding to be a length-2 array, but received a length-" + t.padding.length + " array.");
	      var r = void 0,
	          i = void 0;
	      if ("number" == typeof t.padding[0]) r = [t.padding[0], t.padding[0]], i = [t.padding[1], t.padding[1]];else {
	        if (t.padding = t.padding, 2 !== t.padding[0].length) throw new ValueError("ZeroPadding2D expects height padding to be a length-2 array, but received a length-" + t.padding[0].length + " array.");
	        if (r = t.padding[0], 2 !== t.padding[1].length) throw new ValueError("ZeroPadding2D expects width padding to be a length-2 array, but received a length-" + t.padding[1].length + " array.");
	        i = t.padding[1];
	      }
	      n.padding = [r, i];
	    }
	    return n.inputSpec = [new InputSpec({
	      ndim: 4
	    })], n;
	  }

	  return __extends(t, e), t.prototype.computeOutputShape = function (e) {
	    var t, n;
	    return e = getExactlyOneShape(e), "channelsFirst" === this.dataFormat ? (t = null != e[2] && e[2] >= 0 ? e[2] + this.padding[0][0] + this.padding[0][1] : null, n = null != e[3] && e[3] >= 0 ? e[3] + this.padding[1][0] + this.padding[1][1] : null, [e[0], e[1], t, n]) : (t = null != e[1] && e[1] >= 0 ? e[1] + this.padding[0][0] + this.padding[0][1] : null, n = null != e[2] && e[2] >= 0 ? e[2] + this.padding[1][0] + this.padding[1][1] : null, [e[0], t, n, e[3]]);
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      return spatial2dPadding(getExactlyOneTensor(e), n.padding, n.dataFormat);
	    });
	  }, t.prototype.getConfig = function () {
	    var t = {
	      padding: this.padding,
	      dataFormat: this.dataFormat
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "ZeroPadding2D", t;
	}(Layer);

	function pool2d(e, t, n, r, i, a) {
	  return ze(function () {
	    var o;
	    checkDataFormat(i), checkPoolMode(a), checkPaddingMode(r), null == n && (n = [1, 1]), null == r && (r = "valid"), null == i && (i = imageDataFormat()), null == a && (a = "max"), e = preprocessConv2DInput(e, i);
	    var s = "same" === r ? "same" : "valid";
	    return o = "max" === a ? wu(e, t, n, s) : Cu(e, t, n, s), "channelsFirst" === i && (o = Dl(o, [0, 3, 1, 2])), o;
	  });
	}

	Ph.registerClass(ZeroPadding2D);

	var Pooling1D = function (e) {
	  function t(t) {
	    var n = this;
	    if (null == t.poolSize && (t.poolSize = 2), n = e.call(this, t) || this, "number" == typeof t.poolSize) n.poolSize = [t.poolSize];else {
	      if (!Array.isArray(t.poolSize) || 1 !== t.poolSize.length || "number" != typeof t.poolSize[0]) throw new ValueError("poolSize for 1D convolutional layer must be a number or an Array of a single number, but received " + JSON.stringify(t.poolSize));
	      n.poolSize = t.poolSize;
	    }
	    if (assertPositiveInteger(n.poolSize, "poolSize"), null == t.strides) n.strides = n.poolSize;else if ("number" == typeof t.strides) n.strides = [t.strides];else {
	      if (!Array.isArray(t.strides) || 1 !== t.strides.length || "number" != typeof t.strides[0]) throw new ValueError("strides for 1D convolutional layer must be a number or an Array of a single number, but received " + JSON.stringify(t.strides));
	      n.strides = t.strides;
	    }
	    return assertPositiveInteger(n.strides, "strides"), n.padding = null == t.padding ? "valid" : t.padding, checkPaddingMode(n.padding), n.inputSpec = [new InputSpec({
	      ndim: 3
	    })], n;
	  }

	  return __extends(t, e), t.prototype.computeOutputShape = function (e) {
	    var t = convOutputLength((e = getExactlyOneShape(e))[1], this.poolSize[0], this.padding, this.strides[0]);
	    return [e[0], t, e[2]];
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      n.invokeCallHook(e, t), e = expandDims$1(getExactlyOneTensor(e), 2);
	      var r = n.poolingFunction(getExactlyOneTensor(e), [n.poolSize[0], 1], [n.strides[0], 1], n.padding, "channelsLast");
	      return br(r, [2]);
	    });
	  }, t.prototype.getConfig = function () {
	    var t = {
	      poolSize: this.poolSize,
	      padding: this.padding,
	      strides: this.strides
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t;
	}(Layer),
	    MaxPooling1D = function (e) {
	  function t(t) {
	    return e.call(this, t) || this;
	  }

	  return __extends(t, e), t.prototype.poolingFunction = function (e, t, n, r, i) {
	    return checkDataFormat(i), checkPaddingMode(r), pool2d(e, t, n, r, i, "max");
	  }, t.className = "MaxPooling1D", t;
	}(Pooling1D);

	Ph.registerClass(MaxPooling1D);

	var AveragePooling1D = function (e) {
	  function t(t) {
	    return e.call(this, t) || this;
	  }

	  return __extends(t, e), t.prototype.poolingFunction = function (e, t, n, r, i) {
	    return checkDataFormat(i), checkPaddingMode(r), pool2d(e, t, n, r, i, "avg");
	  }, t.className = "AveragePooling1D", t;
	}(Pooling1D);

	Ph.registerClass(AveragePooling1D);

	var Pooling2D = function (e) {
	  function t(t) {
	    var n = this;
	    if (null == t.poolSize && (t.poolSize = [2, 2]), (n = e.call(this, t) || this).poolSize = Array.isArray(t.poolSize) ? t.poolSize : [t.poolSize, t.poolSize], null == t.strides) n.strides = n.poolSize;else if (Array.isArray(t.strides)) {
	      if (2 !== t.strides.length) throw new ValueError("If the strides property of a 2D pooling layer is an Array, it is expected to have a length of 2, but received length " + t.strides.length + ".");
	      n.strides = t.strides;
	    } else n.strides = [t.strides, t.strides];
	    return assertPositiveInteger(n.poolSize, "poolSize"), assertPositiveInteger(n.strides, "strides"), n.padding = null == t.padding ? "valid" : t.padding, n.dataFormat = null == t.dataFormat ? "channelsLast" : t.dataFormat, checkDataFormat(n.dataFormat), checkPaddingMode(n.padding), n.inputSpec = [new InputSpec({
	      ndim: 4
	    })], n;
	  }

	  return __extends(t, e), t.prototype.computeOutputShape = function (e) {
	    e = getExactlyOneShape(e);
	    var t = "channelsFirst" === this.dataFormat ? e[2] : e[1],
	        n = "channelsFirst" === this.dataFormat ? e[3] : e[2];
	    return t = convOutputLength(t, this.poolSize[0], this.padding, this.strides[0]), n = convOutputLength(n, this.poolSize[1], this.padding, this.strides[1]), "channelsFirst" === this.dataFormat ? [e[0], e[1], t, n] : [e[0], t, n, e[3]];
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      return n.invokeCallHook(e, t), n.poolingFunction(getExactlyOneTensor(e), n.poolSize, n.strides, n.padding, n.dataFormat);
	    });
	  }, t.prototype.getConfig = function () {
	    var t = {
	      poolSize: this.poolSize,
	      padding: this.padding,
	      strides: this.strides,
	      dataFormat: this.dataFormat
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t;
	}(Layer),
	    MaxPooling2D = function (e) {
	  function t(t) {
	    return e.call(this, t) || this;
	  }

	  return __extends(t, e), t.prototype.poolingFunction = function (e, t, n, r, i) {
	    return checkDataFormat(i), checkPaddingMode(r), pool2d(e, t, n, r, i, "max");
	  }, t.className = "MaxPooling2D", t;
	}(Pooling2D);

	Ph.registerClass(MaxPooling2D);

	var AveragePooling2D = function (e) {
	  function t(t) {
	    return e.call(this, t) || this;
	  }

	  return __extends(t, e), t.prototype.poolingFunction = function (e, t, n, r, i) {
	    return checkDataFormat(i), checkPaddingMode(r), pool2d(e, t, n, r, i, "avg");
	  }, t.className = "AveragePooling2D", t;
	}(Pooling2D);

	Ph.registerClass(AveragePooling2D);

	var GlobalPooling1D = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return n.inputSpec = [new InputSpec({
	      ndim: 3
	    })], n;
	  }

	  return __extends(t, e), t.prototype.computeOutputShape = function (e) {
	    return [e[0], e[2]];
	  }, t.prototype.call = function (e, t) {
	    throw new NotImplementedError();
	  }, t;
	}(Layer),
	    GlobalAveragePooling1D = function (e) {
	  function t(t) {
	    return e.call(this, t || {}) || this;
	  }

	  return __extends(t, e), t.prototype.call = function (e, t) {
	    return ze(function () {
	      var t = getExactlyOneTensor(e);
	      return Bu(t, 1);
	    });
	  }, t.className = "GlobalAveragePooling1D", t;
	}(GlobalPooling1D);

	Ph.registerClass(GlobalAveragePooling1D);

	var GlobalMaxPooling1D = function (e) {
	  function t(t) {
	    return e.call(this, t || {}) || this;
	  }

	  return __extends(t, e), t.prototype.call = function (e, t) {
	    return ze(function () {
	      var t = getExactlyOneTensor(e);
	      return Mu(t, 1);
	    });
	  }, t.className = "GlobalMaxPooling1D", t;
	}(GlobalPooling1D);

	Ph.registerClass(GlobalMaxPooling1D);

	var GlobalPooling2D = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return n.dataFormat = null == t.dataFormat ? "channelsLast" : t.dataFormat, checkDataFormat(n.dataFormat), n.inputSpec = [new InputSpec({
	      ndim: 4
	    })], n;
	  }

	  return __extends(t, e), t.prototype.computeOutputShape = function (e) {
	    return e = e, "channelsLast" === this.dataFormat ? [e[0], e[3]] : [e[0], e[1]];
	  }, t.prototype.call = function (e, t) {
	    throw new NotImplementedError();
	  }, t.prototype.getConfig = function () {
	    var t = {
	      dataFormat: this.dataFormat
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t;
	}(Layer),
	    GlobalAveragePooling2D = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      var t = getExactlyOneTensor(e);
	      return "channelsLast" === n.dataFormat ? Bu(t, [1, 2]) : Bu(t, [2, 3]);
	    });
	  }, t.className = "GlobalAveragePooling2D", t;
	}(GlobalPooling2D);

	Ph.registerClass(GlobalAveragePooling2D);

	var GlobalMaxPooling2D = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      var t = getExactlyOneTensor(e);
	      return "channelsLast" === n.dataFormat ? Mu(t, [1, 2]) : Mu(t, [2, 3]);
	    });
	  }, t.className = "GlobalMaxPooling2D", t;
	}(GlobalPooling2D);

	function standardizeArgs(e, t, n, r) {
	  if (Array.isArray(e)) {
	    if (null != t || null != n) throw new ValueError("When inputs is an array, neither initialState or constants should be provided");
	    null != r && (n = e.slice(e.length - r, e.length), e = e.slice(0, e.length - r)), e.length > 1 && (t = e.slice(1, e.length)), e = e[0];
	  }

	  function i(e) {
	    return null == e || Array.isArray(e) ? e : [e];
	  }

	  return {
	    inputs: e,
	    initialState: t = i(t),
	    constants: n = i(n)
	  };
	}

	function rnn(e, t, n, r, i, a, o, s) {
	  return void 0 === r && (r = !1), void 0 === o && (o = !1), void 0 === s && (s = !1), ze(function () {
	    var l = t.shape.length;
	    if (l < 3) throw new ValueError("Input should be at least 3D, but is " + l + "D.");
	    var u = [1, 0].concat(range(2, l));
	    if (t = Dl(t, u), null != a) throw new NotImplementedError("The rnn() functoin of the deeplearn.js backend does not support constants yet.");
	    o && console.warn("Backend rnn(): the unroll = true option is not applicable to the imperative deeplearn.js backend."), null != i && ((i = i.asType("bool").asType("float32")).rank === l - 1 && (i = ir(i, -1)), i = Dl(i, u)), r && (t = du(t, 0), null != i && (i = du(i, 0)));
	    var c,
	        p,
	        h = [],
	        d = n,
	        f = t.shape[0],
	        g = Rr(t);
	    null != i && (p = Rr(i));

	    for (var m, y = function y(t) {
	      var n = g[t],
	          r = ze(function () {
	        return e(n, d);
	      });
	      if (null == i) c = r[0], d = r[1];else {
	        var a = ze(function () {
	          var e = p[t],
	              n = Fn(e).sub(e);
	          return {
	            output: r[0].mul(e).addStrict(d[0].mul(n)),
	            newStates: d.map(function (t, i) {
	              return r[1][i].mul(e).addStrict(t.mul(n));
	            })
	          };
	        });
	        c = a.output, d = a.newStates;
	      }
	      s && h.push(c);
	    }, v = 0; v < f; ++v) {
	      y(v);
	    }

	    if (s) {
	      m = wr(h, 1);
	    }

	    return [c, m, d];
	  });
	}

	Ph.registerClass(GlobalMaxPooling2D);

	var RNN = function (e) {
	  function t(t) {
	    var n,
	        r = e.call(this, t) || this;
	    if (null == t.cell) throw new ValueError("cell property is missing for the constructor of RNN.");
	    if (null == (n = Array.isArray(t.cell) ? new StackedRNNCells({
	      cells: t.cell
	    }) : t.cell).stateSize) throw new ValueError("The RNN cell should have an attribute `stateSize` (tuple of integers, one integer per RNN state).");
	    return r.cell = n, r.returnSequences = null != t.returnSequences && t.returnSequences, r.returnState = null != t.returnState && t.returnState, r.goBackwards = null != t.goBackwards && t.goBackwards, r._stateful = null != t.stateful && t.stateful, r.unroll = null != t.unroll && t.unroll, r.supportsMasking = !0, r.inputSpec = [new InputSpec({
	      ndim: 3
	    })], r.stateSpec = null, r.states_ = null, r.numConstants = null, r.keptStates = [], r;
	  }

	  return __extends(t, e), t.prototype.getStates = function () {
	    return null == this.states_ ? range(0, Array.isArray(this.cell.stateSize) ? this.cell.stateSize.length : 1).map(function (e) {
	      return null;
	    }) : this.states_;
	  }, t.prototype.setStates = function (e) {
	    this.states_ = e;
	  }, t.prototype.computeOutputShape = function (e) {
	    isArrayOfShapes(e) && (e = e[0]), e = e;
	    var t = this.cell.stateSize;
	    Array.isArray(t) || (t = [t]);
	    var n,
	        r = t[0];

	    if (n = this.returnSequences ? [e[0], e[1], r] : [e[0], r], this.returnState) {
	      for (var i = [], a = 0, o = t; a < o.length; a++) {
	        var s = o[a];
	        i.push([e[0], s]);
	      }

	      return [n].concat(i);
	    }

	    return n;
	  }, t.prototype.computeMask = function (e, t) {
	    var n = this;
	    return ze(function () {
	      Array.isArray(t) && (t = t[0]);
	      var e = n.returnSequences ? t : null;

	      if (n.returnState) {
	        var r = n.states.map(function (e) {
	          return null;
	        });
	        return [e].concat(r);
	      }

	      return e;
	    });
	  }, Object.defineProperty(t.prototype, "states", {
	    get: function get() {
	      if (null == this.states_) {
	        for (var e = Array.isArray(this.cell.stateSize) ? this.cell.stateSize.length : 1, t = [], n = 0; n < e; ++n) {
	          t.push(null);
	        }

	        return t;
	      }

	      return this.states_;
	    },
	    set: function set(e) {
	      this.states_ = e;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.build = function (e) {
	    if (null != this.numConstants) throw new NotImplementedError("Constants support is not implemented in RNN yet.");
	    isArrayOfShapes(e) && (e = e[0]), e = e;
	    var t = this.stateful ? e[0] : null,
	        n = e[e.length - 1];
	    this.inputSpec[0] = new InputSpec({
	      shape: [t, null, n]
	    });
	    var r,
	        i = [e[0]].concat(e.slice(2));

	    if (this.cell.build(i), r = Array.isArray(this.cell.stateSize) ? this.cell.stateSize : [this.cell.stateSize], null != this.stateSpec) {
	      if (!Q.arraysEqual(this.stateSpec.map(function (e) {
	        return e.shape[e.shape.length - 1];
	      }), r)) throw new ValueError("An initialState was passed that is not compatible with cell.stateSize. Received stateSpec=" + this.stateSpec + "; However cell.stateSize is " + this.cell.stateSize);
	    } else this.stateSpec = r.map(function (e) {
	      return new InputSpec({
	        shape: [null, e]
	      });
	    });

	    this.stateful && this.resetStates();
	  }, t.prototype.resetStates = function (e, t) {
	    var n = this;
	    void 0 === t && (t = !1), ze(function () {
	      if (!n.stateful) throw new AttributeError("Cannot call resetStates() on an RNN Layer that is not stateful.");
	      var r = n.inputSpec[0].shape[0];
	      if (null == r) throw new ValueError("If an RNN is stateful, it needs to know its batch size. Specify the batch size of your input tensors: \n- If using a Sequential model, specify the batch size by passing a `batchInputShape` option to your first layer.\n- If using the functional API, specify the batch size by passing a `batchShape` option to your Input layer.");
	      if (null == n.states_) Array.isArray(n.cell.stateSize) ? n.states_ = n.cell.stateSize.map(function (e) {
	        return Tn([r, e]);
	      }) : n.states_ = [Tn([r, n.cell.stateSize])];else if (null == e) Ve(n.states_), null != n.keptStates && (Ve(n.keptStates), n.keptStates = []), Array.isArray(n.cell.stateSize) ? n.states_ = n.cell.stateSize.map(function (e) {
	        return Tn([r, e]);
	      }) : n.states_[0] = Tn([r, n.cell.stateSize]);else {
	        if (Array.isArray(e) || (e = [e]), e.length !== n.states_.length) throw new ValueError("Layer " + n.name + " expects " + n.states_.length + " state(s), but it received " + e.length + " state value(s). Input received: " + e);
	        !0 === t ? n.keptStates.push(n.states_.slice()) : Ve(n.states_);

	        for (var i = 0; i < n.states_.length; ++i) {
	          var a = e[i],
	              o = Array.isArray(n.cell.stateSize) ? n.cell.stateSize[i] : n.cell.stateSize,
	              s = [r, o];
	          if (!Q.arraysEqual(a.shape, s)) throw new ValueError("State " + i + " is incompatible with layer " + n.name + ": expected shape=" + s + ", received shape=" + a.shape);
	          n.states_[i] = a;
	        }
	      }
	      n.states_ = n.states_.map(function (e) {
	        return Ge(e.clone());
	      });
	    });
	  }, t.prototype.apply = function (t, n) {
	    var r = null == n ? null : n.initialState,
	        i = null == n ? null : n.constants;
	    null == n && (n = {});
	    var a = standardizeArgs(t, r, i, this.numConstants);
	    t = a.inputs, r = a.initialState, i = a.constants;
	    var o = [],
	        s = [];

	    if (null != r) {
	      n.initialState = r, o = o.concat(r), this.stateSpec = [];

	      for (var l = 0, u = r; l < u.length; l++) {
	        var c = u[l];
	        this.stateSpec.push(new InputSpec({
	          shape: c.shape
	        }));
	      }

	      s = s.concat(this.stateSpec);
	    }

	    if (null != i && (n.constants = i, o = o.concat(i), this.numConstants = i.length), o[0] instanceof SymbolicTensor) {
	      var p = [t].concat(o),
	          h = this.inputSpec.concat(s),
	          d = this.inputSpec;
	      this.inputSpec = h;
	      var f = e.prototype.apply.call(this, p, n);
	      return this.inputSpec = d, f;
	    }

	    return e.prototype.apply.call(this, t, n);
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      var r = null == t ? null : t.mask,
	          i = null == t ? null : t.training,
	          a = null == t ? null : t.initialState;
	      e = getExactlyOneTensor(e), null == a && (a = n.stateful ? n.states_ : n.getInitialState(e));
	      var o = Array.isArray(n.cell.stateSize) ? n.cell.stateSize.length : 1;
	      if (a.length !== o) throw new ValueError("RNN Layer has " + o + " state(s) but was passed " + a.length + " initial state(s).");
	      n.unroll && console.warn("Ignoring unroll = true for RNN layer, due to imperative backend.");
	      var s = {
	        training: i
	      },
	          l = rnn(function (e, t) {
	        var r = n.cell.call([e].concat(t), s);
	        return [r[0], r.slice(1)];
	      }, e, a, n.goBackwards, r, null, n.unroll, n.returnSequences),
	          u = l[0],
	          c = l[1],
	          p = l[2];
	      n.stateful && n.resetStates(p, i);
	      var h = n.returnSequences ? c : u;
	      return n.returnState ? [h].concat(p) : h;
	    });
	  }, t.prototype.getInitialState = function (e) {
	    var t = this;
	    return ze(function () {
	      var n = Tn(e.shape);
	      return n = expandDims$1(n = Wu(n, [1, 2])), Array.isArray(t.cell.stateSize) ? t.cell.stateSize.map(function (e) {
	        return e > 1 ? tile$1(n, [1, e]) : n;
	      }) : t.cell.stateSize > 1 ? [tile$1(n, [1, t.cell.stateSize])] : [n];
	    });
	  }, Object.defineProperty(t.prototype, "trainableWeights", {
	    get: function get() {
	      return this.trainable ? this.cell.trainableWeights : [];
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "nonTrainableWeights", {
	    get: function get() {
	      return this.trainable ? this.cell.nonTrainableWeights : this.cell.weights;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.setFastWeightInitDuringBuild = function (t) {
	    e.prototype.setFastWeightInitDuringBuild.call(this, t), null != this.cell && this.cell.setFastWeightInitDuringBuild(t);
	  }, t.prototype.getConfig = function () {
	    var t = {
	      returnSequences: this.returnSequences,
	      returnState: this.returnState,
	      goBackwards: this.goBackwards,
	      stateful: this.stateful,
	      unroll: this.unroll
	    };
	    null != this.numConstants && (t.numConstants = this.numConstants);
	    var n = this.cell.getConfig();
	    t.cell = {
	      className: this.cell.getClassName(),
	      config: n
	    };
	    var r = e.prototype.getConfig.call(this);
	    return Object.assign(t, r), t;
	  }, t.fromConfig = function (e, t, n) {
	    void 0 === n && (n = {});
	    var r = deserialize(t.cell, n);
	    return new e(Object.assign(t, {
	      cell: r
	    }));
	  }, t.className = "RNN", t;
	}(Layer);

	Ph.registerClass(RNN);

	var RNNCell = function (e) {
	  function t() {
	    return null !== e && e.apply(this, arguments) || this;
	  }

	  return __extends(t, e), t;
	}(Layer),
	    SimpleRNNCell = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return n.DEFAULT_ACTIVATION = "tanh", n.DEFAULT_KERNEL_INITIALIZER = "glorotNormal", n.DEFAULT_RECURRENT_INITIALIZER = "orthogonal", n.DEFAULT_BIAS_INITIALIZER = "zeros", n.units = t.units, assertPositiveInteger(n.units, "units"), n.activation = getActivation(null == t.activation ? n.DEFAULT_ACTIVATION : t.activation), n.useBias = null == t.useBias || t.useBias, n.kernelInitializer = getInitializer(t.kernelInitializer || n.DEFAULT_KERNEL_INITIALIZER), n.recurrentInitializer = getInitializer(t.recurrentInitializer || n.DEFAULT_RECURRENT_INITIALIZER), n.biasInitializer = getInitializer(t.biasInitializer || n.DEFAULT_BIAS_INITIALIZER), n.kernelRegularizer = getRegularizer(t.kernelRegularizer), n.recurrentRegularizer = getRegularizer(t.recurrentRegularizer), n.biasRegularizer = getRegularizer(t.biasRegularizer), n.kernelConstraint = getConstraint(t.kernelConstraint), n.recurrentConstraint = getConstraint(t.recurrentConstraint), n.biasConstraint = getConstraint(t.biasConstraint), n.dropout = min$1([1, max$1([0, null == t.dropout ? 0 : t.dropout])]), n.recurrentDropout = min$1([1, max$1([0, null == t.recurrentDropout ? 0 : t.recurrentDropout])]), n.stateSize = n.units, n.dropoutMask = null, n.recurrentDropoutMask = null, n;
	  }

	  return __extends(t, e), t.prototype.build = function (e) {
	    e = getExactlyOneShape(e), this.kernel = this.addWeight("kernel", [e[e.length - 1], this.units], null, this.kernelInitializer, this.kernelRegularizer, !0, this.kernelConstraint), this.recurrentKernel = this.addWeight("recurrent_kernel", [this.units, this.units], null, this.recurrentInitializer, this.recurrentRegularizer, !0, this.recurrentConstraint), this.useBias ? this.bias = this.addWeight("bias", [this.units], null, this.biasInitializer, this.biasRegularizer, !0, this.biasConstraint) : this.bias = null, this.built = !0;
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      if (2 !== (e = e).length) throw new ValueError("SimpleRNNCell expects 2 input Tensors, got " + e.length + ".");
	      var r = e[1];
	      e = e[0];
	      var i,
	          a = null != t.training && t.training;
	      0 < n.dropout && n.dropout < 1 && null == n.dropoutMask && (n.dropoutMask = generateDropoutMask(function () {
	        return Fn(e);
	      }, n.dropout, a)), 0 < n.recurrentDropout && n.recurrentDropout < 1 && null == n.recurrentDropoutMask && (n.recurrentDropoutMask = generateDropoutMask(function () {
	        return Fn(r);
	      }, n.recurrentDropout, a));
	      var o = n.dropoutMask,
	          s = n.recurrentDropoutMask;
	      i = dot(null != o ? fl(e, o) : e, n.kernel.read()), null != n.bias && (i = biasAdd(i, n.bias.read())), null != s && (r = fl(r, s));
	      var l = Zu(i, dot(r, n.recurrentKernel.read()));
	      return null != n.activation && (l = n.activation.apply(l)), [l, l];
	    });
	  }, t.prototype.getConfig = function () {
	    var t = {
	      units: this.units,
	      activation: serializeActivation(this.activation),
	      useBias: this.useBias,
	      kernelInitializer: serializeInitializer(this.kernelInitializer),
	      recurrentInitializer: serializeInitializer(this.recurrentInitializer),
	      biasInitializer: serializeInitializer(this.biasInitializer),
	      kernelRegularizer: serializeRegularizer(this.kernelRegularizer),
	      recurrentRegularizer: serializeRegularizer(this.recurrentRegularizer),
	      biasRegularizer: serializeRegularizer(this.biasRegularizer),
	      activityRegularizer: serializeRegularizer(this.activityRegularizer),
	      kernelConstraint: serializeConstraint(this.kernelConstraint),
	      recurrentConstraint: serializeConstraint(this.recurrentConstraint),
	      biasConstraint: serializeConstraint(this.biasConstraint),
	      dropout: this.dropout,
	      recurrentDropout: this.recurrentDropout
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "SimpleRNNCell", t;
	}(RNNCell);

	Ph.registerClass(SimpleRNNCell);

	var SimpleRNN = function (e) {
	  function t(t) {
	    return t.cell = new SimpleRNNCell(t), e.call(this, t) || this;
	  }

	  return __extends(t, e), t.prototype.call = function (t, n) {
	    var r = this;
	    return ze(function () {
	      null != r.cell.dropoutMask && (Ve(r.cell.dropoutMask), r.cell.dropoutMask = null), null != r.cell.recurrentDropoutMask && (Ve(r.cell.recurrentDropoutMask), r.cell.recurrentDropoutMask = null);
	      var i = null == n ? null : n.mask,
	          a = null == n ? null : n.training,
	          o = null == n ? null : n.initialState;
	      return e.prototype.call.call(r, t, {
	        mask: i,
	        training: a,
	        initialState: o
	      });
	    });
	  }, Object.defineProperty(t.prototype, "units", {
	    get: function get() {
	      return this.cell.units;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "activation", {
	    get: function get() {
	      return this.cell.activation;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "useBias", {
	    get: function get() {
	      return this.cell.useBias;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "kernelInitializer", {
	    get: function get() {
	      return this.cell.kernelInitializer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "recurrentInitializer", {
	    get: function get() {
	      return this.cell.recurrentInitializer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "biasInitializer", {
	    get: function get() {
	      return this.cell.biasInitializer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "kernelRegularizer", {
	    get: function get() {
	      return this.cell.kernelRegularizer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "recurrentRegularizer", {
	    get: function get() {
	      return this.cell.recurrentRegularizer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "biasRegularizer", {
	    get: function get() {
	      return this.cell.biasRegularizer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "kernelConstraint", {
	    get: function get() {
	      return this.cell.kernelConstraint;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "recurrentConstraint", {
	    get: function get() {
	      return this.cell.recurrentConstraint;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "biasConstraint", {
	    get: function get() {
	      return this.cell.biasConstraint;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "dropout", {
	    get: function get() {
	      return this.cell.dropout;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "recurrentDropout", {
	    get: function get() {
	      return this.cell.recurrentDropout;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.getConfig = function () {
	    var t = {
	      units: this.units,
	      activation: serializeActivation(this.activation),
	      useBias: this.useBias,
	      kernelInitializer: serializeInitializer(this.kernelInitializer),
	      recurrentInitializer: serializeInitializer(this.recurrentInitializer),
	      biasInitializer: serializeInitializer(this.biasInitializer),
	      kernelRegularizer: serializeRegularizer(this.kernelRegularizer),
	      recurrentRegularizer: serializeRegularizer(this.recurrentRegularizer),
	      biasRegularizer: serializeRegularizer(this.biasRegularizer),
	      activityRegularizer: serializeRegularizer(this.activityRegularizer),
	      kernelConstraint: serializeConstraint(this.kernelConstraint),
	      recurrentConstraint: serializeConstraint(this.recurrentConstraint),
	      biasConstraint: serializeConstraint(this.biasConstraint),
	      dropout: this.dropout,
	      recurrentDropout: this.recurrentDropout
	    },
	        n = e.prototype.getConfig.call(this);
	    return delete n.cell, Object.assign(t, n), t;
	  }, t.fromConfig = function (e, t) {
	    return new e(t);
	  }, t.className = "SimpleRNN", t;
	}(RNN);

	Ph.registerClass(SimpleRNN);

	var GRUCell = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return n.DEFAULT_ACTIVATION = "tanh", n.DEFAULT_RECURRENT_ACTIVATION = "hardSigmoid", n.DEFAULT_KERNEL_INITIALIZER = "glorotNormal", n.DEFAULT_RECURRENT_INITIALIZER = "orthogonal", n.DEFAULT_BIAS_INITIALIZER = "zeros", n.units = t.units, assertPositiveInteger(n.units, "units"), n.activation = getActivation(void 0 === t.activation ? n.DEFAULT_ACTIVATION : t.activation), n.recurrentActivation = getActivation(void 0 === t.recurrentActivation ? n.DEFAULT_RECURRENT_ACTIVATION : t.recurrentActivation), n.useBias = null == t.useBias || t.useBias, n.kernelInitializer = getInitializer(t.kernelInitializer || n.DEFAULT_KERNEL_INITIALIZER), n.recurrentInitializer = getInitializer(t.recurrentInitializer || n.DEFAULT_RECURRENT_INITIALIZER), n.biasInitializer = getInitializer(t.biasInitializer || n.DEFAULT_BIAS_INITIALIZER), n.kernelRegularizer = getRegularizer(t.kernelRegularizer), n.recurrentRegularizer = getRegularizer(t.recurrentRegularizer), n.biasRegularizer = getRegularizer(t.biasRegularizer), n.kernelConstraint = getConstraint(t.kernelConstraint), n.recurrentConstraint = getConstraint(t.recurrentConstraint), n.biasConstraint = getConstraint(t.biasConstraint), n.dropout = min$1([1, max$1([0, null == t.dropout ? 0 : t.dropout])]), n.recurrentDropout = min$1([1, max$1([0, null == t.recurrentDropout ? 0 : t.recurrentDropout])]), n.implementation = t.implementation, n.stateSize = n.units, n.dropoutMask = null, n.recurrentDropoutMask = null, n;
	  }

	  return __extends(t, e), t.prototype.build = function (e) {
	    var t = (e = getExactlyOneShape(e))[e.length - 1];
	    this.kernel = this.addWeight("kernel", [t, 3 * this.units], null, this.kernelInitializer, this.kernelRegularizer, !0, this.kernelConstraint), this.recurrentKernel = this.addWeight("recurrent_kernel", [this.units, 3 * this.units], null, this.recurrentInitializer, this.recurrentRegularizer, !0, this.recurrentConstraint), this.useBias ? this.bias = this.addWeight("bias", [3 * this.units], null, this.biasInitializer, this.biasRegularizer, !0, this.biasConstraint) : this.bias = null, this.built = !0;
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      if (2 !== (e = e).length) throw new ValueError("GRUCell expects 2 input Tensors (inputs, h, c), got " + e.length + ".");
	      var r = null != t.training && t.training,
	          i = e[1];
	      e = e[0], 0 < n.dropout && n.dropout < 1 && null == n.dropoutMask && (n.dropoutMask = generateDropoutMask(function () {
	        return Fn(e);
	      }, n.dropout, r, 3)), 0 < n.recurrentDropout && n.recurrentDropout < 1 && null == n.recurrentDropoutMask && (n.recurrentDropoutMask = generateDropoutMask(function () {
	        return Fn(i);
	      }, n.recurrentDropout, r, 3));
	      var a,
	          o,
	          s,
	          l = n.dropoutMask,
	          u = n.recurrentDropoutMask;
	      0 < n.dropout && n.dropout < 1 && (e = fl(e, l[0]));
	      var c = dot(e, n.kernel.read());
	      n.useBias && (c = biasAdd(c, n.bias.read())), 0 < n.recurrentDropout && n.recurrentDropout < 1 && (i = fl(i, u[0]));
	      var p = n.recurrentKernel.read(),
	          h = zn(p, [2 * n.units, n.units], p.rank - 1),
	          d = h[0],
	          f = h[1],
	          g = dot(i, d),
	          m = zn(c, 3, c.rank - 1),
	          y = m[0],
	          v = m[1],
	          b = m[2],
	          w = zn(g, 2, g.rank - 1),
	          z = w[0],
	          S = w[1];
	      a = n.recurrentActivation.apply(Zu(y, z)), o = n.recurrentActivation.apply(Zu(v, S));
	      var A = dot(fl(o, i), f);
	      s = n.activation.apply(Zu(b, A));

	      var _ = Zu(fl(a, i), fl(Zu(1, Es(a)), s));

	      return [_, _];
	    });
	  }, t.prototype.getConfig = function () {
	    var t = {
	      units: this.units,
	      activation: serializeActivation(this.activation),
	      recurrentActivation: serializeActivation(this.recurrentActivation),
	      useBias: this.useBias,
	      kernelInitializer: serializeInitializer(this.kernelInitializer),
	      recurrentInitializer: serializeInitializer(this.recurrentInitializer),
	      biasInitializer: serializeInitializer(this.biasInitializer),
	      kernelRegularizer: serializeRegularizer(this.kernelRegularizer),
	      recurrentRegularizer: serializeRegularizer(this.recurrentRegularizer),
	      biasRegularizer: serializeRegularizer(this.biasRegularizer),
	      activityRegularizer: serializeRegularizer(this.activityRegularizer),
	      kernelConstraint: serializeConstraint(this.kernelConstraint),
	      recurrentConstraint: serializeConstraint(this.recurrentConstraint),
	      biasConstraint: serializeConstraint(this.biasConstraint),
	      dropout: this.dropout,
	      recurrentDropout: this.recurrentDropout,
	      implementation: this.implementation
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "GRUCell", t;
	}(RNNCell);

	Ph.registerClass(GRUCell);

	var GRU = function (e) {
	  function t(t) {
	    return 0 === t.implementation && console.warn("`implementation=0` has been deprecated, and now defaults to `implementation=1`. Please update your layer call."), t.cell = new GRUCell(t), e.call(this, t) || this;
	  }

	  return __extends(t, e), t.prototype.call = function (t, n) {
	    var r = this;
	    return ze(function () {
	      null != r.cell.dropoutMask && (Ve(r.cell.dropoutMask), r.cell.dropoutMask = null), null != r.cell.recurrentDropoutMask && (Ve(r.cell.recurrentDropoutMask), r.cell.recurrentDropoutMask = null);
	      var i = null == n ? null : n.mask,
	          a = null == n ? null : n.training,
	          o = null == n ? null : n.initialState;
	      return e.prototype.call.call(r, t, {
	        mask: i,
	        training: a,
	        initialState: o
	      });
	    });
	  }, Object.defineProperty(t.prototype, "units", {
	    get: function get() {
	      return this.cell.units;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "activation", {
	    get: function get() {
	      return this.cell.activation;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "recurrentActivation", {
	    get: function get() {
	      return this.cell.recurrentActivation;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "useBias", {
	    get: function get() {
	      return this.cell.useBias;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "kernelInitializer", {
	    get: function get() {
	      return this.cell.kernelInitializer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "recurrentInitializer", {
	    get: function get() {
	      return this.cell.recurrentInitializer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "biasInitializer", {
	    get: function get() {
	      return this.cell.biasInitializer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "kernelRegularizer", {
	    get: function get() {
	      return this.cell.kernelRegularizer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "recurrentRegularizer", {
	    get: function get() {
	      return this.cell.recurrentRegularizer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "biasRegularizer", {
	    get: function get() {
	      return this.cell.biasRegularizer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "kernelConstraint", {
	    get: function get() {
	      return this.cell.kernelConstraint;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "recurrentConstraint", {
	    get: function get() {
	      return this.cell.recurrentConstraint;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "biasConstraint", {
	    get: function get() {
	      return this.cell.biasConstraint;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "dropout", {
	    get: function get() {
	      return this.cell.dropout;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "recurrentDropout", {
	    get: function get() {
	      return this.cell.recurrentDropout;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "implementation", {
	    get: function get() {
	      return this.cell.implementation;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.getConfig = function () {
	    var t = {
	      units: this.units,
	      activation: serializeActivation(this.activation),
	      recurrentActivation: serializeActivation(this.recurrentActivation),
	      useBias: this.useBias,
	      kernelInitializer: serializeInitializer(this.kernelInitializer),
	      recurrentInitializer: serializeInitializer(this.recurrentInitializer),
	      biasInitializer: serializeInitializer(this.biasInitializer),
	      kernelRegularizer: serializeRegularizer(this.kernelRegularizer),
	      recurrentRegularizer: serializeRegularizer(this.recurrentRegularizer),
	      biasRegularizer: serializeRegularizer(this.biasRegularizer),
	      activityRegularizer: serializeRegularizer(this.activityRegularizer),
	      kernelConstraint: serializeConstraint(this.kernelConstraint),
	      recurrentConstraint: serializeConstraint(this.recurrentConstraint),
	      biasConstraint: serializeConstraint(this.biasConstraint),
	      dropout: this.dropout,
	      recurrentDropout: this.recurrentDropout,
	      implementation: this.implementation
	    },
	        n = e.prototype.getConfig.call(this);
	    return delete n.cell, Object.assign(t, n), t;
	  }, t.fromConfig = function (e, t) {
	    return 0 === t.implmentation && (t.implementation = 1), new e(t);
	  }, t.className = "GRU", t;
	}(RNN);

	Ph.registerClass(GRU);

	var LSTMCell = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return n.DEFAULT_ACTIVATION = "tanh", n.DEFAULT_RECURRENT_ACTIVATION = "hardSigmoid", n.DEFAULT_KERNEL_INITIALIZER = "glorotNormal", n.DEFAULT_RECURRENT_INITIALIZER = "orthogonal", n.DEFAULT_BIAS_INITIALIZER = "zeros", n.units = t.units, assertPositiveInteger(n.units, "units"), n.activation = getActivation(void 0 === t.activation ? n.DEFAULT_ACTIVATION : t.activation), n.recurrentActivation = getActivation(void 0 === t.recurrentActivation ? n.DEFAULT_RECURRENT_ACTIVATION : t.recurrentActivation), n.useBias = null == t.useBias || t.useBias, n.kernelInitializer = getInitializer(t.kernelInitializer || n.DEFAULT_KERNEL_INITIALIZER), n.recurrentInitializer = getInitializer(t.recurrentInitializer || n.DEFAULT_RECURRENT_INITIALIZER), n.biasInitializer = getInitializer(t.biasInitializer || n.DEFAULT_BIAS_INITIALIZER), n.unitForgetBias = t.unitForgetBias, n.kernelRegularizer = getRegularizer(t.kernelRegularizer), n.recurrentRegularizer = getRegularizer(t.recurrentRegularizer), n.biasRegularizer = getRegularizer(t.biasRegularizer), n.kernelConstraint = getConstraint(t.kernelConstraint), n.recurrentConstraint = getConstraint(t.recurrentConstraint), n.biasConstraint = getConstraint(t.biasConstraint), n.dropout = min$1([1, max$1([0, null == t.dropout ? 0 : t.dropout])]), n.recurrentDropout = min$1([1, max$1([0, null == t.recurrentDropout ? 0 : t.recurrentDropout])]), n.implementation = t.implementation, n.stateSize = [n.units, n.units], n.dropoutMask = null, n.recurrentDropoutMask = null, n;
	  }

	  return __extends(t, e), t.prototype.build = function (e) {
	    var t,
	        n,
	        r = (e = getExactlyOneShape(e))[e.length - 1];

	    if (this.kernel = this.addWeight("kernel", [r, 4 * this.units], null, this.kernelInitializer, this.kernelRegularizer, !0, this.kernelConstraint), this.recurrentKernel = this.addWeight("recurrent_kernel", [this.units, 4 * this.units], null, this.recurrentInitializer, this.recurrentRegularizer, !0, this.recurrentConstraint), this.useBias) {
	      if (this.unitForgetBias) {
	        var i = this.biasInitializer,
	            a = this.units;
	        n = new ((t = function (e) {
	          function t() {
	            return null !== e && e.apply(this, arguments) || this;
	          }

	          return __extends(t, e), t.prototype.apply = function (e, t) {
	            var n = i.apply([a]),
	                r = new Ones().apply([a]),
	                o = i.apply([2 * a]);
	            return concatAlongFirstAxis(concatAlongFirstAxis(n, r), o);
	          }, t;
	        }(Initializer)).className = "CustomInit", t)();
	      } else n = this.biasInitializer;

	      this.bias = this.addWeight("bias", [4 * this.units], null, n, this.biasRegularizer, !0, this.biasConstraint);
	    } else this.bias = null;

	    this.built = !0;
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      var r = null != t.training && t.training;
	      if (3 !== (e = e).length) throw new ValueError("LSTMCell expects 3 input Tensors (inputs, h, c), got " + e.length + ".");
	      var i = e[1],
	          a = e[2];
	      e = e[0], 0 < n.dropout && n.dropout < 1 && null == n.dropoutMask && (n.dropoutMask = generateDropoutMask(function () {
	        return Fn(e);
	      }, n.dropout, r, 4)), 0 < n.recurrentDropout && n.recurrentDropout < 1 && null == n.recurrentDropoutMask && (n.recurrentDropoutMask = generateDropoutMask(function () {
	        return Fn(i);
	      }, n.recurrentDropout, r, 4));
	      var o,
	          s,
	          l,
	          u,
	          c = n.dropoutMask,
	          p = n.recurrentDropoutMask;
	      0 < n.dropout && n.dropout < 1 && (e = fl(e, c[0]));
	      var h = dot(e, n.kernel.read());
	      0 < n.recurrentDropout && n.recurrentDropout < 1 && (i = fl(i, p[0])), h = Zu(h, dot(i, n.recurrentKernel.read())), n.useBias && (h = biasAdd(h, n.bias.read()));
	      var d = zn(h, 4, h.rank - 1),
	          f = d[0],
	          g = d[1],
	          m = d[2],
	          y = d[3];
	      o = n.recurrentActivation.apply(f), s = n.recurrentActivation.apply(g), l = Zu(fl(s, a), fl(o, n.activation.apply(m))), u = n.recurrentActivation.apply(y);
	      var v = fl(u, n.activation.apply(l));
	      return [v, v, l];
	    });
	  }, t.prototype.getConfig = function () {
	    var t = {
	      units: this.units,
	      activation: serializeActivation(this.activation),
	      recurrentActivation: serializeActivation(this.recurrentActivation),
	      useBias: this.useBias,
	      kernelInitializer: serializeInitializer(this.kernelInitializer),
	      recurrentInitializer: serializeInitializer(this.recurrentInitializer),
	      biasInitializer: serializeInitializer(this.biasInitializer),
	      unitForgetBias: this.unitForgetBias,
	      kernelRegularizer: serializeRegularizer(this.kernelRegularizer),
	      recurrentRegularizer: serializeRegularizer(this.recurrentRegularizer),
	      biasRegularizer: serializeRegularizer(this.biasRegularizer),
	      activityRegularizer: serializeRegularizer(this.activityRegularizer),
	      kernelConstraint: serializeConstraint(this.kernelConstraint),
	      recurrentConstraint: serializeConstraint(this.recurrentConstraint),
	      biasConstraint: serializeConstraint(this.biasConstraint),
	      dropout: this.dropout,
	      recurrentDropout: this.recurrentDropout,
	      implementation: this.implementation
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.className = "LSTMCell", t;
	}(RNNCell);

	Ph.registerClass(LSTMCell);

	var LSTM = function (e) {
	  function t(t) {
	    return 0 === t.implementation && console.warn("`implementation=0` has been deprecated, and now defaults to `implementation=1`. Please update your layer call."), t.cell = new LSTMCell(t), e.call(this, t) || this;
	  }

	  return __extends(t, e), t.prototype.call = function (t, n) {
	    var r = this;
	    return ze(function () {
	      null != r.cell.dropoutMask && (Ve(r.cell.dropoutMask), r.cell.dropoutMask = null), null != r.cell.recurrentDropoutMask && (Ve(r.cell.recurrentDropoutMask), r.cell.recurrentDropoutMask = null);
	      var i = null == n ? null : n.mask,
	          a = null == n ? null : n.training,
	          o = null == n ? null : n.initialState;
	      return e.prototype.call.call(r, t, {
	        mask: i,
	        training: a,
	        initialState: o
	      });
	    });
	  }, Object.defineProperty(t.prototype, "units", {
	    get: function get() {
	      return this.cell.units;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "activation", {
	    get: function get() {
	      return this.cell.activation;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "recurrentActivation", {
	    get: function get() {
	      return this.cell.recurrentActivation;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "useBias", {
	    get: function get() {
	      return this.cell.useBias;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "kernelInitializer", {
	    get: function get() {
	      return this.cell.kernelInitializer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "recurrentInitializer", {
	    get: function get() {
	      return this.cell.recurrentInitializer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "biasInitializer", {
	    get: function get() {
	      return this.cell.biasInitializer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "unitForgetBias", {
	    get: function get() {
	      return this.cell.unitForgetBias;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "kernelRegularizer", {
	    get: function get() {
	      return this.cell.kernelRegularizer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "recurrentRegularizer", {
	    get: function get() {
	      return this.cell.recurrentRegularizer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "biasRegularizer", {
	    get: function get() {
	      return this.cell.biasRegularizer;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "kernelConstraint", {
	    get: function get() {
	      return this.cell.kernelConstraint;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "recurrentConstraint", {
	    get: function get() {
	      return this.cell.recurrentConstraint;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "biasConstraint", {
	    get: function get() {
	      return this.cell.biasConstraint;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "dropout", {
	    get: function get() {
	      return this.cell.dropout;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "recurrentDropout", {
	    get: function get() {
	      return this.cell.recurrentDropout;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "implementation", {
	    get: function get() {
	      return this.cell.implementation;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.getConfig = function () {
	    var t = {
	      units: this.units,
	      activation: serializeActivation(this.activation),
	      recurrentActivation: serializeActivation(this.recurrentActivation),
	      useBias: this.useBias,
	      kernelInitializer: serializeInitializer(this.kernelInitializer),
	      recurrentInitializer: serializeInitializer(this.recurrentInitializer),
	      biasInitializer: serializeInitializer(this.biasInitializer),
	      unitForgetBias: this.unitForgetBias,
	      kernelRegularizer: serializeRegularizer(this.kernelRegularizer),
	      recurrentRegularizer: serializeRegularizer(this.recurrentRegularizer),
	      biasRegularizer: serializeRegularizer(this.biasRegularizer),
	      activityRegularizer: serializeRegularizer(this.activityRegularizer),
	      kernelConstraint: serializeConstraint(this.kernelConstraint),
	      recurrentConstraint: serializeConstraint(this.recurrentConstraint),
	      biasConstraint: serializeConstraint(this.biasConstraint),
	      dropout: this.dropout,
	      recurrentDropout: this.recurrentDropout,
	      implementation: this.implementation
	    },
	        n = e.prototype.getConfig.call(this);
	    return delete n.cell, Object.assign(t, n), t;
	  }, t.fromConfig = function (e, t) {
	    return 0 === t.implmentation && (t.implementation = 1), new e(t);
	  }, t.className = "LSTM", t;
	}(RNN);

	Ph.registerClass(LSTM);

	var StackedRNNCells = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return n.cells = t.cells, n;
	  }

	  return __extends(t, e), Object.defineProperty(t.prototype, "stateSize", {
	    get: function get() {
	      for (var e = [], t = 0, n = this.cells.slice().reverse(); t < n.length; t++) {
	        var r = n[t];
	        Array.isArray(r.stateSize) ? e.push.apply(e, r.stateSize) : e.push(r.stateSize);
	      }

	      return e;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      for (var r = (e = e).slice(1), i = [], a = 0, o = n.cells.slice().reverse(); a < o.length; a++) {
	        var s = o[a];
	        Array.isArray(s.stateSize) ? i.push(r.splice(0, s.stateSize.length)) : i.push(r.splice(0, 1));
	      }

	      i.reverse();

	      for (var l, u = [], c = 0; c < n.cells.length; ++c) {
	        s = n.cells[c];
	        r = i[c], l = 0 === c ? [e[0]].concat(r) : [l[0]].concat(r), l = s.call(l, t), u.push(l.slice(1));
	      }

	      r = [];

	      for (var p = 0, h = u.slice().reverse(); p < h.length; p++) {
	        var d = h[p];
	        r.push.apply(r, d);
	      }

	      return [l[0]].concat(r);
	    });
	  }, t.prototype.build = function (e) {
	    var t;
	    isArrayOfShapes(e) && (e = e[0]), e = e;

	    for (var n = 0, r = this.cells; n < r.length; n++) {
	      var i = r[n];
	      i.build(e), t = Array.isArray(i.stateSize) ? i.stateSize[0] : i.stateSize, e = [e[0], t];
	    }

	    this.built = !0;
	  }, t.prototype.getConfig = function () {
	    for (var t = [], n = 0, r = this.cells; n < r.length; n++) {
	      var i = r[n];
	      t.push({
	        className: i.getClassName(),
	        config: i.getConfig()
	      });
	    }

	    var a = {
	      cells: t
	    },
	        o = e.prototype.getConfig.call(this);
	    return Object.assign(a, o), a;
	  }, t.fromConfig = function (e, t, n) {
	    void 0 === n && (n = {});

	    for (var r = [], i = 0, a = t.cells; i < a.length; i++) {
	      var o = a[i];
	      r.push(deserialize(o, n));
	    }

	    return new e({
	      cells: r
	    });
	  }, Object.defineProperty(t.prototype, "trainableWeights", {
	    get: function get() {
	      if (!this.trainable) return [];

	      for (var e = [], t = 0, n = this.cells; t < n.length; t++) {
	        var r = n[t];
	        e.push.apply(e, r.trainableWeights);
	      }

	      return e;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "nonTrainableWeights", {
	    get: function get() {
	      for (var e = [], t = 0, n = this.cells; t < n.length; t++) {
	        var r = n[t];
	        e.push.apply(e, r.nonTrainableWeights);
	      }

	      if (!this.trainable) {
	        for (var i = [], a = 0, o = this.cells; a < o.length; a++) {
	          r = o[a];
	          i.push.apply(i, r.trainableWeights);
	        }

	        return i.concat(e);
	      }

	      return e;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.getWeights = function () {
	    for (var e = [], t = 0, n = this.cells; t < n.length; t++) {
	      var r = n[t];
	      e.push.apply(e, r.weights);
	    }

	    return batchGetValue(e);
	  }, t.prototype.setWeights = function (e) {
	    for (var t = [], n = 0, r = this.cells; n < r.length; n++) {
	      for (var i = r[n], a = i.weights.length, o = e.splice(a), s = 0; s < i.weights.length; ++s) {
	        t.push([i.weights[s], o[s]]);
	      }
	    }

	    batchSetValue(t);
	  }, t.className = "StackedRNNCells", t;
	}(RNNCell);

	function generateDropoutMask(e, t, n, r) {
	  function i() {
	    return dropout$1(e(), t);
	  }

	  if (void 0 === n && (n = null), void 0 === r && (r = 1), r > 1) {
	    for (var a = [], o = 0; o < r; o++) {
	      a.push(inTrainPhase(i, e, n));
	    }

	    return a.map(function (e) {
	      return Ge(e.clone());
	    });
	  }

	  return Ge(inTrainPhase(i, e, n).clone());
	}

	Ph.registerClass(StackedRNNCells);

	var Wrapper = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return n.layer = t.layer, n;
	  }

	  return __extends(t, e), t.prototype.build = function (e) {
	    this.built = !0;
	  }, Object.defineProperty(t.prototype, "trainable", {
	    get: function get() {
	      return null != this.layer && this.layer.trainable;
	    },
	    set: function set(e) {
	      null != this.layer && (this.layer.trainable = e);
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "trainableWeights", {
	    get: function get() {
	      return this.layer.trainableWeights;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "nonTrainableWeights", {
	    get: function get() {
	      return this.layer.nonTrainableWeights;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "updates", {
	    get: function get() {
	      return this.layer._updates;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "losses", {
	    get: function get() {
	      return this.layer.losses;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.getWeights = function () {
	    return this.layer.getWeights();
	  }, t.prototype.setWeights = function (e) {
	    this.layer.setWeights(e);
	  }, t.prototype.getConfig = function () {
	    var t = {
	      layer: {
	        className: this.layer.getClassName(),
	        config: this.layer.getConfig()
	      }
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.prototype.setFastWeightInitDuringBuild = function (t) {
	    e.prototype.setFastWeightInitDuringBuild.call(this, t), null != this.layer && this.layer.setFastWeightInitDuringBuild(t);
	  }, t.fromConfig = function (e, t, n) {
	    void 0 === n && (n = {});
	    var r = deserialize(t.layer, n);
	    delete t.layer;
	    var i = {
	      layer: r
	    };
	    return Object.assign(i, t), new e(i);
	  }, t;
	}(Layer),
	    TimeDistributed = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this;
	    return n.supportsMasking = !0, n;
	  }

	  return __extends(t, e), t.prototype.build = function (t) {
	    if ((t = getExactlyOneShape(t)).length < 3) throw new ValueError("TimeDistributed layer expects an input shape >= 3D, but received input shape " + JSON.stringify(t));
	    this.inputSpec = [{
	      shape: t
	    }];
	    var n = [t[0]].concat(t.slice(2));
	    this.layer.built || (this.layer.build(n), this.layer.built = !0), e.prototype.build.call(this, t);
	  }, t.prototype.computeOutputShape = function (e) {
	    var t = [(e = getExactlyOneShape(e))[0]].concat(e.slice(2)),
	        n = this.layer.computeOutputShape(t),
	        r = e[1];
	    return [n[0], r].concat(n.slice(1));
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      return rnn(function (e, r) {
	        return [getExactlyOneTensor(n.layer.call(e, t)), []];
	      }, e = getExactlyOneTensor(e), [], !1, null, null, !1, !0)[1];
	    });
	  }, t.className = "TimeDistributed", t;
	}(Wrapper);

	function checkBidirectionalMergeMode(e) {
	  checkStringTypeUnionValue(VALID_BIDIRECTIONAL_MERGE_MODES, "BidirectionalMergeMode", e);
	}

	Ph.registerClass(TimeDistributed);

	var DEFAULT_BIDIRECTIONAL_MERGE_MODE = "concat",
	    Bidirectional = function (e) {
	  function t(t) {
	    var n = e.call(this, t) || this,
	        r = t.layer.getConfig(),
	        i = {};
	    i.className = t.layer.getClassName(), i.config = r, n.forwardLayer = deserialize(i), r.goBackwards = !0 !== r.goBackwards;
	    var a = {};
	    if (a.className = t.layer.getClassName(), a.config = r, n.backwardLayer = deserialize(a), n.forwardLayer.name = "forward_" + n.forwardLayer.name, n.backwardLayer.name = "backward_" + n.backwardLayer.name, n.mergeMode = void 0 === t.mergeMode ? DEFAULT_BIDIRECTIONAL_MERGE_MODE : t.mergeMode, checkBidirectionalMergeMode(n.mergeMode), t.weights) throw new NotImplementedError("weights support is not implemented for Bidirectional layer yet.");
	    return n._stateful = t.layer.stateful, n.returnSequences = t.layer.returnSequences, n.returnState = t.layer.returnState, n.supportsMasking = !0, n._trainable = !0, n.inputSpec = t.layer.inputSpec, n.numConstants = null, n;
	  }

	  return __extends(t, e), Object.defineProperty(t.prototype, "trainable", {
	    get: function get() {
	      return this._trainable;
	    },
	    set: function set(e) {
	      this._trainable = e, null != this.forwardLayer && (this.forwardLayer.trainable = e), null != this.backwardLayer && (this.backwardLayer.trainable = e);
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.getWeights = function () {
	    return this.forwardLayer.getWeights().concat(this.backwardLayer.getWeights());
	  }, t.prototype.setWeights = function (e) {
	    var t = e.length,
	        n = Math.floor(t / 2);
	    this.forwardLayer.setWeights(e.slice(0, n)), this.backwardLayer.setWeights(e.slice(n));
	  }, t.prototype.computeOutputShape = function (e) {
	    var t,
	        n,
	        r,
	        i = this.forwardLayer.computeOutputShape(e);
	    return Array.isArray(i) && Array.isArray(i[0]) || (i = [i]), i = i, this.returnState ? (r = i.slice(1), t = i[0]) : t = i[0], t = t, "concat" === this.mergeMode ? (t[t.length - 1] *= 2, n = [t]) : n = null == this.mergeMode ? [t, t.slice()] : [t], this.returnState ? null == this.mergeMode ? n.concat(r).concat(r.slice()) : [t].concat(r).concat(r.slice()) : singletonOrArray(n);
	  }, t.prototype.apply = function (t, n) {
	    var r = null == n ? null : n.initialState,
	        i = null == n ? null : n.constants;
	    null == n && (n = {});
	    var a = standardizeArgs(t, r, i, this.numConstants);
	    if (t = a.inputs, r = a.initialState, i = a.constants, Array.isArray(t) && (r = t.slice(1), t = t[0]), (null == r || 0 === r.length) && null == i) return e.prototype.apply.call(this, t, n);
	    var o = [],
	        s = [];

	    if (null != r) {
	      var l = r.length;
	      if (l % 2 > 0) throw new ValueError("When passing `initialState` to a Bidrectional RNN, the state should be an Array containing the states of the underlying RNNs.");
	      n.initialState = r, o.push.apply(o, r);
	      var u = r.map(function (e) {
	        return new InputSpec({
	          shape: e.shape
	        });
	      });
	      this.forwardLayer.stateSpec = u.slice(0, l / 2), this.backwardLayer.stateSpec = u.slice(l / 2), s.push.apply(s, u);
	    }

	    if (null != i) throw new NotImplementedError("Support for constants in Bidirectional layers is not implemented yet.");

	    for (var c = o[0] instanceof SymbolicTensor, p = 0, h = o; p < h.length; p++) {
	      if (h[p] instanceof SymbolicTensor !== c) throw new ValueError("The initial state of a Bidirectional layer cannot be specified as a mix of symbolic and non-symbolic tensors");
	    }

	    if (c) {
	      var d = [t].concat(o),
	          f = this.inputSpec.concat(s),
	          g = this.inputSpec;
	      this.inputSpec = f;
	      var m = e.prototype.apply.call(this, d, n);
	      return this.inputSpec = g, m;
	    }

	    return e.prototype.apply.call(this, t, n);
	  }, t.prototype.call = function (e, t) {
	    var n = this;
	    return ze(function () {
	      if (null != t.mask) throw new NotImplementedError("The support for masking is not implemented for Bidirectional layers yet.");
	      var r,
	          i,
	          a,
	          o,
	          s = t.initialState;
	      if (null == s) r = n.forwardLayer.call(e, t), i = n.backwardLayer.call(e, t);else {
	        var l = s.slice(0, s.length / 2),
	            u = s.slice(s.length / 2);
	        r = n.forwardLayer.call(e, Object.assign(t, {
	          initialState: l
	        })), i = n.backwardLayer.call(e, Object.assign(t, {
	          initialState: u
	        }));
	      }
	      return n.returnState && (Array.isArray(r) && (a = r.slice(1).concat(i.slice(1))), r = r[0], i = i[0]), n.returnSequences && (i = du(i, 1)), "concat" === n.mergeMode ? o = concatenate([r, i]) : "sum" === n.mergeMode ? o = Zu(r, i) : "ave" === n.mergeMode ? o = fl(.5, Zu(r, i)) : "mul" === n.mergeMode ? o = fl(r, i) : null == n.mergeMode && (o = [r, i]), n.returnState ? null == n.mergeMode ? o.concat(a) : [o].concat(a) : o;
	    });
	  }, t.prototype.resetStates = function (e) {
	    this.forwardLayer.resetStates(), this.backwardLayer.resetStates();
	  }, t.prototype.build = function (e) {
	    var t = this;
	    nameScope(this.forwardLayer.name, function () {
	      t.forwardLayer.build(e);
	    }), nameScope(this.backwardLayer.name, function () {
	      t.backwardLayer.build(e);
	    }), this.built = !0;
	  }, Object.defineProperty(t.prototype, "trainableWeights", {
	    get: function get() {
	      return this.forwardLayer.trainableWeights.concat(this.backwardLayer.trainableWeights);
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(t.prototype, "nonTrainableWeights", {
	    get: function get() {
	      return this.forwardLayer.nonTrainableWeights.concat(this.backwardLayer.nonTrainableWeights);
	    },
	    enumerable: !0,
	    configurable: !0
	  }), t.prototype.setFastWeightInitDuringBuild = function (t) {
	    e.prototype.setFastWeightInitDuringBuild.call(this, t), null != this.forwardLayer && this.forwardLayer.setFastWeightInitDuringBuild(t), null != this.backwardLayer && this.backwardLayer.setFastWeightInitDuringBuild(t);
	  }, t.prototype.getConfig = function () {
	    var t = {
	      mergeMode: this.mergeMode
	    },
	        n = e.prototype.getConfig.call(this);
	    return Object.assign(t, n), t;
	  }, t.fromConfig = function (e, t) {
	    var n = deserialize(t.layer);
	    if (delete t.layer, null != t.numConstants) throw new NotImplementedError("Deserialization of a Bidirectional layer with numConstants present is not supported yet.");
	    var r = t;
	    return r.layer = n, new e(r);
	  }, t.className = "Bidirectional", t;
	}(Wrapper);

	function inputLayer(e) {
	  return new InputLayer(e);
	}

	function elu$2(e) {
	  return new ELU(e);
	}

	function reLU(e) {
	  return new ReLU(e);
	}

	function leakyReLU(e) {
	  return new LeakyReLU(e);
	}

	function prelu$1(e) {
	  return new PReLU(e);
	}

	function softmax$1(e) {
	  return new Softmax$1(e);
	}

	function thresholdedReLU(e) {
	  return new ThresholdedReLU(e);
	}

	function conv1d$2(e) {
	  return new Conv1D(e);
	}

	function conv2d$2(e) {
	  return new Conv2D(e);
	}

	function conv2dTranspose$1(e) {
	  return new Conv2DTranspose(e);
	}

	function conv3d$2(e) {
	  return new Conv3D(e);
	}

	function separableConv2d$1(e) {
	  return new SeparableConv2D(e);
	}

	function cropping2D(e) {
	  return new Cropping2D(e);
	}

	function upSampling2d(e) {
	  return new UpSampling2D(e);
	}

	function depthwiseConv2d$2(e) {
	  return new DepthwiseConv2D(e);
	}

	function activation(e) {
	  return new Activation$1(e);
	}

	function dense(e) {
	  return new Dense(e);
	}

	function dropout$2(e) {
	  return new Dropout(e);
	}

	function flatten$1(e) {
	  return new Flatten(e);
	}

	function repeatVector(e) {
	  return new RepeatVector(e);
	}

	function reshape(e) {
	  return new Reshape(e);
	}

	function permute(e) {
	  return new Permute(e);
	}

	function embedding(e) {
	  return new Embedding(e);
	}

	function add$2(e) {
	  return new Add(e);
	}

	function average$1(e) {
	  return new Average(e);
	}

	function concatenate$2(e) {
	  return new Concatenate(e);
	}

	function maximum$2(e) {
	  return new Maximum(e);
	}

	function minimum$2(e) {
	  return new Minimum(e);
	}

	function multiply$1(e) {
	  return new Multiply(e);
	}

	function dot$1(e) {
	  return new Dot(e);
	}

	function batchNormalization$1(e) {
	  return new BatchNormalization(e);
	}

	function zeroPadding2d(e) {
	  return new ZeroPadding2D(e);
	}

	function averagePooling1d(e) {
	  return new AveragePooling1D(e);
	}

	function avgPool1d(e) {
	  return averagePooling1d(e);
	}

	function avgPooling1d(e) {
	  return averagePooling1d(e);
	}

	function averagePooling2d(e) {
	  return new AveragePooling2D(e);
	}

	function avgPool2d(e) {
	  return averagePooling2d(e);
	}

	function avgPooling2d(e) {
	  return averagePooling2d(e);
	}

	function globalAveragePooling1d(e) {
	  return new GlobalAveragePooling1D(e);
	}

	function globalAveragePooling2d(e) {
	  return new GlobalAveragePooling2D(e);
	}

	function globalMaxPooling1d(e) {
	  return new GlobalMaxPooling1D(e);
	}

	function globalMaxPooling2d(e) {
	  return new GlobalMaxPooling2D(e);
	}

	function maxPooling1d(e) {
	  return new MaxPooling1D(e);
	}

	function maxPooling2d(e) {
	  return new MaxPooling2D(e);
	}

	function gru(e) {
	  return new GRU(e);
	}

	function gruCell(e) {
	  return new GRUCell(e);
	}

	function lstm(e) {
	  return new LSTM(e);
	}

	function lstmCell(e) {
	  return new LSTMCell(e);
	}

	function simpleRNN(e) {
	  return new SimpleRNN(e);
	}

	function simpleRNNCell(e) {
	  return new SimpleRNNCell(e);
	}

	function rnn$1(e) {
	  return new RNN(e);
	}

	function stackedRNNCells(e) {
	  return new StackedRNNCells(e);
	}

	function bidirectional(e) {
	  return new Bidirectional(e);
	}

	function timeDistributed(e) {
	  return new TimeDistributed(e);
	}

	Ph.registerClass(Bidirectional);
	var globalMaxPool1d = globalMaxPooling1d,
	    globalMaxPool2d = globalMaxPooling2d,
	    maxPool1d = maxPooling1d,
	    maxPool2d = maxPooling2d;

	function gaussianNoise(e) {
	  return new GaussianNoise(e);
	}

	function gaussianDropout(e) {
	  return new GaussianDropout(e);
	}

	function alphaDropout(e) {
	  return new AlphaDropout(e);
	}

	function masking(e) {
	  return new Masking(e);
	}

	var exports_layers = Object.freeze({
	  inputLayer: inputLayer,
	  elu: elu$2,
	  reLU: reLU,
	  leakyReLU: leakyReLU,
	  prelu: prelu$1,
	  softmax: softmax$1,
	  thresholdedReLU: thresholdedReLU,
	  conv1d: conv1d$2,
	  conv2d: conv2d$2,
	  conv2dTranspose: conv2dTranspose$1,
	  conv3d: conv3d$2,
	  separableConv2d: separableConv2d$1,
	  cropping2D: cropping2D,
	  upSampling2d: upSampling2d,
	  depthwiseConv2d: depthwiseConv2d$2,
	  activation: activation,
	  dense: dense,
	  dropout: dropout$2,
	  flatten: flatten$1,
	  repeatVector: repeatVector,
	  reshape: reshape,
	  permute: permute,
	  embedding: embedding,
	  add: add$2,
	  average: average$1,
	  concatenate: concatenate$2,
	  maximum: maximum$2,
	  minimum: minimum$2,
	  multiply: multiply$1,
	  dot: dot$1,
	  batchNormalization: batchNormalization$1,
	  zeroPadding2d: zeroPadding2d,
	  averagePooling1d: averagePooling1d,
	  avgPool1d: avgPool1d,
	  avgPooling1d: avgPooling1d,
	  averagePooling2d: averagePooling2d,
	  avgPool2d: avgPool2d,
	  avgPooling2d: avgPooling2d,
	  globalAveragePooling1d: globalAveragePooling1d,
	  globalAveragePooling2d: globalAveragePooling2d,
	  globalMaxPooling1d: globalMaxPooling1d,
	  globalMaxPooling2d: globalMaxPooling2d,
	  maxPooling1d: maxPooling1d,
	  maxPooling2d: maxPooling2d,
	  gru: gru,
	  gruCell: gruCell,
	  lstm: lstm,
	  lstmCell: lstmCell,
	  simpleRNN: simpleRNN,
	  simpleRNNCell: simpleRNNCell,
	  rnn: rnn$1,
	  stackedRNNCells: stackedRNNCells,
	  bidirectional: bidirectional,
	  timeDistributed: timeDistributed,
	  globalMaxPool1d: globalMaxPool1d,
	  globalMaxPool2d: globalMaxPool2d,
	  maxPool1d: maxPool1d,
	  maxPool2d: maxPool2d,
	  Layer: Layer,
	  RNN: RNN,
	  RNNCell: RNNCell,
	  input: input,
	  gaussianNoise: gaussianNoise,
	  gaussianDropout: gaussianDropout,
	  alphaDropout: alphaDropout,
	  masking: masking
	});

	function binaryAccuracy$1(e, t) {
	  return binaryAccuracy(e, t);
	}

	function binaryCrossentropy$2(e, t) {
	  return binaryCrossentropy$1(e, t);
	}

	function sparseCategoricalAccuracy$1(e, t) {
	  return sparseCategoricalAccuracy(e, t);
	}

	function categoricalAccuracy$1(e, t) {
	  return categoricalAccuracy(e, t);
	}

	function categoricalCrossentropy$2(e, t) {
	  return categoricalCrossentropy$1(e, t);
	}

	function precision$1(e, t) {
	  return precision(e, t);
	}

	function recall$1(e, t) {
	  return recall(e, t);
	}

	function cosineProximity$1(e, t) {
	  return cosineProximity(e, t);
	}

	function meanAbsoluteError$1(e, t) {
	  return meanAbsoluteError(e, t);
	}

	function meanAbsolutePercentageError$1(e, t) {
	  return meanAbsolutePercentageError(e, t);
	}

	function MAPE$2(e, t) {
	  return meanAbsolutePercentageError(e, t);
	}

	function mape$2(e, t) {
	  return meanAbsolutePercentageError(e, t);
	}

	function meanSquaredError$1(e, t) {
	  return meanSquaredError(e, t);
	}

	function MSE$2(e, t) {
	  return meanSquaredError(e, t);
	}

	function mse$2(e, t) {
	  return meanSquaredError(e, t);
	}

	var exports_metrics = Object.freeze({
	  binaryAccuracy: binaryAccuracy$1,
	  binaryCrossentropy: binaryCrossentropy$2,
	  sparseCategoricalAccuracy: sparseCategoricalAccuracy$1,
	  categoricalAccuracy: categoricalAccuracy$1,
	  categoricalCrossentropy: categoricalCrossentropy$2,
	  precision: precision$1,
	  recall: recall$1,
	  cosineProximity: cosineProximity$1,
	  meanAbsoluteError: meanAbsoluteError$1,
	  meanAbsolutePercentageError: meanAbsolutePercentageError$1,
	  MAPE: MAPE$2,
	  mape: mape$2,
	  meanSquaredError: meanSquaredError$1,
	  MSE: MSE$2,
	  mse: mse$2
	}),
	    exports_models = Object.freeze({
	  modelFromJSON: modelFromJSON
	});

	function l1l2(e) {
	  return new L1L2(e);
	}

	function l1$1(e) {
	  return l1(e);
	}

	function l2$1(e) {
	  return l2(e);
	}

	var exports_regularizers = Object.freeze({
	  l1l2: l1l2,
	  l1: l1$1,
	  l2: l2$1
	}),
	    Callback = function (e) {
	  function t() {
	    var t = null !== e && e.apply(this, arguments) || this;
	    return t.model = null, t;
	  }

	  return __extends(t, e), t.prototype.setModel = function (e) {
	    if (!(e instanceof LayersModel)) throw new Error("model must be a LayersModel, not some other Container");
	    this.model = e;
	  }, t;
	}(BaseCallback);

	function less(e, t) {
	  return e < t;
	}

	function greater$1(e, t) {
	  return e > t;
	}

	var EarlyStopping = function (e) {
	  function t(t) {
	    var n = e.call(this) || this;
	    if (null == t && (t = {}), t.restoreBestWeights) throw new NotImplementedError("restoreBestWeights = True is not implemented in EarlyStopping yet.");
	    return n.monitor = t.monitor || "val_loss", n.minDelta = Math.abs(t.minDelta || 0), n.patience = t.patience || 0, n.verbose = t.verbose || 0, n.mode = t.mode || "auto", n.baseline = t.baseline, -1 === ["auto", "min", "max"].indexOf(n.mode) && (console.warn("EarlyStopping mode '" + n.mode + "' is invalid. Falling back to mode 'auto'."), n.mode = "auto"), "min" === n.mode ? n.monitorFunc = less : "max" === n.mode ? n.monitorFunc = greater$1 : -1 !== n.monitor.indexOf("acc") ? n.monitorFunc = greater$1 : n.monitorFunc = less, n.monitorFunc === less && (n.minDelta *= -1), n;
	  }

	  return __extends(t, e), t.prototype.onTrainBegin = function (e) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (e) {
	        return this.wait = 0, this.stoppedEpoch = 0, null != this.baseline ? this.best = this.baseline : this.best = this.monitorFunc === less ? 1 / 0 : -1 / 0, [2];
	      });
	    });
	  }, t.prototype.onEpochEnd = function (e, t) {
	    return __awaiter(this, void 0, void 0, function () {
	      var n;
	      return __generator(this, function (r) {
	        switch (r.label) {
	          case 0:
	            return [4, resolveScalarsInLogs(t)];

	          case 1:
	            return r.sent(), null == (n = this.getMonitorValue(t)) ? [2] : (this.monitorFunc(n - this.minDelta, this.best) ? (this.best = n, this.wait = 0) : (this.wait++, this.wait >= this.patience && (this.stoppedEpoch = e, this.model.stopTraining = !0)), [2]);
	        }
	      });
	    });
	  }, t.prototype.onTrainEnd = function (e) {
	    return __awaiter(this, void 0, void 0, function () {
	      return __generator(this, function (e) {
	        return this.stoppedEpoch > 0 && this.verbose && console.log("Epoch " + this.stoppedEpoch + ": early stopping."), [2];
	      });
	    });
	  }, t.prototype.getMonitorValue = function (e) {
	    null == e && (e = {});
	    var t = e[this.monitor];
	    return null == t && console.warn("Metric for EarlyStopping " + this.monitor + " is not available. Available metrics are: " + Object.keys(e)), t;
	  }, t;
	}(Callback);

	function earlyStopping(e) {
	  return new EarlyStopping(e);
	}

	var callbacks = {
	  earlyStopping: earlyStopping
	};

	var _assign$1 = function __assign() {
	  return (_assign$1 = Object.assign || function (e) {
	    for (var t, a = 1, r = arguments.length; a < r; a++) {
	      for (var n in t = arguments[a]) {
	        Object.prototype.hasOwnProperty.call(t, n) && (e[n] = t[n]);
	      }
	    }

	    return e;
	  }).apply(this, arguments);
	};

	function __awaiter$1(e, t, a, r) {
	  return new (a || (a = Promise))(function (n, s) {
	    function o(e) {
	      try {
	        u(r.next(e));
	      } catch (e) {
	        s(e);
	      }
	    }

	    function p(e) {
	      try {
	        u(r["throw"](e));
	      } catch (e) {
	        s(e);
	      }
	    }

	    function u(e) {
	      e.done ? n(e.value) : new a(function (t) {
	        t(e.value);
	      }).then(o, p);
	    }

	    u((r = r.apply(e, t || [])).next());
	  });
	}

	function __generator$1(e, t) {
	  var a,
	      r,
	      n,
	      s,
	      o = {
	    label: 0,
	    sent: function sent() {
	      if (1 & n[0]) throw n[1];
	      return n[1];
	    },
	    trys: [],
	    ops: []
	  };
	  return s = {
	    next: p(0),
	    "throw": p(1),
	    "return": p(2)
	  }, "function" == typeof Symbol && (s[Symbol.iterator] = function () {
	    return this;
	  }), s;

	  function p(s) {
	    return function (p) {
	      return function (s) {
	        if (a) throw new TypeError("Generator is already executing.");

	        for (; o;) {
	          try {
	            if (a = 1, r && (n = 2 & s[0] ? r["return"] : s[0] ? r["throw"] || ((n = r["return"]) && n.call(r), 0) : r.next) && !(n = n.call(r, s[1])).done) return n;

	            switch (r = 0, n && (s = [2 & s[0], n.value]), s[0]) {
	              case 0:
	              case 1:
	                n = s;
	                break;

	              case 4:
	                return o.label++, {
	                  value: s[1],
	                  done: !1
	                };

	              case 5:
	                o.label++, r = s[1], s = [0];
	                continue;

	              case 7:
	                s = o.ops.pop(), o.trys.pop();
	                continue;

	              default:
	                if (!(n = (n = o.trys).length > 0 && n[n.length - 1]) && (6 === s[0] || 2 === s[0])) {
	                  o = 0;
	                  continue;
	                }

	                if (3 === s[0] && (!n || s[1] > n[0] && s[1] < n[3])) {
	                  o.label = s[1];
	                  break;
	                }

	                if (6 === s[0] && o.label < n[1]) {
	                  o.label = n[1], n = s;
	                  break;
	                }

	                if (n && o.label < n[2]) {
	                  o.label = n[2], o.ops.push(s);
	                  break;
	                }

	                n[2] && o.ops.pop(), o.trys.pop();
	                continue;
	            }

	            s = t.call(e, o);
	          } catch (e) {
	            s = [6, e], r = 0;
	          } finally {
	            a = n = 0;
	          }
	        }

	        if (5 & s[0]) throw s[1];
	        return {
	          value: s[0] ? s[1] : void 0,
	          done: !0
	        };
	      }([s, p]);
	    };
	  }
	}

	var DataType,
	    SaverDef,
	    CUSTOM_OPS = {};

	function registerOp(e, t) {
	  var a = {
	    tfOpName: e,
	    category: "custom",
	    inputs: [],
	    attrs: [],
	    customExecutor: t
	  };
	  CUSTOM_OPS[e] = a;
	}

	function getRegisteredOp(e) {
	  return CUSTOM_OPS[e];
	}

	function deregisterOp(e) {
	  delete CUSTOM_OPS[e];
	}

	function getParamValue(e, t, a, r) {
	  var n = t.inputParams[e];

	  if (n && void 0 !== n.inputIndexStart) {
	    var s = n.inputIndexStart,
	        o = 0 === n.inputIndexEnd ? void 0 : void 0 === n.inputIndexEnd ? s + 1 : n.inputIndexEnd;
	    if ("tensor" === n.type) return getTensor(t.inputNames[n.inputIndexStart], a, r);
	    if ("tensors" === n.type) return t.inputNames.slice(s, o).map(function (e) {
	      return getTensor(e, a, r);
	    });
	    var p = Array.prototype.slice.call(getTensor(t.inputNames.slice(s)[0], a, r).dataSync());
	    return "number" === n.type ? p[0] : p;
	  }

	  var u = t.attrParams[e];
	  return u && u.value;
	}

	function getTensor(e, t, a) {
	  var r = parseNodeName(e),
	      n = r[0],
	      s = r[1],
	      o = a.currentContextIds.find(function (e) {
	    return !!t[getNodeNameWithContextId(n, e)];
	  });
	  return void 0 !== o ? t[getNodeNameWithContextId(n, o)][s] : void 0;
	}

	function getTensorsForCurrentContenxt(e, t, a) {
	  return t[getNodeNameWithContextId(e, a.currentContextId)];
	}

	function getNodeNameAndIndex(e, t) {
	  var a = parseNodeName(e),
	      r = a[0],
	      n = a[1];
	  return [getNodeNameWithContextId(r, t && t.currentContextId), n];
	}

	function getNodeNameWithContextId(e, t) {
	  return t ? e + "-" + t : e;
	}

	function parseNodeName(e) {
	  var t = e.lastIndexOf(":");
	  return -1 === t ? [e, 0] : [e.substring(0, t), Number(e.substring(t + 1))];
	}

	function split$1(e, t) {
	  for (var a = [], r = 0; r < e.length; r += t) {
	    a.push(e.slice(r, r + t));
	  }

	  return a;
	}

	!function (e) {
	  e[e.DT_INVALID = 0] = "DT_INVALID", e[e.DT_FLOAT = 1] = "DT_FLOAT", e[e.DT_DOUBLE = 2] = "DT_DOUBLE", e[e.DT_INT32 = 3] = "DT_INT32", e[e.DT_UINT8 = 4] = "DT_UINT8", e[e.DT_INT16 = 5] = "DT_INT16", e[e.DT_INT8 = 6] = "DT_INT8", e[e.DT_STRING = 7] = "DT_STRING", e[e.DT_COMPLEX64 = 8] = "DT_COMPLEX64", e[e.DT_INT64 = 9] = "DT_INT64", e[e.DT_BOOL = 10] = "DT_BOOL", e[e.DT_QINT8 = 11] = "DT_QINT8", e[e.DT_QUINT8 = 12] = "DT_QUINT8", e[e.DT_QINT32 = 13] = "DT_QINT32", e[e.DT_BFLOAT16 = 14] = "DT_BFLOAT16", e[e.DT_FLOAT_REF = 101] = "DT_FLOAT_REF", e[e.DT_DOUBLE_REF = 102] = "DT_DOUBLE_REF", e[e.DT_INT32_REF = 103] = "DT_INT32_REF", e[e.DT_UINT8_REF = 104] = "DT_UINT8_REF", e[e.DT_INT16_REF = 105] = "DT_INT16_REF", e[e.DT_INT8_REF = 106] = "DT_INT8_REF", e[e.DT_STRING_REF = 107] = "DT_STRING_REF", e[e.DT_COMPLEX64_REF = 108] = "DT_COMPLEX64_REF", e[e.DT_INT64_REF = 109] = "DT_INT64_REF", e[e.DT_BOOL_REF = 110] = "DT_BOOL_REF", e[e.DT_QINT8_REF = 111] = "DT_QINT8_REF", e[e.DT_QUINT8_REF = 112] = "DT_QUINT8_REF", e[e.DT_QINT32_REF = 113] = "DT_QINT32_REF", e[e.DT_BFLOAT16_REF = 114] = "DT_BFLOAT16_REF";
	}(DataType || (DataType = {})), function (e) {
	  !function (e) {
	    e[e.LEGACY = 0] = "LEGACY", e[e.V1 = 1] = "V1", e[e.V2 = 2] = "V2";
	  }(e.CheckpointFormatVersion || (e.CheckpointFormatVersion = {}));
	}(SaverDef || (SaverDef = {}));

	var json = [{
	  tfOpName: "Add",
	  category: "arithmetic",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "AddV2",
	  category: "arithmetic",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "AddN",
	  category: "arithmetic",
	  inputs: [{
	    start: 0,
	    end: 0,
	    name: "tensors",
	    type: "tensors"
	  }]
	}, {
	  tfOpName: "BiasAdd",
	  category: "arithmetic",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Sub",
	  category: "arithmetic",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "RealDiv",
	  category: "arithmetic",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Div",
	  category: "arithmetic",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "FloorDiv",
	  category: "arithmetic",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Mul",
	  category: "arithmetic",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Maximum",
	  category: "arithmetic",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }]
	}, {
	  tfOpName: "Minimum",
	  category: "arithmetic",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }]
	}, {
	  tfOpName: "Pow",
	  category: "arithmetic",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "SquaredDifference",
	  category: "arithmetic",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Mod",
	  category: "arithmetic",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "FloorMod",
	  category: "arithmetic",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}],
	    arithmetic = Object.freeze({
	  json: json
	}),
	    json$1 = [{
	  tfOpName: "Abs",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Acos",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Asin",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Atan",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Atan2",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "y",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Ceil",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "ClipByValue",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "clip_value_min",
	    name: "clipValueMin",
	    type: "number"
	  }, {
	    tfName: "clip_value_max",
	    name: "clipValueMax",
	    type: "number"
	  }]
	}, {
	  tfOpName: "Complex",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "real",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "imag",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "ComplexAbs",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Cos",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Cosh",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Elu",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Exp",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Floor",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Log",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Neg",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Relu",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Relu6",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }, {
	    tfName: "clipValueMin",
	    name: "clipValueMin",
	    type: "number",
	    defaultValue: 0
	  }, {
	    tfName: "clipValueMax",
	    name: "clipValueMax",
	    type: "number",
	    defaultValue: 6
	  }]
	}, {
	  tfOpName: "Selu",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Sigmoid",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Sin",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Sinh",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Sqrt",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Rsqrt",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Square",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Tan",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Tanh",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Sign",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Round",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Expm1",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Log1p",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Reciprocal",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Softplus",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Asinh",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Acosh",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Atanh",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Erf",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Prod",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "axes",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "keep_dims",
	    name: "keepDims",
	    type: "bool",
	    notSupported: !0
	  }, {
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "LeakyRelu",
	  category: "basic_math",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "alpha",
	    name: "alpha",
	    type: "number",
	    defaultValue: .2
	  }, {
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}],
	    basicMath = Object.freeze({
	  json: json$1
	}),
	    json$2 = [{
	  tfOpName: "LoopCond",
	  category: "control",
	  inputs: [{
	    start: 0,
	    name: "pred",
	    type: "tensor"
	  }]
	}, {
	  tfOpName: "Switch",
	  category: "control",
	  inputs: [{
	    start: 0,
	    name: "data",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "pred",
	    type: "tensor"
	  }]
	}, {
	  tfOpName: "Merge",
	  category: "control",
	  inputs: [{
	    start: 0,
	    end: 0,
	    name: "tensors",
	    type: "tensors"
	  }]
	}, {
	  tfOpName: "Enter",
	  category: "control",
	  inputs: [{
	    start: 0,
	    name: "tensor",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }, {
	    tfName: "frame_name",
	    name: "frameName",
	    type: "string"
	  }, {
	    tfName: "is_constant",
	    name: "isConstant",
	    type: "bool"
	  }]
	}, {
	  tfOpName: "Exit",
	  category: "control",
	  inputs: [{
	    start: 0,
	    name: "tensor",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "NextIteration",
	  category: "control",
	  inputs: [{
	    start: 0,
	    name: "tensor",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "TensorArrayV3",
	  category: "control",
	  inputs: [{
	    start: 0,
	    name: "size",
	    type: "number"
	  }],
	  attrs: [{
	    tfName: "dtype",
	    name: "dtype",
	    type: "dtype"
	  }, {
	    tfName: "element_shape",
	    name: "elementShape",
	    type: "shape"
	  }, {
	    tfName: "dynamic_size",
	    name: "dynamicSize",
	    type: "bool"
	  }, {
	    tfName: "clear_after_read",
	    name: "clearAfterRead",
	    type: "bool"
	  }, {
	    tfName: "identical_element_shapes",
	    name: "identicalElementShapes",
	    type: "bool"
	  }, {
	    tfName: "tensor_array_name",
	    name: "name",
	    type: "string"
	  }]
	}, {
	  tfOpName: "TensorArrayWriteV3",
	  category: "control",
	  inputs: [{
	    start: 0,
	    name: "tensorArrayId",
	    type: "number"
	  }, {
	    start: 1,
	    name: "index",
	    type: "number"
	  }, {
	    start: 2,
	    name: "tensor",
	    type: "tensor"
	  }, {
	    start: 3,
	    name: "flowIn",
	    type: "number"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "TensorArrayReadV3",
	  category: "control",
	  inputs: [{
	    start: 0,
	    name: "tensorArrayId",
	    type: "number"
	  }, {
	    start: 1,
	    name: "index",
	    type: "number"
	  }, {
	    start: 2,
	    name: "flowIn",
	    type: "number"
	  }],
	  attrs: [{
	    tfName: "dtype",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "TensorArrayGatherV3",
	  category: "control",
	  inputs: [{
	    start: 0,
	    name: "tensorArrayId",
	    type: "number"
	  }, {
	    start: 1,
	    name: "indices",
	    type: "number[]"
	  }, {
	    start: 2,
	    name: "flowIn",
	    type: "number"
	  }],
	  attrs: [{
	    tfName: "dtype",
	    name: "dtype",
	    type: "dtype"
	  }, {
	    tfName: "element_shape",
	    name: "elementShape",
	    type: "shape"
	  }]
	}, {
	  tfOpName: "TensorArrayScatterV3",
	  category: "control",
	  inputs: [{
	    start: 0,
	    name: "tensorArrayId",
	    type: "number"
	  }, {
	    start: 1,
	    name: "indices",
	    type: "number[]"
	  }, {
	    start: 2,
	    name: "tensor",
	    type: "tensor"
	  }, {
	    start: 3,
	    name: "flowIn",
	    type: "number"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype"
	  }]
	}, {
	  tfOpName: "TensorArrayConcatV3",
	  category: "control",
	  inputs: [{
	    start: 0,
	    name: "tensorArrayId",
	    type: "number"
	  }, {
	    start: 1,
	    name: "flowIn",
	    type: "number"
	  }],
	  attrs: [{
	    tfName: "dtype",
	    name: "dtype",
	    type: "dtype"
	  }, {
	    tfName: "element_shape_except0",
	    name: "elementShapeExcept0",
	    type: "shape",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "TensorArraySplitV3",
	  category: "control",
	  inputs: [{
	    start: 0,
	    name: "tensorArrayId",
	    type: "number"
	  }, {
	    start: 1,
	    name: "tensor",
	    type: "tensor"
	  }, {
	    start: 2,
	    name: "lengths",
	    type: "number[]"
	  }, {
	    start: 3,
	    name: "flowIn",
	    type: "number"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype"
	  }]
	}, {
	  tfOpName: "TensorArraySizeV3",
	  category: "control",
	  inputs: [{
	    start: 0,
	    name: "tensorArrayId",
	    type: "number"
	  }, {
	    start: 1,
	    name: "flowIn",
	    type: "number"
	  }]
	}, {
	  tfOpName: "TensorArrayCloseV3",
	  category: "control",
	  inputs: [{
	    start: 0,
	    name: "tensorArrayId",
	    type: "number"
	  }]
	}],
	    control = Object.freeze({
	  json: json$2
	}),
	    json$3 = [{
	  tfOpName: "AvgPool",
	  category: "convolution",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "strides",
	    name: "strides",
	    type: "number[]"
	  }, {
	    tfName: "padding",
	    name: "pad",
	    type: "string"
	  }, {
	    tfName: "data_format",
	    name: "dataFormat",
	    type: "string",
	    notSupported: !0
	  }, {
	    tfName: "ksize",
	    name: "kernelSize",
	    type: "number[]"
	  }, {
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "MaxPool",
	  category: "convolution",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "strides",
	    name: "strides",
	    type: "number[]"
	  }, {
	    tfName: "padding",
	    name: "pad",
	    type: "string"
	  }, {
	    tfName: "data_format",
	    name: "dataFormat",
	    type: "string",
	    notSupported: !0
	  }, {
	    tfName: "ksize",
	    name: "kernelSize",
	    type: "number[]"
	  }, {
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Conv1D",
	  category: "convolution",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "filter",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "stride",
	    name: "stride",
	    type: "number"
	  }, {
	    tfName: "padding",
	    name: "pad",
	    type: "string"
	  }, {
	    tfName: "data_format",
	    name: "dataFormat",
	    type: "string",
	    defaultValue: "NWC"
	  }, {
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }, {
	    tfName: "dilation",
	    name: "dilation",
	    type: "number",
	    defaultValue: 1
	  }]
	}, {
	  tfOpName: "Conv2D",
	  category: "convolution",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "filter",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }, {
	    tfName: "strides",
	    name: "strides",
	    type: "number[]"
	  }, {
	    tfName: "padding",
	    name: "pad",
	    type: "string"
	  }, {
	    tfName: "useCudnnOnGpu",
	    name: "useCudnnOnGpu",
	    type: "bool"
	  }, {
	    tfName: "data_format",
	    name: "dataFormat",
	    type: "string",
	    defaultValue: "NHWC"
	  }, {
	    tfName: "dilations",
	    name: "dilations",
	    type: "number[]"
	  }]
	}, {
	  tfOpName: "Conv2DBackpropInput",
	  category: "convolution",
	  inputs: [{
	    start: 2,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "filter",
	    type: "tensor"
	  }, {
	    start: 0,
	    name: "outputShape",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "strides",
	    name: "strides",
	    type: "number[]"
	  }, {
	    tfName: "padding",
	    name: "pad",
	    type: "string"
	  }, {
	    tfName: "data_format",
	    name: "dataFormat",
	    type: "string",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "DepthwiseConv2d",
	  category: "convolution",
	  inputs: [{
	    start: 0,
	    name: "input",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "filter",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "strides",
	    name: "strides",
	    type: "number[]"
	  }, {
	    tfName: "padding",
	    name: "pad",
	    type: "string"
	  }, {
	    tfName: "data_format",
	    name: "dataFormat",
	    type: "string",
	    defaultValue: "NHWC"
	  }, {
	    tfName: "dilations",
	    name: "dilations",
	    type: "number[]"
	  }]
	}, {
	  tfOpName: "DepthwiseConv2dNative",
	  category: "convolution",
	  inputs: [{
	    start: 0,
	    name: "input",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "filter",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "strides",
	    name: "strides",
	    type: "number[]"
	  }, {
	    tfName: "padding",
	    name: "pad",
	    type: "string"
	  }, {
	    tfName: "data_format",
	    name: "dataFormat",
	    type: "string",
	    defaultValue: "NHWC"
	  }, {
	    tfName: "dilations",
	    name: "dilations",
	    type: "number[]"
	  }]
	}],
	    convolution = Object.freeze({
	  json: json$3
	}),
	    json$4 = [{
	  tfOpName: "Fill",
	  category: "creation",
	  inputs: [{
	    start: 0,
	    name: "shape",
	    type: "number[]"
	  }, {
	    start: 1,
	    name: "value",
	    type: "number"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype"
	  }]
	}, {
	  tfOpName: "LinSpace",
	  category: "creation",
	  inputs: [{
	    start: 0,
	    name: "start",
	    type: "number"
	  }, {
	    start: 1,
	    name: "stop",
	    type: "number"
	  }, {
	    start: 2,
	    name: "num",
	    type: "number"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "OneHot",
	  category: "creation",
	  inputs: [{
	    start: 0,
	    name: "indices",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "depth",
	    type: "number"
	  }, {
	    start: 2,
	    name: "onValue",
	    type: "number",
	    defaultValue: 1
	  }, {
	    start: 3,
	    name: "offValue",
	    type: "number",
	    defaultValue: 0
	  }],
	  attrs: [{
	    tfName: "axis",
	    name: "axis",
	    type: "number",
	    notSupported: !0
	  }, {
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Ones",
	  category: "creation",
	  inputs: [{
	    start: 0,
	    name: "shape",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype"
	  }]
	}, {
	  tfOpName: "OnesLike",
	  category: "creation",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "dtype",
	    name: "dtype",
	    type: "dtype"
	  }]
	}, {
	  tfOpName: "RandomUniform",
	  category: "creation",
	  inputs: [{
	    start: 0,
	    name: "shape",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "minval",
	    name: "minval",
	    type: "number",
	    defaultValue: 0
	  }, {
	    tfName: "maxval",
	    name: "maxval",
	    type: "number",
	    defaultValue: 1
	  }, {
	    tfName: "dtype",
	    name: "dtype",
	    type: "dtype"
	  }, {
	    tfName: "seed",
	    name: "seed",
	    type: "number",
	    defaultValue: 0
	  }, {
	    tfName: "seed2",
	    name: "seed2",
	    type: "number",
	    defaultValue: 0,
	    notSupported: !0
	  }, {
	    tfName: "T",
	    name: "T",
	    type: "number",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Range",
	  category: "creation",
	  inputs: [{
	    start: 0,
	    name: "start",
	    type: "number"
	  }, {
	    start: 1,
	    name: "stop",
	    type: "number"
	  }, {
	    start: 2,
	    name: "step",
	    type: "number",
	    defaultValue: 0
	  }],
	  attrs: [{
	    tfName: "Tidx",
	    name: "dtype",
	    type: "dtype"
	  }]
	}, {
	  tfOpName: "TruncatedNormal",
	  category: "creation",
	  inputs: [{
	    start: 0,
	    name: "shape",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "means",
	    name: "mean",
	    type: "number",
	    defaultValue: 0
	  }, {
	    tfName: "stddev",
	    name: "stdDev",
	    type: "number",
	    defaultValue: 1
	  }, {
	    tfName: "seed",
	    name: "seed",
	    type: "number"
	  }, {
	    tfName: "seed2",
	    name: "seed2",
	    type: "number",
	    defaultValue: 0,
	    notSupported: !0
	  }, {
	    tfName: "dtype",
	    name: "dtype",
	    type: "dtype"
	  }, {
	    tfName: "T",
	    name: "T",
	    type: "number",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Zeros",
	  category: "creation",
	  inputs: [{
	    start: 0,
	    name: "shape",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype"
	  }]
	}, {
	  tfOpName: "ZerosLike",
	  category: "creation",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype"
	  }]
	}],
	    creation = Object.freeze({
	  json: json$4
	}),
	    json$5 = [{
	  tfOpName: "NonMaxSuppressionV2",
	  category: "dynamic",
	  inputs: [{
	    start: 0,
	    name: "boxes",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "scores",
	    type: "tensor"
	  }, {
	    start: 2,
	    name: "maxOutputSize",
	    type: "number"
	  }, {
	    start: 3,
	    name: "iouThreshold",
	    type: "number"
	  }]
	}, {
	  tfOpName: "NonMaxSuppressionV3",
	  category: "dynamic",
	  inputs: [{
	    start: 0,
	    name: "boxes",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "scores",
	    type: "tensor"
	  }, {
	    start: 2,
	    name: "maxOutputSize",
	    type: "number"
	  }, {
	    start: 3,
	    name: "iouThreshold",
	    type: "number"
	  }, {
	    start: 4,
	    name: "scoreThreshold",
	    type: "number"
	  }]
	}, {
	  tfOpName: "Where",
	  category: "dynamic",
	  inputs: [{
	    start: 0,
	    name: "condition",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "ListDiff",
	  category: "dynamic",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "y",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}],
	    dynamic = Object.freeze({
	  json: json$5
	}),
	    json$6 = [{
	  tfOpName: "TopKV2",
	  category: "evaluation",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "k",
	    type: "number"
	  }],
	  attrs: [{
	    tfName: "sorted",
	    name: "sorted",
	    type: "bool"
	  }]
	}],
	    evaluation = Object.freeze({
	  json: json$6
	}),
	    json$7 = [{
	  tfOpName: "PlaceholderWithDefault",
	  category: "graph",
	  inputs: [{
	    start: 0,
	    name: "default",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "shape",
	    name: "shape",
	    type: "shape"
	  }, {
	    tfName: "dtype",
	    name: "dtype",
	    type: "dtype"
	  }]
	}, {
	  tfOpName: "Placeholder",
	  category: "graph",
	  attrs: [{
	    tfName: "shape",
	    name: "shape",
	    type: "shape"
	  }, {
	    tfName: "dtype",
	    name: "dtype",
	    type: "dtype"
	  }]
	}, {
	  tfOpName: "Const",
	  category: "graph"
	}, {
	  tfOpName: "Identity",
	  category: "graph",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }]
	}, {
	  tfOpName: "IdentityN",
	  category: "graph",
	  inputs: [{
	    start: 0,
	    end: 0,
	    name: "x",
	    type: "tensors"
	  }]
	}, {
	  tfOpName: "Snapshot",
	  category: "graph",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }]
	}, {
	  tfOpName: "Rank",
	  category: "graph",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }]
	}, {
	  tfOpName: "Size",
	  category: "graph",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }]
	}, {
	  tfOpName: "Shape",
	  category: "graph",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }]
	}, {
	  tfOpName: "ShapeN",
	  category: "graph",
	  inputs: [{
	    start: 0,
	    end: 0,
	    name: "x",
	    type: "tensors"
	  }]
	}, {
	  tfOpName: "Print",
	  category: "graph",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "data",
	    type: "tensors"
	  }],
	  attrs: [{
	    tfName: "message",
	    name: "message",
	    type: "string"
	  }, {
	    tfName: "first_n",
	    name: "firstN",
	    type: "number",
	    notSupported: !0
	  }, {
	    tfName: "summarize",
	    name: "summarize",
	    type: "number",
	    defaultValue: 3
	  }]
	}, {
	  tfOpName: "NoOp",
	  category: "graph",
	  inputs: []
	}, {
	  tfOpName: "StopGradient",
	  category: "graph",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }]
	}, {
	  tfOpName: "FakeQuantWithMinMaxVars",
	  category: "graph",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "min",
	    name: "min",
	    type: "number"
	  }, {
	    tfName: "max",
	    name: "max",
	    type: "number"
	  }]
	}],
	    graph = Object.freeze({
	  json: json$7
	}),
	    json$8 = [{
	  tfOpName: "ResizeBilinear",
	  category: "image",
	  inputs: [{
	    start: 0,
	    name: "images",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "size",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "align_corners",
	    name: "alignCorners",
	    type: "bool"
	  }, {
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "ResizeNearestNeighbor",
	  category: "image",
	  inputs: [{
	    start: 0,
	    name: "images",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "size",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "align_corners",
	    name: "alignCorners",
	    type: "bool"
	  }, {
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "CropAndResize",
	  category: "image",
	  inputs: [{
	    start: 0,
	    name: "image",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "boxes",
	    type: "tensor"
	  }, {
	    start: 2,
	    name: "boxInd",
	    type: "tensor"
	  }, {
	    start: 3,
	    name: "cropSize",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "method",
	    name: "method",
	    type: "string"
	  }, {
	    tfName: "extrapolation_value",
	    name: "extrapolationValue",
	    type: "number"
	  }]
	}],
	    image$1 = Object.freeze({
	  json: json$8
	}),
	    json$9 = [{
	  tfOpName: "Equal",
	  category: "logical",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "NotEqual",
	  category: "logical",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Greater",
	  category: "logical",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "GreaterEqual",
	  category: "logical",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Less",
	  category: "logical",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "LessEqual",
	  category: "logical",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "LogicalAnd",
	  category: "logical",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "LogicalNot",
	  category: "logical",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "LogicalOr",
	  category: "logical",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Select",
	  category: "logical",
	  inputs: [{
	    start: 0,
	    name: "condition",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 2,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}],
	    logical = Object.freeze({
	  json: json$9
	}),
	    json$10 = [{
	  tfOpName: "MatMul",
	  category: "matrices",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "transpose_a",
	    name: "transposeA",
	    type: "bool",
	    defaultValue: !1
	  }, {
	    tfName: "transpose_b",
	    name: "transposeB",
	    type: "bool",
	    defaultValue: !1
	  }, {
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "BatchMatMul",
	  category: "matrices",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "adj_x",
	    name: "transposeA",
	    type: "bool",
	    defaultValue: !1
	  }, {
	    tfName: "adj_y",
	    name: "transposeB",
	    type: "bool",
	    defaultValue: !1
	  }, {
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "BatchMatMulV2",
	  category: "matrices",
	  inputs: [{
	    start: 0,
	    name: "a",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "b",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "adj_x",
	    name: "transposeA",
	    type: "bool",
	    defaultValue: !1
	  }, {
	    tfName: "adj_y",
	    name: "transposeB",
	    type: "bool",
	    defaultValue: !1
	  }, {
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Transpose",
	  category: "matrices",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "perm",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "T",
	    name: "dtype",
	    type: "dtype",
	    notSupported: !0
	  }]
	}],
	    matrices = Object.freeze({
	  json: json$10
	}),
	    json$11 = [{
	  tfOpName: "FusedBatchNorm",
	  category: "normalization",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "scale",
	    type: "tensor"
	  }, {
	    start: 2,
	    name: "offset",
	    type: "tensor"
	  }, {
	    start: 3,
	    name: "mean",
	    type: "tensor"
	  }, {
	    start: 4,
	    name: "variance",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "epsilon",
	    name: "epsilon",
	    type: "number",
	    defaultValue: .001
	  }, {
	    tfName: "data_format",
	    name: "dataFormat",
	    type: "string",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "FusedBatchNormV2",
	  category: "normalization",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "scale",
	    type: "tensor"
	  }, {
	    start: 2,
	    name: "offset",
	    type: "tensor"
	  }, {
	    start: 3,
	    name: "mean",
	    type: "tensor"
	  }, {
	    start: 4,
	    name: "variance",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "epsilon",
	    name: "epsilon",
	    type: "number",
	    defaultValue: .001
	  }, {
	    tfName: "data_format",
	    name: "dataFormat",
	    type: "string",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "FusedBatchNormV3",
	  category: "normalization",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "scale",
	    type: "tensor"
	  }, {
	    start: 2,
	    name: "offset",
	    type: "tensor"
	  }, {
	    start: 3,
	    name: "mean",
	    type: "tensor"
	  }, {
	    start: 4,
	    name: "variance",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "epsilon",
	    name: "epsilon",
	    type: "number",
	    defaultValue: .001
	  }, {
	    tfName: "data_format",
	    name: "dataFormat",
	    type: "string",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "LRN",
	  category: "normalization",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "depth_radius",
	    name: "radius",
	    type: "number",
	    defaultValue: 5
	  }, {
	    tfName: "bias",
	    name: "bias",
	    type: "number",
	    defaultValue: 1
	  }, {
	    tfName: "alpha",
	    name: "alpha",
	    type: "number",
	    defaultValue: 1
	  }, {
	    tfName: "beta",
	    name: "beta",
	    type: "number",
	    defaultValue: .5
	  }]
	}, {
	  tfOpName: "Softmax",
	  category: "normalization",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }]
	}, {
	  tfOpName: "LogSoftmax",
	  category: "normalization",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }]
	}, {
	  tfOpName: "SparseToDense",
	  category: "normalization",
	  inputs: [{
	    start: 0,
	    name: "sparseIndices",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "outputShape",
	    type: "number[]"
	  }, {
	    start: 2,
	    name: "sparseValues",
	    type: "tensor"
	  }, {
	    start: 3,
	    name: "defaultValue",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "validate_indices",
	    name: "validateIndices",
	    type: "bool",
	    defaultValue: !0,
	    notSupported: !0
	  }]
	}],
	    normalization = Object.freeze({
	  json: json$11
	}),
	    json$12 = [{
	  tfOpName: "Max",
	  category: "reduction",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "axis",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "keep_dims",
	    name: "keepDims",
	    type: "bool"
	  }]
	}, {
	  tfOpName: "Mean",
	  category: "reduction",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "axis",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "keep_dims",
	    name: "keepDims",
	    type: "bool"
	  }]
	}, {
	  tfOpName: "Min",
	  category: "reduction",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "axis",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "keep_dims",
	    name: "keepDims",
	    type: "bool"
	  }]
	}, {
	  tfOpName: "Sum",
	  category: "reduction",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "axis",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "keep_dims",
	    name: "keepDims",
	    type: "bool"
	  }]
	}, {
	  tfOpName: "All",
	  category: "reduction",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "axis",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "keep_dims",
	    name: "keepDims",
	    type: "bool"
	  }]
	}, {
	  tfOpName: "Any",
	  category: "reduction",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "axis",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "keep_dims",
	    name: "keepDims",
	    type: "bool"
	  }]
	}, {
	  tfOpName: "ArgMax",
	  category: "reduction",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "axis",
	    type: "number"
	  }]
	}, {
	  tfOpName: "ArgMin",
	  category: "reduction",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "axis",
	    type: "number"
	  }]
	}, {
	  tfOpName: "Prod",
	  category: "reduction",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "axis",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "keep_dims",
	    name: "keepDims",
	    type: "bool"
	  }]
	}],
	    reduction = Object.freeze({
	  json: json$12
	}),
	    json$13 = [{
	  tfOpName: "ConcatV2",
	  category: "slice_join",
	  inputs: [{
	    start: 0,
	    end: -1,
	    name: "tensors",
	    type: "tensors"
	  }, {
	    start: -1,
	    name: "axis",
	    type: "number"
	  }]
	}, {
	  tfOpName: "Concat",
	  category: "slice_join",
	  inputs: [{
	    start: 1,
	    end: 0,
	    name: "tensors",
	    type: "tensors"
	  }, {
	    start: 0,
	    name: "axis",
	    type: "number"
	  }]
	}, {
	  tfOpName: "GatherV2",
	  category: "slice_join",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "indices",
	    type: "tensor"
	  }, {
	    start: 2,
	    name: "axis",
	    type: "number",
	    defaultValue: 0
	  }]
	}, {
	  tfOpName: "Gather",
	  category: "slice_join",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "indices",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "axis",
	    name: "axis",
	    type: "number",
	    defaultValue: 0
	  }, {
	    tfName: "validate_indices",
	    name: "validateIndices",
	    type: "bool",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Reverse",
	  category: "slice_join",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "dims",
	    type: "bool",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "ReverseV2",
	  category: "slice_join",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "axis",
	    type: "number[]"
	  }]
	}, {
	  tfOpName: "Slice",
	  category: "slice_join",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "begin",
	    type: "number[]"
	  }, {
	    start: 2,
	    name: "size",
	    type: "number[]"
	  }]
	}, {
	  tfOpName: "StridedSlice",
	  category: "slice_join",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "begin",
	    type: "number[]"
	  }, {
	    start: 2,
	    name: "end",
	    type: "number[]"
	  }, {
	    start: 3,
	    name: "strides",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "begin_mask",
	    name: "beginMask",
	    type: "number",
	    defaultValue: 0
	  }, {
	    tfName: "end_mask",
	    name: "endMask",
	    type: "number",
	    defaultValue: 0
	  }, {
	    tfName: "new_axis_mask",
	    name: "newAxisMask",
	    type: "number",
	    defaultValue: 0
	  }, {
	    tfName: "ellipsis_mask",
	    name: "ellipsisMask",
	    type: "number",
	    defaultValue: 0
	  }, {
	    tfName: "shrink_axis_mask",
	    name: "shrinkAxisMask",
	    type: "number",
	    defaultValue: 0
	  }]
	}, {
	  tfOpName: "Pack",
	  category: "slice_join",
	  inputs: [{
	    start: 0,
	    end: 0,
	    name: "tensors",
	    type: "tensors"
	  }],
	  attrs: [{
	    tfName: "axis",
	    name: "axis",
	    type: "number",
	    defaultValue: 0
	  }]
	}, {
	  tfOpName: "Unpack",
	  category: "slice_join",
	  inputs: [{
	    start: 0,
	    name: "tensor",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "axis",
	    name: "axis",
	    type: "number",
	    defaultValue: 0
	  }, {
	    tfName: "num",
	    name: "num",
	    type: "number",
	    defaultValue: 0,
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "Tile",
	  category: "slice_join",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "reps",
	    type: "number[]"
	  }]
	}, {
	  tfOpName: "Split",
	  category: "slice_join",
	  inputs: [{
	    start: 0,
	    name: "axis",
	    type: "number",
	    defaultValue: 0
	  }, {
	    start: 1,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "num_split",
	    name: "numOrSizeSplits",
	    type: "number",
	    defaultValue: 1
	  }]
	}, {
	  tfOpName: "SplitV",
	  category: "slice_join",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "numOrSizeSplits",
	    type: "number[]"
	  }, {
	    start: 2,
	    name: "axis",
	    type: "number",
	    defaultValue: 0
	  }]
	}, {
	  tfOpName: "ScatterNd",
	  category: "slice_join",
	  inputs: [{
	    start: 0,
	    name: "indices",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "values",
	    type: "tensor"
	  }, {
	    start: 2,
	    name: "shape",
	    type: "number[]"
	  }]
	}, {
	  tfOpName: "GatherNd",
	  category: "slice_join",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "indices",
	    type: "tensor"
	  }]
	}, {
	  tfOpName: "SparseToDense",
	  category: "slice_join",
	  inputs: [{
	    start: 0,
	    name: "sparseIndices",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "outputShape",
	    type: "number[]"
	  }, {
	    start: 2,
	    name: "sparseValues",
	    type: "tensor"
	  }, {
	    start: 3,
	    name: "defaultValue",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "validate_indices",
	    name: "validateIndices",
	    type: "bool",
	    defaultValue: !1,
	    notSupported: !0
	  }]
	}],
	    sliceJoin = Object.freeze({
	  json: json$13
	}),
	    json$14 = [{
	  tfOpName: "FFT",
	  category: "spectral",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }]
	}, {
	  tfOpName: "IFFT",
	  category: "spectral",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }]
	}, {
	  tfOpName: "RFFT",
	  category: "spectral",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "fft_length",
	    type: "number",
	    notSupported: !0
	  }]
	}, {
	  tfOpName: "IRFFT",
	  category: "spectral",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "fft_length",
	    type: "number",
	    notSupported: !0
	  }]
	}],
	    spectral = Object.freeze({
	  json: json$14
	}),
	    json$15 = [{
	  tfOpName: "Cast",
	  category: "transformation",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "SrcT",
	    name: "sdtype",
	    type: "dtype",
	    notSupported: !0
	  }, {
	    tfName: "DstT",
	    name: "dtype",
	    type: "dtype"
	  }]
	}, {
	  tfOpName: "ExpandDims",
	  category: "transformation",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "axis",
	    type: "number"
	  }]
	}, {
	  tfOpName: "Pad",
	  category: "transformation",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "padding",
	    type: "number[]"
	  }],
	  attrs: [{
	    tfName: "constant_value",
	    name: "constantValue",
	    type: "number",
	    defaultValue: 0
	  }]
	}, {
	  tfOpName: "PadV2",
	  category: "transformation",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "padding",
	    type: "number[]"
	  }, {
	    start: 2,
	    name: "constantValue",
	    type: "number",
	    defaultValue: 0
	  }]
	}, {
	  tfOpName: "Reshape",
	  category: "transformation",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "shape",
	    type: "number[]"
	  }]
	}, {
	  tfOpName: "Squeeze",
	  category: "transformation",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "axis",
	    tfDeprecatedName: "squeeze_dims",
	    name: "axis",
	    type: "number[]"
	  }]
	}, {
	  tfOpName: "SpaceToBatchND",
	  category: "transformation",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "blockShape",
	    type: "number[]"
	  }, {
	    start: 2,
	    name: "paddings",
	    type: "number[]"
	  }]
	}, {
	  tfOpName: "BatchToSpaceND",
	  category: "transformation",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }, {
	    start: 1,
	    name: "blockShape",
	    type: "number[]"
	  }, {
	    start: 2,
	    name: "crops",
	    type: "number[]"
	  }]
	}, {
	  tfOpName: "DepthToSpace",
	  category: "transformation",
	  inputs: [{
	    start: 0,
	    name: "x",
	    type: "tensor"
	  }],
	  attrs: [{
	    tfName: "block_size",
	    name: "blockSize",
	    type: "number"
	  }, {
	    tfName: "data_format",
	    name: "dataFormat",
	    type: "string"
	  }]
	}],
	    transformation = Object.freeze({
	  json: json$15
	}),
	    OperationMapper = function () {
	  function e() {
	    var e = [arithmetic, basicMath, control, convolution, creation, dynamic, evaluation, logical, image$1, graph, matrices, normalization, reduction, sliceJoin, spectral, transformation],
	        t = [].concat.apply([], e.map(function (e) {
	      return e.json;
	    }));
	    this.opMappers = t.reduce(function (e, t) {
	      return e[t.tfOpName] = t, e;
	    }, {});
	  }

	  return Object.defineProperty(e, "Instance", {
	    get: function get() {
	      return this._instance || (this._instance = new this());
	    },
	    enumerable: !0,
	    configurable: !0
	  }), e.prototype.transformGraph = function (e) {
	    var t = this,
	        a = [],
	        r = [],
	        n = e.node.reduce(function (e, n) {
	      return e[n.name] = t.mapNode(n), "Placeholder" === n.op && a.push(e[n.name]), "Const" === n.op && r.push(e[n.name]), e;
	    }, {}),
	        s = [],
	        o = [],
	        p = Object.keys(n);
	    return p.forEach(function (e) {
	      var t = n[e];
	      t.inputNames.forEach(function (e) {
	        var a = getNodeNameAndIndex(e)[0];
	        t.inputs.push(n[a]), n[a].children.push(t);
	      }), 0 === t.inputs.length && s.push(t);
	    }), p.forEach(function (e) {
	      var t = n[e];
	      0 === t.children.length && o.push(t);
	    }), {
	      nodes: n,
	      inputs: s,
	      outputs: o,
	      weights: r,
	      placeholders: a
	    };
	  }, e.prototype.mapNode = function (e) {
	    var t = getRegisteredOp(e.op) || this.opMappers[e.op] || {};
	    null == e.attr && (e.attr = {});
	    var a = {
	      name: e.name,
	      op: e.op,
	      category: t.category,
	      inputNames: (e.input || []).map(function (e) {
	        return e.startsWith("^") ? e.substr(1) : e;
	      }),
	      inputs: [],
	      children: [],
	      inputParams: {},
	      attrParams: {},
	      rawAttrs: e.attr
	    };
	    return null != t.inputs && (a.inputParams = t.inputs.reduce(function (e, t) {
	      return e[t.name] = {
	        type: t.type,
	        inputIndexStart: t.start,
	        inputIndexEnd: t.end
	      }, e;
	    }, {})), null != t.attrs && (a.attrParams = t.attrs.reduce(function (t, a) {
	      var r = a.type,
	          n = void 0;

	      switch (a.type) {
	        case "string":
	          void 0 === (n = getStringParam(e.attr, a.tfName, a.defaultValue)) && a.tfDeprecatedName && (n = getStringParam(e.attr, a.tfDeprecatedName, a.defaultValue));
	          break;

	        case "string[]":
	          void 0 === (n = getStringArrayParam(e.attr, a.tfName, a.defaultValue)) && a.tfDeprecatedName && (n = getStringArrayParam(e.attr, a.tfDeprecatedName, a.defaultValue));
	          break;

	        case "number":
	          void 0 === (n = getNumberParam(e.attr, a.tfName, a.defaultValue || 0)) && a.tfDeprecatedName && (n = getNumberParam(e.attr, a.tfDeprecatedName, a.defaultValue));
	          break;

	        case "number[]":
	          void 0 === (n = getNumericArrayParam(e.attr, a.tfName, a.defaultValue)) && a.tfDeprecatedName && (n = getNumericArrayParam(e.attr, a.tfDeprecatedName, a.defaultValue));
	          break;

	        case "bool":
	          void 0 === (n = getBoolParam(e.attr, a.tfName, a.defaultValue)) && a.tfDeprecatedName && (n = getBoolParam(e.attr, a.tfDeprecatedName, a.defaultValue));
	          break;

	        case "bool[]":
	          void 0 === (n = getBoolArrayParam(e.attr, a.tfName, a.defaultValue)) && a.tfDeprecatedName && (n = getBoolArrayParam(e.attr, a.tfDeprecatedName, a.defaultValue));
	          break;

	        case "shape":
	          void 0 === (n = getTensorShapeParam(e.attr, a.tfName, a.defaultValue)) && a.tfDeprecatedName && (n = getTensorShapeParam(e.attr, a.tfDeprecatedName, a.defaultValue));
	          break;

	        case "shape[]":
	          void 0 === (n = getTensorShapeArrayParam(e.attr, a.tfName, a.defaultValue)) && a.tfDeprecatedName && (n = getTensorShapeArrayParam(e.attr, a.tfDeprecatedName, a.defaultValue));
	          break;

	        case "dtype":
	          void 0 === (n = getDtypeParam(e.attr, a.tfName, a.defaultValue)) && a.tfDeprecatedName && (n = getDtypeParam(e.attr, a.tfDeprecatedName, a.defaultValue));
	          break;

	        case "dtype[]":
	          void 0 === (n = getDtypeArrayParam(e.attr, a.tfName, a.defaultValue)) && a.tfDeprecatedName && (n = getDtypeArrayParam(e.attr, a.tfDeprecatedName, a.defaultValue));
	          break;

	        case "tensor":
	        case "tensors":
	          break;

	        default:
	          throw new Error("Unsupported param type: " + a.type + " for op: " + e.op);
	      }

	      return t[a.name] = {
	        value: n,
	        type: r
	      }, t;
	    }, {})), a;
	  }, e;
	}();

	function decodeBase64(e) {
	  var t = i.global;
	  if (void 0 !== t.atob) return t.atob(e);
	  if ("undefined" != typeof Buffer) return new Buffer(e, "base64").toString();
	  throw new Error("Unable to decode base64 in this environment. Missing built-in atob() or Buffer()");
	}

	function parseStringParam(e, t) {
	  var a = Array.isArray(e) ? String.fromCharCode.apply(null, e) : decodeBase64(e);
	  return t ? a : a.toLowerCase();
	}

	function getStringParam(e, t, a, r) {
	  void 0 === r && (r = !1);
	  var n = e[t];
	  return null != n ? parseStringParam(n.s, r) : a;
	}

	function getBoolParam(e, t, a) {
	  var r = e[t];
	  return r ? r.b : a;
	}

	function getNumberParam(e, t, a) {
	  var r = e[t] || {},
	      n = null != r.i ? r.i : null != r.f ? r.f : a;
	  return "number" == typeof n ? n : parseInt(n, 10);
	}

	function parseDtypeParam(e) {
	  switch ("string" == typeof e && (e = DataType[e]), e) {
	    case DataType.DT_FLOAT:
	      return "float32";

	    case DataType.DT_INT32:
	      return "int32";

	    case DataType.DT_BOOL:
	      return "bool";

	    case DataType.DT_DOUBLE:
	      return "float32";

	    case DataType.DT_STRING:
	      return "string";

	    default:
	      return null;
	  }
	}

	function getDtypeParam(e, t, a) {
	  var r = e[t];
	  return r && r.type ? parseDtypeParam(r.type) : a;
	}

	function getDtypeArrayParam(e, t, a) {
	  var r = e[t];
	  return r && r.list && r.list.type ? r.list.type.map(function (e) {
	    return parseDtypeParam(e);
	  }) : a;
	}

	function parseTensorShapeParam(e) {
	  if (!e.unknownRank) return null != e.dim ? e.dim.map(function (e) {
	    return "number" == typeof e.size ? e.size : parseInt(e.size, 10);
	  }) : [];
	}

	function getTensorShapeParam(e, t, a) {
	  var r = e[t];
	  return r && r.shape ? parseTensorShapeParam(r.shape) : a;
	}

	function getNumericArrayParam(e, t, a) {
	  var r = e[t];
	  return r ? (r.list.f && r.list.f.length ? r.list.f : r.list.i).map(function (e) {
	    return "number" == typeof e ? e : parseInt(e, 10);
	  }) : a;
	}

	function getStringArrayParam(e, t, a, r) {
	  void 0 === r && (r = !1);
	  var n = e[t];
	  return n && n.list && n.list.s ? n.list.s.map(function (e) {
	    return parseStringParam(e, r);
	  }) : a;
	}

	function getTensorShapeArrayParam(e, t, a) {
	  var r = e[t];
	  return r && r.list && r.list.shape ? r.list.shape.map(function (e) {
	    return parseTensorShapeParam(e);
	  }) : a;
	}

	function getBoolArrayParam(e, t, a) {
	  var r = e[t];
	  return r && r.list && r.list.b ? r.list.b : a;
	}

	var NodeValueImpl = function () {
	  function e(e, t, a) {
	    var r = this;
	    this.node = e, this.tensorMap = t, this.context = a, this.inputs = [], this.attrs = {}, this.inputs = e.inputNames.map(function (e) {
	      return r.getInput(e);
	    }), null != e.rawAttrs && (this.attrs = Object.keys(e.rawAttrs).reduce(function (e, t) {
	      return e[t] = r.getAttr(t), e;
	    }, {}));
	  }

	  return e.prototype.getInput = function (e) {
	    return getTensor(e, this.tensorMap, this.context);
	  }, e.prototype.getAttr = function (e, t) {
	    var a = this.node.rawAttrs[e];
	    if (null != a.tensor) return getTensor(e, this.tensorMap, this.context);
	    if (null != a.i || null != a.f) return getNumberParam(this.node.rawAttrs, e, t);
	    if (null != a.s) return getStringParam(this.node.rawAttrs, e, t);
	    if (null != a.b) return getBoolParam(this.node.rawAttrs, e, t);
	    if (null != a.shape) return getTensorShapeParam(this.node.rawAttrs, e, t);
	    if (null != a.type) return getDtypeParam(this.node.rawAttrs, e, t);

	    if (null != a.list) {
	      if (null != a.list.i || null != a.list.f) return getNumericArrayParam(this.node.rawAttrs, e, t);
	      if (null != a.list.s) return getStringArrayParam(this.node.rawAttrs, e, t);
	      if (null != a.list.shape) return getTensorShapeArrayParam(this.node.rawAttrs, e, t);
	      if (null != a.list.b) return getBoolArrayParam(this.node.rawAttrs, e, t);
	      if (null != a.list.type) return getDtypeArrayParam(this.node.rawAttrs, e, t);
	    }

	    return t;
	  }, e;
	}(),
	    executeOp = function executeOp(e, t, a) {
	  switch (e.op) {
	    case "BiasAdd":
	    case "AddV2":
	    case "Add":
	      return [Zu(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    case "AddN":
	      return [tl(getParamValue("tensors", e, t, a))];

	    case "FloorMod":
	    case "Mod":
	      return [cl(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    case "Mul":
	      return [fl(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    case "RealDiv":
	    case "Div":
	      return [rl(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    case "FloorDiv":
	      return [al(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    case "Sub":
	      return [yl(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    case "Minimum":
	      return [ul(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    case "Maximum":
	      return [il(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    case "Pow":
	      return [dl(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    case "SquaredDifference":
	      return [ml(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    default:
	      throw TypeError("Node type " + e.op + " is not implemented");
	  }
	},
	    executeOp$1 = function executeOp$1(e, t, a) {
	  switch (e.op) {
	    case "Abs":
	    case "ComplexAbs":
	      return [as(getParamValue("x", e, t, a))];

	    case "Acos":
	      return [is(getParamValue("x", e, t, a))];

	    case "Acosh":
	      return [ss(getParamValue("x", e, t, a))];

	    case "Asin":
	      return [us(getParamValue("x", e, t, a))];

	    case "Asinh":
	      return [ls(getParamValue("x", e, t, a))];

	    case "Atan":
	      return [cs(getParamValue("x", e, t, a))];

	    case "Atan2":
	      return [nl(getParamValue("x", e, t, a), getParamValue("y", e, t, a))];

	    case "Atanh":
	      return [hs(getParamValue("x", e, t, a))];

	    case "Ceil":
	      return [fs(getParamValue("x", e, t, a))];

	    case "Complex":
	      return [gn(getParamValue("real", e, t, a), getParamValue("imag", e, t, a))];

	    case "Cos":
	      return [ds(getParamValue("x", e, t, a))];

	    case "Cosh":
	      return [vs(getParamValue("x", e, t, a))];

	    case "Elu":
	      return [Sl(getParamValue("x", e, t, a))];

	    case "Erf":
	      return [ms(getParamValue("x", e, t, a))];

	    case "Exp":
	      return [gs(getParamValue("x", e, t, a))];

	    case "Expm1":
	      return [ys(getParamValue("x", e, t, a))];

	    case "Floor":
	      return [xs(getParamValue("x", e, t, a))];

	    case "Log":
	      return [bs(getParamValue("x", e, t, a))];

	    case "Log1p":
	      return [ws(getParamValue("x", e, t, a))];

	    case "Neg":
	      return [Es(getParamValue("x", e, t, a))];

	    case "Reciprocal":
	      return [Rs(getParamValue("x", e, t, a))];

	    case "Relu":
	      return [Al(getParamValue("x", e, t, a))];

	    case "Round":
	      return [Is(getParamValue("x", e, t, a))];

	    case "Selu":
	      return [Tl(getParamValue("x", e, t, a))];

	    case "Sigmoid":
	      return [Ns(getParamValue("x", e, t, a))];

	    case "Sin":
	      return [_s(getParamValue("x", e, t, a))];

	    case "Sign":
	      return [ks(getParamValue("x", e, t, a))];

	    case "Sinh":
	      return [Os(getParamValue("x", e, t, a))];

	    case "Softplus":
	      return [Fs(getParamValue("x", e, t, a))];

	    case "Sqrt":
	      return [Ms(getParamValue("x", e, t, a))];

	    case "Square":
	      return [Bs(getParamValue("x", e, t, a))];

	    case "Tanh":
	      return [Ws(getParamValue("x", e, t, a))];

	    case "Tan":
	      return [Ls(getParamValue("x", e, t, a))];

	    case "Relu6":
	    case "ClipByValue":
	      return [ps(getParamValue("x", e, t, a), getParamValue("clipValueMin", e, t, a), getParamValue("clipValueMax", e, t, a))];

	    case "Rsqrt":
	      return [Ss(getTensor(e.inputNames[0], t, a))];

	    case "Prod":
	      return [Uu(getParamValue("x", e, t, a), getParamValue("axes", e, t, a))];

	    case "LeakyRelu":
	      return [Nl(getParamValue("x", e, t, a), getParamValue("alpha", e, t, a))];

	    default:
	      throw TypeError("Node type " + e.op + " is not implemented");
	  }
	},
	    TensorArray = function () {
	  function e(t, a, r, n, s, o, p) {
	    this.name = t, this.dtype = a, this.maxSize = r, this.elementShape = n, this.identicalElementShapes = s, this.dynamicSize = o, this.clearAfterRead = p, this.tensors = [], this.closed_ = !1, this.id = e.nextId++;
	  }

	  return Object.defineProperty(e.prototype, "closed", {
	    get: function get() {
	      return this.closed_;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), e.prototype.clearAndClose = function () {
	    this.tensors.forEach(function (e) {
	      return e.tensor.dispose();
	    }), this.tensors = [], this.closed_ = !0;
	  }, e.prototype.size = function () {
	    return this.tensors.length;
	  }, e.prototype.read = function (e) {
	    if (this.closed_) throw new Error("TensorArray " + this.name + " has already been closed.");
	    if (e < 0 || e >= this.tensors.length) throw new Error("Tried to read from index " + e + ", but array size is: " + this.tensors.length);
	    var t = this.tensors[e];
	    if (t.cleared) throw new Error("TensorArray " + this.name + ": Could not read index " + e + " twice because it was cleared after a previous read (perhaps try setting clear_after_read = false?).");
	    return this.clearAfterRead && (t.cleared = !0), t.read = !0, t.tensor;
	  }, e.prototype.readMany = function (e) {
	    var t = this;
	    return e.map(function (e) {
	      return t.read(e);
	    });
	  }, e.prototype.write = function (e, t) {
	    if (this.closed_) throw new Error("TensorArray " + this.name + " has already been closed.");
	    if (e < 0 || !this.dynamicSize && e >= this.maxSize) throw new Error("Tried to write to index " + e + ", but array is not resizeable and size is: " + this.maxSize);
	    var a = this.tensors[e] || {};
	    if (t.dtype !== this.dtype) throw new Error("TensorArray " + this.name + ": Could not write to TensorArray index " + e + ",\n          because the value dtype is " + t.dtype + ", but TensorArray dtype is " + this.dtype + ".");
	    if (0 !== this.size() || null != this.elementShape && 0 !== this.elementShape.length || (this.elementShape = t.shape), this.assertShapesMatchAllowUndefinedSize(this.elementShape, t.shape, "TensorArray " + this.name + ": Could not write to TensorArray index " + e + "."), a && a.read) throw new Error("TensorArray " + this.name + ": Could not write to TensorArray index " + e + ", because it has already been read.");
	    if (a && a.written) throw new Error("TensorArray " + this.name + ": Could not write to TensorArray index " + e + ", because it has already been written.");
	    a.tensor = t, a.written = !0, this.tensors[e] = a;
	  }, e.prototype.writeMany = function (e, t) {
	    var a = this;
	    if (e.length !== t.length) throw new Error("TensorArray " + this.name + ": could not write multiple tensors,because the index size: " + e.length + " is not the same as tensors size: " + t.length + ".");
	    e.forEach(function (e, r) {
	      return a.write(e, t[r]);
	    });
	  }, e.prototype.gather = function (e, t) {
	    if (t && t !== this.dtype) throw new Error("TensorArray dtype is " + this.dtype + " but gather requested dtype " + t);

	    if (!e) {
	      e = [];

	      for (var a = 0; a < this.size(); a++) {
	        e.push(a);
	      }
	    }

	    if (0 === e.length) return bn([], [0].concat(this.elementShape));
	    var r = this.readMany(e);
	    return this.assertShapesMatchAllowUndefinedSize(this.elementShape, r[0].shape, "TensorArray shape mismatch: "), wr(r, 0);
	  }, e.prototype.concat = function (e) {
	    if (e && e !== this.dtype) throw new Error("TensorArray dtype is " + this.dtype + " but concat requested dtype " + e);
	    if (0 === this.size()) return bn([], [0].concat(this.elementShape));

	    for (var t = [], a = 0; a < this.size(); a++) {
	      t.push(a);
	    }

	    var r = this.readMany(t);
	    return this.assertShapesMatchAllowUndefinedSize(this.elementShape, r[0].shape, "TensorArray shape mismatch: tensor array shape (" + this.elementShape + ") vs first tensor shape (" + r[0].shape + ")"), Bn(r, 0);
	  }, e.prototype.scatter = function (e, t) {
	    if (t.dtype !== this.dtype) throw new Error("TensorArray dtype is " + this.dtype + " but tensor has dtype " + t.dtype);
	    if (e.length !== t.shape[0]) throw new Error("Expected len(indices) == tensor.shape[0], but saw: " + e.length + " vs. " + t.shape[0]);
	    var a = Math.max.apply(Math, e);
	    if (!this.dynamicSize && a >= this.maxSize) throw new Error("Max index must be < array size (" + a + "  vs. " + this.maxSize + ")");
	    this.writeMany(e, Rr(t, 0));
	  }, e.prototype.split = function (e, t) {
	    var a = this;
	    if (t.dtype !== this.dtype) throw new Error("TensorArray dtype is " + this.dtype + " but tensor has dtype " + t.dtype);
	    var r = 0,
	        n = e.map(function (e) {
	      return r += e;
	    });
	    if (r !== t.shape[0]) throw new Error("Expected sum of lengths to be equal to\n          tensor.shape[0], but sum of lengths is\n        " + r + ", and tensor's shape is: " + t.shape);
	    if (!this.dynamicSize && e.length !== this.maxSize) throw new Error("TensorArray's size is not equal to the size of lengths (" + this.maxSize + " vs. " + e.length + "), and the TensorArray is not marked as dynamically resizeable");
	    var s = 0 === r ? 0 : t.size / r,
	        o = [];
	    ze(function () {
	      t = t.reshape([1, r, s]);

	      for (var p = 0; p < e.length; ++p) {
	        var u = [0, 0 === p ? 0 : n[p - 1], 0],
	            i = [1, e[p], s];
	        o[p] = Ru(t, u, i).reshape(a.elementShape);
	      }

	      return o;
	    });

	    for (var p = [], u = 0; u < e.length; u++) {
	      p[u] = u;
	    }

	    this.writeMany(p, o);
	  }, e.prototype.assertShapesMatchAllowUndefinedSize = function (e, t, a) {
	    void 0 === a && (a = ""), Q.assert(this.shapesEqualAllowUndefinedSize(e, t), function () {
	      return a + " Shapes " + e + " and " + t + " must match";
	    });
	  }, e.prototype.shapesEqualAllowUndefinedSize = function (e, t) {
	    if (e.length !== t.length) return !1;

	    for (var a = 0; a < e.length; a++) {
	      if (-1 !== e[a] && -1 !== t[a] && e[a] !== t[a]) return !1;
	    }

	    return !0;
	  }, e.nextId = 0, e;
	}();

	function executeOp$2(e, t, a) {
	  return __awaiter$1(this, void 0, void 0, function () {
	    var r, n, s, o, p, u, i, m, c, l, d, y, f, h, g, N, x, b, V, P, T, O, S, v, _, w, A, D, E, I, C, M, k, z, j;

	    return __generator$1(this, function (F) {
	      switch (F.label) {
	        case 0:
	          switch (e.op) {
	            case "LoopCond":
	              return [3, 1];

	            case "Switch":
	              return [3, 2];

	            case "Merge":
	              return [3, 4];

	            case "Enter":
	              return [3, 5];

	            case "Exit":
	              return [3, 6];

	            case "NextIteration":
	              return [3, 7];

	            case "TensorArrayV3":
	              return [3, 8];

	            case "TensorArrayWriteV3":
	              return [3, 9];

	            case "TensorArrayReadV3":
	              return [3, 10];

	            case "TensorArrayGatherV3":
	              return [3, 11];

	            case "TensorArrayScatterV3":
	              return [3, 12];

	            case "TensorArrayConcatV3":
	              return [3, 13];

	            case "TensorArraySplitV3":
	              return [3, 14];

	            case "TensorArraySizeV3":
	              return [3, 15];

	            case "TensorArrayCloseV3":
	              return [3, 16];
	          }

	          return [3, 17];

	        case 1:
	          return [2, [getParamValue("pred", e, t, a).clone()]];

	        case 2:
	          return r = getParamValue("pred", e, t, a), n = getParamValue("data", e, t, a), [4, r.data()];

	        case 3:
	          return [2, F.sent()[0] ? [void 0, n.clone()] : [n.clone(), void 0]];

	        case 4:
	          return [2, (s = e.inputNames.find(function (e) {
	            return void 0 !== getTensor(e, t, a);
	          })) ? [getTensor(s, t, a).clone()] : void 0];

	        case 5:
	          return o = getParamValue("frameName", e, t, a), p = getParamValue("tensor", e, t, a), a.enterFrame(o), [2, [p.clone()]];

	        case 6:
	          return u = getParamValue("tensor", e, t, a), a.exitFrame(), [2, [u.clone()]];

	        case 7:
	          return i = getParamValue("tensor", e, t, a), a.nextIteration(), [2, [i.clone()]];

	        case 8:
	          return m = getParamValue("size", e, t, a), c = getParamValue("dtype", e, t, a), l = getParamValue("elementShape", e, t, a), d = getParamValue("dynamicSize", e, t, a), y = getParamValue("clearAfterRead", e, t, a), f = getParamValue("identicalElementShapes", e, t, a), h = getParamValue("name", e, t, a), g = new TensorArray(h, c, m, l, f, d, y), a.addTensorArray(g), [2, [Cn(g.id), Cn(1)]];

	        case 9:
	          return N = getParamValue("tensorArrayId", e, t, a), x = getParamValue("index", e, t, a), b = getParamValue("tensor", e, t, a), a.getTensorArray(N).write(x, b), [2, [Cn(1)]];

	        case 10:
	          return V = getParamValue("tensorArrayId", e, t, a), P = getParamValue("index", e, t, a), [2, [a.getTensorArray(V).read(P)]];

	        case 11:
	          return T = getParamValue("tensorArrayId", e, t, a), O = getParamValue("indices", e, t, a), S = getParamValue("dtype", e, t, a), [2, [a.getTensorArray(T).gather(O, S)]];

	        case 12:
	          return v = getParamValue("tensorArrayId", e, t, a), _ = getParamValue("indices", e, t, a), w = getParamValue("tensor", e, t, a), a.getTensorArray(v).scatter(_, w), [2, [Cn(1)]];

	        case 13:
	          return A = getParamValue("tensorArrayId", e, t, a), D = a.getTensorArray(A), E = getParamValue("dtype", e, t, a), [2, [D.concat(E)]];

	        case 14:
	          return I = getParamValue("tensorArrayId", e, t, a), C = getParamValue("tensor", e, t, a), M = getParamValue("lengths", e, t, a), a.getTensorArray(I).split(M, C), [2, [Cn(1)]];

	        case 15:
	          return k = getParamValue("tensorArrayId", e, t, a), z = a.getTensorArray(k), [2, [Cn(z.size(), "int32")]];

	        case 16:
	          return j = getParamValue("tensorArrayId", e, t, a), a.getTensorArray(j).clearAndClose(), [2, []];

	        case 17:
	          throw TypeError("Node type " + e.op + " is not implemented");
	      }
	    });
	  });
	}

	var executeOp$3 = function executeOp$3(e, t, a) {
	  switch (e.op) {
	    case "Conv1D":
	      var r = getParamValue("stride", e, t, a),
	          n = getParamValue("pad", e, t, a),
	          s = getParamValue("dataFormat", e, t, a).toUpperCase(),
	          o = getParamValue("dilation", e, t, a);
	      return [ru(getParamValue("x", e, t, a), getParamValue("filter", e, t, a), r, n, s, o)];

	    case "Conv2D":
	      r = getParamValue("strides", e, t, a), n = getParamValue("pad", e, t, a), s = getParamValue("dataFormat", e, t, a).toUpperCase();
	      var p = getParamValue("dilations", e, t, a);
	      return [ou(getParamValue("x", e, t, a), getParamValue("filter", e, t, a), [r[1], r[2]], n, s, [p[1], p[2]])];

	    case "Conv2DBackpropInput":
	    case "Conv2dTranspose":
	      var u = getParamValue("outputShape", e, t, a);
	      r = getParamValue("strides", e, t, a), n = getParamValue("pad", e, t, a);
	      return [cu(getParamValue("x", e, t, a), getParamValue("filter", e, t, a), u, [r[1], r[2]], n)];

	    case "DepthwiseConv2dNative":
	    case "DepthwiseConv2d":
	      r = getParamValue("strides", e, t, a), n = getParamValue("pad", e, t, a), p = getParamValue("dilations", e, t, a), s = getParamValue("dataFormat", e, t, a).toUpperCase();
	      return [uu(getParamValue("input", e, t, a), getParamValue("filter", e, t, a), [r[1], r[2]], n, s, [p[1], p[2]])];

	    case "AvgPool":
	      r = getParamValue("strides", e, t, a), n = getParamValue("pad", e, t, a);
	      var i = getParamValue("kernelSize", e, t, a);
	      return [Cu(getParamValue("x", e, t, a), [i[1], i[2]], [r[1], r[2]], n)];

	    case "MaxPool":
	      r = getParamValue("strides", e, t, a), n = getParamValue("pad", e, t, a), i = getParamValue("kernelSize", e, t, a);
	      return [wu(getParamValue("x", e, t, a), [i[1], i[2]], [r[1], r[2]], n)];

	    default:
	      throw TypeError("Node type " + e.op + " is not implemented");
	  }
	},
	    executeOp$4 = function executeOp$4(e, t, a) {
	  switch (e.op) {
	    case "Fill":
	      var r = getParamValue("shape", e, t, a),
	          n = getParamValue("dtype", e, t, a),
	          s = getParamValue("value", e, t, a);
	      return [Dn(r, s, n)];

	    case "LinSpace":
	      var o = getParamValue("start", e, t, a),
	          p = getParamValue("stop", e, t, a),
	          u = getParamValue("num", e, t, a);
	      return [_n(o, p, u)];

	    case "OneHot":
	      var i = getParamValue("indices", e, t, a),
	          m = getParamValue("depth", e, t, a),
	          c = getParamValue("onValue", e, t, a),
	          l = getParamValue("offValue", e, t, a);
	      return [lr(i, m, c, l)];

	    case "Ones":
	      return [An(getParamValue("shape", e, t, a), getParamValue("dtype", e, t, a))];

	    case "OnesLike":
	      return [Fn(getParamValue("x", e, t, a))];

	    case "RandomUniform":
	      return [gr(getParamValue("shape", e, t, a), getParamValue("minval", e, t, a), getParamValue("maxval", e, t, a), getParamValue("dtype", e, t, a))];

	    case "Range":
	      o = getParamValue("start", e, t, a);
	      var d = getParamValue("stop", e, t, a),
	          y = getParamValue("step", e, t, a);
	      return [On(o, d, y, getParamValue("dtype", e, t, a))];

	    case "TruncatedNormal":
	      r = getParamValue("shape", e, t, a);
	      var f = getParamValue("mean", e, t, a),
	          h = getParamValue("stdDev", e, t, a),
	          g = getParamValue("seed", e, t, a);
	      return [Er(r, f, h, getParamValue("dtype", e, t, a), g)];

	    case "Zeros":
	      return [Tn(getParamValue("shape", e, t, a), getParamValue("dtype", e, t, a))];

	    case "ZerosLike":
	      return [Mn(getParamValue("x", e, t, a))];

	    default:
	      throw TypeError("Node type " + e.op + " is not implemented");
	  }
	};

	function executeOp$5(e, t, a) {
	  return __awaiter$1(this, void 0, void 0, function () {
	    var r, n, s, o, p;
	    return __generator$1(this, function (u) {
	      switch (u.label) {
	        case 0:
	          switch (e.op) {
	            case "NonMaxSuppressionV3":
	            case "NonMaxSuppressionV2":
	              return [3, 1];

	            case "Where":
	              return [3, 3];

	            case "ListDiff":
	              return [3, 5];
	          }

	          return [3, 7];

	        case 1:
	          return r = getParamValue("boxes", e, t, a), n = getParamValue("scores", e, t, a), s = getParamValue("maxOutputSize", e, t, a), o = getParamValue("iouThreshold", e, t, a), p = getParamValue("scoreThreshold", e, t, a), [4, Rc.nonMaxSuppressionAsync(r, n, s, o, p)];

	        case 2:
	          return [2, [u.sent()]];

	        case 3:
	          return [4, Il(getParamValue("condition", e, t, a))];

	        case 4:
	          return [2, [u.sent()]];

	        case 5:
	          return [4, Ir(getParamValue("x", e, t, a), getParamValue("y", e, t, a))];

	        case 6:
	          return [2, u.sent()];

	        case 7:
	          throw TypeError("Node type " + e.op + " is not implemented");
	      }
	    });
	  });
	}

	var executeOp$6 = function executeOp$6(e, t, a) {
	  switch (e.op) {
	    case "TopKV2":
	      var r = getParamValue("x", e, t, a),
	          n = getParamValue("k", e, t, a),
	          s = getParamValue("sorted", e, t, a),
	          o = Vl(r, n, s);
	      return [o.values, o.indices];

	    default:
	      throw TypeError("Node type " + e.op + " is not implemented");
	  }
	},
	    executeOp$7 = function executeOp$7(e, t, a) {
	  switch (e.op) {
	    case "Const":
	      return t[e.name];

	    case "PlaceholderWithDefault":
	      var r = getParamValue("default", e, t, a);
	      return [getTensor(e.name, t, a) || r];

	    case "Placeholder":
	      return [getTensor(e.name, t, a)];

	    case "Identity":
	    case "StopGradient":
	    case "FakeQuantWithMinMaxVars":
	      return [getParamValue("x", e, t, a).clone()];

	    case "IdentityN":
	      return getParamValue("x", e, t, a).map(function (e) {
	        return e.clone();
	      });

	    case "Snapshot":
	      return [getParamValue("x", e, t, a).clone()];

	    case "Shape":
	      return [En(getParamValue("x", e, t, a).shape, "int32")];

	    case "ShapeN":
	      return getParamValue("x", e, t, a).map(function (e) {
	        return En(e.shape);
	      });

	    case "Size":
	      return [Cn(getParamValue("x", e, t, a).size, "int32")];

	    case "Rank":
	      return [Cn(getParamValue("x", e, t, a).rank, "int32")];

	    case "NoOp":
	      return [];

	    case "Print":
	      var n = getParamValue("x", e, t, a),
	          s = getParamValue("data", e, t, a),
	          o = getParamValue("message", e, t, a),
	          p = getParamValue("summarize", e, t, a);
	      console.warn("The graph has a tf.print() operation,usually used for debugging, which slows down performance."), console.log(o);

	      for (var u = 0; u < s.length; u++) {
	        console.log(Array.prototype.slice.call(s[u].dataSync()).slice(0, p));
	      }

	      return [n];

	    default:
	      throw TypeError("Node type " + e.op + " is not implemented");
	  }
	},
	    executeOp$8 = function executeOp$8(e, t, a) {
	  switch (e.op) {
	    case "ResizeBilinear":
	      var r = getParamValue("images", e, t, a),
	          n = getParamValue("size", e, t, a),
	          s = getParamValue("alignCorners", e, t, a);
	      return [Rc.resizeBilinear(r, [n[0], n[1]], s)];

	    case "ResizeNearestNeighbor":
	      r = getParamValue("images", e, t, a), n = getParamValue("size", e, t, a), s = getParamValue("alignCorners", e, t, a);
	      return [Rc.resizeNearestNeighbor(r, [n[0], n[1]], s)];

	    case "CropAndResize":
	      var o = getParamValue("image", e, t, a),
	          p = getParamValue("boxes", e, t, a),
	          u = getParamValue("boxInd", e, t, a),
	          i = getParamValue("cropSize", e, t, a),
	          m = getParamValue("method", e, t, a),
	          c = getParamValue("extrapolationValue", e, t, a);
	      return [Rc.cropAndResize(o, p, u, i, m, c)];

	    default:
	      throw TypeError("Node type " + e.op + " is not implemented");
	  }
	},
	    executeOp$9 = function executeOp$9(e, t, a) {
	  switch (e.op) {
	    case "Equal":
	      return [zu(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    case "NotEqual":
	      return [Qu(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    case "Greater":
	      return [Gu(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    case "GreaterEqual":
	      return [Hu(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    case "Less":
	      return [ju(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    case "LessEqual":
	      return [Ku(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    case "LogicalAnd":
	      return [bl(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    case "LogicalNot":
	      return [wl(getParamValue("a", e, t, a))];

	    case "LogicalOr":
	      return [Cl(getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    case "Select":
	      return [Rl(getParamValue("condition", e, t, a), getParamValue("a", e, t, a), getParamValue("b", e, t, a))];

	    default:
	      throw TypeError("Node type " + e.op + " is not implemented");
	  }
	},
	    executeOp$10 = function executeOp$10(e, t, a) {
	  switch (e.op) {
	    case "BatchMatMul":
	    case "BatchMatMulV2":
	    case "MatMul":
	      return [hu(getParamValue("a", e, t, a), getParamValue("b", e, t, a), getParamValue("transposeA", e, t, a), getParamValue("transposeB", e, t, a))];

	    case "Transpose":
	      return [Dl(getParamValue("x", e, t, a), getParamValue("perm", e, t, a))];

	    default:
	      throw TypeError("Node type " + e.op + " is not implemented");
	  }
	},
	    executeOp$11 = function executeOp$11(e, t, a) {
	  switch (e.op) {
	    case "FusedBatchNorm":
	    case "FusedBatchNormV2":
	    case "FusedBatchNormV3":
	      return [Ys(getParamValue("x", e, t, a), getParamValue("mean", e, t, a), getParamValue("variance", e, t, a), getParamValue("offset", e, t, a), getParamValue("scale", e, t, a), getParamValue("epsilon", e, t, a))];

	    case "LRN":
	      return [_l(getParamValue("x", e, t, a), getParamValue("radius", e, t, a), getParamValue("bias", e, t, a), getParamValue("alpha", e, t, a), getParamValue("beta", e, t, a))];

	    case "Softmax":
	      return [Kr(getParamValue("x", e, t, a))];

	    case "LogSoftmax":
	      return [Xr(getParamValue("x", e, t, a))];

	    case "SparseToDense":
	      return [Xl(getParamValue("sparseIndices", e, t, a), getParamValue("outputShape", e, t, a), getParamValue("sparseValues", e, t, a), getParamValue("defaultValue", e, t, a))];

	    default:
	      throw TypeError("Node type " + e.op + " is not implemented");
	  }
	},
	    executeOp$12 = function executeOp$12(e, t, a) {
	  switch (e.op) {
	    case "Max":
	      var r = getParamValue("axis", e, t, a),
	          n = getParamValue("keepDims", e, t, a);
	      return [Mu(getParamValue("x", e, t, a), r, n)];

	    case "Mean":
	      r = getParamValue("axis", e, t, a), n = getParamValue("keepDims", e, t, a);
	      return [Bu(getParamValue("x", e, t, a), r, n)];

	    case "Min":
	      r = getParamValue("axis", e, t, a), n = getParamValue("keepDims", e, t, a);
	      return [Pu(getParamValue("x", e, t, a), r, n)];

	    case "Sum":
	      r = getParamValue("axis", e, t, a), n = getParamValue("keepDims", e, t, a);
	      return [Wu(getParamValue("x", e, t, a), r, n)];

	    case "All":
	      r = getParamValue("axis", e, t, a), n = getParamValue("keepDims", e, t, a);
	      return [Tu(getParamValue("x", e, t, a), r, n)];

	    case "Any":
	      r = getParamValue("axis", e, t, a), n = getParamValue("keepDims", e, t, a);
	      return [Du(getParamValue("x", e, t, a), r, n)];

	    case "ArgMax":
	      r = getParamValue("axis", e, t, a);
	      return [_u(getParamValue("x", e, t, a), r)];

	    case "ArgMin":
	      r = getParamValue("axis", e, t, a);
	      return [Ou(getParamValue("x", e, t, a), r)];

	    case "Prod":
	      r = getParamValue("axis", e, t, a), n = getParamValue("keepDims", e, t, a);
	      return [Uu(getParamValue("x", e, t, a), r, n)];

	    default:
	      throw TypeError("Node type " + e.op + " is not implemented");
	  }
	},
	    executeOp$13 = function executeOp$13(e, t, a) {
	  switch (e.op) {
	    case "ConcatV2":
	    case "Concat":
	      var r = getParamValue("axis", e, t, a),
	          n = getParamValue("tensors", e, t, a);
	      return [Bn(n, r)];

	    case "GatherV2":
	    case "Gather":
	      r = getParamValue("axis", e, t, a);
	      var s = getParamValue("x", e, t, a),
	          o = getParamValue("indices", e, t, a);
	      return [Bl(s, o.asType("int32"), r)];

	    case "ReverseV2":
	    case "Reverse":
	      r = getParamValue("axis", e, t, a), s = getParamValue("x", e, t, a);
	      return [du(s, r)];

	    case "Slice":
	      var p = getParamValue("begin", e, t, a),
	          u = getParamValue("size", e, t, a);
	      return [Ru(getParamValue("x", e, t, a), p, u)];

	    case "StridedSlice":
	      p = getParamValue("begin", e, t, a);
	      var i = getParamValue("end", e, t, a),
	          m = getParamValue("strides", e, t, a),
	          c = getParamValue("beginMask", e, t, a),
	          l = getParamValue("endMask", e, t, a),
	          d = getParamValue("ellipsisMask", e, t, a),
	          y = getParamValue("newAxisMask", e, t, a),
	          f = getParamValue("shrinkAxisMask", e, t, a),
	          h = getParamValue("x", e, t, a);
	      if (1 === p.length && h.shape.length > 1) for (var g = 1; g < h.shape.length; g++) {
	        p.push(0), i.push(h.shape[g]), m.push(m[0]);
	      }
	      return [zl(h, p, i, m, c, l, d, y, f)];

	    case "Pack":
	      return ze(function () {
	        var r = getParamValue("axis", e, t, a),
	            n = getParamValue("tensors", e, t, a),
	            s = n[0].shape,
	            o = n[0].squeeze().shape,
	            p = n.map(function (e) {
	          var t = Q.arraysEqual(e.shape, s);
	          if (!t && !Q.arraysEqual(e.squeeze().shape, o)) throw new Error("the input tensors shape does not match");
	          return t ? e : e.reshape(s);
	        });
	        return [wr(p, r)];
	      });

	    case "Unpack":
	      return ze(function () {
	        var r = getParamValue("axis", e, t, a),
	            n = getParamValue("tensor", e, t, a);
	        return Rr(n, r);
	      });

	    case "Tile":
	      var N = getParamValue("reps", e, t, a);
	      return [Cr(getParamValue("x", e, t, a), N)];

	    case "Split":
	    case "SplitV":
	      r = getParamValue("axis", e, t, a);
	      var x = getParamValue("numOrSizeSplits", e, t, a);
	      return zn(getParamValue("x", e, t, a), x, r);

	    case "ScatterNd":
	      o = getParamValue("indices", e, t, a);
	      var b = getParamValue("values", e, t, a),
	          V = getParamValue("shape", e, t, a);
	      return [Gl(o, b, V)];

	    case "GatherNd":
	      var P = getParamValue("x", e, t, a);
	      o = getParamValue("indices", e, t, a);
	      return [Yl(P, o)];

	    case "SparseToDense":
	      o = getParamValue("sparseIndices", e, t, a), V = getParamValue("outputShape", e, t, a);
	      var T = getParamValue("sparseValues", e, t, a),
	          O = getParamValue("defaultValue", e, t, a);
	      return [Xl(o, T, V, T.dtype === O.dtype ? O : O.asType(T.dtype))];

	    default:
	      throw TypeError("Node type " + e.op + " is not implemented");
	  }
	},
	    executeOp$14 = function executeOp$14(e, t, a) {
	  switch (e.op) {
	    case "FFT":
	      return [Hl(getParamValue("x", e, t, a))];

	    case "IFFT":
	      return [ql(getParamValue("x", e, t, a))];

	    case "RFFT":
	      return [$l(getParamValue("x", e, t, a))];

	    case "IRFFT":
	      return [jl(getParamValue("x", e, t, a))];

	    default:
	      throw TypeError("Node type " + e.op + " is not implemented");
	  }
	},
	    executeOp$15 = function executeOp$15(e, t, a) {
	  switch (e.op) {
	    case "Cast":
	      return [nr(getParamValue("x", e, t, a), getParamValue("dtype", e, t, a))];

	    case "ExpandDims":
	      var r = getParamValue("axis", e, t, a);
	      return [ir(getParamValue("x", e, t, a), r)];

	    case "Squeeze":
	      r = getParamValue("axis", e, t, a);
	      return [br(getParamValue("x", e, t, a), r)];

	    case "Reshape":
	      return [yr(getParamValue("x", e, t, a), getParamValue("shape", e, t, a))];

	    case "PadV2":
	    case "Pad":
	      return [cr(getParamValue("x", e, t, a), split$1(getParamValue("padding", e, t, a), 2), getParamValue("constantValue", e, t, a))];

	    case "SpaceToBatchND":
	      var n = getParamValue("blockShape", e, t, a),
	          s = split$1(getParamValue("paddings", e, t, a), 2);
	      return [xr(getParamValue("x", e, t, a), n, s)];

	    case "BatchToSpaceND":
	      n = getParamValue("blockShape", e, t, a);
	      var o = split$1(getParamValue("crops", e, t, a), 2);
	      return [er(getParamValue("x", e, t, a), n, o)];

	    case "DepthToSpace":
	      var p = getParamValue("blockSize", e, t, a),
	          u = getParamValue("dataFormat", e, t, a).toUpperCase();
	      return [ar(getParamValue("x", e, t, a), p, u)];

	    default:
	      throw TypeError("Node type " + e.op + " is not implemented");
	  }
	};

	function executeOp$16(e, t, a) {
	  var r = function (e, t, a) {
	    switch (e.category) {
	      case "arithmetic":
	        return executeOp(e, t, a);

	      case "basic_math":
	        return executeOp$1(e, t, a);

	      case "control":
	        return executeOp$2(e, t, a);

	      case "convolution":
	        return executeOp$3(e, t, a);

	      case "creation":
	        return executeOp$4(e, t, a);

	      case "dynamic":
	        return executeOp$5(e, t, a);

	      case "evaluation":
	        return executeOp$6(e, t, a);

	      case "image":
	        return executeOp$8(e, t, a);

	      case "graph":
	        return executeOp$7(e, t, a);

	      case "logical":
	        return executeOp$9(e, t, a);

	      case "matrices":
	        return executeOp$10(e, t, a);

	      case "normalization":
	        return executeOp$11(e, t, a);

	      case "reduction":
	        return executeOp$12(e, t, a);

	      case "slice_join":
	        return executeOp$13(e, t, a);

	      case "spectral":
	        return executeOp$14(e, t, a);

	      case "transformation":
	        return executeOp$15(e, t, a);

	      case "custom":
	        var r = getRegisteredOp(e.op);
	        if (r && r.customExecutor) return r.customExecutor(new NodeValueImpl(e, t, a));
	        throw TypeError("Custom op " + e.op + " is not registered.");

	      default:
	        throw TypeError("Unknown op '" + e.op + "'. File an issue at https://github.com/tensorflow/tfjs/issues so we can add it, or register a custom execution with tf.registerOp()");
	    }
	  }(e, t, a);

	  return r instanceof Promise ? r.then(function (e) {
	    return [].concat(e);
	  }) : [].concat(r);
	}

	var ExecutionContext = function () {
	  function e(e, t) {
	    this.weightMap = e, this.tensorArrayMap = t, this.rootContext = {
	      id: 0,
	      frameName: "",
	      iterationId: 0
	    }, this.contexts = [this.rootContext], this.lastId = 0, this.generateCurrentContextIds();
	  }

	  return e.prototype.newFrame = function (e, t) {
	    return {
	      id: e,
	      frameName: t,
	      iterationId: 0
	    };
	  }, Object.defineProperty(e.prototype, "currentContext", {
	    get: function get() {
	      return this.contexts;
	    },
	    set: function set(e) {
	      this.contexts !== e && (this.contexts = e, this.generateCurrentContextIds());
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(e.prototype, "currentContextId", {
	    get: function get() {
	      return this._currentContextIds[0];
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(e.prototype, "currentContextIds", {
	    get: function get() {
	      return this._currentContextIds;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), e.prototype.generateCurrentContextIds = function () {
	    for (var e = [], t = 0; t < this.contexts.length - 1; t++) {
	      var a = this.contexts.slice(0, this.contexts.length - t);
	      e.push(this.contextIdforContexts(a));
	    }

	    e.push(""), this._currentContextIds = e;
	  }, e.prototype.contextIdforContexts = function (e) {
	    return e ? e.map(function (e) {
	      return 0 === e.id && 0 === e.iterationId ? "" : e.frameName + "-" + e.iterationId;
	    }).join("/") : "";
	  }, e.prototype.enterFrame = function (e) {
	    this.contexts && (this.lastId++, this.contexts = this.contexts.slice(), this.contexts.push(this.newFrame(this.lastId, e)), this._currentContextIds.unshift(this.contextIdforContexts(this.contexts)));
	  }, e.prototype.exitFrame = function () {
	    if (!(this.contexts && this.contexts.length > 1)) throw new Error("Cannot exit frame, the context is empty");
	    this.contexts = this.contexts.slice(), this.contexts.splice(-1), this.currentContextIds.shift();
	  }, e.prototype.nextIteration = function () {
	    if (!(this.contexts && this.contexts.length > 0)) throw new Error("Cannot increase frame iteration, the context is empty");
	    this.contexts = this.contexts.slice(), this.lastId++;
	    var e = Object.assign({}, this.contexts[this.contexts.length - 1]);
	    e.iterationId += 1, e.id = this.lastId, this.contexts.splice(-1, 1, e), this._currentContextIds.splice(0, 1, this.contextIdforContexts(this.contexts));
	  }, e.prototype.getWeight = function (e) {
	    return this.weightMap[e];
	  }, e.prototype.addTensorArray = function (e) {
	    this.tensorArrayMap[e.id] = e;
	  }, e.prototype.getTensorArray = function (e) {
	    return this.tensorArrayMap[e];
	  }, e;
	}();

	function getExecutionSubgraph(e, t, a) {
	  for (var r = new Set(), n = [], s = null, o = null, p = new Set(), u = t.slice(); u.length > 0;) {
	    var i = u.pop();
	    (isControlFlow(i) || isDynamicShape(i)) && null == s && (o = (s = i).children.map(function (e) {
	      return e.name;
	    }).filter(function (e) {
	      return r.has(e);
	    })), r.add(i.name), null == a[i.name] && null == e[i.name] && (0 !== i.inputs.length ? i.inputs.forEach(function (e) {
	      p.has(e.name) || (p.add(e.name), u.push(e));
	    }) : n.push(i.name));
	  }

	  return {
	    inputs: e,
	    outputs: t,
	    usedNodes: r,
	    missingInputs: n,
	    dynamicNode: s,
	    syncInputs: o
	  };
	}

	function getNodesInTopologicalOrder(e, t, a) {
	  var r = a.usedNodes,
	      n = a.inputs,
	      s = [];
	  Object.keys(n).map(function (t) {
	    return e.nodes[t];
	  }).forEach(function (e) {
	    r.has(e.name) && s.push(e);
	  }), e.weights.forEach(function (e) {
	    r.has(e.name) && s.push(e);
	  });

	  for (var o = new Set(), p = []; s.length > 0;) {
	    var u = s.pop();
	    o.add(u.name), t[u.name] || p.push(u), u.children.forEach(function (e) {
	      !o.has(e.name) && r.has(e.name) && e.inputs.every(function (e) {
	        return o.has(e.name);
	      }) && s.push(e);
	    });
	  }

	  return p;
	}

	var CONTROL_FLOW_OPS = ["Switch", "Merge", "Enter", "Exit", "NextIteration"],
	    DYNAMIC_SHAPE_OPS = ["NonMaxSuppressionV2", "NonMaxSuppressionV3", "Where"];

	function isControlFlow(e) {
	  return CONTROL_FLOW_OPS.indexOf(e.op) >= 0;
	}

	function isDynamicShape(e) {
	  return DYNAMIC_SHAPE_OPS.indexOf(e.op) >= 0;
	}

	function rewritePrelu(e, t) {
	  var a = function a(_a) {
	    var r = e.nodes[_a];
	    if (null == r || "Add" !== r.op && "AddV2" !== r.op || 2 !== r.inputNames.length) return "continue";
	    var n = r.inputs.find(function (e) {
	      return "Relu" === e.op;
	    });
	    if (null == n || 1 !== n.inputNames.length) return "continue";
	    var s = r.inputs.find(function (e) {
	      return "Mul" === e.op;
	    });
	    if (null == s || 2 !== s.inputNames.length) return "continue";
	    var o = s.inputs.find(function (e) {
	      return "Const" === e.op;
	    }),
	        p = s.inputs.find(function (e) {
	      return "Relu" === e.op;
	    });
	    if (null == o || null == p || 1 !== p.inputNames.length) return "continue";
	    var u = p.inputs[0];
	    if (null == u || "Neg" !== u.op || 1 !== u.inputNames.length) return "continue";
	    if (n.inputNames[0] !== u.inputNames[0]) return "continue";
	    var i = n.inputs[0],
	        m = r.children,
	        c = o.name + "_neg",
	        l = {
	      name: c,
	      inputNames: [],
	      inputs: [],
	      attrParams: {},
	      category: "graph",
	      children: [],
	      op: "Const",
	      inputParams: {},
	      rawAttrs: {}
	    };
	    t[c] = [Es(t[o.name][0])], e.weights.push(l);
	    var d = {
	      name: r.name + "_Prelu",
	      inputNames: [i.name, l.name],
	      inputs: [i, l],
	      attrParams: {},
	      category: "custom",
	      children: m,
	      op: "Prelu",
	      inputParams: {
	        x: {
	          inputIndexStart: 0,
	          type: "tensor"
	        },
	        alpha: {
	          inputIndexStart: 1,
	          type: "tensor"
	        }
	      }
	    };
	    l.children.push(d);
	    var y = o.children.indexOf(s);
	    y > -1 && o.children.splice(y, 1);
	    var f = i.children.indexOf(n);
	    f > -1 && i.children.splice(f, 1);
	    var h = i.children.indexOf(u);

	    if (h > -1 && i.children.splice(h, 1), i.children.push(d), m.forEach(function (e) {
	      var t = e.inputNames.indexOf(r.name);
	      t > -1 && (e.inputNames[t] = d.name, e.inputs[t] = d);
	    }), 0 === m.length) {
	      var g = e.outputs.indexOf(r);
	      g > -1 && e.outputs.splice(g, 1), e.outputs.push(d);
	    }

	    delete e.nodes[r.name], delete e.nodes[s.name], delete e.nodes[n.name], delete e.nodes[p.name], delete e.nodes[u.name], e.nodes[d.name] = d, e.nodes[l.name] = l;
	  };

	  for (var r in e.nodes) {
	    a(r);
	  }
	}

	var GraphExecutor = function () {
	  function e(e) {
	    this.graph = e, this.compiledMap = new Map(), this._weightMap = {}, this.SEPERATOR = ",", this.placeholders = e.placeholders, this._outputs = e.outputs;
	  }

	  return Object.defineProperty(e.prototype, "weightMap", {
	    get: function get() {
	      return this._weightMap;
	    },
	    set: function set(e) {
	      var t = Object.keys(e).map(function (t) {
	        return e[t].map(function (e) {
	          return e.id;
	        });
	      });
	      this.weightIds = [].concat.apply([], t), this._weightMap = e;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(e.prototype, "inputs", {
	    get: function get() {
	      return this.placeholders.map(function (e) {
	        return {
	          name: e.name,
	          shape: e.attrParams.shape ? e.attrParams.shape.value : void 0,
	          dtype: e.attrParams.dtype ? e.attrParams.dtype.value : void 0
	        };
	      });
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(e.prototype, "outputs", {
	    get: function get() {
	      return this._outputs.map(function (e) {
	        return {
	          name: e.name,
	          shape: e.attrParams.shape ? e.attrParams.shape.value : void 0,
	          dtype: e.attrParams.dtype ? e.attrParams.dtype.value : void 0
	        };
	      });
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(e.prototype, "inputNodes", {
	    get: function get() {
	      return this.placeholders.map(function (e) {
	        return e.name;
	      });
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(e.prototype, "outputNodes", {
	    get: function get() {
	      return this.outputs.map(function (e) {
	        return e.name;
	      });
	    },
	    enumerable: !0,
	    configurable: !0
	  }), e.prototype.getCompilationKey = function (e, t) {
	    var a = e.map(function (e) {
	      return e.name;
	    }).sort(),
	        r = t.map(function (e) {
	      return e.name;
	    }).sort();
	    return a.join(this.SEPERATOR) + "--" + r.join(this.SEPERATOR);
	  }, e.prototype.compile = function (e, t) {
	    var a = getExecutionSubgraph(e, t, this.weightMap),
	        r = a.missingInputs,
	        n = a.dynamicNode,
	        s = a.syncInputs;
	    if (null != n) throw new Error("This execution contains the node '" + n.name + "', which has the dynamic op '" + n.op + "'. Please use model.executeAsync() instead. Alternatively, to avoid the dynamic ops, specify the inputs [" + s + "]");

	    if (r.length > 0) {
	      var o = t.map(function (e) {
	        return e.name;
	      }),
	          p = Object.keys(e);
	      throw new Error("Cannot compute the outputs [" + o + "] from the provided inputs [" + p + "]. Missing the following inputs: [" + r + "]");
	    }

	    return getNodesInTopologicalOrder(this.graph, this.weightMap, a);
	  }, e.prototype.fusePrelu = function () {
	    rewritePrelu(this.graph, this.weightMap);
	  }, e.prototype.execute = function (e, t) {
	    var a = this,
	        r = Object.keys(e).sort();
	    this.checkInputs(e), this.checkInputShapeAndType(e), this.checkOutputs(t);
	    var n = r.map(function (e) {
	      return a.graph.nodes[e];
	    }),
	        s = t.map(function (e) {
	      return a.graph.nodes[parseNodeName(e)[0]];
	    }),
	        o = this.getCompilationKey(n, s),
	        p = this.compiledMap.get(o);
	    null == p && (p = this.compile(e, s), this.compiledMap.set(o, p));
	    var u = {};
	    return ze(function () {
	      var r = new ExecutionContext(a._weightMap, u),
	          n = _assign$1({}, a.weightMap);

	      Object.keys(e).forEach(function (t) {
	        n[t] = [e[t]];
	      });

	      for (var s = a.getFrozenTensorIds(n), o = {}, i = 0; i < p.length; i++) {
	        var m = p[i];

	        if (!n[m.name]) {
	          var c = executeOp$16(m, n, r);
	          if (c instanceof Promise) throw new Error("The execution of the op '" + m.op + "' returned a promise. Please use model.executeAsync() instead.");
	          n[m.name] = c, a.checkTensorForDisposal(m.name, m, n, r, s, t, o);
	        }
	      }

	      return t.map(function (e) {
	        return getTensor(e, n, r);
	      });
	    });
	  }, e.prototype.getFrozenTensorIds = function (e) {
	    var t = [].concat.apply([], Object.keys(e).map(function (t) {
	      return e[t];
	    }).map(function (e) {
	      return e.map(function (e) {
	        return e.id;
	      });
	    }));
	    return new Set(t);
	  }, e.prototype.checkTensorForDisposal = function (e, t, a, r, n, s, o) {
	    "control" !== t.category && -1 === s.indexOf(e) && (a[e].forEach(function (e) {
	      null != e && (o[e.id] = (o[e.id] || 0) + t.children.length);
	    }), t.inputs.forEach(function (e) {
	      if ("control" !== e.category) {
	        var t = getTensorsForCurrentContenxt(e.name, a, r);
	        null != t && t.forEach(function (e) {
	          if (e && !n.has(e.id)) {
	            var t = o[e.id];
	            1 === t ? (e.dispose(), delete o[e.id]) : null != t && o[e.id]--;
	          }
	        });
	      }
	    }));
	  }, e.prototype.executeAsync = function (e, t) {
	    return __awaiter$1(this, void 0, void 0, function () {
	      var a,
	          r,
	          n,
	          s,
	          o,
	          p,
	          u = this;
	      return __generator$1(this, function (i) {
	        switch (i.label) {
	          case 0:
	            return this.checkInputs(e), this.checkInputShapeAndType(e), this.checkOutputs(t), a = {}, r = new ExecutionContext(this._weightMap, a), [4, this.executeWithControlFlow(e, r, t)];

	          case 1:
	            return n = i.sent(), s = t.map(function (e) {
	              return getTensor(e, n, r);
	            }), o = new Set(s.map(function (e) {
	              return e.id;
	            })), p = new Set(Object.keys(e).map(function (t) {
	              return e[t].id;
	            })), Object.keys(n).forEach(function (e) {
	              n[e].forEach(function (e) {
	                !e || e.isDisposed || o.has(e.id) || p.has(e.id) || -1 !== u.weightIds.indexOf(e.id) || e.dispose();
	              });
	            }), [2, s];
	        }
	      });
	    });
	  }, e.prototype.executeWithControlFlow = function (e, t, a) {
	    return __awaiter$1(this, void 0, void 0, function () {
	      var r,
	          n,
	          s,
	          o,
	          p,
	          u,
	          i,
	          m,
	          c,
	          l,
	          d,
	          y,
	          f,
	          h,
	          g,
	          N,
	          x = this;
	      return __generator$1(this, function (b) {
	        switch (b.label) {
	          case 0:
	            r = Object.keys(e), n = r.map(function (e) {
	              return x.graph.nodes[e];
	            }), s = a.map(function (e) {
	              return x.graph.nodes[parseNodeName(e)[0]];
	            }), o = getExecutionSubgraph(e, s, this.weightMap), p = o.usedNodes, u = o.missingInputs, i = o.dynamicNode, m = o.syncInputs, c = n.concat(this.graph.weights).map(function (e) {
	              return {
	                node: e,
	                contexts: t.currentContext
	              };
	            }), l = _assign$1({}, this.weightMap), Object.keys(e).forEach(function (t) {
	              l[t] = [e[t]];
	            }), d = {}, y = this.getFrozenTensorIds(l), f = {}, b.label = 1;

	          case 1:
	            return c.length > 0 ? (h = this.processStack(n, c, t, l, f, y, a, d, p), [4, Promise.all(h)]) : [3, 3];

	          case 2:
	            return b.sent(), [3, 1];

	          case 3:
	            if (null == i && console.warn("This model execution did not contain any nodes with control flow or dynamic output shapes. You can use model.execute() instead."), (g = s.filter(function (e) {
	              return !isControlFlow(e) && !getTensor(e.name, l, t);
	            }).map(function (e) {
	              return e.name;
	            })).length > 0) throw N = "", null != i && (N = "Alternatively, to avoid the dynamic ops, use model.execute() and specify the inputs [" + m + "]"), new Error("Cannot compute the outputs [" + g + "] from the provided inputs [" + r + "]. Consider providing the following inputs: [" + u + "]. " + N);
	            return [2, l];
	        }
	      });
	    });
	  }, e.prototype.processStack = function (e, t, a, r, n, s, o, p, u) {
	    for (var i = this, m = [], c = function c() {
	      var c = t.pop();
	      a.currentContext = c.contexts;
	      var d = "";

	      if ("Enter" === c.node.op && getParamValue("isConstant", c.node, r, a) && (d = getNodeNameAndIndex(c.node.name, a)[0]), -1 === e.indexOf(c.node)) {
	        var y = executeOp$16(c.node, r, a);
	        d || (d = getNodeNameAndIndex(c.node.name, a)[0]);
	        var f = a.currentContext;
	        y instanceof Promise ? m.push(y.then(function (e) {
	          return r[d] = e, a.currentContext = f, i.checkTensorForDisposal(d, c.node, r, a, s, o, p), i.processChildNodes(c.node, t, a, r, n, u), e;
	        })) : (r[d] = y, l.checkTensorForDisposal(d, c.node, r, a, s, o, p), l.processChildNodes(c.node, t, a, r, n, u));
	      } else l.processChildNodes(c.node, t, a, r, n, u);
	    }, l = this; t.length > 0;) {
	      c();
	    }

	    return m;
	  }, e.prototype.processChildNodes = function (e, t, a, r, n, s) {
	    e.children.forEach(function (e) {
	      var o = getNodeNameAndIndex(e.name, a)[0];
	      !n[o] && s.has(e.name) && ("Merge" === e.op ? e.inputNames.some(function (e) {
	        return !!getTensor(e, r, a);
	      }) && (n[o] = !0, t.push({
	        contexts: a.currentContext,
	        node: e
	      })) : e.inputNames.every(function (e) {
	        return !!getTensor(e, r, a);
	      }) && (n[o] = !0, t.push({
	        contexts: a.currentContext,
	        node: e
	      })));
	    });
	  }, e.prototype.dispose = function () {
	    var e = this;
	    Object.keys(this.weightMap).forEach(function (t) {
	      return e.weightMap[t].forEach(function (e) {
	        return e.dispose();
	      });
	    });
	  }, e.prototype.checkInputShapeAndType = function (e) {
	    var t = this;
	    Object.keys(e).forEach(function (a) {
	      var r = e[a],
	          n = t.graph.nodes[a];

	      if (n.attrParams.shape && n.attrParams.shape.value) {
	        var s = n.attrParams.shape.value,
	            o = s.length === r.shape.length && r.shape.every(function (e, t) {
	          return -1 === s[t] || s[t] === e;
	        });
	        Q.assert(o, function () {
	          return "The shape of dict['" + n.name + "'] provided in model.execute(dict) must be [" + s + "], but was [" + r.shape + "]";
	        });
	      }

	      n.attrParams.dtype && n.attrParams.dtype.value && Q.assert(r.dtype === n.attrParams.dtype.value, function () {
	        return "The dtype of dict['" + n.name + "'] provided in model.execute(dict) must be " + n.attrParams.dtype.value + ", but was " + r.dtype;
	      });
	    });
	  }, e.prototype.checkInputs = function (e) {
	    var t = this,
	        a = Object.keys(e).filter(function (e) {
	      return !t.graph.nodes[e];
	    });
	    if (a.length > 0) throw new Error("The dict provided in model.execute(dict) has keys: [" + a + "] that are not part of graph");
	  }, e.prototype.checkOutputs = function (e) {
	    var t = this;
	    e.forEach(function (e) {
	      var a = parseNodeName(e)[0];
	      if (!t.graph.nodes[a]) throw new Error("The output '" + e + "' is not found in the graph");
	    });
	  }, e;
	}(),
	    TFHUB_SEARCH_PARAM = "?tfjs-format=file",
	    DEFAULT_MODEL_NAME = "model.json",
	    GraphModel = function () {
	  function e(e, t) {
	    void 0 === t && (t = {}), this.modelUrl = e, this.loadOptions = t, this.version = "n/a", null == t && (this.loadOptions = {});
	  }

	  return Object.defineProperty(e.prototype, "modelVersion", {
	    get: function get() {
	      return this.version;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(e.prototype, "inputNodes", {
	    get: function get() {
	      return this.executor.inputNodes;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(e.prototype, "outputNodes", {
	    get: function get() {
	      return this.executor.outputNodes;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(e.prototype, "inputs", {
	    get: function get() {
	      return this.executor.inputs;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(e.prototype, "outputs", {
	    get: function get() {
	      return this.executor.outputs;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), Object.defineProperty(e.prototype, "weights", {
	    get: function get() {
	      return this.executor.weightMap;
	    },
	    enumerable: !0,
	    configurable: !0
	  }), e.prototype.fusePrelu = function () {
	    this.executor.fusePrelu(), null == getRegisteredOp("Prelu") && registerOp("Prelu", function (e) {
	      var t = e.inputs[0],
	          a = e.inputs[1];
	      return kl(t, a);
	    });
	  }, e.prototype.findIOHandler = function () {
	    var e = this.modelUrl;
	    if (null != e.load) this.handler = e;else if (null != this.loadOptions.requestInit) this.handler = Ah.browserHTTPRequest(e, this.loadOptions);else {
	      var t = Ah.getLoadHandlers(e, this.loadOptions.onProgress);
	      if (0 === t.length) t.push(Ah.browserHTTPRequest(e, this.loadOptions));else if (t.length > 1) throw new Error("Found more than one (" + t.length + ") load handlers for URL '" + [e] + "'");
	      this.handler = t[0];
	    }
	  }, e.prototype.load = function () {
	    return __awaiter$1(this, void 0, void 0, function () {
	      var e, t, a;
	      return __generator$1(this, function (r) {
	        switch (r.label) {
	          case 0:
	            if (this.findIOHandler(), null == this.handler.load) throw new Error("Cannot proceed with model loading because the IOHandler provided does not have the `load` method implemented.");
	            return [4, this.handler.load()];

	          case 1:
	            return e = r.sent(), t = e.modelTopology, this.version = t.versions.producer + "." + t.versions.minConsumer, a = Ah.decodeWeights(e.weightData, e.weightSpecs), this.executor = new GraphExecutor(OperationMapper.Instance.transformGraph(t)), this.executor.weightMap = this.convertTensorMapToTensorsMap(a), [2, !0];
	        }
	      });
	    });
	  }, e.prototype.predict = function (e, t) {
	    return this.execute(e, this.outputNodes);
	  }, e.prototype.normalizeInputs = function (e) {
	    if (!(e instanceof ht || Array.isArray(e))) return e;
	    if ((e = Array.isArray(e) ? e : [e]).length !== this.inputNodes.length) throw new Error("Input tensor count mismatch,the graph model has " + this.inputNodes.length + " placeholders, while there are " + e.length + " input tensors.");
	    return this.inputNodes.reduce(function (t, a, r) {
	      return t[a] = e[r], t;
	    }, {});
	  }, e.prototype.normalizeOutputs = function (e) {
	    return e = e || this.outputNodes, Array.isArray(e) ? e : [e];
	  }, e.prototype.execute = function (e, t) {
	    e = this.normalizeInputs(e), t = this.normalizeOutputs(t);
	    var a = this.executor.execute(e, t);
	    return a.length > 1 ? a : a[0];
	  }, e.prototype.executeAsync = function (e, t) {
	    return __awaiter$1(this, void 0, void 0, function () {
	      var a;
	      return __generator$1(this, function (r) {
	        switch (r.label) {
	          case 0:
	            return e = this.normalizeInputs(e), t = this.normalizeOutputs(t), [4, this.executor.executeAsync(e, t)];

	          case 1:
	            return [2, (a = r.sent()).length > 1 ? a : a[0]];
	        }
	      });
	    });
	  }, e.prototype.convertTensorMapToTensorsMap = function (e) {
	    return Object.keys(e).reduce(function (t, a) {
	      return t[a] = [e[a]], t;
	    }, {});
	  }, e.prototype.dispose = function () {
	    this.executor.dispose();
	  }, e;
	}();

	function loadGraphModel(e, t) {
	  return void 0 === t && (t = {}), __awaiter$1(this, void 0, void 0, function () {
	    var a;
	    return __generator$1(this, function (r) {
	      switch (r.label) {
	        case 0:
	          if (null == e) throw new Error("modelUrl in loadGraphModel() cannot be null. Please provide a url or an IOHandler that loads the model");
	          return null == t && (t = {}), t.fromTFHub && null == e.load && (e.endsWith("/") || (e += "/"), e = "" + e + DEFAULT_MODEL_NAME + TFHUB_SEARCH_PARAM), [4, (a = new GraphModel(e, t)).load()];

	        case 1:
	          return r.sent(), [2, a];
	      }
	    });
	  });
	}

	var version$2 = "1.2.7";

	var _extendStatics$1 = function extendStatics(t, e) {
	  return (_extendStatics$1 = Object.setPrototypeOf || {
	    __proto__: []
	  } instanceof Array && function (t, e) {
	    t.__proto__ = e;
	  } || function (t, e) {
	    for (var r in e) {
	      e.hasOwnProperty(r) && (t[r] = e[r]);
	    }
	  })(t, e);
	};

	function __extends$1(t, e) {
	  function r() {
	    this.constructor = t;
	  }

	  _extendStatics$1(t, e), t.prototype = null === e ? Object.create(e) : (r.prototype = e.prototype, new r());
	}

	function __awaiter$2(t, e, r, n) {
	  return new (r || (r = Promise))(function (i, o) {
	    function a(t) {
	      try {
	        u(n.next(t));
	      } catch (t) {
	        o(t);
	      }
	    }

	    function s(t) {
	      try {
	        u(n["throw"](t));
	      } catch (t) {
	        o(t);
	      }
	    }

	    function u(t) {
	      t.done ? i(t.value) : new r(function (e) {
	        e(t.value);
	      }).then(a, s);
	    }

	    u((n = n.apply(t, e || [])).next());
	  });
	}

	function __generator$2(t, e) {
	  var r,
	      n,
	      i,
	      o,
	      a = {
	    label: 0,
	    sent: function sent() {
	      if (1 & i[0]) throw i[1];
	      return i[1];
	    },
	    trys: [],
	    ops: []
	  };
	  return o = {
	    next: s(0),
	    "throw": s(1),
	    "return": s(2)
	  }, "function" == typeof Symbol && (o[Symbol.iterator] = function () {
	    return this;
	  }), o;

	  function s(o) {
	    return function (s) {
	      return function (o) {
	        if (r) throw new TypeError("Generator is already executing.");

	        for (; a;) {
	          try {
	            if (r = 1, n && (i = 2 & o[0] ? n["return"] : o[0] ? n["throw"] || ((i = n["return"]) && i.call(n), 0) : n.next) && !(i = i.call(n, o[1])).done) return i;

	            switch (n = 0, i && (o = [2 & o[0], i.value]), o[0]) {
	              case 0:
	              case 1:
	                i = o;
	                break;

	              case 4:
	                return a.label++, {
	                  value: o[1],
	                  done: !1
	                };

	              case 5:
	                a.label++, n = o[1], o = [0];
	                continue;

	              case 7:
	                o = a.ops.pop(), a.trys.pop();
	                continue;

	              default:
	                if (!(i = (i = a.trys).length > 0 && i[i.length - 1]) && (6 === o[0] || 2 === o[0])) {
	                  a = 0;
	                  continue;
	                }

	                if (3 === o[0] && (!i || o[1] > i[0] && o[1] < i[3])) {
	                  a.label = o[1];
	                  break;
	                }

	                if (6 === o[0] && a.label < i[1]) {
	                  a.label = i[1], i = o;
	                  break;
	                }

	                if (i && a.label < i[2]) {
	                  a.label = i[2], a.ops.push(o);
	                  break;
	                }

	                i[2] && a.ops.pop(), a.trys.pop();
	                continue;
	            }

	            o = e.call(t, a);
	          } catch (t) {
	            o = [6, t], n = 0;
	          } finally {
	            r = i = 0;
	          }
	        }

	        if (5 & o[0]) throw o[1];
	        return {
	          value: o[0] ? o[1] : void 0,
	          done: !0
	        };
	      }([o, s]);
	    };
	  }
	}

	function createCommonjsModule$1(t, e) {
	  return t(e = {
	    exports: {}
	  }, e.exports), e.exports;
	}

	var alea = createCommonjsModule$1(function (t) {
	  !function (t, e, r) {
	    function n(t, e) {
	      return e.c = t.c, e.s0 = t.s0, e.s1 = t.s1, e.s2 = t.s2, e;
	    }

	    function i(t, e) {
	      var r = new function (t) {
	        var e,
	            r = this,
	            n = (e = 4022871197, function (t) {
	          t = t.toString();

	          for (var r = 0; r < t.length; r++) {
	            var n = .02519603282416938 * (e += t.charCodeAt(r));
	            n -= e = n >>> 0, e = (n *= e) >>> 0, e += 4294967296 * (n -= e);
	          }

	          return 2.3283064365386963e-10 * (e >>> 0);
	        });
	        r.next = function () {
	          var t = 2091639 * r.s0 + 2.3283064365386963e-10 * r.c;
	          return r.s0 = r.s1, r.s1 = r.s2, r.s2 = t - (r.c = 0 | t);
	        }, r.c = 1, r.s0 = n(" "), r.s1 = n(" "), r.s2 = n(" "), r.s0 -= n(t), r.s0 < 0 && (r.s0 += 1), r.s1 -= n(t), r.s1 < 0 && (r.s1 += 1), r.s2 -= n(t), r.s2 < 0 && (r.s2 += 1), n = null;
	      }(t),
	          i = e && e.state,
	          o = r.next;
	      return o.int32 = function () {
	        return 4294967296 * r.next() | 0;
	      }, o["double"] = function () {
	        return o() + 1.1102230246251565e-16 * (2097152 * o() | 0);
	      }, o.quick = o, i && ("object" == _typeof_1(i) && n(i, r), o.state = function () {
	        return n(r, {});
	      }), o;
	    }

	    e && e.exports ? e.exports = i : r && r.amd ? r(function () {
	      return i;
	    }) : this.alea = i;
	  }(0, t, !1);
	}),
	    xor128 = createCommonjsModule$1(function (t) {
	  !function (t, e, r) {
	    function n(t, e) {
	      return e.x = t.x, e.y = t.y, e.z = t.z, e.w = t.w, e;
	    }

	    function i(t, e) {
	      var r = new function (t) {
	        var e = this,
	            r = "";
	        e.x = 0, e.y = 0, e.z = 0, e.w = 0, e.next = function () {
	          var t = e.x ^ e.x << 11;
	          return e.x = e.y, e.y = e.z, e.z = e.w, e.w ^= e.w >>> 19 ^ t ^ t >>> 8;
	        }, t === (0 | t) ? e.x = t : r += t;

	        for (var n = 0; n < r.length + 64; n++) {
	          e.x ^= 0 | r.charCodeAt(n), e.next();
	        }
	      }(t),
	          i = e && e.state,
	          o = function o() {
	        return (r.next() >>> 0) / 4294967296;
	      };

	      return o["double"] = function () {
	        do {
	          var t = ((r.next() >>> 11) + (r.next() >>> 0) / 4294967296) / (1 << 21);
	        } while (0 === t);

	        return t;
	      }, o.int32 = r.next, o.quick = o, i && ("object" == _typeof_1(i) && n(i, r), o.state = function () {
	        return n(r, {});
	      }), o;
	    }

	    e && e.exports ? e.exports = i : r && r.amd ? r(function () {
	      return i;
	    }) : this.xor128 = i;
	  }(0, t, !1);
	}),
	    xorwow = createCommonjsModule$1(function (t) {
	  !function (t, e, r) {
	    function n(t, e) {
	      return e.x = t.x, e.y = t.y, e.z = t.z, e.w = t.w, e.v = t.v, e.d = t.d, e;
	    }

	    function i(t, e) {
	      var r = new function (t) {
	        var e = this,
	            r = "";
	        e.next = function () {
	          var t = e.x ^ e.x >>> 2;
	          return e.x = e.y, e.y = e.z, e.z = e.w, e.w = e.v, (e.d = e.d + 362437 | 0) + (e.v = e.v ^ e.v << 4 ^ t ^ t << 1) | 0;
	        }, e.x = 0, e.y = 0, e.z = 0, e.w = 0, e.v = 0, t === (0 | t) ? e.x = t : r += t;

	        for (var n = 0; n < r.length + 64; n++) {
	          e.x ^= 0 | r.charCodeAt(n), n == r.length && (e.d = e.x << 10 ^ e.x >>> 4), e.next();
	        }
	      }(t),
	          i = e && e.state,
	          o = function o() {
	        return (r.next() >>> 0) / 4294967296;
	      };

	      return o["double"] = function () {
	        do {
	          var t = ((r.next() >>> 11) + (r.next() >>> 0) / 4294967296) / (1 << 21);
	        } while (0 === t);

	        return t;
	      }, o.int32 = r.next, o.quick = o, i && ("object" == _typeof_1(i) && n(i, r), o.state = function () {
	        return n(r, {});
	      }), o;
	    }

	    e && e.exports ? e.exports = i : r && r.amd ? r(function () {
	      return i;
	    }) : this.xorwow = i;
	  }(0, t, !1);
	}),
	    xorshift7 = createCommonjsModule$1(function (t) {
	  !function (t, e, r) {
	    function n(t, e) {
	      return e.x = t.x.slice(), e.i = t.i, e;
	    }

	    function i(t, e) {
	      null == t && (t = +new Date());

	      var r = new function (t) {
	        var e = this;
	        e.next = function () {
	          var t,
	              r,
	              n = e.x,
	              i = e.i;
	          return t = n[i], r = (t ^= t >>> 7) ^ t << 24, r ^= (t = n[i + 1 & 7]) ^ t >>> 10, r ^= (t = n[i + 3 & 7]) ^ t >>> 3, r ^= (t = n[i + 4 & 7]) ^ t << 7, t = n[i + 7 & 7], r ^= (t ^= t << 13) ^ t << 9, n[i] = r, e.i = i + 1 & 7, r;
	        }, function (t, e) {
	          var r,
	              n = [];
	          if (e === (0 | e)) n[0] = e;else for (e = "" + e, r = 0; r < e.length; ++r) {
	            n[7 & r] = n[7 & r] << 15 ^ e.charCodeAt(r) + n[r + 1 & 7] << 13;
	          }

	          for (; n.length < 8;) {
	            n.push(0);
	          }

	          for (r = 0; r < 8 && 0 === n[r]; ++r) {
	          }

	          for (8 == r ? n[7] = -1 : n[r], t.x = n, t.i = 0, r = 256; r > 0; --r) {
	            t.next();
	          }
	        }(e, t);
	      }(t),
	          i = e && e.state,
	          o = function o() {
	        return (r.next() >>> 0) / 4294967296;
	      };

	      return o["double"] = function () {
	        do {
	          var t = ((r.next() >>> 11) + (r.next() >>> 0) / 4294967296) / (1 << 21);
	        } while (0 === t);

	        return t;
	      }, o.int32 = r.next, o.quick = o, i && (i.x && n(i, r), o.state = function () {
	        return n(r, {});
	      }), o;
	    }

	    e && e.exports ? e.exports = i : r && r.amd ? r(function () {
	      return i;
	    }) : this.xorshift7 = i;
	  }(0, t, !1);
	}),
	    xor4096 = createCommonjsModule$1(function (t) {
	  !function (t, e, r) {
	    function n(t, e) {
	      return e.i = t.i, e.w = t.w, e.X = t.X.slice(), e;
	    }

	    function i(t, e) {
	      null == t && (t = +new Date());

	      var r = new function (t) {
	        var e = this;
	        e.next = function () {
	          var t,
	              r,
	              n = e.w,
	              i = e.X,
	              o = e.i;
	          return e.w = n = n + 1640531527 | 0, r = i[o + 34 & 127], t = i[o = o + 1 & 127], r ^= r << 13, t ^= t << 17, r ^= r >>> 15, t ^= t >>> 12, r = i[o] = r ^ t, e.i = o, r + (n ^ n >>> 16) | 0;
	        }, function (t, e) {
	          var r,
	              n,
	              i,
	              o,
	              a,
	              s = [],
	              u = 128;

	          for (e === (0 | e) ? (n = e, e = null) : (e += "\0", n = 0, u = Math.max(u, e.length)), i = 0, o = -32; o < u; ++o) {
	            e && (n ^= e.charCodeAt((o + 32) % e.length)), 0 === o && (a = n), n ^= n << 10, n ^= n >>> 15, n ^= n << 4, n ^= n >>> 13, o >= 0 && (a = a + 1640531527 | 0, i = 0 == (r = s[127 & o] ^= n + a) ? i + 1 : 0);
	          }

	          for (i >= 128 && (s[127 & (e && e.length || 0)] = -1), i = 127, o = 512; o > 0; --o) {
	            n = s[i + 34 & 127], r = s[i = i + 1 & 127], n ^= n << 13, r ^= r << 17, n ^= n >>> 15, r ^= r >>> 12, s[i] = n ^ r;
	          }

	          t.w = a, t.X = s, t.i = i;
	        }(e, t);
	      }(t),
	          i = e && e.state,
	          o = function o() {
	        return (r.next() >>> 0) / 4294967296;
	      };

	      return o["double"] = function () {
	        do {
	          var t = ((r.next() >>> 11) + (r.next() >>> 0) / 4294967296) / (1 << 21);
	        } while (0 === t);

	        return t;
	      }, o.int32 = r.next, o.quick = o, i && (i.X && n(i, r), o.state = function () {
	        return n(r, {});
	      }), o;
	    }

	    e && e.exports ? e.exports = i : r && r.amd ? r(function () {
	      return i;
	    }) : this.xor4096 = i;
	  }(0, t, !1);
	}),
	    tychei = createCommonjsModule$1(function (t) {
	  !function (t, e, r) {
	    function n(t, e) {
	      return e.a = t.a, e.b = t.b, e.c = t.c, e.d = t.d, e;
	    }

	    function i(t, e) {
	      var r = new function (t) {
	        var e = this,
	            r = "";
	        e.next = function () {
	          var t = e.b,
	              r = e.c,
	              n = e.d,
	              i = e.a;
	          return t = t << 25 ^ t >>> 7 ^ r, r = r - n | 0, n = n << 24 ^ n >>> 8 ^ i, i = i - t | 0, e.b = t = t << 20 ^ t >>> 12 ^ r, e.c = r = r - n | 0, e.d = n << 16 ^ r >>> 16 ^ i, e.a = i - t | 0;
	        }, e.a = 0, e.b = 0, e.c = -1640531527, e.d = 1367130551, t === Math.floor(t) ? (e.a = t / 4294967296 | 0, e.b = 0 | t) : r += t;

	        for (var n = 0; n < r.length + 20; n++) {
	          e.b ^= 0 | r.charCodeAt(n), e.next();
	        }
	      }(t),
	          i = e && e.state,
	          o = function o() {
	        return (r.next() >>> 0) / 4294967296;
	      };

	      return o["double"] = function () {
	        do {
	          var t = ((r.next() >>> 11) + (r.next() >>> 0) / 4294967296) / (1 << 21);
	        } while (0 === t);

	        return t;
	      }, o.int32 = r.next, o.quick = o, i && ("object" == _typeof_1(i) && n(i, r), o.state = function () {
	        return n(r, {});
	      }), o;
	    }

	    e && e.exports ? e.exports = i : r && r.amd ? r(function () {
	      return i;
	    }) : this.tychei = i;
	  }(0, t, !1);
	}),
	    seedrandom = createCommonjsModule$1(function (t) {
	  !function (e, r) {
	    var n,
	        i = this,
	        o = 256,
	        a = 6,
	        s = "random",
	        u = r.pow(o, a),
	        c = r.pow(2, 52),
	        l = 2 * c,
	        h = o - 1;

	    function f(t, f, v) {
	      var _ = [],
	          w = p(function t(e, r) {
	        var n,
	            i = [],
	            o = _typeof_1(e);

	        if (r && "object" == o) for (n in e) {
	          try {
	            i.push(t(e[n], r - 1));
	          } catch (t) {}
	        }
	        return i.length ? i : "string" == o ? e : e + "\0";
	      }((f = 1 == f ? {
	        entropy: !0
	      } : f || {}).entropy ? [t, m(e)] : null == t ? function () {
	        try {
	          var t;
	          return n && (t = n.randomBytes) ? t = t(o) : (t = new Uint8Array(o), (i.crypto || i.msCrypto).getRandomValues(t)), m(t);
	        } catch (t) {
	          var r = i.navigator,
	              a = r && r.plugins;
	          return [+new Date(), i, a, i.screen, m(e)];
	        }
	      }() : t, 3), _),
	          y = new function (t) {
	        var e,
	            r = t.length,
	            n = this,
	            i = 0,
	            a = n.i = n.j = 0,
	            s = n.S = [];
	        r || (t = [r++]);

	        for (; i < o;) {
	          s[i] = i++;
	        }

	        for (i = 0; i < o; i++) {
	          s[i] = s[a = h & a + t[i % r] + (e = s[i])], s[a] = e;
	        }

	        (n.g = function (t) {
	          for (var e, r = 0, i = n.i, a = n.j, s = n.S; t--;) {
	            e = s[i = h & i + 1], r = r * o + s[h & (s[i] = s[a = h & a + e]) + (s[a] = e)];
	          }

	          return n.i = i, n.j = a, r;
	        })(o);
	      }(_),
	          g = function g() {
	        for (var t = y.g(a), e = u, r = 0; t < c;) {
	          t = (t + r) * o, e *= o, r = y.g(1);
	        }

	        for (; t >= l;) {
	          t /= 2, e /= 2, r >>>= 1;
	        }

	        return (t + r) / e;
	      };

	      return g.int32 = function () {
	        return 0 | y.g(4);
	      }, g.quick = function () {
	        return y.g(4) / 4294967296;
	      }, g["double"] = g, p(m(y.S), e), (f.pass || v || function (t, e, n, i) {
	        return i && (i.S && d(i, y), t.state = function () {
	          return d(y, {});
	        }), n ? (r[s] = t, e) : t;
	      })(g, w, "global" in f ? f.global : this == r, f.state);
	    }

	    function d(t, e) {
	      return e.i = t.i, e.j = t.j, e.S = t.S.slice(), e;
	    }

	    function p(t, e) {
	      for (var r, n = t + "", i = 0; i < n.length;) {
	        e[h & i] = h & (r ^= 19 * e[h & i]) + n.charCodeAt(i++);
	      }

	      return m(e);
	    }

	    function m(t) {
	      return String.fromCharCode.apply(0, t);
	    }

	    if (r["seed" + s] = f, p(r.random(), e), t.exports) {
	      t.exports = f;

	      try {
	        n = require("crypto");
	      } catch (t) {}
	    }
	  }([], Math);
	});
	seedrandom.alea = alea, seedrandom.xor128 = xor128, seedrandom.xorwow = xorwow, seedrandom.xorshift7 = xorshift7, seedrandom.xor4096 = xor4096, seedrandom.tychei = tychei;
	var seedrandom$1 = seedrandom,
	    seedrandom_1 = seedrandom$1.alea;

	function deepMap(t, e) {
	  return deepMapInternal(t, e);
	}

	function deepMapInternal(t, e, r, n) {
	  if (void 0 === r && (r = new Map()), void 0 === n && (n = new Set()), null == t) return null;
	  if (n.has(t)) throw new Error("Circular references are not supported.");
	  if (r.has(t)) return r.get(t);
	  var i = e(t);
	  if (i.recurse && null !== i.value) throw new Error("A deep map function may not return both a value and recurse=true.");

	  if (i.recurse) {
	    if (isIterable(t)) {
	      var o = Array.isArray(t) ? [] : {};

	      for (var a in n.add(t), t) {
	        var s = deepMapInternal(t[a], e, r, n);
	        o[a] = s;
	      }

	      return n["delete"](t), o;
	    }

	    throw new Error("Can't recurse into non-iterable type: " + t);
	  }

	  return r.set(t, i.value), i.value;
	}

	function deepZip(t, e) {
	  return void 0 === e && (e = zipToList), deepZipInternal(t, e);
	}

	function deepZipInternal(t, e, r) {
	  void 0 === r && (r = new Set());
	  var n = t[0];
	  if (r.has(n)) throw new Error("Circular references are not supported.");
	  var i = e(t);
	  if (i.recurse && null !== i.value) throw new Error("A deep zip function may not return both a value and recurse=true.");

	  if (i.recurse) {
	    if (isIterable(n)) {
	      var o = Array.isArray(n) ? [] : {};
	      r.add(n);

	      var a = function a(n) {
	        var i = deepZipInternal(t.map(function (t) {
	          return t[n];
	        }), e, r);
	        o[n] = i;
	      };

	      for (var s in n) {
	        a(s);
	      }

	      return r["delete"](n), o;
	    }

	    throw new Error("Can't recurse into non-iterable type: " + n);
	  }

	  return i.value;
	}

	function zipToList(t) {
	  return null === t ? null : isIterable(t[0]) ? {
	    value: null,
	    recurse: !0
	  } : {
	    value: t,
	    recurse: !1
	  };
	}

	function deepMapAndAwaitAll(t, e) {
	  return __awaiter$2(this, void 0, void 0, function () {
	    var r, n, i, o, a, s;
	    return __generator$2(this, function (u) {
	      switch (u.label) {
	        case 0:
	          r = new Map(), deepMapInternal(t, e, r), n = 0, i = Array.from(r.keys()), u.label = 1;

	        case 1:
	          return n < i.length ? (o = i[n], (a = r.get(o)) instanceof Promise ? [4, a] : [3, 3]) : [3, 4];

	        case 2:
	          s = u.sent(), r.set(o, s), u.label = 3;

	        case 3:
	          return n++, [3, 1];

	        case 4:
	          return [2, deepMapInternal(t, e, r)];
	      }
	    });
	  });
	}

	function isIterable(t) {
	  return null != t && (Array.isArray(t) || "object" == _typeof_1(t) && !(t instanceof ht));
	}

	function canTensorify(t) {
	  return null == t || isPrimitive(t) || Array.isArray(t) || "object" == _typeof_1(t) && t instanceof ht || Q.isTypedArray(t);
	}

	function isPrimitive(t) {
	  return null === t || "object" != _typeof_1(t) && "function" != typeof t;
	}

	function deepClone(t) {
	  return deepMap(t, cloneIfTensor);
	}

	function cloneIfTensor(t) {
	  return t instanceof ht ? {
	    value: t.clone(),
	    recurse: !1
	  } : isIterable(t) ? {
	    value: null,
	    recurse: !0
	  } : {
	    value: t,
	    recurse: !1
	  };
	}

	var RingBuffer = function () {
	  function t(t) {
	    if (this.capacity = t, this.begin = 0, this.end = 0, null == t) throw new RangeError("Can't create a ring buffer of unknown capacity.");
	    if (t < 1) throw new RangeError("Can't create ring buffer of capacity < 1.");
	    this.data = new Array(t), this.doubledCapacity = 2 * t;
	  }

	  return t.prototype.wrap = function (t) {
	    for (; t < 0;) {
	      t += this.doubledCapacity;
	    }

	    return t % this.doubledCapacity;
	  }, t.prototype.get = function (t) {
	    if (t < 0) throw new RangeError("Can't get item at a negative index.");
	    return this.data[t % this.capacity];
	  }, t.prototype.set = function (t, e) {
	    if (t < 0) throw new RangeError("Can't set item at a negative index.");
	    this.data[t % this.capacity] = e;
	  }, t.prototype.length = function () {
	    var t = this.end - this.begin;
	    return t < 0 && (t = this.doubledCapacity + t), t;
	  }, t.prototype.isFull = function () {
	    return this.length() === this.capacity;
	  }, t.prototype.isEmpty = function () {
	    return 0 === this.length();
	  }, t.prototype.push = function (t) {
	    if (this.isFull()) throw new RangeError("Ring buffer is full.");
	    this.set(this.end, t), this.end = this.wrap(this.end + 1);
	  }, t.prototype.pushAll = function (t) {
	    for (var e = 0, r = t; e < r.length; e++) {
	      var n = r[e];
	      this.push(n);
	    }
	  }, t.prototype.pop = function () {
	    if (this.isEmpty()) throw new RangeError("Ring buffer is empty.");
	    this.end = this.wrap(this.end - 1);
	    var t = this.get(this.end);
	    return this.set(this.end, void 0), t;
	  }, t.prototype.unshift = function (t) {
	    if (this.isFull()) throw new RangeError("Ring buffer is full.");
	    this.begin = this.wrap(this.begin - 1), this.set(this.begin, t);
	  }, t.prototype.shift = function () {
	    if (this.isEmpty()) throw new RangeError("Ring buffer is empty.");
	    var t = this.get(this.begin);
	    return this.set(this.begin, void 0), this.begin = this.wrap(this.begin + 1), t;
	  }, t.prototype.shuffleExcise = function (t) {
	    if (this.isEmpty()) throw new RangeError("Ring buffer is empty.");
	    var e = this.wrap(this.begin + t),
	        r = this.get(e);
	    return this.set(e, this.pop()), r;
	  }, t;
	}(),
	    GrowingRingBuffer = function (t) {
	  function e() {
	    return t.call(this, e.INITIAL_CAPACITY) || this;
	  }

	  return __extends$1(e, t), e.prototype.isFull = function () {
	    return !1;
	  }, e.prototype.push = function (e) {
	    t.prototype.isFull.call(this) && this.expand(), t.prototype.push.call(this, e);
	  }, e.prototype.unshift = function (e) {
	    t.prototype.isFull.call(this) && this.expand(), t.prototype.unshift.call(this, e);
	  }, e.prototype.expand = function () {
	    for (var t = 2 * this.capacity, e = new Array(t), r = this.length(), n = 0; n < r; n++) {
	      e[n] = this.get(this.wrap(this.begin + n));
	    }

	    this.data = e, this.capacity = t, this.doubledCapacity = 2 * this.capacity, this.begin = 0, this.end = r;
	  }, e.INITIAL_CAPACITY = 32, e;
	}(RingBuffer);

	function iteratorFromItems(t) {
	  return new ArrayIterator(t);
	}

	function iteratorFromFunction(t) {
	  return new FunctionCallIterator(t);
	}

	function iteratorFromConcatenated(t, e) {
	  return new ChainedIterator(t, e);
	}

	function iteratorFromZipped(t, e) {
	  return void 0 === e && (e = ZipMismatchMode.FAIL), new ZipIterator(t, e);
	}

	var ZipMismatchMode,
	    LazyIterator = function () {
	  function t() {}

	  return t.prototype.toArray = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t, e;
	      return __generator$2(this, function (r) {
	        switch (r.label) {
	          case 0:
	            return t = [], [4, this.next()];

	          case 1:
	            e = r.sent(), r.label = 2;

	          case 2:
	            return e.done ? [3, 4] : (t.push(e.value), [4, this.next()]);

	          case 3:
	            return e = r.sent(), [3, 2];

	          case 4:
	            return [2, t];
	        }
	      });
	    });
	  }, t.prototype.toArrayForTest = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t, e, r;
	      return __generator$2(this, function (n) {
	        switch (n.label) {
	          case 0:
	            return t = this.prefetch(100), e = [], [4, t.next()];

	          case 1:
	            r = n.sent(), n.label = 2;

	          case 2:
	            return r.done ? [3, 4] : (e.push(r.value), [4, t.next()]);

	          case 3:
	            return r = n.sent(), [3, 2];

	          case 4:
	            return [2, e];
	        }
	      });
	    });
	  }, t.prototype.resolveFully = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t;
	      return __generator$2(this, function (e) {
	        switch (e.label) {
	          case 0:
	            return [4, this.next()];

	          case 1:
	            t = e.sent(), e.label = 2;

	          case 2:
	            return t.done ? [3, 4] : [4, this.next()];

	          case 3:
	            return t = e.sent(), [3, 2];

	          case 4:
	            return [2];
	        }
	      });
	    });
	  }, t.prototype.resolveWhile = function (t) {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var e, r;
	      return __generator$2(this, function (n) {
	        switch (n.label) {
	          case 0:
	            return [4, this.next()];

	          case 1:
	            e = n.sent(), r = t(e.value), n.label = 2;

	          case 2:
	            return e.done || !r ? [3, 4] : [4, this.next()];

	          case 3:
	            return e = n.sent(), r = t(e.value), [3, 2];

	          case 4:
	            return [2];
	        }
	      });
	    });
	  }, t.prototype.handleErrors = function (t) {
	    return new ErrorHandlingLazyIterator(this, t);
	  }, t.prototype.filter = function (t) {
	    return new FilterIterator(this, t);
	  }, t.prototype.map = function (t) {
	    return new MapIterator(this, t);
	  }, t.prototype.mapAsync = function (t) {
	    return new AsyncMapIterator(this, t);
	  }, t.prototype.serialMapAsync = function (t) {
	    return new AsyncMapIterator(this, t).serial();
	  }, t.prototype.flatmap = function (t) {
	    return new FlatmapIterator(this, t);
	  }, t.prototype.forEachAsync = function (t) {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (e) {
	        return [2, this.map(t).resolveFully()];
	      });
	    });
	  }, t.prototype.serialForEach = function (t) {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (e) {
	        return [2, this.serialMapAsync(t).resolveWhile(function (t) {
	          return !0 === t;
	        })];
	      });
	    });
	  }, t.prototype.rowMajorBatch = function (t, e) {
	    return void 0 === e && (e = !0), new RowMajorBatchIterator(this, t, e);
	  }, t.prototype.columnMajorBatch = function (t, e, r) {
	    return void 0 === e && (e = !0), void 0 === r && (r = zipToList), this.rowMajorBatch(t, e).map(function (t) {
	      return deepZip(t, r);
	    });
	  }, t.prototype.concatenate = function (t, e) {
	    return new ChainedIterator(iteratorFromItems([this, t]), e);
	  }, t.prototype.take = function (t) {
	    return t < 0 || null == t ? this : new TakeIterator(this, t);
	  }, t.prototype.skip = function (t) {
	    return t < 0 || null == t ? this : new SkipIterator(this, t);
	  }, t.prototype.prefetch = function (t) {
	    return new PrefetchIterator(this, t);
	  }, t.prototype.shuffle = function (t, e) {
	    return new ShuffleIterator(this, t, e);
	  }, t.prototype.serial = function () {
	    return new SerialIterator(this);
	  }, t;
	}(),
	    ArrayIterator = function (t) {
	  function e(e) {
	    var r = t.call(this) || this;
	    return r.items = e, r.trav = 0, r;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return "Array of " + this.items.length + " items";
	  }, e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t;
	      return __generator$2(this, function (e) {
	        return this.trav >= this.items.length ? [2, {
	          value: null,
	          done: !0
	        }] : (t = this.items[this.trav], this.trav++, [2, {
	          value: deepClone(t),
	          done: !1
	        }]);
	      });
	    });
	  }, e;
	}(LazyIterator),
	    FunctionCallIterator = function (t) {
	  function e(e) {
	    var r = t.call(this) || this;
	    return r.nextFn = e, r;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return "Function call";
	  }, e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (t) {
	        try {
	          return [2, this.nextFn()];
	        } catch (t) {
	          throw t.message = "Error thrown while iterating through a dataset: " + t.message, t;
	        }

	        return [2];
	      });
	    });
	  }, e;
	}(LazyIterator),
	    SerialIterator = function (t) {
	  function e(e) {
	    var r = t.call(this) || this;
	    return r.upstream = e, r.lastRead = Promise.resolve({
	      value: null,
	      done: !1
	    }), r;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return this.upstream.summary() + " -> Serial";
	  }, e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t = this;
	      return __generator$2(this, function (e) {
	        return this.lastRead = this.lastRead.then(function () {
	          return t.serialNext();
	        }), [2, this.lastRead];
	      });
	    });
	  }, e.prototype.serialNext = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (t) {
	        return [2, this.upstream.next()];
	      });
	    });
	  }, e;
	}(LazyIterator),
	    SkipIterator = function (t) {
	  function e(e, r) {
	    var n = t.call(this) || this;
	    return n.upstream = e, n.maxCount = r, n.count = 0, n.lastRead = Promise.resolve({
	      value: null,
	      done: !1
	    }), n;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return this.upstream.summary() + " -> Skip";
	  }, e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t = this;
	      return __generator$2(this, function (e) {
	        return this.lastRead = this.lastRead.then(function () {
	          return t.serialNext();
	        }), [2, this.lastRead];
	      });
	    });
	  }, e.prototype.serialNext = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t;
	      return __generator$2(this, function (e) {
	        switch (e.label) {
	          case 0:
	            return this.count++ < this.maxCount ? [4, this.upstream.next()] : [3, 2];

	          case 1:
	            return (t = e.sent()).done ? [2, t] : (Ve(t.value), [3, 0]);

	          case 2:
	            return [2, this.upstream.next()];
	        }
	      });
	    });
	  }, e;
	}(LazyIterator),
	    TakeIterator = function (t) {
	  function e(e, r) {
	    var n = t.call(this) || this;
	    return n.upstream = e, n.maxCount = r, n.count = 0, n;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return this.upstream.summary() + " -> Take";
	  }, e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (t) {
	        return this.count++ >= this.maxCount ? [2, {
	          value: null,
	          done: !0
	        }] : [2, this.upstream.next()];
	      });
	    });
	  }, e;
	}(LazyIterator),
	    RowMajorBatchIterator = function (t) {
	  function e(e, r, n) {
	    void 0 === n && (n = !0);
	    var i = t.call(this) || this;
	    return i.upstream = e, i.batchSize = r, i.enableSmallLastBatch = n, i.lastRead = Promise.resolve({
	      value: null,
	      done: !1
	    }), i;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return this.upstream.summary() + " -> RowMajorBatch";
	  }, e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t = this;
	      return __generator$2(this, function (e) {
	        return this.lastRead = this.lastRead.then(function () {
	          return t.serialNext();
	        }), [2, this.lastRead];
	      });
	    });
	  }, e.prototype.serialNext = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t, e;
	      return __generator$2(this, function (r) {
	        switch (r.label) {
	          case 0:
	            t = [], r.label = 1;

	          case 1:
	            return t.length < this.batchSize ? [4, this.upstream.next()] : [3, 3];

	          case 2:
	            return (e = r.sent()).done ? this.enableSmallLastBatch && t.length > 0 ? [2, {
	              value: t,
	              done: !1
	            }] : [2, {
	              value: null,
	              done: !0
	            }] : (t.push(e.value), [3, 1]);

	          case 3:
	            return [2, {
	              value: t,
	              done: !1
	            }];
	        }
	      });
	    });
	  }, e;
	}(LazyIterator),
	    FilterIterator = function (t) {
	  function e(e, r) {
	    var n = t.call(this) || this;
	    return n.upstream = e, n.predicate = r, n.lastRead = Promise.resolve({
	      value: null,
	      done: !1
	    }), n;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return this.upstream.summary() + " -> Filter";
	  }, e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t = this;
	      return __generator$2(this, function (e) {
	        return this.lastRead = this.lastRead.then(function () {
	          return t.serialNext();
	        }), [2, this.lastRead];
	      });
	    });
	  }, e.prototype.serialNext = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t;
	      return __generator$2(this, function (e) {
	        switch (e.label) {
	          case 0:
	            return [4, this.upstream.next()];

	          case 1:
	            return (t = e.sent()).done || this.predicate(t.value) ? [2, t] : (Ve(t.value), [3, 0]);

	          case 2:
	            return [2];
	        }
	      });
	    });
	  }, e;
	}(LazyIterator),
	    MapIterator = function (t) {
	  function e(e, r) {
	    var n = t.call(this) || this;
	    return n.upstream = e, n.transform = r, n;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return this.upstream.summary() + " -> Map";
	  }, e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t, e, r, n, i, o, a;
	      return __generator$2(this, function (s) {
	        switch (s.label) {
	          case 0:
	            return [4, this.upstream.next()];

	          case 1:
	            if ((t = s.sent()).done) return [2, {
	              value: null,
	              done: !0
	            }];

	            for (e = St.getTensorsInContainer(t.value), r = this.transform(t.value), n = St.getTensorsInContainer(r), i = 0, o = e; i < o.length; i++) {
	              a = o[i], St.isTensorInList(a, n) || a.dispose();
	            }

	            return [2, {
	              value: r,
	              done: !1
	            }];
	        }
	      });
	    });
	  }, e;
	}(LazyIterator),
	    ErrorHandlingLazyIterator = function (t) {
	  function e(e, r) {
	    var n = t.call(this) || this;
	    return n.upstream = e, n.handler = r, n.count = 0, n.lastRead = Promise.resolve({
	      value: null,
	      done: !1
	    }), n;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return this.upstream.summary() + " -> handleErrors";
	  }, e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t = this;
	      return __generator$2(this, function (e) {
	        return this.lastRead = this.lastRead.then(function () {
	          return t.serialNext();
	        }), [2, this.lastRead];
	      });
	    });
	  }, e.prototype.serialNext = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t;
	      return __generator$2(this, function (e) {
	        switch (e.label) {
	          case 0:
	            e.label = 1;

	          case 1:
	            return e.trys.push([1, 3,, 4]), [4, this.upstream.next()];

	          case 2:
	            return [2, e.sent()];

	          case 3:
	            return t = e.sent(), this.handler(t) ? [3, 4] : [2, {
	              value: null,
	              done: !0
	            }];

	          case 4:
	            return [3, 0];

	          case 5:
	            return [2];
	        }
	      });
	    });
	  }, e;
	}(LazyIterator),
	    AsyncMapIterator = function (t) {
	  function e(e, r) {
	    var n = t.call(this) || this;
	    return n.upstream = e, n.transform = r, n;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return this.upstream.summary() + " -> AsyncMap";
	  }, e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t, e, r, n, i, o, a;
	      return __generator$2(this, function (s) {
	        switch (s.label) {
	          case 0:
	            return [4, this.upstream.next()];

	          case 1:
	            return (t = s.sent()).done ? [2, {
	              value: null,
	              done: !0
	            }] : (e = St.getTensorsInContainer(t.value), [4, this.transform(t.value)]);

	          case 2:
	            for (r = s.sent(), n = St.getTensorsInContainer(r), i = 0, o = e; i < o.length; i++) {
	              a = o[i], St.isTensorInList(a, n) || a.dispose();
	            }

	            return [2, {
	              value: r,
	              done: !1
	            }];
	        }
	      });
	    });
	  }, e;
	}(LazyIterator),
	    OneToManyIterator = function (t) {
	  function e() {
	    var e = t.call(this) || this;
	    return e.outputQueue = new GrowingRingBuffer(), e.lastRead = Promise.resolve({
	      value: null,
	      done: !1
	    }), e;
	  }

	  return __extends$1(e, t), e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t = this;
	      return __generator$2(this, function (e) {
	        return this.lastRead = this.lastRead.then(function () {
	          return t.serialNext();
	        }), [2, this.lastRead];
	      });
	    });
	  }, e.prototype.serialNext = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (t) {
	        switch (t.label) {
	          case 0:
	            return 0 !== this.outputQueue.length() ? [3, 2] : [4, this.pump()];

	          case 1:
	            return t.sent() ? [3, 0] : [2, {
	              value: null,
	              done: !0
	            }];

	          case 2:
	            return [2, {
	              value: this.outputQueue.shift(),
	              done: !1
	            }];
	        }
	      });
	    });
	  }, e;
	}(LazyIterator),
	    FlatmapIterator = function (t) {
	  function e(e, r) {
	    var n = t.call(this) || this;
	    return n.upstream = e, n.transform = r, n;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return this.upstream.summary() + " -> Flatmap";
	  }, e.prototype.pump = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t, e, r, n, i, o, a;
	      return __generator$2(this, function (s) {
	        switch (s.label) {
	          case 0:
	            return [4, this.upstream.next()];

	          case 1:
	            if ((t = s.sent()).done) return [2, !1];

	            for (e = St.getTensorsInContainer(t.value), r = this.transform(t.value), n = St.getTensorsInContainer(r), this.outputQueue.pushAll(r), i = 0, o = e; i < o.length; i++) {
	              a = o[i], St.isTensorInList(a, n) || a.dispose();
	            }

	            return [2, !0];
	        }
	      });
	    });
	  }, e;
	}(OneToManyIterator),
	    ChainedIterator = function (t) {
	  function e(e, r) {
	    var n = t.call(this) || this;
	    return n.baseErrorHandler = r, n.lastRead = null, n.iterator = null, n.moreIterators = e, n;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return "TODO: fill in upstream of chained summaries -> Chained";
	  }, e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (t) {
	        return this.lastRead = this.readFromChain(this.lastRead), [2, this.lastRead];
	      });
	    });
	  }, e.prototype.readFromChain = function (t) {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var e, r;
	      return __generator$2(this, function (n) {
	        switch (n.label) {
	          case 0:
	            return [4, t];

	          case 1:
	            return n.sent(), null != this.iterator ? [3, 3] : [4, this.moreIterators.next()];

	          case 2:
	            if ((e = n.sent()).done) return [2, {
	              value: null,
	              done: !0
	            }];
	            this.iterator = e.value, null != this.baseErrorHandler && (this.iterator = this.iterator.handleErrors(this.baseErrorHandler)), n.label = 3;

	          case 3:
	            return [4, this.iterator.next()];

	          case 4:
	            return (r = n.sent()).done ? (this.iterator = null, [2, this.readFromChain(t)]) : [2, r];
	        }
	      });
	    });
	  }, e;
	}(LazyIterator);

	!function (t) {
	  t[t.FAIL = 0] = "FAIL", t[t.SHORTEST = 1] = "SHORTEST", t[t.LONGEST = 2] = "LONGEST";
	}(ZipMismatchMode || (ZipMismatchMode = {}));

	var ZipIterator = function (t) {
	  function e(e, r) {
	    void 0 === r && (r = ZipMismatchMode.FAIL);
	    var n = t.call(this) || this;
	    return n.iterators = e, n.mismatchMode = r, n.count = 0, n.currentPromise = null, n;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return "{TODO: fill in upstream of zip summaries} -> Zip";
	  }, e.prototype.nextState = function (t) {
	    return __awaiter$2(this, void 0, void 0, function () {
	      function e(t) {
	        return t instanceof LazyIterator ? {
	          value: t.next().then(function (t) {
	            return r++, t.done && n++, t.value;
	          }),
	          recurse: !1
	        } : {
	          value: null,
	          recurse: !0
	        };
	      }

	      var r, n, i;
	      return __generator$2(this, function (o) {
	        switch (o.label) {
	          case 0:
	            return [4, t];

	          case 1:
	            return o.sent(), r = 0, n = 0, [4, deepMapAndAwaitAll(this.iterators, e)];

	          case 2:
	            if (i = o.sent(), r === n) return [2, {
	              value: null,
	              done: !0
	            }];
	            if (n > 0) switch (this.mismatchMode) {
	              case ZipMismatchMode.FAIL:
	                throw new Error("Zipped streams should have the same length. Mismatched at element " + this.count + ".");

	              case ZipMismatchMode.SHORTEST:
	                return [2, {
	                  value: null,
	                  done: !0
	                }];

	              case ZipMismatchMode.LONGEST:
	            }
	            return this.count++, [2, {
	              value: i,
	              done: !1
	            }];
	        }
	      });
	    });
	  }, e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (t) {
	        switch (t.label) {
	          case 0:
	            return this.currentPromise = this.nextState(this.currentPromise), [4, this.currentPromise];

	          case 1:
	            return [2, t.sent()];
	        }
	      });
	    });
	  }, e;
	}(LazyIterator),
	    PrefetchIterator = function (t) {
	  function e(e, r) {
	    var n = t.call(this) || this;
	    return n.upstream = e, n.bufferSize = r, n.buffer = new RingBuffer(r), n;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return this.upstream.summary() + " -> Prefetch";
	  }, e.prototype.refill = function () {
	    for (; !this.buffer.isFull();) {
	      var t = this.upstream.next();
	      this.buffer.push(t);
	    }
	  }, e.prototype.next = function () {
	    return this.refill(), this.buffer.shift();
	  }, e;
	}(LazyIterator),
	    ShuffleIterator = function (t) {
	  function e(e, r, n) {
	    var i = t.call(this, e, r) || this;
	    return i.upstream = e, i.windowSize = r, i.upstreamExhausted = !1, i.random = seedrandom_1(n || Q.now().toString()), i.lastRead = Promise.resolve({
	      value: null,
	      done: !1
	    }), i;
	  }

	  return __extends$1(e, t), e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t = this;
	      return __generator$2(this, function (e) {
	        return this.lastRead = this.lastRead.then(function () {
	          return t.serialNext();
	        }), [2, this.lastRead];
	      });
	    });
	  }, e.prototype.randomInt = function (t) {
	    return Math.floor(this.random() * t);
	  }, e.prototype.chooseIndex = function () {
	    return this.randomInt(this.buffer.length());
	  }, e.prototype.serialNext = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t, e;
	      return __generator$2(this, function (r) {
	        switch (r.label) {
	          case 0:
	            this.upstreamExhausted || this.refill(), r.label = 1;

	          case 1:
	            return this.buffer.isEmpty() ? [3, 3] : (t = this.chooseIndex(), [4, this.buffer.shuffleExcise(t)]);

	          case 2:
	            return (e = r.sent()).done ? (this.upstreamExhausted = !0, [3, 1]) : (this.refill(), [2, e]);

	          case 3:
	            return [2, {
	              value: null,
	              done: !0
	            }];
	        }
	      });
	    });
	  }, e;
	}(PrefetchIterator),
	    Dataset = function () {
	  function t() {
	    this.size = null;
	  }

	  return t.prototype.batch = function (t, e) {
	    var r = this;
	    void 0 === e && (e = !0);
	    var n = this;
	    return Q.assert(t > 0, function () {
	      return "batchSize needs to be positive, but it is\n      " + t;
	    }), datasetFromIteratorFn(function () {
	      return __awaiter$2(r, void 0, void 0, function () {
	        return __generator$2(this, function (r) {
	          switch (r.label) {
	            case 0:
	              return [4, n.iterator()];

	            case 1:
	              return [2, r.sent().columnMajorBatch(t, e, deepBatchConcat)];
	          }
	        });
	      });
	    }, this.size === 1 / 0 || null == this.size ? this.size : e ? Math.ceil(this.size / t) : Math.floor(this.size / t));
	  }, t.prototype.concatenate = function (t) {
	    var e = this,
	        r = this;
	    return datasetFromIteratorFn(function () {
	      return __awaiter$2(e, void 0, void 0, function () {
	        var e, n;
	        return __generator$2(this, function (i) {
	          switch (i.label) {
	            case 0:
	              return [4, r.iterator()];

	            case 1:
	              return n = (e = i.sent()).concatenate, [4, t.iterator()];

	            case 2:
	              return [2, n.apply(e, [i.sent()])];
	          }
	        });
	      });
	    }, this.size === 1 / 0 || t.size === 1 / 0 ? 1 / 0 : null != this.size && null != t.size ? this.size + t.size : null);
	  }, t.prototype.filter = function (t) {
	    var e = this,
	        r = this;
	    return datasetFromIteratorFn(function () {
	      return __awaiter$2(e, void 0, void 0, function () {
	        return __generator$2(this, function (e) {
	          switch (e.label) {
	            case 0:
	              return [4, r.iterator()];

	            case 1:
	              return [2, e.sent().filter(function (e) {
	                return ze(function () {
	                  return t(e);
	                });
	              })];
	          }
	        });
	      });
	    }, this.size === 1 / 0 ? 1 / 0 : null);
	  }, t.prototype.forEachAsync = function (t) {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (e) {
	        switch (e.label) {
	          case 0:
	            return [4, this.iterator()];

	          case 1:
	            return [2, e.sent().forEachAsync(t)];
	        }
	      });
	    });
	  }, t.prototype.forEach = function (t) {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (e) {
	        return Pe("dataset.forEach() is deprecated and will be removed. Please use dataset.forEachAsync() instead"), [2, this.forEachAsync(t)];
	      });
	    });
	  }, t.prototype.map = function (t) {
	    var e = this,
	        r = this;
	    return datasetFromIteratorFn(function () {
	      return __awaiter$2(e, void 0, void 0, function () {
	        return __generator$2(this, function (e) {
	          switch (e.label) {
	            case 0:
	              return [4, r.iterator()];

	            case 1:
	              return [2, e.sent().map(function (e) {
	                return ze(function () {
	                  return t(e);
	                });
	              })];
	          }
	        });
	      });
	    }, this.size);
	  }, t.prototype.mapAsync = function (t) {
	    var e = this,
	        r = this;
	    return datasetFromIteratorFn(function () {
	      return __awaiter$2(e, void 0, void 0, function () {
	        return __generator$2(this, function (e) {
	          switch (e.label) {
	            case 0:
	              return [4, r.iterator()];

	            case 1:
	              return [2, e.sent().mapAsync(t)];
	          }
	        });
	      });
	    }, this.size);
	  }, t.prototype.prefetch = function (t) {
	    var e = this;
	    if (null == t) throw new RangeError("`Dataset.prefetch()` requires bufferSize to be specified.");
	    var r = this;
	    return datasetFromIteratorFn(function () {
	      return __awaiter$2(e, void 0, void 0, function () {
	        return __generator$2(this, function (e) {
	          switch (e.label) {
	            case 0:
	              return [4, r.iterator()];

	            case 1:
	              return [2, e.sent().prefetch(t)];
	          }
	        });
	      });
	    }, this.size);
	  }, t.prototype.repeat = function (t) {
	    var e = this,
	        r = this;
	    return datasetFromIteratorFn(function () {
	      return __awaiter$2(e, void 0, void 0, function () {
	        var e = this;
	        return __generator$2(this, function (n) {
	          return [2, iteratorFromConcatenated(iteratorFromFunction(function () {
	            return __awaiter$2(e, void 0, void 0, function () {
	              var t;
	              return __generator$2(this, function (e) {
	                switch (e.label) {
	                  case 0:
	                    return t = {}, [4, r.iterator()];

	                  case 1:
	                    return [2, (t.value = e.sent(), t.done = !1, t)];
	                }
	              });
	            });
	          }).take(t))];
	        });
	      });
	    }, null != this.size && t > 0 ? this.size * t : 0 === t ? 0 : null != this.size && (void 0 === t || t < 0) ? 1 / 0 : null);
	  }, t.prototype.skip = function (t) {
	    var e = this,
	        r = this;
	    return datasetFromIteratorFn(function () {
	      return __awaiter$2(e, void 0, void 0, function () {
	        return __generator$2(this, function (e) {
	          switch (e.label) {
	            case 0:
	              return [4, r.iterator()];

	            case 1:
	              return [2, e.sent().skip(t)];
	          }
	        });
	      });
	    }, null != this.size && t >= 0 && this.size >= t ? this.size - t : null != this.size && (this.size < t || void 0 === t || t < 0) ? 0 : null);
	  }, t.prototype.shuffle = function (t, e, r) {
	    var n = this;
	    if (void 0 === r && (r = !0), null == t || t < 0) throw null == this.size ? new RangeError("`Dataset.shuffle()` requires bufferSize to be specified.") : new RangeError("`Dataset.shuffle()` requires bufferSize to be specified.  If your data fits in main memory (for regular JS objects), and/or GPU memory (for `tf.Tensor`s), consider setting bufferSize to the dataset size (" + this.size + " elements)");
	    var i = this,
	        o = seedrandom_1(e || Q.now().toString());
	    return datasetFromIteratorFn(function () {
	      return __awaiter$2(n, void 0, void 0, function () {
	        var e;
	        return __generator$2(this, function (n) {
	          switch (n.label) {
	            case 0:
	              return e = o.int32(), r && (e += o.int32()), [4, i.iterator()];

	            case 1:
	              return [2, n.sent().shuffle(t, e.toString())];
	          }
	        });
	      });
	    }, this.size);
	  }, t.prototype.take = function (t) {
	    var e = this,
	        r = this;
	    return datasetFromIteratorFn(function () {
	      return __awaiter$2(e, void 0, void 0, function () {
	        return __generator$2(this, function (e) {
	          switch (e.label) {
	            case 0:
	              return [4, r.iterator()];

	            case 1:
	              return [2, e.sent().take(t)];
	          }
	        });
	      });
	    }, null != this.size && this.size > t ? t : null != this.size && this.size <= t ? this.size : null);
	  }, t.prototype.toArray = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (t) {
	        switch (t.label) {
	          case 0:
	            if (this.size === 1 / 0) throw new Error("Can not convert infinite data stream to array.");
	            return [4, this.iterator()];

	          case 1:
	            return [2, t.sent().toArray()];
	        }
	      });
	    });
	  }, t.prototype.toArrayForTest = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (t) {
	        switch (t.label) {
	          case 0:
	            if (this.size === 1 / 0) throw new Error("Can not convert infinite data stream to array.");
	            return [4, this.iterator()];

	          case 1:
	            return [2, t.sent().toArrayForTest()];
	        }
	      });
	    });
	  }, t.MAX_BUFFER_SIZE = 1e4, t;
	}();

	function datasetFromIteratorFn(t, e) {
	  return void 0 === e && (e = null), new (function (r) {
	    function n() {
	      var t = null !== r && r.apply(this, arguments) || this;
	      return t.size = e, t;
	    }

	    return __extends$1(n, r), n.prototype.iterator = function () {
	      return __awaiter$2(this, void 0, void 0, function () {
	        return __generator$2(this, function (e) {
	          return [2, t()];
	        });
	      });
	    }, n;
	  }(Dataset))();
	}

	function array(t) {
	  var e = this;
	  return datasetFromIteratorFn(function () {
	    return __awaiter$2(e, void 0, void 0, function () {
	      return __generator$2(this, function (e) {
	        return [2, iteratorFromItems(t)];
	      });
	    });
	  }, t.length);
	}

	function zip(t) {
	  var e,
	      r = this;
	  if (!isIterable(t)) throw new Error("The argument to zip() must be an object or array.");
	  if (Array.isArray(t)) for (var n = 0; n < t.length; n++) {
	    e = null == e ? t[n].size : Math.min(e, t[n].size);
	  } else if (t instanceof Object) for (var i in t) {
	    e = null == e ? t[i].size : Math.min(e, t[i].size);
	  }
	  return datasetFromIteratorFn(function () {
	    return __awaiter$2(r, void 0, void 0, function () {
	      return __generator$2(this, function (e) {
	        switch (e.label) {
	          case 0:
	            return [4, deepMapAndAwaitAll(t, function (t) {
	              if (t instanceof Dataset) return {
	                value: t.iterator(),
	                recurse: !1
	              };
	              if (isIterable(t)) return {
	                value: null,
	                recurse: !0
	              };
	              throw new Error("Leaves of the structure passed to zip() must be Datasets, not primitives.");
	            })];

	          case 1:
	            return [2, iteratorFromZipped(e.sent(), ZipMismatchMode.SHORTEST)];
	        }
	      });
	    });
	  }, e);
	}

	function deepBatchConcat(t) {
	  return null === t ? null : canTensorify(t[0]) ? {
	    value: batchConcat(t),
	    recurse: !1
	  } : {
	    value: null,
	    recurse: !0
	  };
	}

	function batchConcat(t) {
	  if (0 === t.length) throw new Error("Can't make a batch of zero elements.");
	  return t[0] instanceof ht ? wr(t) : bn(t);
	}

	var TextLineDataset = function (t) {
	  function e(e) {
	    var r = t.call(this) || this;
	    return r.input = e, r;
	  }

	  return __extends$1(e, t), e.prototype.iterator = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t, e;
	      return __generator$2(this, function (r) {
	        switch (r.label) {
	          case 0:
	            return [4, this.input.iterator()];

	          case 1:
	            return t = r.sent(), e = t.decodeUTF8(), [2, e.split("\n").map(function (t) {
	              return t.endsWith("\r") && (t = t.slice(0, -1)), t;
	            })];
	        }
	      });
	    });
	  }, e;
	}(Dataset),
	    CODE_QUOTE = '"',
	    STATE_OUT = Symbol("out"),
	    STATE_FIELD = Symbol("field"),
	    STATE_QUOTE = Symbol("quote"),
	    STATE_QUOTE_AFTER_QUOTE = Symbol("quoteafterquote"),
	    STATE_WITHIN_QUOTE_IN_QUOTE = Symbol("quoteinquote"),
	    CSVDataset = function (t) {
	  function e(e, r) {
	    var n = t.call(this) || this;
	    return n.input = e, n.hasHeader = !0, n.fullColumnNames = null, n.columnNamesValidated = !1, n.columnConfigs = null, n.configuredColumnsOnly = !1, n.delimiter = ",", n.delimWhitespace = !1, n.base = new TextLineDataset(e), r || (r = {}), n.hasHeader = !1 !== r.hasHeader, n.fullColumnNames = r.columnNames, n.columnConfigs = r.columnConfigs, n.configuredColumnsOnly = r.configuredColumnsOnly, r.delimWhitespace ? (Q.assert(null == r.delimiter, function () {
	      return "Delimiter should not be provided when delimWhitespace is true.";
	    }), n.delimWhitespace = !0, n.delimiter = " ") : n.delimiter = r.delimiter ? r.delimiter : ",", n;
	  }

	  return __extends$1(e, t), e.prototype.columnNames = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (t) {
	        switch (t.label) {
	          case 0:
	            return this.columnNamesValidated ? [3, 2] : [4, this.setColumnNames()];

	          case 1:
	            t.sent(), t.label = 2;

	          case 2:
	            return [2, this.configuredColumnsOnly ? Object.keys(this.columnConfigs) : this.fullColumnNames];
	        }
	      });
	    });
	  }, e.prototype.setColumnNames = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t,
	          e,
	          r,
	          n,
	          i,
	          o,
	          a = this;
	      return __generator$2(this, function (s) {
	        switch (s.label) {
	          case 0:
	            return [4, this.maybeReadHeaderLine()];

	          case 1:
	            if (t = s.sent(), !this.fullColumnNames && !t) throw new Error("Column names must be provided if there is no header line.");
	            if (this.fullColumnNames && t && Q.assert(t.length === this.fullColumnNames.length, function () {
	              return "The length of provided columnNames (" + a.fullColumnNames.length.toString() + ") does not match the length of the header line read from file (" + t.length.toString() + ").";
	            }), this.fullColumnNames || (this.fullColumnNames = t), e = this.fullColumnNames.reduce(function (t, e) {
	              return t[e] = t[e] + 1 || 1, t;
	            }, {}), r = Object.keys(e).filter(function (t) {
	              return e[t] > 1;
	            }), Q.assert(0 === r.length, function () {
	              return "Duplicate column names found: " + r.toString();
	            }), this.columnConfigs) for (n = 0, i = Object.keys(this.columnConfigs); n < i.length; n++) {
	              if (o = i[n], -1 === this.fullColumnNames.indexOf(o)) throw new Error('The key "' + o + '" provided in columnConfigs does not match any of the column names (' + this.fullColumnNames.toString() + ").");
	            }
	            return this.columnNamesValidated = !0, [2];
	        }
	      });
	    });
	  }, e.prototype.maybeReadHeaderLine = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t, e;
	      return __generator$2(this, function (r) {
	        switch (r.label) {
	          case 0:
	            return this.hasHeader ? [4, this.base.iterator()] : [3, 3];

	          case 1:
	            return [4, r.sent().next()];

	          case 2:
	            if ((t = r.sent()).done) throw new Error("No data was found for CSV parsing.");
	            return e = t.value, [2, this.parseRow(e, !1)];

	          case 3:
	            return [2, null];
	        }
	      });
	    });
	  }, e.prototype.iterator = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t,
	          e = this;
	      return __generator$2(this, function (r) {
	        switch (r.label) {
	          case 0:
	            return this.columnNamesValidated ? [3, 2] : [4, this.setColumnNames()];

	          case 1:
	            r.sent(), r.label = 2;

	          case 2:
	            return [4, this.base.iterator()];

	          case 3:
	            return t = r.sent(), this.hasHeader && (t = t.skip(1)), [2, t.map(function (t) {
	              return e.makeDataElement(t);
	            })];
	        }
	      });
	    });
	  }, e.prototype.makeDataElement = function (t) {
	    for (var e = this.parseRow(t), r = {}, n = {}, i = 0; i < this.fullColumnNames.length; i++) {
	      var o = this.fullColumnNames[i],
	          a = this.columnConfigs ? this.columnConfigs[o] : null;

	      if (!this.configuredColumnsOnly || a) {
	        var s = e[i],
	            u = null;
	        if ("" === s) {
	          if (a && void 0 !== a["default"]) u = a["default"];else {
	            if (a && (a.required || a.isLabel)) throw new Error("Required column " + o + " is empty in this line: " + t);
	            u = void 0;
	          }
	        } else {
	          var c = Number(s);
	          if (isNaN(c)) u = a && "bool" === a.dtype ? this.getBoolean(s) : s;else if (a && a.dtype) switch (a.dtype) {
	            case "float32":
	              u = c;
	              break;

	            case "int32":
	              u = Math.floor(c);
	              break;

	            case "bool":
	              u = this.getBoolean(s);
	              break;

	            default:
	              u = c;
	          } else u = c;
	        }
	        a && a.isLabel ? n[o] = u : r[o] = u;
	      }
	    }

	    return 0 === Object.keys(n).length ? r : {
	      xs: r,
	      ys: n
	    };
	  }, e.prototype.getBoolean = function (t) {
	    return "1" === t || "true" === t.toLowerCase() ? 1 : 0;
	  }, e.prototype.parseRow = function (t, e) {
	    void 0 === e && (e = !0);

	    for (var r = [], n = 0, i = t.length, o = STATE_OUT, a = 0; a < i; a++) {
	      switch (o) {
	        case STATE_OUT:
	          switch (t.charAt(a)) {
	            case CODE_QUOTE:
	              n = a + 1, o = STATE_QUOTE;
	              break;

	            case this.delimiter:
	              if (n = a + 1, " " === this.delimiter && this.delimWhitespace) break;
	              r.push(""), o = STATE_OUT;
	              break;

	            default:
	              o = STATE_FIELD, n = a;
	          }

	          break;

	        case STATE_FIELD:
	          switch (t.charAt(a)) {
	            case this.delimiter:
	              r.push(t.substring(n, a)), o = STATE_OUT, n = a + 1;
	          }

	          break;

	        case STATE_QUOTE:
	          switch (t.charAt(a)) {
	            case CODE_QUOTE:
	              o = STATE_QUOTE_AFTER_QUOTE;
	          }

	          break;

	        case STATE_QUOTE_AFTER_QUOTE:
	          switch (t.charAt(a)) {
	            case this.delimiter:
	              r.push(t.substring(n, a - 1)), o = STATE_OUT, n = a + 1;
	              break;

	            case CODE_QUOTE:
	              o = STATE_QUOTE;
	              break;

	            default:
	              o = STATE_WITHIN_QUOTE_IN_QUOTE;
	          }

	          break;

	        case STATE_WITHIN_QUOTE_IN_QUOTE:
	          switch (t.charAt(a)) {
	            case CODE_QUOTE:
	              o = STATE_QUOTE;
	          }

	      }
	    }

	    if (o === STATE_QUOTE_AFTER_QUOTE ? r.push(t.substring(n, i - 1)) : r.push(t.substring(n)), e && r.length !== this.fullColumnNames.length) throw new Error("Invalid row in csv file. Should have " + this.fullColumnNames.length + " elements in a row, but got " + r);
	    return r;
	  }, e;
	}(Dataset),
	    MicrophoneIterator = function (t) {
	  function e(e) {
	    var r = t.call(this) || this;
	    r.microphoneConfig = e, r.isClosed = !1, r.fftSize = e.fftSize || 1024;
	    var n = Math.log2(r.fftSize);
	    if (r.fftSize < 0 || n < 4 || n > 14 || !Number.isInteger(n)) throw new Error("Invalid fftSize: it must be a power of 2 between 2 to 4 and 2 to 14, but got " + r.fftSize);
	    if (r.numFrames = e.numFramesPerSpectrogram || 43, r.sampleRateHz = e.sampleRateHz, r.columnTruncateLength = e.columnTruncateLength || r.fftSize, r.audioTrackConstraints = e.audioTrackConstraints, r.smoothingTimeConstant = e.smoothingTimeConstant || 0, r.includeSpectrogram = !1 !== e.includeSpectrogram, r.includeWaveform = !0 === e.includeWaveform, !r.includeSpectrogram && !r.includeWaveform) throw new Error("Both includeSpectrogram and includeWaveform are false. At least one type of data should be returned.");
	    return r;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return "microphone";
	  }, e.create = function (t) {
	    return void 0 === t && (t = {}), __awaiter$2(this, void 0, void 0, function () {
	      var r;
	      return __generator$2(this, function (n) {
	        switch (n.label) {
	          case 0:
	            if (i.get("IS_NODE")) throw new Error("microphone API is only supported in browser environment.");
	            return [4, (r = new e(t)).start()];

	          case 1:
	            return n.sent(), [2, r];
	        }
	      });
	    });
	  }, e.prototype.start = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t, e, r, n;
	      return __generator$2(this, function (i) {
	        switch (i.label) {
	          case 0:
	            return i.trys.push([0, 2,, 3]), t = this, [4, navigator.mediaDevices.getUserMedia({
	              audio: null == this.audioTrackConstraints || this.audioTrackConstraints,
	              video: !1
	            })];

	          case 1:
	            return t.stream = i.sent(), [3, 3];

	          case 2:
	            throw e = i.sent(), new Error("Error thrown while initializing video stream: " + e.message);

	          case 3:
	            if (!this.stream) throw new Error("Could not obtain audio from microphone.");

	            if (r = window.AudioContext || window.webkitAudioContext, this.audioContext = new r(), this.sampleRateHz) {
	              if (this.audioContext.sampleRate !== this.sampleRateHz) throw new Error("Mismatch in sampling rate: Expected: " + this.sampleRateHz + "; Actual: " + this.audioContext.sampleRate);
	            } else this.sampleRateHz = this.audioContext.sampleRate;

	            return n = this.audioContext.createMediaStreamSource(this.stream), this.analyser = this.audioContext.createAnalyser(), this.analyser.fftSize = 2 * this.fftSize, this.analyser.smoothingTimeConstant = this.smoothingTimeConstant, n.connect(this.analyser), this.freqData = new Float32Array(this.fftSize), this.timeData = new Float32Array(this.fftSize), [2];
	        }
	      });
	    });
	  }, e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t, e, r, n, i;
	      return __generator$2(this, function (o) {
	        switch (o.label) {
	          case 0:
	            return this.isClosed ? [2, {
	              value: null,
	              done: !0
	            }] : [4, this.getAudioData()];

	          case 1:
	            return r = o.sent(), this.includeSpectrogram && (n = this.flattenQueue(r.freqDataQueue), t = this.getTensorFromAudioDataArray(n, [this.numFrames, this.columnTruncateLength, 1])), this.includeWaveform && (i = this.flattenQueue(r.timeDataQueue), e = this.getTensorFromAudioDataArray(i, [this.numFrames * this.fftSize, 1])), [2, {
	              value: {
	                spectrogram: t,
	                waveform: e
	              },
	              done: !1
	            }];
	        }
	      });
	    });
	  }, e.prototype.capture = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (t) {
	        switch (t.label) {
	          case 0:
	            return [4, this.next()];

	          case 1:
	            return [2, t.sent().value];
	        }
	      });
	    });
	  }, e.prototype.getAudioData = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t,
	          e,
	          r,
	          n = this;
	      return __generator$2(this, function (i) {
	        return t = [], e = [], r = 0, [2, new Promise(function (i) {
	          var o = setInterval(function () {
	            n.includeSpectrogram && (n.analyser.getFloatFrequencyData(n.freqData), n.freqData[0] === -1 / 0 && i({
	              freqDataQueue: t,
	              timeDataQueue: e
	            }), t.push(n.freqData.slice(0, n.columnTruncateLength))), n.includeWaveform && (n.analyser.getFloatTimeDomainData(n.timeData), e.push(n.timeData.slice())), ++r === n.numFrames && (clearInterval(o), i({
	              freqDataQueue: t,
	              timeDataQueue: e
	            }));
	          }, n.fftSize / n.sampleRateHz * 1e3);
	        })];
	      });
	    });
	  }, e.prototype.stop = function () {
	    this.isClosed = !0, this.analyser.disconnect(), this.audioContext.close(), null != this.stream && this.stream.getTracks().length > 0 && this.stream.getTracks()[0].stop();
	  }, e.prototype.toArray = function () {
	    throw new Error("Can not convert infinite audio stream to array.");
	  }, e.prototype.getSampleRate = function () {
	    return this.sampleRateHz;
	  }, e.prototype.flattenQueue = function (t) {
	    var e = t[0].length,
	        r = new Float32Array(t.length * e);
	    return t.forEach(function (t, n) {
	      return r.set(t, n * e);
	    }), r;
	  }, e.prototype.getTensorFromAudioDataArray = function (t, e) {
	    var r = new Float32Array(Q.sizeFromShape(e));
	    return r.set(t, r.length - t.length), bn(r, e);
	  }, e;
	}(LazyIterator),
	    WebcamIterator = function (t) {
	  function e(e, r) {
	    var n = t.call(this) || this;
	    if (n.webcamVideoElement = e, n.webcamConfig = r, n.isClosed = !0, n.resize = !1, n.needToResize()) if (n.resize = !0, n.cropSize = [n.webcamConfig.resizeHeight, n.webcamConfig.resizeWidth], n.cropBoxInd = En([0], "int32"), n.webcamConfig.centerCrop) {
	      var i = 1 * n.webcamConfig.resizeWidth / n.webcamVideoElement.width,
	          o = 1 * n.webcamConfig.resizeHeight / n.webcamVideoElement.height,
	          a = (1 - i) / 2,
	          s = (1 - o) / 2,
	          u = a + i,
	          c = o + s;
	      n.cropBox = Rn([s, a, c, u], [1, 4]);
	    } else n.cropBox = Rn([0, 0, 1, 1], [1, 4]);
	    return n;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return "webcam";
	  }, e.create = function (t, r) {
	    return void 0 === r && (r = {}), __awaiter$2(this, void 0, void 0, function () {
	      var n;
	      return __generator$2(this, function (i$1) {
	        switch (i$1.label) {
	          case 0:
	            if (i.get("IS_NODE")) throw new Error("tf.data.webcam is only supported in browser environment.");

	            if (!t) {
	              if (t = document.createElement("video"), !r.resizeWidth || !r.resizeHeight) throw new Error("Please provide webcam video element, or resizeWidth and resizeHeight to create a hidden video element.");
	              t.width = r.resizeWidth, t.height = r.resizeHeight;
	            }

	            return [4, (n = new e(t, r)).start()];

	          case 1:
	            return i$1.sent(), [2, n];
	        }
	      });
	    });
	  }, e.prototype.start = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t,
	          e,
	          r = this;
	      return __generator$2(this, function (n) {
	        switch (n.label) {
	          case 0:
	            this.webcamConfig.facingMode && Q.assert("user" === this.webcamConfig.facingMode || "environment" === this.webcamConfig.facingMode, function () {
	              return "Invalid webcam facing mode: " + r.webcamConfig.facingMode + ". Please provide 'user' or 'environment'";
	            }), n.label = 1;

	          case 1:
	            return n.trys.push([1, 3,, 4]), t = this, [4, navigator.mediaDevices.getUserMedia({
	              video: {
	                deviceId: this.webcamConfig.deviceId,
	                facingMode: this.webcamConfig.facingMode ? this.webcamConfig.facingMode : "user",
	                width: this.webcamVideoElement.width,
	                height: this.webcamVideoElement.height
	              }
	            })];

	          case 2:
	            return t.stream = n.sent(), [3, 4];

	          case 3:
	            throw (e = n.sent()).message = "Error thrown while initializing video stream: " + e.message, e;

	          case 4:
	            if (!this.stream) throw new Error("Could not obtain video from webcam.");

	            try {
	              this.webcamVideoElement.srcObject = this.stream;
	            } catch (t) {
	              console.log(t), this.webcamVideoElement.src = window.URL.createObjectURL(this.stream);
	            }

	            return this.webcamVideoElement.play(), this.isClosed = !1, [2, new Promise(function (t) {
	              r.webcamVideoElement.onloadedmetadata = function () {
	                t();
	              };
	            })];
	        }
	      });
	    });
	  }, e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t;
	      return __generator$2(this, function (e) {
	        if (this.isClosed) return [2, {
	          value: null,
	          done: !0
	        }];

	        try {
	          t = Oh.fromPixels(this.webcamVideoElement);
	        } catch (t) {
	          throw new Error("Error thrown converting video to pixels: " + JSON.stringify(t));
	        }

	        if (!this.resize) return [2, {
	          value: t,
	          done: !1
	        }];

	        try {
	          return [2, {
	            value: this.cropAndResizeFrame(t),
	            done: !1
	          }];
	        } catch (t) {
	          throw new Error("Error thrown cropping the video: " + t.message);
	        } finally {
	          t.dispose();
	        }

	        return [2];
	      });
	    });
	  }, e.prototype.needToResize = function () {
	    return !(!this.webcamConfig.resizeWidth || !this.webcamConfig.resizeHeight || this.webcamVideoElement.width === this.webcamConfig.resizeWidth && this.webcamVideoElement.height === this.webcamConfig.resizeHeight);
	  }, e.prototype.cropAndResizeFrame = function (t) {
	    var e = this;
	    return ze(function () {
	      var r,
	          n = t.toFloat().expandDims(0),
	          i = (r = Rc.cropAndResize(n, e.cropBox, e.cropBoxInd, e.cropSize, "bilinear")).shape;
	      return r.reshape(i.slice(1));
	    });
	  }, e.prototype.capture = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (t) {
	        switch (t.label) {
	          case 0:
	            return [4, this.next()];

	          case 1:
	            return [2, t.sent().value];
	        }
	      });
	    });
	  }, e.prototype.stop = function () {
	    this.stream.getTracks().forEach(function (t) {
	      return t.stop();
	    });

	    try {
	      this.webcamVideoElement.srcObject = null;
	    } catch (t) {
	      console.log(t), this.webcamVideoElement.src = null;
	    }

	    this.isClosed = !0;
	  }, e.prototype.toArray = function () {
	    throw new Error("Can not convert infinite video stream to array.");
	  }, e;
	}(LazyIterator),
	    DataSource = function () {
	  return function () {};
	}(),
	    StringIterator = function (t) {
	  function e() {
	    return null !== t && t.apply(this, arguments) || this;
	  }

	  return __extends$1(e, t), e.prototype.split = function (t) {
	    return new SplitIterator(this, t);
	  }, e;
	}(LazyIterator),
	    SplitIterator = function (t) {
	  function e(e, r) {
	    var n = t.call(this) || this;
	    return n.upstream = e, n.impl = new SplitIteratorImpl(e, r), n;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return this.impl.summary();
	  }, e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (t) {
	        return [2, this.impl.next()];
	      });
	    });
	  }, e;
	}(StringIterator),
	    SplitIteratorImpl = function (t) {
	  function e(e, r) {
	    var n = t.call(this) || this;
	    return n.upstream = e, n.separator = r, n.carryover = "", n;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return this.upstream.summary() + " -> Split('" + this.separator + "')";
	  }, e.prototype.pump = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t, e, r, n, i;
	      return __generator$2(this, function (o) {
	        switch (o.label) {
	          case 0:
	            return [4, this.upstream.next()];

	          case 1:
	            if ((t = o.sent()).done) return "" === this.carryover ? [2, !1] : (this.outputQueue.push(this.carryover), this.carryover = "", [2, !0]);

	            for ((e = t.value.split(this.separator))[0] = this.carryover + e[0], r = 0, n = e.slice(0, -1); r < n.length; r++) {
	              i = n[r], this.outputQueue.push(i);
	            }

	            return this.carryover = e[e.length - 1], [2, !0];
	        }
	      });
	    });
	  }, e;
	}(OneToManyIterator),
	    ByteChunkIterator = function (t) {
	  function e() {
	    return null !== t && t.apply(this, arguments) || this;
	  }

	  return __extends$1(e, t), e.prototype.decodeUTF8 = function () {
	    return new Utf8Iterator(this);
	  }, e;
	}(LazyIterator),
	    Utf8Iterator = function (t) {
	  function e(e) {
	    var r = t.call(this) || this;
	    return r.upstream = e, r.impl = new Utf8IteratorImpl(e), r;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return this.impl.summary();
	  }, e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (t) {
	        return [2, this.impl.next()];
	      });
	    });
	  }, e;
	}(StringIterator),
	    Utf8IteratorImpl = function (t) {
	  function e(e) {
	    var r = t.call(this) || this;
	    if (r.upstream = e, i.get("IS_BROWSER")) r.decoder = new TextDecoder("utf-8");else {
	      var n = require("string_decoder").StringDecoder;

	      r.decoder = new n("utf8");
	    }
	    return r;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return this.upstream.summary() + " -> Utf8";
	  }, e.prototype.pump = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t, e, r;
	      return __generator$2(this, function (n) {
	        switch (n.label) {
	          case 0:
	            return [4, this.upstream.next()];

	          case 1:
	            return (t = n.sent()).done ? [2, !1] : (e = t.value, r = i.get("IS_BROWSER") ? this.decoder.decode(e, {
	              stream: !0
	            }) : this.decoder.write(Buffer.from(e.buffer)), this.outputQueue.push(r), [2, !0]);
	        }
	      });
	    });
	  }, e;
	}(OneToManyIterator),
	    FileChunkIterator = function (t) {
	  function e(e, r) {
	    void 0 === r && (r = {});
	    var n = t.call(this) || this;
	    return n.file = e, n.options = r, Q.assert(e instanceof Uint8Array || !!i.get("IS_BROWSER") && (e instanceof File || e instanceof Blob), function () {
	      return "FileChunkIterator only supports File, Blob and Uint8Array right now.";
	    }), n.offset = r.offset || 0, n.chunkSize = r.chunkSize || 1048576, n;
	  }

	  return __extends$1(e, t), e.prototype.summary = function () {
	    return "FileChunks " + this.file;
	  }, e.prototype.next = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t,
	          e,
	          r = this;
	      return __generator$2(this, function (n) {
	        switch (n.label) {
	          case 0:
	            return this.offset >= (this.file instanceof Uint8Array ? this.file.byteLength : this.file.size) ? [2, {
	              value: null,
	              done: !0
	            }] : (t = new Promise(function (t, e) {
	              var n = r.offset + r.chunkSize;
	              if (r.file instanceof Uint8Array) t(new Uint8Array(r.file.slice(r.offset, n)));else {
	                var i = new FileReader();
	                i.onload = function (r) {
	                  var n = i.result;
	                  if (n instanceof ArrayBuffer && (n = new Uint8Array(n)), !(n instanceof Uint8Array)) return e(new TypeError("FileReader returned unknown type."));
	                  t(n);
	                }, i.onabort = function (t) {
	                  return e(new Error("Aborted"));
	                }, i.onerror = function (t) {
	                  return e(new Error(t.type));
	                };
	                var o = r.file.slice(r.offset, n);
	                i.readAsArrayBuffer(o);
	              }
	              r.offset = n;
	            }), e = {}, [4, t]);

	          case 1:
	            return [2, (e.value = n.sent(), e.done = !1, e)];
	        }
	      });
	    });
	  }, e;
	}(ByteChunkIterator);

	function urlChunkIterator(t, e) {
	  return void 0 === e && (e = {}), __awaiter$2(this, void 0, void 0, function () {
	    var r, n, i, o, a;
	    return __generator$2(this, function (s) {
	      switch (s.label) {
	        case 0:
	          return "string" == typeof t ? r = t : (r = t.url, n = getRequestInitFromRequest(t)), [4, Q.fetch(r, n)];

	        case 1:
	          return (i = s.sent()).ok ? (a = Uint8Array.bind, [4, i.arrayBuffer()]) : [3, 3];

	        case 2:
	          return o = new (a.apply(Uint8Array, [void 0, s.sent()]))(), [2, new FileChunkIterator(o, e)];

	        case 3:
	          throw new Error(i.statusText);
	      }
	    });
	  });
	}

	var getRequestInitFromRequest = function getRequestInitFromRequest(t) {
	  return {
	    method: t.method,
	    headers: t.headers,
	    body: t.body,
	    mode: t.mode,
	    credentials: t.credentials,
	    cache: t.cache,
	    redirect: t.redirect,
	    referrer: t.referrer,
	    integrity: t.integrity
	  };
	};

	function isLocalPath(t) {
	  return "string" == typeof t && "file://" === t.substr(0, 7);
	}

	var FileDataSource = function (t) {
	  function e(e, r) {
	    void 0 === r && (r = {});
	    var n = t.call(this) || this;
	    return n.input = e, n.options = r, n;
	  }

	  return __extends$1(e, t), e.prototype.iterator = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      var t;
	      return __generator$2(this, function (e) {
	        return isLocalPath(this.input) && i.get("IS_NODE") && (t = require("fs"), this.input = t.readFileSync(this.input.substr(7))), [2, new FileChunkIterator(this.input, this.options)];
	      });
	    });
	  }, e;
	}(DataSource),
	    URLDataSource = function (t) {
	  function e(e, r) {
	    void 0 === r && (r = {});
	    var n = t.call(this) || this;
	    return n.url = e, n.fileOptions = r, n;
	  }

	  return __extends$1(e, t), e.prototype.iterator = function () {
	    return __awaiter$2(this, void 0, void 0, function () {
	      return __generator$2(this, function (t) {
	        return isLocalPath(this.url) ? [2, new FileDataSource(this.url, this.fileOptions).iterator()] : [2, urlChunkIterator(this.url, this.fileOptions)];
	      });
	    });
	  }, e;
	}(DataSource);

	function csv(t, e) {
	  return void 0 === e && (e = {}), new CSVDataset(new URLDataSource(t), e);
	}

	function func(t) {
	  var e = this,
	      r = iteratorFromFunction(t);
	  return datasetFromIteratorFn(function () {
	    return __awaiter$2(e, void 0, void 0, function () {
	      return __generator$2(this, function (t) {
	        return [2, r];
	      });
	    });
	  });
	}

	function generator(t) {
	  var e = this;
	  return datasetFromIteratorFn(function () {
	    return __awaiter$2(e, void 0, void 0, function () {
	      var e;
	      return __generator$2(this, function (r) {
	        switch (r.label) {
	          case 0:
	            return [4, t()];

	          case 1:
	            return e = r.sent(), [2, iteratorFromFunction(function () {
	              return e.next();
	            })];
	        }
	      });
	    });
	  });
	}

	function webcam(t, e) {
	  return __awaiter$2(this, void 0, void 0, function () {
	    return __generator$2(this, function (r) {
	      return [2, WebcamIterator.create(t, e)];
	    });
	  });
	}

	function microphone(t) {
	  return __awaiter$2(this, void 0, void 0, function () {
	    return __generator$2(this, function (e) {
	      return [2, MicrophoneIterator.create(t)];
	    });
	  });
	}

	var version$3 = "1.2.7";

	var tfData_esm = /*#__PURE__*/Object.freeze({
		array: array,
		Dataset: Dataset,
		zip: zip,
		CSVDataset: CSVDataset,
		TextLineDataset: TextLineDataset,
		csv: csv,
		func: func,
		generator: generator,
		microphone: microphone,
		webcam: webcam,
		FileDataSource: FileDataSource,
		URLDataSource: URLDataSource,
		version_data: version$3
	});

	// @tensorflow/tfjs Copyright 2019 Google
	var version$4 = "1.2.7",
	    version$1$1 = {
	  "tfjs-core": Hh,
	  "tfjs-data": version$3,
	  "tfjs-layers": version$1,
	  "tfjs-converter": version$2,
	  tfjs: version$4
	};

	var tf$1 = /*#__PURE__*/Object.freeze({
		data: tfData_esm,
		version: version$1$1,
		AdadeltaOptimizer: jh,
		AdagradOptimizer: Kh,
		AdamOptimizer: Xh,
		AdamaxOptimizer: Yh,
		DataStorage: Yr,
		get ENV () { return i; },
		Environment: o,
		KernelBackend: Qr,
		MomentumOptimizer: Jh,
		Optimizer: $h,
		RMSPropOptimizer: Zh,
		get Rank () { return pt; },
		get Reduction () { return Zl; },
		SGDOptimizer: Qh,
		Tensor: ht,
		TensorBuffer: st,
		Variable: ft,
		abs: as,
		acos: is,
		acosh: ss,
		add: Zu,
		addN: tl,
		addStrict: el,
		all: Tu,
		any: Du,
		argMax: _u,
		argMin: Ou,
		asin: us,
		asinh: ls,
		atan: cs,
		atan2: nl,
		atanh: hs,
		avgPool: Cu,
		backend: Je,
		backend_util: vo,
		basicLSTMCell: Ll,
		batchNorm: Ys,
		batchNorm2d: Qs,
		batchNorm3d: Js,
		batchNorm4d: Zs,
		batchNormalization: Xs,
		batchNormalization2d: $s,
		batchNormalization3d: js,
		batchNormalization4d: Ks,
		batchToSpaceND: er,
		browser: Oh,
		buffer: Zn,
		cast: nr,
		ceil: fs,
		clipByValue: ps,
		clone: rr,
		complex: gn,
		concat: Bn,
		concat1d: Pn,
		concat2d: Ln,
		concat3d: Wn,
		concat4d: Un,
		conv1d: ru,
		conv2d: ou,
		conv2dDerFilter: iu,
		conv2dDerInput: su,
		conv2dTranspose: cu,
		conv3d: au,
		cos: ds,
		cosh: vs,
		cumsum: or,
		customGrad: $r,
		deprecationWarn: Pe,
		depthToSpace: ar,
		depthwiseConv2d: uu,
		disableDeprecationWarnings: Be,
		dispose: Ve,
		disposeVariables: Le,
		div: rl,
		divStrict: ol,
		dot: fu,
		dropout: Ql,
		elu: Sl,
		enableDebugMode: Me,
		enableProdMode: Fe,
		environment: u,
		equal: zu,
		equalStrict: Vu,
		erf: ms,
		exp: gs,
		expandDims: ir,
		expm1: ys,
		eye: sr,
		fft: Hl,
		fill: Dn,
		findBackend: Xe,
		findBackendFactory: Ye,
		floor: xs,
		floorDiv: al,
		frame: nc,
		fused: Nc,
		gather: Bl,
		gatherND: Yl,
		getBackend: je,
		grad: zr,
		grads: Vr,
		greater: Gu,
		greaterEqual: Hu,
		greaterEqualStrict: qu,
		greaterStrict: $u,
		hammingWindow: ec,
		hannWindow: tc,
		ifft: ql,
		imag: xn,
		image: Rc,
		io: Ah,
		irfft: jl,
		isFinite: Ds,
		isInf: Ts,
		isNaN: As,
		keep: Ge,
		leakyRelu: Nl,
		less: ju,
		lessEqual: Ku,
		lessEqualStrict: Xu,
		lessStrict: Yu,
		linalg: gc,
		linspace: _n,
		localResponseNormalization: _l,
		log: bs,
		log1p: ws,
		logSigmoid: Cs,
		logSoftmax: Xr,
		logSumExp: Fu,
		logicalAnd: bl,
		logicalNot: wl,
		logicalOr: Cl,
		logicalXor: El,
		losses: pc,
		matMul: hu,
		math: Dh,
		max: Mu,
		maxPool: wu,
		maximum: il,
		maximumStrict: sl,
		mean: Bu,
		memory: We,
		min: Pu,
		minimum: ul,
		minimumStrict: ll,
		mod: cl,
		modStrict: hl,
		moments: Lu,
		movingAverage: Ul,
		mul: fl,
		mulStrict: pl,
		multiRNNCell: Wl,
		multinomial: ur,
		neg: Es,
		nextFrame: rf,
		norm: Ol,
		notEqual: Qu,
		notEqualStrict: Ju,
		oneHot: lr,
		ones: An,
		onesLike: Fn,
		op: mn,
		outerProduct: pu,
		pad: cr,
		pad1d: hr,
		pad2d: fr,
		pad3d: pr,
		pad4d: dr,
		pool: Eu,
		pow: dl,
		powStrict: vl,
		prelu: kl,
		print: tr,
		prod: Uu,
		profile: Ue,
		rand: vr,
		randomNormal: mr,
		randomUniform: gr,
		range: On,
		ready: $e,
		real: yn,
		reciprocal: Rs,
		registerBackend: Qe,
		relu: Al,
		removeBackend: Ke,
		reshape: yr,
		reverse: du,
		reverse1d: vu,
		reverse2d: mu,
		reverse3d: gu,
		reverse4d: yu,
		rfft: $l,
		round: Is,
		rsqrt: Ss,
		scalar: Cn,
		scatterND: Gl,
		selu: Tl,
		separableConv2d: lu,
		serialization: Ph,
		setBackend: qe,
		setPlatform: Ze,
		setdiff1dAsync: Ir,
		sigmoid: Ns,
		sign: ks,
		signal: rc,
		sin: _s,
		sinh: Os,
		slice: Ru,
		slice1d: Iu,
		slice2d: Su,
		slice3d: Nu,
		slice4d: ku,
		softmax: Kr,
		softplus: Fs,
		spaceToBatchND: xr,
		sparseToDense: Xl,
		spectral: Kl,
		split: zn,
		sqrt: Ms,
		square: Bs,
		squaredDifference: ml,
		squaredDifferenceStrict: gl,
		squeeze: br,
		stack: wr,
		step: Ps,
		stridedSlice: zl,
		sub: yl,
		subStrict: xl,
		sum: Wu,
		tan: Ls,
		tanh: Ws,
		tensor: bn,
		tensor1d: En,
		tensor2d: Rn,
		tensor3d: In,
		tensor4d: Sn,
		tensor5d: Nn,
		tensor6d: kn,
		tensor_util: St,
		test_util: Gh,
		tidy: ze,
		tile: Cr,
		time: He,
		topk: Vl,
		train: ef,
		transpose: Dl,
		truncatedNormal: Er,
		unsortedSegmentSum: Pl,
		unstack: Rr,
		util: Q,
		valueAndGrad: Gr,
		valueAndGrads: Hr,
		variable: yt,
		variableGrads: qr,
		version_core: Hh,
		webgl: qh,
		where: Rl,
		whereAsync: Il,
		zeros: Tn,
		zerosLike: Mn,
		constraints: exports_constraints,
		initializers: exports_initializers,
		layers: exports_layers,
		metrics: exports_metrics,
		models: exports_models,
		regularizers: exports_regularizers,
		CallbackList: CallbackList,
		CustomCallback: CustomCallback,
		History: History,
		Callback: Callback,
		callbacks: callbacks,
		EarlyStopping: EarlyStopping,
		InputSpec: InputSpec,
		SymbolicTensor: SymbolicTensor,
		LayersModel: LayersModel,
		input: input,
		loadLayersModel: loadLayersModel,
		model: model,
		registerCallbackConstructor: registerCallbackConstructor,
		sequential: sequential,
		RNN: RNN,
		Sequential: Sequential,
		LayerVariable: LayerVariable,
		version_layers: version$1,
		GraphModel: GraphModel,
		loadGraphModel: loadGraphModel,
		deregisterOp: deregisterOp,
		registerOp: registerOp,
		version_converter: version$2
	});

	/* fix for rollup */

	/* istanbul ignore next */
	// const tf = (tensorflow && tensorflow.default) ? tensorflow.default : tensorflow;

	/**
	 * Base class for tensorscript models
	 * @interface TensorScriptModelInterface
	 * @property {Object} settings - tensorflow model hyperparameters
	 * @property {Object} model - tensorflow model
	 * @property {Object} tf - tensorflow / tensorflow-node / tensorflow-node-gpu
	 * @property {Function} reshape - static reshape array function
	 * @property {Function} getInputShape - static TensorScriptModelInterface
	 */

	var TensorScriptModelInterface =
	/*#__PURE__*/
	function () {
	  /**
	   * @param {Object} options - tensorflow model hyperparameters
	   * @param {Object} customTF - custom, overridale tensorflow / tensorflow-node / tensorflow-node-gpu
	   * @param {{model:Object,tf:Object,}} properties - extra instance properties
	   */
	  function TensorScriptModelInterface() {
	    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	    var properties = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

	    classCallCheck(this, TensorScriptModelInterface);

	    /** @type {Object} */
	    this.settings = Object.assign({
	      verbose: 0
	    }, options);
	    /** @type {Object} */

	    this.model = properties.model;
	    /** @type {Object} */

	    this.tf = properties.tf || tf$1;
	    /** @type {Boolean} */

	    this.trained = false;
	    /** @type {Function} */

	    this.reshape = TensorScriptModelInterface.reshape;
	    /** @type {Function} */

	    this.getInputShape = TensorScriptModelInterface.getInputShape;
	    return this;
	  }
	  /**
	   * Reshapes an array
	   * @function
	   * @example 
	   * const array = [ 0, 1, 1, 0, ];
	   * const shape = [2,2];
	   * TensorScriptModelInterface.reshape(array,shape) // => 
	   * [
	   *   [ 0, 1, ],
	   *   [ 1, 0, ],
	   * ];
	   * @param {Array<number>} array - input array 
	   * @param {Array<number>} shape - shape array 
	   * @return {Array<Array<number>>} returns a matrix with the defined shape
	   */

	  /* istanbul ignore next */


	  createClass(TensorScriptModelInterface, [{
	    key: "train",

	    /**
	     * Asynchronously trains tensorflow model, must be implemented by tensorscript class
	     * @abstract 
	     * @param {Array<Array<number>>} x_matrix - independent variables
	     * @param {Array<Array<number>>} y_matrix - dependent variables
	     * @return {Object} returns trained tensorflow model 
	     */
	    value: function train(x_matrix, y_matrix) {
	      throw new ReferenceError('train method is not implemented');
	    }
	    /**
	     * Predicts new dependent variables
	     * @abstract 
	     * @param {Array<Array<number>>|Array<number>} matrix - new test independent variables
	     * @return {{data: Promise}} returns tensorflow prediction 
	     */

	  }, {
	    key: "calculate",
	    value: function calculate(matrix) {
	      throw new ReferenceError('calculate method is not implemented');
	    }
	    /**
	     * Loads a saved tensoflow / keras model, this is an alias for 
	     * @param {Object} options - tensorflow load model options
	     * @return {Object} tensorflow model
	     * @see {@link https://www.tensorflow.org/js/guide/save_load#loading_a_tfmodel}
	     */

	  }, {
	    key: "loadModel",
	    value: function () {
	      var _loadModel = asyncToGenerator(
	      /*#__PURE__*/
	      regenerator.mark(function _callee(options) {
	        return regenerator.wrap(function _callee$(_context) {
	          while (1) {
	            switch (_context.prev = _context.next) {
	              case 0:
	                _context.next = 2;
	                return this.tf.loadLayersModel(options);

	              case 2:
	                this.model = _context.sent;
	                this.xShape = this.model.inputs[0].shape;
	                this.yShape = this.model.outputs[0].shape;
	                return _context.abrupt("return", this.model);

	              case 6:
	              case "end":
	                return _context.stop();
	            }
	          }
	        }, _callee, this);
	      }));

	      function loadModel(_x) {
	        return _loadModel.apply(this, arguments);
	      }

	      return loadModel;
	    }()
	    /**
	     * saves a tensorflow model, this is an alias for 
	     * @param {Object} options - tensorflow save model options
	     * @return {Object} tensorflow model
	     * @see {@link https://www.tensorflow.org/js/guide/save_load#save_a_tfmodel}
	     */

	  }, {
	    key: "saveModel",
	    value: function () {
	      var _saveModel = asyncToGenerator(
	      /*#__PURE__*/
	      regenerator.mark(function _callee2(options) {
	        var savedStatus;
	        return regenerator.wrap(function _callee2$(_context2) {
	          while (1) {
	            switch (_context2.prev = _context2.next) {
	              case 0:
	                _context2.next = 2;
	                return this.model.save(options);

	              case 2:
	                savedStatus = _context2.sent;
	                return _context2.abrupt("return", savedStatus);

	              case 4:
	              case "end":
	                return _context2.stop();
	            }
	          }
	        }, _callee2, this);
	      }));

	      function saveModel(_x2) {
	        return _saveModel.apply(this, arguments);
	      }

	      return saveModel;
	    }()
	    /**
	     * Returns prediction values from tensorflow model
	     * @param {Array<Array<number>>|Array<number>} input_matrix - new test independent variables 
	     * @param {Boolean} [options.json=true] - return object instead of typed array
	     * @param {Boolean} [options.probability=true] - return real values instead of integers
	     * @param {Boolean} [options.skip_matrix_check=false] - validate input is a matrix
	     * @return {Array<number>|Array<Array<number>>} predicted model values
	     */

	  }, {
	    key: "predict",
	    value: function () {
	      var _predict = asyncToGenerator(
	      /*#__PURE__*/
	      regenerator.mark(function _callee3(input_matrix) {
	        var _this = this;

	        var options,
	            x_matrix,
	            config,
	            _args3 = arguments;
	        return regenerator.wrap(function _callee3$(_context3) {
	          while (1) {
	            switch (_context3.prev = _context3.next) {
	              case 0:
	                options = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : {};

	                if (!(!input_matrix || Array.isArray(input_matrix) === false)) {
	                  _context3.next = 3;
	                  break;
	                }

	                throw new Error('invalid input matrix');

	              case 3:
	                x_matrix = Array.isArray(input_matrix[0]) || options.skip_matrix_check ? input_matrix : [input_matrix];
	                config = Object.assign({
	                  json: true,
	                  probability: true
	                }, options);
	                return _context3.abrupt("return", this.calculate(x_matrix).data().then(function (predictions) {
	                  // console.log({ predictions });
	                  if (config.json === false) {
	                    return predictions;
	                  } else {
	                    if (!_this.yShape) throw new Error('Model is missing yShape');
	                    var shape = [x_matrix.length, _this.yShape[1]];
	                    var predictionValues = options.probability === false ? Array.from(predictions).map(Math.round) : Array.from(predictions);
	                    return _this.reshape(predictionValues, shape);
	                  }
	                })["catch"](function (e) {
	                  throw e;
	                }));

	              case 6:
	              case "end":
	                return _context3.stop();
	            }
	          }
	        }, _callee3, this);
	      }));

	      function predict(_x3) {
	        return _predict.apply(this, arguments);
	      }

	      return predict;
	    }()
	  }], [{
	    key: "reshape",
	    value: function reshape(array, shape) {
	      var flatArray = flatten$2(array);

	      function product(arr) {
	        return arr.reduce(function (prev, curr) {
	          return prev * curr;
	        });
	      }

	      if (!Array.isArray(array) || !Array.isArray(shape)) {
	        throw new TypeError('Array expected');
	      }

	      if (shape.length === 0) {
	        throw new DimensionError(0, product(size(array)), '!=');
	      }

	      var newArray;
	      var totalSize = 1;
	      var rows = shape[0];

	      for (var sizeIndex = 0; sizeIndex < shape.length; sizeIndex++) {
	        totalSize *= shape[sizeIndex];
	      }

	      if (flatArray.length !== totalSize) {
	        throw new DimensionError(product(shape), product(size(array)), '!=');
	      }

	      try {
	        newArray = _reshape(flatArray, shape);
	      } catch (e) {
	        if (e instanceof DimensionError) {
	          throw new DimensionError(product(shape), product(size(array)), '!=');
	        }

	        throw e;
	      }

	      if (newArray.length !== rows) throw new SyntaxError("specified shape (".concat(shape, ") is compatible with input array or length (").concat(array.length, ")")); // console.log({ newArray ,});

	      return newArray;
	    }
	    /**
	     * Returns the shape of an input matrix
	     * @function
	     * @example 
	     * const input = [
	     *   [ 0, 1, ],
	     *   [ 1, 0, ],
	     * ];
	     * TensorScriptModelInterface.getInputShape(input) // => [2,2]
	     * @see {https://stackoverflow.com/questions/10237615/get-size-of-dimensions-in-array}
	     * @param {Array<Array<number>>} matrix - input matrix 
	     * @return {Array<number>} returns the shape of a matrix (e.g. [2,2])
	     */

	  }, {
	    key: "getInputShape",
	    value: function getInputShape() {
	      var matrix = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
	      if (Array.isArray(matrix) === false || !matrix[0] || !matrix[0].length || Array.isArray(matrix[0]) === false) throw new TypeError('input must be a matrix');
	      var dim = [];
	      var x_dimensions = matrix[0].length;
	      var vectors = matrix;
	      matrix.forEach(function (vector) {
	        if (vector.length !== x_dimensions) throw new SyntaxError('input must have the same length in each row');
	      });

	      for (;;) {
	        dim.push(vectors.length);

	        if (Array.isArray(vectors[0])) {
	          vectors = vectors[0];
	        } else {
	          break;
	        }
	      }

	      return dim;
	    }
	  }]);

	  return TensorScriptModelInterface;
	}();
	/**
	 * Calculate the size of a multi dimensional array.
	 * This function checks the size of the first entry, it does not validate
	 * whether all dimensions match. (use function `validate` for that) (from math.js)
	 * @param {Array} x
	 * @see {https://github.com/josdejong/mathjs/blob/develop/src/utils/array.js}
	 * @ignore
	 * @return {Number[]} size
	 */

	/* istanbul ignore next */

	function size(x) {
	  var s = [];

	  while (Array.isArray(x)) {
	    s.push(x.length);
	    x = x[0];
	  }

	  return s;
	}
	/**
	 * Iteratively re-shape a multi dimensional array to fit the specified dimensions (from math.js)
	 * @param {Array} array           Array to be reshaped
	 * @param {Array.<number>} sizes  List of sizes for each dimension
	 * @returns {Array}               Array whose data has been formatted to fit the
	 *                                specified dimensions
	 * @ignore
	 * @see {https://github.com/josdejong/mathjs/blob/develop/src/utils/array.js}
	 */

	/* istanbul ignore next */

	function _reshape(array, sizes) {
	  // testing if there are enough elements for the requested shape
	  var tmpArray = array;
	  var tmpArray2; // for each dimensions starting by the last one and ignoring the first one

	  for (var sizeIndex = sizes.length - 1; sizeIndex > 0; sizeIndex--) {
	    var size = sizes[sizeIndex];
	    tmpArray2 = []; // aggregate the elements of the current tmpArray in elements of the requested size

	    var length = tmpArray.length / size;

	    for (var i = 0; i < length; i++) {
	      tmpArray2.push(tmpArray.slice(i * size, (i + 1) * size));
	    } // set it as the new tmpArray for the next loop turn or for return


	    tmpArray = tmpArray2;
	  }

	  return tmpArray;
	}
	/**
	 * Create a range error with the message:
	 *     'Dimension mismatch (<actual size> != <expected size>)' (from math.js)
	 * @param {number | number[]} actual        The actual size
	 * @param {number | number[]} expected      The expected size
	 * @param {string} [relation='!=']          Optional relation between actual
	 *                                          and expected size: '!=', '<', etc.
	 * @extends RangeError
	 * @ignore
	 * @see {https://github.com/josdejong/mathjs/blob/develop/src/utils/array.js}
	 */

	/* istanbul ignore next */

	var DimensionError =
	/*#__PURE__*/
	function (_RangeError) {
	  inherits(DimensionError, _RangeError);

	  function DimensionError(actual, expected, relation) {
	    var _this2;

	    classCallCheck(this, DimensionError);

	    /* istanbul ignore next */
	    var message = 'Dimension mismatch (' + (Array.isArray(actual) ? '[' + actual.join(', ') + ']' : actual) + ' ' + '!=' + ' ' + (Array.isArray(expected) ? '[' + expected.join(', ') + ']' : expected) + ')';
	    _this2 = possibleConstructorReturn(this, getPrototypeOf(DimensionError).call(this, message));
	    _this2.actual = actual;
	    _this2.expected = expected;
	    _this2.relation = relation; // this.stack = (new Error()).stack

	    _this2.message = message;
	    _this2.name = 'DimensionError';
	    _this2.isDimensionError = true;
	    return _this2;
	  }

	  return DimensionError;
	}(wrapNativeSuper(RangeError));
	/**
	 * Flatten a multi dimensional array, put all elements in a one dimensional
	 * array
	 * @param {Array} array   A multi dimensional array
	 * @ignore
	 * @see {https://github.com/josdejong/mathjs/blob/develop/src/utils/array.js}
	 * @return {Array}        The flattened array (1 dimensional)
	 */

	/* istanbul ignore next */

	function flatten$2(array) {
	  /* istanbul ignore next */
	  if (!Array.isArray(array)) {
	    // if not an array, return as is

	    /* istanbul ignore next */
	    return array;
	  }

	  var flat = [];
	  /* istanbul ignore next */

	  array.forEach(function callback(value) {
	    if (Array.isArray(value)) {
	      value.forEach(callback); // traverse through sub-arrays recursively
	    } else {
	      flat.push(value);
	    }
	  });
	  return flat;
	}

	/**
	 * Deep Learning with Tensorflow
	 * @class BaseNeuralNetwork
	 * @implements {TensorScriptModelInterface}
	 */

	var BaseNeuralNetwork =
	/*#__PURE__*/
	function (_TensorScriptModelInt) {
	  inherits(BaseNeuralNetwork, _TensorScriptModelInt);

	  /**
	   * @param {{layers:Array<Object>,compile:Object,fit:Object}} options - neural network configuration and tensorflow model hyperparameters
	   * @param {{model:Object,tf:Object,}} properties - extra instance properties
	   */
	  function BaseNeuralNetwork() {
	    var _this;

	    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	    var properties = arguments.length > 1 ? arguments[1] : undefined;

	    classCallCheck(this, BaseNeuralNetwork);

	    var config = Object.assign({
	      layers: [],
	      compile: {
	        loss: 'meanSquaredError',
	        optimizer: 'adam'
	      },
	      fit: {
	        epochs: 100,
	        batchSize: 5
	      }
	    }, options);
	    _this = possibleConstructorReturn(this, getPrototypeOf(BaseNeuralNetwork).call(this, config, properties));
	    return possibleConstructorReturn(_this, assertThisInitialized(_this));
	  }
	  /**
	   * Adds dense layers to tensorflow model
	   * @abstract 
	   * @param {Array<Array<number>>} x_matrix - independent variables
	   * @param {Array<Array<number>>} y_matrix - dependent variables
	   * @param {Array<Object>} layers - model dense layer parameters
	   */


	  createClass(BaseNeuralNetwork, [{
	    key: "generateLayers",
	    value: function generateLayers(x_matrix, y_matrix, layers) {
	      throw new ReferenceError('generateLayers method is not implemented');
	    }
	    /**
	     * Asynchronously trains tensorflow model
	     * @override
	     * @param {Array<Array<number>>} x_matrix - independent variables
	     * @param {Array<Array<number>>} y_matrix - dependent variables
	     * @param {Array<Object>} layers - array of model dense layer parameters
	     * @param {Array<Array<number>>} x_text - validation data independent variables
	     * @param {Array<Array<number>>} y_text - validation data dependent variables
	     * @return {Object} returns trained tensorflow model 
	     */

	  }, {
	    key: "train",
	    value: function () {
	      var _train = asyncToGenerator(
	      /*#__PURE__*/
	      regenerator.mark(function _callee(x_matrix, y_matrix, layers, x_test, y_test) {
	        var xShape, yShape, xs, ys;
	        return regenerator.wrap(function _callee$(_context) {
	          while (1) {
	            switch (_context.prev = _context.next) {
	              case 0:
	                xShape = this.getInputShape(x_matrix);
	                yShape = this.getInputShape(y_matrix);
	                xs = this.tf.tensor(x_matrix, xShape);
	                ys = this.tf.tensor(y_matrix, yShape);
	                this.xShape = xShape;
	                this.yShape = yShape;

	                if (this.trained === false) {
	                  this.model = this.tf.sequential();
	                  this.generateLayers.call(this, x_matrix, y_matrix, layers || this.layers, x_test, y_test);
	                  this.model.compile(this.settings.compile);
	                }

	                _context.next = 9;
	                return this.model.fit(xs, ys, this.settings.fit);

	              case 9:
	                xs.dispose();
	                ys.dispose();
	                return _context.abrupt("return", this.model);

	              case 12:
	              case "end":
	                return _context.stop();
	            }
	          }
	        }, _callee, this);
	      }));

	      function train(_x, _x2, _x3, _x4, _x5) {
	        return _train.apply(this, arguments);
	      }

	      return train;
	    }()
	    /**
	     * Predicts new dependent variables
	     * @override
	     * @param {Array<Array<number>>|Array<number>} matrix - new test independent variables
	     * @param {Object} options - model prediction options
	     * @return {{data: Promise}} returns tensorflow prediction 
	     */

	  }, {
	    key: "calculate",
	    value: function calculate(input_matrix, options) {
	      if (!input_matrix || Array.isArray(input_matrix) === false) throw new Error('invalid input matrix');
	      var predictionInput = Array.isArray(input_matrix[0]) ? input_matrix : [input_matrix];
	      var predictionTensor = this.tf.tensor(predictionInput);
	      var prediction = this.model.predict(predictionTensor, options);
	      predictionTensor.dispose();
	      return prediction;
	    }
	  }]);

	  return BaseNeuralNetwork;
	}(TensorScriptModelInterface);

	function _arrayWithoutHoles(arr) {
	  if (Array.isArray(arr)) {
	    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
	      arr2[i] = arr[i];
	    }

	    return arr2;
	  }
	}

	var arrayWithoutHoles = _arrayWithoutHoles;

	function _iterableToArray(iter) {
	  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
	}

	var iterableToArray = _iterableToArray;

	function _nonIterableSpread() {
	  throw new TypeError("Invalid attempt to spread non-iterable instance");
	}

	var nonIterableSpread = _nonIterableSpread;

	function _toConsumableArray(arr) {
	  return arrayWithoutHoles(arr) || iterableToArray(arr) || nonIterableSpread();
	}

	var toConsumableArray = _toConsumableArray;

	/**
	 * Deep Learning Regression with Tensorflow
	 * @class DeepLearningRegression
	 * @implements {BaseNeuralNetwork}
	 */

	var DeepLearningRegression =
	/*#__PURE__*/
	function (_BaseNeuralNetwork) {
	  inherits(DeepLearningRegression, _BaseNeuralNetwork);

	  /**
	   * @param {{layers:Array<Object>,compile:Object,fit:Object,layerPreference:String}} options - neural network configuration and tensorflow model hyperparameters
	   * @param {{model:Object,tf:Object,}} properties - extra instance properties
	   */
	  function DeepLearningRegression() {
	    var _this;

	    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	    var properties = arguments.length > 1 ? arguments[1] : undefined;

	    classCallCheck(this, DeepLearningRegression);

	    var config = Object.assign({
	      layers: [],
	      layerPreference: 'deep',
	      compile: {
	        loss: 'meanSquaredError',
	        optimizer: 'adam'
	      },
	      fit: {
	        epochs: 100,
	        batchSize: 5
	      }
	    }, options);
	    _this = possibleConstructorReturn(this, getPrototypeOf(DeepLearningRegression).call(this, config, properties));
	    return possibleConstructorReturn(_this, assertThisInitialized(_this));
	  }
	  /**
	   * Adds dense layers to tensorflow regression model
	   * @override 
	   * @param {Array<Array<number>>} x_matrix - independent variables
	   * @param {Array<Array<number>>} y_matrix - dependent variables
	   * @param {Array<Object>} layers - model dense layer parameters
	   */


	  createClass(DeepLearningRegression, [{
	    key: "generateLayers",
	    value: function generateLayers(x_matrix, y_matrix, layers) {
	      var _this2 = this;

	      var xShape = this.getInputShape(x_matrix);
	      var yShape = this.getInputShape(y_matrix);
	      var denseLayers = [];

	      if (layers) {
	        denseLayers.push.apply(denseLayers, toConsumableArray(layers));
	      } else if (this.settings.layerPreference === 'deep') {
	        denseLayers.push({
	          units: xShape[1],
	          inputShape: [xShape[1]],
	          kernelInitializer: 'randomNormal',
	          activation: 'relu'
	        });
	        denseLayers.push({
	          units: parseInt(Math.ceil(xShape[1] / 2), 10),
	          kernelInitializer: 'randomNormal',
	          activation: 'relu'
	        });
	        denseLayers.push({
	          units: yShape[1],
	          kernelInitializer: 'randomNormal'
	        });
	      } else {
	        denseLayers.push({
	          units: xShape[1] * 2,
	          inputShape: [xShape[1]],
	          kernelInitializer: 'randomNormal',
	          activation: 'relu'
	        });
	        denseLayers.push({
	          units: yShape[1],
	          kernelInitializer: 'randomNormal'
	        });
	      }

	      this.layers = denseLayers;
	      denseLayers.forEach(function (layer) {
	        _this2.model.add(_this2.tf.layers.dense(layer));
	      });
	    }
	  }]);

	  return DeepLearningRegression;
	}(BaseNeuralNetwork);

	/**
	 * Deep Learning Classification with Tensorflow
	 * @class DeepLearningClassification
	 * @implements {BaseNeuralNetwork}
	 */

	var DeepLearningClassification =
	/*#__PURE__*/
	function (_BaseNeuralNetwork) {
	  inherits(DeepLearningClassification, _BaseNeuralNetwork);

	  /**
	   * @param {{layers:Array<Object>,compile:Object,fit:Object}} options - neural network configuration and tensorflow model hyperparameters
	   * @param {{model:Object,tf:Object,}} properties - extra instance properties
	   */
	  function DeepLearningClassification() {
	    var _this;

	    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	    var properties = arguments.length > 1 ? arguments[1] : undefined;

	    classCallCheck(this, DeepLearningClassification);

	    var config = Object.assign({
	      layers: [],
	      compile: {
	        loss: 'categoricalCrossentropy',
	        optimizer: 'adam'
	      },
	      fit: {
	        epochs: 100,
	        batchSize: 5
	      }
	    }, options);
	    _this = possibleConstructorReturn(this, getPrototypeOf(DeepLearningClassification).call(this, config, properties));
	    return possibleConstructorReturn(_this, assertThisInitialized(_this));
	  }
	  /**
	   * Adds dense layers to tensorflow classification model
	   * @override 
	   * @param {Array<Array<number>>} x_matrix - independent variables
	   * @param {Array<Array<number>>} y_matrix - dependent variables
	   * @param {Array<Object>} layers - model dense layer parameters
	   */


	  createClass(DeepLearningClassification, [{
	    key: "generateLayers",
	    value: function generateLayers(x_matrix, y_matrix, layers) {
	      var _this2 = this;

	      var xShape = this.getInputShape(x_matrix);
	      var yShape = this.getInputShape(y_matrix);
	      this.yShape = yShape;
	      this.xShape = xShape;
	      var denseLayers = [];

	      if (layers) {
	        denseLayers.push.apply(denseLayers, toConsumableArray(layers));
	      } else {
	        denseLayers.push({
	          units: xShape[1] * 2,
	          inputDim: xShape[1],
	          activation: 'relu'
	        });
	        denseLayers.push({
	          units: yShape[1],
	          activation: 'softmax'
	        });
	      }

	      this.layers = denseLayers;
	      denseLayers.forEach(function (layer) {
	        _this2.model.add(_this2.tf.layers.dense(layer));
	      });
	    }
	  }]);

	  return DeepLearningClassification;
	}(BaseNeuralNetwork);

	/**
	 * Logistic Regression Classification with Tensorflow
	 * @class LogisticRegression
	 * @implements {BaseNeuralNetwork}
	 */

	var LogisticRegression =
	/*#__PURE__*/
	function (_BaseNeuralNetwork) {
	  inherits(LogisticRegression, _BaseNeuralNetwork);

	  /**
	   * @param {{layers:Array<Object>,compile:Object,fit:Object}} options - neural network configuration and tensorflow model hyperparameters
	   * @param {{model:Object,tf:Object,}} properties - extra instance properties
	   */
	  function LogisticRegression() {
	    var _this;

	    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	    var properties = arguments.length > 1 ? arguments[1] : undefined;

	    classCallCheck(this, LogisticRegression);

	    var config = Object.assign({
	      layers: [],
	      type: 'simple',
	      compile: {
	        loss: 'meanSquaredError',
	        optimizer: 'rmsprop'
	      },
	      fit: {
	        epochs: 100,
	        batchSize: 5
	      }
	    }, options);
	    _this = possibleConstructorReturn(this, getPrototypeOf(LogisticRegression).call(this, config, properties));
	    return possibleConstructorReturn(_this, assertThisInitialized(_this));
	  }
	  /**
	   * Adds dense layers to tensorflow classification model
	   * @override 
	   * @param {Array<Array<number>>} x_matrix - independent variables
	   * @param {Array<Array<number>>} y_matrix - dependent variables
	   * @param {Array<Object>} layers - model dense layer parameters
	   * @param {Array<Array<number>>} x_test - validation data independent variables
	   * @param {Array<Array<number>>} y_test - validation data dependent variables
	   */


	  createClass(LogisticRegression, [{
	    key: "generateLayers",
	    value: function generateLayers(x_matrix, y_matrix, layers, x_test, y_test) {
	      var _this2 = this;

	      var xShape = this.getInputShape(x_matrix);
	      var yShape = this.getInputShape(y_matrix);
	      this.yShape = yShape;
	      this.xShape = xShape;
	      var denseLayers = [];

	      if (layers) {
	        denseLayers.push.apply(denseLayers, toConsumableArray(layers));
	      } else if (this.settings.type === 'class') {
	        denseLayers.push({
	          units: 1,
	          inputDim: xShape[1],
	          activation: 'sigmoid'
	        });
	        this.settings.compile.loss = 'binaryCrossentropy';
	      } else if (this.settings.type === 'l1l2') {
	        var kernelRegularizer = this.tf.regularizers.l1l2({
	          l1: 0.01,
	          l2: 0.01
	        });
	        denseLayers.push({
	          units: 1,
	          inputDim: xShape[1],
	          activation: 'sigmoid',
	          kernelRegularizer: kernelRegularizer
	        });
	        this.settings.compile.loss = 'binaryCrossentropy';
	      } else {
	        denseLayers.push({
	          units: 1,
	          inputShape: [xShape[1]]
	        });
	      }

	      this.layers = denseLayers;
	      denseLayers.forEach(function (layer) {
	        _this2.model.add(_this2.tf.layers.dense(layer));
	      });
	      /* istanbul ignore next */

	      if (x_test && y_test) {
	        this.settings.fit.validationData = [x_test, y_test];
	      }
	    }
	  }]);

	  return LogisticRegression;
	}(BaseNeuralNetwork);

	/**
	 * Mulitple Linear Regression with Tensorflow
	 * @class MultipleLinearRegression
	 * @implements {BaseNeuralNetwork}
	 */

	var MultipleLinearRegression =
	/*#__PURE__*/
	function (_BaseNeuralNetwork) {
	  inherits(MultipleLinearRegression, _BaseNeuralNetwork);

	  /**
	   * @param {{layers:Array<Object>,compile:Object,fit:Object}} options - neural network configuration and tensorflow model hyperparameters
	   * @param {{model:Object,tf:Object,}} properties - extra instance properties
	   */

	  /* istanbul ignore next */
	  function MultipleLinearRegression() {
	    var _this;

	    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	    var properties = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

	    classCallCheck(this, MultipleLinearRegression);

	    var config = Object.assign({
	      layers: [],
	      compile: {
	        loss: 'meanSquaredError',
	        optimizer: 'sgd'
	      },
	      fit: {
	        epochs: 500,
	        batchSize: 5
	      }
	    }, options);
	    _this = possibleConstructorReturn(this, getPrototypeOf(MultipleLinearRegression).call(this, config, properties));
	    return possibleConstructorReturn(_this, assertThisInitialized(_this));
	  }
	  /**
	   * Adds dense layers to tensorflow regression model
	   * @override 
	   * @param {Array<Array<number>>} x_matrix - independent variables
	   * @param {Array<Array<number>>} y_matrix - dependent variables
	   * @param {Array<Object>} layers - model dense layer parameters
	   */


	  createClass(MultipleLinearRegression, [{
	    key: "generateLayers",
	    value: function generateLayers(x_matrix, y_matrix, layers) {
	      var _this2 = this;

	      var xShape = this.getInputShape(x_matrix);
	      var yShape = this.getInputShape(y_matrix);
	      var denseLayers = [];

	      if (layers) {
	        denseLayers.push.apply(denseLayers, toConsumableArray(layers));
	      } else {
	        denseLayers.push({
	          units: yShape[1],
	          inputShape: [xShape[1]]
	        });
	      }

	      this.layers = denseLayers;
	      denseLayers.forEach(function (layer) {
	        _this2.model.add(_this2.tf.layers.dense(layer));
	      });
	    }
	  }]);

	  return MultipleLinearRegression;
	}(BaseNeuralNetwork);

	function _superPropBase(object, property) {
	  while (!Object.prototype.hasOwnProperty.call(object, property)) {
	    object = getPrototypeOf(object);
	    if (object === null) break;
	  }

	  return object;
	}

	var superPropBase = _superPropBase;

	var get$2 = createCommonjsModule(function (module) {
	  function _get(target, property, receiver) {
	    if (typeof Reflect !== "undefined" && Reflect.get) {
	      module.exports = _get = Reflect.get;
	    } else {
	      module.exports = _get = function _get(target, property, receiver) {
	        var base = superPropBase(target, property);
	        if (!base) return;
	        var desc = Object.getOwnPropertyDescriptor(base, property);

	        if (desc.get) {
	          return desc.get.call(receiver);
	        }

	        return desc.value;
	      };
	    }

	    return _get(target, property, receiver || target);
	  }

	  module.exports = _get;
	});

	/**
	 * lodash (Custom Build) <https://lodash.com/>
	 * Build: `lodash modularize exports="npm" -o ./`
	 * Copyright jQuery Foundation and other contributors <https://jquery.org/>
	 * Released under MIT license <https://lodash.com/license>
	 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
	 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
	 */

	/** Used as references for various `Number` constants. */
	var INFINITY = 1 / 0,
	    MAX_SAFE_INTEGER = 9007199254740991,
	    MAX_INTEGER = 1.7976931348623157e+308,
	    NAN = 0 / 0;
	/** `Object#toString` result references. */

	var funcTag = '[object Function]',
	    genTag = '[object GeneratorFunction]',
	    symbolTag = '[object Symbol]';
	/** Used to match leading and trailing whitespace. */

	var reTrim = /^\s+|\s+$/g;
	/** Used to detect bad signed hexadecimal string values. */

	var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
	/** Used to detect binary string values. */

	var reIsBinary = /^0b[01]+$/i;
	/** Used to detect octal string values. */

	var reIsOctal = /^0o[0-7]+$/i;
	/** Used to detect unsigned integer values. */

	var reIsUint = /^(?:0|[1-9]\d*)$/;
	/** Built-in method references without a dependency on `root`. */

	var freeParseInt = parseInt;
	/** Used for built-in method references. */

	var objectProto = Object.prototype;
	/**
	 * Used to resolve the
	 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
	 * of values.
	 */

	var objectToString = objectProto.toString;
	/* Built-in method references for those with the same name as other `lodash` methods. */

	var nativeCeil = Math.ceil,
	    nativeMax = Math.max;
	/**
	 * The base implementation of `_.range` and `_.rangeRight` which doesn't
	 * coerce arguments.
	 *
	 * @private
	 * @param {number} start The start of the range.
	 * @param {number} end The end of the range.
	 * @param {number} step The value to increment or decrement by.
	 * @param {boolean} [fromRight] Specify iterating from right to left.
	 * @returns {Array} Returns the range of numbers.
	 */

	function baseRange(start, end, step, fromRight) {
	  var index = -1,
	      length = nativeMax(nativeCeil((end - start) / (step || 1)), 0),
	      result = Array(length);

	  while (length--) {
	    result[fromRight ? length : ++index] = start;
	    start += step;
	  }

	  return result;
	}
	/**
	 * Creates a `_.range` or `_.rangeRight` function.
	 *
	 * @private
	 * @param {boolean} [fromRight] Specify iterating from right to left.
	 * @returns {Function} Returns the new range function.
	 */


	function createRange(fromRight) {
	  return function (start, end, step) {
	    if (step && typeof step != 'number' && isIterateeCall(start, end, step)) {
	      end = step = undefined;
	    } // Ensure the sign of `-0` is preserved.


	    start = toFinite(start);

	    if (end === undefined) {
	      end = start;
	      start = 0;
	    } else {
	      end = toFinite(end);
	    }

	    step = step === undefined ? start < end ? 1 : -1 : toFinite(step);
	    return baseRange(start, end, step, fromRight);
	  };
	}
	/**
	 * Checks if `value` is a valid array-like index.
	 *
	 * @private
	 * @param {*} value The value to check.
	 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
	 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
	 */


	function isIndex(value, length) {
	  length = length == null ? MAX_SAFE_INTEGER : length;
	  return !!length && (typeof value == 'number' || reIsUint.test(value)) && value > -1 && value % 1 == 0 && value < length;
	}
	/**
	 * Checks if the given arguments are from an iteratee call.
	 *
	 * @private
	 * @param {*} value The potential iteratee value argument.
	 * @param {*} index The potential iteratee index or key argument.
	 * @param {*} object The potential iteratee object argument.
	 * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
	 *  else `false`.
	 */


	function isIterateeCall(value, index, object) {
	  if (!isObject(object)) {
	    return false;
	  }

	  var type = _typeof_1(index);

	  if (type == 'number' ? isArrayLike(object) && isIndex(index, object.length) : type == 'string' && index in object) {
	    return eq(object[index], value);
	  }

	  return false;
	}
	/**
	 * Performs a
	 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
	 * comparison between two values to determine if they are equivalent.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to compare.
	 * @param {*} other The other value to compare.
	 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
	 * @example
	 *
	 * var object = { 'a': 1 };
	 * var other = { 'a': 1 };
	 *
	 * _.eq(object, object);
	 * // => true
	 *
	 * _.eq(object, other);
	 * // => false
	 *
	 * _.eq('a', 'a');
	 * // => true
	 *
	 * _.eq('a', Object('a'));
	 * // => false
	 *
	 * _.eq(NaN, NaN);
	 * // => true
	 */


	function eq(value, other) {
	  return value === other || value !== value && other !== other;
	}
	/**
	 * Checks if `value` is array-like. A value is considered array-like if it's
	 * not a function and has a `value.length` that's an integer greater than or
	 * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
	 * @example
	 *
	 * _.isArrayLike([1, 2, 3]);
	 * // => true
	 *
	 * _.isArrayLike(document.body.children);
	 * // => true
	 *
	 * _.isArrayLike('abc');
	 * // => true
	 *
	 * _.isArrayLike(_.noop);
	 * // => false
	 */


	function isArrayLike(value) {
	  return value != null && isLength(value.length) && !isFunction(value);
	}
	/**
	 * Checks if `value` is classified as a `Function` object.
	 *
	 * @static
	 * @memberOf _
	 * @since 0.1.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
	 * @example
	 *
	 * _.isFunction(_);
	 * // => true
	 *
	 * _.isFunction(/abc/);
	 * // => false
	 */


	function isFunction(value) {
	  // The use of `Object#toString` avoids issues with the `typeof` operator
	  // in Safari 8-9 which returns 'object' for typed array and other constructors.
	  var tag = isObject(value) ? objectToString.call(value) : '';
	  return tag == funcTag || tag == genTag;
	}
	/**
	 * Checks if `value` is a valid array-like length.
	 *
	 * **Note:** This method is loosely based on
	 * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
	 * @example
	 *
	 * _.isLength(3);
	 * // => true
	 *
	 * _.isLength(Number.MIN_VALUE);
	 * // => false
	 *
	 * _.isLength(Infinity);
	 * // => false
	 *
	 * _.isLength('3');
	 * // => false
	 */


	function isLength(value) {
	  return typeof value == 'number' && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
	}
	/**
	 * Checks if `value` is the
	 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
	 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
	 *
	 * @static
	 * @memberOf _
	 * @since 0.1.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
	 * @example
	 *
	 * _.isObject({});
	 * // => true
	 *
	 * _.isObject([1, 2, 3]);
	 * // => true
	 *
	 * _.isObject(_.noop);
	 * // => true
	 *
	 * _.isObject(null);
	 * // => false
	 */


	function isObject(value) {
	  var type = _typeof_1(value);

	  return !!value && (type == 'object' || type == 'function');
	}
	/**
	 * Checks if `value` is object-like. A value is object-like if it's not `null`
	 * and has a `typeof` result of "object".
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
	 * @example
	 *
	 * _.isObjectLike({});
	 * // => true
	 *
	 * _.isObjectLike([1, 2, 3]);
	 * // => true
	 *
	 * _.isObjectLike(_.noop);
	 * // => false
	 *
	 * _.isObjectLike(null);
	 * // => false
	 */


	function isObjectLike(value) {
	  return !!value && _typeof_1(value) == 'object';
	}
	/**
	 * Checks if `value` is classified as a `Symbol` primitive or object.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
	 * @example
	 *
	 * _.isSymbol(Symbol.iterator);
	 * // => true
	 *
	 * _.isSymbol('abc');
	 * // => false
	 */


	function isSymbol(value) {
	  return _typeof_1(value) == 'symbol' || isObjectLike(value) && objectToString.call(value) == symbolTag;
	}
	/**
	 * Converts `value` to a finite number.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.12.0
	 * @category Lang
	 * @param {*} value The value to convert.
	 * @returns {number} Returns the converted number.
	 * @example
	 *
	 * _.toFinite(3.2);
	 * // => 3.2
	 *
	 * _.toFinite(Number.MIN_VALUE);
	 * // => 5e-324
	 *
	 * _.toFinite(Infinity);
	 * // => 1.7976931348623157e+308
	 *
	 * _.toFinite('3.2');
	 * // => 3.2
	 */


	function toFinite(value) {
	  if (!value) {
	    return value === 0 ? value : 0;
	  }

	  value = toNumber(value);

	  if (value === INFINITY || value === -INFINITY) {
	    var sign = value < 0 ? -1 : 1;
	    return sign * MAX_INTEGER;
	  }

	  return value === value ? value : 0;
	}
	/**
	 * Converts `value` to a number.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to process.
	 * @returns {number} Returns the number.
	 * @example
	 *
	 * _.toNumber(3.2);
	 * // => 3.2
	 *
	 * _.toNumber(Number.MIN_VALUE);
	 * // => 5e-324
	 *
	 * _.toNumber(Infinity);
	 * // => Infinity
	 *
	 * _.toNumber('3.2');
	 * // => 3.2
	 */


	function toNumber(value) {
	  if (typeof value == 'number') {
	    return value;
	  }

	  if (isSymbol(value)) {
	    return NAN;
	  }

	  if (isObject(value)) {
	    var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
	    value = isObject(other) ? other + '' : other;
	  }

	  if (typeof value != 'string') {
	    return value === 0 ? value : +value;
	  }

	  value = value.replace(reTrim, '');
	  var isBinary = reIsBinary.test(value);
	  return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
	}
	/**
	 * Creates an array of numbers (positive and/or negative) progressing from
	 * `start` up to, but not including, `end`. A step of `-1` is used if a negative
	 * `start` is specified without an `end` or `step`. If `end` is not specified,
	 * it's set to `start` with `start` then set to `0`.
	 *
	 * **Note:** JavaScript follows the IEEE-754 standard for resolving
	 * floating-point values which can produce unexpected results.
	 *
	 * @static
	 * @since 0.1.0
	 * @memberOf _
	 * @category Util
	 * @param {number} [start=0] The start of the range.
	 * @param {number} end The end of the range.
	 * @param {number} [step=1] The value to increment or decrement by.
	 * @returns {Array} Returns the range of numbers.
	 * @see _.inRange, _.rangeRight
	 * @example
	 *
	 * _.range(4);
	 * // => [0, 1, 2, 3]
	 *
	 * _.range(-4);
	 * // => [0, -1, -2, -3]
	 *
	 * _.range(1, 5);
	 * // => [1, 2, 3, 4]
	 *
	 * _.range(0, 20, 5);
	 * // => [0, 5, 10, 15]
	 *
	 * _.range(0, -4, -1);
	 * // => [0, -1, -2, -3]
	 *
	 * _.range(1, 4, 0);
	 * // => [1, 1, 1]
	 *
	 * _.range(0);
	 * // => []
	 */


	var range$1 = createRange();
	var lodash_range = range$1;

	/**
	 * Long Short Term Memory Time Series with Tensorflow
	 * @class LSTMTimeSeries
	 * @implements {BaseNeuralNetwork}
	 */

	var LSTMTimeSeries =
	/*#__PURE__*/
	function (_BaseNeuralNetwork) {
	  inherits(LSTMTimeSeries, _BaseNeuralNetwork);

	  createClass(LSTMTimeSeries, null, [{
	    key: "createDataset",

	    /**
	     * Creates dataset data
	     * @example
	     * LSTMTimeSeries.createDataset([ [ 1, ], [ 2, ], [ 3, ], [ 4, ], [ 5, ], [ 6, ], [ 7, ], [ 8, ], [ 9, ], [ 10, ], ], 3) // => 
	        //  [ 
	        //    [ 
	        //      [ [ 1 ], [ 2 ], [ 3 ] ],
	        //      [ [ 2 ], [ 3 ], [ 4 ] ],
	        //      [ [ 3 ], [ 4 ], [ 5 ] ],
	        //      [ [ 4 ], [ 5 ], [ 6 ] ],
	        //      [ [ 5 ], [ 6 ], [ 7 ] ],
	        //      [ [ 6 ], [ 7 ], [ 8 ] ], 
	        //   ], //x_matrix
	        //   [ [ 4 ], [ 5 ], [ 6 ], [ 7 ], [ 8 ], [ 9 ] ] //y_matrix
	        // ]
	     * @param {Array<Array<number>} dataset - array of values
	     * @param {Number} look_back - number of values in each feature 
	     * @return {[Array<Array<number>>,Array<number>]} returns x matrix and y matrix for model trainning
	     */

	    /* istanbul ignore next */
	    value: function createDataset() {
	      var dataset = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
	      var look_back = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
	      var dataX = [];
	      var dataY = [];

	      for (var index in lodash_range(dataset.length - look_back - 1)) {
	        var i = parseInt(index);
	        var a = dataset.slice(i, i + look_back);
	        dataX.push(a);
	        dataY.push(dataset[i + look_back]);
	      }

	      return [dataX, dataY];
	    }
	    /**
	     * Reshape input to be [samples, time steps, features]
	     * @example
	     * LSTMTimeSeries.getTimeseriesShape([ 
	        [ [ 1 ], [ 2 ], [ 3 ] ],
	        [ [ 2 ], [ 3 ], [ 4 ] ],
	        [ [ 3 ], [ 4 ], [ 5 ] ],
	        [ [ 4 ], [ 5 ], [ 6 ] ],
	        [ [ 5 ], [ 6 ], [ 7 ] ],
	        [ [ 6 ], [ 7 ], [ 8 ] ], 
	      ]) //=> [6, 1, 3,]
	     * @param {Array<Array<number>} x_timeseries - dataset array of values
	     * @return {Array<Array<number>>} returns proper timeseries forecasting shape
	     */

	  }, {
	    key: "getTimeseriesShape",
	    value: function getTimeseriesShape(x_timeseries) {
	      var time_steps = this.settings.timeSteps;
	      var xShape = this.getInputShape(x_timeseries);
	      var _samples = xShape[0];
	      var _timeSteps = time_steps;
	      var _features = xShape[1];
	      var newShape = this.settings.mulitpleTimeSteps || this.settings.stateful ? [_samples, _features, _timeSteps] : [_samples, _timeSteps, _features]; // console.log({newShape})

	      return newShape;
	    }
	    /**
	     * Returns data for predicting values
	     * @param timeseries 
	     * @param look_back 
	     */

	  }, {
	    key: "getTimeseriesDataSet",
	    value: function getTimeseriesDataSet(timeseries, look_back) {
	      var lookBack = look_back || this.settings.lookBack;
	      var matrices = LSTMTimeSeries.createDataset.call(this, timeseries, lookBack);
	      var x_matrix = matrices[0];
	      var y_matrix = matrices[1]; // const timeseriesShape = LSTMTimeSeries.getTimeseriesShape.call(this,x_matrix);

	      var x_matrix_timeseries = BaseNeuralNetwork.reshape(x_matrix, [x_matrix.length, lookBack]);
	      var xShape = BaseNeuralNetwork.getInputShape(x_matrix_timeseries);
	      var yShape = BaseNeuralNetwork.getInputShape(y_matrix);
	      return {
	        yShape: yShape,
	        xShape: xShape,
	        y_matrix: y_matrix,
	        x_matrix: x_matrix_timeseries
	      };
	    }
	    /**
	     * @param {{layers:Array<Object>,compile:Object,fit:Object}} options - neural network configuration and tensorflow model hyperparameters
	     * @param {{model:Object,tf:Object,}} properties - extra instance properties
	     */

	  }]);

	  function LSTMTimeSeries() {
	    var _this;

	    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	    var properties = arguments.length > 1 ? arguments[1] : undefined;

	    classCallCheck(this, LSTMTimeSeries);

	    var config = Object.assign({
	      layers: [],
	      type: 'simple',
	      stateful: false,
	      stacked: false,
	      mulitpleTimeSteps: false,
	      lookBack: 1,
	      batchSize: 1,
	      timeSteps: 1,
	      learningRate: 0.1,
	      compile: {
	        loss: 'meanSquaredError',
	        optimizer: 'adam'
	      },
	      fit: {
	        epochs: 100,
	        batchSize: 1
	      }
	    }, options);
	    _this = possibleConstructorReturn(this, getPrototypeOf(LSTMTimeSeries).call(this, config, properties));
	    _this.createDataset = LSTMTimeSeries.createDataset;
	    _this.getTimeseriesDataSet = LSTMTimeSeries.getTimeseriesDataSet;
	    _this.getTimeseriesShape = LSTMTimeSeries.getTimeseriesShape;
	    return possibleConstructorReturn(_this, assertThisInitialized(_this));
	  }
	  /**
	   * Adds dense layers to tensorflow classification model
	   * @override 
	   * @param {Array<Array<number>>} x_matrix - independent variables
	   * @param {Array<Array<number>>} y_matrix - dependent variables
	   * @param {Array<Object>} layers - model dense layer parameters
	   * @param {Array<Array<number>>} x_test - validation data independent variables
	   * @param {Array<Array<number>>} y_test - validation data dependent variables
	   */


	  createClass(LSTMTimeSeries, [{
	    key: "generateLayers",
	    value: function generateLayers(x_matrix, y_matrix, layers) {
	      var _this2 = this;

	      var xShape = this.getInputShape(x_matrix);
	      var yShape = this.getInputShape(y_matrix);
	      this.yShape = yShape;
	      this.xShape = xShape; // const sgdoptimizer = this.tf.train.sgd(this.settings.learningRate);

	      var lstmLayers = [];
	      var rnnLayers = [];
	      var denseLayers = [];
	      /* istanbul ignore next */

	      if (layers) {
	        if (layers.lstmLayers && layers.lstmLayers.length) lstmLayers.push.apply(lstmLayers, toConsumableArray(layers.lstmLayers));
	        if (layers.rnnLayers && layers.rnnLayers.length) rnnLayers.push.apply(rnnLayers, toConsumableArray(layers.rnnLayers));
	        if (layers.denseLayers && layers.denseLayers.length) denseLayers.push.apply(denseLayers, toConsumableArray(layers.denseLayers));
	      } else if (this.settings.stateful) {
	        var batchInputShape = [this.settings.fit.batchSize, this.settings.lookBack, 1];
	        rnnLayers.push({
	          units: 4,
	          batchInputShape: batchInputShape,
	          returnSequences: true
	        });
	        rnnLayers.push({
	          units: 4,
	          batchInputShape: batchInputShape
	        });
	        denseLayers.push({
	          units: yShape[1]
	        }); // } else if(this.settings.stacked) {
	        //   lstmLayers.push({ units: 4, inputShape: [ 1, this.settings.lookBack ], });
	        //   // model.add(LSTM(4, batch_input_shape=(batch_size, look_back, 1), stateful=True, return_sequences=True))
	        //   // model.add(LSTM(4, batch_input_shape=(batch_size, look_back, 1), stateful=True))
	        //   denseLayers.push({ units: yShape[1], });
	      } else {
	        var inputShape = [1, this.settings.lookBack]; // console.log('default timeseries', { inputShape, xShape, yShape ,  });

	        lstmLayers.push({
	          units: 4,
	          inputShape: inputShape
	        });
	        denseLayers.push({
	          units: yShape[1]
	        });
	      } // console.log('lstmLayers',lstmLayers)
	      // console.log('denseLayers',denseLayers)


	      if (lstmLayers.length) {
	        lstmLayers.forEach(function (layer) {
	          _this2.model.add(_this2.tf.layers.lstm(layer));
	        });
	      }

	      if (rnnLayers.length) {
	        /* istanbul ignore next */
	        rnnLayers.forEach(function (layer) {
	          _this2.model.add(_this2.tf.layers.simpleRNN(layer));
	        });
	      }

	      if (denseLayers.length) {
	        denseLayers.forEach(function (layer) {
	          _this2.model.add(_this2.tf.layers.dense(layer));
	        });
	      }

	      this.layers = {
	        lstmLayers: lstmLayers,
	        rnnLayers: rnnLayers,
	        denseLayers: denseLayers
	      }; // this.settings.compile.optimizer = sgdoptimizer;
	    }
	  }, {
	    key: "train",
	    value: function () {
	      var _train = asyncToGenerator(
	      /*#__PURE__*/
	      regenerator.mark(function _callee(x_timeseries, y_timeseries, layers, x_test, y_test) {
	        var yShape, x_matrix, y_matrix, look_back, matrices, timeseriesShape, x_matrix_timeseries, xs, ys;
	        return regenerator.wrap(function _callee$(_context) {
	          while (1) {
	            switch (_context.prev = _context.next) {
	              case 0:
	                look_back = this.settings.lookBack;

	                if (y_timeseries) {
	                  x_matrix = x_timeseries;
	                  y_matrix = y_timeseries;
	                } else {
	                  matrices = this.createDataset(x_timeseries, look_back);
	                  x_matrix = matrices[0];
	                  y_matrix = matrices[1];
	                  yShape = this.getInputShape(y_matrix);
	                } //_samples, _timeSteps, _features


	                timeseriesShape = this.getTimeseriesShape(x_matrix);
	                x_matrix_timeseries = BaseNeuralNetwork.reshape(x_matrix, timeseriesShape);
	                xs = this.tf.tensor(x_matrix_timeseries, timeseriesShape);
	                ys = this.tf.tensor(y_matrix, yShape);
	                this.xShape = timeseriesShape;
	                this.yShape = yShape;

	                if (this.trained === false) {
	                  this.model = this.tf.sequential();
	                  this.generateLayers.call(this, x_matrix_timeseries, y_matrix, layers || this.layers, x_test, y_test);
	                  this.model.compile(this.settings.compile);

	                  if (this.settings.stateful) {
	                    this.settings.fit.shuffle = false;
	                  }
	                }

	                _context.next = 11;
	                return this.model.fit(xs, ys, this.settings.fit);

	              case 11:
	                // this.model.summary();
	                xs.dispose();
	                ys.dispose();
	                return _context.abrupt("return", this.model);

	              case 14:
	              case "end":
	                return _context.stop();
	            }
	          }
	        }, _callee, this);
	      }));

	      function train(_x, _x2, _x3, _x4, _x5) {
	        return _train.apply(this, arguments);
	      }

	      return train;
	    }()
	  }, {
	    key: "calculate",
	    value: function calculate(x_matrix) {
	      var timeseriesShape = this.getTimeseriesShape(x_matrix);
	      var input_matrix = BaseNeuralNetwork.reshape(x_matrix, timeseriesShape);
	      return get$2(getPrototypeOf(LSTMTimeSeries.prototype), "calculate", this).call(this, input_matrix);
	    }
	  }, {
	    key: "predict",
	    value: function () {
	      var _predict = asyncToGenerator(
	      /*#__PURE__*/
	      regenerator.mark(function _callee2(input_matrix, options) {
	        var _this3 = this;

	        return regenerator.wrap(function _callee2$(_context2) {
	          while (1) {
	            switch (_context2.prev = _context2.next) {
	              case 0:
	                if (!(this.settings.stateful && input_matrix.length > 1)) {
	                  _context2.next = 4;
	                  break;
	                }

	                return _context2.abrupt("return", Promise.all(input_matrix.map(function (input) {
	                  return get$2(getPrototypeOf(LSTMTimeSeries.prototype), "predict", _this3).call(_this3, [input], options);
	                })));

	              case 4:
	                return _context2.abrupt("return", get$2(getPrototypeOf(LSTMTimeSeries.prototype), "predict", this).call(this, input_matrix, options));

	              case 5:
	              case "end":
	                return _context2.stop();
	            }
	          }
	        }, _callee2, this);
	      }));

	      function predict(_x6, _x7) {
	        return _predict.apply(this, arguments);
	      }

	      return predict;
	    }()
	  }]);

	  return LSTMTimeSeries;
	}(BaseNeuralNetwork);

	/**
	 * Long Short Term Memory Multivariate Time Series with Tensorflow
	 * @class LSTMMultivariateTimeSeries
	 * @extends {LSTMTimeSeries}
	 */

	var LSTMMultivariateTimeSeries =
	/*#__PURE__*/
	function (_LSTMTimeSeries) {
	  inherits(LSTMMultivariateTimeSeries, _LSTMTimeSeries);

	  createClass(LSTMMultivariateTimeSeries, null, [{
	    key: "createDataset",

	    /**
	     * Creates dataset data
	     * @example
	     * const ds = [
	    [10, 20, 30, 40, 50, 60, 70, 80, 90,],
	    [11, 21, 31, 41, 51, 61, 71, 81, 91,],
	    [12, 22, 32, 42, 52, 62, 72, 82, 92,],
	    [13, 23, 33, 43, 53, 63, 73, 83, 93,],
	    [14, 24, 34, 44, 54, 64, 74, 84, 94,],
	    [15, 25, 35, 45, 55, 65, 75, 85, 95,],
	    [16, 26, 36, 46, 56, 66, 76, 86, 96,],
	    [17, 27, 37, 47, 57, 67, 77, 87, 97,],
	    [18, 28, 38, 48, 58, 68, 78, 88, 98,],
	    [19, 29, 39, 49, 59, 69, 79, 89, 99,],
	    ];
	     * LSTMMultivariateTimeSeries.createDataset(ds,1) // => 
	        //  [ 
	        //   [ 
	        //    [ 20, 30, 40, 50, 60, 70, 80, 90 ],
	        //    [ 21, 31, 41, 51, 61, 71, 81, 91 ],
	        //    [ 22, 32, 42, 52, 62, 72, 82, 92 ],
	        //    [ 23, 33, 43, 53, 63, 73, 83, 93 ],
	        //    [ 24, 34, 44, 54, 64, 74, 84, 94 ],
	        //    [ 25, 35, 45, 55, 65, 75, 85, 95 ],
	        //    [ 26, 36, 46, 56, 66, 76, 86, 96 ],
	        //    [ 27, 37, 47, 57, 67, 77, 87, 97 ],
	        //    [ 28, 38, 48, 58, 68, 78, 88, 98 ]    
	        //   ], //x_matrix
	        //   [ 11, 12, 13, 14, 15, 16, 17, 18, 19 ], //y_matrix
	        //   8 //features
	        // ]
	     * @param {Array<Array<number>} dataset - array of values
	     * @param {Number} look_back - number of values in each feature 
	     * @override 
	     * @return {[Array<Array<number>>,Array<number>]} returns x matrix and y matrix for model trainning
	     */

	    /* istanbul ignore next */
	    value: function createDataset() {
	      var dataset = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
	      var look_back = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
	      var features = this.settings && this.settings.features ? this.settings.features : dataset[0].length - 1;
	      var n_in = look_back || this.settings.lookback; //1; //lookbacks

	      var n_out = this.settings && this.settings.outputs ? this.settings.outputs : 1; //1;

	      var series = LSTMMultivariateTimeSeries.seriesToSupervised(dataset, n_in, n_out);
	      var dropped = LSTMMultivariateTimeSeries.getDropableColumns(features, n_in, n_out);
	      var droppedColumns = LSTMMultivariateTimeSeries.drop(series, dropped);
	      var original_dropped_c_columns = [0, droppedColumns[0].length - 1];


	      var y = pivotVector(droppedColumns)[droppedColumns[0].length - 1];
	      var x = LSTMMultivariateTimeSeries.drop(droppedColumns, original_dropped_c_columns // [ 0, droppedColumns[ 0 ].length - 1, ]
	      );
	      return [x, y, features];
	    }
	    /**
	     * Drops columns by array index
	     * @example
	    const data = [ [ 10, 20, 30, 40, 50, 60, 70, 80, 90, 11, 21, 31, 41, 51, 61, 71, 81, 91 ],
	       [ 11, 21, 31, 41, 51, 61, 71, 81, 91, 12, 22, 32, 42, 52, 62, 72, 82, 92 ],
	       [ 12, 22, 32, 42, 52, 62, 72, 82, 92, 13, 23, 33, 43, 53, 63, 73, 83, 93 ],
	       [ 13, 23, 33, 43, 53, 63, 73, 83, 93, 14, 24, 34, 44, 54, 64, 74, 84, 94 ],
	       [ 14, 24, 34, 44, 54, 64, 74, 84, 94, 15, 25, 35, 45, 55, 65, 75, 85, 95 ],
	       [ 15, 25, 35, 45, 55, 65, 75, 85, 95, 16, 26, 36, 46, 56, 66, 76, 86, 96 ],
	       [ 16, 26, 36, 46, 56, 66, 76, 86, 96, 17, 27, 37, 47, 57, 67, 77, 87, 97 ],
	       [ 17, 27, 37, 47, 57, 67, 77, 87, 97, 18, 28, 38, 48, 58, 68, 78, 88, 98 ],
	       [ 18, 28, 38, 48, 58, 68, 78, 88, 98, 19, 29, 39, 49, 59, 69, 79, 89, 99 ] ];
	    const n_in = 1; //lookbacks
	    const n_out = 1;
	    const dropColumns = getDropableColumns(8, n_in, n_out); // =>[ 10, 11, 12, 13, 14, 15, 16, 17 ]
	    const newdata = drop(data,dropColumns); //=> [ 
	      // [ 10, 20, 30, 40, 50, 60, 70, 80, 90, 11 ],
	      // [ 11, 21, 31, 41, 51, 61, 71, 81, 91, 12 ],
	      // [ 12, 22, 32, 42, 52, 62, 72, 82, 92, 13 ],
	      // [ 13, 23, 33, 43, 53, 63, 73, 83, 93, 14 ],
	      // [ 14, 24, 34, 44, 54, 64, 74, 84, 94, 15 ],
	      // [ 15, 25, 35, 45, 55, 65, 75, 85, 95, 16 ],
	      // [ 16, 26, 36, 46, 56, 66, 76, 86, 96, 17 ],
	      // [ 17, 27, 37, 47, 57, 67, 77, 87, 97, 18 ],
	      // [ 18, 28, 38, 48, 58, 68, 78, 88, 98, 19 ] 
	      //]
	    * @param {Array<Array<number>>} data - data set to drop columns 
	    * @param {Array<number>} columns - array of column indexes
	     * @returns {Array<Array<number>>} matrix with dropped columns
	     */

	  }, {
	    key: "drop",
	    value: function drop(data, columns) {
	      return data.reduce(function (cols, row, i) {
	        cols[i] = [];
	        row.forEach(function (col, idx) {
	          if (columns.indexOf(idx) === -1) {
	            cols[i].push(col);
	          }
	        });
	        return cols;
	      }, []);
	    }
	    /**
	     * Converts data set to supervised labels for forecasting, the first column must be the dependent variable
	     * @example 
	     const ds = [
	      [10, 20, 30, 40, 50, 60, 70, 80, 90,],
	      [11, 21, 31, 41, 51, 61, 71, 81, 91,],
	      [12, 22, 32, 42, 52, 62, 72, 82, 92,],
	      [13, 23, 33, 43, 53, 63, 73, 83, 93,],
	      [14, 24, 34, 44, 54, 64, 74, 84, 94,],
	      [15, 25, 35, 45, 55, 65, 75, 85, 95,],
	      [16, 26, 36, 46, 56, 66, 76, 86, 96,],
	      [17, 27, 37, 47, 57, 67, 77, 87, 97,],
	      [18, 28, 38, 48, 58, 68, 78, 88, 98,],
	      [19, 29, 39, 49, 59, 69, 79, 89, 99,],
	    ]; 
	    const n_in = 1; //lookbacks
	    const n_out = 1;
	    const series = seriesToSupervised(ds, n_in, n_out); //=> [ 
	      // [ 10, 20, 30, 40, 50, 60, 70, 80, 90, 11, 21, 31, 41, 51, 61, 71, 81, 91 ],
	      // [ 11, 21, 31, 41, 51, 61, 71, 81, 91, 12, 22, 32, 42, 52, 62, 72, 82, 92 ],
	      // [ 12, 22, 32, 42, 52, 62, 72, 82, 92, 13, 23, 33, 43, 53, 63, 73, 83, 93 ],
	      // [ 13, 23, 33, 43, 53, 63, 73, 83, 93, 14, 24, 34, 44, 54, 64, 74, 84, 94 ],
	      // [ 14, 24, 34, 44, 54, 64, 74, 84, 94, 15, 25, 35, 45, 55, 65, 75, 85, 95 ],
	      // [ 15, 25, 35, 45, 55, 65, 75, 85, 95, 16, 26, 36, 46, 56, 66, 76, 86, 96 ],
	      // [ 16, 26, 36, 46, 56, 66, 76, 86, 96, 17, 27, 37, 47, 57, 67, 77, 87, 97 ],
	      // [ 17, 27, 37, 47, 57, 67, 77, 87, 97, 18, 28, 38, 48, 58, 68, 78, 88, 98 ],
	      // [ 18, 28, 38, 48, 58, 68, 78, 88, 98, 19, 29, 39, 49, 59, 69, 79, 89, 99 ] 
	      //];
	     * 
	     * @param {Array<Array<number>>} data - data set 
	     * @param {number} n_in - look backs 
	     * @param {number} n_out - future iterations (only 1 supported) 
	     * @todo support multiple future iterations
	     * @returns {Array<Array<number>>} multivariate dataset for time series
	     */

	  }, {
	    key: "seriesToSupervised",
	    value: function seriesToSupervised(data) {
	      var n_in = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
	      var n_out = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;
	      if (n_out !== 1) throw new RangeError('Only 1 future iteration supported');
	      if (data && Array.isArray(data) && Array.isArray(data[0]) && data[0].length < 2) throw new RangeError('Must include at least two columns, the first column must be the dependent variable, followed by independent variables'); // let n_vars = data[ 0 ].length;

	      var cols = []; // let names = [];
	      // input sequence (t-n, ... t-1)

	      for (var x in data) {
	        x = parseInt(x);
	        var maxIndex = x + n_in + n_out;
	        if (maxIndex > data.length) break;
	        cols[x] = []; // console.log({ x,maxIndex });

	        for (var i in lodash_range(n_in)) {
	          var _cols$x;

	          i = parseInt(i);

	          (_cols$x = cols[x]).push.apply(_cols$x, toConsumableArray(data[x + i])); // console.log({ i, cols, });

	        }

	        for (var j in lodash_range(n_out)) {
	          var _cols$x2;

	          j = parseInt(j);

	          (_cols$x2 = cols[x]).push.apply(_cols$x2, toConsumableArray(data[x + j + n_in])); // console.log({ j, cols, });

	        }
	      }

	      return cols;
	    }
	    /**
	     * Calculates which columns to drop by index
	     * @todo support multiple iterations in the future, also only one output variable supported in column features * lookbacks -1
	     * @example
	    const ds = [
	    [10, 20, 30, 40, 50, 60, 70, 80, 90,],
	    [11, 21, 31, 41, 51, 61, 71, 81, 91,],
	    [12, 22, 32, 42, 52, 62, 72, 82, 92,],
	    [13, 23, 33, 43, 53, 63, 73, 83, 93,],
	    [14, 24, 34, 44, 54, 64, 74, 84, 94,],
	    [15, 25, 35, 45, 55, 65, 75, 85, 95,],
	    [16, 26, 36, 46, 56, 66, 76, 86, 96,],
	    [17, 27, 37, 47, 57, 67, 77, 87, 97,],
	    [18, 28, 38, 48, 58, 68, 78, 88, 98,],
	    [19, 29, 39, 49, 59, 69, 79, 89, 99,],
	    ];
	    const n_in = 1; //lookbacks
	    const n_out = 1;
	    const dropped = getDropableColumns(8, n_in, n_out); //=> [ 10, 11, 12, 13, 14, 15, 16, 17 ]
	     * @param {number} features - number of independent variables
	     * @param {number} n_in - look backs 
	     * @param {number} n_out - future iterations (currently only 1 supported)
	     * @returns {Array<number>} array indexes to drop
	     */

	  }, {
	    key: "getDropableColumns",
	    value: function getDropableColumns(features, n_in, n_out) {
	      if (n_out !== 1) throw new RangeError('Only 1 future iteration supported');
	      var cols = features + 1;
	      var total_cols = cols * n_in + cols * n_out; // console.log({ cols, total_cols });

	      return lodash_range(total_cols - cols + 1, total_cols);
	    }
	    /**
	     * Reshape input to be [samples, time steps, features]
	     * @example
	     * @override 
	     * LSTMTimeSeries.getTimeseriesShape([ 
	        [ [ 1 ], [ 2 ], [ 3 ] ],
	        [ [ 2 ], [ 3 ], [ 4 ] ],
	        [ [ 3 ], [ 4 ], [ 5 ] ],
	        [ [ 4 ], [ 5 ], [ 6 ] ],
	        [ [ 5 ], [ 6 ], [ 7 ] ],
	        [ [ 6 ], [ 7 ], [ 8 ] ], 
	      ]) //=> [6, 1, 3,]
	     * @param {Array<Array<number>} x_timeseries - dataset array of values
	     * @return {Array<Array<number>>} returns proper timeseries forecasting shape
	     */

	  }, {
	    key: "getTimeseriesShape",
	    value: function getTimeseriesShape(x_timeseries) {
	      var time_steps = this.settings && this.settings.lookback ? this.settings.lookback : 1;
	      var xShape = this.getInputShape(x_timeseries);
	      var _samples = xShape[0];
	      var _timeSteps = time_steps;

	      var _features = this.settings && this.settings.features ? this.settings.features : xShape[1]; // reshape input to be 3D [samples, timesteps, features]
	      // train_X = train_X.reshape((train_X.shape[0], n_hours, n_features))


	      var newShape = [_samples, _timeSteps, _features]; // console.log({newShape})

	      return newShape;
	    }
	    /**
	     * Returns data for predicting values
	     * @param timeseries 
	     * @param look_back 
	     * @override 
	     */

	  }, {
	    key: "getTimeseriesDataSet",
	    value: function getTimeseriesDataSet(timeseries, look_back) {
	      var lookBack = look_back || this.settings.lookback;
	      var matrices = LSTMMultivariateTimeSeries.createDataset.call(this, timeseries, lookBack);
	      var x_matrix = matrices[0];
	      var y_matrix_m = LSTMMultivariateTimeSeries.reshape(matrices[1], [matrices[1].length, 1]);
	      var timeseriesShape = LSTMMultivariateTimeSeries.getTimeseriesShape.call(this, x_matrix); // const timeseriesShape = LSTMMultivariateTimeSeries.getTimeseriesShape(x_matrix);

	      var x_matrix_timeseries = LSTMMultivariateTimeSeries.reshape(x_matrix, timeseriesShape); // const x_matrix_timeseries = LSTMMultivariateTimeSeries.reshape(x_matrix, [x_matrix.length, lookBack, ]);

	      var xShape = LSTMMultivariateTimeSeries.getInputShape(x_matrix_timeseries);
	      var y_matrix = pivotVector(y_matrix_m)[y_matrix_m[0].length - 1];
	      var yShape = LSTMMultivariateTimeSeries.getInputShape(y_matrix_m);
	      return {
	        yShape: yShape,
	        xShape: xShape,
	        y_matrix: y_matrix,
	        x_matrix: x_matrix_timeseries
	      };
	    }
	    /**
	     * @param {{layers:Array<Object>,compile:Object,fit:Object}} options - neural network configuration and tensorflow model hyperparameters
	     * @param {{model:Object,tf:Object,}} properties - extra instance properties
	     */

	  }]);

	  function LSTMMultivariateTimeSeries() {
	    var _this;

	    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	    var properties = arguments.length > 1 ? arguments[1] : undefined;

	    classCallCheck(this, LSTMMultivariateTimeSeries);

	    var config = Object.assign({
	      layers: [],
	      stateful: true,
	      mulitpleTimeSteps: false,
	      lookback: 1,
	      features: undefined,
	      outputs: 1,
	      learningRate: 0.1,
	      compile: {
	        loss: 'meanSquaredError',
	        optimizer: 'adam'
	      },
	      fit: {
	        epochs: 100,
	        batchSize: 1,
	        shuffle: false
	      }
	    }, options);
	    _this = possibleConstructorReturn(this, getPrototypeOf(LSTMMultivariateTimeSeries).call(this, config, properties));
	    _this.createDataset = LSTMMultivariateTimeSeries.createDataset;
	    _this.seriesToSupervised = LSTMMultivariateTimeSeries.seriesToSupervised;
	    _this.getDropableColumns = LSTMMultivariateTimeSeries.getDropableColumns;
	    _this.drop = LSTMMultivariateTimeSeries.drop;
	    _this.getTimeseriesShape = LSTMMultivariateTimeSeries.getTimeseriesShape;
	    _this.getTimeseriesDataSet = LSTMMultivariateTimeSeries.getTimeseriesDataSet;
	    return possibleConstructorReturn(_this, assertThisInitialized(_this));
	  }
	  /**
	   * Adds dense layers to tensorflow classification model
	   * @override 
	   * @param {Array<Array<number>>} x_matrix - independent variables
	   * @param {Array<Array<number>>} y_matrix - dependent variables
	   * @param {Array<Object>} layers - model dense layer parameters
	   * @param {Array<Array<number>>} x_test - validation data independent variables
	   * @param {Array<Array<number>>} y_test - validation data dependent variables
	   */


	  createClass(LSTMMultivariateTimeSeries, [{
	    key: "generateLayers",
	    value: function generateLayers(x_matrix, y_matrix, layers) {
	      var _this2 = this;

	      var xShape = this.getInputShape(x_matrix);
	      var yShape = this.getInputShape(y_matrix);
	      this.yShape = yShape;
	      this.xShape = xShape;
	      var lstmLayers = [];
	      var denseLayers = [];

	      if (layers) {
	        if (layers.lstmLayers && layers.lstmLayers.length) lstmLayers.push.apply(lstmLayers, toConsumableArray(layers.lstmLayers));
	        if (layers.denseLayers && layers.denseLayers.length) denseLayers.push.apply(denseLayers, toConsumableArray(layers.denseLayers));
	      } else {
	        var inputShape = [xShape[1], xShape[2]]; // console.log('default timeseries', { inputShape, xShape, yShape, });
	        // model.add(LSTM(50, input_shape=(train_X.shape[1], train_X.shape[2])))
	        // model.add(Dense(1))

	        lstmLayers.push({
	          units: 10,
	          inputShape: inputShape
	        });
	        denseLayers.push({
	          units: yShape[1]
	        });
	      } // console.log('lstmLayers',lstmLayers)
	      // console.log('denseLayers',denseLayers)


	      if (lstmLayers.length) {
	        lstmLayers.forEach(function (layer) {
	          _this2.model.add(_this2.tf.layers.lstm(layer));
	        });
	      }

	      if (denseLayers.length) {
	        denseLayers.forEach(function (layer) {
	          _this2.model.add(_this2.tf.layers.dense(layer));
	        });
	      }

	      this.layers = {
	        lstmLayers: lstmLayers,
	        denseLayers: denseLayers
	      }; // this.settings.compile.optimizer = sgdoptimizer;
	    }
	    /**
	     * @override 
	     * @param x_timeseries 
	     * @param y_timeseries 
	     * @param layers 
	     * @param x_test 
	     * @param y_test 
	     */

	  }, {
	    key: "train",
	    value: function () {
	      var _train = asyncToGenerator(
	      /*#__PURE__*/
	      regenerator.mark(function _callee(x_timeseries, y_timeseries, layers, x_test, y_test) {
	        var xShape, yShape, x_matrix, y_matrix, look_back, matrices, timeseriesShape, x_matrix_timeseries, xs, ys;
	        return regenerator.wrap(function _callee$(_context) {
	          while (1) {
	            switch (_context.prev = _context.next) {
	              case 0:
	                look_back = this.settings.lookback;

	                if (y_timeseries) {
	                  x_matrix = x_timeseries;
	                  y_matrix = y_timeseries;
	                  xShape = this.getInputShape(x_matrix);
	                  yShape = this.getInputShape(y_matrix);
	                } else {
	                  matrices = this.createDataset(x_timeseries, look_back); // console.log({matrices})

	                  x_matrix = matrices[0];
	                  y_matrix = this.reshape(matrices[1], [matrices[1].length, 1]);
	                  xShape = this.getInputShape(x_matrix);
	                  yShape = this.getInputShape(y_matrix);
	                } //_samples, _timeSteps, _features


	                timeseriesShape = this.getTimeseriesShape(x_matrix); // console.log({
	                //   timeseriesShape, yShape, xShape,
	                //   // y_matrix, x_matrix,
	                // });

	                x_matrix_timeseries = LSTMMultivariateTimeSeries.reshape(x_matrix, timeseriesShape); // console.log('x_matrix_timeseries',JSON.stringify(x_matrix_timeseries));
	                // console.log('x_matrix',JSON.stringify(x_matrix));
	                // console.log('y_matrix',JSON.stringify(y_matrix));

	                xs = this.tf.tensor(x_matrix_timeseries, timeseriesShape);
	                ys = this.tf.tensor(y_matrix, yShape);
	                this.xShape = timeseriesShape;
	                this.yShape = yShape;

	                if (this.trained === false) {
	                  this.model = this.tf.sequential();
	                  this.generateLayers.call(this, x_matrix_timeseries, y_matrix, layers || this.layers, x_test, y_test);
	                  this.model.compile(this.settings.compile);
	                }

	                if (x_test && y_test) {
	                  this.settings.fit.validation_data = [x_test, y_test];
	                }

	                _context.next = 12;
	                return this.model.fit(xs, ys, this.settings.fit);

	              case 12:
	                // this.model.summary();
	                xs.dispose();
	                ys.dispose();
	                return _context.abrupt("return", this.model);

	              case 15:
	              case "end":
	                return _context.stop();
	            }
	          }
	        }, _callee, this);
	      }));

	      function train(_x, _x2, _x3, _x4, _x5) {
	        return _train.apply(this, arguments);
	      }

	      return train;
	    }()
	  }]);

	  return LSTMMultivariateTimeSeries;
	}(LSTMTimeSeries);
	/**
	 * Returns an array of vectors as an array of arrays (from modelscript)
	 * @example
	const vectors = [ [1,2,3], [1,2,3], [3,3,4], [3,3,3] ];
	const arrays = pivotVector(vectors); // => [ [1,2,3,3], [2,2,3,3], [3,3,4,3] ];
	 * @memberOf util
	 * @param {Array[]} vectors 
	 * @returns {Array[]}
	 * @ignore
	 * @see {https://github.com/repetere/modelscript/blob/master/src/util.js}
	 */

	/* istanbul ignore next */

	function pivotVector() {
	  var vectors = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

	  /* istanbul ignore next */
	  return vectors.reduce(function (result, val, index
	  /*, arr*/
	  ) {
	    val.forEach(function (vecVal, i) {
	      index === 0 ? result.push([vecVal]) : result[i].push(vecVal);
	    });
	    return result;
	  }, []);
	}

	// @tensorflow/tfjs-models Copyright 2019 Google

	function __awaiter$3(e, n, r, t) {
	  return new (r || (r = Promise))(function (o, i) {
	    function a(e) {
	      try {
	        u(t.next(e));
	      } catch (e) {
	        i(e);
	      }
	    }

	    function s(e) {
	      try {
	        u(t["throw"](e));
	      } catch (e) {
	        i(e);
	      }
	    }

	    function u(e) {
	      e.done ? o(e.value) : new r(function (n) {
	        n(e.value);
	      }).then(a, s);
	    }

	    u((t = t.apply(e, n || [])).next());
	  });
	}

	function __generator$3(e, n) {
	  var r,
	      t,
	      o,
	      i,
	      a = {
	    label: 0,
	    sent: function sent() {
	      if (1 & o[0]) throw o[1];
	      return o[1];
	    },
	    trys: [],
	    ops: []
	  };
	  return i = {
	    next: s(0),
	    "throw": s(1),
	    "return": s(2)
	  }, "function" == typeof Symbol && (i[Symbol.iterator] = function () {
	    return this;
	  }), i;

	  function s(i) {
	    return function (s) {
	      return function (i) {
	        if (r) throw new TypeError("Generator is already executing.");

	        for (; a;) {
	          try {
	            if (r = 1, t && (o = 2 & i[0] ? t["return"] : i[0] ? t["throw"] || ((o = t["return"]) && o.call(t), 0) : t.next) && !(o = o.call(t, i[1])).done) return o;

	            switch (t = 0, o && (i = [2 & i[0], o.value]), i[0]) {
	              case 0:
	              case 1:
	                o = i;
	                break;

	              case 4:
	                return a.label++, {
	                  value: i[1],
	                  done: !1
	                };

	              case 5:
	                a.label++, t = i[1], i = [0];
	                continue;

	              case 7:
	                i = a.ops.pop(), a.trys.pop();
	                continue;

	              default:
	                if (!(o = (o = a.trys).length > 0 && o[o.length - 1]) && (6 === i[0] || 2 === i[0])) {
	                  a = 0;
	                  continue;
	                }

	                if (3 === i[0] && (!o || i[1] > o[0] && i[1] < o[3])) {
	                  a.label = i[1];
	                  break;
	                }

	                if (6 === i[0] && a.label < o[1]) {
	                  a.label = o[1], o = i;
	                  break;
	                }

	                if (o && a.label < o[2]) {
	                  a.label = o[2], a.ops.push(i);
	                  break;
	                }

	                o[2] && a.ops.pop(), a.trys.pop();
	                continue;
	            }

	            i = n.call(e, a);
	          } catch (e) {
	            i = [6, e], t = 0;
	          } finally {
	            r = o = 0;
	          }
	        }

	        if (5 & i[0]) throw i[1];
	        return {
	          value: i[0] ? i[1] : void 0,
	          done: !0
	        };
	      }([i, s]);
	    };
	  }
	}

	var stringToChars = function stringToChars(e) {
	  for (var n = [], r = 0, t = e; r < t.length; r++) {
	    var o = t[r];
	    n.push(o);
	  }

	  return n;
	},
	    TrieNode = function () {
	  function e(e) {
	    this.key = e, this.parent = null, this.children = {}, this.end = !1;
	  }

	  return e.prototype.getWord = function () {
	    for (var e = [], n = this; null !== n;) {
	      null !== n.key && e.unshift(n.key), n = n.parent;
	    }

	    return [e, this.score, this.index];
	  }, e;
	}(),
	    Trie = function () {
	  function e() {
	    this.root = new TrieNode(null);
	  }

	  return e.prototype.findAllCommonPrefixes = function (e, n, r) {
	    if (n.end) {
	      var t = n.getWord();
	      e.slice(0, t[0].length).join("") === t[0].join("") && r.unshift(t);
	    }

	    for (var o in n.children) {
	      this.findAllCommonPrefixes(e, n.children[o], r);
	    }
	  }, e.prototype.insert = function (e, n, r) {
	    for (var t = this.root, o = stringToChars(e), i = 0; i < o.length; i++) {
	      t.children[o[i]] || (t.children[o[i]] = new TrieNode(o[i]), t.children[o[i]].parent = t), t = t.children[o[i]], i === o.length - 1 && (t.end = !0, t.score = n, t.index = r);
	    }
	  }, e.prototype.commonPrefixSearch = function (e) {
	    var n = this.root.children[e[0]],
	        r = [];
	    return n ? this.findAllCommonPrefixes(e, n, r) : r.push([[e[0]], 0, 0]), r;
	  }, e;
	}(),
	    separator = "▁";

	function processInput(e) {
	  var n = e.normalize("NFKC");
	  return separator + n.replace(/ /g, separator);
	}

	var RESERVED_SYMBOLS_COUNT = 6,
	    Tokenizer = function () {
	  function e(e) {
	    this.vocabulary = e, this.trie = new Trie();

	    for (var n = RESERVED_SYMBOLS_COUNT; n < this.vocabulary.length; n++) {
	      this.trie.insert(this.vocabulary[n][0], this.vocabulary[n][1], n);
	    }
	  }

	  return e.prototype.encode = function (e) {
	    var n = [],
	        r = [],
	        t = [];
	    e = processInput(e);

	    for (var o = stringToChars(e), i = 0; i <= o.length; i++) {
	      n.push({}), r.push(0), t.push(0);
	    }

	    for (i = 0; i < o.length; i++) {
	      for (var a = this.trie.commonPrefixSearch(o.slice(i)), s = 0; s < a.length; s++) {
	        var u = a[s],
	            l = {
	          key: u[0],
	          score: u[1],
	          index: u[2]
	        };
	        null == n[i + (c = u[0].length)][i] && (n[i + c][i] = []), n[i + c][i].push(l);
	      }
	    }

	    for (var c = 0; c <= o.length; c++) {
	      for (var h in n[c]) {
	        var f = n[c][h];

	        for (s = 0; s < f.length; s++) {
	          var d = f[s],
	              p = d.score + t[c - d.key.length];
	          (0 === t[c] || p >= t[c]) && (t[c] = p, r[c] = f[s].index);
	        }
	      }
	    }

	    for (var v = [], g = r.length - 1; g > 0;) {
	      v.push(r[g]), g -= this.vocabulary[r[g]][0].length;
	    }

	    var y = [],
	        _ = !1;

	    for (i = 0; i < v.length; i++) {
	      var w = v[i];
	      _ && 0 === w || y.push(w), _ = 0 === w;
	    }

	    return y.reverse();
	  }, e;
	}(),
	    BASE_PATH = "https://storage.googleapis.com/tfjs-models/savedmodel/universal_sentence_encoder/";

	function load() {
	  return __awaiter$3(this, void 0, void 0, function () {
	    var e;
	    return __generator$3(this, function (n) {
	      switch (n.label) {
	        case 0:
	          return [4, (e = new UniversalSentenceEncoder()).load()];

	        case 1:
	          return n.sent(), [2, e];
	      }
	    });
	  });
	}

	function loadTokenizer(e) {
	  return __awaiter$3(this, void 0, void 0, function () {
	    var n;
	    return __generator$3(this, function (r) {
	      switch (r.label) {
	        case 0:
	          return [4, loadVocabulary(e)];

	        case 1:
	          return n = r.sent(), [2, new Tokenizer(n)];
	      }
	    });
	  });
	}

	function loadVocabulary(e) {
	  return void 0 === e && (e = BASE_PATH + "vocab.json"), __awaiter$3(this, void 0, void 0, function () {
	    return __generator$3(this, function (n) {
	      switch (n.label) {
	        case 0:
	          return [4, Q.fetch(e)];

	        case 1:
	          return [2, n.sent().json()];
	      }
	    });
	  });
	}

	var UniversalSentenceEncoder = function () {
	  function e() {}

	  return e.prototype.loadModel = function () {
	    return __awaiter$3(this, void 0, void 0, function () {
	      return __generator$3(this, function (e) {
	        return [2, loadGraphModel(BASE_PATH + "model.json")];
	      });
	    });
	  }, e.prototype.load = function () {
	    return __awaiter$3(this, void 0, void 0, function () {
	      var e, n, r;
	      return __generator$3(this, function (t) {
	        switch (t.label) {
	          case 0:
	            return [4, Promise.all([this.loadModel(), loadVocabulary()])];

	          case 1:
	            return e = t.sent(), n = e[0], r = e[1], this.model = n, this.tokenizer = new Tokenizer(r), [2];
	        }
	      });
	    });
	  }, e.prototype.embed = function (e) {
	    return __awaiter$3(this, void 0, void 0, function () {
	      var n,
	          r,
	          t,
	          o,
	          i,
	          a,
	          s,
	          u = this;
	      return __generator$3(this, function (l) {
	        switch (l.label) {
	          case 0:
	            for ("string" == typeof e && (e = [e]), n = e.map(function (e) {
	              return u.tokenizer.encode(e);
	            }), r = n.map(function (e, n) {
	              return e.map(function (e, r) {
	                return [n, r];
	              });
	            }), t = [], o = 0; o < r.length; o++) {
	              t = t.concat(r[o]);
	            }

	            return i = Rn(t, [t.length, 2], "int32"), a = En(Q.flatten(n), "int32"), [4, this.model.executeAsync({
	              indices: i,
	              values: a
	            })];

	          case 1:
	            return s = l.sent(), i.dispose(), a.dispose(), [2, s];
	        }
	      });
	    });
	  }, e;
	}();

	var model$1;
	var tokenizer;
	/**
	 * Text Embedding with Tensorflow Universal Sentence Encoder (USE)
	 * @class TextEmbedding
	 * @implements {TensorScriptModelInterface}
	 */

	var TextEmbedding =
	/*#__PURE__*/
	function (_TensorScriptModelInt) {
	  inherits(TextEmbedding, _TensorScriptModelInt);

	  /**
	   * @param {Object} options - Options for USE
	   * @param {{model:Object,tf:Object,}} properties - extra instance properties
	   */
	  function TextEmbedding() {
	    var _this;

	    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	    var properties = arguments.length > 1 ? arguments[1] : undefined;

	    classCallCheck(this, TextEmbedding);

	    var config = Object.assign({}, options);
	    _this = possibleConstructorReturn(this, getPrototypeOf(TextEmbedding).call(this, config, properties));
	    return possibleConstructorReturn(_this, assertThisInitialized(_this));
	  }
	  /**
	   * Asynchronously loads Universal Sentence Encoder and tokenizer
	   * @override
	   * @return {Object} returns loaded UniversalSentenceEncoder model
	   */


	  createClass(TextEmbedding, [{
	    key: "train",
	    value: function () {
	      var _train = asyncToGenerator(
	      /*#__PURE__*/
	      regenerator.mark(function _callee() {
	        var promises, USE;
	        return regenerator.wrap(function _callee$(_context) {
	          while (1) {
	            switch (_context.prev = _context.next) {
	              case 0:
	                promises = [];
	                if (!model$1) promises.push(load());else promises.push(Promise.resolve(model$1));
	                if (!tokenizer) promises.push(loadTokenizer());else promises.push(Promise.resolve(tokenizer));
	                _context.next = 5;
	                return Promise.all(promises);

	              case 5:
	                USE = _context.sent;
	                if (!model$1) model$1 = USE[0];
	                if (!tokenizer) tokenizer = USE[1];
	                this.model = model$1;
	                this.tokenizer = tokenizer;
	                return _context.abrupt("return", this.model);

	              case 11:
	              case "end":
	                return _context.stop();
	            }
	          }
	        }, _callee, this);
	      }));

	      function train() {
	        return _train.apply(this, arguments);
	      }

	      return train;
	    }()
	    /**
	     * Calculates sentence embeddings
	     * @override
	     * @param {Array<Array<number>>|Array<number>} input_array - new test independent variables
	     * @param {Object} options - model prediction options
	     * @return {{data: Promise}} returns tensorflow prediction 
	     */

	  }, {
	    key: "calculate",
	    value: function calculate(input_array) {
	      if (!input_array || Array.isArray(input_array) === false) throw new Error('invalid input array of sentences');
	      var embeddings = this.model.embed(input_array);
	      return embeddings;
	    }
	    /**
	     * Returns prediction values from tensorflow model
	     * @param {Array<string>} input_matrix - array of sentences to embed 
	     * @param {Boolean} [options.json=true] - return object instead of typed array
	     * @param {Boolean} [options.probability=true] - return real values instead of integers
	     * @return {Array<Array<number>>} predicted model values
	     */

	  }, {
	    key: "predict",
	    value: function () {
	      var _predict = asyncToGenerator(
	      /*#__PURE__*/
	      regenerator.mark(function _callee2(input_array) {
	        var options,
	            config,
	            embeddings,
	            predictions,
	            shape,
	            predictionValues,
	            _args2 = arguments;
	        return regenerator.wrap(function _callee2$(_context2) {
	          while (1) {
	            switch (_context2.prev = _context2.next) {
	              case 0:
	                options = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : {};
	                config = Object.assign({
	                  json: true,
	                  probability: true
	                }, options);
	                _context2.next = 4;
	                return this.calculate(input_array, options);

	              case 4:
	                embeddings = _context2.sent;
	                _context2.next = 7;
	                return embeddings.data();

	              case 7:
	                predictions = _context2.sent;

	                if (!(config.json === false)) {
	                  _context2.next = 12;
	                  break;
	                }

	                return _context2.abrupt("return", predictions);

	              case 12:
	                shape = [input_array.length, 512];
	                predictionValues = options.probability === false ? Array.from(predictions).map(Math.round) : Array.from(predictions);
	                return _context2.abrupt("return", this.reshape(predictionValues, shape));

	              case 15:
	              case "end":
	                return _context2.stop();
	            }
	          }
	        }, _callee2, this);
	      }));

	      function predict(_x) {
	        return _predict.apply(this, arguments);
	      }

	      return predict;
	    }()
	  }]);

	  return TextEmbedding;
	}(TensorScriptModelInterface);

	exports.BaseNeuralNetwork = BaseNeuralNetwork;
	exports.DeepLearningClassification = DeepLearningClassification;
	exports.DeepLearningRegression = DeepLearningRegression;
	exports.LSTMMultivariateTimeSeries = LSTMMultivariateTimeSeries;
	exports.LSTMTimeSeries = LSTMTimeSeries;
	exports.LogisticRegression = LogisticRegression;
	exports.MultipleLinearRegression = MultipleLinearRegression;
	exports.TensorScriptModelInterface = TensorScriptModelInterface;
	exports.TextEmbedding = TextEmbedding;

	Object.defineProperty(exports, '__esModule', { value: true });

}));
